webpackJsonp([21],{

/***/ 243:
/*!*************************************************************!*\
  !*** ./modules/CoreWebclient/js/views/CPageSwitcherView.js ***!
  \*************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179)
	;

	/**
	 * @constructor
	 * @param {number} iCount
	 * @param {number} iPerPage
	 */
	function CPageSwitcherView(iCount, iPerPage)
	{
		this.bShown = false;
		
		this.currentPage = ko.observable(1);
		this.count = ko.observable(iCount);
		this.perPage = ko.observable(iPerPage);
		this.firstPage = ko.observable(1);
		this.lastPage = ko.observable(1);

		this.pagesCount = ko.computed(function () {
			var iCount = this.perPage() > 0 ? Math.ceil(this.count() / this.perPage()) : 0;
			return (iCount > 0) ? iCount : 1;
		}, this);

		ko.computed(function () {

			var
				iAllLimit = 20,
				iLimit = 4,
				iPagesCount = this.pagesCount(),
				iCurrentPage = this.currentPage(),
				iStart = iCurrentPage,
				iEnd = iCurrentPage
			;

			if (iPagesCount > 1)
			{
				while (true)
				{
					iAllLimit--;
					
					if (1 < iStart)
					{
						iStart--;
						iLimit--;
					}

					if (0 === iLimit)
					{
						break;
					}

					if (iPagesCount > iEnd)
					{
						iEnd++;
						iLimit--;
					}

					if (0 === iLimit)
					{
						break;
					}

					if (0 === iAllLimit)
					{
						break;
					}
				}
			}

			this.firstPage(iStart);
			this.lastPage(iEnd);
			
		}, this);

		this.visibleFirst = ko.computed(function () {
			return (this.firstPage() > 1);
		}, this);

		this.visibleLast = ko.computed(function () {
			return (this.lastPage() < this.pagesCount());
		}, this);

		this.clickPage = _.bind(this.clickPage, this);

		this.pages = ko.computed(function () {
			var
				iIndex = this.firstPage(),
				aPages = []
			;

			if (this.firstPage() < this.lastPage())
			{
				for (; iIndex <= this.lastPage(); iIndex++)
				{
					aPages.push({
						number: iIndex,
						current: (iIndex === this.currentPage()),
						clickFunc: this.clickPage
					});
				}
			}

			return aPages;
		}, this);
		
		if (!App.isMobile())
		{
			this.hotKeysBind();
		}
	}

	CPageSwitcherView.prototype.ViewTemplate = 'CoreWebclient_PageSwitcherView';

	CPageSwitcherView.prototype.hotKeysBind = function ()
	{
		$(document).on('keydown', $.proxy(function(ev) {
			if (this.bShown && !Utils.isTextFieldFocused())
			{
				var sKey = ev.keyCode;
				if (ev.ctrlKey && sKey === Enums.Key.Left)
				{
					this.clickPreviousPage();
				}
				else if (ev.ctrlKey && sKey === Enums.Key.Right)
				{
					this.clickNextPage();
				}
			}
		},this));
	};

	CPageSwitcherView.prototype.hide = function ()
	{
		this.bShown = false;
	};

	CPageSwitcherView.prototype.show = function ()
	{
		this.bShown = true;
	};

	CPageSwitcherView.prototype.clear = function ()
	{
		this.currentPage(1);
		this.count(0);
	};

	/**
	 * @param {number} iCount
	 */
	CPageSwitcherView.prototype.setCount = function (iCount)
	{
		this.count(iCount);
		if (this.currentPage() > this.pagesCount())
		{
			this.currentPage(this.pagesCount());
		}
	};

	/**
	 * @param {number} iPage
	 * @param {number} iPerPage
	 */
	CPageSwitcherView.prototype.setPage = function (iPage, iPerPage)
	{
		this.perPage(iPerPage);
		if (iPage > this.pagesCount())
		{
			this.currentPage(this.pagesCount());
		}
		else
		{
			this.currentPage(iPage);
		}
	};

	/**
	 * @param {Object} oPage
	 */
	CPageSwitcherView.prototype.clickPage = function (oPage)
	{
		var iPage = oPage.number;
		if (iPage < 1)
		{
			iPage = 1;
		}
		if (iPage > this.pagesCount())
		{
			iPage = this.pagesCount();
		}
		this.currentPage(iPage);
	};

	CPageSwitcherView.prototype.clickFirstPage = function ()
	{
		this.currentPage(1);
	};

	CPageSwitcherView.prototype.clickPreviousPage = function ()
	{
		var iPrevPage = this.currentPage() - 1;
		if (iPrevPage < 1)
		{
			iPrevPage = 1;
		}
		this.currentPage(iPrevPage);
	};

	CPageSwitcherView.prototype.clickNextPage = function ()
	{
		var iNextPage = this.currentPage() + 1;
		if (iNextPage > this.pagesCount())
		{
			iNextPage = this.pagesCount();
		}
		this.currentPage(iNextPage);
	};

	CPageSwitcherView.prototype.clickLastPage = function ()
	{
		this.currentPage(this.pagesCount());
	};

	module.exports = CPageSwitcherView;


/***/ }),

/***/ 259:
/*!**************************************!*\
  !*** ./~/css-loader/lib/css-base.js ***!
  \**************************************/
/***/ (function(module, exports) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	// css base code, injected by the css-loader
	module.exports = function() {
		var list = [];

		// return the list of modules as css string
		list.toString = function toString() {
			var result = [];
			for(var i = 0; i < this.length; i++) {
				var item = this[i];
				if(item[2]) {
					result.push("@media " + item[2] + "{" + item[1] + "}");
				} else {
					result.push(item[1]);
				}
			}
			return result.join("");
		};

		// import a list of modules into the list
		list.i = function(modules, mediaQuery) {
			if(typeof modules === "string")
				modules = [[null, modules, ""]];
			var alreadyImportedModules = {};
			for(var i = 0; i < this.length; i++) {
				var id = this[i][0];
				if(typeof id === "number")
					alreadyImportedModules[id] = true;
			}
			for(i = 0; i < modules.length; i++) {
				var item = modules[i];
				// skip already imported module
				// this implementation is not 100% perfect for weird media query combinations
				//  when a module is imported multiple times with different media queries.
				//  I hope this will never occur (Hey this way we have smaller bundles)
				if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
					if(mediaQuery && !item[2]) {
						item[2] = mediaQuery;
					} else if(mediaQuery) {
						item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
					}
					list.push(item);
				}
			}
		};
		return list;
	};


/***/ }),

/***/ 260:
/*!*************************************!*\
  !*** ./~/style-loader/addStyles.js ***!
  \*************************************/
/***/ (function(module, exports, __webpack_require__) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	var stylesInDom = {},
		memoize = function(fn) {
			var memo;
			return function () {
				if (typeof memo === "undefined") memo = fn.apply(this, arguments);
				return memo;
			};
		},
		isOldIE = memoize(function() {
			return /msie [6-9]\b/.test(self.navigator.userAgent.toLowerCase());
		}),
		getHeadElement = memoize(function () {
			return document.head || document.getElementsByTagName("head")[0];
		}),
		singletonElement = null,
		singletonCounter = 0,
		styleElementsInsertedAtTop = [];

	module.exports = function(list, options) {
		if(false) {
			if(typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
		}

		options = options || {};
		// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
		// tags it will allow on a page
		if (typeof options.singleton === "undefined") options.singleton = isOldIE();

		// By default, add <style> tags to the bottom of <head>.
		if (typeof options.insertAt === "undefined") options.insertAt = "bottom";

		var styles = listToStyles(list);
		addStylesToDom(styles, options);

		return function update(newList) {
			var mayRemove = [];
			for(var i = 0; i < styles.length; i++) {
				var item = styles[i];
				var domStyle = stylesInDom[item.id];
				domStyle.refs--;
				mayRemove.push(domStyle);
			}
			if(newList) {
				var newStyles = listToStyles(newList);
				addStylesToDom(newStyles, options);
			}
			for(var i = 0; i < mayRemove.length; i++) {
				var domStyle = mayRemove[i];
				if(domStyle.refs === 0) {
					for(var j = 0; j < domStyle.parts.length; j++)
						domStyle.parts[j]();
					delete stylesInDom[domStyle.id];
				}
			}
		};
	}

	function addStylesToDom(styles, options) {
		for(var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];
			if(domStyle) {
				domStyle.refs++;
				for(var j = 0; j < domStyle.parts.length; j++) {
					domStyle.parts[j](item.parts[j]);
				}
				for(; j < item.parts.length; j++) {
					domStyle.parts.push(addStyle(item.parts[j], options));
				}
			} else {
				var parts = [];
				for(var j = 0; j < item.parts.length; j++) {
					parts.push(addStyle(item.parts[j], options));
				}
				stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
			}
		}
	}

	function listToStyles(list) {
		var styles = [];
		var newStyles = {};
		for(var i = 0; i < list.length; i++) {
			var item = list[i];
			var id = item[0];
			var css = item[1];
			var media = item[2];
			var sourceMap = item[3];
			var part = {css: css, media: media, sourceMap: sourceMap};
			if(!newStyles[id])
				styles.push(newStyles[id] = {id: id, parts: [part]});
			else
				newStyles[id].parts.push(part);
		}
		return styles;
	}

	function insertStyleElement(options, styleElement) {
		var head = getHeadElement();
		var lastStyleElementInsertedAtTop = styleElementsInsertedAtTop[styleElementsInsertedAtTop.length - 1];
		if (options.insertAt === "top") {
			if(!lastStyleElementInsertedAtTop) {
				head.insertBefore(styleElement, head.firstChild);
			} else if(lastStyleElementInsertedAtTop.nextSibling) {
				head.insertBefore(styleElement, lastStyleElementInsertedAtTop.nextSibling);
			} else {
				head.appendChild(styleElement);
			}
			styleElementsInsertedAtTop.push(styleElement);
		} else if (options.insertAt === "bottom") {
			head.appendChild(styleElement);
		} else {
			throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
		}
	}

	function removeStyleElement(styleElement) {
		styleElement.parentNode.removeChild(styleElement);
		var idx = styleElementsInsertedAtTop.indexOf(styleElement);
		if(idx >= 0) {
			styleElementsInsertedAtTop.splice(idx, 1);
		}
	}

	function createStyleElement(options) {
		var styleElement = document.createElement("style");
		styleElement.type = "text/css";
		insertStyleElement(options, styleElement);
		return styleElement;
	}

	function createLinkElement(options) {
		var linkElement = document.createElement("link");
		linkElement.rel = "stylesheet";
		insertStyleElement(options, linkElement);
		return linkElement;
	}

	function addStyle(obj, options) {
		var styleElement, update, remove;

		if (options.singleton) {
			var styleIndex = singletonCounter++;
			styleElement = singletonElement || (singletonElement = createStyleElement(options));
			update = applyToSingletonTag.bind(null, styleElement, styleIndex, false);
			remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true);
		} else if(obj.sourceMap &&
			typeof URL === "function" &&
			typeof URL.createObjectURL === "function" &&
			typeof URL.revokeObjectURL === "function" &&
			typeof Blob === "function" &&
			typeof btoa === "function") {
			styleElement = createLinkElement(options);
			update = updateLink.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
				if(styleElement.href)
					URL.revokeObjectURL(styleElement.href);
			};
		} else {
			styleElement = createStyleElement(options);
			update = applyToTag.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
			};
		}

		update(obj);

		return function updateStyle(newObj) {
			if(newObj) {
				if(newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap)
					return;
				update(obj = newObj);
			} else {
				remove();
			}
		};
	}

	var replaceText = (function () {
		var textStore = [];

		return function (index, replacement) {
			textStore[index] = replacement;
			return textStore.filter(Boolean).join('\n');
		};
	})();

	function applyToSingletonTag(styleElement, index, remove, obj) {
		var css = remove ? "" : obj.css;

		if (styleElement.styleSheet) {
			styleElement.styleSheet.cssText = replaceText(index, css);
		} else {
			var cssNode = document.createTextNode(css);
			var childNodes = styleElement.childNodes;
			if (childNodes[index]) styleElement.removeChild(childNodes[index]);
			if (childNodes.length) {
				styleElement.insertBefore(cssNode, childNodes[index]);
			} else {
				styleElement.appendChild(cssNode);
			}
		}
	}

	function applyToTag(styleElement, obj) {
		var css = obj.css;
		var media = obj.media;

		if(media) {
			styleElement.setAttribute("media", media)
		}

		if(styleElement.styleSheet) {
			styleElement.styleSheet.cssText = css;
		} else {
			while(styleElement.firstChild) {
				styleElement.removeChild(styleElement.firstChild);
			}
			styleElement.appendChild(document.createTextNode(css));
		}
	}

	function updateLink(linkElement, obj) {
		var css = obj.css;
		var sourceMap = obj.sourceMap;

		if(sourceMap) {
			// http://stackoverflow.com/a/26603875
			css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
		}

		var blob = new Blob([css], { type: "text/css" });

		var oldSrc = linkElement.href;

		linkElement.href = URL.createObjectURL(blob);

		if(oldSrc)
			URL.revokeObjectURL(oldSrc);
	}


/***/ }),

/***/ 263:
/*!************************************************!*\
  !*** ./modules/CoreWebclient/js/utils/Date.js ***!
  \************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
				
		DateUtils = {}
	;

	DateUtils.getMonthNamesArray = function ()
	{
		var
			aMonthes = TextUtils.i18n('COREWEBCLIENT/LIST_MONTH_NAMES').split(' '),
			iLen = 12,
			iIndex = aMonthes.length
		;
		
		for (; iIndex < iLen; iIndex++)
		{
			aMonthes[iIndex] = '';
		}
		
		return aMonthes;
	};

	/**
	 * @param {number} iMonth
	 * @param {number} iYear
	 * 
	 * @return {number}
	 */
	DateUtils.daysInMonth = function (iMonth, iYear)
	{
		if (0 < iMonth && 13 > iMonth && 0 < iYear)
		{
			return new Date(iYear, iMonth, 0).getDate();
		}

		return 31;
	};

	module.exports = DateUtils;


/***/ }),

/***/ 264:
/*!******************************************!*\
  !*** ./modules/CoreWebclient/js/CJua.js ***!
  \******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		$ = __webpack_require__(/*! jquery */ 1),
		_ = __webpack_require__(/*! underscore */ 2),

		queue = __webpack_require__(/*! modules/CoreWebclient/js/vendors/queue.js */ 265),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		
		iDefLimit = 20
	;
	/**
	 * @param {*} mValue
	 * @return {boolean}
	 */
	function isUndefined(mValue)
	{
		return 'undefined' === typeof mValue;
	}

	/**
	 * @param {*} oParent
	 * @param {*} oDescendant
	 *
	 * @return {boolean}
	 */
	function contains(oParent, oDescendant)
	{
		var bResult = false;
		if (oParent && oDescendant)
		{
			if (oParent === oDescendant)
			{
				bResult = true;
			}
			else if (oParent.contains)
			{
				bResult = oParent.contains(oDescendant);
			}
			else
			{
				/*jshint bitwise: false*/
				bResult = oDescendant.compareDocumentPosition ?
					!!(oDescendant.compareDocumentPosition(oParent) & 8) : false;
				/*jshint bitwise: true*/
			}
		}

		return bResult;
	}

	function mainClearTimeout(iTimer)
	{
		if (0 < iTimer)
		{
			clearTimeout(iTimer);
		}

		iTimer = 0;
	}

	/**
	 * @param {Event} oEvent
	 * @return {?Event}
	 */
	function getEvent(oEvent)
	{
		oEvent = (oEvent && (oEvent.originalEvent ?
			oEvent.originalEvent : oEvent)) || window.event;

		return oEvent.dataTransfer ? oEvent : null;
	}

	/**
	 * @param {Object} oValues
	 * @param {string} sKey
	 * @param {?} mDefault
	 * @return {?}
	 */
	function getValue(oValues, sKey, mDefault)
	{
		return (!oValues || !sKey || isUndefined(oValues[sKey])) ? mDefault : oValues[sKey];
	}

	/**
	 * @param {Object} oOwner
	 * @param {string} sPublicName
	 * @param {*} mObject
	 */
	function setValue(oOwner, sPublicName, mObject)
	{
		oOwner[sPublicName] = mObject;
	}

	/**
	 * @param {Function} fFunction
	 * @param {Object=} oScope
	 * @return {Function}
	 */
	function scopeBind(fFunction, oScope)
	{
		return function () {
			return fFunction.apply(isUndefined(oScope) ? null : oScope,
				Array.prototype.slice.call(arguments));
		};
	}

	/**
	 * @param {number=} iLen
	 * @return {string}
	 */
	function fakeMd5(iLen)
	{
		var
			sResult = '',
			sLine = '0123456789abcdefghijklmnopqrstuvwxyz'
		;

		iLen = isUndefined(iLen) ? 32 : Types.pInt(iLen);

		while (sResult.length < iLen)
		{
			sResult += sLine.substr(Math.round(Math.random() * sLine.length), 1);
		}

		return sResult;
	}

	/**
	 * @return {string}
	 */
	function getNewUid()
	{
		return 'jua-uid-' + fakeMd5(16) + '-' + (new Date()).getTime().toString();
	}

	/**
	 * @param {*} oFile
	 * @param {string=} sPath
	 * @return {Object}
	 */
	function getDataFromFile(oFile, sPath)
	{
		var
			sFileName = isUndefined(oFile.fileName) ? (isUndefined(oFile.name) ? null : oFile.name) : oFile.fileName,
			iSize = isUndefined(oFile.fileSize) ? (isUndefined(oFile.size) ? null : oFile.size) : oFile.fileSize,
			sType = isUndefined(oFile.type) ? null : oFile.type
		;

		return {
			'FileName': sFileName,
			'Size': iSize,
			'Type': sType,
			'Folder': isUndefined(sPath) ? '' : sPath,
			'File' : oFile
		};
	}

	/**
	 * @param {*} aItems
	 * @param {Function} fFileCallback
	 * @param {boolean=} bEntry = false
	 * @param {boolean=} bAllowFolderDragAndDrop = true
	 * @param {number=} iLimit = 20
	 * @param {Function=} fLimitCallback
	 */
	function getDataFromFiles(aItems, fFileCallback, bEntry, bAllowFolderDragAndDrop, iLimit, fLimitCallback)
	{
		var
			iInputLimit = 0,
			iLen = 0,
			iIndex = 0,
			oItem = null,
			oEntry = null,
			bUseLimit = false,
			bCallLimit = false,
			fTraverseFileTree = function (oItem, sPath, fCallback, fLimitCallbackProxy) {

				if (oItem && !isUndefined(oItem['name']))
				{
					sPath = sPath || '';
					if (oItem['isFile'])
					{
						oItem.file(function (oFile) {
							if (!bUseLimit || 0 <= --iLimit)
							{
								fCallback(getDataFromFile(oFile, sPath));
							}
							else if (bUseLimit && !bCallLimit)
							{
								if (0 > iLimit && fLimitCallback)
								{
									bCallLimit = true;
									fLimitCallback(iInputLimit);
								}
							}
						});
					}
					else if (bAllowFolderDragAndDrop && oItem['isDirectory'] && oItem['createReader'])
					{
						var
							oDirReader = oItem['createReader'](),
							iIndex = 0,
							iLen = 0
						;

						if (oDirReader && oDirReader['readEntries'])
						{
							oDirReader['readEntries'](function (aEntries) {
								if (aEntries && Types.isNonEmptyArray(aEntries))
								{
									for (iIndex = 0, iLen = aEntries.length; iIndex < iLen; iIndex++)
									{
										fTraverseFileTree(aEntries[iIndex], sPath + oItem['name'] + '/', fCallback, fLimitCallbackProxy);
									}
								}
							});
						}
					}
				}
			}
		;

		bAllowFolderDragAndDrop = isUndefined(bAllowFolderDragAndDrop) ? true : !!bAllowFolderDragAndDrop;

		bEntry = isUndefined(bEntry) ? false : !!bEntry;
		iLimit = isUndefined(iLimit) ? iDefLimit : Types.pInt(iLimit);
		iInputLimit = iLimit;
		bUseLimit = 0 < iLimit;

		aItems = aItems && 0 < aItems.length ? aItems : null;
		if (aItems)
		{
			for (iIndex = 0, iLen = aItems.length; iIndex < iLen; iIndex++)
			{
				oItem = aItems[iIndex];
				if (oItem)
				{
					if (bEntry)
					{
						if ('file' === oItem['kind'] && oItem['webkitGetAsEntry'])
						{
							oEntry = oItem['webkitGetAsEntry']();
							if (oEntry)
							{
								fTraverseFileTree(oEntry, '', fFileCallback, fLimitCallback);
							}
						}
					}
					else
					{
						if (!bUseLimit || 0 <= --iLimit)
						{
							fFileCallback(getDataFromFile(oItem));
						}
						else if (bUseLimit && !bCallLimit)
						{
							if (0 > iLimit && fLimitCallback)
							{
								bCallLimit = true;
								fLimitCallback(iInputLimit);
							}
						}
					}
				}
			}
		}
	}

	/**
	 * @param {*} oInput
	 * @param {Function} fFileCallback
	 * @param {number=} iLimit = 20
	 * @param {Function=} fLimitCallback
	 */
	function getDataFromInput(oInput, fFileCallback, iLimit, fLimitCallback)
	{
		var aFiles = oInput && oInput.files && 0 < oInput.files.length ? oInput.files : null;
		if (aFiles)
		{
			getDataFromFiles(aFiles, fFileCallback, false, false, iLimit, fLimitCallback);
		}
		else
		{
			fFileCallback({
				'FileName': oInput.value.split('\\').pop().split('/').pop(),
				'Size': null,
				'Type': null,
				'Folder': '',
				'File' : null
			});
		}
	}

	function eventContainsFiles(oEvent)
	{
		var bResult = false;
		if (oEvent && oEvent.dataTransfer && oEvent.dataTransfer.types && oEvent.dataTransfer.types.length)
		{
			var
				iIindex = 0,
				iLen = oEvent.dataTransfer.types.length
			;

			for (; iIindex < iLen; iIindex++)
			{
				if (oEvent.dataTransfer.types[iIindex].toLowerCase() === 'files')
				{
					bResult = true;
					break;
				}
			}
		}

		return bResult;
	}

	/**
	 * @param {Event} oEvent
	 * @param {Function} fFileCallback
	 * @param {number=} iLimit = 20
	 * @param {Function=} fLimitCallback
	 * @param {boolean=} bAllowFolderDragAndDrop = true
	 */
	function getDataFromDragEvent(oEvent, fFileCallback, iLimit, fLimitCallback, bAllowFolderDragAndDrop)
	{
		var
			aItems = null,
			aFiles = null
		;

		oEvent = getEvent(oEvent);
		if (oEvent)
		{
			aItems = (oEvent.dataTransfer ? getValue(oEvent.dataTransfer, 'items', null) : null) || getValue(oEvent, 'items', null);
			if (aItems && 0 < aItems.length && aItems[0] && aItems[0]['webkitGetAsEntry'])
			{
				getDataFromFiles(aItems, fFileCallback, true, bAllowFolderDragAndDrop, iLimit, fLimitCallback);
			}
			else if (eventContainsFiles(oEvent))
			{
				aFiles = (getValue(oEvent, 'files', null) || (oEvent.dataTransfer ?
					getValue(oEvent.dataTransfer, 'files', null) : null));

				if (aFiles && 0 < aFiles.length)
				{
					getDataFromFiles(aFiles, fFileCallback, false, false, iLimit, fLimitCallback);
				}
			}
		}
	}

	function createNextLabel()
	{
		return $('<label style="' +
	'position: absolute; background-color:#fff; right: 0px; top: 0px; left: 0px; bottom: 0px; margin: 0px; padding: 0px; cursor: pointer;' +
		'"></label>').css({
			'opacity': 0
		});
	}

	/**
	 * @param {string} sInputPos
	 * @param {string=} sAccept = ''
	 * @return {?Object}
	 */
	function createNextInput(sInputPos, sAccept)
	{
		if (sAccept !== '')
		{
			sAccept = ' accept="' + sAccept + '"';
		}
		return $('<input type="file" tabindex="-1" hidefocus="hidefocus" style="position: absolute; ' + sInputPos + ': -9999px;"' + sAccept + ' />');
	}

	/**
	 * @param {string=} sName
	 * @param {boolean=} bMultiple = true
	 * @param {string=} sInputPos = 'left'
	 * @param {string=} sAccept = ''
	 * @return {?Object}
	 */
	function getNewInput(sName, bMultiple, sInputPos, sAccept)
	{
		sName = isUndefined(sName) ? '' : sName.toString();
		sInputPos = isUndefined(sInputPos) ? 'left' : sInputPos.toString();
		sAccept = isUndefined(sAccept) ? '' : sAccept.toString();

		var oLocal = createNextInput(sInputPos, sAccept);
		if (0 < sName.length)
		{
			oLocal.attr('name', sName);
		}

		if (isUndefined(bMultiple) ? true : bMultiple)
		{
			oLocal.prop('multiple', true);
		}

		return oLocal;
	}

	/**
	 * @param {?} mStringOrFunction
	 * @param {Array=} aFunctionParams
	 * @return {string}
	 */
	function getStringOrCallFunction(mStringOrFunction, aFunctionParams)
	{
		return Types.pString(_.isFunction(mStringOrFunction) ? 
			mStringOrFunction.apply(null, _.isArray(aFunctionParams) ? aFunctionParams : []) :
			mStringOrFunction);
	}

	/**
	 * @constructor
	 * @param {CJua} oJua
	 * @param {Object} oOptions
	 */
	function AjaxDriver(oJua, oOptions)
	{
		this.oXhrs = {};
		this.oUids = {};
		this.oJua = oJua;
		this.oOptions = oOptions;
	}

	/**
	 * @type {Object}
	 */
	AjaxDriver.prototype.oXhrs = {};

	/**
	 * @type {Object}
	 */
	AjaxDriver.prototype.oUids = {};

	/**
	 * @type {?CJua}
	 */
	AjaxDriver.prototype.oJua = null;

	/**
	 * @type {Object}
	 */
	AjaxDriver.prototype.oOptions = {};

	/**
	 * @return {boolean}
	 */
	AjaxDriver.prototype.isDragAndDropSupported = function ()
	{
		return true;
	};

	/**
	 * @param {string} sUid
	 */
	AjaxDriver.prototype.regTaskUid = function (sUid)
	{
		this.oUids[sUid] = true;
	};

	/**
	 * @param {string} sUid
	 * @param {?} oFileInfo
	 * @param {Function} fCallback
	 */
	AjaxDriver.prototype.uploadTask = function (sUid, oFileInfo, fCallback, bSkipCompleteFunction, bUseResponce, iProgressOffset)
	{
		if (false === this.oUids[sUid] || !oFileInfo || !oFileInfo['File'])
		{
			fCallback(null, sUid);
			return false;
		}

		try
		{
			var
				self = this,
				oXhr = new XMLHttpRequest(),
				oFormData = new FormData(),
				sAction = getValue(this.oOptions, 'action', ''),
				aHidden = getValue(this.oOptions, 'hidden', {}),
				fStartFunction = this.oJua.getEvent('onStart'),
				fCompleteFunction = this.oJua.getEvent('onComplete'),
				fProgressFunction = this.oJua.getEvent('onProgress'),
				oParsedHiddenParameters = null,
				oHiddenParametersOld = aHidden.Parameters
			;

			oXhr.open('POST', sAction, true);
			oXhr.setRequestHeader('Authorization', 'Bearer ' + $.cookie('AuthToken'));
			
			if (fProgressFunction && oXhr.upload)
			{
				oXhr.upload.onprogress = function (oEvent) {
					if (oEvent && oEvent.lengthComputable && !isUndefined(oEvent.loaded) && !isUndefined(oEvent.total))
					{
						if (typeof iProgressOffset === 'undefined')
						{
							fProgressFunction(sUid, oEvent.loaded, oEvent.total);
						}
						else
						{
							fProgressFunction(sUid, (iProgressOffset + oEvent.loaded) > oFileInfo.Size ? oFileInfo.Size : iProgressOffset + oEvent.loaded, oFileInfo.Size);
						}
					}
				};
			}

			oXhr.onreadystatechange = function () {
				if (4 === oXhr.readyState && 200 === oXhr.status)
				{
					if (fCompleteFunction && !bSkipCompleteFunction)
					{
						var
							bResult = false,
							oResult = null
						;

						try
						{
							oResult = $.parseJSON(oXhr.responseText);
							bResult = true;
						}
						catch (oException)
						{
							oResult = null;
						}

						fCompleteFunction(sUid, bResult, oResult);
					}

					if (!isUndefined(self.oXhrs[sUid]))
					{
						self.oXhrs[sUid] = null;
					}

					if (bUseResponce)
					{
						fCallback(oXhr.responseText, sUid);
					}
					else
					{
						fCallback(null, sUid);
					}
				}
				else
				{
					if (4 === oXhr.readyState)
					{
						fCompleteFunction(sUid, false, null);
						fCallback(null, sUid);
					}
				}
			};

			if (fStartFunction)
			{
				fStartFunction(sUid);
			}

			oFormData.append('jua-post-type', 'ajax');
			oFormData.append(getValue(this.oOptions, 'name', 'juaFile'), oFileInfo['File'], oFileInfo['FileName']);
			//extending jua hidden parameters with file hidden parameters
			oParsedHiddenParameters = JSON.parse(getStringOrCallFunction(aHidden.Parameters, [oFileInfo]));
			oParsedHiddenParameters =  _.extend(oParsedHiddenParameters, oFileInfo.Hidden || {});
			aHidden.Parameters = JSON.stringify(oParsedHiddenParameters);
			
			$.each(aHidden, function (sKey, mValue) {
				oFormData.append(sKey, getStringOrCallFunction(mValue, [oFileInfo]));
			});
			//restore jua hidden parameters
			aHidden.Parameters = oHiddenParametersOld;

			oXhr.send(oFormData);

			this.oXhrs[sUid] = oXhr;
			return true;
		}
		catch (oError)
		{
			if (window.console)
			{
				window.console.error(oError);
			}
		}

		fCallback(null, sUid);
		return false;
	};

	AjaxDriver.prototype.generateNewInput = function (oClickElement)
	{
		var
			self = this,
			oLabel = null,
			oInput = null
		;

		if (oClickElement)
		{
			oInput = getNewInput('', !getValue(this.oOptions, 'disableMultiple', false), getValue(this.oOptions, 'hiddenElementsPosition', 'left'), getValue(this.oOptions, 'accept', ''));
			oLabel = createNextLabel();
			oLabel.append(oInput);

			$(oClickElement).append(oLabel);

			oInput
				.on('click', function (event) {

					if (!self.oJua.bEnableButton)
					{
						event.preventDefault();
						return;
					}
					var fOn = self.oJua.getEvent('onDialog');
					if (fOn)
					{
						fOn();
					}
				})
				.on('change', function () {
					getDataFromInput(this, function (oFile) {
							self.oJua.addNewFile(oFile);
							self.generateNewInput(oClickElement);

							setTimeout(function () {
								oLabel.remove();
							}, 10);
						},
						getValue(self.oOptions, 'multipleSizeLimit', iDefLimit),
						self.oJua.getEvent('onLimitReached')
					);
				})
			;
		}
	};

	AjaxDriver.prototype.cancel = function (sUid)
	{
		this.oUids[sUid] = false;
		if (this.oXhrs[sUid])
		{
			try
			{
				if (this.oXhrs[sUid].abort)
				{
					this.oXhrs[sUid].abort();
				}
			}
			catch (oError)
			{
			}

			this.oXhrs[sUid] = null;
		}
	};

	/**
	 * @constructor
	 * @param {CJua} oJua
	 * @param {Object} oOptions
	 */
	function IframeDriver(oJua, oOptions)
	{
		this.oUids = {};
		this.oForms = {};
		this.oJua = oJua;
		this.oOptions = oOptions;
	}

	/**
	 * @type {Object}
	 */
	IframeDriver.prototype.oUids = {};

	/**
	 * @type {Object}
	 */
	IframeDriver.prototype.oForms = {};

	/**
	 * @type {?CJua}
	 */
	IframeDriver.prototype.oJua = null;

	/**
	 * @type {Object}
	 */
	IframeDriver.prototype.oOptions = {};

	/**
	 * @return {boolean}
	 */
	IframeDriver.prototype.isDragAndDropSupported = function ()
	{
		return false;
	};

	/**
	 * @param {string} sUid
	 */
	IframeDriver.prototype.regTaskUid = function (sUid)
	{
		this.oUids[sUid] = true;
	};

	/**
	 * @param {string} sUid
	 * @param {?} oFileInfo
	 * @param {Function} fCallback
	 */
	IframeDriver.prototype.uploadTask = function (sUid, oFileInfo, fCallback, bSkipCompleteFunction, bUseResponce, iProgressOffset)
	{
		if (false === this.oUids[sUid])
		{
			fCallback(null, sUid);
			return false;
		}

		var
			oForm = this.oForms[sUid],
			aHidden = getValue(this.oOptions, 'hidden', {}),
			fStartFunction = this.oJua.getEvent('onStart'),
			fCompleteFunction = this.oJua.getEvent('onComplete')
		;

		if (oForm)
		{
			oForm.append($('<input type="hidden" />').attr('name', 'jua-post-type').val('iframe'));
			$.each(aHidden, function (sKey, sValue) {
				oForm.append($('<input type="hidden" />').attr('name', sKey).val(getStringOrCallFunction(sValue, [oFileInfo])));
			});

			oForm.trigger('submit');
			if (fStartFunction)
			{
				fStartFunction(sUid);
			}

			oForm.find('iframe').on('load', function (oEvent) {

				var
					bResult = false,
					oIframeDoc = null,
					oResult = {}
				;

				if (fCompleteFunction)
				{
					try
					{
						oIframeDoc = this.contentDocument ? this.contentDocument: this.contentWindow.document;
						oResult = $.parseJSON(oIframeDoc.body.innerHTML);
						bResult = true;
					}
					catch (oErr)
					{
						oResult = {};
					}

					fCompleteFunction(sUid, bResult, oResult);
				}

				fCallback(null, sUid);

				window.setTimeout(function () {
					oForm.remove();
				}, 100);
			});
		}
		else
		{
			fCallback(null, sUid);
		}

		return true;
	};

	IframeDriver.prototype.generateNewInput = function (oClickElement)
	{
		var
			self = this,
			sUid = '',
			oInput = null,
			oIframe = null,
			sAction = getValue(this.oOptions, 'action', ''),
			oForm = null,
			sPos = getValue(this.oOptions, 'hiddenElementsPosition', 'left')
		;

		if (oClickElement)
		{
			sUid = getNewUid();

			oInput = getNewInput(getValue(this.oOptions, 'name', 'juaFile'), !getValue(this.oOptions, 'disableMultiple', false), getValue(this.oOptions, 'hiddenElementsPosition', 'left'), getValue(this.oOptions, 'accept', ''));

			oForm = $('<form action="' + sAction + '" target="iframe-' + sUid + '" ' +
	' method="POST" enctype="multipart/form-data" style="display: block; cursor: pointer;"></form>');

			oIframe = $('<iframe name="iframe-' + sUid + '" tabindex="-1" src="javascript:void(0);" ' +
	' style="position: absolute; top: -1000px; ' + sPos + ': -1000px; cursor: pointer;" />').css({'opacity': 0});

			oForm.append(createNextLabel().append(oInput)).append(oIframe);

			$(oClickElement).append(oForm);

			this.oForms[sUid] = oForm;

			oInput
				.on('click', function (event) {
					if (!self.oJua.bEnableButton)
					{
						event.preventDefault();
						return;
					}
					var fOn = self.oJua.getEvent('onDialog');
					if (fOn)
					{
						fOn();
					}
				})
				.on('change', function () {
					getDataFromInput(this, function (oFile) {
							if (oFile)
							{
								var sPos = getValue(self.oOptions, 'hiddenElementsPosition', 'left');

								oForm.css({
									'position': 'absolute',
									'top': -1000
								});

								oForm.css(sPos, -1000);

								self.oJua.addFile(sUid, oFile);
								self.generateNewInput(oClickElement);
							}

						},
						getValue(self.oOptions, 'multipleSizeLimit', iDefLimit),
						self.oJua.getEvent('onLimitReached')
					);
				})
			;
		}
	};

	IframeDriver.prototype.cancel = function (sUid)
	{
		this.oUids[sUid] = false;
		if (this.oForms[sUid])
		{
			this.oForms[sUid].remove();
			this.oForms[sUid] = false;
		}
	};

	/**
	 * @constructor
	 * @param {Object=} oOptions
	 */
	function CJua(oOptions)
	{
		oOptions = isUndefined(oOptions) ? {} : oOptions;

		var self = this;

		self.bEnableDnD = true;
		self.bEnableButton = true;

		self.oEvents = {
			'onDialog': null,
			'onSelect': null,
			'onStart': null,
			'onComplete': null,
			'onCompleteAll': null,
			'onProgress': null,
			'onDragEnter': null,
			'onDragLeave': null,
			'onDrop': null,
			'onBodyDragEnter': null,
			'onBodyDragLeave': null,
			'onLimitReached': null
		};

		self.oOptions = _.extend({
			'action': '',
			'name': '',
			'hidden': {},
			'queueSize': 10,
			'clickElement': false,
			'dragAndDropElement': false,
			'dragAndDropBodyElement': false,
			'disableAjaxUpload': false,
			'disableFolderDragAndDrop': true,
			'disableDragAndDrop': false,
			'disableMultiple': false,
			'disableDocumentDropPrevent': false,
			'disableAutoUploadOnDrop': false,
			'multipleSizeLimit': 50,
			'hiddenElementsPosition': 'left'
		}, oOptions);
		
		self.oQueue = queue(Types.pInt(getValue(self.oOptions, 'queueSize', 10)));
		if (self.runEvent('onCompleteAll'))
		{
			self.oQueue.await(function () {
				self.runEvent('onCompleteAll');
			});
		}

		self.oDriver = self.isAjaxUploaderSupported() && !getValue(self.oOptions, 'disableAjaxUpload', false) ?
			new AjaxDriver(self, self.oOptions) : new IframeDriver(self, self.oOptions);

		self.oClickElement = getValue(self.oOptions, 'clickElement', null);

		if (self.oClickElement)
		{
			$(self.oClickElement).css({
				'position': 'relative',
				'overflow': 'hidden'
			});

			if ('inline' === $(this.oClickElement).css('display'))
			{
				$(this.oClickElement).css('display', 'inline-block');
			}

			this.oDriver.generateNewInput(this.oClickElement);
		}

		if (this.oDriver.isDragAndDropSupported() && getValue(this.oOptions, 'dragAndDropElement', false) &&
			!getValue(this.oOptions, 'disableAjaxUpload', false))
		{
			(function (self) {
				var
					$doc = $(document),
					oBigDropZone = $(getValue(self.oOptions, 'dragAndDropBodyElement', false) || $doc),
					oDragAndDropElement = getValue(self.oOptions, 'dragAndDropElement', false),
					fHandleDragOver = function (oEvent) {
						if (self.bEnableDnD && oEvent)
						{
							oEvent = getEvent(oEvent);
							if (oEvent && oEvent.dataTransfer && eventContainsFiles(oEvent))
							{
								try
								{
									var sEffect = oEvent.dataTransfer.effectAllowed;

									mainClearTimeout(self.iDocTimer);

									oEvent.dataTransfer.dropEffect = (sEffect === 'move' || sEffect === 'linkMove') ? 'move' : 'copy';

									oEvent.stopPropagation();
									oEvent.preventDefault();

									oBigDropZone.trigger('dragover', oEvent);
								}
								catch (oExc) {}
							}
						}
					},
					fHandleDrop = function (oEvent) {
						if (self.bEnableDnD && oEvent)
						{
							oEvent = getEvent(oEvent);
							if (oEvent && eventContainsFiles(oEvent))
							{
								oEvent.preventDefault();

								getDataFromDragEvent(
									oEvent,
									function (oFile) {
										if (oFile)
										{
											if (getValue(self.oOptions, 'disableAutoUploadOnDrop', false)) {
												self.runEvent('onDrop', [
													oFile,
													oEvent,
													function () {
														self.addNewFile(oFile);
														mainClearTimeout(self.iDocTimer);
													}
												]);
											}
											else
											{
												self.runEvent('onDrop', [oFile, oEvent]);
												self.addNewFile(oFile);
												mainClearTimeout(self.iDocTimer);
											}
										}
									},
									getValue(self.oOptions, 'multipleSizeLimit', iDefLimit),
									self.getEvent('onLimitReached'),
									!getValue(self.oOptions, 'disableFolderDragAndDrop', true)
								);
							}
						}

						self.runEvent('onDragLeave', [oEvent]);
					},
					fHandleDragEnter = function (oEvent) {
						if (self.bEnableDnD && oEvent)
						{
							oEvent = getEvent(oEvent);
							if (oEvent && eventContainsFiles(oEvent))
							{
								mainClearTimeout(self.iDocTimer);

								oEvent.preventDefault();
								self.runEvent('onDragEnter', [oDragAndDropElement, oEvent]);
							}
						}
					},
					fHandleDragLeave = function (oEvent) {
						if (self.bEnableDnD && oEvent)
						{
							oEvent = getEvent(oEvent);
							if (oEvent)
							{
								var oRelatedTarget = document['elementFromPoint'] ? document['elementFromPoint'](oEvent['clientX'], oEvent['clientY']) : null;
								if (oRelatedTarget && contains(this, oRelatedTarget))
								{
									return;
								}

								mainClearTimeout(self.iDocTimer);
								self.runEvent('onDragLeave', [oDragAndDropElement, oEvent]);
							}

							return;
						}
					}
				;

				if (oDragAndDropElement)
				{
					if (!getValue(self.oOptions, 'disableDocumentDropPrevent', false))
					{
						$doc.on('dragover', function (oEvent) {
							if (self.bEnableDnD && oEvent)
							{
								oEvent = getEvent(oEvent);
								if (oEvent && oEvent.dataTransfer && eventContainsFiles(oEvent))
								{
									try
									{
										oEvent.dataTransfer.dropEffect = 'none';
										oEvent.preventDefault();
									}
									catch (oExc) {}
								}
							}
						});
					}

					if (oBigDropZone && oBigDropZone[0])
					{
						oBigDropZone
							.on('dragover', function (oEvent) {
								if (self.bEnableDnD && oEvent)
								{
									mainClearTimeout(self.iDocTimer);
								}
							})
							.on('dragenter', function (oEvent) {
								if (self.bEnableDnD && oEvent)
								{
									oEvent = getEvent(oEvent);
									if (oEvent && eventContainsFiles(oEvent))
									{
										mainClearTimeout(self.iDocTimer);
										oEvent.preventDefault();

										self.runEvent('onBodyDragEnter', [oEvent]);
									}
								}
							})
							.on('dragleave', function (oEvent) {
								if (self.bEnableDnD && oEvent)
								{
									oEvent = getEvent(oEvent);
									if (oEvent)
									{
										mainClearTimeout(self.iDocTimer);
										self.iDocTimer = setTimeout(function () {
											self.runEvent('onBodyDragLeave', [oEvent]);
										}, 200);
									}
								}
							})
							.on('drop', function (oEvent) {
								if (self.bEnableDnD && oEvent)
								{
									oEvent = getEvent(oEvent);
									if (oEvent)
									{
										var bFiles = eventContainsFiles(oEvent);
										if (bFiles)
										{
											oEvent.preventDefault();
										}

										self.runEvent('onBodyDragLeave', [oEvent]);

										return !bFiles;
									}
								}

								return false;
							})
						;
					}

					$(oDragAndDropElement)
						.bind('dragenter', fHandleDragEnter)
						.bind('dragover', fHandleDragOver)
						.bind('dragleave', fHandleDragLeave)
						.bind('drop', fHandleDrop)
					;
				}

			}(self));
		}
		else
		{
			self.bEnableDnD = false;
		}

		setValue(self, 'on', self.on);
		setValue(self, 'cancel', self.cancel);
		setValue(self, 'isDragAndDropSupported', self.isDragAndDropSupported);
		setValue(self, 'isAjaxUploaderSupported', self.isAjaxUploaderSupported);
		setValue(self, 'setDragAndDropEnabledStatus', self.setDragAndDropEnabledStatus);
	}

	/**
	 * @type {boolean}
	 */
	CJua.prototype.bEnableDnD = true;

	/**
	 * @type {number}
	 */
	CJua.prototype.iDocTimer = 0;

	/**
	 * @type {Object}
	 */
	CJua.prototype.oOptions = {};

	/**
	 * @type {Object}
	 */
	CJua.prototype.oEvents = {};

	/**
	 * @type {?Object}
	 */
	CJua.prototype.oQueue = null;

	/**
	 * @type {?Object}
	 */
	CJua.prototype.oDriver = null;

	/**
	 * @param {string} sName
	 * @param {Function} fFunc
	 */
	CJua.prototype.on = function (sName, fFunc)
	{
		this.oEvents[sName] = fFunc;
		return this;
	};

	/**
	 * @param {string} sName
	 * @param {string=} aArgs
	 */
	CJua.prototype.runEvent = function (sName, aArgs)
	{
		if (this.oEvents[sName])
		{
			this.oEvents[sName].apply(null, aArgs || []);
		}
	};

	/**
	 * @param {string} sName
	 */
	CJua.prototype.getEvent = function (sName)
	{
		return this.oEvents[sName] || null;
	};

	/**
	 * @param {string} sUid
	 */
	CJua.prototype.cancel = function (sUid)
	{
		this.oDriver.cancel(sUid);
	};

	/**
	 * @return {boolean}
	 */
	CJua.prototype.isAjaxUploaderSupported = function ()
	{
		return (function () {
			var oInput = document.createElement('input');
			oInput.type = 'file';
			return !!('XMLHttpRequest' in window && 'multiple' in oInput && 'FormData' in window && (new XMLHttpRequest()).upload && true);
		}());
	};

	/**
	 * @param {boolean} bEnabled
	 */
	CJua.prototype.setDragAndDropEnabledStatus = function (bEnabled)
	{
		this.bEnableDnD = !!bEnabled;
	};

	/**
	 * @return {boolean}
	 */
	CJua.prototype.isDragAndDropSupported = function ()
	{
		return this.oDriver.isDragAndDropSupported();
	};

	/**
	 * @param {Object} oFileInfo
	 */
	CJua.prototype.addNewFile = function (oFileInfo)
	{
		this.addFile(getNewUid(), oFileInfo);
	};

	/**
	 * @param {string} sUid
	 * @param {Object} oFileInfo
	 */
	CJua.prototype.addFile = function (sUid, oFileInfo)
	{
		var
			fOnSelect = this.getEvent('onSelect'),
			fOnChunkReadyCallback = null,
			bBreakUpload = false,
			aHidden = getValue(this.oOptions, 'hidden', {}),
			fCompleteFunction = this.getEvent('onComplete'),
			fRegularUploadFileCallback = _.bind(function (sUid, oFileInfo) {
				this.oDriver.regTaskUid(sUid);
				this.oQueue.defer(scopeBind(this.oDriver.uploadTask, this.oDriver), sUid, oFileInfo);
			}, this),
			fCancelFunction = this.getEvent('onCancel')
		;
		if (oFileInfo && (!fOnSelect || (false !== fOnSelect(sUid, oFileInfo))))
		{
			// fOnChunkReadyCallback runs when chunk ready for uploading
			fOnChunkReadyCallback = _.bind(function (sUid, oFileInfo, fProcessNextChunkCallback, iCurrChunk, iChunkNumber, iProgressOffset) {
				var fOnUploadCallback = null;
				// fOnUploadCallback runs when server have responded for upload
				fOnUploadCallback = function (sResponse, sFileUploadUid)
				{
					var oResponse = null;
					
					try
					{ // Suppress exceptions in the connection failure case 
						oResponse = $.parseJSON(sResponse);
					}
					catch (err)
					{
					}

					if (oResponse && oResponse.Result && !oResponse.Result.Error && !oResponse.ErrorCode)
					{//if response contains result and have no errors
						fProcessNextChunkCallback(sUid, fOnChunkReadyCallback);
					}
					else if (oResponse && oResponse.Result && oResponse.Result.Error)
					{
						App.broadcastEvent('Jua::FileUploadingError');
						fCompleteFunction(sFileUploadUid, false, {ErrorCode: oResponse.Result.Error});
					}
					else if (oResponse && oResponse.ErrorCode)
					{
						App.broadcastEvent('Jua::FileUploadingError');
						fCompleteFunction(sFileUploadUid, false, {ErrorCode: oResponse.ErrorCode});
					}
					else
					{
						App.broadcastEvent('Jua::FileUploadingError');
						fCompleteFunction(sFileUploadUid, false);
					}
				};
				
				this.oDriver.regTaskUid(sUid);
				this.oDriver.uploadTask(sUid, oFileInfo, fOnUploadCallback, iCurrChunk < iChunkNumber, true, iProgressOffset);
			}, this);
			bBreakUpload = App.broadcastEvent('Jua::FileUpload::before', {
				sUid: sUid,
				oFileInfo: oFileInfo,
				fOnChunkReadyCallback: fOnChunkReadyCallback,
				sModuleName: aHidden.Module,
				fRegularUploadFileCallback: fRegularUploadFileCallback,
				fCancelFunction: fCancelFunction
			});

			if (bBreakUpload === false)
			{
				fRegularUploadFileCallback(sUid, oFileInfo);
			}
		}
		else
		{
			this.oDriver.cancel(sUid);
		}
	};

	/**
	 * @param {string} sName
	 * @param {mixed} mValue
	 */
	CJua.prototype.setOption = function (sName, mValue)
	{
		this.oOptions[sName] = mValue;
	};

	module.exports = CJua;


/***/ }),

/***/ 265:
/*!***************************************************!*\
  !*** ./modules/CoreWebclient/js/vendors/queue.js ***!
  \***************************************************/
/***/ (function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;!function(){function n(n){function e(){for(;i=a<c.length&&n>p;){var u=a++,e=c[u],o=t.call(e,1);o.push(l(u)),++p,e[0].apply(null,o)}}function l(n){return function(u,t){--p,null==s&&(null!=u?(s=u,a=d=0/0,o()):(c[n]=t,--d?i||e():o()))}}function o(){null!=s?m(s):f?m(s,c):m.apply(null,[s].concat(c))}var r,i,f,c=[],a=0,p=0,d=0,s=null,m=u;return n||(n=1/0),r={defer:function(){return s||(c.push(arguments),++d,e()),r},await:function(n){return m=n,f=!1,d||o(),r},awaitAll:function(n){return m=n,f=!0,d||o(),r}}}function u(){}var t=[].slice;n.version="1.0.7", true?!(__WEBPACK_AMD_DEFINE_RESULT__ = function(){return n}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)):"object"==typeof module&&module.exports?module.exports=n:this.queue=n}();


/***/ }),

/***/ 278:
/*!**********************************************!*\
  !*** ./~/jquery-ui/ui/widgets/datepicker.js ***!
  \**********************************************/
/***/ (function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;// jscs:disable maximumLineLength
	/* jscs:disable requireCamelCaseOrUpperCaseIdentifiers */
	/*!
	 * jQuery UI Datepicker 1.12.1
	 * http://jqueryui.com
	 *
	 * Copyright jQuery Foundation and other contributors
	 * Released under the MIT license.
	 * http://jquery.org/license
	 */

	//>>label: Datepicker
	//>>group: Widgets
	//>>description: Displays a calendar from an input or inline for selecting dates.
	//>>docs: http://api.jqueryui.com/datepicker/
	//>>demos: http://jqueryui.com/datepicker/
	//>>css.structure: ../../themes/base/core.css
	//>>css.structure: ../../themes/base/datepicker.css
	//>>css.theme: ../../themes/base/theme.css

	( function( factory ) {
		if ( true ) {

			// AMD. Register as an anonymous module.
			!(__WEBPACK_AMD_DEFINE_ARRAY__ = [
				__webpack_require__(/*! jquery */ 1),
				__webpack_require__(/*! ../version */ 205),
				__webpack_require__(/*! ../keycode */ 204)
			], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else {

			// Browser globals
			factory( jQuery );
		}
	}( function( $ ) {

	$.extend( $.ui, { datepicker: { version: "1.12.1" } } );

	var datepicker_instActive;

	function datepicker_getZindex( elem ) {
		var position, value;
		while ( elem.length && elem[ 0 ] !== document ) {

			// Ignore z-index if position is set to a value where z-index is ignored by the browser
			// This makes behavior of this function consistent across browsers
			// WebKit always returns auto if the element is positioned
			position = elem.css( "position" );
			if ( position === "absolute" || position === "relative" || position === "fixed" ) {

				// IE returns 0 when zIndex is not specified
				// other browsers return a string
				// we ignore the case of nested elements with an explicit value of 0
				// <div style="z-index: -10;"><div style="z-index: 0;"></div></div>
				value = parseInt( elem.css( "zIndex" ), 10 );
				if ( !isNaN( value ) && value !== 0 ) {
					return value;
				}
			}
			elem = elem.parent();
		}

		return 0;
	}
	/* Date picker manager.
	   Use the singleton instance of this class, $.datepicker, to interact with the date picker.
	   Settings for (groups of) date pickers are maintained in an instance object,
	   allowing multiple different settings on the same page. */

	function Datepicker() {
		this._curInst = null; // The current instance in use
		this._keyEvent = false; // If the last event was a key event
		this._disabledInputs = []; // List of date picker inputs that have been disabled
		this._datepickerShowing = false; // True if the popup picker is showing , false if not
		this._inDialog = false; // True if showing within a "dialog", false if not
		this._mainDivId = "ui-datepicker-div"; // The ID of the main datepicker division
		this._inlineClass = "ui-datepicker-inline"; // The name of the inline marker class
		this._appendClass = "ui-datepicker-append"; // The name of the append marker class
		this._triggerClass = "ui-datepicker-trigger"; // The name of the trigger marker class
		this._dialogClass = "ui-datepicker-dialog"; // The name of the dialog marker class
		this._disableClass = "ui-datepicker-disabled"; // The name of the disabled covering marker class
		this._unselectableClass = "ui-datepicker-unselectable"; // The name of the unselectable cell marker class
		this._currentClass = "ui-datepicker-current-day"; // The name of the current day marker class
		this._dayOverClass = "ui-datepicker-days-cell-over"; // The name of the day hover marker class
		this.regional = []; // Available regional settings, indexed by language code
		this.regional[ "" ] = { // Default regional settings
			closeText: "Done", // Display text for close link
			prevText: "Prev", // Display text for previous month link
			nextText: "Next", // Display text for next month link
			currentText: "Today", // Display text for current month link
			monthNames: [ "January","February","March","April","May","June",
				"July","August","September","October","November","December" ], // Names of months for drop-down and formatting
			monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ], // For formatting
			dayNames: [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ], // For formatting
			dayNamesShort: [ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ], // For formatting
			dayNamesMin: [ "Su","Mo","Tu","We","Th","Fr","Sa" ], // Column headings for days starting at Sunday
			weekHeader: "Wk", // Column header for week of the year
			dateFormat: "mm/dd/yy", // See format options on parseDate
			firstDay: 0, // The first day of the week, Sun = 0, Mon = 1, ...
			isRTL: false, // True if right-to-left language, false if left-to-right
			showMonthAfterYear: false, // True if the year select precedes month, false for month then year
			yearSuffix: "" // Additional text to append to the year in the month headers
		};
		this._defaults = { // Global defaults for all the date picker instances
			showOn: "focus", // "focus" for popup on focus,
				// "button" for trigger button, or "both" for either
			showAnim: "fadeIn", // Name of jQuery animation for popup
			showOptions: {}, // Options for enhanced animations
			defaultDate: null, // Used when field is blank: actual date,
				// +/-number for offset from today, null for today
			appendText: "", // Display text following the input box, e.g. showing the format
			buttonText: "...", // Text for trigger button
			buttonImage: "", // URL for trigger button image
			buttonImageOnly: false, // True if the image appears alone, false if it appears on a button
			hideIfNoPrevNext: false, // True to hide next/previous month links
				// if not applicable, false to just disable them
			navigationAsDateFormat: false, // True if date formatting applied to prev/today/next links
			gotoCurrent: false, // True if today link goes back to current selection instead
			changeMonth: false, // True if month can be selected directly, false if only prev/next
			changeYear: false, // True if year can be selected directly, false if only prev/next
			yearRange: "c-10:c+10", // Range of years to display in drop-down,
				// either relative to today's year (-nn:+nn), relative to currently displayed year
				// (c-nn:c+nn), absolute (nnnn:nnnn), or a combination of the above (nnnn:-n)
			showOtherMonths: false, // True to show dates in other months, false to leave blank
			selectOtherMonths: false, // True to allow selection of dates in other months, false for unselectable
			showWeek: false, // True to show week of the year, false to not show it
			calculateWeek: this.iso8601Week, // How to calculate the week of the year,
				// takes a Date and returns the number of the week for it
			shortYearCutoff: "+10", // Short year values < this are in the current century,
				// > this are in the previous century,
				// string value starting with "+" for current year + value
			minDate: null, // The earliest selectable date, or null for no limit
			maxDate: null, // The latest selectable date, or null for no limit
			duration: "fast", // Duration of display/closure
			beforeShowDay: null, // Function that takes a date and returns an array with
				// [0] = true if selectable, false if not, [1] = custom CSS class name(s) or "",
				// [2] = cell title (optional), e.g. $.datepicker.noWeekends
			beforeShow: null, // Function that takes an input field and
				// returns a set of custom settings for the date picker
			onSelect: null, // Define a callback function when a date is selected
			onChangeMonthYear: null, // Define a callback function when the month or year is changed
			onClose: null, // Define a callback function when the datepicker is closed
			numberOfMonths: 1, // Number of months to show at a time
			showCurrentAtPos: 0, // The position in multipe months at which to show the current month (starting at 0)
			stepMonths: 1, // Number of months to step back/forward
			stepBigMonths: 12, // Number of months to step back/forward for the big links
			altField: "", // Selector for an alternate field to store selected dates into
			altFormat: "", // The date format to use for the alternate field
			constrainInput: true, // The input is constrained by the current date format
			showButtonPanel: false, // True to show button panel, false to not show it
			autoSize: false, // True to size the input for the date format, false to leave as is
			disabled: false // The initial disabled state
		};
		$.extend( this._defaults, this.regional[ "" ] );
		this.regional.en = $.extend( true, {}, this.regional[ "" ] );
		this.regional[ "en-US" ] = $.extend( true, {}, this.regional.en );
		this.dpDiv = datepicker_bindHover( $( "<div id='" + this._mainDivId + "' class='ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>" ) );
	}

	$.extend( Datepicker.prototype, {
		/* Class name added to elements to indicate already configured with a date picker. */
		markerClassName: "hasDatepicker",

		//Keep track of the maximum number of rows displayed (see #7043)
		maxRows: 4,

		// TODO rename to "widget" when switching to widget factory
		_widgetDatepicker: function() {
			return this.dpDiv;
		},

		/* Override the default settings for all instances of the date picker.
		 * @param  settings  object - the new settings to use as defaults (anonymous object)
		 * @return the manager object
		 */
		setDefaults: function( settings ) {
			datepicker_extendRemove( this._defaults, settings || {} );
			return this;
		},

		/* Attach the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 * @param  settings  object - the new settings to use for this date picker instance (anonymous)
		 */
		_attachDatepicker: function( target, settings ) {
			var nodeName, inline, inst;
			nodeName = target.nodeName.toLowerCase();
			inline = ( nodeName === "div" || nodeName === "span" );
			if ( !target.id ) {
				this.uuid += 1;
				target.id = "dp" + this.uuid;
			}
			inst = this._newInst( $( target ), inline );
			inst.settings = $.extend( {}, settings || {} );
			if ( nodeName === "input" ) {
				this._connectDatepicker( target, inst );
			} else if ( inline ) {
				this._inlineDatepicker( target, inst );
			}
		},

		/* Create a new instance object. */
		_newInst: function( target, inline ) {
			var id = target[ 0 ].id.replace( /([^A-Za-z0-9_\-])/g, "\\\\$1" ); // escape jQuery meta chars
			return { id: id, input: target, // associated target
				selectedDay: 0, selectedMonth: 0, selectedYear: 0, // current selection
				drawMonth: 0, drawYear: 0, // month being drawn
				inline: inline, // is datepicker inline or not
				dpDiv: ( !inline ? this.dpDiv : // presentation div
				datepicker_bindHover( $( "<div class='" + this._inlineClass + " ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>" ) ) ) };
		},

		/* Attach the date picker to an input field. */
		_connectDatepicker: function( target, inst ) {
			var input = $( target );
			inst.append = $( [] );
			inst.trigger = $( [] );
			if ( input.hasClass( this.markerClassName ) ) {
				return;
			}
			this._attachments( input, inst );
			input.addClass( this.markerClassName ).on( "keydown", this._doKeyDown ).
				on( "keypress", this._doKeyPress ).on( "keyup", this._doKeyUp );
			this._autoSize( inst );
			$.data( target, "datepicker", inst );

			//If disabled option is true, disable the datepicker once it has been attached to the input (see ticket #5665)
			if ( inst.settings.disabled ) {
				this._disableDatepicker( target );
			}
		},

		/* Make attachments based on settings. */
		_attachments: function( input, inst ) {
			var showOn, buttonText, buttonImage,
				appendText = this._get( inst, "appendText" ),
				isRTL = this._get( inst, "isRTL" );

			if ( inst.append ) {
				inst.append.remove();
			}
			if ( appendText ) {
				inst.append = $( "<span class='" + this._appendClass + "'>" + appendText + "</span>" );
				input[ isRTL ? "before" : "after" ]( inst.append );
			}

			input.off( "focus", this._showDatepicker );

			if ( inst.trigger ) {
				inst.trigger.remove();
			}

			showOn = this._get( inst, "showOn" );
			if ( showOn === "focus" || showOn === "both" ) { // pop-up date picker when in the marked field
				input.on( "focus", this._showDatepicker );
			}
			if ( showOn === "button" || showOn === "both" ) { // pop-up date picker when button clicked
				buttonText = this._get( inst, "buttonText" );
				buttonImage = this._get( inst, "buttonImage" );
				inst.trigger = $( this._get( inst, "buttonImageOnly" ) ?
					$( "<img/>" ).addClass( this._triggerClass ).
						attr( { src: buttonImage, alt: buttonText, title: buttonText } ) :
					$( "<button type='button'></button>" ).addClass( this._triggerClass ).
						html( !buttonImage ? buttonText : $( "<img/>" ).attr(
						{ src:buttonImage, alt:buttonText, title:buttonText } ) ) );
				input[ isRTL ? "before" : "after" ]( inst.trigger );
				inst.trigger.on( "click", function() {
					if ( $.datepicker._datepickerShowing && $.datepicker._lastInput === input[ 0 ] ) {
						$.datepicker._hideDatepicker();
					} else if ( $.datepicker._datepickerShowing && $.datepicker._lastInput !== input[ 0 ] ) {
						$.datepicker._hideDatepicker();
						$.datepicker._showDatepicker( input[ 0 ] );
					} else {
						$.datepicker._showDatepicker( input[ 0 ] );
					}
					return false;
				} );
			}
		},

		/* Apply the maximum length for the date format. */
		_autoSize: function( inst ) {
			if ( this._get( inst, "autoSize" ) && !inst.inline ) {
				var findMax, max, maxI, i,
					date = new Date( 2009, 12 - 1, 20 ), // Ensure double digits
					dateFormat = this._get( inst, "dateFormat" );

				if ( dateFormat.match( /[DM]/ ) ) {
					findMax = function( names ) {
						max = 0;
						maxI = 0;
						for ( i = 0; i < names.length; i++ ) {
							if ( names[ i ].length > max ) {
								max = names[ i ].length;
								maxI = i;
							}
						}
						return maxI;
					};
					date.setMonth( findMax( this._get( inst, ( dateFormat.match( /MM/ ) ?
						"monthNames" : "monthNamesShort" ) ) ) );
					date.setDate( findMax( this._get( inst, ( dateFormat.match( /DD/ ) ?
						"dayNames" : "dayNamesShort" ) ) ) + 20 - date.getDay() );
				}
				inst.input.attr( "size", this._formatDate( inst, date ).length );
			}
		},

		/* Attach an inline date picker to a div. */
		_inlineDatepicker: function( target, inst ) {
			var divSpan = $( target );
			if ( divSpan.hasClass( this.markerClassName ) ) {
				return;
			}
			divSpan.addClass( this.markerClassName ).append( inst.dpDiv );
			$.data( target, "datepicker", inst );
			this._setDate( inst, this._getDefaultDate( inst ), true );
			this._updateDatepicker( inst );
			this._updateAlternate( inst );

			//If disabled option is true, disable the datepicker before showing it (see ticket #5665)
			if ( inst.settings.disabled ) {
				this._disableDatepicker( target );
			}

			// Set display:block in place of inst.dpDiv.show() which won't work on disconnected elements
			// http://bugs.jqueryui.com/ticket/7552 - A Datepicker created on a detached div has zero height
			inst.dpDiv.css( "display", "block" );
		},

		/* Pop-up the date picker in a "dialog" box.
		 * @param  input element - ignored
		 * @param  date	string or Date - the initial date to display
		 * @param  onSelect  function - the function to call when a date is selected
		 * @param  settings  object - update the dialog date picker instance's settings (anonymous object)
		 * @param  pos int[2] - coordinates for the dialog's position within the screen or
		 *					event - with x/y coordinates or
		 *					leave empty for default (screen centre)
		 * @return the manager object
		 */
		_dialogDatepicker: function( input, date, onSelect, settings, pos ) {
			var id, browserWidth, browserHeight, scrollX, scrollY,
				inst = this._dialogInst; // internal instance

			if ( !inst ) {
				this.uuid += 1;
				id = "dp" + this.uuid;
				this._dialogInput = $( "<input type='text' id='" + id +
					"' style='position: absolute; top: -100px; width: 0px;'/>" );
				this._dialogInput.on( "keydown", this._doKeyDown );
				$( "body" ).append( this._dialogInput );
				inst = this._dialogInst = this._newInst( this._dialogInput, false );
				inst.settings = {};
				$.data( this._dialogInput[ 0 ], "datepicker", inst );
			}
			datepicker_extendRemove( inst.settings, settings || {} );
			date = ( date && date.constructor === Date ? this._formatDate( inst, date ) : date );
			this._dialogInput.val( date );

			this._pos = ( pos ? ( pos.length ? pos : [ pos.pageX, pos.pageY ] ) : null );
			if ( !this._pos ) {
				browserWidth = document.documentElement.clientWidth;
				browserHeight = document.documentElement.clientHeight;
				scrollX = document.documentElement.scrollLeft || document.body.scrollLeft;
				scrollY = document.documentElement.scrollTop || document.body.scrollTop;
				this._pos = // should use actual width/height below
					[ ( browserWidth / 2 ) - 100 + scrollX, ( browserHeight / 2 ) - 150 + scrollY ];
			}

			// Move input on screen for focus, but hidden behind dialog
			this._dialogInput.css( "left", ( this._pos[ 0 ] + 20 ) + "px" ).css( "top", this._pos[ 1 ] + "px" );
			inst.settings.onSelect = onSelect;
			this._inDialog = true;
			this.dpDiv.addClass( this._dialogClass );
			this._showDatepicker( this._dialogInput[ 0 ] );
			if ( $.blockUI ) {
				$.blockUI( this.dpDiv );
			}
			$.data( this._dialogInput[ 0 ], "datepicker", inst );
			return this;
		},

		/* Detach a datepicker from its control.
		 * @param  target	element - the target input field or division or span
		 */
		_destroyDatepicker: function( target ) {
			var nodeName,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			$.removeData( target, "datepicker" );
			if ( nodeName === "input" ) {
				inst.append.remove();
				inst.trigger.remove();
				$target.removeClass( this.markerClassName ).
					off( "focus", this._showDatepicker ).
					off( "keydown", this._doKeyDown ).
					off( "keypress", this._doKeyPress ).
					off( "keyup", this._doKeyUp );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				$target.removeClass( this.markerClassName ).empty();
			}

			if ( datepicker_instActive === inst ) {
				datepicker_instActive = null;
			}
		},

		/* Enable the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 */
		_enableDatepicker: function( target ) {
			var nodeName, inline,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			if ( nodeName === "input" ) {
				target.disabled = false;
				inst.trigger.filter( "button" ).
					each( function() { this.disabled = false; } ).end().
					filter( "img" ).css( { opacity: "1.0", cursor: "" } );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				inline = $target.children( "." + this._inlineClass );
				inline.children().removeClass( "ui-state-disabled" );
				inline.find( "select.ui-datepicker-month, select.ui-datepicker-year" ).
					prop( "disabled", false );
			}
			this._disabledInputs = $.map( this._disabledInputs,
				function( value ) { return ( value === target ? null : value ); } ); // delete entry
		},

		/* Disable the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 */
		_disableDatepicker: function( target ) {
			var nodeName, inline,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			if ( nodeName === "input" ) {
				target.disabled = true;
				inst.trigger.filter( "button" ).
					each( function() { this.disabled = true; } ).end().
					filter( "img" ).css( { opacity: "0.5", cursor: "default" } );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				inline = $target.children( "." + this._inlineClass );
				inline.children().addClass( "ui-state-disabled" );
				inline.find( "select.ui-datepicker-month, select.ui-datepicker-year" ).
					prop( "disabled", true );
			}
			this._disabledInputs = $.map( this._disabledInputs,
				function( value ) { return ( value === target ? null : value ); } ); // delete entry
			this._disabledInputs[ this._disabledInputs.length ] = target;
		},

		/* Is the first field in a jQuery collection disabled as a datepicker?
		 * @param  target	element - the target input field or division or span
		 * @return boolean - true if disabled, false if enabled
		 */
		_isDisabledDatepicker: function( target ) {
			if ( !target ) {
				return false;
			}
			for ( var i = 0; i < this._disabledInputs.length; i++ ) {
				if ( this._disabledInputs[ i ] === target ) {
					return true;
				}
			}
			return false;
		},

		/* Retrieve the instance data for the target control.
		 * @param  target  element - the target input field or division or span
		 * @return  object - the associated instance data
		 * @throws  error if a jQuery problem getting data
		 */
		_getInst: function( target ) {
			try {
				return $.data( target, "datepicker" );
			}
			catch ( err ) {
				throw "Missing instance data for this datepicker";
			}
		},

		/* Update or retrieve the settings for a date picker attached to an input field or division.
		 * @param  target  element - the target input field or division or span
		 * @param  name	object - the new settings to update or
		 *				string - the name of the setting to change or retrieve,
		 *				when retrieving also "all" for all instance settings or
		 *				"defaults" for all global defaults
		 * @param  value   any - the new value for the setting
		 *				(omit if above is an object or to retrieve a value)
		 */
		_optionDatepicker: function( target, name, value ) {
			var settings, date, minDate, maxDate,
				inst = this._getInst( target );

			if ( arguments.length === 2 && typeof name === "string" ) {
				return ( name === "defaults" ? $.extend( {}, $.datepicker._defaults ) :
					( inst ? ( name === "all" ? $.extend( {}, inst.settings ) :
					this._get( inst, name ) ) : null ) );
			}

			settings = name || {};
			if ( typeof name === "string" ) {
				settings = {};
				settings[ name ] = value;
			}

			if ( inst ) {
				if ( this._curInst === inst ) {
					this._hideDatepicker();
				}

				date = this._getDateDatepicker( target, true );
				minDate = this._getMinMaxDate( inst, "min" );
				maxDate = this._getMinMaxDate( inst, "max" );
				datepicker_extendRemove( inst.settings, settings );

				// reformat the old minDate/maxDate values if dateFormat changes and a new minDate/maxDate isn't provided
				if ( minDate !== null && settings.dateFormat !== undefined && settings.minDate === undefined ) {
					inst.settings.minDate = this._formatDate( inst, minDate );
				}
				if ( maxDate !== null && settings.dateFormat !== undefined && settings.maxDate === undefined ) {
					inst.settings.maxDate = this._formatDate( inst, maxDate );
				}
				if ( "disabled" in settings ) {
					if ( settings.disabled ) {
						this._disableDatepicker( target );
					} else {
						this._enableDatepicker( target );
					}
				}
				this._attachments( $( target ), inst );
				this._autoSize( inst );
				this._setDate( inst, date );
				this._updateAlternate( inst );
				this._updateDatepicker( inst );
			}
		},

		// Change method deprecated
		_changeDatepicker: function( target, name, value ) {
			this._optionDatepicker( target, name, value );
		},

		/* Redraw the date picker attached to an input field or division.
		 * @param  target  element - the target input field or division or span
		 */
		_refreshDatepicker: function( target ) {
			var inst = this._getInst( target );
			if ( inst ) {
				this._updateDatepicker( inst );
			}
		},

		/* Set the dates for a jQuery selection.
		 * @param  target element - the target input field or division or span
		 * @param  date	Date - the new date
		 */
		_setDateDatepicker: function( target, date ) {
			var inst = this._getInst( target );
			if ( inst ) {
				this._setDate( inst, date );
				this._updateDatepicker( inst );
				this._updateAlternate( inst );
			}
		},

		/* Get the date(s) for the first entry in a jQuery selection.
		 * @param  target element - the target input field or division or span
		 * @param  noDefault boolean - true if no default date is to be used
		 * @return Date - the current date
		 */
		_getDateDatepicker: function( target, noDefault ) {
			var inst = this._getInst( target );
			if ( inst && !inst.inline ) {
				this._setDateFromField( inst, noDefault );
			}
			return ( inst ? this._getDate( inst ) : null );
		},

		/* Handle keystrokes. */
		_doKeyDown: function( event ) {
			var onSelect, dateStr, sel,
				inst = $.datepicker._getInst( event.target ),
				handled = true,
				isRTL = inst.dpDiv.is( ".ui-datepicker-rtl" );

			inst._keyEvent = true;
			if ( $.datepicker._datepickerShowing ) {
				switch ( event.keyCode ) {
					case 9: $.datepicker._hideDatepicker();
							handled = false;
							break; // hide on tab out
					case 13: sel = $( "td." + $.datepicker._dayOverClass + ":not(." +
										$.datepicker._currentClass + ")", inst.dpDiv );
							if ( sel[ 0 ] ) {
								$.datepicker._selectDay( event.target, inst.selectedMonth, inst.selectedYear, sel[ 0 ] );
							}

							onSelect = $.datepicker._get( inst, "onSelect" );
							if ( onSelect ) {
								dateStr = $.datepicker._formatDate( inst );

								// Trigger custom callback
								onSelect.apply( ( inst.input ? inst.input[ 0 ] : null ), [ dateStr, inst ] );
							} else {
								$.datepicker._hideDatepicker();
							}

							return false; // don't submit the form
					case 27: $.datepicker._hideDatepicker();
							break; // hide on escape
					case 33: $.datepicker._adjustDate( event.target, ( event.ctrlKey ?
								-$.datepicker._get( inst, "stepBigMonths" ) :
								-$.datepicker._get( inst, "stepMonths" ) ), "M" );
							break; // previous month/year on page up/+ ctrl
					case 34: $.datepicker._adjustDate( event.target, ( event.ctrlKey ?
								+$.datepicker._get( inst, "stepBigMonths" ) :
								+$.datepicker._get( inst, "stepMonths" ) ), "M" );
							break; // next month/year on page down/+ ctrl
					case 35: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._clearDate( event.target );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // clear on ctrl or command +end
					case 36: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._gotoToday( event.target );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // current on ctrl or command +home
					case 37: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, ( isRTL ? +1 : -1 ), "D" );
							}
							handled = event.ctrlKey || event.metaKey;

							// -1 day on ctrl or command +left
							if ( event.originalEvent.altKey ) {
								$.datepicker._adjustDate( event.target, ( event.ctrlKey ?
									-$.datepicker._get( inst, "stepBigMonths" ) :
									-$.datepicker._get( inst, "stepMonths" ) ), "M" );
							}

							// next month/year on alt +left on Mac
							break;
					case 38: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, -7, "D" );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // -1 week on ctrl or command +up
					case 39: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, ( isRTL ? -1 : +1 ), "D" );
							}
							handled = event.ctrlKey || event.metaKey;

							// +1 day on ctrl or command +right
							if ( event.originalEvent.altKey ) {
								$.datepicker._adjustDate( event.target, ( event.ctrlKey ?
									+$.datepicker._get( inst, "stepBigMonths" ) :
									+$.datepicker._get( inst, "stepMonths" ) ), "M" );
							}

							// next month/year on alt +right
							break;
					case 40: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, +7, "D" );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // +1 week on ctrl or command +down
					default: handled = false;
				}
			} else if ( event.keyCode === 36 && event.ctrlKey ) { // display the date picker on ctrl+home
				$.datepicker._showDatepicker( this );
			} else {
				handled = false;
			}

			if ( handled ) {
				event.preventDefault();
				event.stopPropagation();
			}
		},

		/* Filter entered characters - based on date format. */
		_doKeyPress: function( event ) {
			var chars, chr,
				inst = $.datepicker._getInst( event.target );

			if ( $.datepicker._get( inst, "constrainInput" ) ) {
				chars = $.datepicker._possibleChars( $.datepicker._get( inst, "dateFormat" ) );
				chr = String.fromCharCode( event.charCode == null ? event.keyCode : event.charCode );
				return event.ctrlKey || event.metaKey || ( chr < " " || !chars || chars.indexOf( chr ) > -1 );
			}
		},

		/* Synchronise manual entry and field/alternate field. */
		_doKeyUp: function( event ) {
			var date,
				inst = $.datepicker._getInst( event.target );

			if ( inst.input.val() !== inst.lastVal ) {
				try {
					date = $.datepicker.parseDate( $.datepicker._get( inst, "dateFormat" ),
						( inst.input ? inst.input.val() : null ),
						$.datepicker._getFormatConfig( inst ) );

					if ( date ) { // only if valid
						$.datepicker._setDateFromField( inst );
						$.datepicker._updateAlternate( inst );
						$.datepicker._updateDatepicker( inst );
					}
				}
				catch ( err ) {
				}
			}
			return true;
		},

		/* Pop-up the date picker for a given input field.
		 * If false returned from beforeShow event handler do not show.
		 * @param  input  element - the input field attached to the date picker or
		 *					event - if triggered by focus
		 */
		_showDatepicker: function( input ) {
			input = input.target || input;
			if ( input.nodeName.toLowerCase() !== "input" ) { // find from button/image trigger
				input = $( "input", input.parentNode )[ 0 ];
			}

			if ( $.datepicker._isDisabledDatepicker( input ) || $.datepicker._lastInput === input ) { // already here
				return;
			}

			var inst, beforeShow, beforeShowSettings, isFixed,
				offset, showAnim, duration;

			inst = $.datepicker._getInst( input );
			if ( $.datepicker._curInst && $.datepicker._curInst !== inst ) {
				$.datepicker._curInst.dpDiv.stop( true, true );
				if ( inst && $.datepicker._datepickerShowing ) {
					$.datepicker._hideDatepicker( $.datepicker._curInst.input[ 0 ] );
				}
			}

			beforeShow = $.datepicker._get( inst, "beforeShow" );
			beforeShowSettings = beforeShow ? beforeShow.apply( input, [ input, inst ] ) : {};
			if ( beforeShowSettings === false ) {
				return;
			}
			datepicker_extendRemove( inst.settings, beforeShowSettings );

			inst.lastVal = null;
			$.datepicker._lastInput = input;
			$.datepicker._setDateFromField( inst );

			if ( $.datepicker._inDialog ) { // hide cursor
				input.value = "";
			}
			if ( !$.datepicker._pos ) { // position below input
				$.datepicker._pos = $.datepicker._findPos( input );
				$.datepicker._pos[ 1 ] += input.offsetHeight; // add the height
			}

			isFixed = false;
			$( input ).parents().each( function() {
				isFixed |= $( this ).css( "position" ) === "fixed";
				return !isFixed;
			} );

			offset = { left: $.datepicker._pos[ 0 ], top: $.datepicker._pos[ 1 ] };
			$.datepicker._pos = null;

			//to avoid flashes on Firefox
			inst.dpDiv.empty();

			// determine sizing offscreen
			inst.dpDiv.css( { position: "absolute", display: "block", top: "-1000px" } );
			$.datepicker._updateDatepicker( inst );

			// fix width for dynamic number of date pickers
			// and adjust position before showing
			offset = $.datepicker._checkOffset( inst, offset, isFixed );
			inst.dpDiv.css( { position: ( $.datepicker._inDialog && $.blockUI ?
				"static" : ( isFixed ? "fixed" : "absolute" ) ), display: "none",
				left: offset.left + "px", top: offset.top + "px" } );

			if ( !inst.inline ) {
				showAnim = $.datepicker._get( inst, "showAnim" );
				duration = $.datepicker._get( inst, "duration" );
				inst.dpDiv.css( "z-index", datepicker_getZindex( $( input ) ) + 1 );
				$.datepicker._datepickerShowing = true;

				if ( $.effects && $.effects.effect[ showAnim ] ) {
					inst.dpDiv.show( showAnim, $.datepicker._get( inst, "showOptions" ), duration );
				} else {
					inst.dpDiv[ showAnim || "show" ]( showAnim ? duration : null );
				}

				if ( $.datepicker._shouldFocusInput( inst ) ) {
					inst.input.trigger( "focus" );
				}

				$.datepicker._curInst = inst;
			}
		},

		/* Generate the date picker content. */
		_updateDatepicker: function( inst ) {
			this.maxRows = 4; //Reset the max number of rows being displayed (see #7043)
			datepicker_instActive = inst; // for delegate hover events
			inst.dpDiv.empty().append( this._generateHTML( inst ) );
			this._attachHandlers( inst );

			var origyearshtml,
				numMonths = this._getNumberOfMonths( inst ),
				cols = numMonths[ 1 ],
				width = 17,
				activeCell = inst.dpDiv.find( "." + this._dayOverClass + " a" );

			if ( activeCell.length > 0 ) {
				datepicker_handleMouseover.apply( activeCell.get( 0 ) );
			}

			inst.dpDiv.removeClass( "ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4" ).width( "" );
			if ( cols > 1 ) {
				inst.dpDiv.addClass( "ui-datepicker-multi-" + cols ).css( "width", ( width * cols ) + "em" );
			}
			inst.dpDiv[ ( numMonths[ 0 ] !== 1 || numMonths[ 1 ] !== 1 ? "add" : "remove" ) +
				"Class" ]( "ui-datepicker-multi" );
			inst.dpDiv[ ( this._get( inst, "isRTL" ) ? "add" : "remove" ) +
				"Class" ]( "ui-datepicker-rtl" );

			if ( inst === $.datepicker._curInst && $.datepicker._datepickerShowing && $.datepicker._shouldFocusInput( inst ) ) {
				inst.input.trigger( "focus" );
			}

			// Deffered render of the years select (to avoid flashes on Firefox)
			if ( inst.yearshtml ) {
				origyearshtml = inst.yearshtml;
				setTimeout( function() {

					//assure that inst.yearshtml didn't change.
					if ( origyearshtml === inst.yearshtml && inst.yearshtml ) {
						inst.dpDiv.find( "select.ui-datepicker-year:first" ).replaceWith( inst.yearshtml );
					}
					origyearshtml = inst.yearshtml = null;
				}, 0 );
			}
		},

		// #6694 - don't focus the input if it's already focused
		// this breaks the change event in IE
		// Support: IE and jQuery <1.9
		_shouldFocusInput: function( inst ) {
			return inst.input && inst.input.is( ":visible" ) && !inst.input.is( ":disabled" ) && !inst.input.is( ":focus" );
		},

		/* Check positioning to remain on screen. */
		_checkOffset: function( inst, offset, isFixed ) {
			var dpWidth = inst.dpDiv.outerWidth(),
				dpHeight = inst.dpDiv.outerHeight(),
				inputWidth = inst.input ? inst.input.outerWidth() : 0,
				inputHeight = inst.input ? inst.input.outerHeight() : 0,
				viewWidth = document.documentElement.clientWidth + ( isFixed ? 0 : $( document ).scrollLeft() ),
				viewHeight = document.documentElement.clientHeight + ( isFixed ? 0 : $( document ).scrollTop() );

			offset.left -= ( this._get( inst, "isRTL" ) ? ( dpWidth - inputWidth ) : 0 );
			offset.left -= ( isFixed && offset.left === inst.input.offset().left ) ? $( document ).scrollLeft() : 0;
			offset.top -= ( isFixed && offset.top === ( inst.input.offset().top + inputHeight ) ) ? $( document ).scrollTop() : 0;

			// Now check if datepicker is showing outside window viewport - move to a better place if so.
			offset.left -= Math.min( offset.left, ( offset.left + dpWidth > viewWidth && viewWidth > dpWidth ) ?
				Math.abs( offset.left + dpWidth - viewWidth ) : 0 );
			offset.top -= Math.min( offset.top, ( offset.top + dpHeight > viewHeight && viewHeight > dpHeight ) ?
				Math.abs( dpHeight + inputHeight ) : 0 );

			return offset;
		},

		/* Find an object's position on the screen. */
		_findPos: function( obj ) {
			var position,
				inst = this._getInst( obj ),
				isRTL = this._get( inst, "isRTL" );

			while ( obj && ( obj.type === "hidden" || obj.nodeType !== 1 || $.expr.filters.hidden( obj ) ) ) {
				obj = obj[ isRTL ? "previousSibling" : "nextSibling" ];
			}

			position = $( obj ).offset();
			return [ position.left, position.top ];
		},

		/* Hide the date picker from view.
		 * @param  input  element - the input field attached to the date picker
		 */
		_hideDatepicker: function( input ) {
			var showAnim, duration, postProcess, onClose,
				inst = this._curInst;

			if ( !inst || ( input && inst !== $.data( input, "datepicker" ) ) ) {
				return;
			}

			if ( this._datepickerShowing ) {
				showAnim = this._get( inst, "showAnim" );
				duration = this._get( inst, "duration" );
				postProcess = function() {
					$.datepicker._tidyDialog( inst );
				};

				// DEPRECATED: after BC for 1.8.x $.effects[ showAnim ] is not needed
				if ( $.effects && ( $.effects.effect[ showAnim ] || $.effects[ showAnim ] ) ) {
					inst.dpDiv.hide( showAnim, $.datepicker._get( inst, "showOptions" ), duration, postProcess );
				} else {
					inst.dpDiv[ ( showAnim === "slideDown" ? "slideUp" :
						( showAnim === "fadeIn" ? "fadeOut" : "hide" ) ) ]( ( showAnim ? duration : null ), postProcess );
				}

				if ( !showAnim ) {
					postProcess();
				}
				this._datepickerShowing = false;

				onClose = this._get( inst, "onClose" );
				if ( onClose ) {
					onClose.apply( ( inst.input ? inst.input[ 0 ] : null ), [ ( inst.input ? inst.input.val() : "" ), inst ] );
				}

				this._lastInput = null;
				if ( this._inDialog ) {
					this._dialogInput.css( { position: "absolute", left: "0", top: "-100px" } );
					if ( $.blockUI ) {
						$.unblockUI();
						$( "body" ).append( this.dpDiv );
					}
				}
				this._inDialog = false;
			}
		},

		/* Tidy up after a dialog display. */
		_tidyDialog: function( inst ) {
			inst.dpDiv.removeClass( this._dialogClass ).off( ".ui-datepicker-calendar" );
		},

		/* Close date picker if clicked elsewhere. */
		_checkExternalClick: function( event ) {
			if ( !$.datepicker._curInst ) {
				return;
			}

			var $target = $( event.target ),
				inst = $.datepicker._getInst( $target[ 0 ] );

			if ( ( ( $target[ 0 ].id !== $.datepicker._mainDivId &&
					$target.parents( "#" + $.datepicker._mainDivId ).length === 0 &&
					!$target.hasClass( $.datepicker.markerClassName ) &&
					!$target.closest( "." + $.datepicker._triggerClass ).length &&
					$.datepicker._datepickerShowing && !( $.datepicker._inDialog && $.blockUI ) ) ) ||
				( $target.hasClass( $.datepicker.markerClassName ) && $.datepicker._curInst !== inst ) ) {
					$.datepicker._hideDatepicker();
			}
		},

		/* Adjust one of the date sub-fields. */
		_adjustDate: function( id, offset, period ) {
			var target = $( id ),
				inst = this._getInst( target[ 0 ] );

			if ( this._isDisabledDatepicker( target[ 0 ] ) ) {
				return;
			}
			this._adjustInstDate( inst, offset +
				( period === "M" ? this._get( inst, "showCurrentAtPos" ) : 0 ), // undo positioning
				period );
			this._updateDatepicker( inst );
		},

		/* Action for current link. */
		_gotoToday: function( id ) {
			var date,
				target = $( id ),
				inst = this._getInst( target[ 0 ] );

			if ( this._get( inst, "gotoCurrent" ) && inst.currentDay ) {
				inst.selectedDay = inst.currentDay;
				inst.drawMonth = inst.selectedMonth = inst.currentMonth;
				inst.drawYear = inst.selectedYear = inst.currentYear;
			} else {
				date = new Date();
				inst.selectedDay = date.getDate();
				inst.drawMonth = inst.selectedMonth = date.getMonth();
				inst.drawYear = inst.selectedYear = date.getFullYear();
			}
			this._notifyChange( inst );
			this._adjustDate( target );
		},

		/* Action for selecting a new month/year. */
		_selectMonthYear: function( id, select, period ) {
			var target = $( id ),
				inst = this._getInst( target[ 0 ] );

			inst[ "selected" + ( period === "M" ? "Month" : "Year" ) ] =
			inst[ "draw" + ( period === "M" ? "Month" : "Year" ) ] =
				parseInt( select.options[ select.selectedIndex ].value, 10 );

			this._notifyChange( inst );
			this._adjustDate( target );
		},

		/* Action for selecting a day. */
		_selectDay: function( id, month, year, td ) {
			var inst,
				target = $( id );

			if ( $( td ).hasClass( this._unselectableClass ) || this._isDisabledDatepicker( target[ 0 ] ) ) {
				return;
			}

			inst = this._getInst( target[ 0 ] );
			inst.selectedDay = inst.currentDay = $( "a", td ).html();
			inst.selectedMonth = inst.currentMonth = month;
			inst.selectedYear = inst.currentYear = year;
			this._selectDate( id, this._formatDate( inst,
				inst.currentDay, inst.currentMonth, inst.currentYear ) );
		},

		/* Erase the input field and hide the date picker. */
		_clearDate: function( id ) {
			var target = $( id );
			this._selectDate( target, "" );
		},

		/* Update the input field with the selected date. */
		_selectDate: function( id, dateStr ) {
			var onSelect,
				target = $( id ),
				inst = this._getInst( target[ 0 ] );

			dateStr = ( dateStr != null ? dateStr : this._formatDate( inst ) );
			if ( inst.input ) {
				inst.input.val( dateStr );
			}
			this._updateAlternate( inst );

			onSelect = this._get( inst, "onSelect" );
			if ( onSelect ) {
				onSelect.apply( ( inst.input ? inst.input[ 0 ] : null ), [ dateStr, inst ] );  // trigger custom callback
			} else if ( inst.input ) {
				inst.input.trigger( "change" ); // fire the change event
			}

			if ( inst.inline ) {
				this._updateDatepicker( inst );
			} else {
				this._hideDatepicker();
				this._lastInput = inst.input[ 0 ];
				if ( typeof( inst.input[ 0 ] ) !== "object" ) {
					inst.input.trigger( "focus" ); // restore focus
				}
				this._lastInput = null;
			}
		},

		/* Update any alternate field to synchronise with the main field. */
		_updateAlternate: function( inst ) {
			var altFormat, date, dateStr,
				altField = this._get( inst, "altField" );

			if ( altField ) { // update alternate field too
				altFormat = this._get( inst, "altFormat" ) || this._get( inst, "dateFormat" );
				date = this._getDate( inst );
				dateStr = this.formatDate( altFormat, date, this._getFormatConfig( inst ) );
				$( altField ).val( dateStr );
			}
		},

		/* Set as beforeShowDay function to prevent selection of weekends.
		 * @param  date  Date - the date to customise
		 * @return [boolean, string] - is this date selectable?, what is its CSS class?
		 */
		noWeekends: function( date ) {
			var day = date.getDay();
			return [ ( day > 0 && day < 6 ), "" ];
		},

		/* Set as calculateWeek to determine the week of the year based on the ISO 8601 definition.
		 * @param  date  Date - the date to get the week for
		 * @return  number - the number of the week within the year that contains this date
		 */
		iso8601Week: function( date ) {
			var time,
				checkDate = new Date( date.getTime() );

			// Find Thursday of this week starting on Monday
			checkDate.setDate( checkDate.getDate() + 4 - ( checkDate.getDay() || 7 ) );

			time = checkDate.getTime();
			checkDate.setMonth( 0 ); // Compare with Jan 1
			checkDate.setDate( 1 );
			return Math.floor( Math.round( ( time - checkDate ) / 86400000 ) / 7 ) + 1;
		},

		/* Parse a string value into a date object.
		 * See formatDate below for the possible formats.
		 *
		 * @param  format string - the expected format of the date
		 * @param  value string - the date in the above format
		 * @param  settings Object - attributes include:
		 *					shortYearCutoff  number - the cutoff year for determining the century (optional)
		 *					dayNamesShort	string[7] - abbreviated names of the days from Sunday (optional)
		 *					dayNames		string[7] - names of the days from Sunday (optional)
		 *					monthNamesShort string[12] - abbreviated names of the months (optional)
		 *					monthNames		string[12] - names of the months (optional)
		 * @return  Date - the extracted date value or null if value is blank
		 */
		parseDate: function( format, value, settings ) {
			if ( format == null || value == null ) {
				throw "Invalid arguments";
			}

			value = ( typeof value === "object" ? value.toString() : value + "" );
			if ( value === "" ) {
				return null;
			}

			var iFormat, dim, extra,
				iValue = 0,
				shortYearCutoffTemp = ( settings ? settings.shortYearCutoff : null ) || this._defaults.shortYearCutoff,
				shortYearCutoff = ( typeof shortYearCutoffTemp !== "string" ? shortYearCutoffTemp :
					new Date().getFullYear() % 100 + parseInt( shortYearCutoffTemp, 10 ) ),
				dayNamesShort = ( settings ? settings.dayNamesShort : null ) || this._defaults.dayNamesShort,
				dayNames = ( settings ? settings.dayNames : null ) || this._defaults.dayNames,
				monthNamesShort = ( settings ? settings.monthNamesShort : null ) || this._defaults.monthNamesShort,
				monthNames = ( settings ? settings.monthNames : null ) || this._defaults.monthNames,
				year = -1,
				month = -1,
				day = -1,
				doy = -1,
				literal = false,
				date,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				},

				// Extract a number from the string value
				getNumber = function( match ) {
					var isDoubled = lookAhead( match ),
						size = ( match === "@" ? 14 : ( match === "!" ? 20 :
						( match === "y" && isDoubled ? 4 : ( match === "o" ? 3 : 2 ) ) ) ),
						minSize = ( match === "y" ? size : 1 ),
						digits = new RegExp( "^\\d{" + minSize + "," + size + "}" ),
						num = value.substring( iValue ).match( digits );
					if ( !num ) {
						throw "Missing number at position " + iValue;
					}
					iValue += num[ 0 ].length;
					return parseInt( num[ 0 ], 10 );
				},

				// Extract a name from the string value and convert to an index
				getName = function( match, shortNames, longNames ) {
					var index = -1,
						names = $.map( lookAhead( match ) ? longNames : shortNames, function( v, k ) {
							return [ [ k, v ] ];
						} ).sort( function( a, b ) {
							return -( a[ 1 ].length - b[ 1 ].length );
						} );

					$.each( names, function( i, pair ) {
						var name = pair[ 1 ];
						if ( value.substr( iValue, name.length ).toLowerCase() === name.toLowerCase() ) {
							index = pair[ 0 ];
							iValue += name.length;
							return false;
						}
					} );
					if ( index !== -1 ) {
						return index + 1;
					} else {
						throw "Unknown name at position " + iValue;
					}
				},

				// Confirm that a literal character matches the string value
				checkLiteral = function() {
					if ( value.charAt( iValue ) !== format.charAt( iFormat ) ) {
						throw "Unexpected literal at position " + iValue;
					}
					iValue++;
				};

			for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
				if ( literal ) {
					if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
						literal = false;
					} else {
						checkLiteral();
					}
				} else {
					switch ( format.charAt( iFormat ) ) {
						case "d":
							day = getNumber( "d" );
							break;
						case "D":
							getName( "D", dayNamesShort, dayNames );
							break;
						case "o":
							doy = getNumber( "o" );
							break;
						case "m":
							month = getNumber( "m" );
							break;
						case "M":
							month = getName( "M", monthNamesShort, monthNames );
							break;
						case "y":
							year = getNumber( "y" );
							break;
						case "@":
							date = new Date( getNumber( "@" ) );
							year = date.getFullYear();
							month = date.getMonth() + 1;
							day = date.getDate();
							break;
						case "!":
							date = new Date( ( getNumber( "!" ) - this._ticksTo1970 ) / 10000 );
							year = date.getFullYear();
							month = date.getMonth() + 1;
							day = date.getDate();
							break;
						case "'":
							if ( lookAhead( "'" ) ) {
								checkLiteral();
							} else {
								literal = true;
							}
							break;
						default:
							checkLiteral();
					}
				}
			}

			if ( iValue < value.length ) {
				extra = value.substr( iValue );
				if ( !/^\s+/.test( extra ) ) {
					throw "Extra/unparsed characters found in date: " + extra;
				}
			}

			if ( year === -1 ) {
				year = new Date().getFullYear();
			} else if ( year < 100 ) {
				year += new Date().getFullYear() - new Date().getFullYear() % 100 +
					( year <= shortYearCutoff ? 0 : -100 );
			}

			if ( doy > -1 ) {
				month = 1;
				day = doy;
				do {
					dim = this._getDaysInMonth( year, month - 1 );
					if ( day <= dim ) {
						break;
					}
					month++;
					day -= dim;
				} while ( true );
			}

			date = this._daylightSavingAdjust( new Date( year, month - 1, day ) );
			if ( date.getFullYear() !== year || date.getMonth() + 1 !== month || date.getDate() !== day ) {
				throw "Invalid date"; // E.g. 31/02/00
			}
			return date;
		},

		/* Standard date formats. */
		ATOM: "yy-mm-dd", // RFC 3339 (ISO 8601)
		COOKIE: "D, dd M yy",
		ISO_8601: "yy-mm-dd",
		RFC_822: "D, d M y",
		RFC_850: "DD, dd-M-y",
		RFC_1036: "D, d M y",
		RFC_1123: "D, d M yy",
		RFC_2822: "D, d M yy",
		RSS: "D, d M y", // RFC 822
		TICKS: "!",
		TIMESTAMP: "@",
		W3C: "yy-mm-dd", // ISO 8601

		_ticksTo1970: ( ( ( 1970 - 1 ) * 365 + Math.floor( 1970 / 4 ) - Math.floor( 1970 / 100 ) +
			Math.floor( 1970 / 400 ) ) * 24 * 60 * 60 * 10000000 ),

		/* Format a date object into a string value.
		 * The format can be combinations of the following:
		 * d  - day of month (no leading zero)
		 * dd - day of month (two digit)
		 * o  - day of year (no leading zeros)
		 * oo - day of year (three digit)
		 * D  - day name short
		 * DD - day name long
		 * m  - month of year (no leading zero)
		 * mm - month of year (two digit)
		 * M  - month name short
		 * MM - month name long
		 * y  - year (two digit)
		 * yy - year (four digit)
		 * @ - Unix timestamp (ms since 01/01/1970)
		 * ! - Windows ticks (100ns since 01/01/0001)
		 * "..." - literal text
		 * '' - single quote
		 *
		 * @param  format string - the desired format of the date
		 * @param  date Date - the date value to format
		 * @param  settings Object - attributes include:
		 *					dayNamesShort	string[7] - abbreviated names of the days from Sunday (optional)
		 *					dayNames		string[7] - names of the days from Sunday (optional)
		 *					monthNamesShort string[12] - abbreviated names of the months (optional)
		 *					monthNames		string[12] - names of the months (optional)
		 * @return  string - the date in the above format
		 */
		formatDate: function( format, date, settings ) {
			if ( !date ) {
				return "";
			}

			var iFormat,
				dayNamesShort = ( settings ? settings.dayNamesShort : null ) || this._defaults.dayNamesShort,
				dayNames = ( settings ? settings.dayNames : null ) || this._defaults.dayNames,
				monthNamesShort = ( settings ? settings.monthNamesShort : null ) || this._defaults.monthNamesShort,
				monthNames = ( settings ? settings.monthNames : null ) || this._defaults.monthNames,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				},

				// Format a number, with leading zero if necessary
				formatNumber = function( match, value, len ) {
					var num = "" + value;
					if ( lookAhead( match ) ) {
						while ( num.length < len ) {
							num = "0" + num;
						}
					}
					return num;
				},

				// Format a name, short or long as requested
				formatName = function( match, value, shortNames, longNames ) {
					return ( lookAhead( match ) ? longNames[ value ] : shortNames[ value ] );
				},
				output = "",
				literal = false;

			if ( date ) {
				for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
					if ( literal ) {
						if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
							literal = false;
						} else {
							output += format.charAt( iFormat );
						}
					} else {
						switch ( format.charAt( iFormat ) ) {
							case "d":
								output += formatNumber( "d", date.getDate(), 2 );
								break;
							case "D":
								output += formatName( "D", date.getDay(), dayNamesShort, dayNames );
								break;
							case "o":
								output += formatNumber( "o",
									Math.round( ( new Date( date.getFullYear(), date.getMonth(), date.getDate() ).getTime() - new Date( date.getFullYear(), 0, 0 ).getTime() ) / 86400000 ), 3 );
								break;
							case "m":
								output += formatNumber( "m", date.getMonth() + 1, 2 );
								break;
							case "M":
								output += formatName( "M", date.getMonth(), monthNamesShort, monthNames );
								break;
							case "y":
								output += ( lookAhead( "y" ) ? date.getFullYear() :
									( date.getFullYear() % 100 < 10 ? "0" : "" ) + date.getFullYear() % 100 );
								break;
							case "@":
								output += date.getTime();
								break;
							case "!":
								output += date.getTime() * 10000 + this._ticksTo1970;
								break;
							case "'":
								if ( lookAhead( "'" ) ) {
									output += "'";
								} else {
									literal = true;
								}
								break;
							default:
								output += format.charAt( iFormat );
						}
					}
				}
			}
			return output;
		},

		/* Extract all possible characters from the date format. */
		_possibleChars: function( format ) {
			var iFormat,
				chars = "",
				literal = false,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				};

			for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
				if ( literal ) {
					if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
						literal = false;
					} else {
						chars += format.charAt( iFormat );
					}
				} else {
					switch ( format.charAt( iFormat ) ) {
						case "d": case "m": case "y": case "@":
							chars += "0123456789";
							break;
						case "D": case "M":
							return null; // Accept anything
						case "'":
							if ( lookAhead( "'" ) ) {
								chars += "'";
							} else {
								literal = true;
							}
							break;
						default:
							chars += format.charAt( iFormat );
					}
				}
			}
			return chars;
		},

		/* Get a setting value, defaulting if necessary. */
		_get: function( inst, name ) {
			return inst.settings[ name ] !== undefined ?
				inst.settings[ name ] : this._defaults[ name ];
		},

		/* Parse existing date and initialise date picker. */
		_setDateFromField: function( inst, noDefault ) {
			if ( inst.input.val() === inst.lastVal ) {
				return;
			}

			var dateFormat = this._get( inst, "dateFormat" ),
				dates = inst.lastVal = inst.input ? inst.input.val() : null,
				defaultDate = this._getDefaultDate( inst ),
				date = defaultDate,
				settings = this._getFormatConfig( inst );

			try {
				date = this.parseDate( dateFormat, dates, settings ) || defaultDate;
			} catch ( event ) {
				dates = ( noDefault ? "" : dates );
			}
			inst.selectedDay = date.getDate();
			inst.drawMonth = inst.selectedMonth = date.getMonth();
			inst.drawYear = inst.selectedYear = date.getFullYear();
			inst.currentDay = ( dates ? date.getDate() : 0 );
			inst.currentMonth = ( dates ? date.getMonth() : 0 );
			inst.currentYear = ( dates ? date.getFullYear() : 0 );
			this._adjustInstDate( inst );
		},

		/* Retrieve the default date shown on opening. */
		_getDefaultDate: function( inst ) {
			return this._restrictMinMax( inst,
				this._determineDate( inst, this._get( inst, "defaultDate" ), new Date() ) );
		},

		/* A date may be specified as an exact value or a relative one. */
		_determineDate: function( inst, date, defaultDate ) {
			var offsetNumeric = function( offset ) {
					var date = new Date();
					date.setDate( date.getDate() + offset );
					return date;
				},
				offsetString = function( offset ) {
					try {
						return $.datepicker.parseDate( $.datepicker._get( inst, "dateFormat" ),
							offset, $.datepicker._getFormatConfig( inst ) );
					}
					catch ( e ) {

						// Ignore
					}

					var date = ( offset.toLowerCase().match( /^c/ ) ?
						$.datepicker._getDate( inst ) : null ) || new Date(),
						year = date.getFullYear(),
						month = date.getMonth(),
						day = date.getDate(),
						pattern = /([+\-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,
						matches = pattern.exec( offset );

					while ( matches ) {
						switch ( matches[ 2 ] || "d" ) {
							case "d" : case "D" :
								day += parseInt( matches[ 1 ], 10 ); break;
							case "w" : case "W" :
								day += parseInt( matches[ 1 ], 10 ) * 7; break;
							case "m" : case "M" :
								month += parseInt( matches[ 1 ], 10 );
								day = Math.min( day, $.datepicker._getDaysInMonth( year, month ) );
								break;
							case "y": case "Y" :
								year += parseInt( matches[ 1 ], 10 );
								day = Math.min( day, $.datepicker._getDaysInMonth( year, month ) );
								break;
						}
						matches = pattern.exec( offset );
					}
					return new Date( year, month, day );
				},
				newDate = ( date == null || date === "" ? defaultDate : ( typeof date === "string" ? offsetString( date ) :
					( typeof date === "number" ? ( isNaN( date ) ? defaultDate : offsetNumeric( date ) ) : new Date( date.getTime() ) ) ) );

			newDate = ( newDate && newDate.toString() === "Invalid Date" ? defaultDate : newDate );
			if ( newDate ) {
				newDate.setHours( 0 );
				newDate.setMinutes( 0 );
				newDate.setSeconds( 0 );
				newDate.setMilliseconds( 0 );
			}
			return this._daylightSavingAdjust( newDate );
		},

		/* Handle switch to/from daylight saving.
		 * Hours may be non-zero on daylight saving cut-over:
		 * > 12 when midnight changeover, but then cannot generate
		 * midnight datetime, so jump to 1AM, otherwise reset.
		 * @param  date  (Date) the date to check
		 * @return  (Date) the corrected date
		 */
		_daylightSavingAdjust: function( date ) {
			if ( !date ) {
				return null;
			}
			date.setHours( date.getHours() > 12 ? date.getHours() + 2 : 0 );
			return date;
		},

		/* Set the date(s) directly. */
		_setDate: function( inst, date, noChange ) {
			var clear = !date,
				origMonth = inst.selectedMonth,
				origYear = inst.selectedYear,
				newDate = this._restrictMinMax( inst, this._determineDate( inst, date, new Date() ) );

			inst.selectedDay = inst.currentDay = newDate.getDate();
			inst.drawMonth = inst.selectedMonth = inst.currentMonth = newDate.getMonth();
			inst.drawYear = inst.selectedYear = inst.currentYear = newDate.getFullYear();
			if ( ( origMonth !== inst.selectedMonth || origYear !== inst.selectedYear ) && !noChange ) {
				this._notifyChange( inst );
			}
			this._adjustInstDate( inst );
			if ( inst.input ) {
				inst.input.val( clear ? "" : this._formatDate( inst ) );
			}
		},

		/* Retrieve the date(s) directly. */
		_getDate: function( inst ) {
			var startDate = ( !inst.currentYear || ( inst.input && inst.input.val() === "" ) ? null :
				this._daylightSavingAdjust( new Date(
				inst.currentYear, inst.currentMonth, inst.currentDay ) ) );
				return startDate;
		},

		/* Attach the onxxx handlers.  These are declared statically so
		 * they work with static code transformers like Caja.
		 */
		_attachHandlers: function( inst ) {
			var stepMonths = this._get( inst, "stepMonths" ),
				id = "#" + inst.id.replace( /\\\\/g, "\\" );
			inst.dpDiv.find( "[data-handler]" ).map( function() {
				var handler = {
					prev: function() {
						$.datepicker._adjustDate( id, -stepMonths, "M" );
					},
					next: function() {
						$.datepicker._adjustDate( id, +stepMonths, "M" );
					},
					hide: function() {
						$.datepicker._hideDatepicker();
					},
					today: function() {
						$.datepicker._gotoToday( id );
					},
					selectDay: function() {
						$.datepicker._selectDay( id, +this.getAttribute( "data-month" ), +this.getAttribute( "data-year" ), this );
						return false;
					},
					selectMonth: function() {
						$.datepicker._selectMonthYear( id, this, "M" );
						return false;
					},
					selectYear: function() {
						$.datepicker._selectMonthYear( id, this, "Y" );
						return false;
					}
				};
				$( this ).on( this.getAttribute( "data-event" ), handler[ this.getAttribute( "data-handler" ) ] );
			} );
		},

		/* Generate the HTML for the current state of the date picker. */
		_generateHTML: function( inst ) {
			var maxDraw, prevText, prev, nextText, next, currentText, gotoDate,
				controls, buttonPanel, firstDay, showWeek, dayNames, dayNamesMin,
				monthNames, monthNamesShort, beforeShowDay, showOtherMonths,
				selectOtherMonths, defaultDate, html, dow, row, group, col, selectedDate,
				cornerClass, calender, thead, day, daysInMonth, leadDays, curRows, numRows,
				printDate, dRow, tbody, daySettings, otherMonth, unselectable,
				tempDate = new Date(),
				today = this._daylightSavingAdjust(
					new Date( tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate() ) ), // clear time
				isRTL = this._get( inst, "isRTL" ),
				showButtonPanel = this._get( inst, "showButtonPanel" ),
				hideIfNoPrevNext = this._get( inst, "hideIfNoPrevNext" ),
				navigationAsDateFormat = this._get( inst, "navigationAsDateFormat" ),
				numMonths = this._getNumberOfMonths( inst ),
				showCurrentAtPos = this._get( inst, "showCurrentAtPos" ),
				stepMonths = this._get( inst, "stepMonths" ),
				isMultiMonth = ( numMonths[ 0 ] !== 1 || numMonths[ 1 ] !== 1 ),
				currentDate = this._daylightSavingAdjust( ( !inst.currentDay ? new Date( 9999, 9, 9 ) :
					new Date( inst.currentYear, inst.currentMonth, inst.currentDay ) ) ),
				minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				drawMonth = inst.drawMonth - showCurrentAtPos,
				drawYear = inst.drawYear;

			if ( drawMonth < 0 ) {
				drawMonth += 12;
				drawYear--;
			}
			if ( maxDate ) {
				maxDraw = this._daylightSavingAdjust( new Date( maxDate.getFullYear(),
					maxDate.getMonth() - ( numMonths[ 0 ] * numMonths[ 1 ] ) + 1, maxDate.getDate() ) );
				maxDraw = ( minDate && maxDraw < minDate ? minDate : maxDraw );
				while ( this._daylightSavingAdjust( new Date( drawYear, drawMonth, 1 ) ) > maxDraw ) {
					drawMonth--;
					if ( drawMonth < 0 ) {
						drawMonth = 11;
						drawYear--;
					}
				}
			}
			inst.drawMonth = drawMonth;
			inst.drawYear = drawYear;

			prevText = this._get( inst, "prevText" );
			prevText = ( !navigationAsDateFormat ? prevText : this.formatDate( prevText,
				this._daylightSavingAdjust( new Date( drawYear, drawMonth - stepMonths, 1 ) ),
				this._getFormatConfig( inst ) ) );

			prev = ( this._canAdjustMonth( inst, -1, drawYear, drawMonth ) ?
				"<a class='ui-datepicker-prev ui-corner-all' data-handler='prev' data-event='click'" +
				" title='" + prevText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "e" : "w" ) + "'>" + prevText + "</span></a>" :
				( hideIfNoPrevNext ? "" : "<a class='ui-datepicker-prev ui-corner-all ui-state-disabled' title='" + prevText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "e" : "w" ) + "'>" + prevText + "</span></a>" ) );

			nextText = this._get( inst, "nextText" );
			nextText = ( !navigationAsDateFormat ? nextText : this.formatDate( nextText,
				this._daylightSavingAdjust( new Date( drawYear, drawMonth + stepMonths, 1 ) ),
				this._getFormatConfig( inst ) ) );

			next = ( this._canAdjustMonth( inst, +1, drawYear, drawMonth ) ?
				"<a class='ui-datepicker-next ui-corner-all' data-handler='next' data-event='click'" +
				" title='" + nextText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "w" : "e" ) + "'>" + nextText + "</span></a>" :
				( hideIfNoPrevNext ? "" : "<a class='ui-datepicker-next ui-corner-all ui-state-disabled' title='" + nextText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "w" : "e" ) + "'>" + nextText + "</span></a>" ) );

			currentText = this._get( inst, "currentText" );
			gotoDate = ( this._get( inst, "gotoCurrent" ) && inst.currentDay ? currentDate : today );
			currentText = ( !navigationAsDateFormat ? currentText :
				this.formatDate( currentText, gotoDate, this._getFormatConfig( inst ) ) );

			controls = ( !inst.inline ? "<button type='button' class='ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all' data-handler='hide' data-event='click'>" +
				this._get( inst, "closeText" ) + "</button>" : "" );

			buttonPanel = ( showButtonPanel ) ? "<div class='ui-datepicker-buttonpane ui-widget-content'>" + ( isRTL ? controls : "" ) +
				( this._isInRange( inst, gotoDate ) ? "<button type='button' class='ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all' data-handler='today' data-event='click'" +
				">" + currentText + "</button>" : "" ) + ( isRTL ? "" : controls ) + "</div>" : "";

			firstDay = parseInt( this._get( inst, "firstDay" ), 10 );
			firstDay = ( isNaN( firstDay ) ? 0 : firstDay );

			showWeek = this._get( inst, "showWeek" );
			dayNames = this._get( inst, "dayNames" );
			dayNamesMin = this._get( inst, "dayNamesMin" );
			monthNames = this._get( inst, "monthNames" );
			monthNamesShort = this._get( inst, "monthNamesShort" );
			beforeShowDay = this._get( inst, "beforeShowDay" );
			showOtherMonths = this._get( inst, "showOtherMonths" );
			selectOtherMonths = this._get( inst, "selectOtherMonths" );
			defaultDate = this._getDefaultDate( inst );
			html = "";

			for ( row = 0; row < numMonths[ 0 ]; row++ ) {
				group = "";
				this.maxRows = 4;
				for ( col = 0; col < numMonths[ 1 ]; col++ ) {
					selectedDate = this._daylightSavingAdjust( new Date( drawYear, drawMonth, inst.selectedDay ) );
					cornerClass = " ui-corner-all";
					calender = "";
					if ( isMultiMonth ) {
						calender += "<div class='ui-datepicker-group";
						if ( numMonths[ 1 ] > 1 ) {
							switch ( col ) {
								case 0: calender += " ui-datepicker-group-first";
									cornerClass = " ui-corner-" + ( isRTL ? "right" : "left" ); break;
								case numMonths[ 1 ] - 1: calender += " ui-datepicker-group-last";
									cornerClass = " ui-corner-" + ( isRTL ? "left" : "right" ); break;
								default: calender += " ui-datepicker-group-middle"; cornerClass = ""; break;
							}
						}
						calender += "'>";
					}
					calender += "<div class='ui-datepicker-header ui-widget-header ui-helper-clearfix" + cornerClass + "'>" +
						( /all|left/.test( cornerClass ) && row === 0 ? ( isRTL ? next : prev ) : "" ) +
						( /all|right/.test( cornerClass ) && row === 0 ? ( isRTL ? prev : next ) : "" ) +
						this._generateMonthYearHeader( inst, drawMonth, drawYear, minDate, maxDate,
						row > 0 || col > 0, monthNames, monthNamesShort ) + // draw month headers
						"</div><table class='ui-datepicker-calendar'><thead>" +
						"<tr>";
					thead = ( showWeek ? "<th class='ui-datepicker-week-col'>" + this._get( inst, "weekHeader" ) + "</th>" : "" );
					for ( dow = 0; dow < 7; dow++ ) { // days of the week
						day = ( dow + firstDay ) % 7;
						thead += "<th scope='col'" + ( ( dow + firstDay + 6 ) % 7 >= 5 ? " class='ui-datepicker-week-end'" : "" ) + ">" +
							"<span title='" + dayNames[ day ] + "'>" + dayNamesMin[ day ] + "</span></th>";
					}
					calender += thead + "</tr></thead><tbody>";
					daysInMonth = this._getDaysInMonth( drawYear, drawMonth );
					if ( drawYear === inst.selectedYear && drawMonth === inst.selectedMonth ) {
						inst.selectedDay = Math.min( inst.selectedDay, daysInMonth );
					}
					leadDays = ( this._getFirstDayOfMonth( drawYear, drawMonth ) - firstDay + 7 ) % 7;
					curRows = Math.ceil( ( leadDays + daysInMonth ) / 7 ); // calculate the number of rows to generate
					numRows = ( isMultiMonth ? this.maxRows > curRows ? this.maxRows : curRows : curRows ); //If multiple months, use the higher number of rows (see #7043)
					this.maxRows = numRows;
					printDate = this._daylightSavingAdjust( new Date( drawYear, drawMonth, 1 - leadDays ) );
					for ( dRow = 0; dRow < numRows; dRow++ ) { // create date picker rows
						calender += "<tr>";
						tbody = ( !showWeek ? "" : "<td class='ui-datepicker-week-col'>" +
							this._get( inst, "calculateWeek" )( printDate ) + "</td>" );
						for ( dow = 0; dow < 7; dow++ ) { // create date picker days
							daySettings = ( beforeShowDay ?
								beforeShowDay.apply( ( inst.input ? inst.input[ 0 ] : null ), [ printDate ] ) : [ true, "" ] );
							otherMonth = ( printDate.getMonth() !== drawMonth );
							unselectable = ( otherMonth && !selectOtherMonths ) || !daySettings[ 0 ] ||
								( minDate && printDate < minDate ) || ( maxDate && printDate > maxDate );
							tbody += "<td class='" +
								( ( dow + firstDay + 6 ) % 7 >= 5 ? " ui-datepicker-week-end" : "" ) + // highlight weekends
								( otherMonth ? " ui-datepicker-other-month" : "" ) + // highlight days from other months
								( ( printDate.getTime() === selectedDate.getTime() && drawMonth === inst.selectedMonth && inst._keyEvent ) || // user pressed key
								( defaultDate.getTime() === printDate.getTime() && defaultDate.getTime() === selectedDate.getTime() ) ?

								// or defaultDate is current printedDate and defaultDate is selectedDate
								" " + this._dayOverClass : "" ) + // highlight selected day
								( unselectable ? " " + this._unselectableClass + " ui-state-disabled" : "" ) +  // highlight unselectable days
								( otherMonth && !showOtherMonths ? "" : " " + daySettings[ 1 ] + // highlight custom dates
								( printDate.getTime() === currentDate.getTime() ? " " + this._currentClass : "" ) + // highlight selected day
								( printDate.getTime() === today.getTime() ? " ui-datepicker-today" : "" ) ) + "'" + // highlight today (if different)
								( ( !otherMonth || showOtherMonths ) && daySettings[ 2 ] ? " title='" + daySettings[ 2 ].replace( /'/g, "&#39;" ) + "'" : "" ) + // cell title
								( unselectable ? "" : " data-handler='selectDay' data-event='click' data-month='" + printDate.getMonth() + "' data-year='" + printDate.getFullYear() + "'" ) + ">" + // actions
								( otherMonth && !showOtherMonths ? "&#xa0;" : // display for other months
								( unselectable ? "<span class='ui-state-default'>" + printDate.getDate() + "</span>" : "<a class='ui-state-default" +
								( printDate.getTime() === today.getTime() ? " ui-state-highlight" : "" ) +
								( printDate.getTime() === currentDate.getTime() ? " ui-state-active" : "" ) + // highlight selected day
								( otherMonth ? " ui-priority-secondary" : "" ) + // distinguish dates from other months
								"' href='#'>" + printDate.getDate() + "</a>" ) ) + "</td>"; // display selectable date
							printDate.setDate( printDate.getDate() + 1 );
							printDate = this._daylightSavingAdjust( printDate );
						}
						calender += tbody + "</tr>";
					}
					drawMonth++;
					if ( drawMonth > 11 ) {
						drawMonth = 0;
						drawYear++;
					}
					calender += "</tbody></table>" + ( isMultiMonth ? "</div>" +
								( ( numMonths[ 0 ] > 0 && col === numMonths[ 1 ] - 1 ) ? "<div class='ui-datepicker-row-break'></div>" : "" ) : "" );
					group += calender;
				}
				html += group;
			}
			html += buttonPanel;
			inst._keyEvent = false;
			return html;
		},

		/* Generate the month and year header. */
		_generateMonthYearHeader: function( inst, drawMonth, drawYear, minDate, maxDate,
				secondary, monthNames, monthNamesShort ) {

			var inMinYear, inMaxYear, month, years, thisYear, determineYear, year, endYear,
				changeMonth = this._get( inst, "changeMonth" ),
				changeYear = this._get( inst, "changeYear" ),
				showMonthAfterYear = this._get( inst, "showMonthAfterYear" ),
				html = "<div class='ui-datepicker-title'>",
				monthHtml = "";

			// Month selection
			if ( secondary || !changeMonth ) {
				monthHtml += "<span class='ui-datepicker-month'>" + monthNames[ drawMonth ] + "</span>";
			} else {
				inMinYear = ( minDate && minDate.getFullYear() === drawYear );
				inMaxYear = ( maxDate && maxDate.getFullYear() === drawYear );
				monthHtml += "<select class='ui-datepicker-month' data-handler='selectMonth' data-event='change'>";
				for ( month = 0; month < 12; month++ ) {
					if ( ( !inMinYear || month >= minDate.getMonth() ) && ( !inMaxYear || month <= maxDate.getMonth() ) ) {
						monthHtml += "<option value='" + month + "'" +
							( month === drawMonth ? " selected='selected'" : "" ) +
							">" + monthNamesShort[ month ] + "</option>";
					}
				}
				monthHtml += "</select>";
			}

			if ( !showMonthAfterYear ) {
				html += monthHtml + ( secondary || !( changeMonth && changeYear ) ? "&#xa0;" : "" );
			}

			// Year selection
			if ( !inst.yearshtml ) {
				inst.yearshtml = "";
				if ( secondary || !changeYear ) {
					html += "<span class='ui-datepicker-year'>" + drawYear + "</span>";
				} else {

					// determine range of years to display
					years = this._get( inst, "yearRange" ).split( ":" );
					thisYear = new Date().getFullYear();
					determineYear = function( value ) {
						var year = ( value.match( /c[+\-].*/ ) ? drawYear + parseInt( value.substring( 1 ), 10 ) :
							( value.match( /[+\-].*/ ) ? thisYear + parseInt( value, 10 ) :
							parseInt( value, 10 ) ) );
						return ( isNaN( year ) ? thisYear : year );
					};
					year = determineYear( years[ 0 ] );
					endYear = Math.max( year, determineYear( years[ 1 ] || "" ) );
					year = ( minDate ? Math.max( year, minDate.getFullYear() ) : year );
					endYear = ( maxDate ? Math.min( endYear, maxDate.getFullYear() ) : endYear );
					inst.yearshtml += "<select class='ui-datepicker-year' data-handler='selectYear' data-event='change'>";
					for ( ; year <= endYear; year++ ) {
						inst.yearshtml += "<option value='" + year + "'" +
							( year === drawYear ? " selected='selected'" : "" ) +
							">" + year + "</option>";
					}
					inst.yearshtml += "</select>";

					html += inst.yearshtml;
					inst.yearshtml = null;
				}
			}

			html += this._get( inst, "yearSuffix" );
			if ( showMonthAfterYear ) {
				html += ( secondary || !( changeMonth && changeYear ) ? "&#xa0;" : "" ) + monthHtml;
			}
			html += "</div>"; // Close datepicker_header
			return html;
		},

		/* Adjust one of the date sub-fields. */
		_adjustInstDate: function( inst, offset, period ) {
			var year = inst.selectedYear + ( period === "Y" ? offset : 0 ),
				month = inst.selectedMonth + ( period === "M" ? offset : 0 ),
				day = Math.min( inst.selectedDay, this._getDaysInMonth( year, month ) ) + ( period === "D" ? offset : 0 ),
				date = this._restrictMinMax( inst, this._daylightSavingAdjust( new Date( year, month, day ) ) );

			inst.selectedDay = date.getDate();
			inst.drawMonth = inst.selectedMonth = date.getMonth();
			inst.drawYear = inst.selectedYear = date.getFullYear();
			if ( period === "M" || period === "Y" ) {
				this._notifyChange( inst );
			}
		},

		/* Ensure a date is within any min/max bounds. */
		_restrictMinMax: function( inst, date ) {
			var minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				newDate = ( minDate && date < minDate ? minDate : date );
			return ( maxDate && newDate > maxDate ? maxDate : newDate );
		},

		/* Notify change of month/year. */
		_notifyChange: function( inst ) {
			var onChange = this._get( inst, "onChangeMonthYear" );
			if ( onChange ) {
				onChange.apply( ( inst.input ? inst.input[ 0 ] : null ),
					[ inst.selectedYear, inst.selectedMonth + 1, inst ] );
			}
		},

		/* Determine the number of months to show. */
		_getNumberOfMonths: function( inst ) {
			var numMonths = this._get( inst, "numberOfMonths" );
			return ( numMonths == null ? [ 1, 1 ] : ( typeof numMonths === "number" ? [ 1, numMonths ] : numMonths ) );
		},

		/* Determine the current maximum date - ensure no time components are set. */
		_getMinMaxDate: function( inst, minMax ) {
			return this._determineDate( inst, this._get( inst, minMax + "Date" ), null );
		},

		/* Find the number of days in a given month. */
		_getDaysInMonth: function( year, month ) {
			return 32 - this._daylightSavingAdjust( new Date( year, month, 32 ) ).getDate();
		},

		/* Find the day of the week of the first of a month. */
		_getFirstDayOfMonth: function( year, month ) {
			return new Date( year, month, 1 ).getDay();
		},

		/* Determines if we should allow a "next/prev" month display change. */
		_canAdjustMonth: function( inst, offset, curYear, curMonth ) {
			var numMonths = this._getNumberOfMonths( inst ),
				date = this._daylightSavingAdjust( new Date( curYear,
				curMonth + ( offset < 0 ? offset : numMonths[ 0 ] * numMonths[ 1 ] ), 1 ) );

			if ( offset < 0 ) {
				date.setDate( this._getDaysInMonth( date.getFullYear(), date.getMonth() ) );
			}
			return this._isInRange( inst, date );
		},

		/* Is the given date in the accepted range? */
		_isInRange: function( inst, date ) {
			var yearSplit, currentYear,
				minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				minYear = null,
				maxYear = null,
				years = this._get( inst, "yearRange" );
				if ( years ) {
					yearSplit = years.split( ":" );
					currentYear = new Date().getFullYear();
					minYear = parseInt( yearSplit[ 0 ], 10 );
					maxYear = parseInt( yearSplit[ 1 ], 10 );
					if ( yearSplit[ 0 ].match( /[+\-].*/ ) ) {
						minYear += currentYear;
					}
					if ( yearSplit[ 1 ].match( /[+\-].*/ ) ) {
						maxYear += currentYear;
					}
				}

			return ( ( !minDate || date.getTime() >= minDate.getTime() ) &&
				( !maxDate || date.getTime() <= maxDate.getTime() ) &&
				( !minYear || date.getFullYear() >= minYear ) &&
				( !maxYear || date.getFullYear() <= maxYear ) );
		},

		/* Provide the configuration settings for formatting/parsing. */
		_getFormatConfig: function( inst ) {
			var shortYearCutoff = this._get( inst, "shortYearCutoff" );
			shortYearCutoff = ( typeof shortYearCutoff !== "string" ? shortYearCutoff :
				new Date().getFullYear() % 100 + parseInt( shortYearCutoff, 10 ) );
			return { shortYearCutoff: shortYearCutoff,
				dayNamesShort: this._get( inst, "dayNamesShort" ), dayNames: this._get( inst, "dayNames" ),
				monthNamesShort: this._get( inst, "monthNamesShort" ), monthNames: this._get( inst, "monthNames" ) };
		},

		/* Format the given date for display. */
		_formatDate: function( inst, day, month, year ) {
			if ( !day ) {
				inst.currentDay = inst.selectedDay;
				inst.currentMonth = inst.selectedMonth;
				inst.currentYear = inst.selectedYear;
			}
			var date = ( day ? ( typeof day === "object" ? day :
				this._daylightSavingAdjust( new Date( year, month, day ) ) ) :
				this._daylightSavingAdjust( new Date( inst.currentYear, inst.currentMonth, inst.currentDay ) ) );
			return this.formatDate( this._get( inst, "dateFormat" ), date, this._getFormatConfig( inst ) );
		}
	} );

	/*
	 * Bind hover events for datepicker elements.
	 * Done via delegate so the binding only occurs once in the lifetime of the parent div.
	 * Global datepicker_instActive, set by _updateDatepicker allows the handlers to find their way back to the active picker.
	 */
	function datepicker_bindHover( dpDiv ) {
		var selector = "button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";
		return dpDiv.on( "mouseout", selector, function() {
				$( this ).removeClass( "ui-state-hover" );
				if ( this.className.indexOf( "ui-datepicker-prev" ) !== -1 ) {
					$( this ).removeClass( "ui-datepicker-prev-hover" );
				}
				if ( this.className.indexOf( "ui-datepicker-next" ) !== -1 ) {
					$( this ).removeClass( "ui-datepicker-next-hover" );
				}
			} )
			.on( "mouseover", selector, datepicker_handleMouseover );
	}

	function datepicker_handleMouseover() {
		if ( !$.datepicker._isDisabledDatepicker( datepicker_instActive.inline ? datepicker_instActive.dpDiv.parent()[ 0 ] : datepicker_instActive.input[ 0 ] ) ) {
			$( this ).parents( ".ui-datepicker-calendar" ).find( "a" ).removeClass( "ui-state-hover" );
			$( this ).addClass( "ui-state-hover" );
			if ( this.className.indexOf( "ui-datepicker-prev" ) !== -1 ) {
				$( this ).addClass( "ui-datepicker-prev-hover" );
			}
			if ( this.className.indexOf( "ui-datepicker-next" ) !== -1 ) {
				$( this ).addClass( "ui-datepicker-next-hover" );
			}
		}
	}

	/* jQuery extend now ignores nulls! */
	function datepicker_extendRemove( target, props ) {
		$.extend( target, props );
		for ( var name in props ) {
			if ( props[ name ] == null ) {
				target[ name ] = props[ name ];
			}
		}
		return target;
	}

	/* Invoke the datepicker functionality.
	   @param  options  string - a command, optionally followed by additional parameters or
						Object - settings for attaching new datepicker functionality
	   @return  jQuery object */
	$.fn.datepicker = function( options ) {

		/* Verify an empty collection wasn't passed - Fixes #6976 */
		if ( !this.length ) {
			return this;
		}

		/* Initialise the date picker. */
		if ( !$.datepicker.initialized ) {
			$( document ).on( "mousedown", $.datepicker._checkExternalClick );
			$.datepicker.initialized = true;
		}

		/* Append datepicker main container to body if not exist. */
		if ( $( "#" + $.datepicker._mainDivId ).length === 0 ) {
			$( "body" ).append( $.datepicker.dpDiv );
		}

		var otherArgs = Array.prototype.slice.call( arguments, 1 );
		if ( typeof options === "string" && ( options === "isDisabled" || options === "getDate" || options === "widget" ) ) {
			return $.datepicker[ "_" + options + "Datepicker" ].
				apply( $.datepicker, [ this[ 0 ] ].concat( otherArgs ) );
		}
		if ( options === "option" && arguments.length === 2 && typeof arguments[ 1 ] === "string" ) {
			return $.datepicker[ "_" + options + "Datepicker" ].
				apply( $.datepicker, [ this[ 0 ] ].concat( otherArgs ) );
		}
		return this.each( function() {
			typeof options === "string" ?
				$.datepicker[ "_" + options + "Datepicker" ].
					apply( $.datepicker, [ this ].concat( otherArgs ) ) :
				$.datepicker._attachDatepicker( this, options );
		} );
	};

	$.datepicker = new Datepicker(); // singleton instance
	$.datepicker.initialized = false;
	$.datepicker.uuid = new Date().getTime();
	$.datepicker.version = "1.12.1";

	return $.datepicker;

	} ) );


/***/ }),

/***/ 280:
/*!***********************************************************!*\
  !*** ./modules/CoreWebclient/js/views/CHeaderItemView.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	
	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190)
	;

	function CHeaderItemView(sLinkText)
	{
		this.sName = '';
		
		this.visible = ko.observable(true);
		this.baseHash = ko.observable('');
		this.hash = ko.observable('');
		this.linkText = ko.observable(sLinkText);
		this.isCurrent = ko.observable(false);
		
		this.recivedAnim = ko.observable(false).extend({'autoResetToFalse': 500});
		this.unseenCount = ko.observable(0);
		
		this.allowChangeTitle = ko.observable(false); // allows to change favicon and browser title when browser is inactive
		this.inactiveTitle = ko.observable('');
		
		this.excludedHashes = ko.observableArray([]);
	}

	CHeaderItemView.prototype.ViewTemplate = 'CoreWebclient_HeaderItemView';

	CHeaderItemView.prototype.setName = function (sName)
	{
		this.sName = sName.toLowerCase();
		if (this.baseHash() === '')
		{
			this.hash(Routing.buildHashFromArray([sName.toLowerCase()]));
			this.baseHash(this.hash());
		}
		else
		{
			this.hash(this.baseHash());
		}
	};

	module.exports = CHeaderItemView;


/***/ }),

/***/ 298:
/*!***********************************************!*\
  !*** ./modules/CoreWebclient/js/CSelector.js ***!
  \***********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178)
	;

	/**
	 * @param {Function} list (knockout)
	 * @param {Function=} fSelectCallback
	 * @param {Function=} fDeleteCallback
	 * @param {Function=} fDblClickCallback
	 * @param {Function=} fEnterCallback
	 * @param {Function=} multiplyLineFactor (knockout)
	 * @param {boolean=} bResetCheckedOnClick = false
	 * @param {boolean=} bCheckOnSelect = false
	 * @param {boolean=} bUnselectOnCtrl = false
	 * @param {boolean=} bDisableMultiplySelection = false
	 * @param {boolean=} bChangeOnSelect = true
	 * @constructor
	 */
	function CSelector(list, fSelectCallback, fDeleteCallback, fDblClickCallback, fEnterCallback, multiplyLineFactor,
		bResetCheckedOnClick, bCheckOnSelect, bUnselectOnCtrl, bDisableMultiplySelection, bChangeOnSelect)
	{
		this.fSelectCallback = fSelectCallback || function() {};
		this.fDeleteCallback = fDeleteCallback || function() {};
		this.fDblClickCallback = (!App.isMobile() && fDblClickCallback) ? fDblClickCallback : function() {};
		this.fEnterCallback = fEnterCallback || function() {};
		this.bResetCheckedOnClick = !!bResetCheckedOnClick;
		this.bCheckOnSelect = !!bCheckOnSelect;
		this.bUnselectOnCtrl = !!bUnselectOnCtrl;
		this.bDisableMultiplySelection = !!bDisableMultiplySelection;
		this.bChangeOnSelect = (typeof bChangeOnSelect === 'undefined') ? true : !!bChangeOnSelect;
		
		this.useKeyboardKeys = ko.observable(false);

		this.list = ko.observableArray([]);

		if (list && list['subscribe'])
		{
			list['subscribe'](function (mValue) {
				this.list(mValue);
			}, this);
		}
		
		this.multiplyLineFactor = multiplyLineFactor;
		
		this.oLast = null;
		this.oListScope = null;
		this.oScrollScope = null;

		this.iTimer = 0;
		this.iFactor = 1;

		this.KeyUp = Enums.Key.Up;
		this.KeyDown = Enums.Key.Down;
		this.KeyLeft = Enums.Key.Up;
		this.KeyRight = Enums.Key.Down;

		if (this.multiplyLineFactor)
		{
			if (this.multiplyLineFactor.subscribe)
			{
				this.multiplyLineFactor.subscribe(function (iValue) {
					this.iFactor = 0 < iValue ? iValue : 1;
				}, this);
			}
			else
			{
				this.iFactor = Types.pInt(this.multiplyLineFactor);
			}

			this.KeyUp = Enums.Key.Up;
			this.KeyDown = Enums.Key.Down;
			this.KeyLeft = Enums.Key.Left;
			this.KeyRight = Enums.Key.Right;

			if ($('html').hasClass('rtl'))
			{
				this.KeyLeft = Enums.Key.Right;
				this.KeyRight = Enums.Key.Left;
			}
		}

		this.sActionSelector = '';
		this.sSelectabelSelector = '';
		this.sCheckboxSelector = '';

		var self = this;

		// reading returns a list of checked items.
		// recording (bool) puts all checked, or unchecked.
		this.listChecked = ko.computed({
			'read': function () {
				var aList = _.filter(this.list(), function (oItem) {
					var
						bC = oItem.checked(),
						bS = oItem.selected()
					;

					return bC || (self.bCheckOnSelect && bS);
				});

				return aList;
			},
			'write': function (bValue) {
				bValue = !!bValue;
				_.each(this.list(), function (oItem) {
					oItem.checked(bValue);
				});
				this.list.valueHasMutated();
			},
			'owner': this
		});

		this.checkAll = ko.computed({
			'read': function () {
				return 0 < this.listChecked().length;
			},

			'write': function (bValue) {
				this.listChecked(!!bValue);
			},
			'owner': this
		});

		this.selectorHook = ko.observable(null);

		this.selectorHook.subscribe(function () {
			var oPrev = this.selectorHook();
			if (oPrev)
			{
				oPrev.selected(false);
			}
		}, this, 'beforeChange');

		this.selectorHook.subscribe(function (oGroup) {
			if (oGroup)
			{
				oGroup.selected(true);
			}
		}, this);

		this.itemSelected = ko.computed({

			'read': this.selectorHook,

			'write': function (oItemToSelect) {

				this.selectorHook(oItemToSelect);

				if (oItemToSelect)
				{
					self.scrollToSelected();
					this.oLast = oItemToSelect;
				}
			},
			'owner': this
		});

		this.list.subscribe(function (aList) {
			if (_.isArray(aList))
			{
				var	oSelected = this.itemSelected();
				if (oSelected)
				{
					if (!_.find(aList, function (oItem) {
						return oSelected === oItem;
					}))
					{
						this.itemSelected(null);
					}
				}
			}
			else
			{
				this.itemSelected(null);
			}
		}, this);

		this.listCheckedOrSelected = ko.computed({
			'read': function () {
				var
					oSelected = this.itemSelected(),
					aChecked = this.listChecked()
				;
				return 0 < aChecked.length ? aChecked : (oSelected ? [oSelected] : []);
			},
			'write': function (bValue) {
				if (!bValue)
				{
					this.itemSelected(null);
					this.listChecked(false);
				}
				else
				{
					this.listChecked(true);
				}
			},
			'owner': this
		});

		this.listCheckedAndSelected = ko.computed({
			'read': function () {
				var
					aResult = [],
					oSelected = this.itemSelected(),
					aChecked = this.listChecked()
				;

				if (aChecked)
				{
					aResult = aChecked.slice(0);
				}

				if (oSelected && _.indexOf(aChecked, oSelected) === -1)
				{
					aResult.push(oSelected);
				}

				return aResult;
			},
			'write': function (bValue) {
				if (!bValue)
				{
					this.itemSelected(null);
					this.listChecked(false);
				}
				else
				{
					this.listChecked(true);
				}
			},
			'owner': this
		});

		this.isIncompleteChecked = ko.computed(function () {
			var
				iM = this.list().length,
				iC = this.listChecked().length
			;
			return 0 < iM && 0 < iC && iM > iC;
		}, this);

		this.onKeydownBound = _.bind(this.onKeydown, this);
	}

	CSelector.prototype.iTimer = 0;
	CSelector.prototype.bResetCheckedOnClick = false;
	CSelector.prototype.bCheckOnSelect = false;
	CSelector.prototype.bUnselectOnCtrl = false;
	CSelector.prototype.bDisableMultiplySelection = false;

	CSelector.prototype.getLastOrSelected = function ()
	{
		var
			iCheckedCount = 0,
			oLastSelected = null
		;
		
		_.each(this.list(), function (oItem) {
			if (oItem.checked())
			{
				iCheckedCount++;
			}

			if (oItem.selected())
			{
				oLastSelected = oItem;
			}
		});

		return 0 === iCheckedCount && oLastSelected ? oLastSelected : this.oLast;
	};

	/**
	 * @param {string} sActionSelector css-selector for the active for pressing regions of the list
	 * @param {string} sSelectabelSelector css-selector to the item that was selected
	 * @param {string} sCheckboxSelector css-selector to the element that checkbox in the list
	 * @param {*} oListScope
	 * @param {*} oScrollScope
	 */
	CSelector.prototype.initOnApplyBindings = function (sActionSelector, sSelectabelSelector, sCheckboxSelector, oListScope, oScrollScope)
	{
		$(document).on('keydown', this.onKeydownBound);

		this.oListScope = oListScope;
		this.oScrollScope = oScrollScope;
		this.sActionSelector = sActionSelector;
		this.sSelectabelSelector = sSelectabelSelector;
		this.sCheckboxSelector = sCheckboxSelector;

		var
			self = this,

			fEventClickFunction = function (oLast, oItem, oEvent) {

				var
					iIndex = 0,
					iLength = 0,
					oListItem = null,
					bChangeRange = false,
					bIsInRange = false,
					aList = [],
					bChecked = false
				;

				oItem = oItem ? oItem : null;
				if (oEvent && oEvent.shiftKey)
				{
					if (null !== oItem && null !== oLast && oItem !== oLast)
					{
						aList = self.list();
						bChecked = oItem.checked();

						for (iIndex = 0, iLength = aList.length; iIndex < iLength; iIndex++)
						{
							oListItem = aList[iIndex];

							bChangeRange = false;
							if (oListItem === oLast || oListItem === oItem)
							{
								bChangeRange = true;
							}

							if (bChangeRange)
							{
								bIsInRange = !bIsInRange;
							}

							if (bIsInRange || bChangeRange)
							{
								oListItem.checked(bChecked);
							}
						}
					}
				}

				if (oItem)
				{
					self.oLast = oItem;
				}
			}
		;

		$(this.oListScope).on('dblclick', sActionSelector, function (oEvent) {
			var oItem = ko.dataFor(this);
			if (oItem && oEvent && !oEvent.ctrlKey && !oEvent.altKey && !oEvent.shiftKey)
			{
				self.onDblClick(oItem);
			}
		});

		if (Browser.mobileDevice)
		{
			$(this.oListScope).on('touchstart', sActionSelector, function (e) {

				if (!e)
				{
					return;
				}

				var
					t2 = e.timeStamp,
					t1 = $(this).data('lastTouch') || t2,
					dt = t2 - t1,
					fingers = e.originalEvent && e.originalEvent.touches ? e.originalEvent.touches.length : 0
				;

				$(this).data('lastTouch', t2);
				if (!dt || dt > 250 || fingers > 1)
				{
					return;
				}

				e.preventDefault();
				$(this).trigger('dblclick');
			});
		}

		$(this.oListScope).on('click', sActionSelector, function (oEvent) {

			var
				bClick = true,
				oSelected = null,
				oLast = self.getLastOrSelected(),
				oItem = ko.dataFor(this)
			;

			if (oItem && oEvent)
			{
				if (oEvent.shiftKey)
				{
					bClick = false;
					if (!self.bDisableMultiplySelection)
					{
						if (null === self.oLast)
						{
							self.oLast = oItem;
						}


						oItem.checked(!oItem.checked());
						fEventClickFunction(oLast, oItem, oEvent);
					}
				}
				else if (oEvent.ctrlKey)
				{
					bClick = false;
					if (!self.bDisableMultiplySelection)
					{
						self.oLast = oItem;
						oSelected = self.itemSelected();
						if (oSelected && !oSelected.checked() && !oItem.checked())
						{
							oSelected.checked(true);
						}

						if (self.bUnselectOnCtrl && oItem === self.itemSelected())
						{
							oItem.checked(!oItem.selected());
							self.itemSelected(null);
						}
						else
						{
							oItem.checked(!oItem.checked());
						}
					}
				}

				if (bClick)
				{
					self.onSelect(oItem, true);
					self.scrollToSelected();
				}
			}
		});

		$(this.oListScope).on('click', sCheckboxSelector, function (oEvent) {

			var oItem = ko.dataFor(this);
			if (oItem && oEvent && !self.bDisableMultiplySelection)
			{
				if (oEvent.shiftKey)
				{
					if (null === self.oLast)
					{
						self.oLast = oItem;
					}

					fEventClickFunction(self.getLastOrSelected(), oItem, oEvent);
				}
				else
				{
					self.oLast = oItem;
				}
			}

			if (oEvent && oEvent.stopPropagation)
			{
				oEvent.stopPropagation();
			}
		});

		$(this.oListScope).on('dblclick', sCheckboxSelector, function (oEvent) {
			if (oEvent && oEvent.stopPropagation)
			{
				oEvent.stopPropagation();
			}
		});
	};

	/**
	 * @param {Object} oSelected
	 * @param {number} iEventKeyCode
	 * 
	 * @return {Object}
	 */
	CSelector.prototype.getResultSelection = function (oSelected, iEventKeyCode)
	{
		var
			self = this,
			bStop = false,
			bNext = false,
			oResult = null,
			iPageStep = this.iFactor,
			bMultiply = !!this.multiplyLineFactor,
			iIndex = 0,
			iLen = 0,
			aList = []
		;

		if (!oSelected && -1 < $.inArray(iEventKeyCode, [this.KeyUp, this.KeyDown, this.KeyLeft, this.KeyRight,
			Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End]))
		{
			aList = this.list();
			if (aList && 0 < aList.length)
			{
				if (-1 < $.inArray(iEventKeyCode, [this.KeyDown, this.KeyRight, Enums.Key.PageUp, Enums.Key.Home]))
				{
					oResult = aList[0];
				}
				else if (-1 < $.inArray(iEventKeyCode, [this.KeyUp, this.KeyLeft, Enums.Key.PageDown, Enums.Key.End]))
				{
					oResult = aList[aList.length - 1];
				}
			}
		}
		else if (oSelected)
		{
			aList = this.list();
			iLen = aList ? aList.length : 0;

			if (0 < iLen)
			{
				if (
					Enums.Key.Home === iEventKeyCode || Enums.Key.PageUp === iEventKeyCode ||
					Enums.Key.End === iEventKeyCode || Enums.Key.PageDown === iEventKeyCode ||
					(bMultiply && (Enums.Key.Left === iEventKeyCode || Enums.Key.Right === iEventKeyCode)) ||
					(!bMultiply && (Enums.Key.Up === iEventKeyCode || Enums.Key.Down === iEventKeyCode))
				)
				{
					_.each(aList, function (oItem) {
						if (!bStop)
						{
							switch (iEventKeyCode) {
								case self.KeyUp:
								case self.KeyLeft:
									if (oSelected === oItem)
									{
										bStop = true;
									}
									else
									{
										oResult = oItem;
									}
									break;
								case Enums.Key.Home:
								case Enums.Key.PageUp:
									oResult = oItem;
									bStop = true;
									break;
								case self.KeyDown:
								case self.KeyRight:
									if (bNext)
									{
										oResult = oItem;
										bStop = true;
									}
									else if (oSelected === oItem)
									{
										bNext = true;
									}
									break;
								case Enums.Key.End:
								case Enums.Key.PageDown:
									oResult = oItem;
									break;
							}
						}
					});
				}
				else if (bMultiply && this.KeyDown === iEventKeyCode)
				{
					for (; iIndex < iLen; iIndex++)
					{
						if (oSelected === aList[iIndex])
						{
							iIndex += iPageStep;
							if (iLen - 1 < iIndex)
							{
								iIndex -= iPageStep;
							}

							oResult = aList[iIndex];
							break;
						}
					}
				}
				else if (bMultiply && this.KeyUp === iEventKeyCode)
				{
					for (iIndex = iLen; iIndex >= 0; iIndex--)
					{
						if (oSelected === aList[iIndex])
						{
							iIndex -= iPageStep;
							if (0 > iIndex)
							{
								iIndex += iPageStep;
							}

							oResult = aList[iIndex];
							break;
						}
					}
				}
			}
		}

		return oResult;
	};

	/**
	 * @param {Object} oResult
	 * @param {Object} oSelected
	 * @param {number} iEventKeyCode
	 */
	CSelector.prototype.shiftClickResult = function (oResult, oSelected, iEventKeyCode)
	{
		if (oSelected)
		{
			var
				bMultiply = !!this.multiplyLineFactor,
				bInRange = false,
				bSelected = false
			;

			if (-1 < $.inArray(iEventKeyCode,
				bMultiply ? [Enums.Key.Left, Enums.Key.Right] : [Enums.Key.Up, Enums.Key.Down]))
			{
				oSelected.checked(!oSelected.checked());
			}
			else if (-1 < $.inArray(iEventKeyCode, bMultiply ?
				[Enums.Key.Up, Enums.Key.Down, Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End] :
				[Enums.Key.Left, Enums.Key.Right, Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End]
			))
			{
				bSelected = !oSelected.checked();

				_.each(this.list(), function (oItem) {
					var Add = false;
					if (oItem === oResult || oSelected === oItem)
					{
						bInRange = !bInRange;
						Add = true;
					}

					if (bInRange || Add)
					{
						oItem.checked(bSelected);
						Add = false;
					}
				});
				
				if (bMultiply && oResult && (iEventKeyCode === Enums.Key.Up || iEventKeyCode === Enums.Key.Down))
				{
					oResult.checked(!oResult.checked());
				}
			}
		}	
	};

	/**
	 * @param {number} iEventKeyCode
	 * @param {boolean} bShiftKey
	 */
	CSelector.prototype.clickNewSelectPosition = function (iEventKeyCode, bShiftKey)
	{
		var
			oSelected = this.itemSelected(),
			oResult = this.getResultSelection(oSelected, iEventKeyCode)
		;

		if (oResult)
		{
			if (bShiftKey)
			{
				this.shiftClickResult(oResult, oSelected, iEventKeyCode);
			}
			this.selectionFunc(oResult);
		}
	};

	/**
	 * @param {Object} oEvent
	 * 
	 * @return {boolean}
	 */
	CSelector.prototype.onKeydown = function (oEvent)
	{
		var
			bResult = true,
			iCode = 0
		;

		if (this.useKeyboardKeys() && oEvent && !Utils.isTextFieldFocused())// && !App.Screens.hasOpenedMaximizedPopups())
		{
			iCode = oEvent.keyCode;
			if (!oEvent.ctrlKey &&
				(
					this.KeyUp === iCode || this.KeyDown === iCode ||
					this.KeyLeft === iCode || this.KeyRight === iCode ||
					Enums.Key.PageUp === iCode || Enums.Key.PageDown === iCode ||
					Enums.Key.Home === iCode || Enums.Key.End === iCode
				)
			)
			{
				this.clickNewSelectPosition(iCode, oEvent.shiftKey);
				bResult = false;
			}
			else if (Enums.Key.Del === iCode && !oEvent.ctrlKey && !oEvent.shiftKey)
			{
				if (0 < this.list().length)
				{
					this.onDelete();
					bResult = false;
				}
			}
			else if (Enums.Key.Enter === iCode)
			{
				if (0 < this.list().length && !oEvent.ctrlKey)
				{
					this.onEnter(this.itemSelected());
					bResult = false;
				}
			}
			else if (oEvent.ctrlKey && !oEvent.altKey && !oEvent.shiftKey && Enums.Key.a === iCode)
			{
				this.checkAll(!(this.checkAll() && !this.isIncompleteChecked()));
				bResult = false;
			}
		}

		return bResult;
	};

	CSelector.prototype.onDelete = function ()
	{
		this.fDeleteCallback.call(this, this.listCheckedOrSelected());
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.onEnter = function (oItem)
	{
		this.fEnterCallback.call(this, oItem);
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.selectionFunc = function (oItem)
	{
		var
			fProceedSelection = _.bind(function () {
				if (this.bChangeOnSelect)
				{
					this.itemSelected(null);
				}
				if (this.bResetCheckedOnClick)
				{
					this.listChecked(false);
				}
				if (this.bChangeOnSelect)
				{
					this.itemSelected(oItem);
				}
				this.fSelectCallback.call(this, oItem);
			}, this),
			oParams = {
				'Item': oItem,
				'Cancel': false,
				'ProceedSelectionHandler': fProceedSelection
			}
		;
		
		if (!oParams.Cancel)
		{
			fProceedSelection();
		}
	};

	/**
	 * @param {Object} oItem
	 * @param {boolean} bCheckBefore
	 */
	CSelector.prototype.onSelect = function (oItem, bCheckBefore)
	{
		this.selectionFunc(oItem);
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.onDblClick = function (oItem)
	{
		this.fDblClickCallback.call(this, oItem);
	};

	CSelector.prototype.koCheckAll = function ()
	{
		return ko.computed({
			'read': this.checkAll,
			'write': this.checkAll,
			'owner': this
		});
	};

	CSelector.prototype.koCheckAllIncomplete = function ()
	{
		return ko.computed({
			'read': this.isIncompleteChecked,
			'write': this.isIncompleteChecked,
			'owner': this
		});
	};

	/**
	 * @return {boolean}
	 */
	CSelector.prototype.scrollToSelected = function ()
	{
		if (!this.oListScope || !this.oScrollScope)
		{
			return false;
		}

		var
			iOffset = 20,
			oSelected = $(this.sSelectabelSelector, this.oScrollScope),
			oPos = oSelected.position(),
			iVisibleHeight = this.oScrollScope.height(),
			iSelectedHeight = oSelected.outerHeight()
		;

		if (oPos && (oPos.top < 0 || oPos.top + iSelectedHeight > iVisibleHeight))
		{
			if (oPos.top < 0)
			{
				this.oScrollScope.scrollTop(this.oScrollScope.scrollTop() + oPos.top - iOffset);
			}
			else
			{
				this.oScrollScope.scrollTop(this.oScrollScope.scrollTop() + oPos.top - iVisibleHeight + iSelectedHeight + iOffset);
			}

			return true;
		}

		return false;
	};

	module.exports = CSelector;


/***/ }),

/***/ 304:
/*!*******************************************************!*\
  !*** ./modules/CoreWebclient/js/models/CDateModel.js ***!
  \*******************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		moment = __webpack_require__(/*! moment */ 51),
				
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45)
	;

	/**
	 * @constructor
	 */
	function CDateModel()
	{
		this.iTimeStampInUTC = 0;
		this.oMoment = null;
	}

	/**
	 * @param {number} iTimeStampInUTC
	 */
	CDateModel.prototype.parse = function (iTimeStampInUTC)
	{
		this.iTimeStampInUTC = iTimeStampInUTC;
		this.oMoment = moment.unix(this.iTimeStampInUTC);
	};

	/**
	 * @param {number} iYear
	 * @param {number} iMonth
	 * @param {number} iDay
	 */
	CDateModel.prototype.setDate = function (iYear, iMonth, iDay)
	{
		this.oMoment = moment([iYear, iMonth, iDay]);
	};

	/**
	 * @return {string}
	 */
	CDateModel.prototype.getTimeFormat = function ()
	{
		return (UserSettings.timeFormat() === window.Enums.TimeFormat.F24) ? 'HH:mm' : 'hh:mm A';
	};

	/**
	 * @return {string}
	 */
	CDateModel.prototype.getFullDate = function ()
	{
		return this.getDate() + ' ' + this.getTime();	
	};

	/**
	 * @return {string}
	 */
	CDateModel.prototype.getMidDate = function ()
	{
		return this.getShortDate(true);
	};

	/**
	 * @param {boolean=} bTime = false
	 * 
	 * @return {string}
	 */
	CDateModel.prototype.getShortDate = function (bTime)
	{
		var
			sResult = '',
			oMomentNow = null
		;

		if (this.oMoment)
		{
			oMomentNow = moment();

			if (oMomentNow.format('L') === this.oMoment.format('L'))
			{
				sResult = this.oMoment.format(this.getTimeFormat());
			}
			else
			{
				if (oMomentNow.clone().subtract(1, 'days').format('L') === this.oMoment.format('L'))
				{
					sResult = TextUtils.i18n('COREWEBCLIENT/LABEL_YESTERDAY');
				}
				else
				{
					if (UserSettings.UserSelectsDateFormat)
					{
						sResult = this.oMoment.format(Utils.getDateFormatForMoment(UserSettings.dateFormat()));
					}
					else
					{
						if (oMomentNow.year() === this.oMoment.year())
						{
							sResult = this.oMoment.format('MMM D');
						}
						else
						{
							sResult = this.oMoment.format('MMM D, YYYY');
						}
					}
				}

				if (!!bTime)
				{
					sResult += ', ' + this.oMoment.format(this.getTimeFormat());
				}
			}
		}

		return sResult;
	};

	/**
	 * @return {string}
	 */
	CDateModel.prototype.getDate = function ()
	{
		var sFormat = 'ddd, MMM D, YYYY';
		
		if (UserSettings.UserSelectsDateFormat)
		{
			sFormat = 'ddd, ' + Utils.getDateFormatForMoment(UserSettings.dateFormat());
		}
		
		return (this.oMoment) ? this.oMoment.format(sFormat) : '';
	};

	/**
	 * @return {string}
	 */
	CDateModel.prototype.getTime = function ()
	{
		return (this.oMoment) ? this.oMoment.format(this.getTimeFormat()): '';
	};

	/**
	 * @return {number}
	 */
	CDateModel.prototype.getTimeStampInUTC = function ()
	{
		return this.iTimeStampInUTC;
	};

	module.exports = CDateModel;


/***/ }),

/***/ 364:
/*!***************************************************************!*\
  !*** ./modules/CoreWebclient/js/models/CAbstractFileModel.js ***!
  \***************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		FilesUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Files.js */ 365),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		aViewMimeTypes = [
			'image/jpeg', 'image/png', 'image/gif',
			'text/html', 'text/plain', 'text/css',
			'text/rfc822-headers', 'message/delivery-status',
			'application/x-httpd-php', 'application/javascript'
		],
		
		aViewExtensions = []
	;

	if ($('html').hasClass('pdf'))
	{
		aViewMimeTypes.push('application/pdf');
		aViewMimeTypes.push('application/x-pdf');
	}

	/**
	 * @constructor
	 */
	function CAbstractFileModel()
	{
		this.id = ko.observable('');
		this.index = ko.observable(0);
		this.fileName = ko.observable('');
		this.tempName = ko.observable('');
		this.displayName = ko.observable('');
		this.extension = ko.observable('');
		
		this.fileName.subscribe(function (sFileName) {
			this.id(sFileName);
			this.displayName(sFileName);
			this.extension(Utils.getFileExtension(sFileName));
		}, this);
		
		this.size = ko.observable(0);
		this.friendlySize = ko.computed(function () {
			return this.size() > 0 ? TextUtils.getFriendlySize(this.size()) : '';
		}, this);
		
		this.hash = ko.observable('');
		
		this.thumbUrlInQueue = ko.observable('');
		this.thumbUrlInQueueSubscribtion = this.thumbUrlInQueue.subscribe(function () {
			this.getInThumbQueue();
		}, this);

		this.thumbnailSrc = ko.observable('');
		this.thumbnailLoaded = ko.observable(false);
		this.thumbnailSessionUid = ko.observable('');

		this.mimeType = ko.observable('');
		this.uploadUid = ko.observable('');
		this.uploaded = ko.observable(false);
		this.uploadError = ko.observable(false);
		this.downloading = ko.observable(false);
		this.isViewMimeType = ko.computed(function () {
			return (-1 !== $.inArray(this.mimeType(), aViewMimeTypes));
		}, this);
		this.bHasHtmlEmbed = false;
		
		this.otherTemplates = ko.observableArray([]);

		this.statusText = ko.observable('');
		this.statusTooltip = ko.computed(function () {
			return this.uploadError() ? this.statusText() : '';
		}, this);
		this.progressPercent = ko.observable(0);
		this.visibleProgress = ko.observable(false);
		
		this.uploadStarted = ko.observable(false);
		this.uploadStarted.subscribe(function () {
			if (this.uploadStarted())
			{
				this.uploaded(false);
				this.visibleProgress(true);
				this.progressPercent(20);
			}
			else
			{
				this.progressPercent(100);
				this.visibleProgress(false);
				this.uploaded(true);
			}
		}, this);
		
		this.downloading.subscribe(function () {
			if (this.downloading())
			{
				this.visibleProgress(true);
			}
			else
			{
				this.visibleProgress(false);
				this.progressPercent(0);
			}
		}, this);
		
		this.allowDrag = ko.observable(false);
		this.allowUpload = ko.observable(false);
		this.allowSharing = ko.observable(false);
		this.bIsSecure = ko.observable(false);
		
		this.sHeaderText = '';

		this.oActionsData = {
			'view': {
				'Text': TextUtils.i18n('COREWEBCLIENT/ACTION_VIEW_FILE'),
				'Handler': _.bind(function () { this.viewFile(); }, this)
			},
			'download': {
				'Text': TextUtils.i18n('COREWEBCLIENT/ACTION_DOWNLOAD_FILE'),
				'Handler': _.bind(function () { this.downloadFile(); }, this),
				'Tooltip': ko.computed(function () {
					var sTitle = TextUtils.i18n('COREWEBCLIENT/INFO_CLICK_TO_DOWNLOAD_FILE', {
						'FILENAME': this.fileName(),
						'SIZE': this.friendlySize()
					});

					if (this.friendlySize() === '')
					{
						sTitle = sTitle.replace(' ()', '');
					}

					return sTitle;
				}, this)
			}
		};
		
		this.allowActions = ko.observable(true);
		
		this.iconAction = ko.observable('download');
		
		this.cssClasses = ko.computed(function () {
			return this.getCommonClasses().join(' ');
		}, this);
		
		this.actions = ko.observableArray([]);
		
		this.firstAction = ko.computed(function () {
			if (this.actions().length > 1)
			{
				return this.actions()[0];
			}
			return '';
		}, this);
		
		this.secondAction = ko.computed(function () {
			if (this.actions().length === 1)
			{
				return this.actions()[0];
			}
			if (this.actions().length > 1)
			{
				return this.actions()[1];
			}
			return '';
		}, this);
		
		this.subFiles = ko.observableArray([]);
		this.subFilesExpanded = ko.observable(false);
	}

	CAbstractFileModel.prototype.addAction = function (sAction, bMain, oActionData)
	{
		if (bMain)
		{
			this.actions.unshift(sAction);
		}
		else
		{
			this.actions.push(sAction);
		}
		this.actions(_.compact(this.actions()));
		if (oActionData)
		{
			this.oActionsData[sAction] = oActionData;
		}
	};

	CAbstractFileModel.prototype.removeAction = function (sAction)
	{
		this.actions(_.without(this.actions(), sAction));
	};

	CAbstractFileModel.prototype.getMainAction = function ()
	{
		return this.actions()[0];
	};

	CAbstractFileModel.prototype.hasAction = function (sAction)
	{
		return _.indexOf(this.actions(), sAction) !== -1;
	};

	/**
	 * Returns button text for specified action.
	 * @param {string} sAction
	 * @returns string
	 */
	CAbstractFileModel.prototype.getActionText = function (sAction)
	{
		if (this.hasAction(sAction) && this.oActionsData[sAction] && (typeof this.oActionsData[sAction].Text === 'string' || _.isFunction(this.oActionsData[sAction].Text)))
		{
			return _.isFunction(this.oActionsData[sAction].Text) ? this.oActionsData[sAction].Text() : this.oActionsData[sAction].Text;
		}
		return '';
	};

	CAbstractFileModel.prototype.getActionUrl = function (sAction)
	{
		return (this.hasAction(sAction) && this.oActionsData[sAction]) ? (this.oActionsData[sAction].Url || '') : '';
	};

	/**
	 * Executes specified action.
	 * @param {string} sAction
	 */
	CAbstractFileModel.prototype.executeAction = function (sAction)
	{
		if (this.hasAction(sAction) && this.oActionsData[sAction] && _.isFunction(this.oActionsData[sAction].Handler))
		{
			this.oActionsData[sAction].Handler();
		}
	};

	/**
	 * Returns tooltip for specified action.
	 * @param {string} sAction
	 * @returns string
	 */
	CAbstractFileModel.prototype.getTooltip = function (sAction)
	{
		var mTootip = this.hasAction(sAction) && this.oActionsData[sAction] ? this.oActionsData[sAction].Tooltip : '';
		if (typeof mTootip === 'string')
		{
			return mTootip;
		}
		if (_.isFunction(mTootip))
		{
			return mTootip();
		}
		return '';
	};

	/**
	 * Returns list of css classes for file.
	 * @returns array
	 */
	CAbstractFileModel.prototype.getCommonClasses = function ()
	{
		var aClasses = [];

		if ((this.allowUpload() && !this.uploaded()) || this.downloading())
		{
			aClasses.push('incomplete');
		}
		if (this.uploadError())
		{
			aClasses.push('fail');
		}
		else
		{
			aClasses.push('success');
		}

		return aClasses;
	};

	/**
	 * Parses attachment data from server.
	 * @param {AjaxAttachmenResponse} oData
	 */
	CAbstractFileModel.prototype.parse = function (oData)
	{
		this.fileName(Types.pString(oData.FileName));
		this.tempName(Types.pString(oData.TempName));
		if (this.tempName() === '')
		{
			this.tempName(this.fileName());
		}

		this.mimeType(Types.pString(oData.MimeType));
		this.size(oData.EstimatedSize ? Types.pInt(oData.EstimatedSize) : Types.pInt(oData.SizeInBytes));

		this.hash(Types.pString(oData.Hash));

		this.parseActions(oData);

		this.uploadUid(this.hash());
		this.uploaded(true);

		if ($.isFunction(this.additionalParse))
		{
			this.additionalParse(oData);
		}
	};

	CAbstractFileModel.prototype.parseActions = function (oData)
	{
		this.commonParseActions(oData);
	};

	CAbstractFileModel.prototype.commonParseActions = function (oData)
	{
		this.thumbUrlInQueue(Types.pString(oData.ThumbnailUrl) !== '' ? Types.pString(oData.ThumbnailUrl) + '/' + Math.random() : '');
		_.each (oData.Actions, function (oData, sAction) {
			if (!this.oActionsData[sAction])
			{
				this.oActionsData[sAction] = {};
			}
			this.oActionsData[sAction].Url = Types.pString(oData.url);
			this.actions.push(sAction);
		}, this);
	};

	CAbstractFileModel.addViewExtensions = function (aAddViewExtensions)
	{
		if (_.isArray(aAddViewExtensions))
		{
			aViewExtensions = _.union(aViewExtensions, aAddViewExtensions);
		}
	};

	CAbstractFileModel.prototype.isViewSupported = function ()
	{
		return (-1 !== $.inArray(this.mimeType(), aViewMimeTypes) || -1 !== $.inArray(this.extension(), aViewExtensions));
	};

	CAbstractFileModel.prototype.getInThumbQueue = function ()
	{
		if(this.thumbUrlInQueue() !== '' && (!this.linked || this.linked && !this.linked()))
		{
			this.thumbnailSessionUid(Date.now().toString());
			FilesUtils.thumbQueue(this.thumbnailSessionUid(), this.thumbUrlInQueue(), this.thumbnailSrc);
		}
	};

	/**
	 * Starts downloading attachment on click.
	 */
	CAbstractFileModel.prototype.downloadFile = function ()
	{
		//todo: UrlUtils.downloadByUrl in nessesary context in new window
		var 
			sDownloadLink = this.getActionUrl('download'),
			oParams = {
				'File': this,
				'CancelDownload': false
			}
		;
		if (sDownloadLink.length > 0 && sDownloadLink !== '#')
		{
			App.broadcastEvent('AbstractFileModel::FileDownload::before', oParams);
			if (!oParams.CancelDownload)
			{
				if (_.isFunction(oParams.CustomDownloadHandler))
				{
					oParams.CustomDownloadHandler();
				}
				else
				{
					UrlUtils.downloadByUrl(sDownloadLink);
				}
			}
		}
	};

	/**
	 * Can be overridden.
	 * Starts viewing attachment on click.
	 * @param {Object} oViewModel
	 * @param {Object} oEvent
	 */
	CAbstractFileModel.prototype.viewFile = function (oViewModel, oEvent)
	{
		Utils.calmEvent(oEvent);
		this.viewCommonFile();
	};

	/**
	 * Starts viewing attachment on click.
	 * @param {string=} sUrl
	 */
	CAbstractFileModel.prototype.viewCommonFile = function (sUrl)
	{
		var 
			oWin = null,
			oParams = null
		;
		
		if (!Types.isNonEmptyString(sUrl))
		{
			sUrl = UrlUtils.getAppPath() + this.getActionUrl('view');
		}

		if (sUrl.length > 0 && sUrl !== '#')
		{
			oParams = {sUrl: sUrl, index: this.index(), bBreakView: false};
			
			App.broadcastEvent('AbstractFileModel::FileView::before', oParams);
			
			if (!oParams.bBreakView)
			{
				oWin = WindowOpener.open(sUrl, sUrl, false);

				if (oWin)
				{
					oWin.focus();
				}
			}
		}
	};

	/**
	 * @param {Object} oAttachment
	 * @param {*} oEvent
	 * @return {boolean}
	 */
	CAbstractFileModel.prototype.eventDragStart = function (oAttachment, oEvent)
	{
		var oLocalEvent = oEvent.originalEvent || oEvent;
		if (oAttachment && oLocalEvent && oLocalEvent.dataTransfer && oLocalEvent.dataTransfer.setData)
		{
			oLocalEvent.dataTransfer.setData('DownloadURL', this.generateTransferDownloadUrl());
		}

		return true;
	};

	/**
	 * @return {string}
	 */
	CAbstractFileModel.prototype.generateTransferDownloadUrl = function ()
	{
		var sLink = this.getActionUrl('download');
		if ('http' !== sLink.substr(0, 4))
		{
			sLink = UrlUtils.getAppPath() + sLink;
		}

		return this.mimeType() + ':' + this.fileName() + ':' + sLink;
	};

	/**
	 * Fills attachment data for upload.
	 *
	 * @param {string} sFileUid
	 * @param {Object} oFileData
	 * @param {bool} bOnlyUploadStatus
	 */
	CAbstractFileModel.prototype.onUploadSelect = function (sFileUid, oFileData, bOnlyUploadStatus)
	{
		if (!bOnlyUploadStatus)
		{
			this.fileName(Types.pString(oFileData['FileName']));
			this.mimeType(Types.pString(oFileData['Type']));
			this.size(Types.pInt(oFileData['Size']));
		}
		
		this.uploadUid(sFileUid);
		this.uploaded(false);
		this.statusText('');
		this.progressPercent(0);
		this.visibleProgress(false);
	};

	/**
	 * Starts progress.
	 */
	CAbstractFileModel.prototype.onUploadStart = function ()
	{
		this.visibleProgress(true);
	};

	/**
	 * Fills progress upload data.
	 *
	 * @param {number} iUploadedSize
	 * @param {number} iTotalSize
	 */
	CAbstractFileModel.prototype.onUploadProgress = function (iUploadedSize, iTotalSize)
	{
		if (iTotalSize > 0)
		{
			this.progressPercent(Math.ceil(iUploadedSize / iTotalSize * 100));
			this.visibleProgress(true);
		}
	};

	/**
	 * Fills progress download data.
	 *
	 * @param {number} iDownloadedSize
	 * @param {number} iTotalSize
	 */
	CAbstractFileModel.prototype.onDownloadProgress = function (iDownloadedSize, iTotalSize)
	{
		if (iTotalSize > 0)
		{
			this.progressPercent(Math.ceil(iDownloadedSize / iTotalSize * 100));
			this.visibleProgress(this.progressPercent() < 100);
		}
	};

	/**
	 * Fills data when upload has completed.
	 *
	 * @param {string} sFileUid
	 * @param {boolean} bResponseReceived
	 * @param {Object} oResponse
	 */
	CAbstractFileModel.prototype.onUploadComplete = function (sFileUid, bResponseReceived, oResponse)
	{
		var
			bError = !bResponseReceived || !oResponse || !!oResponse.ErrorCode || !oResponse.Result || !!oResponse.Result.Error || false,
			sError = (oResponse && oResponse.Result && oResponse.Result.Error === 'size') ?
				TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_SIZE') :
				TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_UNKNOWN')
		;
		
		this.progressPercent(0);
		this.visibleProgress(false);
		
		this.uploaded(true);
		this.uploadError(bError);
		this.statusText(bError ? sError : TextUtils.i18n('COREWEBCLIENT/REPORT_UPLOAD_COMPLETE'));

		if (!bError)
		{
			this.fillDataAfterUploadComplete(oResponse, sFileUid);
			
			setTimeout((function (self) {
				return function () {
					self.statusText('');
				};
			})(this), 3000);
		}
	};

	/**
	 * Should be overriden.
	 * 
	 * @param {Object} oResult
	 * @param {string} sFileUid
	 */
	CAbstractFileModel.prototype.fillDataAfterUploadComplete = function (oResult, sFileUid)
	{
	};

	/**
	 * @param {Object} oAttachmentModel
	 * @param {Object} oEvent
	 */
	CAbstractFileModel.prototype.onImageLoad = function (oAttachmentModel, oEvent)
	{
		if(this.thumbUrlInQueue() !== '' && !this.thumbnailLoaded())
		{
			this.thumbnailLoaded(true);
			FilesUtils.thumbQueue(this.thumbnailSessionUid());
		}
	};

	/**
	 * Signalise that file download was stoped.
	 */
	CAbstractFileModel.prototype.stopDownloading = function ()
	{
		this.downloading(false);
	};

	/**
	 * Signalise that file download was started.
	 */
	CAbstractFileModel.prototype.startDownloading = function ()
	{
		this.downloading(true);
	};

	module.exports = CAbstractFileModel;


/***/ }),

/***/ 365:
/*!*************************************************!*\
  !*** ./modules/CoreWebclient/js/utils/Files.js ***!
  \*************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		AlertPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/AlertPopup.js */ 188),
		
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		FilesUtils = {}
	;

	/**
	 * Gets link for download by hash.
	 *
	 * @param {string} sModuleName Name of module that owns the file.
	 * @param {string} sHash Hash of the file.
	 * @param {string} sPublicHash Hash of shared folder if the file is displayed by public link.
	 * 
	 * @return {string}
	 */
	FilesUtils.getDownloadLink = function (sModuleName, sHash, sPublicHash)
	{
		return sHash.length > 0 ? '?/Download/' + sModuleName + '/DownloadFile/' + sHash + '/' + (sPublicHash ? '0/' + sPublicHash : '') : '';
	};

	/**
	 * Gets link for view by hash in iframe.
	 *
	 * @param {number} iAccountId
	 * @param {string} sUrl
	 *
	 * @return {string}
	 */
	FilesUtils.getIframeWrappwer = function (iAccountId, sUrl)
	{
		return '?/Raw/Iframe/' + iAccountId + '/' + window.encodeURIComponent(sUrl) + '/';
	};

	FilesUtils.thumbQueue = (function () {

		var
			oImages = {},
			oImagesIncrements = {},
			iNumberOfImages = 2
		;

		return function (sSessionUid, sImageSrc, fImageSrcObserver)
		{
			if(sImageSrc && fImageSrcObserver)
			{
				if(!(sSessionUid in oImagesIncrements) || oImagesIncrements[sSessionUid] > 0) //load first images
				{
					if(!(sSessionUid in oImagesIncrements)) //on first image
					{
						oImagesIncrements[sSessionUid] = iNumberOfImages;
						oImages[sSessionUid] = [];
					}
					oImagesIncrements[sSessionUid]--;

					fImageSrcObserver(sImageSrc); //load image
				}
				else //create queue
				{
					oImages[sSessionUid].push({
						imageSrc: sImageSrc,
						imageSrcObserver: fImageSrcObserver,
						messageUid: sSessionUid
					});
				}
			}
			else //load images from queue (fires load event)
			{
				if(oImages[sSessionUid] && oImages[sSessionUid].length)
				{
					oImages[sSessionUid][0].imageSrcObserver(oImages[sSessionUid][0].imageSrc);
					oImages[sSessionUid].shift();
				}
			}
		};
	}());

	/**
	 * @param {string} sFileName
	 * @param {number} iSize
	 * @returns {Boolean}
	 */
	FilesUtils.showErrorIfAttachmentSizeLimit = function (sFileName, iSize)
	{
		var
			sWarning = TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_SIZE_DETAILED', {
				'FILENAME': sFileName,
				'MAXSIZE': TextUtils.getFriendlySize(UserSettings.AttachmentSizeLimit)
			})
		;
		
		if (UserSettings.AttachmentSizeLimit > 0 && iSize > UserSettings.AttachmentSizeLimit)
		{
			Popups.showPopup(AlertPopup, [sWarning]);
			return true;
		}
		
		return false;
	};

	module.exports = FilesUtils;


/***/ }),

/***/ 391:
/*!***************************************************!*\
  !*** ./modules/MailMobileWebclient/js/manager.js ***!
  \***************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = function (oAppData) {
		var
			_ = __webpack_require__(/*! underscore */ 2),
			ko = __webpack_require__(/*! knockout */ 46),
			$ = __webpack_require__(/*! jquery */ 1),
			
			App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
			ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
			
			MailSettings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
		;
		
		MailSettings.init(oAppData);
		
		if (!ModulesManager.isModuleAvailable('CoreMobileWebclient'))
		{
			return null;
		}
		
		__webpack_require__(/*! modules/MailWebclient/js/enums.js */ 393);
		
	//	require('node_modules/framework7/dist/css/framework7.css');
		__webpack_require__(/*! node_modules/framework7/dist/css/framework7.material.css */ 394);
		__webpack_require__(/*! node_modules/framework7/dist/css/framework7.material.colors.css */ 397);
	//	require('node_modules/framework7/dist/css/framework7.ios.css');
	//	require('node_modules/framework7/dist/css/framework7.ios.colors.css');
		
		$('html').addClass("md");
		
		if (App.getUserRole() === Enums.UserRole.NormalUser)
		{
			if (App.isMobile())
			{
				var Cache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399);
				Cache.init();
				var AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402);

				return {
					enableModule: ko.observable(MailSettings.AllowAddAccounts || AccountList.hasAccount() ),
					start: function (ModulesManager) {
						var
							Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178),
							MailUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Mail.js */ 419)
						;

						__webpack_require__(/*! modules/MailWebclient/js/koBindings.js */ 432);

						if (MailSettings.AllowAppRegisterMailto)
						{
							MailUtils.registerMailto(Browser.firefox);
						}

						ko.computed(function () {
							var aAuthAcconts = _.filter(AccountList.collection(), function (oAccount) {
								return oAccount.useToAuthorize();
							});

							MailSettings.userMailAccountsCount(aAuthAcconts.length);
						}, this);
					},
					getScreens: function () {
						var oScreens = {};
						oScreens[MailSettings.HashModuleName] = function () {
							return __webpack_require__(/*! modules/MailMobileWebclient/js/views/MailView.js */ 433);
						};
						oScreens[MailSettings.HashModuleName + '-compose'] = function () {
							var CComposeView = __webpack_require__(/*! modules/MailWebclient/js/views/CComposeView.js */ 413);
							CComposeView.prototype.registerOwnToolbarControllers = function ()
	{							this.registerToolbarController({
									ViewTemplate: 'MailWebclient_Compose_BackButtonView',
									sId: 'back',
									bOnlyMobile: true,
									backToListCommand: this.backToListCommand
								});
								this.registerToolbarController({
									ViewTemplate: 'MailMobileWebclient_Compose_SendButtonView',
									sId: 'send',
									bAllowMobile: true,
									sendCommand: this.sendCommand
								});
								this.registerToolbarController({
									ViewTemplate: 'MailMobileWebclient_Compose_SaveButtonView',
									sId: 'save',
									bAllowMobile: true,
									saveCommand: this.saveCommand
								});
								this.registerToolbarController({
									ViewTemplate: 'MailWebclient_Compose_ImportanceDropdownView',
									sId: 'importance',
									selectedImportance: this.selectedImportance
								});
								this.registerToolbarController({
									ViewTemplate: 'MailWebclient_Compose_ConfirmationCheckboxView',
									sId: 'confirmation',
									sendReadingConfirmation: this.sendReadingConfirmation
								});
							};
							var oComposeView = new CComposeView();
							oComposeView.ViewTemplate = 'MailMobileWebclient_ComposeView';
							oComposeView.oHtmlEditor.ViewTemplate = 'MailMobileWebclient_HtmlEditorView';
							oComposeView.executeBackToList = function ()
							{
								if (App.isNewTab())
								{
									window.close();
								}
								else if (!!this.shown && this.shown())
								{
									var
										HeaderItemView = __webpack_require__(/*! modules/MailMobileWebclient/js/views/HeaderItemView.js */ 440),
										Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190)
									;
									HeaderItemView.hash(HeaderItemView.baseHash());
									Routing.setPreviousHash();
								}
								this.backToListOnSendOrSave(false);
							};
							return oComposeView;
						};
						return oScreens;
					},
					getHeaderItem: function () {
						return {
							item: __webpack_require__(/*! modules/MailMobileWebclient/js/views/HeaderItemView.js */ 440),
							name: MailSettings.HashModuleName
						};
					}
				};
			}
		}
		
		return null;
	};


/***/ }),

/***/ 392:
/*!**********************************************!*\
  !*** ./modules/MailWebclient/js/Settings.js ***!
  \**********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		_ = __webpack_require__(/*! underscore */ 2),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179)
	;

	module.exports = {
		ServerModuleName: 'Mail',
		HashModuleName: 'mail',
		FetchersServerModuleName: 'MailSuite',
		
		// from Mail module
		AllowAddAccounts: false,
		AllowAutoresponder: false,
		AllowAutosaveInDrafts: true,
		AllowDefaultAccountForUser: true,
		AllowFetchers: false,
		AllowFilters: false,
		AllowForward: false,
		AllowIdentities: false,
		AllowInsertImage: true,
		AllowMultiAccounts: false,
		AutoSaveIntervalSeconds: 60,
		ImageUploadSizeLimit: 0,
		
		// from MailWebclient module
		AllowAppRegisterMailto: false,
		AllowChangeInputDirection: true,
		AllowExpandFolders: false,
		AllowSpamFolder: true,
		AllowAddNewFolderOnMainScreen: false,
		ComposeToolbarOrder: ['back', 'send', 'save', 'importance', 'MailSensitivity', 'confirmation', 'OpenPgp'],
		DefaultFontName: 'Tahoma',
		DefaultFontSize: 3,
		JoinReplyPrefixes: true,
		MailsPerPage: 20,
		MaxMessagesBodiesSizeToPrefetch: 50000,
		ShowEmailAsTabName: true,
		
		userMailAccountsCount: ko.observable(0),
		mailAccountsEmails: ko.observableArray([]),
		
		/**
		 * Initializes settings from AppData object sections.
		 * 
		 * @param {Object} oAppData Object contained modules settings.
		 */
		init: function (oAppData)
		{
			var
				oAppDataMailSection = oAppData[this.ServerModuleName],
				oAppDataMailWebclientSection = oAppData['MailWebclient'],
				oAppDataFetchersSection = oAppData[this.FetchersServerModuleName]
			;
			
			if (!_.isEmpty(oAppDataMailSection))
			{
				this.AllowAddAccounts = Types.pBool(oAppDataMailSection.AllowAddAccounts, this.AllowAddAccounts);
				this.AllowAutoresponder = Types.pBool(oAppDataMailSection.AllowAutoresponder, this.AllowAutoresponder);
				this.AllowAutosaveInDrafts = Types.pBool(oAppDataMailSection.AllowAutosaveInDrafts, this.AllowAutosaveInDrafts);
				this.AllowDefaultAccountForUser = Types.pBool(oAppDataMailSection.AllowDefaultAccountForUser, this.AllowDefaultAccountForUser);
				this.AllowFilters = Types.pBool(oAppDataMailSection.AllowFilters, this.AllowFilters);
				this.AllowForward = Types.pBool(oAppDataMailSection.AllowForward, this.AllowForward);
				this.AllowIdentities = Types.pBool(oAppDataMailSection.AllowIdentities, this.AllowIdentities);
				this.AllowInsertImage = Types.pBool(oAppDataMailSection.AllowInsertImage, this.AllowInsertImage);
				this.AllowMultiAccounts = Types.pBool(oAppDataMailSection.AllowMultiAccounts, this.AllowMultiAccounts);
				this.AutoSaveIntervalSeconds = Types.pNonNegativeInt(oAppDataMailSection.AutoSaveIntervalSeconds, this.AutoSaveIntervalSeconds);
				this.ImageUploadSizeLimit = Types.pNonNegativeInt(oAppDataMailSection.ImageUploadSizeLimit, this.ImageUploadSizeLimit);
				window.Enums.SmtpAuthType = Types.pObject(oAppDataMailSection.SmtpAuthType);
			}
				
			if (!_.isEmpty(oAppDataMailWebclientSection))
			{
				this.AllowAppRegisterMailto = Types.pBool(oAppDataMailWebclientSection.AllowAppRegisterMailto, this.AllowAppRegisterMailto);
				this.AllowChangeInputDirection = Types.pBool(oAppDataMailWebclientSection.AllowChangeInputDirection, this.AllowChangeInputDirection);
				this.AllowExpandFolders = Types.pBool(oAppDataMailWebclientSection.AllowExpandFolders, this.AllowExpandFolders);
				this.AllowSpamFolder = Types.pBool(oAppDataMailWebclientSection.AllowSpamFolder, this.AllowSpamFolder);
				this.AllowAddNewFolderOnMainScreen = Types.pBool(oAppDataMailWebclientSection.AllowAddNewFolderOnMainScreen, this.AllowAddNewFolderOnMainScreen);
				this.ComposeToolbarOrder = Types.pArray(oAppDataMailWebclientSection.ComposeToolbarOrder, this.ComposeToolbarOrder);
				this.DefaultFontName = Types.pString(oAppDataMailWebclientSection.DefaultFontName, this.DefaultFontName);
				this.DefaultFontSize = Types.pPositiveInt(oAppDataMailWebclientSection.DefaultFontSize, this.DefaultFontSize);
				this.JoinReplyPrefixes = Types.pBool(oAppDataMailWebclientSection.JoinReplyPrefixes, this.JoinReplyPrefixes);
				this.MailsPerPage = Types.pPositiveInt(oAppDataMailWebclientSection.MailsPerPage, this.MailsPerPage);
				this.MaxMessagesBodiesSizeToPrefetch = Types.pNonNegativeInt(oAppDataMailWebclientSection.MaxMessagesBodiesSizeToPrefetch, this.MaxMessagesBodiesSizeToPrefetch);
				this.ShowEmailAsTabName = Types.pBool(oAppDataMailWebclientSection.ShowEmailAsTabName, this.ShowEmailAsTabName);
			}
			
			if (!_.isEmpty(oAppDataFetchersSection))
			{
				this.AllowFetchers = Types.pBool(oAppDataFetchersSection.AllowFetchers, this.AllowFetchers);
			}
			
			App.registerUserAccountsCount(this.userMailAccountsCount);
			App.registerAccountsWithPass(this.mailAccountsEmails);
		},
		
		/**
		 * Updates new settings values after saving on server.
		 * 
		 * @param {number} iMailsPerPage
		 * @param {boolean} bAllowAutosaveInDrafts
		 * @param {boolean} bAllowChangeInputDirection
		 */
		update: function (iMailsPerPage, bAllowAutosaveInDrafts, bAllowChangeInputDirection)
		{
			this.AllowAutosaveInDrafts = Types.pBool(bAllowAutosaveInDrafts, this.AllowAutosaveInDrafts);
			
			this.AllowChangeInputDirection = Types.pBool(bAllowChangeInputDirection, this.AllowChangeInputDirection);
			this.MailsPerPage = Types.pPositiveInt(iMailsPerPage, this.MailsPerPage);
		}
	};


/***/ }),

/***/ 393:
/*!*******************************************!*\
  !*** ./modules/MailWebclient/js/enums.js ***!
  \*******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		Enums = {}
	;

	/**
	 * @enum {string}
	 */
	Enums.FolderFilter = {
		'Flagged': 'flagged',
		'Unseen': 'unseen'
	};

	/**
	 * @enum {number}
	 */
	Enums.FolderTypes = {
		'Inbox': 1,
		'Sent': 2,
		'Drafts': 3,
		'Spam': 4,
		'Trash': 5,
		'Virus': 6,
		'Starred': 7,
		'System': 9,
		'User': 10
	};

	/**
	 * @enum {number}
	 */
	Enums.Importance = {
		'Low': 5,
		'Normal': 3,
		'High': 1
	};

	/**
	 * @enum {number}
	 */
	Enums.Sensitivity = {
		'Nothing': 0,
		'Confidential': 1,
		'Private': 2,
		'Personal': 3
	};

	/**
	 * @enum {string}
	 */
	Enums.AnotherMessageComposedAnswer = {
		'Discard': 'Discard',
		'SaveAsDraft': 'SaveAsDraft',
		'Cancel': 'Cancel'
	};

	/**
	 * @enum {string}
	 */
	Enums.ReplyType = {
		'Reply': 'reply',
		'ReplyAll': 'reply-all',
		'Resend': 'resend',
		'Forward': 'forward',
		'ForwardAsAttach': 'eml'
	};

	Enums.HtmlEditorImageSizes = {
		'Small': 'small',
		'Medium': 'medium',
		'Large': 'large',
		'Original': 'original'
	};

	Enums.UseSignature = {
		'Off': '0',
		'On': '1'
	};

	Enums.MailErrors = {
		'CannotMoveMessageQuota': 4008
	};

	if (typeof window.Enums === 'undefined')
	{
		window.Enums = {};
	}

	_.extendOwn(window.Enums, Enums);


/***/ }),

/***/ 394:
/*!*******************************************************!*\
  !*** ./~/framework7/dist/css/framework7.material.css ***!
  \*******************************************************/
/***/ (function(module, exports, __webpack_require__) {

	// style-loader: Adds some css to the DOM by adding a <style> tag

	// load the styles
	var content = __webpack_require__(/*! !../../../css-loader!./framework7.material.css */ 395);
	if(typeof content === 'string') content = [[module.id, content, '']];
	// add the styles to the DOM
	var update = __webpack_require__(/*! ../../../style-loader/addStyles.js */ 260)(content, {});
	if(content.locals) module.exports = content.locals;
	// Hot Module Replacement
	if(false) {
		// When the styles change, update the <style> tags
		if(!content.locals) {
			module.hot.accept("!!../../../css-loader/index.js!./framework7.material.css", function() {
				var newContent = require("!!../../../css-loader/index.js!./framework7.material.css");
				if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
				update(newContent);
			});
		}
		// When the module is disposed, remove the <style> tags
		module.hot.dispose(function() { update(); });
	}

/***/ }),

/***/ 395:
/*!**********************************************************************!*\
  !*** ./~/css-loader!./~/framework7/dist/css/framework7.material.css ***!
  \**********************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	exports = module.exports = __webpack_require__(/*! ../../../css-loader/lib/css-base.js */ 259)();
	// imports


	// module
	exports.push([module.id, "/**\n * Framework7 1.7.1\n * Full featured mobile HTML framework for building iOS & Android apps\n * \n * Google Material Theme\n *\n * http://framework7.io/\n * \n * Copyright 2018, Vladimir Kharlampidi\n * The iDangero.us\n * http://www.idangero.us/\n * \n * Licensed under MIT\n * \n * Released on: April 7, 2018\n */\nhtml,\nbody,\n.framework7-root {\n  position: relative;\n  height: 100%;\n  width: 100%;\n  overflow-x: hidden;\n}\nbody {\n  font-family: Roboto, Noto, Helvetica, Arial, sans-serif;\n  margin: 0;\n  padding: 0;\n  color: #212121;\n  font-size: 14px;\n  line-height: 1.5;\n  width: 100%;\n  -webkit-text-size-adjust: 100%;\n  background: #fff;\n  overflow: hidden;\n}\n.framework7-root {\n  overflow: hidden;\n}\n* {\n  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);\n  -webkit-touch-callout: none;\n}\na,\ninput,\ntextarea,\nselect {\n  outline: 0;\n}\na {\n  text-decoration: none;\n  color: #2196f3;\n}\np {\n  margin: 1em 0;\n}\n/* === Grid === */\n.row {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-lines: multiple;\n  -moz-box-lines: multiple;\n  -webkit-flex-wrap: wrap;\n  -ms-flex-wrap: wrap;\n  flex-wrap: wrap;\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n}\n.row > [class*=\"col-\"] {\n  box-sizing: border-box;\n}\n.row .col-auto {\n  width: 100%;\n}\n.row .col-100 {\n  width: 100%;\n  width: -webkit-calc((100% - 16px*0) / 1);\n  width: calc((100% - 16px*0) / 1);\n}\n.row.no-gutter .col-100 {\n  width: 100%;\n}\n.row .col-95 {\n  width: 95%;\n  width: -webkit-calc((100% - 16px*0.05263157894736836) / 1.0526315789473684);\n  width: calc((100% - 16px*0.05263157894736836) / 1.0526315789473684);\n}\n.row.no-gutter .col-95 {\n  width: 95%;\n}\n.row .col-90 {\n  width: 90%;\n  width: -webkit-calc((100% - 16px*0.11111111111111116) / 1.1111111111111112);\n  width: calc((100% - 16px*0.11111111111111116) / 1.1111111111111112);\n}\n.row.no-gutter .col-90 {\n  width: 90%;\n}\n.row .col-85 {\n  width: 85%;\n  width: -webkit-calc((100% - 16px*0.17647058823529416) / 1.1764705882352942);\n  width: calc((100% - 16px*0.17647058823529416) / 1.1764705882352942);\n}\n.row.no-gutter .col-85 {\n  width: 85%;\n}\n.row .col-80 {\n  width: 80%;\n  width: -webkit-calc((100% - 16px*0.25) / 1.25);\n  width: calc((100% - 16px*0.25) / 1.25);\n}\n.row.no-gutter .col-80 {\n  width: 80%;\n}\n.row .col-75 {\n  width: 75%;\n  width: -webkit-calc((100% - 16px*0.33333333333333326) / 1.3333333333333333);\n  width: calc((100% - 16px*0.33333333333333326) / 1.3333333333333333);\n}\n.row.no-gutter .col-75 {\n  width: 75%;\n}\n.row .col-70 {\n  width: 70%;\n  width: -webkit-calc((100% - 16px*0.4285714285714286) / 1.4285714285714286);\n  width: calc((100% - 16px*0.4285714285714286) / 1.4285714285714286);\n}\n.row.no-gutter .col-70 {\n  width: 70%;\n}\n.row .col-66 {\n  width: 66.66666666666666%;\n  width: -webkit-calc((100% - 16px*0.5000000000000002) / 1.5000000000000002);\n  width: calc((100% - 16px*0.5000000000000002) / 1.5000000000000002);\n}\n.row.no-gutter .col-66 {\n  width: 66.66666666666666%;\n}\n.row .col-65 {\n  width: 65%;\n  width: -webkit-calc((100% - 16px*0.5384615384615385) / 1.5384615384615385);\n  width: calc((100% - 16px*0.5384615384615385) / 1.5384615384615385);\n}\n.row.no-gutter .col-65 {\n  width: 65%;\n}\n.row .col-60 {\n  width: 60%;\n  width: -webkit-calc((100% - 16px*0.6666666666666667) / 1.6666666666666667);\n  width: calc((100% - 16px*0.6666666666666667) / 1.6666666666666667);\n}\n.row.no-gutter .col-60 {\n  width: 60%;\n}\n.row .col-55 {\n  width: 55%;\n  width: -webkit-calc((100% - 16px*0.8181818181818181) / 1.8181818181818181);\n  width: calc((100% - 16px*0.8181818181818181) / 1.8181818181818181);\n}\n.row.no-gutter .col-55 {\n  width: 55%;\n}\n.row .col-50 {\n  width: 50%;\n  width: -webkit-calc((100% - 16px*1) / 2);\n  width: calc((100% - 16px*1) / 2);\n}\n.row.no-gutter .col-50 {\n  width: 50%;\n}\n.row .col-45 {\n  width: 45%;\n  width: -webkit-calc((100% - 16px*1.2222222222222223) / 2.2222222222222223);\n  width: calc((100% - 16px*1.2222222222222223) / 2.2222222222222223);\n}\n.row.no-gutter .col-45 {\n  width: 45%;\n}\n.row .col-40 {\n  width: 40%;\n  width: -webkit-calc((100% - 16px*1.5) / 2.5);\n  width: calc((100% - 16px*1.5) / 2.5);\n}\n.row.no-gutter .col-40 {\n  width: 40%;\n}\n.row .col-35 {\n  width: 35%;\n  width: -webkit-calc((100% - 16px*1.8571428571428572) / 2.857142857142857);\n  width: calc((100% - 16px*1.8571428571428572) / 2.857142857142857);\n}\n.row.no-gutter .col-35 {\n  width: 35%;\n}\n.row .col-33 {\n  width: 33.333333333333336%;\n  width: -webkit-calc((100% - 16px*2) / 3);\n  width: calc((100% - 16px*2) / 3);\n}\n.row.no-gutter .col-33 {\n  width: 33.333333333333336%;\n}\n.row .col-30 {\n  width: 30%;\n  width: -webkit-calc((100% - 16px*2.3333333333333335) / 3.3333333333333335);\n  width: calc((100% - 16px*2.3333333333333335) / 3.3333333333333335);\n}\n.row.no-gutter .col-30 {\n  width: 30%;\n}\n.row .col-25 {\n  width: 25%;\n  width: -webkit-calc((100% - 16px*3) / 4);\n  width: calc((100% - 16px*3) / 4);\n}\n.row.no-gutter .col-25 {\n  width: 25%;\n}\n.row .col-20 {\n  width: 20%;\n  width: -webkit-calc((100% - 16px*4) / 5);\n  width: calc((100% - 16px*4) / 5);\n}\n.row.no-gutter .col-20 {\n  width: 20%;\n}\n.row .col-15 {\n  width: 15%;\n  width: -webkit-calc((100% - 16px*5.666666666666667) / 6.666666666666667);\n  width: calc((100% - 16px*5.666666666666667) / 6.666666666666667);\n}\n.row.no-gutter .col-15 {\n  width: 15%;\n}\n.row .col-10 {\n  width: 10%;\n  width: -webkit-calc((100% - 16px*9) / 10);\n  width: calc((100% - 16px*9) / 10);\n}\n.row.no-gutter .col-10 {\n  width: 10%;\n}\n.row .col-5 {\n  width: 5%;\n  width: -webkit-calc((100% - 16px*19) / 20);\n  width: calc((100% - 16px*19) / 20);\n}\n.row.no-gutter .col-5 {\n  width: 5%;\n}\n.row .col-auto:nth-last-child(1),\n.row .col-auto:nth-last-child(1) ~ .col-auto {\n  width: 100%;\n  width: -webkit-calc((100% - 16px*0) / 1);\n  width: calc((100% - 16px*0) / 1);\n}\n.row.no-gutter .col-auto:nth-last-child(1),\n.row.no-gutter .col-auto:nth-last-child(1) ~ .col-auto {\n  width: 100%;\n}\n.row .col-auto:nth-last-child(2),\n.row .col-auto:nth-last-child(2) ~ .col-auto {\n  width: 50%;\n  width: -webkit-calc((100% - 16px*1) / 2);\n  width: calc((100% - 16px*1) / 2);\n}\n.row.no-gutter .col-auto:nth-last-child(2),\n.row.no-gutter .col-auto:nth-last-child(2) ~ .col-auto {\n  width: 50%;\n}\n.row .col-auto:nth-last-child(3),\n.row .col-auto:nth-last-child(3) ~ .col-auto {\n  width: 33.33333333%;\n  width: -webkit-calc((100% - 16px*2) / 3);\n  width: calc((100% - 16px*2) / 3);\n}\n.row.no-gutter .col-auto:nth-last-child(3),\n.row.no-gutter .col-auto:nth-last-child(3) ~ .col-auto {\n  width: 33.33333333%;\n}\n.row .col-auto:nth-last-child(4),\n.row .col-auto:nth-last-child(4) ~ .col-auto {\n  width: 25%;\n  width: -webkit-calc((100% - 16px*3) / 4);\n  width: calc((100% - 16px*3) / 4);\n}\n.row.no-gutter .col-auto:nth-last-child(4),\n.row.no-gutter .col-auto:nth-last-child(4) ~ .col-auto {\n  width: 25%;\n}\n.row .col-auto:nth-last-child(5),\n.row .col-auto:nth-last-child(5) ~ .col-auto {\n  width: 20%;\n  width: -webkit-calc((100% - 16px*4) / 5);\n  width: calc((100% - 16px*4) / 5);\n}\n.row.no-gutter .col-auto:nth-last-child(5),\n.row.no-gutter .col-auto:nth-last-child(5) ~ .col-auto {\n  width: 20%;\n}\n.row .col-auto:nth-last-child(6),\n.row .col-auto:nth-last-child(6) ~ .col-auto {\n  width: 16.66666667%;\n  width: -webkit-calc((100% - 16px*5) / 6);\n  width: calc((100% - 16px*5) / 6);\n}\n.row.no-gutter .col-auto:nth-last-child(6),\n.row.no-gutter .col-auto:nth-last-child(6) ~ .col-auto {\n  width: 16.66666667%;\n}\n.row .col-auto:nth-last-child(7),\n.row .col-auto:nth-last-child(7) ~ .col-auto {\n  width: 14.28571429%;\n  width: -webkit-calc((100% - 16px*6) / 7);\n  width: calc((100% - 16px*6) / 7);\n}\n.row.no-gutter .col-auto:nth-last-child(7),\n.row.no-gutter .col-auto:nth-last-child(7) ~ .col-auto {\n  width: 14.28571429%;\n}\n.row .col-auto:nth-last-child(8),\n.row .col-auto:nth-last-child(8) ~ .col-auto {\n  width: 12.5%;\n  width: -webkit-calc((100% - 16px*7) / 8);\n  width: calc((100% - 16px*7) / 8);\n}\n.row.no-gutter .col-auto:nth-last-child(8),\n.row.no-gutter .col-auto:nth-last-child(8) ~ .col-auto {\n  width: 12.5%;\n}\n.row .col-auto:nth-last-child(9),\n.row .col-auto:nth-last-child(9) ~ .col-auto {\n  width: 11.11111111%;\n  width: -webkit-calc((100% - 16px*8) / 9);\n  width: calc((100% - 16px*8) / 9);\n}\n.row.no-gutter .col-auto:nth-last-child(9),\n.row.no-gutter .col-auto:nth-last-child(9) ~ .col-auto {\n  width: 11.11111111%;\n}\n.row .col-auto:nth-last-child(10),\n.row .col-auto:nth-last-child(10) ~ .col-auto {\n  width: 10%;\n  width: -webkit-calc((100% - 16px*9) / 10);\n  width: calc((100% - 16px*9) / 10);\n}\n.row.no-gutter .col-auto:nth-last-child(10),\n.row.no-gutter .col-auto:nth-last-child(10) ~ .col-auto {\n  width: 10%;\n}\n.row .col-auto:nth-last-child(11),\n.row .col-auto:nth-last-child(11) ~ .col-auto {\n  width: 9.09090909%;\n  width: -webkit-calc((100% - 16px*10) / 11);\n  width: calc((100% - 16px*10) / 11);\n}\n.row.no-gutter .col-auto:nth-last-child(11),\n.row.no-gutter .col-auto:nth-last-child(11) ~ .col-auto {\n  width: 9.09090909%;\n}\n.row .col-auto:nth-last-child(12),\n.row .col-auto:nth-last-child(12) ~ .col-auto {\n  width: 8.33333333%;\n  width: -webkit-calc((100% - 16px*11) / 12);\n  width: calc((100% - 16px*11) / 12);\n}\n.row.no-gutter .col-auto:nth-last-child(12),\n.row.no-gutter .col-auto:nth-last-child(12) ~ .col-auto {\n  width: 8.33333333%;\n}\n.row .col-auto:nth-last-child(13),\n.row .col-auto:nth-last-child(13) ~ .col-auto {\n  width: 7.69230769%;\n  width: -webkit-calc((100% - 16px*12) / 13);\n  width: calc((100% - 16px*12) / 13);\n}\n.row.no-gutter .col-auto:nth-last-child(13),\n.row.no-gutter .col-auto:nth-last-child(13) ~ .col-auto {\n  width: 7.69230769%;\n}\n.row .col-auto:nth-last-child(14),\n.row .col-auto:nth-last-child(14) ~ .col-auto {\n  width: 7.14285714%;\n  width: -webkit-calc((100% - 16px*13) / 14);\n  width: calc((100% - 16px*13) / 14);\n}\n.row.no-gutter .col-auto:nth-last-child(14),\n.row.no-gutter .col-auto:nth-last-child(14) ~ .col-auto {\n  width: 7.14285714%;\n}\n.row .col-auto:nth-last-child(15),\n.row .col-auto:nth-last-child(15) ~ .col-auto {\n  width: 6.66666667%;\n  width: -webkit-calc((100% - 16px*14) / 15);\n  width: calc((100% - 16px*14) / 15);\n}\n.row.no-gutter .col-auto:nth-last-child(15),\n.row.no-gutter .col-auto:nth-last-child(15) ~ .col-auto {\n  width: 6.66666667%;\n}\n.row .col-auto:nth-last-child(16),\n.row .col-auto:nth-last-child(16) ~ .col-auto {\n  width: 6.25%;\n  width: -webkit-calc((100% - 16px*15) / 16);\n  width: calc((100% - 16px*15) / 16);\n}\n.row.no-gutter .col-auto:nth-last-child(16),\n.row.no-gutter .col-auto:nth-last-child(16) ~ .col-auto {\n  width: 6.25%;\n}\n.row .col-auto:nth-last-child(17),\n.row .col-auto:nth-last-child(17) ~ .col-auto {\n  width: 5.88235294%;\n  width: -webkit-calc((100% - 16px*16) / 17);\n  width: calc((100% - 16px*16) / 17);\n}\n.row.no-gutter .col-auto:nth-last-child(17),\n.row.no-gutter .col-auto:nth-last-child(17) ~ .col-auto {\n  width: 5.88235294%;\n}\n.row .col-auto:nth-last-child(18),\n.row .col-auto:nth-last-child(18) ~ .col-auto {\n  width: 5.55555556%;\n  width: -webkit-calc((100% - 16px*17) / 18);\n  width: calc((100% - 16px*17) / 18);\n}\n.row.no-gutter .col-auto:nth-last-child(18),\n.row.no-gutter .col-auto:nth-last-child(18) ~ .col-auto {\n  width: 5.55555556%;\n}\n.row .col-auto:nth-last-child(19),\n.row .col-auto:nth-last-child(19) ~ .col-auto {\n  width: 5.26315789%;\n  width: -webkit-calc((100% - 16px*18) / 19);\n  width: calc((100% - 16px*18) / 19);\n}\n.row.no-gutter .col-auto:nth-last-child(19),\n.row.no-gutter .col-auto:nth-last-child(19) ~ .col-auto {\n  width: 5.26315789%;\n}\n.row .col-auto:nth-last-child(20),\n.row .col-auto:nth-last-child(20) ~ .col-auto {\n  width: 5%;\n  width: -webkit-calc((100% - 16px*19) / 20);\n  width: calc((100% - 16px*19) / 20);\n}\n.row.no-gutter .col-auto:nth-last-child(20),\n.row.no-gutter .col-auto:nth-last-child(20) ~ .col-auto {\n  width: 5%;\n}\n.row .col-auto:nth-last-child(21),\n.row .col-auto:nth-last-child(21) ~ .col-auto {\n  width: 4.76190476%;\n  width: -webkit-calc((100% - 16px*20) / 21);\n  width: calc((100% - 16px*20) / 21);\n}\n.row.no-gutter .col-auto:nth-last-child(21),\n.row.no-gutter .col-auto:nth-last-child(21) ~ .col-auto {\n  width: 4.76190476%;\n}\n@media all and (min-width: 768px) {\n  .row .tablet-100 {\n    width: 100%;\n    width: -webkit-calc((100% - 16px*0) / 1);\n    width: calc((100% - 16px*0) / 1);\n  }\n  .row.no-gutter .tablet-100 {\n    width: 100%;\n  }\n  .row .tablet-95 {\n    width: 95%;\n    width: -webkit-calc((100% - 16px*0.05263157894736836) / 1.0526315789473684);\n    width: calc((100% - 16px*0.05263157894736836) / 1.0526315789473684);\n  }\n  .row.no-gutter .tablet-95 {\n    width: 95%;\n  }\n  .row .tablet-90 {\n    width: 90%;\n    width: -webkit-calc((100% - 16px*0.11111111111111116) / 1.1111111111111112);\n    width: calc((100% - 16px*0.11111111111111116) / 1.1111111111111112);\n  }\n  .row.no-gutter .tablet-90 {\n    width: 90%;\n  }\n  .row .tablet-85 {\n    width: 85%;\n    width: -webkit-calc((100% - 16px*0.17647058823529416) / 1.1764705882352942);\n    width: calc((100% - 16px*0.17647058823529416) / 1.1764705882352942);\n  }\n  .row.no-gutter .tablet-85 {\n    width: 85%;\n  }\n  .row .tablet-80 {\n    width: 80%;\n    width: -webkit-calc((100% - 16px*0.25) / 1.25);\n    width: calc((100% - 16px*0.25) / 1.25);\n  }\n  .row.no-gutter .tablet-80 {\n    width: 80%;\n  }\n  .row .tablet-75 {\n    width: 75%;\n    width: -webkit-calc((100% - 16px*0.33333333333333326) / 1.3333333333333333);\n    width: calc((100% - 16px*0.33333333333333326) / 1.3333333333333333);\n  }\n  .row.no-gutter .tablet-75 {\n    width: 75%;\n  }\n  .row .tablet-70 {\n    width: 70%;\n    width: -webkit-calc((100% - 16px*0.4285714285714286) / 1.4285714285714286);\n    width: calc((100% - 16px*0.4285714285714286) / 1.4285714285714286);\n  }\n  .row.no-gutter .tablet-70 {\n    width: 70%;\n  }\n  .row .tablet-66 {\n    width: 66.66666666666666%;\n    width: -webkit-calc((100% - 16px*0.5000000000000002) / 1.5000000000000002);\n    width: calc((100% - 16px*0.5000000000000002) / 1.5000000000000002);\n  }\n  .row.no-gutter .tablet-66 {\n    width: 66.66666666666666%;\n  }\n  .row .tablet-65 {\n    width: 65%;\n    width: -webkit-calc((100% - 16px*0.5384615384615385) / 1.5384615384615385);\n    width: calc((100% - 16px*0.5384615384615385) / 1.5384615384615385);\n  }\n  .row.no-gutter .tablet-65 {\n    width: 65%;\n  }\n  .row .tablet-60 {\n    width: 60%;\n    width: -webkit-calc((100% - 16px*0.6666666666666667) / 1.6666666666666667);\n    width: calc((100% - 16px*0.6666666666666667) / 1.6666666666666667);\n  }\n  .row.no-gutter .tablet-60 {\n    width: 60%;\n  }\n  .row .tablet-55 {\n    width: 55%;\n    width: -webkit-calc((100% - 16px*0.8181818181818181) / 1.8181818181818181);\n    width: calc((100% - 16px*0.8181818181818181) / 1.8181818181818181);\n  }\n  .row.no-gutter .tablet-55 {\n    width: 55%;\n  }\n  .row .tablet-50 {\n    width: 50%;\n    width: -webkit-calc((100% - 16px*1) / 2);\n    width: calc((100% - 16px*1) / 2);\n  }\n  .row.no-gutter .tablet-50 {\n    width: 50%;\n  }\n  .row .tablet-45 {\n    width: 45%;\n    width: -webkit-calc((100% - 16px*1.2222222222222223) / 2.2222222222222223);\n    width: calc((100% - 16px*1.2222222222222223) / 2.2222222222222223);\n  }\n  .row.no-gutter .tablet-45 {\n    width: 45%;\n  }\n  .row .tablet-40 {\n    width: 40%;\n    width: -webkit-calc((100% - 16px*1.5) / 2.5);\n    width: calc((100% - 16px*1.5) / 2.5);\n  }\n  .row.no-gutter .tablet-40 {\n    width: 40%;\n  }\n  .row .tablet-35 {\n    width: 35%;\n    width: -webkit-calc((100% - 16px*1.8571428571428572) / 2.857142857142857);\n    width: calc((100% - 16px*1.8571428571428572) / 2.857142857142857);\n  }\n  .row.no-gutter .tablet-35 {\n    width: 35%;\n  }\n  .row .tablet-33 {\n    width: 33.333333333333336%;\n    width: -webkit-calc((100% - 16px*2) / 3);\n    width: calc((100% - 16px*2) / 3);\n  }\n  .row.no-gutter .tablet-33 {\n    width: 33.333333333333336%;\n  }\n  .row .tablet-30 {\n    width: 30%;\n    width: -webkit-calc((100% - 16px*2.3333333333333335) / 3.3333333333333335);\n    width: calc((100% - 16px*2.3333333333333335) / 3.3333333333333335);\n  }\n  .row.no-gutter .tablet-30 {\n    width: 30%;\n  }\n  .row .tablet-25 {\n    width: 25%;\n    width: -webkit-calc((100% - 16px*3) / 4);\n    width: calc((100% - 16px*3) / 4);\n  }\n  .row.no-gutter .tablet-25 {\n    width: 25%;\n  }\n  .row .tablet-20 {\n    width: 20%;\n    width: -webkit-calc((100% - 16px*4) / 5);\n    width: calc((100% - 16px*4) / 5);\n  }\n  .row.no-gutter .tablet-20 {\n    width: 20%;\n  }\n  .row .tablet-15 {\n    width: 15%;\n    width: -webkit-calc((100% - 16px*5.666666666666667) / 6.666666666666667);\n    width: calc((100% - 16px*5.666666666666667) / 6.666666666666667);\n  }\n  .row.no-gutter .tablet-15 {\n    width: 15%;\n  }\n  .row .tablet-10 {\n    width: 10%;\n    width: -webkit-calc((100% - 16px*9) / 10);\n    width: calc((100% - 16px*9) / 10);\n  }\n  .row.no-gutter .tablet-10 {\n    width: 10%;\n  }\n  .row .tablet-5 {\n    width: 5%;\n    width: -webkit-calc((100% - 16px*19) / 20);\n    width: calc((100% - 16px*19) / 20);\n  }\n  .row.no-gutter .tablet-5 {\n    width: 5%;\n  }\n  .row .tablet-auto:nth-last-child(1),\n  .row .tablet-auto:nth-last-child(1) ~ .col-auto {\n    width: 100%;\n    width: -webkit-calc((100% - 16px*0) / 1);\n    width: calc((100% - 16px*0) / 1);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(1),\n  .row.no-gutter .tablet-auto:nth-last-child(1) ~ .tablet-auto {\n    width: 100%;\n  }\n  .row .tablet-auto:nth-last-child(2),\n  .row .tablet-auto:nth-last-child(2) ~ .col-auto {\n    width: 50%;\n    width: -webkit-calc((100% - 16px*1) / 2);\n    width: calc((100% - 16px*1) / 2);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(2),\n  .row.no-gutter .tablet-auto:nth-last-child(2) ~ .tablet-auto {\n    width: 50%;\n  }\n  .row .tablet-auto:nth-last-child(3),\n  .row .tablet-auto:nth-last-child(3) ~ .col-auto {\n    width: 33.33333333%;\n    width: -webkit-calc((100% - 16px*2) / 3);\n    width: calc((100% - 16px*2) / 3);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(3),\n  .row.no-gutter .tablet-auto:nth-last-child(3) ~ .tablet-auto {\n    width: 33.33333333%;\n  }\n  .row .tablet-auto:nth-last-child(4),\n  .row .tablet-auto:nth-last-child(4) ~ .col-auto {\n    width: 25%;\n    width: -webkit-calc((100% - 16px*3) / 4);\n    width: calc((100% - 16px*3) / 4);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(4),\n  .row.no-gutter .tablet-auto:nth-last-child(4) ~ .tablet-auto {\n    width: 25%;\n  }\n  .row .tablet-auto:nth-last-child(5),\n  .row .tablet-auto:nth-last-child(5) ~ .col-auto {\n    width: 20%;\n    width: -webkit-calc((100% - 16px*4) / 5);\n    width: calc((100% - 16px*4) / 5);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(5),\n  .row.no-gutter .tablet-auto:nth-last-child(5) ~ .tablet-auto {\n    width: 20%;\n  }\n  .row .tablet-auto:nth-last-child(6),\n  .row .tablet-auto:nth-last-child(6) ~ .col-auto {\n    width: 16.66666667%;\n    width: -webkit-calc((100% - 16px*5) / 6);\n    width: calc((100% - 16px*5) / 6);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(6),\n  .row.no-gutter .tablet-auto:nth-last-child(6) ~ .tablet-auto {\n    width: 16.66666667%;\n  }\n  .row .tablet-auto:nth-last-child(7),\n  .row .tablet-auto:nth-last-child(7) ~ .col-auto {\n    width: 14.28571429%;\n    width: -webkit-calc((100% - 16px*6) / 7);\n    width: calc((100% - 16px*6) / 7);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(7),\n  .row.no-gutter .tablet-auto:nth-last-child(7) ~ .tablet-auto {\n    width: 14.28571429%;\n  }\n  .row .tablet-auto:nth-last-child(8),\n  .row .tablet-auto:nth-last-child(8) ~ .col-auto {\n    width: 12.5%;\n    width: -webkit-calc((100% - 16px*7) / 8);\n    width: calc((100% - 16px*7) / 8);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(8),\n  .row.no-gutter .tablet-auto:nth-last-child(8) ~ .tablet-auto {\n    width: 12.5%;\n  }\n  .row .tablet-auto:nth-last-child(9),\n  .row .tablet-auto:nth-last-child(9) ~ .col-auto {\n    width: 11.11111111%;\n    width: -webkit-calc((100% - 16px*8) / 9);\n    width: calc((100% - 16px*8) / 9);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(9),\n  .row.no-gutter .tablet-auto:nth-last-child(9) ~ .tablet-auto {\n    width: 11.11111111%;\n  }\n  .row .tablet-auto:nth-last-child(10),\n  .row .tablet-auto:nth-last-child(10) ~ .col-auto {\n    width: 10%;\n    width: -webkit-calc((100% - 16px*9) / 10);\n    width: calc((100% - 16px*9) / 10);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(10),\n  .row.no-gutter .tablet-auto:nth-last-child(10) ~ .tablet-auto {\n    width: 10%;\n  }\n  .row .tablet-auto:nth-last-child(11),\n  .row .tablet-auto:nth-last-child(11) ~ .col-auto {\n    width: 9.09090909%;\n    width: -webkit-calc((100% - 16px*10) / 11);\n    width: calc((100% - 16px*10) / 11);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(11),\n  .row.no-gutter .tablet-auto:nth-last-child(11) ~ .tablet-auto {\n    width: 9.09090909%;\n  }\n  .row .tablet-auto:nth-last-child(12),\n  .row .tablet-auto:nth-last-child(12) ~ .col-auto {\n    width: 8.33333333%;\n    width: -webkit-calc((100% - 16px*11) / 12);\n    width: calc((100% - 16px*11) / 12);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(12),\n  .row.no-gutter .tablet-auto:nth-last-child(12) ~ .tablet-auto {\n    width: 8.33333333%;\n  }\n  .row .tablet-auto:nth-last-child(13),\n  .row .tablet-auto:nth-last-child(13) ~ .col-auto {\n    width: 7.69230769%;\n    width: -webkit-calc((100% - 16px*12) / 13);\n    width: calc((100% - 16px*12) / 13);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(13),\n  .row.no-gutter .tablet-auto:nth-last-child(13) ~ .tablet-auto {\n    width: 7.69230769%;\n  }\n  .row .tablet-auto:nth-last-child(14),\n  .row .tablet-auto:nth-last-child(14) ~ .col-auto {\n    width: 7.14285714%;\n    width: -webkit-calc((100% - 16px*13) / 14);\n    width: calc((100% - 16px*13) / 14);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(14),\n  .row.no-gutter .tablet-auto:nth-last-child(14) ~ .tablet-auto {\n    width: 7.14285714%;\n  }\n  .row .tablet-auto:nth-last-child(15),\n  .row .tablet-auto:nth-last-child(15) ~ .col-auto {\n    width: 6.66666667%;\n    width: -webkit-calc((100% - 16px*14) / 15);\n    width: calc((100% - 16px*14) / 15);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(15),\n  .row.no-gutter .tablet-auto:nth-last-child(15) ~ .tablet-auto {\n    width: 6.66666667%;\n  }\n  .row .tablet-auto:nth-last-child(16),\n  .row .tablet-auto:nth-last-child(16) ~ .col-auto {\n    width: 6.25%;\n    width: -webkit-calc((100% - 16px*15) / 16);\n    width: calc((100% - 16px*15) / 16);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(16),\n  .row.no-gutter .tablet-auto:nth-last-child(16) ~ .tablet-auto {\n    width: 6.25%;\n  }\n  .row .tablet-auto:nth-last-child(17),\n  .row .tablet-auto:nth-last-child(17) ~ .col-auto {\n    width: 5.88235294%;\n    width: -webkit-calc((100% - 16px*16) / 17);\n    width: calc((100% - 16px*16) / 17);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(17),\n  .row.no-gutter .tablet-auto:nth-last-child(17) ~ .tablet-auto {\n    width: 5.88235294%;\n  }\n  .row .tablet-auto:nth-last-child(18),\n  .row .tablet-auto:nth-last-child(18) ~ .col-auto {\n    width: 5.55555556%;\n    width: -webkit-calc((100% - 16px*17) / 18);\n    width: calc((100% - 16px*17) / 18);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(18),\n  .row.no-gutter .tablet-auto:nth-last-child(18) ~ .tablet-auto {\n    width: 5.55555556%;\n  }\n  .row .tablet-auto:nth-last-child(19),\n  .row .tablet-auto:nth-last-child(19) ~ .col-auto {\n    width: 5.26315789%;\n    width: -webkit-calc((100% - 16px*18) / 19);\n    width: calc((100% - 16px*18) / 19);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(19),\n  .row.no-gutter .tablet-auto:nth-last-child(19) ~ .tablet-auto {\n    width: 5.26315789%;\n  }\n  .row .tablet-auto:nth-last-child(20),\n  .row .tablet-auto:nth-last-child(20) ~ .col-auto {\n    width: 5%;\n    width: -webkit-calc((100% - 16px*19) / 20);\n    width: calc((100% - 16px*19) / 20);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(20),\n  .row.no-gutter .tablet-auto:nth-last-child(20) ~ .tablet-auto {\n    width: 5%;\n  }\n  .row .tablet-auto:nth-last-child(21),\n  .row .tablet-auto:nth-last-child(21) ~ .col-auto {\n    width: 4.76190476%;\n    width: -webkit-calc((100% - 16px*20) / 21);\n    width: calc((100% - 16px*20) / 21);\n  }\n  .row.no-gutter .tablet-auto:nth-last-child(21),\n  .row.no-gutter .tablet-auto:nth-last-child(21) ~ .tablet-auto {\n    width: 4.76190476%;\n  }\n}\n/* === Views === */\n.views,\n.view {\n  position: relative;\n  height: 100%;\n  z-index: 5000;\n}\n.views {\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n}\n.view {\n  width: 100%;\n  overflow: hidden;\n  box-sizing: border-box;\n}\n/* === Pages === */\n.pages {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n}\n.page {\n  box-sizing: border-box;\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background: #fff;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.page.cached {\n  display: none;\n}\n.page-on-left {\n  opacity: 1;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.page-on-right {\n  opacity: 0;\n  pointer-events: none;\n  -webkit-transform: translate3d(0, 56px, 0);\n  transform: translate3d(0, 56px, 0);\n}\n.page-content {\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n  box-sizing: border-box;\n  height: 100%;\n  position: relative;\n  z-index: 1;\n}\n.page-transitioning {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.page-from-right-to-center {\n  pointer-events: none;\n  -webkit-animation: pageFromRightToCenter 300ms forwards;\n  animation: pageFromRightToCenter 300ms forwards;\n}\n.page-from-center-to-right {\n  pointer-events: none;\n  -webkit-animation: pageFromCenterToRight 300ms forwards;\n  animation: pageFromCenterToRight 300ms forwards;\n}\n@-webkit-keyframes pageFromRightToCenter {\n  from {\n    opacity: 0;\n    -webkit-transform: translate3d(0, 56px, 0);\n  }\n  to {\n    opacity: 1;\n    -webkit-transform: translate3d(0, 0, 0);\n  }\n}\n@keyframes pageFromRightToCenter {\n  from {\n    opacity: 0;\n    transform: translate3d(0, 56px, 0);\n  }\n  to {\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n  }\n}\n@-webkit-keyframes pageFromCenterToRight {\n  from {\n    opacity: 1;\n    -webkit-transform: translate3d(0, 0, 0);\n  }\n  to {\n    opacity: 0;\n    -webkit-transform: translate3d(0, 56px, 0);\n  }\n}\n@keyframes pageFromCenterToRight {\n  from {\n    opacity: 1;\n    transform: translate3d(0, 0, 0);\n  }\n  to {\n    opacity: 0;\n    transform: translate3d(0, 56px, 0);\n  }\n}\n.page-from-center-to-left {\n  -webkit-animation: pageFromCenterToLeft 300ms forwards;\n  animation: pageFromCenterToLeft 300ms forwards;\n}\n.page-from-left-to-center {\n  -webkit-animation: pageFromLeftToCenter 300ms forwards;\n  animation: pageFromLeftToCenter 300ms forwards;\n}\n@-webkit-keyframes pageFromCenterToLeft {\n  from {\n    opacity: 1;\n  }\n  to {\n    opacity: 1;\n  }\n}\n@keyframes pageFromCenterToLeft {\n  from {\n    opacity: 1;\n  }\n  to {\n    opacity: 1;\n  }\n}\n@-webkit-keyframes pageFromLeftToCenter {\n  from {\n    opacity: 1;\n  }\n  to {\n    opacity: 1;\n  }\n}\n@keyframes pageFromLeftToCenter {\n  from {\n    opacity: 1;\n  }\n  to {\n    opacity: 1;\n  }\n}\n/* === Toolbars === */\n.navbar-inner,\n.toolbar-inner {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  box-sizing: border-box;\n  overflow: hidden;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.navbar-inner {\n  -webkit-box-pack: start;\n  -ms-flex-pack: start;\n  -webkit-justify-content: flex-start;\n  justify-content: flex-start;\n}\n.toolbar-inner {\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n}\n.navbar-inner.cached {\n  display: none;\n}\n.navbar,\n.toolbar {\n  width: 100%;\n  box-sizing: border-box;\n  position: relative;\n  margin: 0;\n  z-index: 500;\n  -webkit-backface-visibility: hidden;\n  backface-visibility: hidden;\n  color: #fff;\n}\n.navbar b,\n.toolbar b {\n  font-weight: 500;\n}\n.navbar ~ .toolbar {\n  z-index: 499;\n}\n.navbar,\n.toolbar,\n.subnavbar {\n  background: #2196f3;\n}\n.navbar a.link,\n.toolbar a.link,\n.subnavbar a.link {\n  text-decoration: none;\n  position: relative;\n  color: #fff;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  padding: 0 16px;\n  min-width: 48px;\n}\n.navbar a.link:before,\n.toolbar a.link:before,\n.subnavbar a.link:before {\n  content: '';\n  width: 152%;\n  height: 152%;\n  position: absolute;\n  left: -26%;\n  top: -26%;\n  background-image: -webkit-radial-gradient(center, circle cover, rgba(255, 255, 255, 0.15) 66%, rgba(255, 255, 255, 0) 66%);\n  background-image: radial-gradient(circle at center, rgba(255, 255, 255, 0.15) 66%, rgba(255, 255, 255, 0) 66%);\n  background-repeat: no-repeat;\n  background-position: center;\n  background-size: 100% 100%;\n  opacity: 0;\n  pointer-events: none;\n  -webkit-transition-duration: 600ms;\n  transition-duration: 600ms;\n}\nhtml:not(.watch-active-state) .navbar a.link:active:before,\nhtml:not(.watch-active-state) .toolbar a.link:active:before,\nhtml:not(.watch-active-state) .subnavbar a.link:active:before,\n.navbar a.link.active-state:before,\n.toolbar a.link.active-state:before,\n.subnavbar a.link.active-state:before {\n  opacity: 1;\n  -webkit-transition-duration: 150ms;\n  transition-duration: 150ms;\n}\n.navbar a.link i + span,\n.toolbar a.link i + span,\n.subnavbar a.link i + span,\n.navbar a.link i + i,\n.toolbar a.link i + i,\n.subnavbar a.link i + i,\n.navbar a.link span + i,\n.toolbar a.link span + i,\n.subnavbar a.link span + i,\n.navbar a.link span + span,\n.toolbar a.link span + span,\n.subnavbar a.link span + span {\n  margin-left: 8px;\n}\n.navbar a.icon-only,\n.toolbar a.icon-only,\n.subnavbar a.icon-only {\n  min-width: 0;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.navbar i.icon,\n.toolbar i.icon,\n.subnavbar i.icon {\n  display: block;\n}\n.navbar .center,\n.subnavbar .center {\n  font-size: 20px;\n  font-weight: 500;\n  text-align: center;\n  margin: 0 16px;\n  position: relative;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  line-height: 56px;\n  display: inline-block;\n  text-align: left;\n}\n.navbar .left,\n.subnavbar .left,\n.navbar .right,\n.subnavbar .right {\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: start;\n  -ms-flex-pack: start;\n  -webkit-justify-content: flex-start;\n  justify-content: flex-start;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.navbar .right,\n.subnavbar .right {\n  margin-left: auto;\n}\n.navbar .right:first-child,\n.subnavbar .right:first-child {\n  position: absolute;\n  right: 16px;\n  height: 100%;\n}\n.navbar {\n  left: 0;\n  top: 0;\n  height: 56px;\n  font-size: 20px;\n}\n.navbar a.link {\n  line-height: 56px;\n  height: 56px;\n}\n.popup .navbar {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.subnavbar {\n  height: 48px;\n  width: 100%;\n  position: absolute;\n  left: 0;\n  top: 100%;\n  z-index: 20;\n  box-sizing: border-box;\n  padding: 0 16px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  overflow: hidden;\n}\n.subnavbar a.link {\n  line-height: 48px;\n  height: 48px;\n}\n.subnavbar .center {\n  line-height: 48px;\n}\n.subnavbar .center:first-child {\n  margin-left: 56px;\n}\n.navbar.no-border .subnavbar {\n  margin-top: 0;\n}\n.navbar-on-left .subnavbar,\n.navbar-on-right .subnavbar {\n  pointer-events: none;\n}\n.navbar .subnavbar,\n.page .subnavbar {\n  position: absolute;\n}\n.page > .subnavbar {\n  top: 0;\n  margin-top: 0;\n}\n.subnavbar > .buttons-row {\n  width: 100%;\n}\n.subnavbar .searchbar,\n.subnavbar.searchbar {\n  position: absolute;\n}\n.subnavbar.searchbar,\n.subnavbar .searchbar {\n  position: absolute;\n}\n.subnavbar .searchbar {\n  left: 0;\n  top: 0;\n}\n.toolbar {\n  left: 0;\n  bottom: 0;\n  height: 48px;\n  font-size: 14px;\n}\n.toolbar a.link {\n  line-height: 48px;\n  height: 48px;\n}\n.toolbar a {\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  position: relative;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n}\n.tabbar {\n  z-index: 5001;\n  overflow: hidden;\n  bottom: auto;\n  top: 0;\n}\n.tabbar .toolbar-inner {\n  padding-left: 0;\n  padding-right: 0;\n}\n.tabbar a.link {\n  line-height: 1.4;\n}\n.tabbar a.tab-link,\n.tabbar a.link {\n  height: 100%;\n  width: 100%;\n  box-sizing: border-box;\n  padding-left: 0;\n  padding-right: 0;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -ms-flex: 1;\n  -webkit-box-orient: vertical;\n  -moz-box-orient: vertical;\n  -ms-flex-direction: column;\n  -webkit-flex-direction: column;\n  flex-direction: column;\n  font-size: 14px;\n  text-transform: uppercase;\n}\n.tabbar i.icon {\n  height: 24px;\n}\n.tabbar a.tab-link {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  overflow: hidden;\n  color: rgba(255, 255, 255, 0.7);\n  position: relative;\n}\n.tabbar a.tab-link.active,\nhtml:not(.watch-active-state) .tabbar a.tab-link:active,\n.tabbar a.tab-link.active-state {\n  color: #ffffff;\n}\n.tabbar .tab-link-highlight {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  height: 3px;\n  background: #0a6ebd;\n  background: rgba(255, 255, 255, 0.5);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.tabbar-labels {\n  height: 72px;\n}\n.tabbar-labels a.tab-link,\n.tabbar-labels a.link {\n  padding-top: 12px;\n  padding-bottom: 12px;\n  height: 100%;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n}\n.tabbar-labels span.tabbar-label {\n  line-height: 1;\n  display: block;\n  margin: 0;\n  margin-top: 10px;\n  position: relative;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  overflow: hidden;\n  max-width: 100%;\n}\n.tabbar-labels.toolbar-bottom span.tabbar-label {\n  text-transform: none;\n}\n.tabbar-scrollable .toolbar-inner {\n  -webkit-box-pack: start;\n  -ms-flex-pack: start;\n  -webkit-justify-content: flex-start;\n  justify-content: flex-start;\n  overflow: auto;\n}\n.tabbar-scrollable .toolbar-inner::-webkit-scrollbar {\n  display: none !important;\n  width: 0 !important;\n  height: 0 !important;\n  -webkit-appearance: none;\n  opacity: 0 !important;\n}\n.tabbar-scrollable a.tab-link,\n.tabbar-scrollable a.link {\n  width: auto;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  -ms-flex: 0;\n  padding: 0 16px;\n}\n.toolbar-bottom {\n  bottom: 0;\n  top: auto;\n}\n.toolbar-bottom .tab-link-highlight {\n  bottom: auto;\n  top: 0;\n}\n.subnavbar input[type=\"text\"],\n.navbar input[type=\"text\"],\n.subnavbar input[type=\"password\"],\n.navbar input[type=\"password\"],\n.subnavbar input[type=\"search\"],\n.navbar input[type=\"search\"],\n.subnavbar input[type=\"email\"],\n.navbar input[type=\"email\"],\n.subnavbar input[type=\"tel\"],\n.navbar input[type=\"tel\"],\n.subnavbar input[type=\"url\"],\n.navbar input[type=\"url\"] {\n  box-sizing: border-box;\n  width: 100%;\n  height: 32px;\n  display: block;\n  border: none;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border-radius: 0;\n  font-family: inherit;\n  color: #fff;\n  font-size: 16px;\n  font-weight: 400;\n  background-color: transparent;\n  padding: 0;\n  border-bottom: 1px solid #fff;\n}\n.subnavbar input[type=\"text\"]::-webkit-input-placeholder,\n.navbar input[type=\"text\"]::-webkit-input-placeholder,\n.subnavbar input[type=\"password\"]::-webkit-input-placeholder,\n.navbar input[type=\"password\"]::-webkit-input-placeholder,\n.subnavbar input[type=\"search\"]::-webkit-input-placeholder,\n.navbar input[type=\"search\"]::-webkit-input-placeholder,\n.subnavbar input[type=\"email\"]::-webkit-input-placeholder,\n.navbar input[type=\"email\"]::-webkit-input-placeholder,\n.subnavbar input[type=\"tel\"]::-webkit-input-placeholder,\n.navbar input[type=\"tel\"]::-webkit-input-placeholder,\n.subnavbar input[type=\"url\"]::-webkit-input-placeholder,\n.navbar input[type=\"url\"]::-webkit-input-placeholder {\n  color: #ffffff;\n  opacity: 1;\n}\n/* === Relation between toolbar/navbar types and pages === */\n.page > .navbar,\n.view > .navbar,\n.views > .navbar,\n.page > .toolbar,\n.view > .toolbar,\n.views > .toolbar {\n  position: absolute;\n}\n.subnavbar ~ .page-content {\n  padding-top: 48px;\n}\n.toolbar-fixed .page-content,\n.tabbar-fixed .page-content {\n  padding-top: 48px;\n}\n.tabbar-labels-fixed .page-content {\n  padding-top: 72px;\n}\n.toolbar ~ .page-content {\n  padding-top: 48px;\n}\n.tabbar-labels ~ .page-content {\n  padding-top: 72px;\n}\n.toolbar-bottom ~ .page-content,\n.messagebar ~ .page-content,\n.toolbar-bottom ~ .pages .page-content,\n.messagebar ~ .pages .page-content,\n.toolbar-bottom ~ .view .page-content,\n.messagebar ~ .view .page-content {\n  padding-top: 0;\n  padding-bottom: 48px;\n}\n.tabbar-labels.toolbar-bottom ~ .page-content,\n.tabbar-labels.toolbar-bottom ~ .pages .page-content,\n.tabbar-labels.toolbar-bottom ~ .page .page-content,\n.tabbar-labels.toolbar-bottom ~ .view .page-content {\n  padding-bottom: 72px;\n}\n.navbar-fixed .page-content,\n.navbar-through .page-content,\n.navbar-fixed.pages .page-content,\n.navbar-through.pages .page-content,\n.navbar-fixed.view .page-content,\n.navbar-through.view .page-content {\n  padding-top: 56px;\n}\n.navbar-fixed.toolbar-fixed .page-content,\n.navbar-through.toolbar-fixed .page-content,\n.navbar-fixed.tabbar-fixed .page-content,\n.navbar-through.tabbar-fixed .page-content,\n.navbar-fixed .toolbar-fixed .page-content,\n.navbar-through .toolbar-fixed .page-content,\n.navbar-fixed .tabbar-fixed .page-content,\n.navbar-through .tabbar-fixed .page-content,\n.toolbar-fixed .navbar-fixed .page-content,\n.toolbar-fixed .navbar-through .page-content,\n.tabbar-fixed .navbar-fixed .page-content,\n.tabbar-fixed .navbar-through .page-content {\n  padding-top: 104px;\n}\n.navbar-fixed.toolbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through.toolbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed.tabbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through.tabbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed .toolbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through .toolbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed .tabbar-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through .tabbar-fixed .toolbar-bottom ~ .pages .page-content,\n.toolbar-fixed .navbar-fixed .toolbar-bottom ~ .pages .page-content,\n.toolbar-fixed .navbar-through .toolbar-bottom ~ .pages .page-content,\n.tabbar-fixed .navbar-fixed .toolbar-bottom ~ .pages .page-content,\n.tabbar-fixed .navbar-through .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed.toolbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through.toolbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-fixed.tabbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through.tabbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-fixed .toolbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through .toolbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-fixed .tabbar-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through .tabbar-fixed .toolbar-bottom ~ .view .page-content,\n.toolbar-fixed .navbar-fixed .toolbar-bottom ~ .view .page-content,\n.toolbar-fixed .navbar-through .toolbar-bottom ~ .view .page-content,\n.tabbar-fixed .navbar-fixed .toolbar-bottom ~ .view .page-content,\n.tabbar-fixed .navbar-through .toolbar-bottom ~ .view .page-content {\n  padding-top: 56px;\n}\n.navbar-fixed.tabbar-labels-fixed .page-content,\n.navbar-through.tabbar-labels-fixed .page-content,\n.navbar-fixed .tabbar-labels-fixed .page-content,\n.navbar-through .tabbar-labels-fixed .page-content,\n.tabbar-labels-fixed .navbar-fixed .page-content,\n.tabbar-labels-fixed .navbar-through .page-content {\n  padding-top: 128px;\n}\n.navbar-fixed.tabbar-labels-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through.tabbar-labels-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed .tabbar-labels-fixed .toolbar-bottom ~ .pages .page-content,\n.navbar-through .tabbar-labels-fixed .toolbar-bottom ~ .pages .page-content,\n.tabbar-labels-fixed .navbar-fixed .toolbar-bottom ~ .pages .page-content,\n.tabbar-labels-fixed .navbar-through .toolbar-bottom ~ .pages .page-content,\n.navbar-fixed.tabbar-labels-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through.tabbar-labels-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-fixed .tabbar-labels-fixed .toolbar-bottom ~ .view .page-content,\n.navbar-through .tabbar-labels-fixed .toolbar-bottom ~ .view .page-content,\n.tabbar-labels-fixed .navbar-fixed .toolbar-bottom ~ .view .page-content,\n.tabbar-labels-fixed .navbar-through .toolbar-bottom ~ .view .page-content {\n  padding-top: 56px;\n}\n.navbar-fixed .toolbar ~ .page-content,\n.navbar-through .toolbar ~ .page-content {\n  padding-top: 104px;\n}\n.navbar-fixed .messagebar ~ .page-content,\n.navbar-through .messagebar ~ .page-content,\n.navbar-fixed .toolbar-bottom ~ .page-content,\n.navbar-through .toolbar-bottom ~ .page-content {\n  padding-top: 56px;\n}\n.navbar-fixed .tabbar-labels ~ .page-content,\n.navbar-through .tabbar-labels ~ .page-content {\n  padding-top: 128px;\n}\n.navbar-fixed .tabbar-labels.toolbar-bottom ~ .page-content,\n.navbar-through .tabbar-labels.toolbar-bottom ~ .page-content {\n  padding-top: 56px;\n}\n.navbar-fixed .with-subnavbar .page-content,\n.navbar-through .with-subnavbar .page-content,\n.navbar-fixed .page-content.with-subnavbar,\n.navbar-through .page-content.with-subnavbar,\n.navbar-fixed .subnavbar ~ .page-content,\n.navbar-through .subnavbar ~ .page-content {\n  padding-top: 104px;\n}\n.navbar-fixed .page .subnavbar,\n.navbar-through .page .subnavbar,\n.navbar-fixed.page .subnavbar,\n.navbar-through.page .subnavbar {\n  top: 56px;\n}\n.navbar-fixed .toolbar,\n.navbar-through .toolbar {\n  top: 56px;\n}\n.navbar-fixed .messagebar,\n.navbar-through .messagebar,\n.navbar-fixed .toolbar-bottom,\n.navbar-through .toolbar-bottom {\n  top: auto;\n}\n.navbar.navbar-hiding {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.navbar.navbar-hiding ~ .page-content .list-group-title,\n.navbar.navbar-hiding ~ .pages .list-group-title,\n.navbar.navbar-hiding ~ .page .list-group-title {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.navbar.navbar-hiding ~ .page-content .subnavbar,\n.navbar.navbar-hiding ~ .pages .subnavbar,\n.navbar.navbar-hiding ~ .page .subnavbar {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.navbar.navbar-hiding ~ .subnavbar,\n.navbar.navbar-hiding ~ .toolbar {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.navbar.navbar-hidden {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  -webkit-transform: translate3d(0, -100%, 0);\n  transform: translate3d(0, -100%, 0);\n}\n.navbar.navbar-hidden ~ .page-content .list-group-title,\n.navbar.navbar-hidden ~ .pages .list-group-title,\n.navbar.navbar-hidden ~ .page .list-group-title {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  top: -56px;\n}\n.navbar.navbar-hidden ~ .page-content .subnavbar,\n.navbar.navbar-hidden ~ .pages .subnavbar,\n.navbar.navbar-hidden ~ .page .subnavbar {\n  -webkit-transform: translate3d(0, -56px, 0);\n  transform: translate3d(0, -56px, 0);\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.navbar.navbar-hidden ~ .subnavbar,\n.navbar.navbar-hidden ~ .toolbar:not(.messagebar):not(.toolbar-bottom) {\n  -webkit-transform: translate3d(0, -56px, 0);\n  transform: translate3d(0, -56px, 0);\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.navbar.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.page.no-navbar .page-content {\n  padding-top: 0;\n}\n.page.no-navbar.with-subnavbar .page-content,\n.with-subnavbar .page.no-navbar .page-content,\n.page.no-navbar .page-content.with-subnavbar {\n  padding-top: 48px;\n}\n.toolbar.toolbar-hiding,\n.tabbar.toolbar-hiding,\n.toolbar.tabbar-hiding,\n.tabbar.tabbar-hiding {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.toolbar.toolbar-hidden,\n.tabbar.toolbar-hidden,\n.toolbar.tabbar-hidden,\n.tabbar.tabbar-hidden {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.toolbar.not-animated,\n.tabbar.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.toolbar.toolbar-hidden,\n.tabbar.toolbar-hidden,\n.toolbar.tabbar-hidden,\n.tabbar.tabbar-hidden {\n  -webkit-transform: translate3d(0, -100%, 0);\n  transform: translate3d(0, -100%, 0);\n}\n.navbar ~ .toolbar.toolbar-hidden:not(.messagebar):not(.toolbar-bottom),\n.navbar ~ .tabbar.toolbar-hidden:not(.messagebar):not(.toolbar-bottom),\n.navbar ~ .toolbar.tabbar-hidden,\n.navbar ~ .tabbar.tabbar-hidden {\n  -webkit-transform: translate3d(0, -104px, 0);\n  transform: translate3d(0, -104px, 0);\n}\n.navbar ~ .toolbar.tabbar-labels.toolbar-hidden,\n.navbar ~ .tabbar.tabbar-labels.toolbar-hidden {\n  -webkit-transform: translate3d(0, -128px, 0);\n  transform: translate3d(0, -128px, 0);\n}\n.toolbar.toolbar-hidden.messagebar,\n.tabbar.toolbar-hidden.messagebar,\n.toolbar.toolbar-hidden.toolbar-bottom,\n.tabbar.toolbar-hidden.toolbar-bottom {\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.page.no-toolbar .page-content,\n.page.no-tabbar .page-content {\n  padding-bottom: 0;\n}\n.navbar.no-shadow,\n.toolbar.no-shadow {\n  box-shadow: none !important;\n}\n.navbar-fixed .subnavbar,\n.navbar-through .subnavbar {\n  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.2), 0px 4px 4px 0px rgba(0, 0, 0, 0.14), 0px 1px 1px 0px rgba(0, 0, 0, 0.12);\n}\n.navbar-fixed .navbar,\n.navbar-through .navbar {\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0.2), 0px 4px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 10px 0px rgba(0, 0, 0, 0.12);\n}\n.navbar-fixed .navbar.navbar-hidden,\n.navbar-through .navbar.navbar-hidden {\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0), 0px 4px 5px 0px rgba(0, 0, 0, 0), 0px 1px 10px 0px rgba(0, 0, 0, 0) !important;\n}\n.toolbar-fixed .toolbar,\n.tabbar-fixed .toolbar,\n.tabbar-labels-fixed .toolbar {\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0.2), 0px 4px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 10px 0px rgba(0, 0, 0, 0.12);\n}\n.toolbar-fixed .toolbar.toolbar-hidden,\n.tabbar-fixed .toolbar.toolbar-hidden,\n.tabbar-labels-fixed .toolbar.toolbar-hidden {\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0), 0px 4px 5px 0px rgba(0, 0, 0, 0), 0px 1px 10px 0px rgba(0, 0, 0, 0) !important;\n}\n.toolbar-fixed .toolbar-bottom,\n.tabbar-fixed .toolbar-bottom,\n.tabbar-labels-fixed .toolbar-bottom,\n.toolbar-bottom {\n  box-shadow: 0px -2px 4px -1px rgba(0, 0, 0, 0.2), 0px -4px 5px 0px rgba(0, 0, 0, 0.14), 0px -1px 10px 0px rgba(0, 0, 0, 0.12);\n}\n.toolbar-bottom.toolbar-hidden {\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0), 0px 4px 5px 0px rgba(0, 0, 0, 0), 0px 1px 10px 0px rgba(0, 0, 0, 0) !important;\n}\n.navbar-fixed.toolbar-fixed .navbar,\n.navbar-through.toolbar-fixed .navbar,\n.navbar-fixed .toolbar-fixed .navbar,\n.navbar-through .toolbar-fixed .navbar,\n.navbar-fixed.tabbar-fixed .navbar,\n.navbar-through.tabbar-fixed .navbar,\n.navbar-fixed .tabbar-fixed .navbar,\n.navbar-through .tabbar-fixed .navbar,\n.navbar-fixed.tabbar-labels-fixed .navbar,\n.navbar-through.tabbar-labels-fixed .navbar,\n.navbar-fixed .tabbar-labels-fixed .navbar,\n.navbar-through .tabbar-labels-fixed .navbar {\n  box-shadow: none;\n}\n/* === Search Bar === */\n.searchbar {\n  height: 48px;\n  width: 100%;\n  background: #2196f3;\n  box-sizing: border-box;\n  padding: 0 16px;\n  overflow: hidden;\n  position: relative;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  color: #fff;\n}\n.searchbar.no-shadow {\n  box-shadow: none;\n}\n.searchbar a {\n  position: relative;\n  color: #fff;\n}\n.searchbar a:before {\n  content: '';\n  width: 152%;\n  height: 152%;\n  position: absolute;\n  left: -26%;\n  top: -26%;\n  background-image: -webkit-radial-gradient(center, circle cover, rgba(255, 255, 255, 0.15) 66%, rgba(255, 255, 255, 0) 66%);\n  background-image: radial-gradient(circle at center, rgba(255, 255, 255, 0.15) 66%, rgba(255, 255, 255, 0) 66%);\n  background-repeat: no-repeat;\n  background-position: center;\n  background-size: 100% 100%;\n  opacity: 0;\n  pointer-events: none;\n  -webkit-transition-duration: 600ms;\n  transition-duration: 600ms;\n}\nhtml:not(.watch-active-state) .searchbar a:active:before,\n.searchbar a.active-state:before {\n  opacity: 1;\n  -webkit-transition-duration: 150ms;\n  transition-duration: 150ms;\n}\n.searchbar .searchbar-input {\n  width: 100%;\n  height: 32px;\n  position: relative;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n}\n.searchbar input[type=\"search\"] {\n  box-sizing: border-box;\n  width: 100%;\n  height: 32px;\n  display: block;\n  border: none;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border-radius: 0;\n  font-family: inherit;\n  color: #fff;\n  font-size: 16px;\n  font-weight: 400;\n  padding: 0;\n  border-bottom: 1px solid #fff;\n  height: 100%;\n  padding: 0 36px 0 24px;\n  background-color: transparent;\n  background-repeat: no-repeat;\n  background-position: 0 center;\n  opacity: 0.6;\n  -webkit-background-size: 24px 24px;\n  background-size: 24px 24px;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23FFFFFF'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M15.5%2014h-.79l-.28-.27C15.41%2012.59%2016%2011.11%2016%209.5%2016%205.91%2013.09%203%209.5%203S3%205.91%203%209.5%205.91%2016%209.5%2016c1.61%200%203.09-.59%204.23-1.57l.27.28v.79l5%204.99L20.49%2019l-4.99-5zm-6%200C7.01%2014%205%2011.99%205%209.5S7.01%205%209.5%205%2014%207.01%2014%209.5%2011.99%2014%209.5%2014z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\n.searchbar input[type=\"search\"]::-webkit-input-placeholder {\n  color: #ffffff;\n  opacity: 1;\n}\n.searchbar input[type=\"search\"]::-webkit-search-cancel-button {\n  -webkit-appearance: none;\n}\n.searchbar .searchbar-clear {\n  position: absolute;\n  width: 56px;\n  height: 100%;\n  right: -16px;\n  top: 0;\n  opacity: 0;\n  pointer-events: none;\n  background-position: center;\n  background-repeat: no-repeat;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23fff'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M19%206.41L17.59%205%2012%2010.59%206.41%205%205%206.41%2010.59%2012%205%2017.59%206.41%2019%2012%2013.41%2017.59%2019%2019%2017.59%2013.41%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n  -webkit-background-size: 24px 24px;\n  background-size: 24px 24px;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  cursor: pointer;\n}\n.searchbar .searchbar-cancel {\n  display: none;\n}\n.searchbar.searchbar-active input[type=\"search\"] {\n  opacity: 1;\n}\n.searchbar.searchbar-active .searchbar-clear {\n  pointer-events: auto;\n  opacity: 1;\n}\n.searchbar.searchbar-not-empty .searchbar-clear {\n  pointer-events: auto;\n  opacity: 1;\n}\n.searchbar-overlay {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  z-index: 100;\n  opacity: 0;\n  pointer-events: none;\n  background: rgba(0, 0, 0, 0.25);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.searchbar-overlay.searchbar-overlay-active {\n  opacity: 1;\n  pointer-events: auto;\n}\n.searchbar-not-found {\n  display: none;\n}\n.hidden-by-searchbar,\n.list-block .hidden-by-searchbar,\n.list-block li.hidden-by-searchbar {\n  display: none;\n}\n.page > .searchbar {\n  position: absolute;\n  width: 100%;\n  left: 0;\n  top: 0;\n  z-index: 200;\n  box-shadow: 0px 2px 4px -1px rgba(0, 0, 0, 0.2), 0px 4px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 10px 0px rgba(0, 0, 0, 0.12);\n}\n.page > .searchbar ~ .page-content {\n  padding-top: 48px;\n}\n.page > .searchbar.no-shadow {\n  box-shadow: none;\n}\n.navbar-fixed .page > .searchbar,\n.navbar-through .page > .searchbar,\n.navbar-fixed > .searchbar,\n.navbar-through > .searchbar {\n  top: 56px;\n}\n.navbar-fixed .page > .searchbar ~ .page-content,\n.navbar-through .page > .searchbar ~ .page-content,\n.navbar-fixed > .searchbar ~ .page-content,\n.navbar-through > .searchbar ~ .page-content {\n  padding-top: 104px;\n}\n/* === Message Bar === */\n.toolbar.messagebar {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  background: #fff;\n  height: 48px;\n  top: auto;\n  bottom: 0;\n  font-size: 16px;\n  overflow: hidden;\n}\n.toolbar.messagebar:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #d1d1d1;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .toolbar.messagebar:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .toolbar.messagebar:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.toolbar.messagebar textarea {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  -webkit-box-sizing: border-box;\n  -moz-box-sizing: border-box;\n  box-sizing: border-box;\n  border: none;\n  background: none;\n  border-radius: 0;\n  box-shadow: none;\n  display: block;\n  padding: 3px 8px 3px;\n  margin: 0;\n  width: 100%;\n  height: 28px;\n  color: #333;\n  font-size: 16px;\n  line-height: 22px;\n  font-family: inherit;\n  resize: none;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n}\n.toolbar.messagebar a.link {\n  color: #333;\n  -ms-flex-item-align: flex-end;\n  -webkit-align-self: flex-end;\n  align-self: flex-end;\n  height: 48px;\n  line-height: 48px;\n}\n.toolbar.messagebar a.link:before {\n  background-image: -webkit-radial-gradient(center, circle cover, rgba(0, 0, 0, 0.1) 66%, rgba(0, 0, 0, 0) 66%);\n  background-image: radial-gradient(circle at center, rgba(0, 0, 0, 0.1) 66%, rgba(0, 0, 0, 0) 66%);\n}\n.toolbar.messagebar .link {\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.toolbar.messagebar ~ .page-content {\n  padding-bottom: 48px;\n}\n.page.no-toolbar .toolbar.messagebar ~ .page-content,\n.page.no-tabbar .toolbar.messagebar ~ .page-content {\n  padding-bottom: 48px;\n}\n.hidden-toolbar .toolbar.messagebar {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n/* === Icons === */\ni.icon {\n  display: inline-block;\n  vertical-align: middle;\n  background-size: 100% auto;\n  background-position: center;\n  background-repeat: no-repeat;\n  font-style: normal;\n  position: relative;\n  /* Material Icons http://google.github.io/material-design-icons/ */\n}\ni.icon.icon-back {\n  width: 24px;\n  height: 24px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-forward {\n  width: 24px;\n  height: 24px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-bars {\n  width: 24px;\n  height: 24px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-camera {\n  width: 24px;\n  height: 24px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23333'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Ccircle%20cx%3D'12'%20cy%3D'12'%20r%3D'3.2'%2F%3E%3Cpath%20d%3D'M9%202L7.17%204H4c-1.1%200-2%20.9-2%202v12c0%201.1.9%202%202%202h16c1.1%200%202-.9%202-2V6c0-1.1-.9-2-2-2h-3.17L15%202H9zm3%2015c-2.76%200-5-2.24-5-5s2.24-5%205-5%205%202.24%205%205-2.24%205-5%205z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-f7 {\n  width: 24px;\n  height: 24px;\n  background-image: url(" + __webpack_require__(/*! ../img/i-f7-material.png */ 396) + ");\n  border-radius: 3px;\n}\ni.icon.icon-next,\ni.icon.icon-prev {\n  width: 24px;\n  height: 24px;\n}\ni.icon.icon-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-plus {\n  width: 24px;\n  height: 24px;\n  font-size: 0;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23FFFFFF'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M19%2013h-6v6h-2v-6H5v-2h6V5h2v6h6v2z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon.icon-close {\n  width: 24px;\n  height: 24px;\n  font-size: 0;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23FFFFFF'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M19%206.41L17.59%205%2012%2010.59%206.41%205%205%206.41%2010.59%2012%205%2017.59%206.41%2019%2012%2013.41%2017.59%2019%2019%2017.59%2013.41%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\n.badge {\n  font-size: 10px;\n  display: inline-block;\n  color: #fff;\n  background: #8e8e93;\n  border-radius: 3px;\n  padding: 1px 6px;\n  box-sizing: border-box;\n  vertical-align: middle;\n}\n.icon .badge,\n.f7-icons .badge,\n.material-icons .badge,\n.framework7-icons .badge {\n  position: absolute;\n  left: 100%;\n  margin-left: -10px;\n  top: -2px;\n  font-size: 10px;\n  line-height: 1.4;\n  padding: 1px 5px;\n  font-family: Roboto, Noto, Helvetica, Arial, sans-serif;\n}\n/* === Chips === */\n.chip {\n  font-size: 13px;\n  font-weight: normal;\n  color: rgba(0, 0, 0, 0.87);\n  background: rgba(0, 0, 0, 0.12);\n  display: inline-block;\n  height: 32px;\n  line-height: 32px;\n  border-radius: 16px;\n  padding: 0 12px;\n  box-sizing: border-box;\n  vertical-align: middle;\n  display: -webkit-inline-box;\n  display: -ms-inline-flexbox;\n  display: -webkit-inline-flex;\n  display: inline-flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  margin: 2px 0;\n}\n.chip-media {\n  width: 32px;\n  height: 32px;\n  margin-left: -12px;\n  vertical-align: top;\n  border-radius: 50%;\n  text-align: center;\n  line-height: 32px;\n  color: #fff;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  font-size: 16px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n}\n.chip-media img {\n  max-width: 100%;\n  max-height: 100%;\n  width: auto;\n  height: auto;\n  border-radius: 50%;\n  display: block;\n}\n.chip-media + .chip-label {\n  margin-left: 8px;\n}\n.chip-label {\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  position: relative;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  min-width: 0;\n}\n.chip-label + .chip-delete {\n  margin-left: 4px;\n}\n.chip-delete {\n  margin-right: -8px;\n  width: 24px;\n  height: 24px;\n  text-align: center;\n  line-height: 24px;\n  cursor: pointer;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23000'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M12%202C6.47%202%202%206.47%202%2012s4.47%2010%2010%2010%2010-4.47%2010-10S17.53%202%2012%202zm5%2013.59L15.59%2017%2012%2013.41%208.41%2017%207%2015.59%2010.59%2012%207%208.41%208.41%207%2012%2010.59%2015.59%207%2017%208.41%2013.41%2012%2017%2015.59z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n  background-repeat: no-repeat;\n  background-position: center;\n  background-size: 20px 20px;\n  opacity: 0.54;\n}\nhtml:not(.watch-active-state) .chip-delete:active,\n.chip-delete.active-state {\n  opacity: 1;\n}\n/* === Content Block === */\n.content-block {\n  margin: 32px 0;\n  padding: 0 16px;\n  box-sizing: border-box;\n}\n.content-block.no-hairlines:before,\n.content-block.no-hairlines ul:before,\n.content-block.no-hairlines .content-block-inner:before {\n  display: none;\n}\n.content-block.no-hairlines:after,\n.content-block.no-hairlines ul:after,\n.content-block.no-hairlines .content-block-inner:after {\n  display: none;\n}\n.content-block-title {\n  position: relative;\n  overflow: hidden;\n  margin: 0;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  font-size: 14px;\n  line-height: 1;\n  margin: 16px 16px 16px;\n  padding-top: 16px;\n  line-height: 16px;\n  font-weight: 500;\n  color: rgba(0, 0, 0, 0.54);\n}\n.content-block-title + .list-block,\n.content-block-title + .content-block,\n.content-block-title + .card,\n.content-block-title + .timeline {\n  margin-top: 0px;\n}\n.content-block-inner {\n  padding: 16px 16px;\n  margin-left: -16px;\n  width: 100%;\n  position: relative;\n}\n.content-block-inner:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .content-block-inner:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .content-block-inner:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.content-block-inner:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .content-block-inner:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .content-block-inner:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.content-block-inner > p:first-child {\n  margin-top: 0;\n}\n.content-block-inner > p:last-child {\n  margin-bottom: 0;\n}\n.content-block.inset {\n  margin-left: 16px;\n  margin-right: 16px;\n  border-radius: 7px;\n}\n.content-block.inset .content-block-inner {\n  border-radius: 4px;\n}\n.content-block.inset .content-block-inner:before {\n  display: none;\n}\n.content-block.inset .content-block-inner:after {\n  display: none;\n}\n@media all and (min-width: 768px) {\n  .content-block.tablet-inset {\n    margin-left: 16px;\n    margin-right: 16px;\n    border-radius: 4px;\n  }\n  .content-block.tablet-inset .content-block-inner {\n    border-radius: 4px;\n  }\n  .content-block.tablet-inset .content-block-inner:before {\n    display: none;\n  }\n  .content-block.tablet-inset .content-block-inner:after {\n    display: none;\n  }\n}\n/* === Lists === */\n.list-block {\n  margin: 32px 0;\n  font-size: 16px;\n}\n.list-block ul {\n  list-style: none;\n  padding: 0;\n  margin: 0;\n  position: relative;\n}\n.list-block ul:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .list-block ul:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .list-block ul:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.list-block ul:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .list-block ul:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .list-block ul:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.list-block ul ul {\n  padding-left: 56px;\n}\n.list-block ul ul:before {\n  display: none;\n}\n.list-block ul ul:after {\n  display: none;\n}\n.list-block .align-top,\n.list-block .align-top .item-content,\n.list-block .align-top .item-inner {\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n}\n.list-block.inset {\n  margin-left: 16px;\n  margin-right: 16px;\n  border-radius: 4px;\n}\n.list-block.inset .content-block-title {\n  margin-left: 0;\n  margin-right: 0;\n}\n.list-block.inset ul {\n  border-radius: 4px;\n}\n.list-block.inset ul:before {\n  display: none;\n}\n.list-block.inset ul:after {\n  display: none;\n}\n.list-block.inset li:first-child > a {\n  border-radius: 4px 4px 0 0;\n}\n.list-block.inset li:last-child > a {\n  border-radius: 0 0 4px 4px;\n}\n.list-block.inset li:first-child:last-child > a {\n  border-radius: 4px;\n}\n@media all and (min-width: 768px) {\n  .list-block.tablet-inset {\n    margin-left: 16px;\n    margin-right: 16px;\n    border-radius: 4px;\n  }\n  .list-block.tablet-inset .content-block-title {\n    margin-left: 0;\n    margin-right: 0;\n  }\n  .list-block.tablet-inset ul {\n    border-radius: 4px;\n  }\n  .list-block.tablet-inset ul:before {\n    display: none;\n  }\n  .list-block.tablet-inset ul:after {\n    display: none;\n  }\n  .list-block.tablet-inset li:first-child > a {\n    border-radius: 4px 4px 0 0;\n  }\n  .list-block.tablet-inset li:last-child > a {\n    border-radius: 0 0 4px 4px;\n  }\n  .list-block.tablet-inset li:first-child:last-child > a {\n    border-radius: 4px;\n  }\n  .list-block.tablet-inset .content-block-title {\n    margin-left: 0;\n    margin-right: 0;\n  }\n  .list-block.tablet-inset ul {\n    border-radius: 4px;\n  }\n  .list-block.tablet-inset ul:before {\n    display: none;\n  }\n  .list-block.tablet-inset ul:after {\n    display: none;\n  }\n  .list-block.tablet-inset li:first-child > a {\n    border-radius: 4px 4px 0 0;\n  }\n  .list-block.tablet-inset li:last-child > a {\n    border-radius: 0 0 4px 4px;\n  }\n  .list-block.tablet-inset li:first-child:last-child > a {\n    border-radius: 4px;\n  }\n}\n.list-block li {\n  box-sizing: border-box;\n  position: relative;\n}\n.list-block .item-media {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  -webkit-box-lines: single;\n  -moz-box-lines: single;\n  -webkit-flex-wrap: nowrap;\n  -ms-flex-wrap: none;\n  -ms-flex-wrap: nowrap;\n  flex-wrap: nowrap;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  box-sizing: border-box;\n  padding-top: 8px;\n  padding-bottom: 8px;\n  min-width: 40px;\n}\n.list-block .item-media i + i {\n  margin-left: 8px;\n}\n.list-block .item-media i + img {\n  margin-left: 8px;\n}\n.list-block .item-media + .item-inner {\n  margin-left: 16px;\n}\n.list-block .item-inner {\n  padding-right: 16px;\n  position: relative;\n  width: 100%;\n  padding-top: 8px;\n  padding-bottom: 8px;\n  min-height: 48px;\n  box-sizing: border-box;\n  -webkit-box-flex: 1;\n  -ms-flex: 1;\n  min-width: 0;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -ms-flex-item-align: stretch;\n  -webkit-align-self: stretch;\n  align-self: stretch;\n}\n.list-block .item-inner:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .list-block .item-inner:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .list-block .item-inner:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.list-block .item-title {\n  min-width: 0;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  white-space: nowrap;\n  position: relative;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  max-width: 100%;\n}\n.list-block .item-after {\n  white-space: nowrap;\n  color: #757575;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  margin-left: auto;\n  padding-left: 8px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  max-height: 28px;\n  font-size: 14px;\n}\n.list-block .smart-select .item-after,\n.list-block .autocomplete-opener .item-after {\n  max-width: 70%;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  position: relative;\n  display: block;\n}\n.list-block .item-actions {\n  margin-left: auto;\n  padding-left: 8px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n}\n.list-block .item-actions a {\n  min-width: 24px;\n  position: relative;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n}\n.list-block .item-actions a + a {\n  margin-left: 8px;\n}\n.list-block .item-after + .item-actions {\n  margin-left: 0;\n}\n.list-block .item-link,\n.list-block .list-button {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  display: block;\n  color: inherit;\n  position: relative;\n  overflow: hidden;\n  z-index: 0;\n}\n.list-block .item-link .item-inner,\n.list-block .list-button .item-inner {\n  padding-right: 42px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20viewBox%3D'0%200%2060%20120'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'm60%2061.5-38.25%2038.25-9.75-9.75%2029.25-28.5-29.25-28.5%209.75-9.75z'%20fill%3D'%23c7c7cc'%2F%3E%3C%2Fsvg%3E\");\n  background-size: 10px 20px;\n  background-repeat: no-repeat;\n  background-position: 95% center;\n  background-position: -webkit-calc(100% - 16px) center;\n  background-position: calc(100% - 16px) center;\n}\nhtml:not(.watch-active-state) .list-block .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-button:active,\n.list-block .item-link.active-state,\n.list-block .list-button.active-state {\n  background-color: rgba(0, 0, 0, 0.1);\n}\n.list-block .list-button {\n  padding: 0 16px;\n  font-size: 16px;\n  display: block;\n  line-height: 48px;\n}\n.list-block .item-content {\n  box-sizing: border-box;\n  padding-left: 16px;\n  min-height: 48px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.list-block .list-block-label {\n  margin: 10px 0 35px;\n  padding: 0 16px;\n  font-size: 14px;\n  color: rgba(0, 0, 0, 0.54);\n}\n.list-block .swipeout {\n  overflow: hidden;\n  -webkit-transform-style: preserve-3d;\n  transform-style: preserve-3d;\n}\n.list-block .swipeout.deleting {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block .swipeout.deleting .swipeout-content {\n  -webkit-transform: translateX(-100%);\n  transform: translateX(-100%);\n}\n.list-block .swipeout.transitioning .swipeout-content,\n.list-block .swipeout.transitioning .swipeout-actions-right a,\n.list-block .swipeout.transitioning .swipeout-actions-left a,\n.list-block .swipeout.transitioning .swipeout-overswipe {\n  -webkit-transition: 300ms;\n  transition: 300ms;\n}\n.list-block .swipeout-content {\n  position: relative;\n  z-index: 10;\n}\n.list-block .swipeout-overswipe {\n  -webkit-transition: 200ms left;\n  transition: 200ms left;\n}\n.list-block .swipeout-actions-left,\n.list-block .swipeout-actions-right {\n  position: absolute;\n  top: 0;\n  height: 100%;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n}\n.list-block .swipeout-actions-left a,\n.list-block .swipeout-actions-right a {\n  padding: 0 24px;\n  color: #fff;\n  background: #c7c7cc;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  position: relative;\n  left: 0;\n}\n.list-block .swipeout-actions-left a:after,\n.list-block .swipeout-actions-right a:after {\n  content: '';\n  position: absolute;\n  top: 0;\n  width: 600%;\n  height: 100%;\n  background: inherit;\n  z-index: -1;\n}\n.list-block .swipeout-actions-left a.swipeout-delete,\n.list-block .swipeout-actions-right a.swipeout-delete {\n  background: #f44336;\n}\n.list-block .swipeout-actions-right {\n  right: 0%;\n  -webkit-transform: translateX(100%);\n  transform: translateX(100%);\n}\n.list-block .swipeout-actions-right a:after {\n  left: 100%;\n  margin-left: -1px;\n}\n.list-block .swipeout-actions-left {\n  left: 0%;\n  -webkit-transform: translateX(-100%);\n  transform: translateX(-100%);\n}\n.list-block .swipeout-actions-left a:after {\n  right: 100%;\n  margin-right: -1px;\n}\n.list-block .item-subtitle {\n  font-size: 14px;\n  position: relative;\n  overflow: hidden;\n  white-space: nowrap;\n  max-width: 100%;\n  text-overflow: ellipsis;\n}\n.list-block .item-text {\n  font-size: 14px;\n  color: #757575;\n  line-height: 20px;\n  position: relative;\n  overflow: hidden;\n  max-height: 40px;\n  text-overflow: ellipsis;\n  -webkit-line-clamp: 2;\n  -webkit-box-orient: vertical;\n  display: -webkit-box;\n}\n.list-block.media-list .item-inner,\n.list-block li.media-item .item-inner {\n  display: block;\n  padding-top: 14px;\n  padding-bottom: 14px;\n  -ms-flex-item-align: stretch;\n  -webkit-align-self: stretch;\n  align-self: stretch;\n}\n.list-block.media-list .item-link .item-inner,\n.list-block li.media-item .item-link .item-inner {\n  background: none;\n  padding-right: 16px;\n}\n.list-block.media-list .item-link .item-title-row,\n.list-block li.media-item .item-link .item-title-row {\n  padding-right: 26px;\n  background: no-repeat right top;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20viewBox%3D'0%200%2060%20120'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'm60%2061.5-38.25%2038.25-9.75-9.75%2029.25-28.5-29.25-28.5%209.75-9.75z'%20fill%3D'%23c7c7cc'%2F%3E%3C%2Fsvg%3E\");\n  background-size: 10px 20px;\n}\n.list-block.media-list .item-media,\n.list-block li.media-item .item-media {\n  padding-top: 14px;\n  padding-bottom: 14px;\n  -ms-flex-item-align: flex-start;\n  -webkit-align-self: flex-start;\n  align-self: flex-start;\n}\n.list-block.media-list .item-media img,\n.list-block li.media-item .item-media img {\n  display: block;\n}\n.list-block.media-list .item-title-row,\n.list-block li.media-item .item-title-row {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n}\n.list-block.media-list .item-content > .item-after,\n.list-block li.media-item .item-content > .item-after {\n  padding-top: 14px;\n  padding-bottom: 14px;\n  -ms-flex-item-align: flex-start;\n  -webkit-align-self: flex-start;\n  align-self: flex-start;\n}\n.list-block .list-group ul:after,\n.list-block .list-group ul:before {\n  z-index: 11;\n}\n.list-block .list-group + .list-group ul:before {\n  display: none;\n}\n.list-block .item-divider,\n.list-block .list-group-title {\n  background: #f4f4f4;\n  padding: 0px 16px;\n  white-space: nowrap;\n  position: relative;\n  max-width: 100%;\n  text-overflow: ellipsis;\n  overflow: hidden;\n  color: rgba(0, 0, 0, 0.54);\n  height: 48px;\n  box-sizing: border-box;\n  line-height: 48px;\n  font-size: 14px;\n}\n.list-block .item-divider:before,\n.list-block .list-group-title:before {\n  display: none;\n}\n.list-block .list-group-title {\n  position: relative;\n  position: -webkit-sticky;\n  position: -moz-sticky;\n  position: sticky;\n  top: 0px;\n  z-index: 10;\n  margin-top: 0;\n}\n.list-block .sortable-handler {\n  position: absolute;\n  right: 0;\n  top: 0;\n  bottom: 1px;\n  z-index: 10;\n  background-repeat: no-repeat;\n  background-size: 18px 12px;\n  background-position: center;\n  width: 50px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2018%2012'%20fill%3D'%23c7c7cc'%3E%3Cpath%20d%3D'M0%2C2V0h22v2H0z'%2F%3E%3Cpath%20d%3D'M0%2C7V5h22v2H0z'%2F%3E%3Cpath%20d%3D'M0%2C12v-2h22v2H0z'%2F%3E%3C%2Fsvg%3E\");\n  opacity: 0;\n  visibility: hidden;\n  cursor: pointer;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block.sortable .item-inner {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block.sortable-opened .sortable-handler {\n  visibility: visible;\n  opacity: 1;\n}\n.list-block.sortable-opened .item-inner,\n.list-block.sortable-opened .item-link .item-inner {\n  padding-right: 50px;\n}\n.list-block.sortable-opened .item-link .item-inner,\n.list-block.sortable-opened .item-link .item-title-row {\n  background-image: none;\n}\n.list-block.sortable-sorting li {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block li.sorting {\n  z-index: 50;\n  background: rgba(255, 255, 255, 0.8);\n  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.list-block li.sorting .item-inner:after {\n  display: none;\n}\n.list-block li:last-child .list-button:after {\n  display: none;\n}\n.list-block li:last-child .item-inner:after,\n.list-block li:last-child li:last-child .item-inner:after {\n  display: none;\n}\n.list-block li li:last-child .item-inner:after,\n.list-block li:last-child li .item-inner:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .list-block li li:last-child .item-inner:after,\nhtml.pixel-ratio-2 .list-block li:last-child li .item-inner:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .list-block li li:last-child .item-inner:after,\nhtml.pixel-ratio-3 .list-block li:last-child li .item-inner:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.list-block.no-hairlines:before,\n.list-block.no-hairlines ul:before,\n.list-block.no-hairlines .content-block-inner:before {\n  display: none;\n}\n.list-block.no-hairlines:after,\n.list-block.no-hairlines ul:after,\n.list-block.no-hairlines .content-block-inner:after {\n  display: none;\n}\n.list-block.no-hairlines-between .item-inner:after,\n.list-block.no-hairlines-between .list-button:after,\n.list-block.no-hairlines-between .item-divider:after,\n.list-block.no-hairlines-between .list-group-title:after,\n.list-block.no-hairlines-between .list-group-title:after {\n  display: none;\n}\n/* === Contacts === */\n.contacts-block {\n  margin: 0;\n}\n.contacts-block .list-group-title {\n  padding: 0 16px;\n  pointer-events: none;\n  background: none;\n  color: #888888;\n  line-height: 48px;\n  height: 48px;\n  font-size: 20px;\n  font-weight: 500;\n  overflow: visible;\n  width: 56px;\n  top: 0;\n}\n.contacts-block .list-group-title + li {\n  margin-top: -48px;\n}\n.contacts-block .list-group:first-child ul:before {\n  display: none;\n}\n.contacts-block .list-group:last-child ul:after {\n  display: none;\n}\n.contacts-block li:not(.list-group-title) {\n  padding-left: 56px;\n}\n/* === Forms === */\n.list-block input[type=\"text\"],\n.list-block input[type=\"password\"],\n.list-block input[type=\"search\"],\n.list-block input[type=\"email\"],\n.list-block input[type=\"tel\"],\n.list-block input[type=\"url\"],\n.list-block input[type=\"date\"],\n.list-block input[type=\"datetime-local\"],\n.list-block input[type=\"time\"],\n.list-block input[type=\"number\"],\n.list-block select,\n.list-block textarea {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  box-sizing: border-box;\n  border: none;\n  background: none;\n  border-radius: 0 0 0 0;\n  box-shadow: none;\n  display: block;\n  padding: 0;\n  margin: 0;\n  width: 100%;\n  height: 36px;\n  color: #212121;\n  font-size: 16px;\n  font-family: inherit;\n}\n.list-block input[type=\"text\"]::-webkit-input-placeholder,\n.list-block input[type=\"password\"]::-webkit-input-placeholder,\n.list-block input[type=\"search\"]::-webkit-input-placeholder,\n.list-block input[type=\"email\"]::-webkit-input-placeholder,\n.list-block input[type=\"tel\"]::-webkit-input-placeholder,\n.list-block input[type=\"url\"]::-webkit-input-placeholder,\n.list-block input[type=\"date\"]::-webkit-input-placeholder,\n.list-block input[type=\"datetime-local\"]::-webkit-input-placeholder,\n.list-block input[type=\"time\"]::-webkit-input-placeholder,\n.list-block input[type=\"number\"]::-webkit-input-placeholder,\n.list-block select::-webkit-input-placeholder,\n.list-block textarea::-webkit-input-placeholder {\n  color: rgba(0, 0, 0, 0.35);\n}\n.list-block .label,\n.list-block .floating-label {\n  vertical-align: top;\n  color: rgba(0, 0, 0, 0.65);\n  -webkit-transition-duration: 200ms;\n  transition-duration: 200ms;\n  width: 35%;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.list-block input[type=\"date\"],\n.list-block input[type=\"datetime-local\"] {\n  line-height: 44px;\n}\n.list-block select {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n}\n.list-block textarea {\n  resize: none;\n  line-height: 1.4;\n  padding-top: 8px;\n  padding-bottom: 7px;\n  height: 100px;\n}\n.list-block textarea.resizable {\n  height: 36px;\n}\n.list-block .item-input {\n  width: 100%;\n  -ms-flex: 1;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  font-size: 0;\n  position: relative;\n  margin-bottom: 4px;\n  min-height: 36px;\n}\n.list-block .input-item ul:after,\n.list-block.inputs-list ul:after {\n  display: none;\n}\n.list-block .input-item .item-media,\n.list-block.inputs-list .item-media {\n  -ms-flex-item-align: flex-end;\n  -webkit-align-self: flex-end;\n  align-self: flex-end;\n  min-height: 36px;\n  margin-bottom: 8px;\n  padding: 0;\n}\n.list-block .input-item .item-inner,\n.list-block.inputs-list .item-inner {\n  display: block;\n  margin-bottom: 4px;\n  padding-bottom: 0;\n}\n.list-block .input-item .item-inner:after,\n.list-block.inputs-list .item-inner:after {\n  display: none;\n}\n.list-block .input-item .label,\n.list-block.inputs-list .label,\n.list-block .input-item .floating-label,\n.list-block.inputs-list .floating-label {\n  width: 100%;\n  font-size: 12px;\n}\n.list-block .input-item .floating-label,\n.list-block.inputs-list .floating-label {\n  -webkit-transform-origin: left;\n  transform-origin: left;\n  -webkit-transform: scale(1.33333333) translateY(21px);\n  transform: scale(1.33333333) translateY(21px);\n  color: rgba(0, 0, 0, 0.35);\n  width: auto;\n  max-width: 75%;\n}\n.list-block .input-item .floating-label ~ .item-input input::-webkit-input-placeholder,\n.list-block.inputs-list .floating-label ~ .item-input input::-webkit-input-placeholder {\n  color: transparent;\n}\n.list-block .focus-state .floating-label,\n.list-block .not-empty-state .floating-label {\n  color: rgba(0, 0, 0, 0.65);\n  -webkit-transform: scale(1) translateY(0);\n  transform: scale(1) translateY(0);\n}\n.list-block .focus-state.item-inner .label {\n  color: #2196f3;\n}\n.list-block .focus-state.input-field:after,\n.list-block .focus-state .item-input-field:after {\n  background: #2196f3;\n}\n.list-block .focus-state .label,\n.list-block .focus-state .floating-label {\n  color: #2196f3;\n}\n.list-block .not-empty-state.item-inner .label {\n  color: rgba(0, 0, 0, 0.65);\n}\n.list-block .not-empty-state.input-field:after,\n.list-block .not-empty-state .item-input-field:after {\n  background: rgba(0, 0, 0, 0.12);\n  transform: none !important;\n}\n.item-input-field,\n.input-field {\n  position: relative;\n}\n.item-input-field:after,\n.input-field:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .item-input-field:after,\nhtml.pixel-ratio-2 .input-field:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .item-input-field:after,\nhtml.pixel-ratio-3 .input-field:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.item-input-field:after,\n.input-field:after {\n  -webkit-transition-duration: 200ms;\n  transition-duration: 200ms;\n}\n.item-input-field.focus-state:after,\n.input-field.focus-state:after,\n.item-input-field.not-empty-state:after,\n.input-field.not-empty-state:after,\n.focus-state .item-input-field:after,\n.focus-state .input-field:after,\n.not-empty-state .item-input-field:after,\n.not-empty-state .input-field:after {\n  background: #2196f3;\n  -webkit-transform: scaleY(2) !important;\n  transform: scaleY(2) !important;\n}\ntextarea.resizable {\n  overflow: hidden;\n}\n.label-switch {\n  display: inline-block;\n  vertical-align: middle;\n  width: 36px;\n  height: 14px;\n  position: relative;\n  cursor: pointer;\n  -ms-flex-item-align: center;\n  -webkit-align-self: center;\n  align-self: center;\n}\n.label-switch .checkbox {\n  width: 36px;\n  border-radius: 36px;\n  box-sizing: border-box;\n  height: 14px;\n  background: #b0afaf;\n  z-index: 0;\n  margin: 0;\n  padding: 0;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border: none;\n  cursor: pointer;\n  position: relative;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.label-switch .checkbox:after {\n  content: ' ';\n  height: 20px;\n  width: 20px;\n  border-radius: 20px;\n  background: #fff;\n  position: absolute;\n  z-index: 2;\n  top: -3px;\n  left: 0px;\n  box-shadow: 0 2px 5px rgba(0, 0, 0, 0.4);\n  -webkit-transform: translateX(0px);\n  transform: translateX(0px);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.label-switch input[type=\"checkbox\"] {\n  display: none;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox {\n  background: rgba(33, 150, 243, 0.5);\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox:after {\n  -webkit-transform: translateX(16px);\n  transform: translateX(16px);\n  background: #2196f3;\n}\n.item-input .label-switch {\n  top: 11px;\n}\n.button {\n  color: #2196f3;\n  text-decoration: none;\n  text-align: center;\n  display: block;\n  border-radius: 2px;\n  line-height: 36px;\n  box-sizing: border-box;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  background: none;\n  padding: 0 10px;\n  margin: 0;\n  height: 36px;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  font-size: 14px;\n  text-transform: uppercase;\n  font-family: inherit;\n  cursor: pointer;\n  min-width: 64px;\n  padding: 0 8px;\n  position: relative;\n  overflow: hidden;\n  outline: 0;\n  border: none;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\ninput[type=\"submit\"].button,\ninput[type=\"button\"].button {\n  width: 100%;\n}\nhtml:not(.watch-active-state) .button:active,\n.button.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.button.button-fill {\n  background-color: #2196f3;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill:active,\n.button.button-fill.active-state {\n  background: #0c82df;\n}\n.button.button-big {\n  height: 48px;\n  line-height: 48px;\n  border-radius: 3px;\n}\n.button i.icon + span,\n.button span:not(.ripple-wave) + span,\n.button span:not(.ripple-wave) + i.icon,\n.button i.icon + i.icon {\n  margin-left: 8px;\n}\n.navbar .button:not(.button-fill),\n.toolbar .button:not(.button-fill),\n.subnavbar .button:not(.button-fill),\n.notifications .button:not(.button-fill) {\n  color: #fff;\n}\nhtml:not(.watch-active-state) .navbar .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .toolbar .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .subnavbar .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .notifications .button:not(.button-fill):active,\n.navbar .button:not(.button-fill).active-state,\n.toolbar .button:not(.button-fill).active-state,\n.subnavbar .button:not(.button-fill).active-state,\n.notifications .button:not(.button-fill).active-state {\n  background: rgba(255, 255, 255, 0.15);\n}\n.button-raised {\n  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);\n}\nhtml:not(.watch-active-state) .button-raised:active,\n.button-raised.active-state {\n  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);\n}\n.buttons-row {\n  -ms-flex-item-align: center;\n  -webkit-align-self: center;\n  align-self: center;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-lines: single;\n  -moz-box-lines: single;\n  -webkit-flex-wrap: nowrap;\n  -ms-flex-wrap: none;\n  -ms-flex-wrap: nowrap;\n  flex-wrap: nowrap;\n}\n.buttons-row .button {\n  margin-left: 16px;\n  width: 100%;\n  -webkit-box-flex: 1;\n  -ms-flex: 1;\n}\n.buttons-row .button:first-child {\n  margin-left: 0;\n}\n.range-slider {\n  width: 100%;\n  position: relative;\n  overflow: hidden;\n  -ms-flex-item-align: center;\n  -webkit-align-self: center;\n  align-self: center;\n}\n.range-slider input[type=\"range\"] {\n  position: relative;\n  height: 20px;\n  width: 100%;\n  margin: 0;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  background: -webkit-gradient(linear, 50% 0, 50% 100%, color-stop(0, #b9b9b9), color-stop(100%, #b9b9b9));\n  background: linear-gradient(to right, #b9b9b9 0, #b9b9b9 100%);\n  background-position: center;\n  background-size: 100% 2px;\n  background-repeat: no-repeat;\n  outline: 0;\n  -ms-background-position-y: 500px;\n}\n.range-slider input[type=\"range\"]:focus,\n.range-slider input[type=\"range\"]:active {\n  border: 0;\n  outline: 0 none;\n}\n.range-slider input[type=\"range\"]::-webkit-slider-thumb {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border: none;\n  outline: 0;\n  height: 20px;\n  width: 20px;\n  position: relative;\n  background: #2196f3;\n  border-radius: 20px;\n}\n.range-slider input[type=\"range\"]::-webkit-slider-thumb:before {\n  position: absolute;\n  top: 50%;\n  right: 100%;\n  width: 2000px;\n  height: 2px;\n  margin-top: -1px;\n  z-index: 1;\n  background: #2196f3;\n  content: ' ';\n}\n.range-slider input[type=\"range\"]::-moz-range-track {\n  width: 100%;\n  height: 2px;\n  background: #b7b8b7;\n  border: none;\n  outline: 0;\n}\n.range-slider input[type=\"range\"]::-moz-range-thumb {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border: none;\n  outline: 0;\n  height: 20px;\n  width: 20px;\n  position: relative;\n  background: #2196f3;\n  border-radius: 20px;\n}\n.range-slider input[type=\"range\"]::-ms-track {\n  width: 100%;\n  height: 2px;\n  cursor: pointer;\n  background: transparent;\n  border-color: transparent;\n  color: transparent;\n}\n.range-slider input[type=\"range\"]::-ms-thumb {\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  border: none;\n  outline: 0;\n  height: 20px;\n  width: 20px;\n  position: relative;\n  background: #2196f3;\n  border-radius: 20px;\n}\n.range-slider input[type=\"range\"]::-ms-fill-lower {\n  background: #2196f3;\n}\n.range-slider input[type=\"range\"]::-ms-fill-upper {\n  background: #b7b8b7;\n}\n.item-input .range-slider {\n  top: 8px;\n}\n.form-checkbox {\n  position: relative;\n  display: inline-block;\n  vertical-align: middle;\n}\nlabel.label-checkbox,\n.form-checkbox {\n  cursor: pointer;\n}\nlabel.label-checkbox input[type=\"checkbox\"],\n.form-checkbox input[type=\"checkbox\"],\nlabel.label-checkbox input[type=\"radio\"],\n.form-checkbox input[type=\"radio\"] {\n  display: none;\n}\nlabel.label-checkbox i.icon-form-checkbox,\n.form-checkbox i {\n  width: 18px;\n  height: 18px;\n  position: relative;\n  border-radius: 2px;\n  border: 2px solid #6d6d6d;\n  box-sizing: border-box;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  background: transparent;\n  display: block;\n}\nlabel.label-checkbox i.icon-form-checkbox:after,\n.form-checkbox i:after {\n  content: ' ';\n  position: absolute;\n  width: 18px;\n  height: 18px;\n  left: -2px;\n  top: -2px;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  opacity: 0;\n  background: no-repeat center;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n  -webkit-background-size: 100% auto;\n  background-size: 100% auto;\n}\nlabel.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\n.form-checkbox input[type=\"checkbox\"]:checked ~ i {\n  border-color: #2196f3;\n  background-color: #2196f3;\n}\nlabel.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox:after,\nlabel.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox:after,\nlabel.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox:after,\nlabel.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox:after,\nlabel.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox:after,\nlabel.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox:after,\n.form-checkbox input[type=\"checkbox\"]:checked ~ i:after {\n  opacity: 1;\n}\n.form-radio {\n  position: relative;\n  display: inline-block;\n  vertical-align: middle;\n}\nlabel.label-radio,\n.form-radio {\n  cursor: pointer;\n}\nlabel.label-radio input[type=\"checkbox\"],\n.form-radio input[type=\"checkbox\"],\nlabel.label-radio input[type=\"radio\"],\n.form-radio input[type=\"radio\"] {\n  display: none;\n}\nlabel.label-radio i.icon-form-radio,\n.form-radio i {\n  width: 20px;\n  height: 20px;\n  position: relative;\n  border-radius: 20px;\n  border: 2px solid #6d6d6d;\n  box-sizing: border-box;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  display: block;\n}\nlabel.label-radio i.icon-form-radio:after,\n.form-radio i:after {\n  content: ' ';\n  position: absolute;\n  width: 10px;\n  height: 10px;\n  left: 50%;\n  top: 50%;\n  margin-left: -5px;\n  margin-top: -5px;\n  background-color: #2196f3;\n  border-radius: 100%;\n  -webkit-transform: scale(0);\n  transform: scale(0);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\nlabel.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\n.form-radio input[type=\"radio\"]:checked ~ i {\n  border-color: #2196f3;\n}\nlabel.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\n.form-radio input[type=\"radio\"]:checked ~ i:after {\n  background-color: #2196f3;\n  -webkit-transform: scale(1);\n  transform: scale(1);\n}\nlabel.label-checkbox,\nlabel.label-radio {\n  position: relative;\n  overflow: hidden;\n  z-index: 0;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\nlabel.label-checkbox .item-after i.icon-form-checkbox,\nlabel.label-radio .item-after i.icon-form-checkbox,\nlabel.label-checkbox .item-after i.icon-form-radio,\nlabel.label-radio .item-after i.icon-form-radio {\n  margin-left: 8px;\n  margin-right: 16px;\n}\n.media-list label.label-checkbox .item-media i.icon-form-checkbox,\n.media-list label.label-radio .item-media i.icon-form-checkbox,\n.media-item label.label-checkbox .item-media i.icon-form-checkbox,\n.media-item label.label-radio .item-media i.icon-form-checkbox,\n.media-list label.label-checkbox .item-media i.icon-form-radio,\n.media-list label.label-radio .item-media i.icon-form-radio,\n.media-item label.label-checkbox .item-media i.icon-form-radio,\n.media-item label.label-radio .item-media i.icon-form-radio {\n  margin-top: 4px;\n}\nhtml:not(.watch-active-state) label.label-checkbox:active,\nhtml:not(.watch-active-state) label.label-radio:active,\nlabel.label-checkbox.active-state,\nlabel.label-radio.active-state {\n  background-color: rgba(0, 0, 0, 0.1);\n}\nhtml:not(.watch-active-state) label.label-checkbox:active .item-inner:after,\nhtml:not(.watch-active-state) label.label-radio:active .item-inner:after,\nlabel.label-checkbox.active-state .item-inner:after,\nlabel.label-radio.active-state .item-inner:after {\n  background-color: transparent;\n}\n.smart-select select {\n  display: none;\n}\n/* === Floating Action Button === */\n.floating-button {\n  position: absolute;\n  right: 16px;\n  bottom: 16px;\n  width: 56px;\n  height: 56px;\n  border-radius: 50%;\n  z-index: 1500;\n  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);\n  background-color: #2196f3;\n  color: #fff;\n  overflow: hidden;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n}\nhtml:not(.watch-active-state) .floating-button:active,\n.floating-button.active-state {\n  background: #0c82df;\n}\n.floating-button-toolbar,\n.speed-dial {\n  position: absolute;\n  right: 16px;\n  bottom: 16px;\n  z-index: 1500;\n}\n.floating-button-toolbar .floating-button,\n.speed-dial .floating-button {\n  right: 0;\n  bottom: 0;\n  position: relative;\n}\n.speed-dial .floating-button i {\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  -webkit-transform: translate3d(-50%, -50%, 0) rotate(0deg) scale(1);\n  transform: translate3d(-50%, -50%, 0) rotate(0deg) scale(1);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.speed-dial .floating-button i + i {\n  -webkit-transform: translate3d(-50%, -50%, 0) rotate(-90deg) scale(0.5);\n  transform: translate3d(-50%, -50%, 0) rotate(-90deg) scale(0.5);\n  opacity: 0;\n}\n.speed-dial.speed-dial-opened .floating-button i {\n  -webkit-transform: translate3d(-50%, -50%, 0) rotate(90deg) scale(0.5);\n  transform: translate3d(-50%, -50%, 0) rotate(90deg) scale(0.5);\n  opacity: 0;\n}\n.speed-dial.speed-dial-opened .floating-button i + i {\n  -webkit-transform: translate3d(-50%, -50%, 0) rotate(0deg) scale(1);\n  transform: translate3d(-50%, -50%, 0) rotate(0deg) scale(1);\n  opacity: 1;\n}\n.speed-dial-buttons {\n  position: absolute;\n  width: 40px;\n  left: 50%;\n  margin-left: -20px;\n  bottom: 100%;\n  margin-bottom: 16px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -webkit-box-direction: reverse;\n  -moz-box-orient: vertical;\n  -moz-box-direction: reverse;\n  -ms-flex-direction: column-reverse;\n  -webkit-flex-direction: column-reverse;\n  flex-direction: column-reverse;\n  visibility: hidden;\n  pointer-events: none;\n}\n.speed-dial-buttons a {\n  width: 40px;\n  height: 40px;\n  opacity: 0;\n  color: #fff;\n  border-radius: 50%;\n  position: relative;\n  z-index: 1;\n  overflow: hidden;\n  background-color: #2196f3;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-transform: translate3d(0, 8px, 0) scale(0.3);\n  transform: translate3d(0, 8px, 0) scale(0.3);\n  -webkit-transform-origin: center bottom;\n  transform-origin: center bottom;\n}\nhtml:not(.watch-active-state) .speed-dial-buttons a:active,\n.speed-dial-buttons a.active-state {\n  background: #0c82df;\n}\n.speed-dial-buttons a + a {\n  margin-bottom: 16px;\n}\n.speed-dial-opened .speed-dial-buttons {\n  visibility: visible;\n  pointer-events: auto;\n}\n.speed-dial-opened .speed-dial-buttons a {\n  opacity: 1;\n  -webkit-transform: translate3d(0, 0, 0) scaleY(1);\n  transform: translate3d(0, 0, 0) scaleY(1);\n  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);\n}\n.speed-dial-opened .speed-dial-buttons a:nth-child(2) {\n  -webkit-transition-delay: 50ms;\n  transition-delay: 50ms;\n}\n.speed-dial-opened .speed-dial-buttons a:nth-child(3) {\n  -webkit-transition-delay: 100ms;\n  transition-delay: 100ms;\n}\n.speed-dial-opened .speed-dial-buttons a:nth-child(4) {\n  -webkit-transition-delay: 150ms;\n  transition-delay: 150ms;\n}\n.speed-dial-opened .speed-dial-buttons a:nth-child(5) {\n  -webkit-transition-delay: 200ms;\n  transition-delay: 200ms;\n}\n.speed-dial-opened .speed-dial-buttons a:nth-child(6) {\n  -webkit-transition-delay: 250ms;\n  transition-delay: 250ms;\n}\n.floating-button-to-popover.floating-button-to-popover {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.floating-button-to-popover.floating-button-to-popover-in {\n  -webkit-transition-duration: 100ms;\n  transition-duration: 100ms;\n}\n.floating-button-to-popover.floating-button-to-popover-in i {\n  opacity: 0;\n  -webkit-transition-duration: 100ms;\n  transition-duration: 100ms;\n}\n.floating-button-to-popover.floating-button-to-popover-scale {\n  border-radius: 0;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  box-shadow: none;\n}\n.floating-button-to-popover.floating-button-to-popover-out {\n  -webkit-transition-delay: 0ms;\n  transition-delay: 0ms;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.floating-button-to-popover.floating-button-to-popover-out i {\n  opacity: 1;\n  -webkit-transition-duration: 100ms;\n  transition-duration: 100ms;\n  -webkit-transition-delay: 200ms;\n  transition-delay: 200ms;\n}\n/* === Accordion === */\n.list-block .accordion-item-toggle {\n  cursor: pointer;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block .accordion-item-toggle .item-inner {\n  padding-right: 42px;\n  background: no-repeat -webkit-calc(100% - 15px) center;\n  background: no-repeat calc(100% - 15px) center;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20viewBox%3D'0%200%2060%20120'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'm60%2061.5-38.25%2038.25-9.75-9.75%2029.25-28.5-29.25-28.5%209.75-9.75z'%20fill%3D'%23c7c7cc'%2F%3E%3C%2Fsvg%3E\");\n  background-size: 10px 20px;\n}\nhtml:not(.watch-active-state) .list-block .accordion-item-toggle:active,\n.list-block .accordion-item-toggle.active-state {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n  background-color: #d9d9d9;\n}\nhtml:not(.watch-active-state) .list-block .accordion-item-toggle:active > .item-inner:after,\n.list-block .accordion-item-toggle.active-state > .item-inner:after {\n  background-color: transparent;\n}\n.list-block .accordion-item-toggle .item-inner,\n.list-block .accordion-item > .item-link .item-inner {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transition-property: background-color;\n  transition-property: background-color;\n}\n.list-block .accordion-item-toggle .item-inner:after,\n.list-block .accordion-item > .item-link .item-inner:after {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.list-block:not(.media-list) .accordion-item-expanded:not(.media-item) .accordion-item-toggle .item-inner,\n.list-block:not(.media-list) .accordion-item-expanded:not(.media-item) > .item-link .item-inner,\n.list-block.media-list .accordion-item-expanded .accordion-item-toggle .item-title-row,\n.list-block.media-list .accordion-item-expanded > .item-link .item-title-row,\n.list-block .accordion-item-expanded.media-item .accordion-item-toggle .item-title-row,\n.list-block .accordion-item-expanded.media-item > .item-link .item-title-row {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20viewBox%3D'0%200%2060%20120'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'm60%2061.5-38.25%2038.25-9.75-9.75%2029.25-28.5-29.25-28.5%209.75-9.75z'%20transform%3D'translate(115%2C%2030)%20rotate(90)'%20fill%3D'%23c7c7cc'%2F%3E%3C%2Fsvg%3E\");\n  background-size: 20px 20px;\n}\n.list-block .accordion-item-expanded .accordion-item-toggle .item-inner:after,\n.list-block .accordion-item-expanded > .item-link .item-inner:after {\n  background-color: transparent;\n}\n.list-block .accordion-item .content-block,\n.list-block .accordion-item .list-block {\n  margin-top: 0;\n  margin-bottom: 0;\n}\n.list-block .accordion-item ul {\n  padding-left: 0;\n}\n.accordion-item-content {\n  position: relative;\n  overflow: hidden;\n  height: 0;\n  font-size: 14px;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.accordion-item-expanded > .accordion-item-content {\n  height: auto;\n}\nhtml.android-4 .accordion-item-content {\n  -webkit-transform: none;\n  transform: none;\n}\n/* === Cards === */\n.cards-list ul,\n.card .list-block ul {\n  background: none;\n}\n.cards-list > ul:before,\n.card .list-block > ul:before {\n  display: none;\n}\n.cards-list > ul:after,\n.card .list-block > ul:after {\n  display: none;\n}\n.card {\n  background: #fff;\n  margin: 8px;\n  position: relative;\n  border-radius: 2px;\n  font-size: 14px;\n  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);\n}\n.card .list-block,\n.card .content-block {\n  margin: 0;\n}\n.row:not(.no-gutter) .col > .card {\n  margin-left: 0;\n  margin-right: 0;\n}\n.page-content > .card:last-child {\n  margin-bottom: 32px;\n}\n.card-content {\n  position: relative;\n}\n.card-content-inner {\n  padding: 16px;\n  position: relative;\n}\n.card-content-inner > p:first-child {\n  margin-top: 0;\n}\n.card-content-inner > p:last-child {\n  margin-bottom: 0;\n}\n.card-content-inner > .list-block,\n.card-content-inner > .content-block {\n  margin: -15px;\n}\n.card-header,\n.card-footer {\n  min-height: 48px;\n  position: relative;\n  padding: 4px 16px;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.card-header[valign=\"top\"],\n.card-footer[valign=\"top\"] {\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n}\n.card-header[valign=\"bottom\"],\n.card-footer[valign=\"bottom\"] {\n  -webkit-box-align: end;\n  -ms-flex-align: end;\n  -webkit-align-items: flex-end;\n  align-items: flex-end;\n}\n.card-header a.link,\n.card-footer a.link {\n  color: #2196f3;\n  text-decoration: none;\n  text-align: center;\n  display: block;\n  border-radius: 2px;\n  line-height: 36px;\n  box-sizing: border-box;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  background: none;\n  padding: 0 10px;\n  margin: 0;\n  height: 36px;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  font-size: 14px;\n  text-transform: uppercase;\n  font-family: inherit;\n  cursor: pointer;\n  min-width: 64px;\n  padding: 0 8px;\n  position: relative;\n  overflow: hidden;\n  outline: 0;\n  border: none;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  -webkit-user-select: none;\n  user-select: none;\n}\ninput[type=\"submit\"].card-header a.link,\ninput[type=\"submit\"].card-footer a.link,\ninput[type=\"button\"].card-header a.link,\ninput[type=\"button\"].card-footer a.link {\n  width: 100%;\n}\nhtml:not(.watch-active-state) .card-header a.link:active,\nhtml:not(.watch-active-state) .card-footer a.link:active,\n.card-header a.link.active-state,\n.card-footer a.link.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.card-header a.link.button-fill,\n.card-footer a.link.button-fill {\n  background-color: #2196f3;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .card-header a.link.button-fill:active,\nhtml:not(.watch-active-state) .card-footer a.link.button-fill:active,\n.card-header a.link.button-fill.active-state,\n.card-footer a.link.button-fill.active-state {\n  background: #0c82df;\n}\n.card-header a.link.button-big,\n.card-footer a.link.button-big {\n  height: 48px;\n  line-height: 48px;\n  border-radius: 3px;\n}\n.card-header a.link i.icon + span,\n.card-footer a.link i.icon + span,\n.card-header a.link span:not(.ripple-wave) + span,\n.card-footer a.link span:not(.ripple-wave) + span,\n.card-header a.link span:not(.ripple-wave) + i.icon,\n.card-footer a.link span:not(.ripple-wave) + i.icon,\n.card-header a.link i.icon + i.icon,\n.card-footer a.link i.icon + i.icon {\n  margin-left: 8px;\n}\n.navbar .card-header a.link:not(.button-fill),\n.navbar .card-footer a.link:not(.button-fill),\n.toolbar .card-header a.link:not(.button-fill),\n.toolbar .card-footer a.link:not(.button-fill),\n.subnavbar .card-header a.link:not(.button-fill),\n.subnavbar .card-footer a.link:not(.button-fill),\n.notifications .card-header a.link:not(.button-fill),\n.notifications .card-footer a.link:not(.button-fill) {\n  color: #fff;\n}\nhtml:not(.watch-active-state) .navbar .card-header a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .navbar .card-footer a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .toolbar .card-header a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .toolbar .card-footer a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .subnavbar .card-header a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .subnavbar .card-footer a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .notifications .card-header a.link:not(.button-fill):active,\nhtml:not(.watch-active-state) .notifications .card-footer a.link:not(.button-fill):active,\n.navbar .card-header a.link:not(.button-fill).active-state,\n.navbar .card-footer a.link:not(.button-fill).active-state,\n.toolbar .card-header a.link:not(.button-fill).active-state,\n.toolbar .card-footer a.link:not(.button-fill).active-state,\n.subnavbar .card-header a.link:not(.button-fill).active-state,\n.subnavbar .card-footer a.link:not(.button-fill).active-state,\n.notifications .card-header a.link:not(.button-fill).active-state,\n.notifications .card-footer a.link:not(.button-fill).active-state {\n  background: rgba(255, 255, 255, 0.15);\n}\n.card-header a.link i + span,\n.card-footer a.link i + span,\n.card-header a.link i + i,\n.card-footer a.link i + i,\n.card-header a.link span + i,\n.card-footer a.link span + i,\n.card-header a.link span + span,\n.card-footer a.link span + span {\n  margin-left: 7px;\n}\n.card-header a.link i.icon,\n.card-footer a.link i.icon {\n  display: block;\n}\n.card-header a.icon-only,\n.card-footer a.icon-only {\n  min-width: 48px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  margin: 0;\n}\n.card-header {\n  border-radius: 2px 2px 0 0;\n  font-size: 16px;\n}\n.card-header:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #e1e1e1;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .card-header:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .card-header:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.card-header.no-border:after {\n  display: none;\n}\n.card-footer {\n  border-radius: 0 0 2px 2px;\n  color: #757575;\n}\n.card-footer:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #e1e1e1;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .card-footer:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .card-footer:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.card-footer.no-border:before {\n  display: none;\n}\n/* === Modals === */\n.modal-overlay,\n.preloader-indicator-overlay,\n.popup-overlay,\n.picker-modal-overlay {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background: rgba(0, 0, 0, 0.4);\n  z-index: 13000;\n  visibility: hidden;\n  opacity: 0;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.modal-overlay.not-animated,\n.preloader-indicator-overlay.not-animated,\n.popup-overlay.not-animated,\n.picker-modal-overlay.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.modal-overlay.modal-overlay-visible,\n.preloader-indicator-overlay.modal-overlay-visible,\n.popup-overlay.modal-overlay-visible,\n.picker-modal-overlay.modal-overlay-visible {\n  visibility: visible;\n  opacity: 1;\n}\n.popup-overlay {\n  z-index: 10500;\n}\n.picker-modal-overlay {\n  z-index: 12000;\n}\n.modal {\n  width: 280px;\n  position: absolute;\n  z-index: 13500;\n  left: 50%;\n  margin-left: -140px;\n  margin-top: 0;\n  top: 50%;\n  border-radius: 3px;\n  opacity: 0;\n  -webkit-transform: translate3d(0, 0, 0) scale(1.185);\n  transform: translate3d(0, 0, 0) scale(1.185);\n  -webkit-transition-property: -webkit-transform, opacity;\n  -moz-transition-property: -moz-transform, opacity;\n  -ms-transition-property: -ms-transform, opacity;\n  -o-transition-property: -o-transform, opacity;\n  transition-property: transform, opacity;\n  color: #757575;\n  display: none;\n  background: #fff;\n  font-size: 16px;\n  box-shadow: 0 19px 38px rgba(0, 0, 0, 0.3), 0 15px 12px rgba(0, 0, 0, 0.22);\n}\n.modal.modal-in {\n  opacity: 1;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  -webkit-transform: translate3d(0, 0, 0) scale(1);\n  transform: translate3d(0, 0, 0) scale(1);\n}\n.modal.modal-out {\n  opacity: 0;\n  z-index: 13499;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n  -webkit-transform: translate3d(0, 0, 0) scale(0.815);\n  transform: translate3d(0, 0, 0) scale(0.815);\n}\n.modal-inner {\n  padding: 24px 24px 20px;\n  position: relative;\n}\n.modal-title {\n  font-weight: 500;\n  font-size: 20px;\n  color: #212121;\n  line-height: 1.3;\n}\n.modal-title + .modal-text {\n  margin-top: 20px;\n}\n.modal-text {\n  line-height: 1.5;\n}\n.modal-buttons {\n  height: 48px;\n  padding: 6px 8px;\n  overflow: hidden;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: end;\n  -ms-flex-pack: end;\n  -webkit-justify-content: flex-end;\n  justify-content: flex-end;\n}\n.modal-buttons.modal-buttons-vertical {\n  display: block;\n  height: auto;\n  padding: 0 0 8px 0;\n}\n.modal-buttons.modal-buttons-vertical .modal-button {\n  margin-left: 0;\n  text-align: right;\n  height: 48px;\n  line-height: 48px;\n  border-radius: 0;\n  padding-left: 16px;\n  padding-right: 16px;\n}\n.modal-button,\n.modal-buttons .button {\n  color: #2196f3;\n  text-decoration: none;\n  text-align: center;\n  display: block;\n  border-radius: 2px;\n  line-height: 36px;\n  box-sizing: border-box;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  background: none;\n  padding: 0 10px;\n  margin: 0;\n  height: 36px;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  font-size: 14px;\n  text-transform: uppercase;\n  font-family: inherit;\n  cursor: pointer;\n  min-width: 64px;\n  padding: 0 8px;\n  position: relative;\n  overflow: hidden;\n  outline: 0;\n  border: none;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  -webkit-user-select: none;\n  user-select: none;\n}\ninput[type=\"submit\"].modal-button,\ninput[type=\"submit\"].modal-buttons .button,\ninput[type=\"button\"].modal-button,\ninput[type=\"button\"].modal-buttons .button {\n  width: 100%;\n}\nhtml:not(.watch-active-state) .modal-button:active,\nhtml:not(.watch-active-state) .modal-buttons .button:active,\n.modal-button.active-state,\n.modal-buttons .button.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.modal-button.button-fill,\n.modal-buttons .button.button-fill {\n  background-color: #2196f3;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .modal-button.button-fill:active,\nhtml:not(.watch-active-state) .modal-buttons .button.button-fill:active,\n.modal-button.button-fill.active-state,\n.modal-buttons .button.button-fill.active-state {\n  background: #0c82df;\n}\n.modal-button.button-big,\n.modal-buttons .button.button-big {\n  height: 48px;\n  line-height: 48px;\n  border-radius: 3px;\n}\n.modal-button i.icon + span,\n.modal-buttons .button i.icon + span,\n.modal-button span:not(.ripple-wave) + span,\n.modal-buttons .button span:not(.ripple-wave) + span,\n.modal-button span:not(.ripple-wave) + i.icon,\n.modal-buttons .button span:not(.ripple-wave) + i.icon,\n.modal-button i.icon + i.icon,\n.modal-buttons .button i.icon + i.icon {\n  margin-left: 8px;\n}\n.navbar .modal-button:not(.button-fill),\n.navbar .modal-buttons .button:not(.button-fill),\n.toolbar .modal-button:not(.button-fill),\n.toolbar .modal-buttons .button:not(.button-fill),\n.subnavbar .modal-button:not(.button-fill),\n.subnavbar .modal-buttons .button:not(.button-fill),\n.notifications .modal-button:not(.button-fill),\n.notifications .modal-buttons .button:not(.button-fill) {\n  color: #fff;\n}\nhtml:not(.watch-active-state) .navbar .modal-button:not(.button-fill):active,\nhtml:not(.watch-active-state) .navbar .modal-buttons .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .toolbar .modal-button:not(.button-fill):active,\nhtml:not(.watch-active-state) .toolbar .modal-buttons .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .subnavbar .modal-button:not(.button-fill):active,\nhtml:not(.watch-active-state) .subnavbar .modal-buttons .button:not(.button-fill):active,\nhtml:not(.watch-active-state) .notifications .modal-button:not(.button-fill):active,\nhtml:not(.watch-active-state) .notifications .modal-buttons .button:not(.button-fill):active,\n.navbar .modal-button:not(.button-fill).active-state,\n.navbar .modal-buttons .button:not(.button-fill).active-state,\n.toolbar .modal-button:not(.button-fill).active-state,\n.toolbar .modal-buttons .button:not(.button-fill).active-state,\n.subnavbar .modal-button:not(.button-fill).active-state,\n.subnavbar .modal-buttons .button:not(.button-fill).active-state,\n.notifications .modal-button:not(.button-fill).active-state,\n.notifications .modal-buttons .button:not(.button-fill).active-state {\n  background: rgba(255, 255, 255, 0.15);\n}\n.modal-button.modal-button-bold,\n.modal-buttons .button.modal-button-bold {\n  font-weight: 700;\n}\n.modal-button + .modal-button,\n.modal-buttons .button + .modal-button {\n  margin-left: 4px;\n}\n.modal-no-buttons .modal-buttons {\n  display: none;\n}\n.actions-modal {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  z-index: 13500;\n  width: 100%;\n  background: #fff;\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n  max-height: 100%;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n}\n.actions-modal.modal-in,\n.actions-modal.modal-out {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.actions-modal.modal-in.not-animated,\n.actions-modal.modal-out.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.actions-modal.modal-in {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.actions-modal.modal-out {\n  z-index: 13499;\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.actions-modal-group {\n  position: relative;\n}\n.actions-modal-group:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #d2d2d6;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .actions-modal-group:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .actions-modal-group:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.actions-modal-group:last-child:after {\n  display: none;\n}\n.actions-modal-button,\n.actions-modal-label {\n  width: 100%;\n  font-weight: normal;\n  margin: 0;\n  box-sizing: border-box;\n  display: block;\n  position: relative;\n  padding: 0 16px;\n}\n.actions-modal-button a,\n.actions-modal-label a {\n  text-decoration: none;\n  color: inherit;\n  display: block;\n}\n.actions-modal-button b,\n.actions-modal-label b {\n  font-weight: 500;\n}\n.actions-modal-button.actions-modal-button-bold,\n.actions-modal-label.actions-modal-button-bold {\n  font-weight: 500;\n}\n.actions-modal-button.actions-modal-button-red,\n.actions-modal-label.actions-modal-button-red {\n  color: #f44336;\n}\n.actions-modal-button.disabled,\n.actions-modal-label.disabled {\n  opacity: 0.95;\n  color: #9e9e9e;\n}\n.actions-modal-button {\n  cursor: pointer;\n  line-height: 48px;\n  font-size: 16px;\n  color: rgba(0, 0, 0, 0.87);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.actions-modal-button a,\n.actions-modal-button {\n  position: relative;\n  overflow: hidden;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n}\nhtml:not(.watch-active-state) .actions-modal-button:active,\n.actions-modal-button.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.actions-modal-label {\n  font-size: 16px;\n  color: rgba(0, 0, 0, 0.54);\n  min-height: 56px;\n  line-height: 1.3;\n  padding-top: 12px;\n  padding-bottom: 12px;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: start;\n  -ms-flex-pack: start;\n  -webkit-justify-content: flex-start;\n  justify-content: flex-start;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\ninput.modal-text-input {\n  box-sizing: border-box;\n  height: 36px;\n  background: #fff;\n  margin: 0;\n  margin-top: 15px;\n  padding: 0;\n  border: none;\n  width: 100%;\n  font-size: 16px;\n  font-family: inherit;\n  display: block;\n  box-shadow: none;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  appearance: none;\n  -webkit-transition-duration: 200ms;\n  transition-duration: 200ms;\n}\ninput.modal-text-input::-webkit-input-placeholder {\n  color: rgba(0, 0, 0, 0.35);\n}\ninput.modal-text-input + input.modal-text-input {\n  margin-top: 16px;\n}\n.popover {\n  width: 320px;\n  background: #fff;\n  z-index: 13500;\n  margin: 0;\n  top: 0;\n  opacity: 0;\n  left: 0;\n  border-radius: 3px;\n  position: absolute;\n  display: none;\n  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23);\n  -webkit-transform: scale(0.85, 0.6);\n  transform: scale(0.85, 0.6);\n  -webkit-transition-property: opacity, -webkit-transform, border-radius;\n  -moz-transition-property: opacity, -moz-transform, border-radius;\n  transition-property: opacity, transform, border-radius;\n}\n.popover.popover-on-top {\n  -webkit-transform-origin: center bottom;\n  transform-origin: center bottom;\n}\n.popover.popover-on-bottom {\n  -webkit-transform-origin: center top;\n  transform-origin: center top;\n}\n.popover.modal-in,\n.popover.modal-out {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.popover.modal-in.not-animated,\n.popover.modal-out.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.popover.modal-in {\n  -webkit-transform: scale(1);\n  transform: scale(1);\n  opacity: 1;\n}\n.popover.modal-out {\n  -webkit-transform: scale(1);\n  transform: scale(1);\n  opacity: 0;\n}\n.popover .list-block {\n  margin: 0;\n}\n.popover .list-block:first-child:last-child ul:before {\n  display: none;\n}\n.popover .list-block:first-child:last-child ul:after {\n  display: none;\n}\n.popover .list-block ul {\n  background: none;\n}\n.popover .list-block ul:before {\n  display: none;\n}\n.popover .list-block:first-child ul {\n  border-radius: 3px 3px 0 0;\n}\n.popover .list-block:first-child li:first-child a {\n  border-radius: 3px 3px 0 0;\n}\n.popover .list-block:last-child ul {\n  border-radius: 0 0 3px 3px;\n}\n.popover .list-block:last-child ul:after {\n  display: none;\n}\n.popover .list-block:last-child li:last-child a {\n  border-radius: 0 0 3px 3px;\n}\n.popover .list-block:first-child:last-child li:first-child:last-child a,\n.popover .list-block:first-child:last-child ul:first-child:last-child {\n  border-radius: 3px;\n}\n.popover.popover-floating-button {\n  -webkit-transform-origin: center center;\n  transform-origin: center center;\n  -webkit-transform: scale(0.7);\n  transform: scale(0.7);\n  border-radius: 50%;\n  box-shadow: none;\n  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);\n}\n.popover.popover-floating-button.modal-in {\n  border-radius: 0%;\n  -webkit-transform: scale(1);\n  transform: scale(1);\n  -webkit-transition-delay: 200ms;\n  transition-delay: 200ms;\n  -webkit-transition-duration: 200ms;\n  transition-duration: 200ms;\n}\n.popover.popover-floating-button.modal-out {\n  border-radius: 50%;\n  -webkit-transform: scale(0.7);\n  transform: scale(0.7);\n  -webkit-transition-delay: 0ms;\n  transition-delay: 0ms;\n  -webkit-transition-duration: 100ms;\n  transition-duration: 100ms;\n}\n.popover.popover-floating-button .list-block {\n  margin: 0;\n}\n.popover.popover-floating-button .list-block:first-child ul {\n  border-radius: 0;\n}\n.popover.popover-floating-button .list-block:first-child li:first-child a {\n  border-radius: 0;\n}\n.popover.popover-floating-button .list-block:last-child ul {\n  border-radius: 0;\n}\n.popover.popover-floating-button .list-block:last-child li:last-child a {\n  border-radius: 0;\n}\n.popover.popover-floating-button .list-block:first-child:last-child li:first-child:last-child a,\n.popover.popover-floating-button .list-block:first-child:last-child ul:first-child:last-child {\n  border-radius: 0;\n}\n.popover-inner {\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n}\n.actions-popover .list-block {\n  margin: 0;\n}\n.actions-popover-label {\n  padding: 8px 16px;\n  color: rgba(0, 0, 0, 0.54);\n  font-size: 16px;\n  line-height: 1.3;\n  padding-top: 12px;\n  padding-bottom: 12px;\n  position: relative;\n}\n.actions-popover-label:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #d2d2d6;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .actions-popover-label:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .actions-popover-label:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.actions-popover-label:last-child:after {\n  display: none;\n}\n.popup,\n.login-screen {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  z-index: 11000;\n  background: #fff;\n  box-sizing: border-box;\n  display: none;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n  -webkit-transition-property: -webkit-transform;\n  -moz-transition-property: -moz-transform;\n  -ms-transition-property: -ms-transform;\n  -o-transition-property: -o-transform;\n  transition-property: transform;\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.popup.modal-in,\n.login-screen.modal-in,\n.popup.modal-out,\n.login-screen.modal-out {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.popup.modal-in.not-animated,\n.login-screen.modal-in.not-animated,\n.popup.modal-out.not-animated,\n.login-screen.modal-out.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.popup.modal-in,\n.login-screen.modal-in {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.popup.modal-out,\n.login-screen.modal-out {\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.login-screen.modal-in,\n.login-screen.modal-out {\n  display: block;\n}\n@media all and (min-width: 630px) and (min-height: 630px) {\n  .popup:not(.tablet-fullscreen) {\n    width: 630px;\n    height: 630px;\n    left: 50%;\n    top: 50%;\n    margin-left: -315px;\n    margin-top: -315px;\n    box-shadow: 0px 20px 44px rgba(0, 0, 0, 0.5);\n    border-radius: 3px;\n    -webkit-transform: translate3d(0, 1024px, 0);\n    transform: translate3d(0, 1024px, 0);\n  }\n  .popup:not(.tablet-fullscreen).modal-in {\n    -webkit-transform: translate3d(0, 0, 0);\n    transform: translate3d(0, 0, 0);\n  }\n  .popup:not(.tablet-fullscreen).modal-out {\n    -webkit-transform: translate3d(0, 1024px, 0);\n    transform: translate3d(0, 1024px, 0);\n  }\n}\n@media all and (max-width: 629px), (max-height: 629px) {\n  html.with-statusbar-overlay .popup {\n    height: -webkit-calc(100% - 24px);\n    height: calc(100% - 24px);\n    top: 24px;\n  }\n  html.with-statusbar-overlay .popup-overlay {\n    z-index: 9500;\n  }\n  html.with-statusbar-overlay.ios .popup {\n    height: -webkit-calc(100% - 20px);\n    height: calc(100% - 20px);\n    top: 20px;\n  }\n}\nhtml.with-statusbar-overlay .login-screen,\nhtml.with-statusbar-overlay .popup.tablet-fullscreen {\n  height: -webkit-calc(100% - 24px);\n  height: calc(100% - 24px);\n  top: 24px;\n}\nhtml.with-statusbar-overlay.ios .login-screen,\nhtml.with-statusbar-overlay.ios .popup.tablet-fullscreen {\n  height: -webkit-calc(100% - 20px);\n  height: calc(100% - 20px);\n  top: 20px;\n}\n.modal-preloader .modal-title,\n.modal-preloader .modal-inner {\n  text-align: center;\n}\n.preloader-indicator-overlay {\n  visibility: visible;\n  opacity: 0;\n  background: none;\n}\n.preloader-indicator-modal {\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  padding: 8px;\n  margin-left: -24px;\n  margin-top: -24px;\n  background: rgba(0, 0, 0, 0.8);\n  z-index: 13500;\n  border-radius: 4px;\n}\n.preloader-indicator-modal .preloader {\n  display: block;\n}\n.picker-modal {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  width: 100%;\n  height: 260px;\n  z-index: 12000;\n  display: none;\n  -webkit-transition-property: -webkit-transform;\n  -moz-transition-property: -moz-transform;\n  -ms-transition-property: -ms-transform;\n  -o-transition-property: -o-transform;\n  transition-property: transform;\n  background: #fff;\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.picker-modal.modal-in,\n.picker-modal.modal-out {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.picker-modal.modal-in.not-animated,\n.picker-modal.modal-out.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.picker-modal.modal-in {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.picker-modal.modal-out {\n  -webkit-transform: translate3d(0, 100%, 0);\n  transform: translate3d(0, 100%, 0);\n}\n.picker-modal .picker-modal-inner {\n  height: 100%;\n  position: relative;\n}\n.picker-modal .toolbar {\n  position: relative;\n  width: 100%;\n  top: 0;\n}\n.picker-modal .toolbar + .picker-modal-inner {\n  height: -webkit-calc(100% - 48px);\n  height: -moz-calc(100% - 48px);\n  height: calc(100% - 48px);\n}\n.picker-modal .toolbar a.link {\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.picker-modal .picker-header,\n.picker-modal .picker-footer {\n  height: 48px;\n}\n.picker-modal .picker-header {\n  background: #2196f3;\n}\n.picker-modal .picker-header + .toolbar .toolbar-inner {\n  overflow: visible;\n}\n.picker-modal .picker-header + .picker-footer + .toolbar + .picker-modal-inner {\n  height: -webkit-calc(100% - 48px * 3);\n  height: -moz-calc(100% - 48px * 3);\n  height: calc(100% - 48px * 3);\n}\n.picker-modal .picker-footer {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  width: 100%;\n  height: 48px;\n  padding: 6px 8px;\n  overflow: hidden;\n  box-sizing: border-box;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: end;\n  -ms-flex-pack: end;\n  -webkit-justify-content: flex-end;\n  justify-content: flex-end;\n}\n.picker-modal .picker-footer.modal-buttons-vertical {\n  display: block;\n  height: auto;\n  padding: 0 0 8px 0;\n}\n.picker-modal .picker-footer.modal-buttons-vertical .modal-button {\n  margin-left: 0;\n  text-align: right;\n  height: 48px;\n  line-height: 48px;\n  border-radius: 0;\n  padding-left: 16px;\n  padding-right: 16px;\n}\n.picker-modal .picker-header + .picker-modal-inner,\n.picker-modal .picker-footer + .picker-modal-inner {\n  height: -webkit-calc(100% - 48px);\n  height: -moz-calc(100% - 48px);\n  height: calc(100% - 48px);\n}\n.picker-modal .picker-header + .toolbar + .picker-modal-inner,\n.picker-modal .picker-footer + .toolbar + .picker-modal-inner {\n  height: -webkit-calc(100% - 48px * 2);\n  height: -moz-calc(100% - 48px * 2);\n  height: calc(100% - 48px * 2);\n}\n.picker-modal.picker-modal-inline,\n.popover .picker-modal {\n  display: block;\n  position: relative;\n  background: none;\n  z-index: inherit;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.picker-modal.picker-modal-inline .toolbar,\n.popover .picker-modal .toolbar {\n  top: 0;\n}\n.popover .picker-modal {\n  width: auto;\n}\n.popover .picker-modal .toolbar:first-child,\n.popover .picker-modal .picker-header:first-child {\n  border-radius: 2px 2px 0 0;\n}\n.picker-modal.smart-select-picker .list-block {\n  margin: 0;\n}\n.picker-modal.smart-select-picker .list-block ul:before {\n  display: none;\n}\n.picker-modal.smart-select-picker .list-block ul:after {\n  display: none;\n}\n/* === Panels === */\n.panel-overlay {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background: rgba(0, 0, 0, 0.2);\n  opacity: 0;\n  z-index: 5999;\n  display: none;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.panel-overlay.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.panel {\n  z-index: 1000;\n  display: none;\n  background: #fff;\n  box-sizing: border-box;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n  position: absolute;\n  width: 260px;\n  top: 0;\n  height: 100%;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.panel.not-animated {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.panel.panel-visible {\n  display: block;\n}\n.panel.panel-left {\n  left: 0;\n}\n.panel.panel-left.panel-cover {\n  z-index: 6000;\n  -webkit-transform: translate3d(-100%, 0, 0);\n  transform: translate3d(-100%, 0, 0);\n}\n.panel.panel-right {\n  right: 0;\n}\n.panel.panel-right.panel-cover {\n  z-index: 6000;\n  -webkit-transform: translate3d(100%, 0, 0);\n  transform: translate3d(100%, 0, 0);\n}\n.panel.panel-visible-by-breakpoint {\n  display: block;\n  -webkit-transform: translate3d(0, 0, 0) !important;\n  transform: translate3d(0, 0, 0) !important;\n  box-shadow: none !important;\n}\n.panel.panel-visible-by-breakpoint.panel-cover {\n  z-index: 5900;\n}\nbody.with-panel-left-cover .panel,\nbody.with-panel-right-cover .panel {\n  box-shadow: 0px 0px 20px rgba(0, 0, 0, 0.5);\n}\nbody.with-panel-left-cover .views,\nbody.with-panel-right-cover .views {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\nbody.with-panel-left-cover .panel-overlay,\nbody.with-panel-right-cover .panel-overlay {\n  display: block;\n  opacity: 1;\n}\nbody.with-panel-left-reveal .views,\nbody.with-panel-right-reveal .views {\n  box-shadow: 0px 0px 20px rgba(0, 0, 0, 0.5);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transition-property: -webkit-transform, box-shadow;\n  -moz-transition-property: -moz-transform, box-shadow;\n  transition-property: transform, box-shadow;\n}\nbody.with-panel-left-reveal .panel.not-animated ~ .views,\nbody.with-panel-right-reveal .panel.not-animated ~ .views {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\nbody.with-panel-left-reveal .panel-overlay,\nbody.with-panel-right-reveal .panel-overlay {\n  background: rgba(0, 0, 0, 0);\n  display: block;\n  opacity: 0;\n}\nbody.with-panel-left-reveal .views {\n  -webkit-transform: translate3d(260px, 0, 0);\n  transform: translate3d(260px, 0, 0);\n}\nbody.with-panel-left-reveal .panel-overlay {\n  -webkit-transform: translate3d(260px, 0, 0);\n  transform: translate3d(260px, 0, 0);\n}\nbody.with-panel-left-cover .panel.panel-left {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\nbody.with-panel-right-reveal .views {\n  -webkit-transform: translate3d(-260px, 0, 0);\n  transform: translate3d(-260px, 0, 0);\n}\nbody.with-panel-right-reveal .panel-overlay {\n  -webkit-transform: translate3d(-260px, 0, 0);\n  transform: translate3d(-260px, 0, 0);\n}\nbody.with-panel-right-cover .panel.panel-right {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\nbody.panel-closing .panel-overlay {\n  display: block;\n}\nbody.panel-closing .views {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transition-property: -webkit-transform, box-shadow;\n  -moz-transition-property: -moz-transform, box-shadow;\n  transition-property: transform, box-shadow;\n}\nbody.panel-closing .panel.not-animated ~ .views {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n/* === Images Lazy Loading === */\n.lazy-loaded.lazy-fadeIn {\n  -webkit-animation: lazyFadeIn 600ms;\n  animation: lazyFadeIn 600ms;\n}\n@-webkit-keyframes lazyFadeIn {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n@keyframes lazyFadeIn {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n/* === Tabs === */\n.tabs .tab {\n  display: none;\n}\n.tabs .tab.active {\n  display: block;\n}\n.tabs-animated-wrap {\n  position: relative;\n  width: 100%;\n  overflow: hidden;\n  height: 100%;\n}\n.tabs-animated-wrap > .tabs {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  height: 100%;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.tabs-animated-wrap > .tabs > .tab {\n  width: 100%;\n  display: block;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.tabs-animated-wrap.not-animated > .tabs {\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.tabs-swipeable-wrap {\n  height: 100%;\n}\n.tabs-swipeable-wrap > .tabs > .tab {\n  display: block;\n}\n/* === Messages === */\n.messages-content {\n  background: #eee;\n}\n.messages {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -moz-box-orient: vertical;\n  -ms-flex-direction: column;\n  -webkit-flex-direction: column;\n  flex-direction: column;\n}\n.messages-date {\n  text-align: center;\n  font-weight: 500;\n  font-size: 12px;\n  line-height: 1;\n  margin: 10px 15px;\n}\n.messages-date span {\n  font-weight: 400;\n}\n.message {\n  box-sizing: border-box;\n  margin: 0px 8px 8px 8px;\n  max-width: 80%;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -moz-box-orient: vertical;\n  -ms-flex-direction: column;\n  -webkit-flex-direction: column;\n  flex-direction: column;\n}\n.message:first-child {\n  margin-top: 8px;\n}\n.message.message-pic img {\n  display: block;\n}\n.message-name,\n.message-label,\n.message-date,\n.messages-date {\n  color: rgba(0, 0, 0, 0.51);\n}\n.message-name {\n  font-size: 12px;\n  line-height: 1;\n  margin-bottom: 2px;\n  margin-top: 7px;\n}\n.message-hide-name .message-name {\n  display: none;\n}\n.message-label {\n  font-size: 12px;\n  line-height: 1;\n  margin-top: 4px;\n}\n.message-hide-label .message-label {\n  display: none;\n}\n.message-avatar {\n  width: 48px;\n  height: 48px;\n  border-radius: 100%;\n  margin-top: -48px;\n  position: relative;\n  top: 1px;\n  background-size: cover;\n  opacity: 1;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.message-hide-avatar .message-avatar {\n  opacity: 0;\n}\n.message-text {\n  box-sizing: border-box;\n  border-radius: 2px;\n  padding: 6px 8px;\n  min-width: 48px;\n  font-size: 16px;\n  line-height: 1.2;\n  word-break: break-word;\n  color: #333;\n  min-height: 48px;\n  position: relative;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.message-text img {\n  max-width: 100%;\n  height: auto;\n}\n.message-pic .message-text {\n  padding: 8px;\n}\n.message-date {\n  font-size: 12px;\n  margin-top: 4px;\n}\n.message-pic img + .message-date {\n  margin-top: 8px;\n}\n.message-sent {\n  -ms-flex-item-align: end;\n  -webkit-align-self: flex-end;\n  align-self: flex-end;\n  -webkit-box-align: end;\n  -ms-flex-align: end;\n  -webkit-align-items: flex-end;\n  align-items: flex-end;\n}\n.message-sent .message-name,\n.message-sent .message-label {\n  margin-right: 8px;\n}\n.message-sent .message-text {\n  background-color: #C8E6C9;\n  margin-left: auto;\n  border-radius: 2px 2px 0 2px;\n  margin-right: 8px;\n}\n.message-sent .message-text:before {\n  position: absolute;\n  content: '';\n  border-left: 0px solid transparent;\n  border-right: 8px solid transparent;\n  border-bottom: 8px solid #C8E6C9;\n  left: 100%;\n  bottom: 0;\n  width: 0;\n  height: 0;\n}\n.message-sent.message-with-avatar .message-text,\n.message-sent.message-with-avatar .message-name,\n.message-sent.message-with-avatar .message-label {\n  margin-right: 56px;\n}\n.message-received {\n  -ms-flex-item-align: start;\n  -webkit-align-self: flex-start;\n  align-self: flex-start;\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n}\n.message-received .message-text {\n  background-color: #fff;\n  border-radius: 2px 2px 2px 0px;\n  margin-left: 8px;\n}\n.message-received .message-text:before {\n  position: absolute;\n  content: '';\n  border-left: 8px solid transparent;\n  border-right: 0px solid transparent;\n  border-bottom: 8px solid #fff;\n  right: 100%;\n  bottom: 0;\n  width: 0;\n  height: 0;\n}\n.message-received .message-name,\n.message-received .message-label {\n  margin-left: 8px;\n}\n.message-received.message-with-avatar .message-text,\n.message-received.message-with-avatar .message-name,\n.message-received.message-with-avatar .message-label {\n  margin-left: 56px;\n}\n.message-appear-from-bottom {\n  -webkit-animation: messageAppearFromBottom 400ms;\n  animation: messageAppearFromBottom 400ms;\n}\n.message-appear-from-top {\n  -webkit-animation: messageAppearFromTop 400ms;\n  animation: messageAppearFromTop 400ms;\n}\n@-webkit-keyframes messageAppearFromBottom {\n  from {\n    -webkit-transform: translate3d(0, 100%, 0);\n  }\n  to {\n    -webkit-transform: translate3d(0, 0, 0);\n  }\n}\n@keyframes messageAppearFromBottom {\n  from {\n    transform: translate3d(0, 100%, 0);\n  }\n  to {\n    transform: translate3d(0, 0, 0);\n  }\n}\n@-webkit-keyframes messageAppearFromTop {\n  from {\n    -webkit-transform: translate3d(0, -100%, 0);\n  }\n  to {\n    -webkit-transform: translate3d(0, 0, 0);\n  }\n}\n@keyframes messageAppearFromTop {\n  from {\n    transform: translate3d(0, -100%, 0);\n  }\n  to {\n    transform: translate3d(0, 0, 0);\n  }\n}\n/* === Statusbar overlay === */\nhtml.with-statusbar-overlay .framework7-root {\n  padding-top: 24px;\n  box-sizing: border-box;\n}\nhtml.with-statusbar-overlay .framework7-root .statusbar-overlay {\n  display: block;\n}\nhtml.with-statusbar-overlay .framework7-root .panel {\n  padding-top: 24px;\n}\n.statusbar-overlay {\n  background: #0D47A1;\n  z-index: 10000;\n  position: absolute;\n  left: 0;\n  top: 0;\n  height: 24px;\n  width: 100%;\n  display: none;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\nhtml.with-statusbar-overlay.ios .framework7-root {\n  padding-top: 20px;\n}\nhtml.with-statusbar-overlay.ios .framework7-root .panel {\n  padding-top: 20px;\n}\nhtml.ios .statusbar-overlay {\n  height: 20px;\n}\n/* ===\n    Preloader\n    By Rudi Theunissen (https://github.com/rtheunissen/md-preloader)\n=== */\n.preloader {\n  font-size: 0;\n  display: inline-block;\n  width: 32px;\n  height: 32px;\n  -webkit-animation: preloader-outer 3300ms linear infinite;\n  animation: preloader-outer 3300ms linear infinite;\n}\n.preloader svg {\n  width: 100%;\n  height: 100%;\n  -webkit-animation: preloader-inner 1320ms linear infinite;\n  animation: preloader-inner 1320ms linear infinite;\n}\n.preloader svg circle {\n  fill: none;\n  stroke: #757575;\n  stroke-linecap: square;\n  -webkit-animation: preloader-arc 1320ms cubic-bezier(0.8, 0, 0.4, 0.8) infinite;\n  animation: preloader-arc 1320ms cubic-bezier(0.8, 0, 0.4, 0.8) infinite;\n}\n@-webkit-keyframes preloader-outer {\n  0% {\n    -webkit-transform: rotate(0);\n  }\n  100% {\n    -webkit-transform: rotate(360deg);\n  }\n}\n@keyframes preloader-outer {\n  0% {\n    transform: rotate(0);\n  }\n  100% {\n    transform: rotate(360deg);\n  }\n}\n@-webkit-keyframes preloader-inner {\n  0% {\n    -webkit-transform: rotate(-100.8deg);\n  }\n  100% {\n    -webkit-transform: rotate(0);\n  }\n}\n@keyframes preloader-inner {\n  0% {\n    transform: rotate(-100.8deg);\n  }\n  100% {\n    transform: rotate(0);\n  }\n}\n@-webkit-keyframes preloader-arc {\n  0% {\n    stroke-dasharray: 1 210.48670779px;\n    stroke-dashoffset: 0;\n  }\n  40% {\n    stroke-dasharray: 151.55042961px, 210.48670779px;\n    stroke-dashoffset: 0;\n  }\n  100% {\n    stroke-dasharray: 1 210.48670779px;\n    stroke-dashoffset: -151.55042961px;\n  }\n}\n@keyframes preloader-arc {\n  0% {\n    stroke-dasharray: 1 210.48670779px;\n    stroke-dashoffset: 0;\n  }\n  40% {\n    stroke-dasharray: 151.55042961px, 210.48670779px;\n    stroke-dashoffset: 0;\n  }\n  100% {\n    stroke-dasharray: 1 210.48670779px;\n    stroke-dashoffset: -151.55042961px;\n  }\n}\n.preloader-inner {\n  position: relative;\n  display: block;\n  width: 100%;\n  height: 100%;\n  -webkit-animation: preloader-inner-rotate 5.25s cubic-bezier(0.35, 0, 0.25, 1) infinite;\n  animation: preloader-inner-rotate 5.25s cubic-bezier(0.35, 0, 0.25, 1) infinite;\n}\n.preloader-inner .preloader-inner-gap {\n  position: absolute;\n  width: 2px;\n  left: 50%;\n  margin-left: -1px;\n  top: 0;\n  bottom: 0;\n  box-sizing: border-box;\n  border-top: 4px solid #757575;\n}\n.preloader-inner .preloader-inner-left,\n.preloader-inner .preloader-inner-right {\n  position: absolute;\n  top: 0;\n  height: 100%;\n  width: 50%;\n  overflow: hidden;\n}\n.preloader-inner .preloader-inner-half-circle {\n  position: absolute;\n  top: 0;\n  height: 100%;\n  width: 200%;\n  box-sizing: border-box;\n  border: 4px solid #757575;\n  border-bottom-color: transparent !important;\n  border-radius: 50%;\n  -webkit-animation-iteration-count: infinite;\n  -webkit-animation-duration: 1.3125s;\n  -webkit-animation-timing-function: cubic-bezier(0.35, 0, 0.25, 1);\n  animation-iteration-count: infinite;\n  animation-duration: 1.3125s;\n  animation-timing-function: cubic-bezier(0.35, 0, 0.25, 1);\n}\n.preloader-white .preloader-inner .preloader-inner-gap,\n.preloader-white .preloader-inner .preloader-inner-half-circle {\n  border-color: #fff;\n}\n.preloader-inner .preloader-inner-left {\n  left: 0;\n}\n.preloader-inner .preloader-inner-left .preloader-inner-half-circle {\n  left: 0;\n  border-right-color: transparent !important;\n  -webkit-animation-name: preloader-left-rotate;\n  animation-name: preloader-left-rotate;\n}\n.preloader-inner .preloader-inner-right {\n  right: 0;\n}\n.preloader-inner .preloader-inner-right .preloader-inner-half-circle {\n  right: 0;\n  border-left-color: transparent !important;\n  -webkit-animation-name: preloader-right-rotate;\n  animation-name: preloader-right-rotate;\n}\n.color-multi .preloader-inner .preloader-inner-left .preloader-inner-half-circle {\n  -webkit-animation-name: preloader-left-rotate-multicolor;\n  animation-name: preloader-left-rotate-multicolor;\n}\n.color-multi .preloader-inner .preloader-inner-right .preloader-inner-half-circle {\n  -webkit-animation-name: preloader-right-rotate-multicolor;\n  animation-name: preloader-right-rotate-multicolor;\n}\n@-webkit-keyframes preloader-left-rotate {\n  0%,\n  100% {\n    -webkit-transform: rotate(130deg);\n  }\n  50% {\n    -webkit-transform: rotate(-5deg);\n  }\n}\n@keyframes preloader-left-rotate {\n  0%,\n  100% {\n    transform: rotate(130deg);\n  }\n  50% {\n    transform: rotate(-5deg);\n  }\n}\n@-webkit-keyframes preloader-right-rotate {\n  0%,\n  100% {\n    -webkit-transform: rotate(-130deg);\n  }\n  50% {\n    -webkit-transform: rotate(5deg);\n  }\n}\n@keyframes preloader-right-rotate {\n  0%,\n  100% {\n    transform: rotate(-130deg);\n  }\n  50% {\n    transform: rotate(5deg);\n  }\n}\n@-webkit-keyframes preloader-inner-rotate {\n  12.5% {\n    -webkit-transform: rotate(135deg);\n  }\n  25% {\n    -webkit-transform: rotate(270deg);\n  }\n  37.5% {\n    -webkit-transform: rotate(405deg);\n  }\n  50% {\n    -webkit-transform: rotate(540deg);\n  }\n  62.5% {\n    -webkit-transform: rotate(675deg);\n  }\n  75% {\n    -webkit-transform: rotate(810deg);\n  }\n  87.5% {\n    -webkit-transform: rotate(945deg);\n  }\n  100% {\n    -webkit-transform: rotate(1080deg);\n  }\n}\n@keyframes preloader-inner-rotate {\n  12.5% {\n    transform: rotate(135deg);\n  }\n  25% {\n    transform: rotate(270deg);\n  }\n  37.5% {\n    transform: rotate(405deg);\n  }\n  50% {\n    transform: rotate(540deg);\n  }\n  62.5% {\n    transform: rotate(675deg);\n  }\n  75% {\n    transform: rotate(810deg);\n  }\n  87.5% {\n    transform: rotate(945deg);\n  }\n  100% {\n    transform: rotate(1080deg);\n  }\n}\n@-webkit-keyframes preloader-left-rotate-multicolor {\n  0%,\n  100% {\n    border-left-color: #4285F4;\n    -webkit-transform: rotate(130deg);\n  }\n  75% {\n    border-left-color: #1B9A59;\n    border-top-color: #1B9A59;\n  }\n  50% {\n    border-left-color: #F7C223;\n    border-top-color: #F7C223;\n    -webkit-transform: rotate(-5deg);\n  }\n  25% {\n    border-left-color: #DE3E35;\n    border-top-color: #DE3E35;\n  }\n}\n@keyframes preloader-left-rotate-multicolor {\n  0%,\n  100% {\n    border-left-color: #4285F4;\n    transform: rotate(130deg);\n  }\n  75% {\n    border-left-color: #1B9A59;\n    border-top-color: #1B9A59;\n  }\n  50% {\n    border-left-color: #F7C223;\n    border-top-color: #F7C223;\n    transform: rotate(-5deg);\n  }\n  25% {\n    border-left-color: #DE3E35;\n    border-top-color: #DE3E35;\n  }\n}\n@-webkit-keyframes preloader-right-rotate-multicolor {\n  0%,\n  100% {\n    border-right-color: #4285F4;\n    -webkit-transform: rotate(-130deg);\n  }\n  75% {\n    border-right-color: #1B9A59;\n    border-top-color: #1B9A59;\n  }\n  50% {\n    border-right-color: #F7C223;\n    border-top-color: #F7C223;\n    -webkit-transform: rotate(5deg);\n  }\n  25% {\n    border-top-color: #DE3E35;\n    border-right-color: #DE3E35;\n  }\n}\n@keyframes preloader-right-rotate-multicolor {\n  0%,\n  100% {\n    border-right-color: #4285F4;\n    transform: rotate(-130deg);\n  }\n  75% {\n    border-right-color: #1B9A59;\n    border-top-color: #1B9A59;\n  }\n  50% {\n    border-right-color: #F7C223;\n    border-top-color: #F7C223;\n    transform: rotate(5deg);\n  }\n  25% {\n    border-top-color: #DE3E35;\n    border-right-color: #DE3E35;\n  }\n}\n/* === Progress Bar === */\n.progressbar,\n.progressbar-infinite {\n  height: 4px;\n  width: 100%;\n  overflow: hidden;\n  display: block;\n  position: relative;\n  -webkit-transform-origin: center bottom;\n  transform-origin: center bottom;\n  background: rgba(33, 150, 243, 0.5);\n}\n.progressbar {\n  display: block;\n  vertical-align: middle;\n  -webkit-transform-style: preserve-3d;\n  transform-style: preserve-3d;\n}\n.progressbar span {\n  content: '';\n  width: 100%;\n  background: #2196f3;\n  height: 100%;\n  position: absolute;\n  left: 0;\n  top: 0;\n  -webkit-transform: translate3d(-100%, 0, 0);\n  transform: translate3d(-100%, 0, 0);\n  -webkit-transition-duration: 150ms;\n  transition-duration: 150ms;\n}\n.progressbar-infinite {\n  z-index: 15000;\n}\n.progressbar-infinite:before,\n.progressbar-infinite:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background: #2196f3;\n  -webkit-transform-origin: left center;\n  transform-origin: left center;\n}\n.progressbar-infinite:before {\n  -webkit-animation: progressbar-infinite-1 2s linear infinite;\n  animation: progressbar-infinite-1 2s linear infinite;\n}\n.progressbar-infinite:after {\n  -webkit-animation: progressbar-infinite-2 2s linear infinite;\n  animation: progressbar-infinite-2 2s linear infinite;\n}\nhtml.with-statusbar-overlay body > .progressbar-infinite,\nhtml.with-statusbar-overlay .framework7-root > .progressbar-infinite {\n  top: 24px;\n}\nhtml.with-statusbar-overlay.ios body > .progressbar-infinite,\nhtml.with-statusbar-overlay.ios .framework7-root > .progressbar-infinite {\n  top: 20px;\n}\n.progressbar-infinite.color-multi {\n  background: none !important;\n}\n.progressbar-infinite.color-multi:before,\n.progressbar-infinite.color-multi:after {\n  width: 100%;\n  animation: none;\n}\n.progressbar-infinite.color-multi:before {\n  background: none;\n  -webkit-animation: progressbar-infinite-multicolor-bg 3s step-end infinite;\n  animation: progressbar-infinite-multicolor-bg 3s step-end infinite;\n}\n.progressbar-infinite.color-multi:after {\n  background: none;\n  -webkit-animation: progressbar-infinite-multicolor-fill 3s linear infinite;\n  animation: progressbar-infinite-multicolor-fill 3s linear infinite;\n  -webkit-transform-origin: center center;\n  transform-origin: center center;\n}\nbody > .progressbar,\n.view > .progressbar,\n.views > .progressbar,\n.page > .progressbar,\n.panel > .progressbar,\n.popup > .progressbar,\n.framework7-root > .progressbar,\nbody > .progressbar-infinite,\n.view > .progressbar-infinite,\n.views > .progressbar-infinite,\n.page > .progressbar-infinite,\n.panel > .progressbar-infinite,\n.popup > .progressbar-infinite,\n.framework7-root > .progressbar-infinite {\n  position: absolute;\n  left: 0;\n  top: 0;\n  z-index: 15000;\n  -webkit-transform-origin: center top;\n  transform-origin: center top;\n}\n.progressbar-in {\n  -webkit-animation: progressbar-in 300ms forwards;\n  animation: progressbar-in 300ms forwards;\n}\n.progressbar-out {\n  -webkit-animation: progressbar-out 300ms forwards;\n  animation: progressbar-out 300ms forwards;\n}\nhtml.with-statusbar-overlay body > .progressbar,\nhtml.with-statusbar-overlay .framework7-root > .progressbar {\n  top: 24px;\n}\nhtml.with-statusbar-overlay.ios body > .progressbar,\nhtml.with-statusbar-overlay.ios .framework7-root > .progressbar {\n  top: 20px;\n}\n@-webkit-keyframes progressbar-in {\n  from {\n    opacity: 0;\n    -webkit-transform: scaleY(0);\n  }\n  to {\n    opacity: 1;\n    -webkit-transform: scaleY(1);\n  }\n}\n@keyframes progressbar-in {\n  from {\n    opacity: 0;\n    transform: scaleY(0);\n  }\n  to {\n    opacity: 1;\n    transform: scaleY(1);\n  }\n}\n@-webkit-keyframes progressbar-out {\n  from {\n    opacity: 1;\n    -webkit-transform: scaleY(1);\n  }\n  to {\n    opacity: 0;\n    -webkit-transform: scaleY(0);\n  }\n}\n@keyframes progressbar-out {\n  from {\n    opacity: 1;\n    transform: scaleY(1);\n  }\n  to {\n    opacity: 0;\n    transform: scaleY(0);\n  }\n}\n@-webkit-keyframes progressbar-infinite-1 {\n  0% {\n    -webkit-transform: translateX(-10%) scaleX(0.1);\n  }\n  25% {\n    -webkit-transform: translateX(30%) scaleX(0.6);\n  }\n  50% {\n    -webkit-transform: translateX(100%) scaleX(1);\n  }\n  100% {\n    -webkit-transform: translateX(100%) scaleX(1);\n  }\n}\n@keyframes progressbar-infinite-1 {\n  0% {\n    transform: translateX(-10%) scaleX(0.1);\n  }\n  25% {\n    transform: translateX(30%) scaleX(0.6);\n  }\n  50% {\n    transform: translateX(100%) scaleX(1);\n  }\n  100% {\n    transform: translateX(100%) scaleX(1);\n  }\n}\n@-webkit-keyframes progressbar-infinite-2 {\n  0% {\n    -webkit-transform: translateX(-100%) scaleX(1);\n  }\n  40% {\n    -webkit-transform: translateX(-100%) scaleX(1);\n  }\n  75% {\n    -webkit-transform: translateX(60%) scaleX(0.35);\n  }\n  90% {\n    -webkit-transform: translateX(100%) scaleX(0.1);\n  }\n  100% {\n    -webkit-transform: translateX(100%) scaleX(0.1);\n  }\n}\n@keyframes progressbar-infinite-2 {\n  0% {\n    transform: translateX(-100%) scaleX(1);\n  }\n  40% {\n    transform: translateX(-100%) scaleX(1);\n  }\n  75% {\n    transform: translateX(60%) scaleX(0.35);\n  }\n  90% {\n    transform: translateX(100%) scaleX(0.1);\n  }\n  100% {\n    transform: translateX(100%) scaleX(0.1);\n  }\n}\n@-webkit-keyframes progressbar-infinite-multicolor-bg {\n  0% {\n    background-color: #4caf50;\n  }\n  25% {\n    background-color: #f44336;\n  }\n  50% {\n    background-color: #2196f3;\n  }\n  75% {\n    background-color: #ffeb3b;\n  }\n}\n@keyframes progressbar-infinite-multicolor-bg {\n  0% {\n    background-color: #4caf50;\n  }\n  25% {\n    background-color: #f44336;\n  }\n  50% {\n    background-color: #2196f3;\n  }\n  75% {\n    background-color: #ffeb3b;\n  }\n}\n@-webkit-keyframes progressbar-infinite-multicolor-fill {\n  0% {\n    -webkit-transform: scaleX(0);\n    background-color: #f44336;\n  }\n  24.9% {\n    -webkit-transform: scaleX(1);\n    background-color: #f44336;\n  }\n  25% {\n    -webkit-transform: scaleX(0);\n    background-color: #2196f3;\n  }\n  49.9% {\n    -webkit-transform: scaleX(1);\n    background-color: #2196f3;\n  }\n  50% {\n    -webkit-transform: scaleX(0);\n    background-color: #ffeb3b;\n  }\n  74.9% {\n    -webkit-transform: scaleX(1);\n    background-color: #ffeb3b;\n  }\n  75% {\n    -webkit-transform: scaleX(0);\n    background-color: #4caf50;\n  }\n  100% {\n    -webkit-transform: scaleX(1);\n    background-color: #4caf50;\n  }\n}\n@keyframes progressbar-infinite-multicolor-fill {\n  0% {\n    transform: scaleX(0);\n    background-color: #f44336;\n  }\n  24.9% {\n    transform: scaleX(1);\n    background-color: #f44336;\n  }\n  25% {\n    transform: scaleX(0);\n    background-color: #2196f3;\n  }\n  49.9% {\n    transform: scaleX(1);\n    background-color: #2196f3;\n  }\n  50% {\n    transform: scaleX(0);\n    background-color: #ffeb3b;\n  }\n  74.9% {\n    transform: scaleX(1);\n    background-color: #ffeb3b;\n  }\n  75% {\n    transform: scaleX(0);\n    background-color: #4caf50;\n  }\n  100% {\n    transform: scaleX(1);\n    background-color: #4caf50;\n  }\n}\n/* === Pull To Refresh === */\n.pull-to-refresh-layer {\n  position: relative;\n  margin-top: -48px;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 48px;\n}\n.pull-to-refresh-layer .preloader {\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  margin-left: -16px;\n  margin-top: -16px;\n  visibility: hidden;\n}\n.pull-to-refresh-layer .pull-to-refresh-arrow {\n  width: 24px;\n  height: 24px;\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  margin-left: -12px;\n  margin-top: -12px;\n  background: no-repeat center;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'-80%204%2024%2024'%3E%3Cpath%20d%3D'M-69%2C8v12.2l-5.6-5.6L-76%2C16l8%2C8l8-8l-1.4-1.4l-5.6%2C5.6V8H-69z'%20fill%3D'%238c8c8c'%2F%3E%3C%2Fsvg%3E\");\n  z-index: 10;\n  -webkit-transform: rotate(0deg) translate3d(0, 0, 0);\n  transform: rotate(0deg) translate3d(0, 0, 0);\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.pull-to-refresh-content.pull-to-refresh-no-navbar {\n  margin-top: -48px;\n  height: -webkit-calc(100% + 48px);\n  height: -moz-calc(100% + 48px);\n  height: calc(100% + 48px);\n}\n.pull-to-refresh-content.pull-to-refresh-no-navbar .pull-to-refresh-layer {\n  margin-top: 0;\n}\n.pull-to-refresh-content.transitioning,\n.pull-to-refresh-content.refreshing {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.pull-to-refresh-content:not(.refreshing) .pull-to-refresh-layer .preloader {\n  -webkit-animation: none;\n  animation: none;\n}\n.pull-to-refresh-content.refreshing {\n  -webkit-transform: translate3d(0, 48px, 0);\n  transform: translate3d(0, 48px, 0);\n}\n.pull-to-refresh-content.refreshing .pull-to-refresh-arrow {\n  visibility: hidden;\n  -webkit-transition-duration: 0ms;\n  transition-duration: 0ms;\n}\n.pull-to-refresh-content.refreshing .preloader {\n  visibility: visible;\n}\n.pull-to-refresh-content.pull-up .pull-to-refresh-arrow {\n  -webkit-transform: rotate(180deg) translate3d(0, 0, 0);\n  transform: rotate(180deg) translate3d(0, 0, 0);\n}\n/* === Infinite Scroll Preloader === */\n.infinite-scroll-preloader {\n  text-align: center;\n  padding: 8px 0;\n}\n/* === Autocomplete === */\n.autocomplete-page .autocomplete-found {\n  display: block;\n}\n.autocomplete-page .autocomplete-not-found {\n  display: none;\n}\n.autocomplete-page .autocomplete-values {\n  display: block;\n}\n.autocomplete-page .list-block ul:empty {\n  display: none;\n}\n.autocomplete-page .navbar .autocomplete-preloader {\n  margin-right: 16px;\n}\n.autocomplete-preloader:not(.autocomplete-preloader-visible) {\n  -webkit-animation: none;\n  animation: none;\n  visibility: hidden;\n}\n.autocomplete-dropdown {\n  background: #fff;\n  box-sizing: border-box;\n  position: absolute;\n  z-index: 500;\n  box-shadow: 0 2px 2px rgba(0, 0, 0, 0.25);\n  width: 100%;\n  left: 0;\n}\n.autocomplete-dropdown .autocomplete-dropdown-inner {\n  position: relative;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n  height: 100%;\n  z-index: 1;\n}\n.autocomplete-dropdown .autocomplete-preloader {\n  display: none;\n  position: absolute;\n  right: 16px;\n  bottom: 100%;\n  margin-bottom: 8px;\n  width: 20px;\n  height: 20px;\n}\n.autocomplete-dropdown .autocomplete-preloader .preloader-inner-gap,\n.autocomplete-dropdown .autocomplete-preloader .preloader-inner-half-circle {\n  border-width: 3px;\n}\n.autocomplete-dropdown .autocomplete-preloader-visible {\n  display: block;\n}\n.autocomplete-dropdown .autocomplete-dropdown-placeholder {\n  color: #a9a9a9;\n}\n.autocomplete-dropdown .list-block {\n  margin: 0;\n  color: rgba(0, 0, 0, 0.54);\n}\n.autocomplete-dropdown .list-block ul {\n  background: none !important;\n}\n.autocomplete-dropdown .list-block ul:before {\n  display: none;\n}\n.autocomplete-dropdown .list-block ul:after {\n  display: none;\n}\n.autocomplete-dropdown .list-block b {\n  font-weight: normal;\n  color: #212121;\n}\n/* === Timeline === */\n.timeline {\n  margin: 32px 0;\n  padding: 0 16px;\n  box-sizing: border-box;\n}\n.content-block-inner .timeline {\n  padding: 0;\n  margin: 0;\n}\n.timeline-item {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: start;\n  -ms-flex-pack: start;\n  -webkit-justify-content: flex-start;\n  justify-content: flex-start;\n  overflow: hidden;\n  padding: 2px 0px 16px;\n  box-sizing: border-box;\n  position: relative;\n}\n.timeline-item:last-child {\n  padding-bottom: 2px;\n}\n.timeline-item-date {\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  width: 50px;\n  text-align: right;\n  box-sizing: border-box;\n}\n.timeline-item-date small {\n  font-size: 10px;\n}\n.timeline-item-content {\n  margin: 2px;\n  min-width: 0;\n  position: relative;\n  -webkit-box-flex: 10;\n  -webkit-flex-shrink: 10;\n  -ms-flex: 0 10 auto;\n  flex-shrink: 10;\n}\n.timeline-item-content p:first-child,\n.timeline-item-content ul:first-child,\n.timeline-item-content ol:first-child,\n.timeline-item-content h1:first-child,\n.timeline-item-content h2:first-child,\n.timeline-item-content h3:first-child,\n.timeline-item-content h4:first-child {\n  margin-top: 0;\n}\n.timeline-item-content p:last-child,\n.timeline-item-content ul:last-child,\n.timeline-item-content ol:last-child,\n.timeline-item-content h1:last-child,\n.timeline-item-content h2:last-child,\n.timeline-item-content h3:last-child,\n.timeline-item-content h4:last-child {\n  margin-bottom: 0;\n}\n.timeline-item-content .card,\n.timeline-item-content.card,\n.timeline-item-content .list-block,\n.timeline-item-content.list-block,\n.timeline-item-content .content-block,\n.timeline-item-content.content-block {\n  margin: 0;\n  width: 100%;\n}\n.timeline-item-content .card + .card,\n.timeline-item-content .list-block + .card,\n.timeline-item-content .content-block + .card,\n.timeline-item-content .card + .list-block,\n.timeline-item-content .list-block + .list-block,\n.timeline-item-content .content-block + .list-block,\n.timeline-item-content .card + .content-block,\n.timeline-item-content .list-block + .content-block,\n.timeline-item-content .content-block + .content-block {\n  margin: 16px 0 0;\n}\n.timeline-item-inner {\n  border-radius: 2px;\n  padding: 8px 16px;\n  background: #fff;\n  box-sizing: border-box;\n  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);\n}\n.timeline-item-inner .content-block {\n  padding: 0;\n  color: inherit;\n}\n.timeline-item-inner .content-block-inner {\n  padding-left: 0;\n  padding-right: 0;\n  margin: 0;\n}\n.timeline-item-inner .content-block-inner:before {\n  display: none;\n}\n.timeline-item-inner .content-block-inner:after {\n  display: none;\n}\n.timeline-item-inner .list-block ul:before {\n  display: none;\n}\n.timeline-item-inner .list-block ul:after {\n  display: none;\n}\n.timeline-item-inner + .timeline-item-inner {\n  margin-top: 16px;\n}\n.timeline-item-divider {\n  width: 1px;\n  margin: 0 16px;\n  position: relative;\n  width: 10px;\n  height: 10px;\n  background: #bbb;\n  border-radius: 50%;\n  margin-top: 3px;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n}\n.timeline-item-divider:after,\n.timeline-item-divider:before {\n  content: ' ';\n  width: 1px;\n  height: 100vh;\n  position: absolute;\n  left: 50%;\n  background: inherit;\n  -webkit-transform: translate3d(-50%, 0, 0);\n  transform: translate3d(-50%, 0, 0);\n}\n.timeline-item-divider:after {\n  top: 100%;\n}\n.timeline-item-divider:before {\n  bottom: 100%;\n}\n.timeline-item:last-child .timeline-item-divider:after {\n  display: none;\n}\n.timeline-item:first-child .timeline-item-divider:before {\n  display: none;\n}\n.timeline-item-time {\n  color: rgba(0, 0, 0, 0.54);\n  margin-top: 16px;\n  font-size: 13px;\n}\n.timeline-item-time:first-child {\n  margin-top: 0;\n}\n.timeline-item-title + .timeline-item-time {\n  margin-top: 0;\n}\n.timeline-item-title {\n  font-size: 16px;\n}\n.timeline-sides .timeline-item {\n  margin-left: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: 0;\n}\n.timeline-sides .timeline-item .timeline-item-date {\n  text-align: right;\n}\n.timeline-sides .timeline-item:not(.timeline-item-right):nth-child(2n) {\n  -webkit-box-direction: reverse;\n  -moz-box-direction: reverse;\n  -ms-flex-direction: row-reverse;\n  -webkit-flex-direction: row-reverse;\n  flex-direction: row-reverse;\n  margin-right: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: 0;\n}\n.timeline-sides .timeline-item:not(.timeline-item-right):nth-child(2n) .timeline-item-date {\n  text-align: left;\n}\n.timeline-sides .timeline-item-left {\n  -webkit-box-direction: reverse;\n  -moz-box-direction: reverse;\n  -ms-flex-direction: row-reverse;\n  -webkit-flex-direction: row-reverse;\n  flex-direction: row-reverse;\n  margin-right: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: 0;\n}\n.timeline-sides .timeline-item-left .timeline-item-date {\n  text-align: left;\n}\n.timeline-sides .timeline-item-right {\n  margin-left: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n  margin-left: calc(50% - (32px + 10px) / 2 - 50px);\n  margin-right: 0;\n}\n.timeline-sides .timeline-item-right .timeline-item-date {\n  text-align: right;\n}\n@media (min-width: 768px) {\n  .tablet-sides .timeline-item {\n    margin-left: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: 0;\n  }\n  .tablet-sides .timeline-item .timeline-item-date {\n    text-align: right;\n  }\n  .tablet-sides .timeline-item:not(.timeline-item-right):nth-child(2n) {\n    -webkit-box-direction: reverse;\n    -moz-box-direction: reverse;\n    -ms-flex-direction: row-reverse;\n    -webkit-flex-direction: row-reverse;\n    flex-direction: row-reverse;\n    margin-right: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: 0;\n  }\n  .tablet-sides .timeline-item:not(.timeline-item-right):nth-child(2n) .timeline-item-date {\n    text-align: left;\n  }\n  .tablet-sides .timeline-item-left {\n    -webkit-box-direction: reverse;\n    -moz-box-direction: reverse;\n    -ms-flex-direction: row-reverse;\n    -webkit-flex-direction: row-reverse;\n    flex-direction: row-reverse;\n    margin-right: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: 0;\n  }\n  .tablet-sides .timeline-item-left .timeline-item-date {\n    text-align: left;\n  }\n  .tablet-sides .timeline-item-right {\n    margin-left: -moz-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: -webkit-calc(50% - (32px + 10px) / 2 - 50px);\n    margin-left: calc(50% - (32px + 10px) / 2 - 50px);\n    margin-right: 0;\n  }\n  .tablet-sides .timeline-item-right .timeline-item-date {\n    text-align: right;\n  }\n}\n.timeline-horizontal {\n  padding: 0;\n  margin: 0;\n  height: 100%;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  position: relative;\n}\n.timeline-horizontal .timeline-item {\n  display: block;\n  width: 33.33333333vw;\n  margin: 0;\n  padding: 0;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  padding-top: 34px;\n  padding-bottom: 12px;\n  position: relative;\n  height: 100%;\n}\n.timeline-horizontal .timeline-item:after {\n  content: '';\n  position: absolute;\n  right: 0;\n  top: 0;\n  left: auto;\n  bottom: auto;\n  width: 1px;\n  height: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 100% 50%;\n  transform-origin: 100% 50%;\n}\nhtml.pixel-ratio-2 .timeline-horizontal .timeline-item:after {\n  -webkit-transform: scaleX(0.5);\n  transform: scaleX(0.5);\n}\nhtml.pixel-ratio-3 .timeline-horizontal .timeline-item:after {\n  -webkit-transform: scaleX(0.33);\n  transform: scaleX(0.33);\n}\n.timeline-horizontal .timeline-item:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .timeline-horizontal .timeline-item:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .timeline-horizontal .timeline-item:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.timeline-horizontal .timeline-item-date {\n  background: #2196f3;\n  width: auto;\n  text-align: left;\n  padding: 0px 12px;\n  line-height: 34px;\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 34px;\n  color: #fff;\n}\n.timeline-horizontal .timeline-item-date:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .timeline-horizontal .timeline-item-date:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .timeline-horizontal .timeline-item-date:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.timeline-horizontal .timeline-item-content {\n  padding: 12px;\n  overflow: auto;\n  -webkit-overflow-scrolling: touch;\n  margin: 0;\n  height: -webkit-calc(100% - 12px);\n  height: -moz-calc(100% - 12px);\n  height: calc(100% - 12px);\n}\n.timeline-horizontal .timeline-item-divider {\n  display: none;\n}\n.timeline-horizontal.col-100 .timeline-item {\n  width: 100vw;\n}\n.timeline-horizontal.col-95 .timeline-item {\n  width: 95vw;\n}\n.timeline-horizontal.col-90 .timeline-item {\n  width: 90vw;\n}\n.timeline-horizontal.col-85 .timeline-item {\n  width: 85vw;\n}\n.timeline-horizontal.col-80 .timeline-item {\n  width: 80vw;\n}\n.timeline-horizontal.col-75 .timeline-item {\n  width: 75vw;\n}\n.timeline-horizontal.col-70 .timeline-item {\n  width: 70vw;\n}\n.timeline-horizontal.col-66 .timeline-item {\n  width: 66.66666666666666vw;\n}\n.timeline-horizontal.col-65 .timeline-item {\n  width: 65vw;\n}\n.timeline-horizontal.col-60 .timeline-item {\n  width: 60vw;\n}\n.timeline-horizontal.col-55 .timeline-item {\n  width: 55vw;\n}\n.timeline-horizontal.col-50 .timeline-item {\n  width: 50vw;\n}\n.timeline-horizontal.col-45 .timeline-item {\n  width: 45vw;\n}\n.timeline-horizontal.col-40 .timeline-item {\n  width: 40vw;\n}\n.timeline-horizontal.col-35 .timeline-item {\n  width: 35vw;\n}\n.timeline-horizontal.col-33 .timeline-item {\n  width: 33.333333333333336vw;\n}\n.timeline-horizontal.col-30 .timeline-item {\n  width: 30vw;\n}\n.timeline-horizontal.col-25 .timeline-item {\n  width: 25vw;\n}\n.timeline-horizontal.col-20 .timeline-item {\n  width: 20vw;\n}\n.timeline-horizontal.col-15 .timeline-item {\n  width: 15vw;\n}\n.timeline-horizontal.col-10 .timeline-item {\n  width: 10vw;\n}\n.timeline-horizontal.col-5 .timeline-item {\n  width: 5vw;\n}\n@media all and (min-width: 768px) {\n  .timeline-horizontal.tablet-100 .timeline-item {\n    width: 100vw;\n  }\n  .timeline-horizontal.tablet-95 .timeline-item {\n    width: 95vw;\n  }\n  .timeline-horizontal.tablet-90 .timeline-item {\n    width: 90vw;\n  }\n  .timeline-horizontal.tablet-85 .timeline-item {\n    width: 85vw;\n  }\n  .timeline-horizontal.tablet-80 .timeline-item {\n    width: 80vw;\n  }\n  .timeline-horizontal.tablet-75 .timeline-item {\n    width: 75vw;\n  }\n  .timeline-horizontal.tablet-70 .timeline-item {\n    width: 70vw;\n  }\n  .timeline-horizontal.tablet-66 .timeline-item {\n    width: 66.66666666666666vw;\n  }\n  .timeline-horizontal.tablet-65 .timeline-item {\n    width: 65vw;\n  }\n  .timeline-horizontal.tablet-60 .timeline-item {\n    width: 60vw;\n  }\n  .timeline-horizontal.tablet-55 .timeline-item {\n    width: 55vw;\n  }\n  .timeline-horizontal.tablet-50 .timeline-item {\n    width: 50vw;\n  }\n  .timeline-horizontal.tablet-45 .timeline-item {\n    width: 45vw;\n  }\n  .timeline-horizontal.tablet-40 .timeline-item {\n    width: 40vw;\n  }\n  .timeline-horizontal.tablet-35 .timeline-item {\n    width: 35vw;\n  }\n  .timeline-horizontal.tablet-33 .timeline-item {\n    width: 33.333333333333336vw;\n  }\n  .timeline-horizontal.tablet-30 .timeline-item {\n    width: 30vw;\n  }\n  .timeline-horizontal.tablet-25 .timeline-item {\n    width: 25vw;\n  }\n  .timeline-horizontal.tablet-20 .timeline-item {\n    width: 20vw;\n  }\n  .timeline-horizontal.tablet-15 .timeline-item {\n    width: 15vw;\n  }\n  .timeline-horizontal.tablet-10 .timeline-item {\n    width: 10vw;\n  }\n  .timeline-horizontal.tablet-5 .timeline-item {\n    width: 5vw;\n  }\n}\n.timeline-year,\n.timeline-month {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  padding-top: 24px;\n  position: relative;\n  box-sizing: border-box;\n  height: 100%;\n}\n.timeline-year-title,\n.timeline-month-title {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  line-height: 24px;\n  height: 24px;\n  padding: 0 12px;\n  box-sizing: border-box;\n  background: #2196f3;\n  color: #fff;\n}\n.timeline-year-title span,\n.timeline-month-title span {\n  display: inline-block;\n  position: -webkit-sticky;\n  position: -moz-sticky;\n  position: sticky;\n  left: 12px;\n}\n.timeline-year-title {\n  font-size: 16px;\n}\n.timeline-year-title span {\n  margin-top: 2px;\n}\n.timeline-month-title span {\n  margin-top: -2px;\n}\n/* === Swiper === */\n.swiper-container {\n  margin-left: auto;\n  margin-right: auto;\n  position: relative;\n  overflow: hidden;\n  /* Fix of Webkit flickering */\n  z-index: 1;\n}\n.swiper-container-no-flexbox .swiper-slide {\n  float: left;\n}\n.swiper-container-vertical > .swiper-wrapper {\n  -webkit-box-orient: vertical;\n  -moz-box-orient: vertical;\n  -ms-flex-direction: column;\n  -webkit-flex-direction: column;\n  flex-direction: column;\n}\n.swiper-wrapper {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  z-index: 1;\n  display: -webkit-box;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-transition-property: -webkit-transform;\n  -moz-transition-property: -moz-transform;\n  -o-transition-property: -o-transform;\n  -ms-transition-property: -ms-transform;\n  transition-property: transform;\n  -webkit-box-sizing: content-box;\n  -moz-box-sizing: content-box;\n  box-sizing: content-box;\n}\n.swiper-container-android .swiper-slide,\n.swiper-wrapper {\n  -webkit-transform: translate3d(0px, 0, 0);\n  -moz-transform: translate3d(0px, 0, 0);\n  -o-transform: translate(0px, 0px);\n  -ms-transform: translate3d(0px, 0, 0);\n  transform: translate3d(0px, 0, 0);\n}\n.swiper-container-multirow > .swiper-wrapper {\n  -webkit-box-lines: multiple;\n  -moz-box-lines: multiple;\n  -ms-flex-wrap: wrap;\n  -webkit-flex-wrap: wrap;\n  flex-wrap: wrap;\n}\n.swiper-container-free-mode > .swiper-wrapper {\n  -webkit-transition-timing-function: ease-out;\n  -moz-transition-timing-function: ease-out;\n  -ms-transition-timing-function: ease-out;\n  -o-transition-timing-function: ease-out;\n  transition-timing-function: ease-out;\n  margin: 0 auto;\n}\n.swiper-slide {\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  width: 100%;\n  height: 100%;\n  position: relative;\n}\n/* Auto Height */\n.swiper-container-autoheight,\n.swiper-container-autoheight .swiper-slide {\n  height: auto;\n}\n.swiper-container-autoheight .swiper-wrapper {\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n  -webkit-transition-property: -webkit-transform, height;\n  -moz-transition-property: -moz-transform;\n  -o-transition-property: -o-transform;\n  -ms-transition-property: -ms-transform;\n  transition-property: transform, height;\n}\n/* a11y */\n.swiper-container .swiper-notification {\n  position: absolute;\n  left: 0;\n  top: 0;\n  pointer-events: none;\n  opacity: 0;\n  z-index: -1000;\n}\n/* IE10 Windows Phone 8 Fixes */\n.swiper-wp8-horizontal {\n  -ms-touch-action: pan-y;\n  touch-action: pan-y;\n}\n.swiper-wp8-vertical {\n  -ms-touch-action: pan-x;\n  touch-action: pan-x;\n}\n/* Arrows */\n.swiper-button-prev,\n.swiper-button-next {\n  position: absolute;\n  top: 50%;\n  width: 27px;\n  height: 44px;\n  margin-top: -22px;\n  z-index: 10;\n  cursor: pointer;\n  -moz-background-size: 27px 44px;\n  -webkit-background-size: 27px 44px;\n  background-size: 27px 44px;\n  background-position: center;\n  background-repeat: no-repeat;\n}\n.swiper-button-prev.swiper-button-disabled,\n.swiper-button-next.swiper-button-disabled {\n  opacity: 0.35;\n  cursor: auto;\n  pointer-events: none;\n}\n.swiper-button-prev,\n.swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23007aff'%2F%3E%3C%2Fsvg%3E\");\n  left: 10px;\n  right: auto;\n}\n.swiper-button-next,\n.swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23007aff'%2F%3E%3C%2Fsvg%3E\");\n  right: 10px;\n  left: auto;\n}\n/* Pagination Styles */\n.swiper-pagination {\n  position: absolute;\n  text-align: center;\n  -webkit-transition: 300ms;\n  -moz-transition: 300ms;\n  -o-transition: 300ms;\n  transition: 300ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  -ms-transform: translate3d(0, 0, 0);\n  -o-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  z-index: 10;\n}\n.swiper-pagination.swiper-pagination-hidden {\n  opacity: 0;\n}\n/* Common Styles */\n.swiper-pagination-fraction,\n.swiper-pagination-custom,\n.swiper-container-horizontal > .swiper-pagination-bullets {\n  bottom: 10px;\n  left: 0;\n  width: 100%;\n}\n/* Bullets */\n.swiper-pagination-bullet {\n  width: 8px;\n  height: 8px;\n  display: inline-block;\n  border-radius: 100%;\n  background: #000;\n  opacity: 0.2;\n}\nbutton.swiper-pagination-bullet {\n  border: none;\n  margin: 0;\n  padding: 0;\n  box-shadow: none;\n  -moz-appearance: none;\n  -ms-appearance: none;\n  -webkit-appearance: none;\n  appearance: none;\n}\n.swiper-pagination-clickable .swiper-pagination-bullet {\n  cursor: pointer;\n}\n.swiper-pagination-bullet-active {\n  opacity: 1;\n  background: #007aff;\n}\n.swiper-container-vertical > .swiper-pagination-bullets {\n  right: 10px;\n  top: 50%;\n  -webkit-transform: translate3d(0px, -50%, 0);\n  -moz-transform: translate3d(0px, -50%, 0);\n  -o-transform: translate(0px, -50%);\n  -ms-transform: translate3d(0px, -50%, 0);\n  transform: translate3d(0px, -50%, 0);\n}\n.swiper-container-vertical > .swiper-pagination-bullets .swiper-pagination-bullet {\n  margin: 5px 0;\n  display: block;\n}\n.swiper-container-horizontal > .swiper-pagination-bullets .swiper-pagination-bullet {\n  margin: 0 5px;\n}\n/* Progress */\n.swiper-pagination-progress {\n  background: rgba(0, 0, 0, 0.25);\n  position: absolute;\n}\n.swiper-pagination-progress .swiper-pagination-progressbar {\n  background: #007aff;\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  -webkit-transform: scale(0);\n  -ms-transform: scale(0);\n  -o-transform: scale(0);\n  transform: scale(0);\n  -webkit-transform-origin: left top;\n  -moz-transform-origin: left top;\n  -ms-transform-origin: left top;\n  -o-transform-origin: left top;\n  transform-origin: left top;\n}\n.swiper-container-rtl .swiper-pagination-progress .swiper-pagination-progressbar {\n  -webkit-transform-origin: right top;\n  -moz-transform-origin: right top;\n  -ms-transform-origin: right top;\n  -o-transform-origin: right top;\n  transform-origin: right top;\n}\n.swiper-container-horizontal > .swiper-pagination-progress {\n  width: 100%;\n  height: 4px;\n  left: 0;\n  top: 0;\n}\n.swiper-container-vertical > .swiper-pagination-progress {\n  width: 4px;\n  height: 100%;\n  left: 0;\n  top: 0;\n}\n/* 3D Container */\n.swiper-container-3d {\n  -webkit-perspective: 1200px;\n  -moz-perspective: 1200px;\n  -o-perspective: 1200px;\n  perspective: 1200px;\n}\n.swiper-container-3d .swiper-wrapper,\n.swiper-container-3d .swiper-slide,\n.swiper-container-3d .swiper-slide-shadow-left,\n.swiper-container-3d .swiper-slide-shadow-right,\n.swiper-container-3d .swiper-slide-shadow-top,\n.swiper-container-3d .swiper-slide-shadow-bottom,\n.swiper-container-3d .swiper-cube-shadow {\n  -webkit-transform-style: preserve-3d;\n  -moz-transform-style: preserve-3d;\n  -ms-transform-style: preserve-3d;\n  transform-style: preserve-3d;\n}\n.swiper-container-3d .swiper-slide-shadow-left,\n.swiper-container-3d .swiper-slide-shadow-right,\n.swiper-container-3d .swiper-slide-shadow-top,\n.swiper-container-3d .swiper-slide-shadow-bottom {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  pointer-events: none;\n  z-index: 10;\n}\n.swiper-container-3d .swiper-slide-shadow-left {\n  background-image: -webkit-gradient(linear, left top, right top, from(rgba(0, 0, 0, 0.5)), to(rgba(0, 0, 0, 0)));\n  /* Safari 4+, Chrome */\n  background-image: -webkit-linear-gradient(right, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Chrome 10+, Safari 5.1+, iOS 5+ */\n  background-image: -moz-linear-gradient(right, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 3.6-15 */\n  background-image: -o-linear-gradient(right, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Opera 11.10-12.00 */\n  background-image: linear-gradient(to left, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 16+, IE10, Opera 12.50+ */\n}\n.swiper-container-3d .swiper-slide-shadow-right {\n  background-image: -webkit-gradient(linear, right top, left top, from(rgba(0, 0, 0, 0.5)), to(rgba(0, 0, 0, 0)));\n  /* Safari 4+, Chrome */\n  background-image: -webkit-linear-gradient(left, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Chrome 10+, Safari 5.1+, iOS 5+ */\n  background-image: -moz-linear-gradient(left, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 3.6-15 */\n  background-image: -o-linear-gradient(left, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Opera 11.10-12.00 */\n  background-image: linear-gradient(to right, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 16+, IE10, Opera 12.50+ */\n}\n.swiper-container-3d .swiper-slide-shadow-top {\n  background-image: -webkit-gradient(linear, left top, left bottom, from(rgba(0, 0, 0, 0.5)), to(rgba(0, 0, 0, 0)));\n  /* Safari 4+, Chrome */\n  background-image: -webkit-linear-gradient(bottom, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Chrome 10+, Safari 5.1+, iOS 5+ */\n  background-image: -moz-linear-gradient(bottom, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 3.6-15 */\n  background-image: -o-linear-gradient(bottom, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Opera 11.10-12.00 */\n  background-image: linear-gradient(to top, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 16+, IE10, Opera 12.50+ */\n}\n.swiper-container-3d .swiper-slide-shadow-bottom {\n  background-image: -webkit-gradient(linear, left bottom, left top, from(rgba(0, 0, 0, 0.5)), to(rgba(0, 0, 0, 0)));\n  /* Safari 4+, Chrome */\n  background-image: -webkit-linear-gradient(top, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Chrome 10+, Safari 5.1+, iOS 5+ */\n  background-image: -moz-linear-gradient(top, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 3.6-15 */\n  background-image: -o-linear-gradient(top, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Opera 11.10-12.00 */\n  background-image: linear-gradient(to bottom, rgba(0, 0, 0, 0.5), rgba(0, 0, 0, 0));\n  /* Firefox 16+, IE10, Opera 12.50+ */\n}\n/* Coverflow */\n.swiper-container-coverflow .swiper-wrapper,\n.swiper-container-flip .swiper-wrapper {\n  /* Windows 8 IE 10 fix */\n  -ms-perspective: 1200px;\n}\n/* Cube + Flip */\n.swiper-container-cube,\n.swiper-container-flip {\n  overflow: visible;\n}\n.swiper-container-cube .swiper-slide,\n.swiper-container-flip .swiper-slide {\n  pointer-events: none;\n  -webkit-backface-visibility: hidden;\n  -moz-backface-visibility: hidden;\n  -ms-backface-visibility: hidden;\n  backface-visibility: hidden;\n  z-index: 1;\n}\n.swiper-container-cube .swiper-slide .swiper-slide,\n.swiper-container-flip .swiper-slide .swiper-slide {\n  pointer-events: none;\n}\n.swiper-container-cube .swiper-slide-active,\n.swiper-container-flip .swiper-slide-active,\n.swiper-container-cube .swiper-slide-active .swiper-slide-active,\n.swiper-container-flip .swiper-slide-active .swiper-slide-active {\n  pointer-events: auto;\n}\n.swiper-container-cube .swiper-slide-shadow-top,\n.swiper-container-flip .swiper-slide-shadow-top,\n.swiper-container-cube .swiper-slide-shadow-bottom,\n.swiper-container-flip .swiper-slide-shadow-bottom,\n.swiper-container-cube .swiper-slide-shadow-left,\n.swiper-container-flip .swiper-slide-shadow-left,\n.swiper-container-cube .swiper-slide-shadow-right,\n.swiper-container-flip .swiper-slide-shadow-right {\n  z-index: 0;\n  -webkit-backface-visibility: hidden;\n  -moz-backface-visibility: hidden;\n  -ms-backface-visibility: hidden;\n  backface-visibility: hidden;\n}\n/* Cube */\n.swiper-container-cube .swiper-slide {\n  visibility: hidden;\n  -webkit-transform-origin: 0 0;\n  -moz-transform-origin: 0 0;\n  -ms-transform-origin: 0 0;\n  transform-origin: 0 0;\n  width: 100%;\n  height: 100%;\n}\n.swiper-container-cube.swiper-container-rtl .swiper-slide {\n  -webkit-transform-origin: 100% 0;\n  -moz-transform-origin: 100% 0;\n  -ms-transform-origin: 100% 0;\n  transform-origin: 100% 0;\n}\n.swiper-container-cube .swiper-slide-active,\n.swiper-container-cube .swiper-slide-next,\n.swiper-container-cube .swiper-slide-prev,\n.swiper-container-cube .swiper-slide-next + .swiper-slide {\n  pointer-events: auto;\n  visibility: visible;\n}\n.swiper-container-cube .swiper-cube-shadow {\n  position: absolute;\n  left: 0;\n  bottom: 0px;\n  width: 100%;\n  height: 100%;\n  background: #000;\n  opacity: 0.6;\n  -webkit-filter: blur(50px);\n  filter: blur(50px);\n  z-index: 0;\n}\n/* Fade */\n.swiper-container-fade.swiper-container-free-mode .swiper-slide {\n  -webkit-transition-timing-function: ease-out;\n  -moz-transition-timing-function: ease-out;\n  -ms-transition-timing-function: ease-out;\n  -o-transition-timing-function: ease-out;\n  transition-timing-function: ease-out;\n}\n.swiper-container-fade .swiper-slide {\n  pointer-events: none;\n  -webkit-transition-property: opacity;\n  -moz-transition-property: opacity;\n  -o-transition-property: opacity;\n  transition-property: opacity;\n}\n.swiper-container-fade .swiper-slide .swiper-slide {\n  pointer-events: none;\n}\n.swiper-container-fade .swiper-slide-active,\n.swiper-container-fade .swiper-slide-active .swiper-slide-active {\n  pointer-events: auto;\n}\n.swiper-zoom-container {\n  width: 100%;\n  height: 100%;\n  display: -webkit-box;\n  display: -moz-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -moz-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -moz-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  text-align: center;\n}\n.swiper-zoom-container > img,\n.swiper-zoom-container > svg,\n.swiper-zoom-container > canvas {\n  max-width: 100%;\n  max-height: 100%;\n  object-fit: contain;\n}\n/* Scrollbar */\n.swiper-scrollbar {\n  border-radius: 10px;\n  position: relative;\n  -ms-touch-action: none;\n  background: rgba(0, 0, 0, 0.1);\n}\n.swiper-container-horizontal > .swiper-scrollbar {\n  position: absolute;\n  left: 1%;\n  bottom: 3px;\n  z-index: 50;\n  height: 5px;\n  width: 98%;\n}\n.swiper-container-vertical > .swiper-scrollbar {\n  position: absolute;\n  right: 3px;\n  top: 1%;\n  z-index: 50;\n  width: 5px;\n  height: 98%;\n}\n.swiper-scrollbar-drag {\n  height: 100%;\n  width: 100%;\n  position: relative;\n  background: rgba(0, 0, 0, 0.5);\n  border-radius: 10px;\n  left: 0;\n  top: 0;\n}\n.swiper-scrollbar-cursor-drag {\n  cursor: move;\n}\n/* Preloader */\n.swiper-slide .preloader {\n  width: 42px;\n  height: 42px;\n  position: absolute;\n  left: 50%;\n  top: 50%;\n  margin-left: -21px;\n  margin-top: -21px;\n  z-index: 10;\n}\n/* === Photo Browser === */\n.photo-browser {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  z-index: 11500;\n}\nbody > .photo-browser,\n.framework7-root > .photo-browser {\n  opacity: 0;\n  display: none;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\nbody > .photo-browser.photo-browser-in,\n.framework7-root > .photo-browser.photo-browser-in {\n  display: block;\n  -webkit-animation: photoBrowserIn 400ms forwards;\n  animation: photoBrowserIn 400ms forwards;\n}\nbody > .photo-browser.photo-browser-out,\n.framework7-root > .photo-browser.photo-browser-out {\n  display: block;\n  -webkit-animation: photoBrowserOut 400ms forwards;\n  animation: photoBrowserOut 400ms forwards;\n}\nhtml.with-statusbar-overlay body > .photo-browser,\nhtml.with-statusbar-overlay .framework7-root > .photo-browser {\n  height: -webkit-calc(100% - 24px);\n  height: calc(100% - 24px);\n  top: 24px;\n}\nhtml.with-statusbar-overlay.ios body > .photo-browser,\nhtml.with-statusbar-overlay.ios .framework7-root > .photo-browser {\n  height: -webkit-calc(100% - 20px);\n  height: calc(100% - 20px);\n  top: 20px;\n}\n.popup > .photo-browser .navbar,\nbody > .photo-browser .navbar,\n.framework7-root > .photo-browser .navbar,\n.popup > .photo-browser .toolbar,\nbody > .photo-browser .toolbar,\n.framework7-root > .photo-browser .toolbar {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.photo-browser .page[data-page=\"photo-browser-slides\"] {\n  background: none;\n}\n.photo-browser-popup {\n  background: none;\n}\n.photo-browser .navbar,\n.views .view[data-page=\"photo-browser-slides\"] .navbar,\n.photo-browser .toolbar,\n.views .view[data-page=\"photo-browser-slides\"] .toolbar {\n  background: rgba(33, 150, 243, 0.95);\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.view[data-page=\"photo-browser-slides\"] .page[data-page=\"photo-browser-slides\"] .navbar,\n.view[data-page=\"photo-browser-slides\"] .page[data-page=\"photo-browser-slides\"] .toolbar {\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.view[data-page=\"photo-browser-slides\"] .page[data-page=\"photo-browser-slides\"] .toolbar,\n.photo-browser .page[data-page=\"photo-browser-slides\"] .toolbar {\n  bottom: 0;\n  top: auto;\n}\n.photo-browser-exposed .navbar,\n.photo-browser-exposed .toolbar {\n  opacity: 0;\n  visibility: hidden;\n  pointer-events: none;\n}\n.photo-browser-exposed .photo-browser-swiper-container {\n  background: #000;\n}\n.photo-browser-of {\n  margin: 0 5px;\n}\n.photo-browser-captions {\n  pointer-events: none;\n  position: absolute;\n  left: 0;\n  width: 100%;\n  bottom: 0;\n  z-index: 10;\n  opacity: 1;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.photo-browser-captions.photo-browser-captions-exposed {\n  opacity: 0;\n}\n.toolbar ~ .photo-browser-captions {\n  bottom: 48px;\n  -webkit-transform: translate3d(0, 0px, 0);\n  transform: translate3d(0, 0px, 0);\n}\n.photo-browser-exposed .toolbar ~ .photo-browser-captions {\n  -webkit-transform: translate3d(0, 48px, 0);\n  transform: translate3d(0, 48px, 0);\n}\n.toolbar ~ .photo-browser-captions.photo-browser-captions-exposed {\n  -webkit-transform: translate3d(0, 0px, 0);\n  transform: translate3d(0, 0px, 0);\n}\n.photo-browser-caption {\n  box-sizing: border-box;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  position: absolute;\n  bottom: 0;\n  left: 0;\n  opacity: 0;\n  padding: 4px 5px;\n  width: 100%;\n  text-align: center;\n  background: rgba(0, 0, 0, 0.8);\n}\n.photo-browser-caption:empty {\n  display: none;\n}\n.photo-browser-caption.photo-browser-caption-active {\n  opacity: 1;\n}\n.photo-browser-captions-light .photo-browser-caption {\n  background: rgba(255, 255, 255, 0.8);\n}\n.photo-browser-captions-dark .photo-browser-caption {\n  color: #fff;\n}\n.photo-browser-exposed .photo-browser-caption {\n  color: #fff;\n  background: rgba(0, 0, 0, 0.8);\n}\n.photo-browser-swiper-container {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  background: #fff;\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.photo-browser-swiper-wrapper {\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  padding: 0;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n}\n.photo-browser-link-inactive {\n  opacity: 0.3;\n}\n.photo-browser-slide {\n  width: 100%;\n  height: 100%;\n  position: relative;\n  overflow: hidden;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-flex: 0;\n  -webkit-flex-shrink: 0;\n  -ms-flex: 0 0 auto;\n  flex-shrink: 0;\n  box-sizing: border-box;\n}\n.photo-browser-slide.transitioning {\n  -webkit-transition-duration: 400ms;\n  transition-duration: 400ms;\n}\n.photo-browser-slide span.swiper-zoom-container {\n  display: none;\n}\n.photo-browser-slide img {\n  width: auto;\n  height: auto;\n  max-width: 100%;\n  max-height: 100%;\n  display: none;\n}\n.photo-browser-slide.swiper-slide-active span.swiper-zoom-container,\n.photo-browser-slide.swiper-slide-next span.swiper-zoom-container,\n.photo-browser-slide.swiper-slide-prev span.swiper-zoom-container {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n}\n.photo-browser-slide.swiper-slide-active img,\n.photo-browser-slide.swiper-slide-next img,\n.photo-browser-slide.swiper-slide-prev img {\n  display: inline;\n}\n.photo-browser-slide.swiper-slide-active.photo-browser-slide-lazy .preloader,\n.photo-browser-slide.swiper-slide-next.photo-browser-slide-lazy .preloader,\n.photo-browser-slide.swiper-slide-prev.photo-browser-slide-lazy .preloader {\n  display: block;\n}\n.photo-browser-slide iframe {\n  width: 100%;\n  height: 100%;\n}\n.photo-browser-slide .preloader {\n  display: none;\n  position: absolute;\n  width: 42px;\n  height: 42px;\n  margin-left: -21px;\n  margin-top: -21px;\n  left: 50%;\n  top: 50%;\n}\n.photo-browser.photo-browser-dark .navbar,\n.photo-browser.photo-browser-dark .toolbar {\n  background: rgba(30, 30, 30, 0.8);\n  color: #fff;\n}\n.photo-browser.photo-browser-dark .navbar:before,\n.photo-browser.photo-browser-dark .toolbar:before {\n  display: none;\n}\n.photo-browser.photo-browser-dark .navbar:after,\n.photo-browser.photo-browser-dark .toolbar:after {\n  display: none;\n}\n.photo-browser.photo-browser-dark .navbar a,\n.photo-browser.photo-browser-dark .toolbar a {\n  color: #fff;\n}\n.photo-browser.photo-browser-dark .photo-browser-swiper-container {\n  background: #000;\n}\n@-webkit-keyframes photoBrowserIn {\n  0% {\n    -webkit-transform: translate3d(0, 0, 0) scale(0.5);\n    opacity: 0;\n  }\n  100% {\n    -webkit-transform: translate3d(0, 0, 0) scale(1);\n    opacity: 1;\n  }\n}\n@keyframes photoBrowserIn {\n  0% {\n    transform: translate3d(0, 0, 0) scale(0.5);\n    opacity: 0;\n  }\n  100% {\n    transform: translate3d(0, 0, 0) scale(1);\n    opacity: 1;\n  }\n}\n@-webkit-keyframes photoBrowserOut {\n  0% {\n    -webkit-transform: translate3d(0, 0, 0) scale(1);\n    opacity: 1;\n  }\n  100% {\n    -webkit-transform: translate3d(0, 0, 0) scale(0.5);\n    opacity: 0;\n  }\n}\n@keyframes photoBrowserOut {\n  0% {\n    transform: translate3d(0, 0, 0) scale(1);\n    opacity: 1;\n  }\n  100% {\n    transform: translate3d(0, 0, 0) scale(0.5);\n    opacity: 0;\n  }\n}\n/* === Columns Picker === */\n.picker-columns {\n  width: 100%;\n  height: 260px;\n  z-index: 11500;\n}\n.picker-columns.picker-modal-inline {\n  height: 200px;\n}\n@media (orientation: landscape) and (max-height: 415px) {\n  .picker-columns:not(.picker-modal-inline) {\n    height: 200px;\n  }\n}\n.popover.popover-picker-columns {\n  width: 280px;\n}\n.popover.popover-picker-columns .toolbar {\n  border-radius: 2px 2px 0 0;\n}\n.picker-items {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  padding: 0;\n  text-align: right;\n  font-size: 20px;\n  -webkit-mask-box-image: -webkit-linear-gradient(bottom, transparent, transparent 5%, white 20%, white 80%, transparent 95%, transparent);\n  -webkit-mask-box-image: linear-gradient(to top, transparent, transparent 5%, white 20%, white 80%, transparent 95%, transparent);\n}\n.picker-items-col {\n  overflow: hidden;\n  position: relative;\n  max-height: 100%;\n}\n.picker-items-col.picker-items-col-left {\n  text-align: left;\n}\n.picker-items-col.picker-items-col-center {\n  text-align: center;\n}\n.picker-items-col.picker-items-col-right {\n  text-align: right;\n}\n.picker-items-col.picker-items-col-divider {\n  color: rgba(0, 0, 0, 0.87);\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.picker-items-col-wrapper {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transition-timing-function: ease-out;\n  transition-timing-function: ease-out;\n}\n.picker-item {\n  height: 36px;\n  line-height: 36px;\n  white-space: nowrap;\n  position: relative;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  color: rgba(0, 0, 0, 0.54);\n  left: 0;\n  top: 0;\n  width: 100%;\n  box-sizing: border-box;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.picker-item span {\n  padding: 0 10px;\n}\n.picker-items-col-absolute .picker-item {\n  position: absolute;\n}\n.picker-item.picker-item-far {\n  pointer-events: none;\n}\n.picker-item.picker-selected {\n  color: rgba(0, 0, 0, 0.87);\n  -webkit-transform: translate3d(0, 0, 0) rotateX(0deg);\n  transform: translate3d(0, 0, 0) rotateX(0deg);\n}\n.picker-center-highlight {\n  height: 36px;\n  box-sizing: border-box;\n  position: absolute;\n  left: 0;\n  width: 100%;\n  top: 50%;\n  margin-top: -18px;\n  pointer-events: none;\n}\n.picker-center-highlight:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.15);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .picker-center-highlight:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .picker-center-highlight:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.picker-center-highlight:after {\n  content: '';\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  right: auto;\n  top: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.15);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 100%;\n  transform-origin: 50% 100%;\n}\nhtml.pixel-ratio-2 .picker-center-highlight:after {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .picker-center-highlight:after {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\n.picker-3d .picker-items {\n  overflow: hidden;\n  -webkit-perspective: 1200px;\n  perspective: 1200px;\n}\n.picker-3d .picker-items-col,\n.picker-3d .picker-items-col-wrapper,\n.picker-3d .picker-item {\n  -webkit-transform-style: preserve-3d;\n  transform-style: preserve-3d;\n}\n.picker-3d .picker-items-col {\n  overflow: visible;\n}\n.picker-3d .picker-item {\n  -webkit-transform-origin: center center -110px;\n  transform-origin: center center -110px;\n  -webkit-backface-visibility: hidden;\n  backface-visibility: hidden;\n  -webkit-transition-timing-function: ease-out;\n  transition-timing-function: ease-out;\n}\n/* === Calendar === */\n.picker-calendar {\n  background: #fff;\n  height: 420px;\n  overflow: hidden;\n  bottom: auto;\n  width: 90%;\n  left: 50%;\n  top: 50%;\n  min-width: 300px;\n  max-width: 380px;\n  -webkit-transform: translate3d(-50%, 100%, 0);\n  transform: translate3d(-50%, 100%, 0);\n  box-shadow: 0 19px 38px rgba(0, 0, 0, 0.3), 0 15px 12px rgba(0, 0, 0, 0.22);\n}\n@media (orientation: landscape) and (max-height: 460px) {\n  .picker-calendar:not(.picker-modal-inline) {\n    height: -webkit-calc(100% - 40px);\n    height: calc(100% - 40px);\n  }\n}\n.popover-picker-calendar .picker-calendar {\n  height: 420px;\n}\n.picker-calendar .picker-modal-inner {\n  overflow: hidden;\n}\n.picker-calendar.modal-in {\n  -webkit-transform: translate3d(-50%, -50%, 0);\n  transform: translate3d(-50%, -50%, 0);\n}\n.picker-calendar.modal-out {\n  -webkit-transform: translate3d(-50%, 100%, 0);\n  transform: translate3d(-50%, 100%, 0);\n}\n.picker-calendar.picker-modal-inline {\n  height: 300px;\n}\n.picker-calendar.picker-modal-inline,\n.popover-picker-calendar .picker-calendar {\n  -webkit-transform: translate3d(0%, 0%, 0);\n  transform: translate3d(0%, 0%, 0);\n  width: auto;\n  max-width: none;\n  left: 0;\n  top: 0;\n  box-shadow: none;\n}\n.picker-calendar.picker-modal {\n  z-index: 12500;\n}\n.popover.popover-picker-calendar {\n  width: 320px;\n}\n.picker-calendar-selected-date {\n  line-height: 48px;\n  color: #fff;\n  padding: 0 24px;\n  font-size: 20px;\n  position: relative;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n.picker-calendar-week-days {\n  height: 14.28571429%;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  font-size: 12px;\n  box-sizing: border-box;\n  position: relative;\n  color: rgba(0, 0, 0, 0.54);\n}\n.picker-calendar-week-days .picker-calendar-week-day {\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  width: 14.28571429%;\n  width: -webkit-calc(100% / 7);\n  width: -moz-calc(100% / 7);\n  width: calc(100% / 7);\n  text-align: center;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.picker-calendar-week-days + .picker-calendar-months {\n  height: -webkit-calc(100% - 100% / 7);\n  height: -moz-calc(100% - 100% / 7);\n  height: calc(100% - 100% / 7);\n}\n.picker-calendar-months {\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  position: relative;\n}\n.picker-calendar-months-wrapper {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n}\n.picker-calendar-month {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -moz-box-orient: vertical;\n  -ms-flex-direction: column;\n  -webkit-flex-direction: column;\n  flex-direction: column;\n  width: 100%;\n  height: 100%;\n  position: absolute;\n  left: 0;\n  top: 0;\n}\n.picker-calendar-row {\n  height: 16.66666667%;\n  height: -webkit-calc(100% / 6);\n  height: -moz-calc(100% / 6);\n  height: calc(100% / 6);\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  width: 100%;\n  position: relative;\n}\n.picker-calendar-day {\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: center;\n  -ms-flex-pack: center;\n  -webkit-justify-content: center;\n  justify-content: center;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  box-sizing: border-box;\n  width: 14.28571429%;\n  width: -webkit-calc(100% / 7);\n  width: -moz-calc(100% / 7);\n  width: calc(100% / 7);\n  text-align: center;\n  font-size: 12px;\n  cursor: pointer;\n}\n.picker-calendar-day.picker-calendar-day-prev,\n.picker-calendar-day.picker-calendar-day-next {\n  color: #b8b8b8;\n}\n.picker-calendar-day.picker-calendar-day-disabled {\n  color: #d4d4d4;\n  cursor: auto;\n}\n.picker-calendar-day.picker-calendar-day-today span {\n  color: #2196f3;\n}\n.picker-calendar-day.picker-calendar-day-selected span {\n  background: #2196f3;\n  color: #fff;\n}\n.picker-calendar-range .picker-calendar-day.picker-calendar-day-selected span {\n  border-radius: 0;\n  width: 100%;\n}\n.picker-calendar-day.picker-calendar-day-has-events span:after {\n  content: '';\n  width: 4px;\n  height: 4px;\n  border-radius: 50%;\n  background: #2196f3;\n  position: absolute;\n  margin-left: -2px;\n  left: 50%;\n  bottom: 2px;\n}\n.picker-calendar-day.picker-calendar-day-has-events.picker-calendar-day-selected span:after {\n  display: none;\n}\n.picker-calendar-day span {\n  display: inline-block;\n  border-radius: 100%;\n  width: 36px;\n  height: 36px;\n  line-height: 36px;\n  position: relative;\n}\n.picker-calendar-month-picker,\n.picker-calendar-year-picker {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  width: 50%;\n  max-width: 200px;\n  -webkit-box-flex: 10;\n  -webkit-flex-shrink: 10;\n  -ms-flex: 0 10 auto;\n  flex-shrink: 10;\n}\n.picker-calendar-month-picker span,\n.picker-calendar-year-picker span {\n  -webkit-box-flex: 1;\n  -webkit-flex-shrink: 1;\n  -ms-flex: 0 1 auto;\n  flex-shrink: 1;\n  position: relative;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  width: 100%;\n  text-align: center;\n}\n/* === Notifications === */\n.notifications {\n  position: absolute;\n  left: 0;\n  bottom: 0;\n  width: 100%;\n  z-index: 20000;\n  color: #fff;\n  font-size: 14px;\n  margin: 0;\n  border: none;\n  display: none;\n  box-sizing: border-box;\n  max-height: 100%;\n  overflow: hidden;\n  -webkit-overflow-scrolling: touch;\n  -webkit-transition-duration: 450ms;\n  transition-duration: 450ms;\n  -webkit-perspective: 1200px;\n  perspective: 1200px;\n}\n.notifications.list-block > ul {\n  max-width: 568px;\n  background: #323232;\n  margin: 0 auto;\n}\n.notifications.list-block > ul:before {\n  display: none;\n}\n.notifications.list-block > ul:after {\n  display: none;\n}\n.notifications .item-content {\n  -webkit-box-align: start;\n  -ms-flex-align: start;\n  -webkit-align-items: flex-start;\n  align-items: flex-start;\n  padding-left: 24px;\n}\n.notifications .item-title {\n  font-size: 14px;\n  font-weight: normal;\n  white-space: normal;\n  padding-top: 14px;\n  padding-bottom: 14px;\n}\n.notifications .item-inner {\n  padding-right: 24px;\n  padding-top: 0;\n  padding-bottom: 0;\n}\n.notifications .item-inner:after {\n  display: none;\n}\n.notifications .item-after {\n  max-height: none;\n  margin-left: 16px;\n}\n.notifications .button.close-notification {\n  color: #48aeff;\n}\n.notifications .notification-item {\n  margin: 0 auto;\n  -webkit-transition-duration: 450ms;\n  transition-duration: 450ms;\n  -webkit-transition-delay: 100ms;\n  transition-delay: 100ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n  opacity: 1;\n}\n.notifications .notification-hidden {\n  opacity: 0;\n  -webkit-transition-delay: 0ms;\n  transition-delay: 0ms;\n  -webkit-transform: translate3d(0, 0, 0);\n  transform: translate3d(0, 0, 0);\n}\n.notifications .notification-item-removing {\n  -webkit-transition-delay: 0ms;\n  transition-delay: 0ms;\n}\n@media (min-width: 569px) {\n  .notifications.list-block > ul {\n    border-radius: 2px;\n    width: auto;\n    min-width: 288px;\n  }\n}\n/* === Login screen === */\n.login-screen-content {\n  background: #fff;\n}\n.login-screen-content .login-screen-title,\n.login-screen-content .list-block,\n.login-screen-content .content-block,\n.login-screen-content .list-block-label {\n  max-width: 480px;\n  margin: 24px auto;\n}\n.login-screen-content .list-block ul {\n  background: none;\n}\n.login-screen-content .list-block ul:before {\n  display: none;\n}\n.login-screen-content .list-block ul:after {\n  display: none;\n}\n.login-screen-content .list-block-label {\n  text-align: center;\n}\n.navbar-fixed .page .login-screen-content {\n  padding-top: 0;\n}\n.login-screen-title {\n  text-align: center;\n  font-size: 34px;\n}\n/* === Touch ripple === */\n.ripple,\na.floating-button,\n.floating-button > a,\na.link,\na.item-link,\n.button,\n.modal-button,\n.tab-link,\n.label-radio,\n.label-checkbox,\n.actions-modal-button,\n.speed-dial-buttons a {\n  -webkit-user-select: none;\n  user-select: none;\n}\n.ripple-wave {\n  left: 0;\n  top: 0;\n  position: absolute !important;\n  border-radius: 50%;\n  pointer-events: none;\n  z-index: -1;\n  background: rgba(0, 0, 0, 0.1);\n  padding: 0;\n  margin: 0;\n  font-size: 0;\n  -webkit-transform: translate3d(0px, 0px, 0) scale(0);\n  transform: translate3d(0px, 0px, 0) scale(0);\n  -webkit-transition-duration: 1400ms;\n  transition-duration: 1400ms;\n}\n.ripple-wave.ripple-wave-fill {\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  opacity: 0.35;\n}\n.ripple-wave.ripple-wave-out {\n  -webkit-transition-duration: 600ms;\n  transition-duration: 600ms;\n  opacity: 0;\n}\n.button-fill .ripple-wave,\n.picker-calendar-day .ripple-wave {\n  z-index: 1;\n}\n.button-fill .ripple-wave,\n.navbar .ripple-wave,\n.toolbar .ripple-wave,\n.subnavbar .ripple-wave,\n.searchbar .ripple-wave,\n.notifications .ripple-wave,\n.floating-button .ripple-wave,\n.speed-dial-buttons a .ripple-wave {\n  background: rgba(255, 255, 255, 0.3);\n}\n.messagebar .ripple-wave {\n  background: rgba(0, 0, 0, 0.1);\n}\n.data-table .sortable-cell .ripple-wave {\n  z-index: 0;\n}\n.form-checkbox .ripple-wave,\n.form-radio .ripple-wave {\n  background: rgba(33, 150, 243, 0.5);\n  z-index: 0;\n}\n/* === Disabled elements === */\n.disabled,\n[disabled] {\n  opacity: 0.55;\n  pointer-events: none;\n}\n.disabled .disabled,\n.disabled [disabled],\n[disabled] .disabled,\n[disabled] [disabled] {\n  opacity: 1;\n}\n.data-table {\n  overflow-x: auto;\n}\n.data-table table {\n  width: 100%;\n  border: none;\n  padding: 0;\n  margin: 0;\n  border-collapse: collapse;\n  text-align: left;\n}\n.data-table thead {\n  font-size: 12px;\n}\n.data-table thead th,\n.data-table thead td {\n  font-weight: 500;\n  height: 56px;\n  overflow: hidden;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  line-height: 16px;\n}\n.data-table thead th:not(.sortable-active),\n.data-table thead td:not(.sortable-active) {\n  color: rgba(0, 0, 0, 0.54);\n}\n.data-table thead i.icon,\n.data-table thead i.material-icons {\n  font-size: 16px;\n  width: 16px;\n  height: 16px;\n  vertical-align: top;\n}\n.data-table tbody {\n  font-size: 13px;\n}\n.data-table tbody tr.data-table-row-selected {\n  background: #f5f5f5;\n}\n.data-table tbody td {\n  height: 48px;\n}\n.data-table tbody td:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: rgba(0, 0, 0, 0.12);\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .data-table tbody td:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .data-table tbody td:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\nhtml:not(.ios):not(.android) .data-table tbody tr:hover {\n  background: #f5f5f5;\n}\n.data-table th,\n.data-table td {\n  padding: 0;\n  position: relative;\n  padding-left: 28px;\n  padding-right: 28px;\n}\n.data-table th.label-cell,\n.data-table td.label-cell {\n  padding-left: 24px;\n  padding-right: 24px;\n}\n.data-table th:first-child,\n.data-table td:first-child {\n  padding-left: 24px;\n}\n.data-table th:last-child,\n.data-table td:last-child {\n  padding-right: 24px;\n}\n.data-table th.numeric-cell,\n.data-table td.numeric-cell {\n  text-align: right;\n}\n.data-table th.checkbox-cell,\n.data-table td.checkbox-cell {\n  padding-left: 24px;\n  padding-right: 12px;\n  width: 18px;\n  overflow: visible;\n}\n.data-table th.checkbox-cell + td,\n.data-table td.checkbox-cell + td,\n.data-table th.checkbox-cell + th,\n.data-table td.checkbox-cell + th {\n  padding-left: 12px;\n}\n.data-table th.checkbox-cell label + span,\n.data-table td.checkbox-cell label + span {\n  padding-left: 8px;\n}\n.data-table th.actions-cell,\n.data-table td.actions-cell {\n  text-align: right;\n  white-space: nowrap;\n}\n.data-table th.actions-cell a.link,\n.data-table td.actions-cell a.link {\n  color: rgba(0, 0, 0, 0.54);\n  position: relative;\n  z-index: 1;\n  cursor: pointer;\n}\n.data-table th.actions-cell a.link + a.link,\n.data-table td.actions-cell a.link + a.link {\n  margin-left: 24px;\n}\n.data-table th.actions-cell a.icon-only,\n.data-table td.actions-cell a.icon-only {\n  width: 24px;\n  height: 24px;\n  display: inline-block;\n  vertical-align: middle;\n  font-size: 18px;\n  line-height: 24px;\n  text-align: center;\n  font-size: 0;\n}\n.data-table th.actions-cell a.icon-only i,\n.data-table td.actions-cell a.icon-only i {\n  font-size: 18px;\n  vertical-align: middle;\n}\n.data-table .sortable-cell {\n  cursor: pointer;\n  position: relative;\n}\n.data-table .sortable-cell:not(.numeric-cell):after,\n.data-table .sortable-cell.numeric-cell:before {\n  content: '';\n  display: inline-block;\n  vertical-align: top;\n  width: 16px;\n  height: 16px;\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23000000'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M0%200h24v24H0V0z'%20fill%3D'none'%2F%3E%3Cpath%20d%3D'M20%2012l-1.41-1.41L13%2016.17V4h-2v12.17l-5.58-5.59L4%2012l8%208%208-8z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n  background-size: 100% auto;\n  background-position: center;\n  background-repeat: no-repeat;\n  font-size: 0;\n  -webkit-transition-duration: 300ms;\n  transition-duration: 300ms;\n  -webkit-transform: rotate(0);\n  transform: rotate(0);\n  opacity: 0;\n}\nhtml:not(.ios):not(.android) .data-table .sortable-cell:not(.sortable-active):hover:after,\nhtml:not(.ios):not(.android) .data-table .sortable-cell:not(.sortable-active):hover:before {\n  opacity: 0.54;\n}\n.data-table .sortable-cell.sortable-active:after,\n.data-table .sortable-cell.sortable-active:before {\n  opacity: 0.87;\n}\n.data-table .sortable-cell.sortable-desc:after,\n.data-table .sortable-cell.sortable-desc:before {\n  -webkit-transform: rotate(180deg);\n  transform: rotate(180deg);\n}\n.data-table .sortable-cell:not(.numeric-cell):after {\n  margin-left: 8px;\n}\n.data-table .sortable-cell.numeric-cell:before {\n  margin-right: 8px;\n}\n.data-table.card .card-header,\n.card .data-table .card-header,\n.data-table.card .card-footer,\n.card .data-table .card-footer {\n  padding-left: 24px;\n  padding-right: 14px;\n}\n.data-table.card .card-header,\n.card .data-table .card-header {\n  height: 64px;\n}\n.data-table.card .card-footer,\n.card .data-table .card-footer {\n  height: 56px;\n}\n.data-table.card .card-content,\n.card .data-table .card-content {\n  overflow-x: auto;\n}\n.data-table .data-table-title {\n  font-size: 20px;\n}\n.data-table .data-table-links,\n.data-table .data-table-actions {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n}\n.data-table .data-table-links a.link,\n.data-table .data-table-actions a.link {\n  cursor: pointer;\n}\n.data-table .data-table-links a.link + a.link,\n.data-table .data-table-actions a.link + a.link {\n  margin-left: 24px;\n}\n.data-table .data-table-actions {\n  margin-left: auto;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n}\n.data-table .data-table-actions a.link {\n  cursor: pointer;\n  min-width: 0;\n  color: rgba(0, 0, 0, 0.54);\n}\n.data-table .data-table-actions a.link.icon-only {\n  width: 24px;\n  height: 24px;\n  line-height: 1;\n  overflow: visible;\n}\n.data-table .data-table-actions a.link.icon-only.active-state,\nhtml:not(.watch-active-state) .data-table .data-table-actions a.link.icon-only:active {\n  background: none;\n}\n.data-table .data-table-header,\n.data-table .data-table-header-selected {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n  -webkit-box-pack: justify;\n  -ms-flex-pack: justify;\n  -webkit-justify-content: space-between;\n  justify-content: space-between;\n  -webkit-box-align: center;\n  -ms-flex-align: center;\n  -webkit-align-items: center;\n  align-items: center;\n  width: 100%;\n}\n.data-table .card-header > .data-table-header,\n.data-table .card-header > .data-table-header-selected {\n  padding-left: 24px;\n  padding-right: 14px;\n  margin-left: -24px;\n  margin-right: -14px;\n  height: 100%;\n  padding-top: 4px;\n  padding-bottom: 4px;\n}\n.data-table .data-table-header-selected {\n  display: none;\n  background: rgba(33, 150, 243, 0.1);\n}\n.data-table.data-table-has-checked .data-table-header {\n  display: none;\n}\n.data-table.data-table-has-checked .data-table-header-selected {\n  display: -webkit-box;\n  display: -ms-flexbox;\n  display: -webkit-flex;\n  display: flex;\n}\n.data-table .data-table-title-selected {\n  color: #2196f3;\n  font-size: 14px;\n}\n@media (max-width: 480px) and (orientation: portrait) {\n  .data-table.data-table-collapsible thead {\n    display: none;\n  }\n  .data-table.data-table-collapsible tbody,\n  .data-table.data-table-collapsible tr,\n  .data-table.data-table-collapsible td {\n    display: block;\n  }\n  .data-table.data-table-collapsible tr {\n    position: relative;\n  }\n  .data-table.data-table-collapsible tr:before {\n    content: '';\n    position: absolute;\n    left: 0;\n    top: 0;\n    bottom: auto;\n    right: auto;\n    height: 1px;\n    width: 100%;\n    background-color: rgba(0, 0, 0, 0.12);\n    display: block;\n    z-index: 15;\n    -webkit-transform-origin: 50% 0%;\n    transform-origin: 50% 0%;\n  }\n  html.pixel-ratio-2 .data-table.data-table-collapsible tr:before {\n    -webkit-transform: scaleY(0.5);\n    transform: scaleY(0.5);\n  }\n  html.pixel-ratio-3 .data-table.data-table-collapsible tr:before {\n    -webkit-transform: scaleY(0.33);\n    transform: scaleY(0.33);\n  }\n  .data-table.data-table-collapsible tr:hover {\n    background-color: inherit;\n  }\n  .data-table.data-table-collapsible td {\n    text-align: left;\n    padding-left: 16px;\n    padding-right: 16px;\n    display: -webkit-box;\n    display: -ms-flexbox;\n    display: -webkit-flex;\n    display: flex;\n    -ms-flex-line-pack: center;\n    -webkit-align-content: center;\n    align-content: center;\n    -webkit-box-align: center;\n    -ms-flex-align: center;\n    -webkit-align-items: center;\n    align-items: center;\n    -webkit-box-pack: start;\n    -ms-flex-pack: start;\n    -webkit-justify-content: flex-start;\n    justify-content: flex-start;\n  }\n  .data-table.data-table-collapsible td:before {\n    display: none;\n  }\n  .data-table.data-table-collapsible td:not(.checkbox-cell) {\n    font-size: 16px;\n  }\n  .data-table.data-table-collapsible td:not(.checkbox-cell):before {\n    width: 40%;\n    display: block;\n    content: attr(data-collapsible-title);\n    position: relative;\n    height: auto;\n    background: none;\n    -webkit-transform: none !important;\n    transform: none !important;\n    color: rgba(0, 0, 0, 0.54);\n    font-weight: 500;\n    font-size: 12px;\n    margin-right: 16px;\n    line-height: 16px;\n    -webkit-box-flex: 0;\n    -webkit-flex-shrink: 0;\n    -ms-flex: 0 0 auto;\n    flex-shrink: 0;\n  }\n  .data-table.data-table-collapsible td.checkbox-cell {\n    position: absolute;\n    left: 0;\n    top: 0;\n  }\n  .data-table.data-table-collapsible td.checkbox-cell + td {\n    padding-left: 16px;\n  }\n  .data-table.data-table-collapsible td.checkbox-cell ~ td {\n    margin-left: 32px;\n  }\n}\n.data-table .tablet-only,\n.data-table .tablet-landscape-only {\n  display: none;\n}\n@media (min-width: 768px) {\n  .data-table .tablet-only {\n    display: table-cell;\n  }\n}\n@media (min-width: 768px) and (orientation: landscape) {\n  .data-table .tablet-landscape-only {\n    display: table-cell;\n  }\n}\n", ""]);

	// exports


/***/ }),

/***/ 396:
/*!*************************************************!*\
  !*** ./~/framework7/dist/img/i-f7-material.png ***!
  \*************************************************/
/***/ (function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__.p + "ccc2c70bd64673a3fdc669741f749af2.png";

/***/ }),

/***/ 397:
/*!**************************************************************!*\
  !*** ./~/framework7/dist/css/framework7.material.colors.css ***!
  \**************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	// style-loader: Adds some css to the DOM by adding a <style> tag

	// load the styles
	var content = __webpack_require__(/*! !../../../css-loader!./framework7.material.colors.css */ 398);
	if(typeof content === 'string') content = [[module.id, content, '']];
	// add the styles to the DOM
	var update = __webpack_require__(/*! ../../../style-loader/addStyles.js */ 260)(content, {});
	if(content.locals) module.exports = content.locals;
	// Hot Module Replacement
	if(false) {
		// When the styles change, update the <style> tags
		if(!content.locals) {
			module.hot.accept("!!../../../css-loader/index.js!./framework7.material.colors.css", function() {
				var newContent = require("!!../../../css-loader/index.js!./framework7.material.colors.css");
				if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
				update(newContent);
			});
		}
		// When the module is disposed, remove the <style> tags
		module.hot.dispose(function() { update(); });
	}

/***/ }),

/***/ 398:
/*!*****************************************************************************!*\
  !*** ./~/css-loader!./~/framework7/dist/css/framework7.material.colors.css ***!
  \*****************************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	exports = module.exports = __webpack_require__(/*! ../../../css-loader/lib/css-base.js */ 259)();
	// imports


	// module
	exports.push([module.id, "/**\n * Framework7 1.7.1\n * Full featured mobile HTML framework for building iOS & Android apps\n * \n * Google Material Theme\n *\n * http://framework7.io/\n * \n * Copyright 2018, Vladimir Kharlampidi\n * The iDangero.us\n * http://www.idangero.us/\n * \n * Licensed under MIT\n * \n * Released on: April 7, 2018\n */\n/*==========================\nFramework7 Layouts Themes\n==========================*/\n/* === Dark layout === */\n.layout-dark .page,\n.layout-dark .login-screen-content,\n.page.layout-dark,\n.layout-dark .panel,\n.panel.layout-dark {\n  background-color: #222;\n  color: rgba(255, 255, 255, 0.87);\n}\n.layout-dark .content-block-title {\n  color: rgba(255, 255, 255, 0.87);\n}\n.layout-dark .content-block-inner:before {\n  background-color: #393939;\n}\n.layout-dark .content-block-inner:after {\n  background-color: #393939;\n}\n.layout-dark .popover .list-block ul {\n  background: none;\n}\n.layout-dark .card {\n  background: #1c1c1c;\n}\n.layout-dark .card-header:after {\n  background-color: #393939;\n}\n.layout-dark .card-footer {\n  color: #bbb;\n}\n.layout-dark .card-footer:before {\n  background-color: #393939;\n}\n.layout-dark .list-block ul:before,\n.list-block.layout-dark ul:before {\n  background-color: #393939;\n}\n.layout-dark .list-block ul:after,\n.list-block.layout-dark ul:after {\n  background-color: #393939;\n}\n.layout-dark .list-block.inset ul,\n.list-block.layout-dark.inset ul {\n  background: #1c1c1c;\n}\n.layout-dark .list-block.notifications > ul,\n.list-block.layout-dark.notifications > ul {\n  background: none;\n}\n.layout-dark li.sorting {\n  background-color: rgba(34, 34, 34, 0.8);\n}\n.layout-dark .swipeout-actions-left a,\n.layout-dark .swipeout-actions-right a {\n  background-color: #444;\n}\n.layout-dark .item-inner:after,\n.layout-dark .list-block ul ul li:last-child .item-inner:after {\n  background-color: #393939;\n}\n.layout-dark .item-after,\n.layout-dark .item-text {\n  color: rgba(255, 255, 255, 0.7);\n}\n.layout-dark .list-block-label {\n  color: #bbb;\n}\n.layout-dark .item-divider,\n.layout-dark .list-group-title {\n  background: #1a1a1a;\n  color: #bbb;\n}\n.layout-dark .item-divider:before,\n.layout-dark .list-group-title:before {\n  background-color: #393939;\n}\n.layout-dark .contacts-block .list-group-title {\n  background: none;\n}\n.layout-dark .autocomplete-dropdown {\n  background: #1c1c1c;\n}\n.layout-dark .autocomplete-dropdown .list-block {\n  color: rgba(255, 255, 255, 0.54);\n}\n.layout-dark .autocomplete-dropdown .list-block b {\n  color: rgba(255, 255, 255, 0.87);\n}\nhtml:not(.watch-active-state) .layout-dark .item-link:active,\nhtml:not(.watch-active-state) .layout-dark label.label-checkbox:active,\nhtml:not(.watch-active-state) .layout-dark label.label-radio:active,\n.layout-dark .item-link.active-state,\n.layout-dark label.label-checkbox.active-state,\n.layout-dark label.label-radio.active-state {\n  background-color: rgba(255, 255, 255, 0.05);\n}\n.layout-dark .list-block input[type=\"text\"],\n.layout-dark .list-block input[type=\"password\"],\n.layout-dark .list-block input[type=\"search\"],\n.layout-dark .list-block input[type=\"email\"],\n.layout-dark .list-block input[type=\"tel\"],\n.layout-dark .list-block input[type=\"url\"],\n.layout-dark .list-block input[type=\"date\"],\n.layout-dark .list-block input[type=\"datetime-local\"],\n.layout-dark .list-block input[type=\"time\"],\n.layout-dark .list-block input[type=\"number\"],\n.layout-dark .list-block select,\n.layout-dark .list-block textarea {\n  color: #fff;\n}\n.layout-dark .list-block input[type=\"text\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"password\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"search\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"email\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"tel\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"url\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"date\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"datetime-local\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"time\"]::-webkit-input-placeholder,\n.layout-dark .list-block input[type=\"number\"]::-webkit-input-placeholder,\n.layout-dark .list-block select::-webkit-input-placeholder,\n.layout-dark .list-block textarea::-webkit-input-placeholder {\n  color: rgba(255, 255, 255, 0.35);\n}\n.layout-dark .label-switch .checkbox {\n  background: rgba(255, 255, 255, 0.3);\n}\n.layout-dark .item-inner:not(.focus-state) .label,\n.layout-dark .item-inner:not(.focus-state) .floating-label {\n  color: rgba(255, 255, 255, 0.7);\n}\n.layout-dark .item-inner:not(.focus-state):not(.not-empty-state) .item-input-field:after,\n.layout-dark .item-inner:not(.focus-state):not(.not-empty-state) .input-field:after {\n  background-color: rgba(255, 255, 255, 0.12);\n}\n.layout-dark label.label-checkbox i.icon-form-checkbox {\n  border-color: rgba(255, 255, 255, 0.7);\n}\n.layout-dark label.label-radio i.icon-form-radio {\n  border-color: rgba(255, 255, 255, 0.7);\n}\n.layout-dark .item-link.list-button:after,\n.layout-dark .list-button:after {\n  background-color: #393939;\n}\n.layout-dark .page-content .ripple-wave {\n  background: rgba(255, 255, 255, 0.3);\n}\nhtml:not(.watch-active-state) .layout-dark .button:not(.button-fill):active,\n.layout-dark .button:not(.button-fill).active-state {\n  background: rgba(255, 255, 255, 0.1);\n}\n.layout-dark .chip {\n  background: rgba(255, 255, 255, 0.87);\n}\n.layout-dark .timeline-item-inner {\n  background: #1c1c1c;\n}\n.layout-dark .timeline-item-divider {\n  background: rgba(255, 255, 255, 0.3);\n}\n.layout-dark .content-block-inner .timeline-item-inner {\n  border-color: #393939;\n}\n.layout-dark .timeline-item-time {\n  color: rgba(255, 255, 255, 0.7);\n}\n.layout-dark .data-table tbody tr.data-table-row-selected {\n  background: rgba(255, 255, 255, 0.05);\n}\n.layout-dark .data-table tbody td:before {\n  content: '';\n  position: absolute;\n  left: 0;\n  top: 0;\n  bottom: auto;\n  right: auto;\n  height: 1px;\n  width: 100%;\n  background-color: #393939;\n  display: block;\n  z-index: 15;\n  -webkit-transform-origin: 50% 0%;\n  transform-origin: 50% 0%;\n}\nhtml.pixel-ratio-2 .layout-dark .data-table tbody td:before {\n  -webkit-transform: scaleY(0.5);\n  transform: scaleY(0.5);\n}\nhtml.pixel-ratio-3 .layout-dark .data-table tbody td:before {\n  -webkit-transform: scaleY(0.33);\n  transform: scaleY(0.33);\n}\nhtml:not(.ios):not(.android) .layout-dark .data-table tbody tr:hover {\n  background: rgba(255, 255, 255, 0.05);\n}\n.layout-dark .data-table thead th:not(.sortable-active),\n.layout-dark .data-table thead td:not(.sortable-active) {\n  color: rgba(255, 255, 255, 0.5);\n}\n.layout-dark .data-table th.actions-cell a.link,\n.layout-dark .data-table td.actions-cell a.link {\n  color: rgba(255, 255, 255, 0.5);\n}\n.layout-dark .data-table .sortable-cell:not(.numeric-cell):after,\n.layout-dark .data-table .sortable-cell.numeric-cell:before {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20fill%3D'%23ffffff'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%20width%3D'24'%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%3E%3Cpath%20d%3D'M0%200h24v24H0V0z'%20fill%3D'none'%2F%3E%3Cpath%20d%3D'M20%2012l-1.41-1.41L13%2016.17V4h-2v12.17l-5.58-5.59L4%2012l8%208%208-8z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\n.layout-dark .data-table .data-table-actions a.link {\n  color: rgba(255, 255, 255, 0.5);\n}\n@media (max-width: 480px) and (orientation: portrait) {\n  .layout-dark .data-table.data-table-collapsible tr:before {\n    content: '';\n    position: absolute;\n    left: 0;\n    top: 0;\n    bottom: auto;\n    right: auto;\n    height: 1px;\n    width: 100%;\n    background-color: #393939;\n    display: block;\n    z-index: 15;\n    -webkit-transform-origin: 50% 0%;\n    transform-origin: 50% 0%;\n  }\n  html.pixel-ratio-2 .layout-dark .data-table.data-table-collapsible tr:before {\n    -webkit-transform: scaleY(0.5);\n    transform: scaleY(0.5);\n  }\n  html.pixel-ratio-3 .layout-dark .data-table.data-table-collapsible tr:before {\n    -webkit-transform: scaleY(0.33);\n    transform: scaleY(0.33);\n  }\n  .layout-dark .data-table.data-table-collapsible tr:hover {\n    background-color: inherit;\n  }\n  .layout-dark .data-table.data-table-collapsible td:not(.checkbox-cell):before {\n    color: rgba(255, 255, 255, 0.5);\n  }\n}\n/*==========================\nFramework7 Color Themes\n==========================*/\n.theme-red .button:not(.button-fill) {\n  color: #f44336;\n}\n.theme-red .navbar .button:not(.button-fill),\n.theme-red.navbar .button:not(.button-fill),\n.theme-red .toolbar .button:not(.button-fill),\n.theme-red.toolbar .button:not(.button-fill),\n.theme-red .subnavbar .button:not(.button-fill),\n.theme-red.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-red .button.button-fill {\n  background: #f44336;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-red .button.button-fill:active,\n.theme-red .button.button-fill.active-state {\n  background: #D32F2F;\n}\n.progressbar.theme-red,\n.theme-red .progressbar {\n  background-color: rgba(244, 67, 54, 0.5);\n}\n.progressbar.theme-red span,\n.theme-red .progressbar span {\n  background-color: #f44336;\n}\n.progressbar-infinite.theme-red,\n.theme-red .progressbar-infinite {\n  background-color: rgba(244, 67, 54, 0.5);\n}\n.progressbar-infinite.theme-red:after,\n.theme-red .progressbar-infinite:after,\n.progressbar-infinite.theme-red:before,\n.theme-red .progressbar-infinite:before {\n  background-color: #f44336;\n}\n.color-red i.icon,\ni.icon.color-red {\n  color: #f44336;\n}\ni.icon-next.color-red,\ni.icon-next.theme-red {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23f44336'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-red,\ni.icon-prev.theme-red {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23f44336'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-red,\ni.icon-back.theme-red {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23f44336'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-red,\ni.icon-forward.theme-red {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23f44336'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-red,\ni.icon-bars.theme-red {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23f44336'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-red a,\n.theme-red .card a {\n  color: #f44336;\n}\n.theme-red .navbar,\n.navbar.theme-red,\n.theme-red .toolbar,\n.toolbar.theme-red,\n.theme-red .subnavbar,\n.subnavbar.theme-red,\n.theme-red .searchbar,\n.searchbar.theme-red {\n  background-color: #f44336;\n}\n.theme-red .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-red input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(244, 67, 54, 0.5);\n}\n.theme-red .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-red input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #f44336;\n}\n.theme-red label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-red i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-red label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-red label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-red label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-red label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-red label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-red label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-red input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #f44336;\n  background-color: #f44336;\n}\n.theme-red label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-red i.icon-form-radio:after {\n  background-color: #f44336;\n}\n.theme-red label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-red label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-red label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-red label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-red label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-red label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #f44336;\n}\n.theme-red label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-red label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-red label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-red label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-red label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-red label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-red input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #f44336;\n}\n.theme-red .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-red input[type=\"checkbox\"]:checked ~ i {\n  border-color: #f44336;\n  background-color: #f44336;\n}\n.theme-red .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-red input[type=\"radio\"]:checked ~ i {\n  border-color: #f44336;\n}\n.theme-red .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-red input[type=\"radio\"]:checked ~ i:after {\n  background-color: #f44336;\n}\n.theme-red .form-checkbox .ripple-wave,\n.theme-red .form-radio .ripple-wave {\n  background: rgba(244, 67, 54, 0.5);\n}\n.theme-red .focus-state .label,\n.theme-red .focus-state .floating-label {\n  color: #f44336;\n}\n.theme-red .item-input-field.focus-state:after,\n.theme-red .input-field.focus-state:after,\n.theme-red .item-input-field.not-empty-state:after,\n.theme-red .input-field.not-empty-state:after {\n  background: #f44336;\n}\n.theme-red .picker-calendar-day.picker-calendar-day-today span {\n  color: #f44336;\n}\n.theme-red .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #f44336;\n  color: #fff;\n}\n.theme-red .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #f44336;\n}\n.theme-red .picker-header {\n  background-color: #f44336;\n}\n.theme-red .modal-button {\n  color: #f44336;\n}\n.theme-red .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-red .timeline-item-date {\n  background-color: #f44336;\n}\n.theme-red .timeline-year-title,\n.theme-red .timeline-month-title {\n  background-color: #f44336;\n}\n.theme-red .statusbar-overlay {\n  background-color: #B71C1C;\n}\n.theme-red .data-table .data-table-header-selected,\n.data-table.theme-red .data-table-header-selected {\n  background: rgba(244, 67, 54, 0.1);\n}\n.theme-red .data-table .data-table-title-selected,\n.data-table.theme-red .data-table-title-selected {\n  color: #f44336;\n}\n.swiper-pagination.color-red .swiper-pagination-bullet-active,\n.theme-red .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #f44336;\n}\n.swiper-pagination.color-red .swiper-pagination-progressbar,\n.theme-red .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #f44336;\n}\n.swiper-pagination.swiper-pagination-progress.bg-red {\n  background-color: rgba(244, 67, 54, 0.25);\n}\n.swiper-button-next.color-red,\n.swiper-container-rtl .swiper-button-prev.color-red,\n.theme-red .swiper-button-next,\n.theme-red .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23f44336'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-red,\n.swiper-container-rtl .swiper-button-next.color-red,\n.theme-red .swiper-button-prev,\n.theme-red .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23f44336'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-red .floating-button,\n.theme-red .speed-dial-buttons a,\n.floating-button.theme-red,\n.speed-dial-buttons a.theme-red {\n  color: #fff;\n  background: #f44336;\n}\nhtml:not(.watch-active-state) .theme-red .floating-button:active,\nhtml:not(.watch-active-state) .theme-red .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-red:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-red:active,\n.theme-red .floating-button.active-state,\n.theme-red .speed-dial-buttons a.active-state,\n.floating-button.theme-red.active-state,\n.speed-dial-buttons a.theme-red.active-state {\n  background: #D32F2F;\n}\n.theme-red .floating-button i,\n.theme-red .speed-dial-buttons a i,\n.floating-button.theme-red i,\n.speed-dial-buttons a.theme-red i {\n  color: inherit;\n}\n.theme-red .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-red input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #f44336;\n}\n.theme-red .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-red input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #f44336;\n}\n.theme-red .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-red input[type=\"range\"]::-ms-thumb {\n  background-color: #f44336;\n}\n.theme-red .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-red input[type=\"range\"]::-ms-fill-lower {\n  background-color: #f44336;\n}\n.theme-red .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-red input[type=\"range\"]::-moz-range-thumb {\n  background-color: #f44336;\n}\n.badge.theme-red {\n  background-color: #f44336;\n  color: #fff;\n}\n.theme-pink .button:not(.button-fill) {\n  color: #e91e63;\n}\n.theme-pink .navbar .button:not(.button-fill),\n.theme-pink.navbar .button:not(.button-fill),\n.theme-pink .toolbar .button:not(.button-fill),\n.theme-pink.toolbar .button:not(.button-fill),\n.theme-pink .subnavbar .button:not(.button-fill),\n.theme-pink.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-pink .button.button-fill {\n  background: #e91e63;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-pink .button.button-fill:active,\n.theme-pink .button.button-fill.active-state {\n  background: #C2185B;\n}\n.progressbar.theme-pink,\n.theme-pink .progressbar {\n  background-color: rgba(233, 30, 99, 0.5);\n}\n.progressbar.theme-pink span,\n.theme-pink .progressbar span {\n  background-color: #e91e63;\n}\n.progressbar-infinite.theme-pink,\n.theme-pink .progressbar-infinite {\n  background-color: rgba(233, 30, 99, 0.5);\n}\n.progressbar-infinite.theme-pink:after,\n.theme-pink .progressbar-infinite:after,\n.progressbar-infinite.theme-pink:before,\n.theme-pink .progressbar-infinite:before {\n  background-color: #e91e63;\n}\n.color-pink i.icon,\ni.icon.color-pink {\n  color: #e91e63;\n}\ni.icon-next.color-pink,\ni.icon-next.theme-pink {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23e91e63'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-pink,\ni.icon-prev.theme-pink {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23e91e63'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-pink,\ni.icon-back.theme-pink {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23e91e63'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-pink,\ni.icon-forward.theme-pink {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23e91e63'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-pink,\ni.icon-bars.theme-pink {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23e91e63'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-pink a,\n.theme-pink .card a {\n  color: #e91e63;\n}\n.theme-pink .navbar,\n.navbar.theme-pink,\n.theme-pink .toolbar,\n.toolbar.theme-pink,\n.theme-pink .subnavbar,\n.subnavbar.theme-pink,\n.theme-pink .searchbar,\n.searchbar.theme-pink {\n  background-color: #e91e63;\n}\n.theme-pink .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-pink input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(233, 30, 99, 0.5);\n}\n.theme-pink .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-pink input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #e91e63;\n}\n.theme-pink label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-pink i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-pink label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-pink label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-pink label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-pink label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-pink label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-pink label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-pink input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #e91e63;\n  background-color: #e91e63;\n}\n.theme-pink label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-pink i.icon-form-radio:after {\n  background-color: #e91e63;\n}\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-pink label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-pink label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-pink label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #e91e63;\n}\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-pink label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-pink label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-pink label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-pink label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-pink input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #e91e63;\n}\n.theme-pink .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-pink input[type=\"checkbox\"]:checked ~ i {\n  border-color: #e91e63;\n  background-color: #e91e63;\n}\n.theme-pink .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-pink input[type=\"radio\"]:checked ~ i {\n  border-color: #e91e63;\n}\n.theme-pink .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-pink input[type=\"radio\"]:checked ~ i:after {\n  background-color: #e91e63;\n}\n.theme-pink .form-checkbox .ripple-wave,\n.theme-pink .form-radio .ripple-wave {\n  background: rgba(233, 30, 99, 0.5);\n}\n.theme-pink .focus-state .label,\n.theme-pink .focus-state .floating-label {\n  color: #e91e63;\n}\n.theme-pink .item-input-field.focus-state:after,\n.theme-pink .input-field.focus-state:after,\n.theme-pink .item-input-field.not-empty-state:after,\n.theme-pink .input-field.not-empty-state:after {\n  background: #e91e63;\n}\n.theme-pink .picker-calendar-day.picker-calendar-day-today span {\n  color: #e91e63;\n}\n.theme-pink .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #e91e63;\n  color: #fff;\n}\n.theme-pink .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #e91e63;\n}\n.theme-pink .picker-header {\n  background-color: #e91e63;\n}\n.theme-pink .modal-button {\n  color: #e91e63;\n}\n.theme-pink .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-pink .timeline-item-date {\n  background-color: #e91e63;\n}\n.theme-pink .timeline-year-title,\n.theme-pink .timeline-month-title {\n  background-color: #e91e63;\n}\n.theme-pink .statusbar-overlay {\n  background-color: #880E4F;\n}\n.theme-pink .data-table .data-table-header-selected,\n.data-table.theme-pink .data-table-header-selected {\n  background: rgba(233, 30, 99, 0.1);\n}\n.theme-pink .data-table .data-table-title-selected,\n.data-table.theme-pink .data-table-title-selected {\n  color: #e91e63;\n}\n.swiper-pagination.color-pink .swiper-pagination-bullet-active,\n.theme-pink .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #e91e63;\n}\n.swiper-pagination.color-pink .swiper-pagination-progressbar,\n.theme-pink .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #e91e63;\n}\n.swiper-pagination.swiper-pagination-progress.bg-pink {\n  background-color: rgba(233, 30, 99, 0.25);\n}\n.swiper-button-next.color-pink,\n.swiper-container-rtl .swiper-button-prev.color-pink,\n.theme-pink .swiper-button-next,\n.theme-pink .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23e91e63'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-pink,\n.swiper-container-rtl .swiper-button-next.color-pink,\n.theme-pink .swiper-button-prev,\n.theme-pink .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23e91e63'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-pink .floating-button,\n.theme-pink .speed-dial-buttons a,\n.floating-button.theme-pink,\n.speed-dial-buttons a.theme-pink {\n  color: #fff;\n  background: #e91e63;\n}\nhtml:not(.watch-active-state) .theme-pink .floating-button:active,\nhtml:not(.watch-active-state) .theme-pink .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-pink:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-pink:active,\n.theme-pink .floating-button.active-state,\n.theme-pink .speed-dial-buttons a.active-state,\n.floating-button.theme-pink.active-state,\n.speed-dial-buttons a.theme-pink.active-state {\n  background: #C2185B;\n}\n.theme-pink .floating-button i,\n.theme-pink .speed-dial-buttons a i,\n.floating-button.theme-pink i,\n.speed-dial-buttons a.theme-pink i {\n  color: inherit;\n}\n.theme-pink .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-pink input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #e91e63;\n}\n.theme-pink .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-pink input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #e91e63;\n}\n.theme-pink .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-pink input[type=\"range\"]::-ms-thumb {\n  background-color: #e91e63;\n}\n.theme-pink .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-pink input[type=\"range\"]::-ms-fill-lower {\n  background-color: #e91e63;\n}\n.theme-pink .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-pink input[type=\"range\"]::-moz-range-thumb {\n  background-color: #e91e63;\n}\n.badge.theme-pink {\n  background-color: #e91e63;\n  color: #fff;\n}\n.theme-purple .button:not(.button-fill) {\n  color: #9c27b0;\n}\n.theme-purple .navbar .button:not(.button-fill),\n.theme-purple.navbar .button:not(.button-fill),\n.theme-purple .toolbar .button:not(.button-fill),\n.theme-purple.toolbar .button:not(.button-fill),\n.theme-purple .subnavbar .button:not(.button-fill),\n.theme-purple.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-purple .button.button-fill {\n  background: #9c27b0;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-purple .button.button-fill:active,\n.theme-purple .button.button-fill.active-state {\n  background: #7B1FA2;\n}\n.progressbar.theme-purple,\n.theme-purple .progressbar {\n  background-color: rgba(156, 39, 176, 0.5);\n}\n.progressbar.theme-purple span,\n.theme-purple .progressbar span {\n  background-color: #9c27b0;\n}\n.progressbar-infinite.theme-purple,\n.theme-purple .progressbar-infinite {\n  background-color: rgba(156, 39, 176, 0.5);\n}\n.progressbar-infinite.theme-purple:after,\n.theme-purple .progressbar-infinite:after,\n.progressbar-infinite.theme-purple:before,\n.theme-purple .progressbar-infinite:before {\n  background-color: #9c27b0;\n}\n.color-purple i.icon,\ni.icon.color-purple {\n  color: #9c27b0;\n}\ni.icon-next.color-purple,\ni.icon-next.theme-purple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%239c27b0'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-purple,\ni.icon-prev.theme-purple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%239c27b0'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-purple,\ni.icon-back.theme-purple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%239c27b0'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-purple,\ni.icon-forward.theme-purple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%239c27b0'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-purple,\ni.icon-bars.theme-purple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%239c27b0'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-purple a,\n.theme-purple .card a {\n  color: #9c27b0;\n}\n.theme-purple .navbar,\n.navbar.theme-purple,\n.theme-purple .toolbar,\n.toolbar.theme-purple,\n.theme-purple .subnavbar,\n.subnavbar.theme-purple,\n.theme-purple .searchbar,\n.searchbar.theme-purple {\n  background-color: #9c27b0;\n}\n.theme-purple .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-purple input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(156, 39, 176, 0.5);\n}\n.theme-purple .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-purple input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #9c27b0;\n}\n.theme-purple label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-purple i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-purple label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-purple label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-purple label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-purple label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-purple label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-purple label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-purple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #9c27b0;\n  background-color: #9c27b0;\n}\n.theme-purple label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-purple i.icon-form-radio:after {\n  background-color: #9c27b0;\n}\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-purple label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-purple label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-purple label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #9c27b0;\n}\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-purple label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-purple label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-purple label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-purple label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-purple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #9c27b0;\n}\n.theme-purple .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-purple input[type=\"checkbox\"]:checked ~ i {\n  border-color: #9c27b0;\n  background-color: #9c27b0;\n}\n.theme-purple .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-purple input[type=\"radio\"]:checked ~ i {\n  border-color: #9c27b0;\n}\n.theme-purple .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-purple input[type=\"radio\"]:checked ~ i:after {\n  background-color: #9c27b0;\n}\n.theme-purple .form-checkbox .ripple-wave,\n.theme-purple .form-radio .ripple-wave {\n  background: rgba(156, 39, 176, 0.5);\n}\n.theme-purple .focus-state .label,\n.theme-purple .focus-state .floating-label {\n  color: #9c27b0;\n}\n.theme-purple .item-input-field.focus-state:after,\n.theme-purple .input-field.focus-state:after,\n.theme-purple .item-input-field.not-empty-state:after,\n.theme-purple .input-field.not-empty-state:after {\n  background: #9c27b0;\n}\n.theme-purple .picker-calendar-day.picker-calendar-day-today span {\n  color: #9c27b0;\n}\n.theme-purple .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #9c27b0;\n  color: #fff;\n}\n.theme-purple .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #9c27b0;\n}\n.theme-purple .picker-header {\n  background-color: #9c27b0;\n}\n.theme-purple .modal-button {\n  color: #9c27b0;\n}\n.theme-purple .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-purple .timeline-item-date {\n  background-color: #9c27b0;\n}\n.theme-purple .timeline-year-title,\n.theme-purple .timeline-month-title {\n  background-color: #9c27b0;\n}\n.theme-purple .statusbar-overlay {\n  background-color: #4A148C;\n}\n.theme-purple .data-table .data-table-header-selected,\n.data-table.theme-purple .data-table-header-selected {\n  background: rgba(156, 39, 176, 0.1);\n}\n.theme-purple .data-table .data-table-title-selected,\n.data-table.theme-purple .data-table-title-selected {\n  color: #9c27b0;\n}\n.swiper-pagination.color-purple .swiper-pagination-bullet-active,\n.theme-purple .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #9c27b0;\n}\n.swiper-pagination.color-purple .swiper-pagination-progressbar,\n.theme-purple .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #9c27b0;\n}\n.swiper-pagination.swiper-pagination-progress.bg-purple {\n  background-color: rgba(156, 39, 176, 0.25);\n}\n.swiper-button-next.color-purple,\n.swiper-container-rtl .swiper-button-prev.color-purple,\n.theme-purple .swiper-button-next,\n.theme-purple .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%239c27b0'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-purple,\n.swiper-container-rtl .swiper-button-next.color-purple,\n.theme-purple .swiper-button-prev,\n.theme-purple .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%239c27b0'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-purple .floating-button,\n.theme-purple .speed-dial-buttons a,\n.floating-button.theme-purple,\n.speed-dial-buttons a.theme-purple {\n  color: #fff;\n  background: #9c27b0;\n}\nhtml:not(.watch-active-state) .theme-purple .floating-button:active,\nhtml:not(.watch-active-state) .theme-purple .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-purple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-purple:active,\n.theme-purple .floating-button.active-state,\n.theme-purple .speed-dial-buttons a.active-state,\n.floating-button.theme-purple.active-state,\n.speed-dial-buttons a.theme-purple.active-state {\n  background: #7B1FA2;\n}\n.theme-purple .floating-button i,\n.theme-purple .speed-dial-buttons a i,\n.floating-button.theme-purple i,\n.speed-dial-buttons a.theme-purple i {\n  color: inherit;\n}\n.theme-purple .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-purple input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #9c27b0;\n}\n.theme-purple .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-purple input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #9c27b0;\n}\n.theme-purple .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-purple input[type=\"range\"]::-ms-thumb {\n  background-color: #9c27b0;\n}\n.theme-purple .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-purple input[type=\"range\"]::-ms-fill-lower {\n  background-color: #9c27b0;\n}\n.theme-purple .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-purple input[type=\"range\"]::-moz-range-thumb {\n  background-color: #9c27b0;\n}\n.badge.theme-purple {\n  background-color: #9c27b0;\n  color: #fff;\n}\n.theme-deeppurple .button:not(.button-fill) {\n  color: #673ab7;\n}\n.theme-deeppurple .navbar .button:not(.button-fill),\n.theme-deeppurple.navbar .button:not(.button-fill),\n.theme-deeppurple .toolbar .button:not(.button-fill),\n.theme-deeppurple.toolbar .button:not(.button-fill),\n.theme-deeppurple .subnavbar .button:not(.button-fill),\n.theme-deeppurple.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-deeppurple .button.button-fill {\n  background: #673ab7;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-deeppurple .button.button-fill:active,\n.theme-deeppurple .button.button-fill.active-state {\n  background: #512DA8;\n}\n.progressbar.theme-deeppurple,\n.theme-deeppurple .progressbar {\n  background-color: rgba(103, 58, 183, 0.5);\n}\n.progressbar.theme-deeppurple span,\n.theme-deeppurple .progressbar span {\n  background-color: #673ab7;\n}\n.progressbar-infinite.theme-deeppurple,\n.theme-deeppurple .progressbar-infinite {\n  background-color: rgba(103, 58, 183, 0.5);\n}\n.progressbar-infinite.theme-deeppurple:after,\n.theme-deeppurple .progressbar-infinite:after,\n.progressbar-infinite.theme-deeppurple:before,\n.theme-deeppurple .progressbar-infinite:before {\n  background-color: #673ab7;\n}\n.color-deeppurple i.icon,\ni.icon.color-deeppurple {\n  color: #673ab7;\n}\ni.icon-next.color-deeppurple,\ni.icon-next.theme-deeppurple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23673ab7'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-deeppurple,\ni.icon-prev.theme-deeppurple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23673ab7'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-deeppurple,\ni.icon-back.theme-deeppurple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23673ab7'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-deeppurple,\ni.icon-forward.theme-deeppurple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23673ab7'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-deeppurple,\ni.icon-bars.theme-deeppurple {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23673ab7'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeppurple a,\n.theme-deeppurple .card a {\n  color: #673ab7;\n}\n.theme-deeppurple .navbar,\n.navbar.theme-deeppurple,\n.theme-deeppurple .toolbar,\n.toolbar.theme-deeppurple,\n.theme-deeppurple .subnavbar,\n.subnavbar.theme-deeppurple,\n.theme-deeppurple .searchbar,\n.searchbar.theme-deeppurple {\n  background-color: #673ab7;\n}\n.theme-deeppurple .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-deeppurple input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(103, 58, 183, 0.5);\n}\n.theme-deeppurple .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-deeppurple input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #673ab7;\n}\n.theme-deeppurple label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-deeppurple i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeppurple label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-deeppurple label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-deeppurple label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-deeppurple label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-deeppurple label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-deeppurple label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeppurple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #673ab7;\n  background-color: #673ab7;\n}\n.theme-deeppurple label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple i.icon-form-radio:after {\n  background-color: #673ab7;\n}\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #673ab7;\n}\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-deeppurple label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-deeppurple label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-deeppurple input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #673ab7;\n}\n.theme-deeppurple .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-deeppurple input[type=\"checkbox\"]:checked ~ i {\n  border-color: #673ab7;\n  background-color: #673ab7;\n}\n.theme-deeppurple .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-deeppurple input[type=\"radio\"]:checked ~ i {\n  border-color: #673ab7;\n}\n.theme-deeppurple .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-deeppurple input[type=\"radio\"]:checked ~ i:after {\n  background-color: #673ab7;\n}\n.theme-deeppurple .form-checkbox .ripple-wave,\n.theme-deeppurple .form-radio .ripple-wave {\n  background: rgba(103, 58, 183, 0.5);\n}\n.theme-deeppurple .focus-state .label,\n.theme-deeppurple .focus-state .floating-label {\n  color: #673ab7;\n}\n.theme-deeppurple .item-input-field.focus-state:after,\n.theme-deeppurple .input-field.focus-state:after,\n.theme-deeppurple .item-input-field.not-empty-state:after,\n.theme-deeppurple .input-field.not-empty-state:after {\n  background: #673ab7;\n}\n.theme-deeppurple .picker-calendar-day.picker-calendar-day-today span {\n  color: #673ab7;\n}\n.theme-deeppurple .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #673ab7;\n  color: #fff;\n}\n.theme-deeppurple .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #673ab7;\n}\n.theme-deeppurple .picker-header {\n  background-color: #673ab7;\n}\n.theme-deeppurple .modal-button {\n  color: #673ab7;\n}\n.theme-deeppurple .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-deeppurple .timeline-item-date {\n  background-color: #673ab7;\n}\n.theme-deeppurple .timeline-year-title,\n.theme-deeppurple .timeline-month-title {\n  background-color: #673ab7;\n}\n.theme-deeppurple .statusbar-overlay {\n  background-color: #311B92;\n}\n.theme-deeppurple .data-table .data-table-header-selected,\n.data-table.theme-deeppurple .data-table-header-selected {\n  background: rgba(103, 58, 183, 0.1);\n}\n.theme-deeppurple .data-table .data-table-title-selected,\n.data-table.theme-deeppurple .data-table-title-selected {\n  color: #673ab7;\n}\n.swiper-pagination.color-deeppurple .swiper-pagination-bullet-active,\n.theme-deeppurple .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #673ab7;\n}\n.swiper-pagination.color-deeppurple .swiper-pagination-progressbar,\n.theme-deeppurple .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #673ab7;\n}\n.swiper-pagination.swiper-pagination-progress.bg-deeppurple {\n  background-color: rgba(103, 58, 183, 0.25);\n}\n.swiper-button-next.color-deeppurple,\n.swiper-container-rtl .swiper-button-prev.color-deeppurple,\n.theme-deeppurple .swiper-button-next,\n.theme-deeppurple .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23673ab7'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-deeppurple,\n.swiper-container-rtl .swiper-button-next.color-deeppurple,\n.theme-deeppurple .swiper-button-prev,\n.theme-deeppurple .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23673ab7'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeppurple .floating-button,\n.theme-deeppurple .speed-dial-buttons a,\n.floating-button.theme-deeppurple,\n.speed-dial-buttons a.theme-deeppurple {\n  color: #fff;\n  background: #673ab7;\n}\nhtml:not(.watch-active-state) .theme-deeppurple .floating-button:active,\nhtml:not(.watch-active-state) .theme-deeppurple .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-deeppurple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-deeppurple:active,\n.theme-deeppurple .floating-button.active-state,\n.theme-deeppurple .speed-dial-buttons a.active-state,\n.floating-button.theme-deeppurple.active-state,\n.speed-dial-buttons a.theme-deeppurple.active-state {\n  background: #512DA8;\n}\n.theme-deeppurple .floating-button i,\n.theme-deeppurple .speed-dial-buttons a i,\n.floating-button.theme-deeppurple i,\n.speed-dial-buttons a.theme-deeppurple i {\n  color: inherit;\n}\n.theme-deeppurple .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-deeppurple input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #673ab7;\n}\n.theme-deeppurple .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-deeppurple input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #673ab7;\n}\n.theme-deeppurple .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-deeppurple input[type=\"range\"]::-ms-thumb {\n  background-color: #673ab7;\n}\n.theme-deeppurple .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-deeppurple input[type=\"range\"]::-ms-fill-lower {\n  background-color: #673ab7;\n}\n.theme-deeppurple .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-deeppurple input[type=\"range\"]::-moz-range-thumb {\n  background-color: #673ab7;\n}\n.badge.theme-deeppurple {\n  background-color: #673ab7;\n  color: #fff;\n}\n.theme-indigo .button:not(.button-fill) {\n  color: #3f51b5;\n}\n.theme-indigo .navbar .button:not(.button-fill),\n.theme-indigo.navbar .button:not(.button-fill),\n.theme-indigo .toolbar .button:not(.button-fill),\n.theme-indigo.toolbar .button:not(.button-fill),\n.theme-indigo .subnavbar .button:not(.button-fill),\n.theme-indigo.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-indigo .button.button-fill {\n  background: #3f51b5;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-indigo .button.button-fill:active,\n.theme-indigo .button.button-fill.active-state {\n  background: #303F9F;\n}\n.progressbar.theme-indigo,\n.theme-indigo .progressbar {\n  background-color: rgba(63, 81, 181, 0.5);\n}\n.progressbar.theme-indigo span,\n.theme-indigo .progressbar span {\n  background-color: #3f51b5;\n}\n.progressbar-infinite.theme-indigo,\n.theme-indigo .progressbar-infinite {\n  background-color: rgba(63, 81, 181, 0.5);\n}\n.progressbar-infinite.theme-indigo:after,\n.theme-indigo .progressbar-infinite:after,\n.progressbar-infinite.theme-indigo:before,\n.theme-indigo .progressbar-infinite:before {\n  background-color: #3f51b5;\n}\n.color-indigo i.icon,\ni.icon.color-indigo {\n  color: #3f51b5;\n}\ni.icon-next.color-indigo,\ni.icon-next.theme-indigo {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%233f51b5'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-indigo,\ni.icon-prev.theme-indigo {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%233f51b5'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-indigo,\ni.icon-back.theme-indigo {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%233f51b5'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-indigo,\ni.icon-forward.theme-indigo {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%233f51b5'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-indigo,\ni.icon-bars.theme-indigo {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%233f51b5'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-indigo a,\n.theme-indigo .card a {\n  color: #3f51b5;\n}\n.theme-indigo .navbar,\n.navbar.theme-indigo,\n.theme-indigo .toolbar,\n.toolbar.theme-indigo,\n.theme-indigo .subnavbar,\n.subnavbar.theme-indigo,\n.theme-indigo .searchbar,\n.searchbar.theme-indigo {\n  background-color: #3f51b5;\n}\n.theme-indigo .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-indigo input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(63, 81, 181, 0.5);\n}\n.theme-indigo .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-indigo input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #3f51b5;\n}\n.theme-indigo label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-indigo i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-indigo label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-indigo label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-indigo label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-indigo label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-indigo label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-indigo label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-indigo input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #3f51b5;\n  background-color: #3f51b5;\n}\n.theme-indigo label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-indigo i.icon-form-radio:after {\n  background-color: #3f51b5;\n}\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #3f51b5;\n}\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-indigo label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-indigo label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-indigo input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #3f51b5;\n}\n.theme-indigo .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-indigo input[type=\"checkbox\"]:checked ~ i {\n  border-color: #3f51b5;\n  background-color: #3f51b5;\n}\n.theme-indigo .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-indigo input[type=\"radio\"]:checked ~ i {\n  border-color: #3f51b5;\n}\n.theme-indigo .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-indigo input[type=\"radio\"]:checked ~ i:after {\n  background-color: #3f51b5;\n}\n.theme-indigo .form-checkbox .ripple-wave,\n.theme-indigo .form-radio .ripple-wave {\n  background: rgba(63, 81, 181, 0.5);\n}\n.theme-indigo .focus-state .label,\n.theme-indigo .focus-state .floating-label {\n  color: #3f51b5;\n}\n.theme-indigo .item-input-field.focus-state:after,\n.theme-indigo .input-field.focus-state:after,\n.theme-indigo .item-input-field.not-empty-state:after,\n.theme-indigo .input-field.not-empty-state:after {\n  background: #3f51b5;\n}\n.theme-indigo .picker-calendar-day.picker-calendar-day-today span {\n  color: #3f51b5;\n}\n.theme-indigo .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #3f51b5;\n  color: #fff;\n}\n.theme-indigo .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #3f51b5;\n}\n.theme-indigo .picker-header {\n  background-color: #3f51b5;\n}\n.theme-indigo .modal-button {\n  color: #3f51b5;\n}\n.theme-indigo .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-indigo .timeline-item-date {\n  background-color: #3f51b5;\n}\n.theme-indigo .timeline-year-title,\n.theme-indigo .timeline-month-title {\n  background-color: #3f51b5;\n}\n.theme-indigo .statusbar-overlay {\n  background-color: #1A237E;\n}\n.theme-indigo .data-table .data-table-header-selected,\n.data-table.theme-indigo .data-table-header-selected {\n  background: rgba(63, 81, 181, 0.1);\n}\n.theme-indigo .data-table .data-table-title-selected,\n.data-table.theme-indigo .data-table-title-selected {\n  color: #3f51b5;\n}\n.swiper-pagination.color-indigo .swiper-pagination-bullet-active,\n.theme-indigo .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #3f51b5;\n}\n.swiper-pagination.color-indigo .swiper-pagination-progressbar,\n.theme-indigo .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #3f51b5;\n}\n.swiper-pagination.swiper-pagination-progress.bg-indigo {\n  background-color: rgba(63, 81, 181, 0.25);\n}\n.swiper-button-next.color-indigo,\n.swiper-container-rtl .swiper-button-prev.color-indigo,\n.theme-indigo .swiper-button-next,\n.theme-indigo .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%233f51b5'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-indigo,\n.swiper-container-rtl .swiper-button-next.color-indigo,\n.theme-indigo .swiper-button-prev,\n.theme-indigo .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%233f51b5'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-indigo .floating-button,\n.theme-indigo .speed-dial-buttons a,\n.floating-button.theme-indigo,\n.speed-dial-buttons a.theme-indigo {\n  color: #fff;\n  background: #3f51b5;\n}\nhtml:not(.watch-active-state) .theme-indigo .floating-button:active,\nhtml:not(.watch-active-state) .theme-indigo .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-indigo:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-indigo:active,\n.theme-indigo .floating-button.active-state,\n.theme-indigo .speed-dial-buttons a.active-state,\n.floating-button.theme-indigo.active-state,\n.speed-dial-buttons a.theme-indigo.active-state {\n  background: #303F9F;\n}\n.theme-indigo .floating-button i,\n.theme-indigo .speed-dial-buttons a i,\n.floating-button.theme-indigo i,\n.speed-dial-buttons a.theme-indigo i {\n  color: inherit;\n}\n.theme-indigo .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-indigo input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #3f51b5;\n}\n.theme-indigo .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-indigo input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #3f51b5;\n}\n.theme-indigo .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-indigo input[type=\"range\"]::-ms-thumb {\n  background-color: #3f51b5;\n}\n.theme-indigo .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-indigo input[type=\"range\"]::-ms-fill-lower {\n  background-color: #3f51b5;\n}\n.theme-indigo .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-indigo input[type=\"range\"]::-moz-range-thumb {\n  background-color: #3f51b5;\n}\n.badge.theme-indigo {\n  background-color: #3f51b5;\n  color: #fff;\n}\n.theme-blue .button:not(.button-fill) {\n  color: #2196f3;\n}\n.theme-blue .navbar .button:not(.button-fill),\n.theme-blue.navbar .button:not(.button-fill),\n.theme-blue .toolbar .button:not(.button-fill),\n.theme-blue.toolbar .button:not(.button-fill),\n.theme-blue .subnavbar .button:not(.button-fill),\n.theme-blue.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-blue .button.button-fill {\n  background: #2196f3;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-blue .button.button-fill:active,\n.theme-blue .button.button-fill.active-state {\n  background: #1976D2;\n}\n.progressbar.theme-blue,\n.theme-blue .progressbar {\n  background-color: rgba(33, 150, 243, 0.5);\n}\n.progressbar.theme-blue span,\n.theme-blue .progressbar span {\n  background-color: #2196f3;\n}\n.progressbar-infinite.theme-blue,\n.theme-blue .progressbar-infinite {\n  background-color: rgba(33, 150, 243, 0.5);\n}\n.progressbar-infinite.theme-blue:after,\n.theme-blue .progressbar-infinite:after,\n.progressbar-infinite.theme-blue:before,\n.theme-blue .progressbar-infinite:before {\n  background-color: #2196f3;\n}\n.color-blue i.icon,\ni.icon.color-blue {\n  color: #2196f3;\n}\ni.icon-next.color-blue,\ni.icon-next.theme-blue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%232196f3'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-blue,\ni.icon-prev.theme-blue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%232196f3'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-blue,\ni.icon-back.theme-blue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%232196f3'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-blue,\ni.icon-forward.theme-blue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%232196f3'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-blue,\ni.icon-bars.theme-blue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%232196f3'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-blue a,\n.theme-blue .card a {\n  color: #2196f3;\n}\n.theme-blue .navbar,\n.navbar.theme-blue,\n.theme-blue .toolbar,\n.toolbar.theme-blue,\n.theme-blue .subnavbar,\n.subnavbar.theme-blue,\n.theme-blue .searchbar,\n.searchbar.theme-blue {\n  background-color: #2196f3;\n}\n.theme-blue .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-blue input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(33, 150, 243, 0.5);\n}\n.theme-blue .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-blue input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #2196f3;\n}\n.theme-blue label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-blue i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-blue label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-blue label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-blue label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-blue label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-blue label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-blue label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-blue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #2196f3;\n  background-color: #2196f3;\n}\n.theme-blue label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-blue i.icon-form-radio:after {\n  background-color: #2196f3;\n}\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-blue label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-blue label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-blue label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #2196f3;\n}\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-blue label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-blue label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-blue label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-blue label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-blue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #2196f3;\n}\n.theme-blue .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-blue input[type=\"checkbox\"]:checked ~ i {\n  border-color: #2196f3;\n  background-color: #2196f3;\n}\n.theme-blue .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-blue input[type=\"radio\"]:checked ~ i {\n  border-color: #2196f3;\n}\n.theme-blue .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-blue input[type=\"radio\"]:checked ~ i:after {\n  background-color: #2196f3;\n}\n.theme-blue .form-checkbox .ripple-wave,\n.theme-blue .form-radio .ripple-wave {\n  background: rgba(33, 150, 243, 0.5);\n}\n.theme-blue .focus-state .label,\n.theme-blue .focus-state .floating-label {\n  color: #2196f3;\n}\n.theme-blue .item-input-field.focus-state:after,\n.theme-blue .input-field.focus-state:after,\n.theme-blue .item-input-field.not-empty-state:after,\n.theme-blue .input-field.not-empty-state:after {\n  background: #2196f3;\n}\n.theme-blue .picker-calendar-day.picker-calendar-day-today span {\n  color: #2196f3;\n}\n.theme-blue .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #2196f3;\n  color: #fff;\n}\n.theme-blue .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #2196f3;\n}\n.theme-blue .picker-header {\n  background-color: #2196f3;\n}\n.theme-blue .modal-button {\n  color: #2196f3;\n}\n.theme-blue .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-blue .timeline-item-date {\n  background-color: #2196f3;\n}\n.theme-blue .timeline-year-title,\n.theme-blue .timeline-month-title {\n  background-color: #2196f3;\n}\n.theme-blue .statusbar-overlay {\n  background-color: #0D47A1;\n}\n.theme-blue .data-table .data-table-header-selected,\n.data-table.theme-blue .data-table-header-selected {\n  background: rgba(33, 150, 243, 0.1);\n}\n.theme-blue .data-table .data-table-title-selected,\n.data-table.theme-blue .data-table-title-selected {\n  color: #2196f3;\n}\n.swiper-pagination.color-blue .swiper-pagination-bullet-active,\n.theme-blue .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #2196f3;\n}\n.swiper-pagination.color-blue .swiper-pagination-progressbar,\n.theme-blue .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #2196f3;\n}\n.swiper-pagination.swiper-pagination-progress.bg-blue {\n  background-color: rgba(33, 150, 243, 0.25);\n}\n.swiper-button-next.color-blue,\n.swiper-container-rtl .swiper-button-prev.color-blue,\n.theme-blue .swiper-button-next,\n.theme-blue .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%232196f3'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-blue,\n.swiper-container-rtl .swiper-button-next.color-blue,\n.theme-blue .swiper-button-prev,\n.theme-blue .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%232196f3'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-blue .floating-button,\n.theme-blue .speed-dial-buttons a,\n.floating-button.theme-blue,\n.speed-dial-buttons a.theme-blue {\n  color: #fff;\n  background: #2196f3;\n}\nhtml:not(.watch-active-state) .theme-blue .floating-button:active,\nhtml:not(.watch-active-state) .theme-blue .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-blue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-blue:active,\n.theme-blue .floating-button.active-state,\n.theme-blue .speed-dial-buttons a.active-state,\n.floating-button.theme-blue.active-state,\n.speed-dial-buttons a.theme-blue.active-state {\n  background: #1976D2;\n}\n.theme-blue .floating-button i,\n.theme-blue .speed-dial-buttons a i,\n.floating-button.theme-blue i,\n.speed-dial-buttons a.theme-blue i {\n  color: inherit;\n}\n.theme-blue .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-blue input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #2196f3;\n}\n.theme-blue .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-blue input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #2196f3;\n}\n.theme-blue .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-blue input[type=\"range\"]::-ms-thumb {\n  background-color: #2196f3;\n}\n.theme-blue .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-blue input[type=\"range\"]::-ms-fill-lower {\n  background-color: #2196f3;\n}\n.theme-blue .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-blue input[type=\"range\"]::-moz-range-thumb {\n  background-color: #2196f3;\n}\n.badge.theme-blue {\n  background-color: #2196f3;\n  color: #fff;\n}\n.theme-lightblue .button:not(.button-fill) {\n  color: #03a9f4;\n}\n.theme-lightblue .navbar .button:not(.button-fill),\n.theme-lightblue.navbar .button:not(.button-fill),\n.theme-lightblue .toolbar .button:not(.button-fill),\n.theme-lightblue.toolbar .button:not(.button-fill),\n.theme-lightblue .subnavbar .button:not(.button-fill),\n.theme-lightblue.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-lightblue .button.button-fill {\n  background: #03a9f4;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-lightblue .button.button-fill:active,\n.theme-lightblue .button.button-fill.active-state {\n  background: #0288D1;\n}\n.progressbar.theme-lightblue,\n.theme-lightblue .progressbar {\n  background-color: rgba(3, 169, 244, 0.5);\n}\n.progressbar.theme-lightblue span,\n.theme-lightblue .progressbar span {\n  background-color: #03a9f4;\n}\n.progressbar-infinite.theme-lightblue,\n.theme-lightblue .progressbar-infinite {\n  background-color: rgba(3, 169, 244, 0.5);\n}\n.progressbar-infinite.theme-lightblue:after,\n.theme-lightblue .progressbar-infinite:after,\n.progressbar-infinite.theme-lightblue:before,\n.theme-lightblue .progressbar-infinite:before {\n  background-color: #03a9f4;\n}\n.color-lightblue i.icon,\ni.icon.color-lightblue {\n  color: #03a9f4;\n}\ni.icon-next.color-lightblue,\ni.icon-next.theme-lightblue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%2303a9f4'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-lightblue,\ni.icon-prev.theme-lightblue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%2303a9f4'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-lightblue,\ni.icon-back.theme-lightblue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%2303a9f4'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-lightblue,\ni.icon-forward.theme-lightblue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%2303a9f4'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-lightblue,\ni.icon-bars.theme-lightblue {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%2303a9f4'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightblue a,\n.theme-lightblue .card a {\n  color: #03a9f4;\n}\n.theme-lightblue .navbar,\n.navbar.theme-lightblue,\n.theme-lightblue .toolbar,\n.toolbar.theme-lightblue,\n.theme-lightblue .subnavbar,\n.subnavbar.theme-lightblue,\n.theme-lightblue .searchbar,\n.searchbar.theme-lightblue {\n  background-color: #03a9f4;\n}\n.theme-lightblue .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-lightblue input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(3, 169, 244, 0.5);\n}\n.theme-lightblue .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-lightblue input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #03a9f4;\n}\n.theme-lightblue label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-lightblue i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightblue label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lightblue label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lightblue label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lightblue label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lightblue label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-lightblue label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightblue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #03a9f4;\n  background-color: #03a9f4;\n}\n.theme-lightblue label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue i.icon-form-radio:after {\n  background-color: #03a9f4;\n}\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #03a9f4;\n}\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lightblue label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-lightblue label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lightblue input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #03a9f4;\n}\n.theme-lightblue .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-lightblue input[type=\"checkbox\"]:checked ~ i {\n  border-color: #03a9f4;\n  background-color: #03a9f4;\n}\n.theme-lightblue .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-lightblue input[type=\"radio\"]:checked ~ i {\n  border-color: #03a9f4;\n}\n.theme-lightblue .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-lightblue input[type=\"radio\"]:checked ~ i:after {\n  background-color: #03a9f4;\n}\n.theme-lightblue .form-checkbox .ripple-wave,\n.theme-lightblue .form-radio .ripple-wave {\n  background: rgba(3, 169, 244, 0.5);\n}\n.theme-lightblue .focus-state .label,\n.theme-lightblue .focus-state .floating-label {\n  color: #03a9f4;\n}\n.theme-lightblue .item-input-field.focus-state:after,\n.theme-lightblue .input-field.focus-state:after,\n.theme-lightblue .item-input-field.not-empty-state:after,\n.theme-lightblue .input-field.not-empty-state:after {\n  background: #03a9f4;\n}\n.theme-lightblue .picker-calendar-day.picker-calendar-day-today span {\n  color: #03a9f4;\n}\n.theme-lightblue .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #03a9f4;\n  color: #fff;\n}\n.theme-lightblue .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #03a9f4;\n}\n.theme-lightblue .picker-header {\n  background-color: #03a9f4;\n}\n.theme-lightblue .modal-button {\n  color: #03a9f4;\n}\n.theme-lightblue .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-lightblue .timeline-item-date {\n  background-color: #03a9f4;\n}\n.theme-lightblue .timeline-year-title,\n.theme-lightblue .timeline-month-title {\n  background-color: #03a9f4;\n}\n.theme-lightblue .statusbar-overlay {\n  background-color: #01579B;\n}\n.theme-lightblue .data-table .data-table-header-selected,\n.data-table.theme-lightblue .data-table-header-selected {\n  background: rgba(3, 169, 244, 0.1);\n}\n.theme-lightblue .data-table .data-table-title-selected,\n.data-table.theme-lightblue .data-table-title-selected {\n  color: #03a9f4;\n}\n.swiper-pagination.color-lightblue .swiper-pagination-bullet-active,\n.theme-lightblue .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #03a9f4;\n}\n.swiper-pagination.color-lightblue .swiper-pagination-progressbar,\n.theme-lightblue .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #03a9f4;\n}\n.swiper-pagination.swiper-pagination-progress.bg-lightblue {\n  background-color: rgba(3, 169, 244, 0.25);\n}\n.swiper-button-next.color-lightblue,\n.swiper-container-rtl .swiper-button-prev.color-lightblue,\n.theme-lightblue .swiper-button-next,\n.theme-lightblue .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%2303a9f4'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-lightblue,\n.swiper-container-rtl .swiper-button-next.color-lightblue,\n.theme-lightblue .swiper-button-prev,\n.theme-lightblue .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%2303a9f4'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightblue .floating-button,\n.theme-lightblue .speed-dial-buttons a,\n.floating-button.theme-lightblue,\n.speed-dial-buttons a.theme-lightblue {\n  color: #fff;\n  background: #03a9f4;\n}\nhtml:not(.watch-active-state) .theme-lightblue .floating-button:active,\nhtml:not(.watch-active-state) .theme-lightblue .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-lightblue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-lightblue:active,\n.theme-lightblue .floating-button.active-state,\n.theme-lightblue .speed-dial-buttons a.active-state,\n.floating-button.theme-lightblue.active-state,\n.speed-dial-buttons a.theme-lightblue.active-state {\n  background: #0288D1;\n}\n.theme-lightblue .floating-button i,\n.theme-lightblue .speed-dial-buttons a i,\n.floating-button.theme-lightblue i,\n.speed-dial-buttons a.theme-lightblue i {\n  color: inherit;\n}\n.theme-lightblue .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-lightblue input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #03a9f4;\n}\n.theme-lightblue .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-lightblue input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #03a9f4;\n}\n.theme-lightblue .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-lightblue input[type=\"range\"]::-ms-thumb {\n  background-color: #03a9f4;\n}\n.theme-lightblue .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-lightblue input[type=\"range\"]::-ms-fill-lower {\n  background-color: #03a9f4;\n}\n.theme-lightblue .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-lightblue input[type=\"range\"]::-moz-range-thumb {\n  background-color: #03a9f4;\n}\n.badge.theme-lightblue {\n  background-color: #03a9f4;\n  color: #fff;\n}\n.theme-cyan .button:not(.button-fill) {\n  color: #00bcd4;\n}\n.theme-cyan .navbar .button:not(.button-fill),\n.theme-cyan.navbar .button:not(.button-fill),\n.theme-cyan .toolbar .button:not(.button-fill),\n.theme-cyan.toolbar .button:not(.button-fill),\n.theme-cyan .subnavbar .button:not(.button-fill),\n.theme-cyan.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-cyan .button.button-fill {\n  background: #00bcd4;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-cyan .button.button-fill:active,\n.theme-cyan .button.button-fill.active-state {\n  background: #0097A7;\n}\n.progressbar.theme-cyan,\n.theme-cyan .progressbar {\n  background-color: rgba(0, 188, 212, 0.5);\n}\n.progressbar.theme-cyan span,\n.theme-cyan .progressbar span {\n  background-color: #00bcd4;\n}\n.progressbar-infinite.theme-cyan,\n.theme-cyan .progressbar-infinite {\n  background-color: rgba(0, 188, 212, 0.5);\n}\n.progressbar-infinite.theme-cyan:after,\n.theme-cyan .progressbar-infinite:after,\n.progressbar-infinite.theme-cyan:before,\n.theme-cyan .progressbar-infinite:before {\n  background-color: #00bcd4;\n}\n.color-cyan i.icon,\ni.icon.color-cyan {\n  color: #00bcd4;\n}\ni.icon-next.color-cyan,\ni.icon-next.theme-cyan {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%2300bcd4'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-cyan,\ni.icon-prev.theme-cyan {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%2300bcd4'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-cyan,\ni.icon-back.theme-cyan {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%2300bcd4'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-cyan,\ni.icon-forward.theme-cyan {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%2300bcd4'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-cyan,\ni.icon-bars.theme-cyan {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%2300bcd4'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-cyan a,\n.theme-cyan .card a {\n  color: #00bcd4;\n}\n.theme-cyan .navbar,\n.navbar.theme-cyan,\n.theme-cyan .toolbar,\n.toolbar.theme-cyan,\n.theme-cyan .subnavbar,\n.subnavbar.theme-cyan,\n.theme-cyan .searchbar,\n.searchbar.theme-cyan {\n  background-color: #00bcd4;\n}\n.theme-cyan .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-cyan input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(0, 188, 212, 0.5);\n}\n.theme-cyan .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-cyan input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #00bcd4;\n}\n.theme-cyan label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-cyan i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-cyan label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-cyan label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-cyan label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-cyan label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-cyan label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-cyan label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-cyan input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #00bcd4;\n  background-color: #00bcd4;\n}\n.theme-cyan label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-cyan i.icon-form-radio:after {\n  background-color: #00bcd4;\n}\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #00bcd4;\n}\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-cyan label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-cyan label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-cyan input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #00bcd4;\n}\n.theme-cyan .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-cyan input[type=\"checkbox\"]:checked ~ i {\n  border-color: #00bcd4;\n  background-color: #00bcd4;\n}\n.theme-cyan .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-cyan input[type=\"radio\"]:checked ~ i {\n  border-color: #00bcd4;\n}\n.theme-cyan .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-cyan input[type=\"radio\"]:checked ~ i:after {\n  background-color: #00bcd4;\n}\n.theme-cyan .form-checkbox .ripple-wave,\n.theme-cyan .form-radio .ripple-wave {\n  background: rgba(0, 188, 212, 0.5);\n}\n.theme-cyan .focus-state .label,\n.theme-cyan .focus-state .floating-label {\n  color: #00bcd4;\n}\n.theme-cyan .item-input-field.focus-state:after,\n.theme-cyan .input-field.focus-state:after,\n.theme-cyan .item-input-field.not-empty-state:after,\n.theme-cyan .input-field.not-empty-state:after {\n  background: #00bcd4;\n}\n.theme-cyan .picker-calendar-day.picker-calendar-day-today span {\n  color: #00bcd4;\n}\n.theme-cyan .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #00bcd4;\n  color: #fff;\n}\n.theme-cyan .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #00bcd4;\n}\n.theme-cyan .picker-header {\n  background-color: #00bcd4;\n}\n.theme-cyan .modal-button {\n  color: #00bcd4;\n}\n.theme-cyan .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-cyan .timeline-item-date {\n  background-color: #00bcd4;\n}\n.theme-cyan .timeline-year-title,\n.theme-cyan .timeline-month-title {\n  background-color: #00bcd4;\n}\n.theme-cyan .statusbar-overlay {\n  background-color: #006064;\n}\n.theme-cyan .data-table .data-table-header-selected,\n.data-table.theme-cyan .data-table-header-selected {\n  background: rgba(0, 188, 212, 0.1);\n}\n.theme-cyan .data-table .data-table-title-selected,\n.data-table.theme-cyan .data-table-title-selected {\n  color: #00bcd4;\n}\n.swiper-pagination.color-cyan .swiper-pagination-bullet-active,\n.theme-cyan .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #00bcd4;\n}\n.swiper-pagination.color-cyan .swiper-pagination-progressbar,\n.theme-cyan .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #00bcd4;\n}\n.swiper-pagination.swiper-pagination-progress.bg-cyan {\n  background-color: rgba(0, 188, 212, 0.25);\n}\n.swiper-button-next.color-cyan,\n.swiper-container-rtl .swiper-button-prev.color-cyan,\n.theme-cyan .swiper-button-next,\n.theme-cyan .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%2300bcd4'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-cyan,\n.swiper-container-rtl .swiper-button-next.color-cyan,\n.theme-cyan .swiper-button-prev,\n.theme-cyan .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%2300bcd4'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-cyan .floating-button,\n.theme-cyan .speed-dial-buttons a,\n.floating-button.theme-cyan,\n.speed-dial-buttons a.theme-cyan {\n  color: #fff;\n  background: #00bcd4;\n}\nhtml:not(.watch-active-state) .theme-cyan .floating-button:active,\nhtml:not(.watch-active-state) .theme-cyan .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-cyan:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-cyan:active,\n.theme-cyan .floating-button.active-state,\n.theme-cyan .speed-dial-buttons a.active-state,\n.floating-button.theme-cyan.active-state,\n.speed-dial-buttons a.theme-cyan.active-state {\n  background: #0097A7;\n}\n.theme-cyan .floating-button i,\n.theme-cyan .speed-dial-buttons a i,\n.floating-button.theme-cyan i,\n.speed-dial-buttons a.theme-cyan i {\n  color: inherit;\n}\n.theme-cyan .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-cyan input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #00bcd4;\n}\n.theme-cyan .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-cyan input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #00bcd4;\n}\n.theme-cyan .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-cyan input[type=\"range\"]::-ms-thumb {\n  background-color: #00bcd4;\n}\n.theme-cyan .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-cyan input[type=\"range\"]::-ms-fill-lower {\n  background-color: #00bcd4;\n}\n.theme-cyan .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-cyan input[type=\"range\"]::-moz-range-thumb {\n  background-color: #00bcd4;\n}\n.badge.theme-cyan {\n  background-color: #00bcd4;\n  color: #fff;\n}\n.theme-teal .button:not(.button-fill) {\n  color: #009688;\n}\n.theme-teal .navbar .button:not(.button-fill),\n.theme-teal.navbar .button:not(.button-fill),\n.theme-teal .toolbar .button:not(.button-fill),\n.theme-teal.toolbar .button:not(.button-fill),\n.theme-teal .subnavbar .button:not(.button-fill),\n.theme-teal.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-teal .button.button-fill {\n  background: #009688;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-teal .button.button-fill:active,\n.theme-teal .button.button-fill.active-state {\n  background: #00897B;\n}\n.progressbar.theme-teal,\n.theme-teal .progressbar {\n  background-color: rgba(0, 150, 136, 0.5);\n}\n.progressbar.theme-teal span,\n.theme-teal .progressbar span {\n  background-color: #009688;\n}\n.progressbar-infinite.theme-teal,\n.theme-teal .progressbar-infinite {\n  background-color: rgba(0, 150, 136, 0.5);\n}\n.progressbar-infinite.theme-teal:after,\n.theme-teal .progressbar-infinite:after,\n.progressbar-infinite.theme-teal:before,\n.theme-teal .progressbar-infinite:before {\n  background-color: #009688;\n}\n.color-teal i.icon,\ni.icon.color-teal {\n  color: #009688;\n}\ni.icon-next.color-teal,\ni.icon-next.theme-teal {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23009688'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-teal,\ni.icon-prev.theme-teal {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23009688'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-teal,\ni.icon-back.theme-teal {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23009688'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-teal,\ni.icon-forward.theme-teal {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23009688'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-teal,\ni.icon-bars.theme-teal {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23009688'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-teal a,\n.theme-teal .card a {\n  color: #009688;\n}\n.theme-teal .navbar,\n.navbar.theme-teal,\n.theme-teal .toolbar,\n.toolbar.theme-teal,\n.theme-teal .subnavbar,\n.subnavbar.theme-teal,\n.theme-teal .searchbar,\n.searchbar.theme-teal {\n  background-color: #009688;\n}\n.theme-teal .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-teal input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(0, 150, 136, 0.5);\n}\n.theme-teal .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-teal input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #009688;\n}\n.theme-teal label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-teal i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-teal label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-teal label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-teal label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-teal label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-teal label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-teal label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-teal input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #009688;\n  background-color: #009688;\n}\n.theme-teal label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-teal i.icon-form-radio:after {\n  background-color: #009688;\n}\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-teal label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-teal label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-teal label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #009688;\n}\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-teal label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-teal label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-teal label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-teal label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-teal input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #009688;\n}\n.theme-teal .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-teal input[type=\"checkbox\"]:checked ~ i {\n  border-color: #009688;\n  background-color: #009688;\n}\n.theme-teal .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-teal input[type=\"radio\"]:checked ~ i {\n  border-color: #009688;\n}\n.theme-teal .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-teal input[type=\"radio\"]:checked ~ i:after {\n  background-color: #009688;\n}\n.theme-teal .form-checkbox .ripple-wave,\n.theme-teal .form-radio .ripple-wave {\n  background: rgba(0, 150, 136, 0.5);\n}\n.theme-teal .focus-state .label,\n.theme-teal .focus-state .floating-label {\n  color: #009688;\n}\n.theme-teal .item-input-field.focus-state:after,\n.theme-teal .input-field.focus-state:after,\n.theme-teal .item-input-field.not-empty-state:after,\n.theme-teal .input-field.not-empty-state:after {\n  background: #009688;\n}\n.theme-teal .picker-calendar-day.picker-calendar-day-today span {\n  color: #009688;\n}\n.theme-teal .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #009688;\n  color: #fff;\n}\n.theme-teal .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #009688;\n}\n.theme-teal .picker-header {\n  background-color: #009688;\n}\n.theme-teal .modal-button {\n  color: #009688;\n}\n.theme-teal .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-teal .timeline-item-date {\n  background-color: #009688;\n}\n.theme-teal .timeline-year-title,\n.theme-teal .timeline-month-title {\n  background-color: #009688;\n}\n.theme-teal .statusbar-overlay {\n  background-color: #004D40;\n}\n.theme-teal .data-table .data-table-header-selected,\n.data-table.theme-teal .data-table-header-selected {\n  background: rgba(0, 150, 136, 0.1);\n}\n.theme-teal .data-table .data-table-title-selected,\n.data-table.theme-teal .data-table-title-selected {\n  color: #009688;\n}\n.swiper-pagination.color-teal .swiper-pagination-bullet-active,\n.theme-teal .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #009688;\n}\n.swiper-pagination.color-teal .swiper-pagination-progressbar,\n.theme-teal .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #009688;\n}\n.swiper-pagination.swiper-pagination-progress.bg-teal {\n  background-color: rgba(0, 150, 136, 0.25);\n}\n.swiper-button-next.color-teal,\n.swiper-container-rtl .swiper-button-prev.color-teal,\n.theme-teal .swiper-button-next,\n.theme-teal .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23009688'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-teal,\n.swiper-container-rtl .swiper-button-next.color-teal,\n.theme-teal .swiper-button-prev,\n.theme-teal .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23009688'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-teal .floating-button,\n.theme-teal .speed-dial-buttons a,\n.floating-button.theme-teal,\n.speed-dial-buttons a.theme-teal {\n  color: #fff;\n  background: #009688;\n}\nhtml:not(.watch-active-state) .theme-teal .floating-button:active,\nhtml:not(.watch-active-state) .theme-teal .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-teal:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-teal:active,\n.theme-teal .floating-button.active-state,\n.theme-teal .speed-dial-buttons a.active-state,\n.floating-button.theme-teal.active-state,\n.speed-dial-buttons a.theme-teal.active-state {\n  background: #00897B;\n}\n.theme-teal .floating-button i,\n.theme-teal .speed-dial-buttons a i,\n.floating-button.theme-teal i,\n.speed-dial-buttons a.theme-teal i {\n  color: inherit;\n}\n.theme-teal .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-teal input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #009688;\n}\n.theme-teal .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-teal input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #009688;\n}\n.theme-teal .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-teal input[type=\"range\"]::-ms-thumb {\n  background-color: #009688;\n}\n.theme-teal .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-teal input[type=\"range\"]::-ms-fill-lower {\n  background-color: #009688;\n}\n.theme-teal .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-teal input[type=\"range\"]::-moz-range-thumb {\n  background-color: #009688;\n}\n.badge.theme-teal {\n  background-color: #009688;\n  color: #fff;\n}\n.theme-green .button:not(.button-fill) {\n  color: #4caf50;\n}\n.theme-green .navbar .button:not(.button-fill),\n.theme-green.navbar .button:not(.button-fill),\n.theme-green .toolbar .button:not(.button-fill),\n.theme-green.toolbar .button:not(.button-fill),\n.theme-green .subnavbar .button:not(.button-fill),\n.theme-green.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-green .button.button-fill {\n  background: #4caf50;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-green .button.button-fill:active,\n.theme-green .button.button-fill.active-state {\n  background: #388E3C;\n}\n.progressbar.theme-green,\n.theme-green .progressbar {\n  background-color: rgba(76, 175, 80, 0.5);\n}\n.progressbar.theme-green span,\n.theme-green .progressbar span {\n  background-color: #4caf50;\n}\n.progressbar-infinite.theme-green,\n.theme-green .progressbar-infinite {\n  background-color: rgba(76, 175, 80, 0.5);\n}\n.progressbar-infinite.theme-green:after,\n.theme-green .progressbar-infinite:after,\n.progressbar-infinite.theme-green:before,\n.theme-green .progressbar-infinite:before {\n  background-color: #4caf50;\n}\n.color-green i.icon,\ni.icon.color-green {\n  color: #4caf50;\n}\ni.icon-next.color-green,\ni.icon-next.theme-green {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%234caf50'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-green,\ni.icon-prev.theme-green {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%234caf50'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-green,\ni.icon-back.theme-green {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%234caf50'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-green,\ni.icon-forward.theme-green {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%234caf50'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-green,\ni.icon-bars.theme-green {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%234caf50'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-green a,\n.theme-green .card a {\n  color: #4caf50;\n}\n.theme-green .navbar,\n.navbar.theme-green,\n.theme-green .toolbar,\n.toolbar.theme-green,\n.theme-green .subnavbar,\n.subnavbar.theme-green,\n.theme-green .searchbar,\n.searchbar.theme-green {\n  background-color: #4caf50;\n}\n.theme-green .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-green input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(76, 175, 80, 0.5);\n}\n.theme-green .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-green input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #4caf50;\n}\n.theme-green label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-green i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-green label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-green label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-green label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-green label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-green label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-green label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-green input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #4caf50;\n  background-color: #4caf50;\n}\n.theme-green label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-green i.icon-form-radio:after {\n  background-color: #4caf50;\n}\n.theme-green label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-green label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-green label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-green label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-green label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-green label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #4caf50;\n}\n.theme-green label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-green label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-green label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-green label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-green label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-green label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-green input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #4caf50;\n}\n.theme-green .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-green input[type=\"checkbox\"]:checked ~ i {\n  border-color: #4caf50;\n  background-color: #4caf50;\n}\n.theme-green .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-green input[type=\"radio\"]:checked ~ i {\n  border-color: #4caf50;\n}\n.theme-green .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-green input[type=\"radio\"]:checked ~ i:after {\n  background-color: #4caf50;\n}\n.theme-green .form-checkbox .ripple-wave,\n.theme-green .form-radio .ripple-wave {\n  background: rgba(76, 175, 80, 0.5);\n}\n.theme-green .focus-state .label,\n.theme-green .focus-state .floating-label {\n  color: #4caf50;\n}\n.theme-green .item-input-field.focus-state:after,\n.theme-green .input-field.focus-state:after,\n.theme-green .item-input-field.not-empty-state:after,\n.theme-green .input-field.not-empty-state:after {\n  background: #4caf50;\n}\n.theme-green .picker-calendar-day.picker-calendar-day-today span {\n  color: #4caf50;\n}\n.theme-green .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #4caf50;\n  color: #fff;\n}\n.theme-green .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #4caf50;\n}\n.theme-green .picker-header {\n  background-color: #4caf50;\n}\n.theme-green .modal-button {\n  color: #4caf50;\n}\n.theme-green .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-green .timeline-item-date {\n  background-color: #4caf50;\n}\n.theme-green .timeline-year-title,\n.theme-green .timeline-month-title {\n  background-color: #4caf50;\n}\n.theme-green .statusbar-overlay {\n  background-color: #1B5E20;\n}\n.theme-green .data-table .data-table-header-selected,\n.data-table.theme-green .data-table-header-selected {\n  background: rgba(76, 175, 80, 0.1);\n}\n.theme-green .data-table .data-table-title-selected,\n.data-table.theme-green .data-table-title-selected {\n  color: #4caf50;\n}\n.swiper-pagination.color-green .swiper-pagination-bullet-active,\n.theme-green .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #4caf50;\n}\n.swiper-pagination.color-green .swiper-pagination-progressbar,\n.theme-green .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #4caf50;\n}\n.swiper-pagination.swiper-pagination-progress.bg-green {\n  background-color: rgba(76, 175, 80, 0.25);\n}\n.swiper-button-next.color-green,\n.swiper-container-rtl .swiper-button-prev.color-green,\n.theme-green .swiper-button-next,\n.theme-green .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%234caf50'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-green,\n.swiper-container-rtl .swiper-button-next.color-green,\n.theme-green .swiper-button-prev,\n.theme-green .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%234caf50'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-green .floating-button,\n.theme-green .speed-dial-buttons a,\n.floating-button.theme-green,\n.speed-dial-buttons a.theme-green {\n  color: #fff;\n  background: #4caf50;\n}\nhtml:not(.watch-active-state) .theme-green .floating-button:active,\nhtml:not(.watch-active-state) .theme-green .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-green:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-green:active,\n.theme-green .floating-button.active-state,\n.theme-green .speed-dial-buttons a.active-state,\n.floating-button.theme-green.active-state,\n.speed-dial-buttons a.theme-green.active-state {\n  background: #388E3C;\n}\n.theme-green .floating-button i,\n.theme-green .speed-dial-buttons a i,\n.floating-button.theme-green i,\n.speed-dial-buttons a.theme-green i {\n  color: inherit;\n}\n.theme-green .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-green input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #4caf50;\n}\n.theme-green .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-green input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #4caf50;\n}\n.theme-green .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-green input[type=\"range\"]::-ms-thumb {\n  background-color: #4caf50;\n}\n.theme-green .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-green input[type=\"range\"]::-ms-fill-lower {\n  background-color: #4caf50;\n}\n.theme-green .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-green input[type=\"range\"]::-moz-range-thumb {\n  background-color: #4caf50;\n}\n.badge.theme-green {\n  background-color: #4caf50;\n  color: #fff;\n}\n.theme-lightgreen .button:not(.button-fill) {\n  color: #8bc34a;\n}\n.theme-lightgreen .navbar .button:not(.button-fill),\n.theme-lightgreen.navbar .button:not(.button-fill),\n.theme-lightgreen .toolbar .button:not(.button-fill),\n.theme-lightgreen.toolbar .button:not(.button-fill),\n.theme-lightgreen .subnavbar .button:not(.button-fill),\n.theme-lightgreen.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-lightgreen .button.button-fill {\n  background: #8bc34a;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-lightgreen .button.button-fill:active,\n.theme-lightgreen .button.button-fill.active-state {\n  background: #689F38;\n}\n.progressbar.theme-lightgreen,\n.theme-lightgreen .progressbar {\n  background-color: rgba(139, 195, 74, 0.5);\n}\n.progressbar.theme-lightgreen span,\n.theme-lightgreen .progressbar span {\n  background-color: #8bc34a;\n}\n.progressbar-infinite.theme-lightgreen,\n.theme-lightgreen .progressbar-infinite {\n  background-color: rgba(139, 195, 74, 0.5);\n}\n.progressbar-infinite.theme-lightgreen:after,\n.theme-lightgreen .progressbar-infinite:after,\n.progressbar-infinite.theme-lightgreen:before,\n.theme-lightgreen .progressbar-infinite:before {\n  background-color: #8bc34a;\n}\n.color-lightgreen i.icon,\ni.icon.color-lightgreen {\n  color: #8bc34a;\n}\ni.icon-next.color-lightgreen,\ni.icon-next.theme-lightgreen {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%238bc34a'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-lightgreen,\ni.icon-prev.theme-lightgreen {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%238bc34a'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-lightgreen,\ni.icon-back.theme-lightgreen {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%238bc34a'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-lightgreen,\ni.icon-forward.theme-lightgreen {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%238bc34a'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-lightgreen,\ni.icon-bars.theme-lightgreen {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%238bc34a'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightgreen a,\n.theme-lightgreen .card a {\n  color: #8bc34a;\n}\n.theme-lightgreen .navbar,\n.navbar.theme-lightgreen,\n.theme-lightgreen .toolbar,\n.toolbar.theme-lightgreen,\n.theme-lightgreen .subnavbar,\n.subnavbar.theme-lightgreen,\n.theme-lightgreen .searchbar,\n.searchbar.theme-lightgreen {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-lightgreen input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(139, 195, 74, 0.5);\n}\n.theme-lightgreen .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-lightgreen input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #8bc34a;\n}\n.theme-lightgreen label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-lightgreen i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightgreen label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lightgreen label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lightgreen label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lightgreen label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lightgreen label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-lightgreen label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lightgreen input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #8bc34a;\n  background-color: #8bc34a;\n}\n.theme-lightgreen label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen i.icon-form-radio:after {\n  background-color: #8bc34a;\n}\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #8bc34a;\n}\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lightgreen label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-lightgreen label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lightgreen input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-lightgreen input[type=\"checkbox\"]:checked ~ i {\n  border-color: #8bc34a;\n  background-color: #8bc34a;\n}\n.theme-lightgreen .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-lightgreen input[type=\"radio\"]:checked ~ i {\n  border-color: #8bc34a;\n}\n.theme-lightgreen .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-lightgreen input[type=\"radio\"]:checked ~ i:after {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .form-checkbox .ripple-wave,\n.theme-lightgreen .form-radio .ripple-wave {\n  background: rgba(139, 195, 74, 0.5);\n}\n.theme-lightgreen .focus-state .label,\n.theme-lightgreen .focus-state .floating-label {\n  color: #8bc34a;\n}\n.theme-lightgreen .item-input-field.focus-state:after,\n.theme-lightgreen .input-field.focus-state:after,\n.theme-lightgreen .item-input-field.not-empty-state:after,\n.theme-lightgreen .input-field.not-empty-state:after {\n  background: #8bc34a;\n}\n.theme-lightgreen .picker-calendar-day.picker-calendar-day-today span {\n  color: #8bc34a;\n}\n.theme-lightgreen .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #8bc34a;\n  color: #fff;\n}\n.theme-lightgreen .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .picker-header {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .modal-button {\n  color: #8bc34a;\n}\n.theme-lightgreen .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-lightgreen .timeline-item-date {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .timeline-year-title,\n.theme-lightgreen .timeline-month-title {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .statusbar-overlay {\n  background-color: #33691E;\n}\n.theme-lightgreen .data-table .data-table-header-selected,\n.data-table.theme-lightgreen .data-table-header-selected {\n  background: rgba(139, 195, 74, 0.1);\n}\n.theme-lightgreen .data-table .data-table-title-selected,\n.data-table.theme-lightgreen .data-table-title-selected {\n  color: #8bc34a;\n}\n.swiper-pagination.color-lightgreen .swiper-pagination-bullet-active,\n.theme-lightgreen .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #8bc34a;\n}\n.swiper-pagination.color-lightgreen .swiper-pagination-progressbar,\n.theme-lightgreen .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #8bc34a;\n}\n.swiper-pagination.swiper-pagination-progress.bg-lightgreen {\n  background-color: rgba(139, 195, 74, 0.25);\n}\n.swiper-button-next.color-lightgreen,\n.swiper-container-rtl .swiper-button-prev.color-lightgreen,\n.theme-lightgreen .swiper-button-next,\n.theme-lightgreen .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%238bc34a'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-lightgreen,\n.swiper-container-rtl .swiper-button-next.color-lightgreen,\n.theme-lightgreen .swiper-button-prev,\n.theme-lightgreen .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%238bc34a'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lightgreen .floating-button,\n.theme-lightgreen .speed-dial-buttons a,\n.floating-button.theme-lightgreen,\n.speed-dial-buttons a.theme-lightgreen {\n  color: #fff;\n  background: #8bc34a;\n}\nhtml:not(.watch-active-state) .theme-lightgreen .floating-button:active,\nhtml:not(.watch-active-state) .theme-lightgreen .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-lightgreen:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-lightgreen:active,\n.theme-lightgreen .floating-button.active-state,\n.theme-lightgreen .speed-dial-buttons a.active-state,\n.floating-button.theme-lightgreen.active-state,\n.speed-dial-buttons a.theme-lightgreen.active-state {\n  background: #689F38;\n}\n.theme-lightgreen .floating-button i,\n.theme-lightgreen .speed-dial-buttons a i,\n.floating-button.theme-lightgreen i,\n.speed-dial-buttons a.theme-lightgreen i {\n  color: inherit;\n}\n.theme-lightgreen .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-lightgreen input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-lightgreen input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-lightgreen input[type=\"range\"]::-ms-thumb {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-lightgreen input[type=\"range\"]::-ms-fill-lower {\n  background-color: #8bc34a;\n}\n.theme-lightgreen .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-lightgreen input[type=\"range\"]::-moz-range-thumb {\n  background-color: #8bc34a;\n}\n.badge.theme-lightgreen {\n  background-color: #8bc34a;\n  color: #fff;\n}\n.theme-lime .button:not(.button-fill) {\n  color: #cddc39;\n}\n.theme-lime .navbar .button:not(.button-fill),\n.theme-lime.navbar .button:not(.button-fill),\n.theme-lime .toolbar .button:not(.button-fill),\n.theme-lime.toolbar .button:not(.button-fill),\n.theme-lime .subnavbar .button:not(.button-fill),\n.theme-lime.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-lime .button.button-fill {\n  background: #cddc39;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-lime .button.button-fill:active,\n.theme-lime .button.button-fill.active-state {\n  background: #AFB42B;\n}\n.progressbar.theme-lime,\n.theme-lime .progressbar {\n  background-color: rgba(205, 220, 57, 0.5);\n}\n.progressbar.theme-lime span,\n.theme-lime .progressbar span {\n  background-color: #cddc39;\n}\n.progressbar-infinite.theme-lime,\n.theme-lime .progressbar-infinite {\n  background-color: rgba(205, 220, 57, 0.5);\n}\n.progressbar-infinite.theme-lime:after,\n.theme-lime .progressbar-infinite:after,\n.progressbar-infinite.theme-lime:before,\n.theme-lime .progressbar-infinite:before {\n  background-color: #cddc39;\n}\n.color-lime i.icon,\ni.icon.color-lime {\n  color: #cddc39;\n}\ni.icon-next.color-lime,\ni.icon-next.theme-lime {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23cddc39'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-lime,\ni.icon-prev.theme-lime {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23cddc39'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-lime,\ni.icon-back.theme-lime {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23cddc39'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-lime,\ni.icon-forward.theme-lime {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23cddc39'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-lime,\ni.icon-bars.theme-lime {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23cddc39'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lime a,\n.theme-lime .card a {\n  color: #cddc39;\n}\n.theme-lime .navbar,\n.navbar.theme-lime,\n.theme-lime .toolbar,\n.toolbar.theme-lime,\n.theme-lime .subnavbar,\n.subnavbar.theme-lime,\n.theme-lime .searchbar,\n.searchbar.theme-lime {\n  background-color: #cddc39;\n}\n.theme-lime .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-lime input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(205, 220, 57, 0.5);\n}\n.theme-lime .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-lime input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #cddc39;\n}\n.theme-lime label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-lime i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lime label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lime label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-lime label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lime label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-lime label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-lime label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-lime input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #cddc39;\n  background-color: #cddc39;\n}\n.theme-lime label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-lime i.icon-form-radio:after {\n  background-color: #cddc39;\n}\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-lime label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lime label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-lime label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #cddc39;\n}\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lime label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lime label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-lime label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-lime label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-lime input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #cddc39;\n}\n.theme-lime .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-lime input[type=\"checkbox\"]:checked ~ i {\n  border-color: #cddc39;\n  background-color: #cddc39;\n}\n.theme-lime .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-lime input[type=\"radio\"]:checked ~ i {\n  border-color: #cddc39;\n}\n.theme-lime .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-lime input[type=\"radio\"]:checked ~ i:after {\n  background-color: #cddc39;\n}\n.theme-lime .form-checkbox .ripple-wave,\n.theme-lime .form-radio .ripple-wave {\n  background: rgba(205, 220, 57, 0.5);\n}\n.theme-lime .focus-state .label,\n.theme-lime .focus-state .floating-label {\n  color: #cddc39;\n}\n.theme-lime .item-input-field.focus-state:after,\n.theme-lime .input-field.focus-state:after,\n.theme-lime .item-input-field.not-empty-state:after,\n.theme-lime .input-field.not-empty-state:after {\n  background: #cddc39;\n}\n.theme-lime .picker-calendar-day.picker-calendar-day-today span {\n  color: #cddc39;\n}\n.theme-lime .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #cddc39;\n  color: #fff;\n}\n.theme-lime .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #cddc39;\n}\n.theme-lime .picker-header {\n  background-color: #cddc39;\n}\n.theme-lime .modal-button {\n  color: #cddc39;\n}\n.theme-lime .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-lime .timeline-item-date {\n  background-color: #cddc39;\n}\n.theme-lime .timeline-year-title,\n.theme-lime .timeline-month-title {\n  background-color: #cddc39;\n}\n.theme-lime .statusbar-overlay {\n  background-color: #827717;\n}\n.theme-lime .data-table .data-table-header-selected,\n.data-table.theme-lime .data-table-header-selected {\n  background: rgba(205, 220, 57, 0.1);\n}\n.theme-lime .data-table .data-table-title-selected,\n.data-table.theme-lime .data-table-title-selected {\n  color: #cddc39;\n}\n.swiper-pagination.color-lime .swiper-pagination-bullet-active,\n.theme-lime .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #cddc39;\n}\n.swiper-pagination.color-lime .swiper-pagination-progressbar,\n.theme-lime .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #cddc39;\n}\n.swiper-pagination.swiper-pagination-progress.bg-lime {\n  background-color: rgba(205, 220, 57, 0.25);\n}\n.swiper-button-next.color-lime,\n.swiper-container-rtl .swiper-button-prev.color-lime,\n.theme-lime .swiper-button-next,\n.theme-lime .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23cddc39'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-lime,\n.swiper-container-rtl .swiper-button-next.color-lime,\n.theme-lime .swiper-button-prev,\n.theme-lime .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23cddc39'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-lime .floating-button,\n.theme-lime .speed-dial-buttons a,\n.floating-button.theme-lime,\n.speed-dial-buttons a.theme-lime {\n  color: #fff;\n  background: #cddc39;\n}\nhtml:not(.watch-active-state) .theme-lime .floating-button:active,\nhtml:not(.watch-active-state) .theme-lime .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-lime:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-lime:active,\n.theme-lime .floating-button.active-state,\n.theme-lime .speed-dial-buttons a.active-state,\n.floating-button.theme-lime.active-state,\n.speed-dial-buttons a.theme-lime.active-state {\n  background: #AFB42B;\n}\n.theme-lime .floating-button i,\n.theme-lime .speed-dial-buttons a i,\n.floating-button.theme-lime i,\n.speed-dial-buttons a.theme-lime i {\n  color: inherit;\n}\n.theme-lime .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-lime input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #cddc39;\n}\n.theme-lime .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-lime input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #cddc39;\n}\n.theme-lime .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-lime input[type=\"range\"]::-ms-thumb {\n  background-color: #cddc39;\n}\n.theme-lime .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-lime input[type=\"range\"]::-ms-fill-lower {\n  background-color: #cddc39;\n}\n.theme-lime .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-lime input[type=\"range\"]::-moz-range-thumb {\n  background-color: #cddc39;\n}\n.badge.theme-lime {\n  background-color: #cddc39;\n  color: #fff;\n}\n.theme-yellow .button:not(.button-fill) {\n  color: #ffeb3b;\n}\n.theme-yellow .navbar .button:not(.button-fill),\n.theme-yellow.navbar .button:not(.button-fill),\n.theme-yellow .toolbar .button:not(.button-fill),\n.theme-yellow.toolbar .button:not(.button-fill),\n.theme-yellow .subnavbar .button:not(.button-fill),\n.theme-yellow.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-yellow .button.button-fill {\n  background: #ffeb3b;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-yellow .button.button-fill:active,\n.theme-yellow .button.button-fill.active-state {\n  background: #FBC02D;\n}\n.progressbar.theme-yellow,\n.theme-yellow .progressbar {\n  background-color: rgba(255, 235, 59, 0.5);\n}\n.progressbar.theme-yellow span,\n.theme-yellow .progressbar span {\n  background-color: #ffeb3b;\n}\n.progressbar-infinite.theme-yellow,\n.theme-yellow .progressbar-infinite {\n  background-color: rgba(255, 235, 59, 0.5);\n}\n.progressbar-infinite.theme-yellow:after,\n.theme-yellow .progressbar-infinite:after,\n.progressbar-infinite.theme-yellow:before,\n.theme-yellow .progressbar-infinite:before {\n  background-color: #ffeb3b;\n}\n.color-yellow i.icon,\ni.icon.color-yellow {\n  color: #ffeb3b;\n}\ni.icon-next.color-yellow,\ni.icon-next.theme-yellow {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffeb3b'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-yellow,\ni.icon-prev.theme-yellow {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffeb3b'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-yellow,\ni.icon-back.theme-yellow {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ffeb3b'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-yellow,\ni.icon-forward.theme-yellow {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ffeb3b'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-yellow,\ni.icon-bars.theme-yellow {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ffeb3b'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-yellow a,\n.theme-yellow .card a {\n  color: #ffeb3b;\n}\n.theme-yellow .navbar,\n.navbar.theme-yellow,\n.theme-yellow .toolbar,\n.toolbar.theme-yellow,\n.theme-yellow .subnavbar,\n.subnavbar.theme-yellow,\n.theme-yellow .searchbar,\n.searchbar.theme-yellow {\n  background-color: #ffeb3b;\n}\n.theme-yellow .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-yellow input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(255, 235, 59, 0.5);\n}\n.theme-yellow .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-yellow input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #ffeb3b;\n}\n.theme-yellow label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-yellow i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-yellow label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-yellow label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-yellow label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-yellow label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-yellow label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-yellow label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-yellow input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #ffeb3b;\n  background-color: #ffeb3b;\n}\n.theme-yellow label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-yellow i.icon-form-radio:after {\n  background-color: #ffeb3b;\n}\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #ffeb3b;\n}\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-yellow label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-yellow label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-yellow input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #ffeb3b;\n}\n.theme-yellow .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-yellow input[type=\"checkbox\"]:checked ~ i {\n  border-color: #ffeb3b;\n  background-color: #ffeb3b;\n}\n.theme-yellow .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-yellow input[type=\"radio\"]:checked ~ i {\n  border-color: #ffeb3b;\n}\n.theme-yellow .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-yellow input[type=\"radio\"]:checked ~ i:after {\n  background-color: #ffeb3b;\n}\n.theme-yellow .form-checkbox .ripple-wave,\n.theme-yellow .form-radio .ripple-wave {\n  background: rgba(255, 235, 59, 0.5);\n}\n.theme-yellow .focus-state .label,\n.theme-yellow .focus-state .floating-label {\n  color: #ffeb3b;\n}\n.theme-yellow .item-input-field.focus-state:after,\n.theme-yellow .input-field.focus-state:after,\n.theme-yellow .item-input-field.not-empty-state:after,\n.theme-yellow .input-field.not-empty-state:after {\n  background: #ffeb3b;\n}\n.theme-yellow .picker-calendar-day.picker-calendar-day-today span {\n  color: #ffeb3b;\n}\n.theme-yellow .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #ffeb3b;\n  color: #fff;\n}\n.theme-yellow .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #ffeb3b;\n}\n.theme-yellow .picker-header {\n  background-color: #ffeb3b;\n}\n.theme-yellow .modal-button {\n  color: #ffeb3b;\n}\n.theme-yellow .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-yellow .timeline-item-date {\n  background-color: #ffeb3b;\n}\n.theme-yellow .timeline-year-title,\n.theme-yellow .timeline-month-title {\n  background-color: #ffeb3b;\n}\n.theme-yellow .statusbar-overlay {\n  background-color: #F57F17;\n}\n.theme-yellow .data-table .data-table-header-selected,\n.data-table.theme-yellow .data-table-header-selected {\n  background: rgba(255, 235, 59, 0.1);\n}\n.theme-yellow .data-table .data-table-title-selected,\n.data-table.theme-yellow .data-table-title-selected {\n  color: #ffeb3b;\n}\n.swiper-pagination.color-yellow .swiper-pagination-bullet-active,\n.theme-yellow .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #ffeb3b;\n}\n.swiper-pagination.color-yellow .swiper-pagination-progressbar,\n.theme-yellow .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #ffeb3b;\n}\n.swiper-pagination.swiper-pagination-progress.bg-yellow {\n  background-color: rgba(255, 235, 59, 0.25);\n}\n.swiper-button-next.color-yellow,\n.swiper-container-rtl .swiper-button-prev.color-yellow,\n.theme-yellow .swiper-button-next,\n.theme-yellow .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23ffeb3b'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-yellow,\n.swiper-container-rtl .swiper-button-next.color-yellow,\n.theme-yellow .swiper-button-prev,\n.theme-yellow .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23ffeb3b'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-yellow .floating-button,\n.theme-yellow .speed-dial-buttons a,\n.floating-button.theme-yellow,\n.speed-dial-buttons a.theme-yellow {\n  color: #fff;\n  background: #ffeb3b;\n}\nhtml:not(.watch-active-state) .theme-yellow .floating-button:active,\nhtml:not(.watch-active-state) .theme-yellow .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-yellow:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-yellow:active,\n.theme-yellow .floating-button.active-state,\n.theme-yellow .speed-dial-buttons a.active-state,\n.floating-button.theme-yellow.active-state,\n.speed-dial-buttons a.theme-yellow.active-state {\n  background: #FBC02D;\n}\n.theme-yellow .floating-button i,\n.theme-yellow .speed-dial-buttons a i,\n.floating-button.theme-yellow i,\n.speed-dial-buttons a.theme-yellow i {\n  color: inherit;\n}\n.theme-yellow .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-yellow input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffeb3b;\n}\n.theme-yellow .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-yellow input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffeb3b;\n}\n.theme-yellow .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-yellow input[type=\"range\"]::-ms-thumb {\n  background-color: #ffeb3b;\n}\n.theme-yellow .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-yellow input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffeb3b;\n}\n.theme-yellow .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-yellow input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffeb3b;\n}\n.badge.theme-yellow {\n  background-color: #ffeb3b;\n  color: #fff;\n}\n.theme-amber .button:not(.button-fill) {\n  color: #ffc107;\n}\n.theme-amber .navbar .button:not(.button-fill),\n.theme-amber.navbar .button:not(.button-fill),\n.theme-amber .toolbar .button:not(.button-fill),\n.theme-amber.toolbar .button:not(.button-fill),\n.theme-amber .subnavbar .button:not(.button-fill),\n.theme-amber.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-amber .button.button-fill {\n  background: #ffc107;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-amber .button.button-fill:active,\n.theme-amber .button.button-fill.active-state {\n  background: #FFA000;\n}\n.progressbar.theme-amber,\n.theme-amber .progressbar {\n  background-color: rgba(255, 193, 7, 0.5);\n}\n.progressbar.theme-amber span,\n.theme-amber .progressbar span {\n  background-color: #ffc107;\n}\n.progressbar-infinite.theme-amber,\n.theme-amber .progressbar-infinite {\n  background-color: rgba(255, 193, 7, 0.5);\n}\n.progressbar-infinite.theme-amber:after,\n.theme-amber .progressbar-infinite:after,\n.progressbar-infinite.theme-amber:before,\n.theme-amber .progressbar-infinite:before {\n  background-color: #ffc107;\n}\n.color-amber i.icon,\ni.icon.color-amber {\n  color: #ffc107;\n}\ni.icon-next.color-amber,\ni.icon-next.theme-amber {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffc107'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-amber,\ni.icon-prev.theme-amber {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffc107'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-amber,\ni.icon-back.theme-amber {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ffc107'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-amber,\ni.icon-forward.theme-amber {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ffc107'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-amber,\ni.icon-bars.theme-amber {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ffc107'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-amber a,\n.theme-amber .card a {\n  color: #ffc107;\n}\n.theme-amber .navbar,\n.navbar.theme-amber,\n.theme-amber .toolbar,\n.toolbar.theme-amber,\n.theme-amber .subnavbar,\n.subnavbar.theme-amber,\n.theme-amber .searchbar,\n.searchbar.theme-amber {\n  background-color: #ffc107;\n}\n.theme-amber .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-amber input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(255, 193, 7, 0.5);\n}\n.theme-amber .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-amber input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #ffc107;\n}\n.theme-amber label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-amber i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-amber label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-amber label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-amber label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-amber label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-amber label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-amber label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-amber input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #ffc107;\n  background-color: #ffc107;\n}\n.theme-amber label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-amber i.icon-form-radio:after {\n  background-color: #ffc107;\n}\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-amber label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-amber label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-amber label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #ffc107;\n}\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-amber label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-amber label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-amber label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-amber label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-amber input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #ffc107;\n}\n.theme-amber .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-amber input[type=\"checkbox\"]:checked ~ i {\n  border-color: #ffc107;\n  background-color: #ffc107;\n}\n.theme-amber .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-amber input[type=\"radio\"]:checked ~ i {\n  border-color: #ffc107;\n}\n.theme-amber .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-amber input[type=\"radio\"]:checked ~ i:after {\n  background-color: #ffc107;\n}\n.theme-amber .form-checkbox .ripple-wave,\n.theme-amber .form-radio .ripple-wave {\n  background: rgba(255, 193, 7, 0.5);\n}\n.theme-amber .focus-state .label,\n.theme-amber .focus-state .floating-label {\n  color: #ffc107;\n}\n.theme-amber .item-input-field.focus-state:after,\n.theme-amber .input-field.focus-state:after,\n.theme-amber .item-input-field.not-empty-state:after,\n.theme-amber .input-field.not-empty-state:after {\n  background: #ffc107;\n}\n.theme-amber .picker-calendar-day.picker-calendar-day-today span {\n  color: #ffc107;\n}\n.theme-amber .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #ffc107;\n  color: #fff;\n}\n.theme-amber .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #ffc107;\n}\n.theme-amber .picker-header {\n  background-color: #ffc107;\n}\n.theme-amber .modal-button {\n  color: #ffc107;\n}\n.theme-amber .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-amber .timeline-item-date {\n  background-color: #ffc107;\n}\n.theme-amber .timeline-year-title,\n.theme-amber .timeline-month-title {\n  background-color: #ffc107;\n}\n.theme-amber .statusbar-overlay {\n  background-color: #FF6F00;\n}\n.theme-amber .data-table .data-table-header-selected,\n.data-table.theme-amber .data-table-header-selected {\n  background: rgba(255, 193, 7, 0.1);\n}\n.theme-amber .data-table .data-table-title-selected,\n.data-table.theme-amber .data-table-title-selected {\n  color: #ffc107;\n}\n.swiper-pagination.color-amber .swiper-pagination-bullet-active,\n.theme-amber .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #ffc107;\n}\n.swiper-pagination.color-amber .swiper-pagination-progressbar,\n.theme-amber .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #ffc107;\n}\n.swiper-pagination.swiper-pagination-progress.bg-amber {\n  background-color: rgba(255, 193, 7, 0.25);\n}\n.swiper-button-next.color-amber,\n.swiper-container-rtl .swiper-button-prev.color-amber,\n.theme-amber .swiper-button-next,\n.theme-amber .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23ffc107'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-amber,\n.swiper-container-rtl .swiper-button-next.color-amber,\n.theme-amber .swiper-button-prev,\n.theme-amber .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23ffc107'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-amber .floating-button,\n.theme-amber .speed-dial-buttons a,\n.floating-button.theme-amber,\n.speed-dial-buttons a.theme-amber {\n  color: #fff;\n  background: #ffc107;\n}\nhtml:not(.watch-active-state) .theme-amber .floating-button:active,\nhtml:not(.watch-active-state) .theme-amber .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-amber:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-amber:active,\n.theme-amber .floating-button.active-state,\n.theme-amber .speed-dial-buttons a.active-state,\n.floating-button.theme-amber.active-state,\n.speed-dial-buttons a.theme-amber.active-state {\n  background: #FFA000;\n}\n.theme-amber .floating-button i,\n.theme-amber .speed-dial-buttons a i,\n.floating-button.theme-amber i,\n.speed-dial-buttons a.theme-amber i {\n  color: inherit;\n}\n.theme-amber .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-amber input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffc107;\n}\n.theme-amber .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-amber input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffc107;\n}\n.theme-amber .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-amber input[type=\"range\"]::-ms-thumb {\n  background-color: #ffc107;\n}\n.theme-amber .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-amber input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffc107;\n}\n.theme-amber .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-amber input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffc107;\n}\n.badge.theme-amber {\n  background-color: #ffc107;\n  color: #fff;\n}\n.theme-orange .button:not(.button-fill) {\n  color: #ff9800;\n}\n.theme-orange .navbar .button:not(.button-fill),\n.theme-orange.navbar .button:not(.button-fill),\n.theme-orange .toolbar .button:not(.button-fill),\n.theme-orange.toolbar .button:not(.button-fill),\n.theme-orange .subnavbar .button:not(.button-fill),\n.theme-orange.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-orange .button.button-fill {\n  background: #ff9800;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-orange .button.button-fill:active,\n.theme-orange .button.button-fill.active-state {\n  background: #F57C00;\n}\n.progressbar.theme-orange,\n.theme-orange .progressbar {\n  background-color: rgba(255, 152, 0, 0.5);\n}\n.progressbar.theme-orange span,\n.theme-orange .progressbar span {\n  background-color: #ff9800;\n}\n.progressbar-infinite.theme-orange,\n.theme-orange .progressbar-infinite {\n  background-color: rgba(255, 152, 0, 0.5);\n}\n.progressbar-infinite.theme-orange:after,\n.theme-orange .progressbar-infinite:after,\n.progressbar-infinite.theme-orange:before,\n.theme-orange .progressbar-infinite:before {\n  background-color: #ff9800;\n}\n.color-orange i.icon,\ni.icon.color-orange {\n  color: #ff9800;\n}\ni.icon-next.color-orange,\ni.icon-next.theme-orange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ff9800'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-orange,\ni.icon-prev.theme-orange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ff9800'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-orange,\ni.icon-back.theme-orange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ff9800'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-orange,\ni.icon-forward.theme-orange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ff9800'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-orange,\ni.icon-bars.theme-orange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ff9800'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-orange a,\n.theme-orange .card a {\n  color: #ff9800;\n}\n.theme-orange .navbar,\n.navbar.theme-orange,\n.theme-orange .toolbar,\n.toolbar.theme-orange,\n.theme-orange .subnavbar,\n.subnavbar.theme-orange,\n.theme-orange .searchbar,\n.searchbar.theme-orange {\n  background-color: #ff9800;\n}\n.theme-orange .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-orange input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(255, 152, 0, 0.5);\n}\n.theme-orange .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-orange input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #ff9800;\n}\n.theme-orange label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-orange i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-orange label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-orange label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-orange label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-orange label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-orange label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-orange label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-orange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #ff9800;\n  background-color: #ff9800;\n}\n.theme-orange label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-orange i.icon-form-radio:after {\n  background-color: #ff9800;\n}\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-orange label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-orange label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-orange label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #ff9800;\n}\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-orange label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-orange label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-orange label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-orange label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-orange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #ff9800;\n}\n.theme-orange .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-orange input[type=\"checkbox\"]:checked ~ i {\n  border-color: #ff9800;\n  background-color: #ff9800;\n}\n.theme-orange .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-orange input[type=\"radio\"]:checked ~ i {\n  border-color: #ff9800;\n}\n.theme-orange .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-orange input[type=\"radio\"]:checked ~ i:after {\n  background-color: #ff9800;\n}\n.theme-orange .form-checkbox .ripple-wave,\n.theme-orange .form-radio .ripple-wave {\n  background: rgba(255, 152, 0, 0.5);\n}\n.theme-orange .focus-state .label,\n.theme-orange .focus-state .floating-label {\n  color: #ff9800;\n}\n.theme-orange .item-input-field.focus-state:after,\n.theme-orange .input-field.focus-state:after,\n.theme-orange .item-input-field.not-empty-state:after,\n.theme-orange .input-field.not-empty-state:after {\n  background: #ff9800;\n}\n.theme-orange .picker-calendar-day.picker-calendar-day-today span {\n  color: #ff9800;\n}\n.theme-orange .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #ff9800;\n  color: #fff;\n}\n.theme-orange .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #ff9800;\n}\n.theme-orange .picker-header {\n  background-color: #ff9800;\n}\n.theme-orange .modal-button {\n  color: #ff9800;\n}\n.theme-orange .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-orange .timeline-item-date {\n  background-color: #ff9800;\n}\n.theme-orange .timeline-year-title,\n.theme-orange .timeline-month-title {\n  background-color: #ff9800;\n}\n.theme-orange .statusbar-overlay {\n  background-color: #E65100;\n}\n.theme-orange .data-table .data-table-header-selected,\n.data-table.theme-orange .data-table-header-selected {\n  background: rgba(255, 152, 0, 0.1);\n}\n.theme-orange .data-table .data-table-title-selected,\n.data-table.theme-orange .data-table-title-selected {\n  color: #ff9800;\n}\n.swiper-pagination.color-orange .swiper-pagination-bullet-active,\n.theme-orange .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #ff9800;\n}\n.swiper-pagination.color-orange .swiper-pagination-progressbar,\n.theme-orange .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #ff9800;\n}\n.swiper-pagination.swiper-pagination-progress.bg-orange {\n  background-color: rgba(255, 152, 0, 0.25);\n}\n.swiper-button-next.color-orange,\n.swiper-container-rtl .swiper-button-prev.color-orange,\n.theme-orange .swiper-button-next,\n.theme-orange .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23ff9800'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-orange,\n.swiper-container-rtl .swiper-button-next.color-orange,\n.theme-orange .swiper-button-prev,\n.theme-orange .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23ff9800'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-orange .floating-button,\n.theme-orange .speed-dial-buttons a,\n.floating-button.theme-orange,\n.speed-dial-buttons a.theme-orange {\n  color: #fff;\n  background: #ff9800;\n}\nhtml:not(.watch-active-state) .theme-orange .floating-button:active,\nhtml:not(.watch-active-state) .theme-orange .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-orange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-orange:active,\n.theme-orange .floating-button.active-state,\n.theme-orange .speed-dial-buttons a.active-state,\n.floating-button.theme-orange.active-state,\n.speed-dial-buttons a.theme-orange.active-state {\n  background: #F57C00;\n}\n.theme-orange .floating-button i,\n.theme-orange .speed-dial-buttons a i,\n.floating-button.theme-orange i,\n.speed-dial-buttons a.theme-orange i {\n  color: inherit;\n}\n.theme-orange .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-orange input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ff9800;\n}\n.theme-orange .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-orange input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ff9800;\n}\n.theme-orange .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-orange input[type=\"range\"]::-ms-thumb {\n  background-color: #ff9800;\n}\n.theme-orange .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-orange input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ff9800;\n}\n.theme-orange .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-orange input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ff9800;\n}\n.badge.theme-orange {\n  background-color: #ff9800;\n  color: #fff;\n}\n.theme-deeporange .button:not(.button-fill) {\n  color: #ff5722;\n}\n.theme-deeporange .navbar .button:not(.button-fill),\n.theme-deeporange.navbar .button:not(.button-fill),\n.theme-deeporange .toolbar .button:not(.button-fill),\n.theme-deeporange.toolbar .button:not(.button-fill),\n.theme-deeporange .subnavbar .button:not(.button-fill),\n.theme-deeporange.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-deeporange .button.button-fill {\n  background: #ff5722;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-deeporange .button.button-fill:active,\n.theme-deeporange .button.button-fill.active-state {\n  background: #E64A19;\n}\n.progressbar.theme-deeporange,\n.theme-deeporange .progressbar {\n  background-color: rgba(255, 87, 34, 0.5);\n}\n.progressbar.theme-deeporange span,\n.theme-deeporange .progressbar span {\n  background-color: #ff5722;\n}\n.progressbar-infinite.theme-deeporange,\n.theme-deeporange .progressbar-infinite {\n  background-color: rgba(255, 87, 34, 0.5);\n}\n.progressbar-infinite.theme-deeporange:after,\n.theme-deeporange .progressbar-infinite:after,\n.progressbar-infinite.theme-deeporange:before,\n.theme-deeporange .progressbar-infinite:before {\n  background-color: #ff5722;\n}\n.color-deeporange i.icon,\ni.icon.color-deeporange {\n  color: #ff5722;\n}\ni.icon-next.color-deeporange,\ni.icon-next.theme-deeporange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ff5722'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-deeporange,\ni.icon-prev.theme-deeporange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ff5722'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-deeporange,\ni.icon-back.theme-deeporange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ff5722'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-deeporange,\ni.icon-forward.theme-deeporange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ff5722'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-deeporange,\ni.icon-bars.theme-deeporange {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ff5722'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeporange a,\n.theme-deeporange .card a {\n  color: #ff5722;\n}\n.theme-deeporange .navbar,\n.navbar.theme-deeporange,\n.theme-deeporange .toolbar,\n.toolbar.theme-deeporange,\n.theme-deeporange .subnavbar,\n.subnavbar.theme-deeporange,\n.theme-deeporange .searchbar,\n.searchbar.theme-deeporange {\n  background-color: #ff5722;\n}\n.theme-deeporange .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-deeporange input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(255, 87, 34, 0.5);\n}\n.theme-deeporange .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-deeporange input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #ff5722;\n}\n.theme-deeporange label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-deeporange i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeporange label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-deeporange label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-deeporange label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-deeporange label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-deeporange label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-deeporange label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-deeporange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #ff5722;\n  background-color: #ff5722;\n}\n.theme-deeporange label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange i.icon-form-radio:after {\n  background-color: #ff5722;\n}\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #ff5722;\n}\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-deeporange label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-deeporange label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-deeporange input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #ff5722;\n}\n.theme-deeporange .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-deeporange input[type=\"checkbox\"]:checked ~ i {\n  border-color: #ff5722;\n  background-color: #ff5722;\n}\n.theme-deeporange .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-deeporange input[type=\"radio\"]:checked ~ i {\n  border-color: #ff5722;\n}\n.theme-deeporange .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-deeporange input[type=\"radio\"]:checked ~ i:after {\n  background-color: #ff5722;\n}\n.theme-deeporange .form-checkbox .ripple-wave,\n.theme-deeporange .form-radio .ripple-wave {\n  background: rgba(255, 87, 34, 0.5);\n}\n.theme-deeporange .focus-state .label,\n.theme-deeporange .focus-state .floating-label {\n  color: #ff5722;\n}\n.theme-deeporange .item-input-field.focus-state:after,\n.theme-deeporange .input-field.focus-state:after,\n.theme-deeporange .item-input-field.not-empty-state:after,\n.theme-deeporange .input-field.not-empty-state:after {\n  background: #ff5722;\n}\n.theme-deeporange .picker-calendar-day.picker-calendar-day-today span {\n  color: #ff5722;\n}\n.theme-deeporange .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #ff5722;\n  color: #fff;\n}\n.theme-deeporange .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #ff5722;\n}\n.theme-deeporange .picker-header {\n  background-color: #ff5722;\n}\n.theme-deeporange .modal-button {\n  color: #ff5722;\n}\n.theme-deeporange .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-deeporange .timeline-item-date {\n  background-color: #ff5722;\n}\n.theme-deeporange .timeline-year-title,\n.theme-deeporange .timeline-month-title {\n  background-color: #ff5722;\n}\n.theme-deeporange .statusbar-overlay {\n  background-color: #BF360C;\n}\n.theme-deeporange .data-table .data-table-header-selected,\n.data-table.theme-deeporange .data-table-header-selected {\n  background: rgba(255, 87, 34, 0.1);\n}\n.theme-deeporange .data-table .data-table-title-selected,\n.data-table.theme-deeporange .data-table-title-selected {\n  color: #ff5722;\n}\n.swiper-pagination.color-deeporange .swiper-pagination-bullet-active,\n.theme-deeporange .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #ff5722;\n}\n.swiper-pagination.color-deeporange .swiper-pagination-progressbar,\n.theme-deeporange .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #ff5722;\n}\n.swiper-pagination.swiper-pagination-progress.bg-deeporange {\n  background-color: rgba(255, 87, 34, 0.25);\n}\n.swiper-button-next.color-deeporange,\n.swiper-container-rtl .swiper-button-prev.color-deeporange,\n.theme-deeporange .swiper-button-next,\n.theme-deeporange .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23ff5722'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-deeporange,\n.swiper-container-rtl .swiper-button-next.color-deeporange,\n.theme-deeporange .swiper-button-prev,\n.theme-deeporange .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23ff5722'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-deeporange .floating-button,\n.theme-deeporange .speed-dial-buttons a,\n.floating-button.theme-deeporange,\n.speed-dial-buttons a.theme-deeporange {\n  color: #fff;\n  background: #ff5722;\n}\nhtml:not(.watch-active-state) .theme-deeporange .floating-button:active,\nhtml:not(.watch-active-state) .theme-deeporange .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-deeporange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-deeporange:active,\n.theme-deeporange .floating-button.active-state,\n.theme-deeporange .speed-dial-buttons a.active-state,\n.floating-button.theme-deeporange.active-state,\n.speed-dial-buttons a.theme-deeporange.active-state {\n  background: #E64A19;\n}\n.theme-deeporange .floating-button i,\n.theme-deeporange .speed-dial-buttons a i,\n.floating-button.theme-deeporange i,\n.speed-dial-buttons a.theme-deeporange i {\n  color: inherit;\n}\n.theme-deeporange .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-deeporange input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ff5722;\n}\n.theme-deeporange .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-deeporange input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ff5722;\n}\n.theme-deeporange .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-deeporange input[type=\"range\"]::-ms-thumb {\n  background-color: #ff5722;\n}\n.theme-deeporange .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-deeporange input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ff5722;\n}\n.theme-deeporange .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-deeporange input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ff5722;\n}\n.badge.theme-deeporange {\n  background-color: #ff5722;\n  color: #fff;\n}\n.theme-brown .button:not(.button-fill) {\n  color: #795548;\n}\n.theme-brown .navbar .button:not(.button-fill),\n.theme-brown.navbar .button:not(.button-fill),\n.theme-brown .toolbar .button:not(.button-fill),\n.theme-brown.toolbar .button:not(.button-fill),\n.theme-brown .subnavbar .button:not(.button-fill),\n.theme-brown.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-brown .button.button-fill {\n  background: #795548;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-brown .button.button-fill:active,\n.theme-brown .button.button-fill.active-state {\n  background: #5D4037;\n}\n.progressbar.theme-brown,\n.theme-brown .progressbar {\n  background-color: rgba(121, 85, 72, 0.5);\n}\n.progressbar.theme-brown span,\n.theme-brown .progressbar span {\n  background-color: #795548;\n}\n.progressbar-infinite.theme-brown,\n.theme-brown .progressbar-infinite {\n  background-color: rgba(121, 85, 72, 0.5);\n}\n.progressbar-infinite.theme-brown:after,\n.theme-brown .progressbar-infinite:after,\n.progressbar-infinite.theme-brown:before,\n.theme-brown .progressbar-infinite:before {\n  background-color: #795548;\n}\n.color-brown i.icon,\ni.icon.color-brown {\n  color: #795548;\n}\ni.icon-next.color-brown,\ni.icon-next.theme-brown {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23795548'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-brown,\ni.icon-prev.theme-brown {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23795548'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-brown,\ni.icon-back.theme-brown {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23795548'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-brown,\ni.icon-forward.theme-brown {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23795548'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-brown,\ni.icon-bars.theme-brown {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23795548'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-brown a,\n.theme-brown .card a {\n  color: #795548;\n}\n.theme-brown .navbar,\n.navbar.theme-brown,\n.theme-brown .toolbar,\n.toolbar.theme-brown,\n.theme-brown .subnavbar,\n.subnavbar.theme-brown,\n.theme-brown .searchbar,\n.searchbar.theme-brown {\n  background-color: #795548;\n}\n.theme-brown .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-brown input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(121, 85, 72, 0.5);\n}\n.theme-brown .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-brown input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #795548;\n}\n.theme-brown label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-brown i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-brown label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-brown label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-brown label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-brown label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-brown label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-brown label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-brown input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #795548;\n  background-color: #795548;\n}\n.theme-brown label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-brown i.icon-form-radio:after {\n  background-color: #795548;\n}\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-brown label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-brown label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-brown label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #795548;\n}\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-brown label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-brown label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-brown label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-brown label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-brown input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #795548;\n}\n.theme-brown .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-brown input[type=\"checkbox\"]:checked ~ i {\n  border-color: #795548;\n  background-color: #795548;\n}\n.theme-brown .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-brown input[type=\"radio\"]:checked ~ i {\n  border-color: #795548;\n}\n.theme-brown .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-brown input[type=\"radio\"]:checked ~ i:after {\n  background-color: #795548;\n}\n.theme-brown .form-checkbox .ripple-wave,\n.theme-brown .form-radio .ripple-wave {\n  background: rgba(121, 85, 72, 0.5);\n}\n.theme-brown .focus-state .label,\n.theme-brown .focus-state .floating-label {\n  color: #795548;\n}\n.theme-brown .item-input-field.focus-state:after,\n.theme-brown .input-field.focus-state:after,\n.theme-brown .item-input-field.not-empty-state:after,\n.theme-brown .input-field.not-empty-state:after {\n  background: #795548;\n}\n.theme-brown .picker-calendar-day.picker-calendar-day-today span {\n  color: #795548;\n}\n.theme-brown .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #795548;\n  color: #fff;\n}\n.theme-brown .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #795548;\n}\n.theme-brown .picker-header {\n  background-color: #795548;\n}\n.theme-brown .modal-button {\n  color: #795548;\n}\n.theme-brown .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-brown .timeline-item-date {\n  background-color: #795548;\n}\n.theme-brown .timeline-year-title,\n.theme-brown .timeline-month-title {\n  background-color: #795548;\n}\n.theme-brown .statusbar-overlay {\n  background-color: #3E2723;\n}\n.theme-brown .data-table .data-table-header-selected,\n.data-table.theme-brown .data-table-header-selected {\n  background: rgba(121, 85, 72, 0.1);\n}\n.theme-brown .data-table .data-table-title-selected,\n.data-table.theme-brown .data-table-title-selected {\n  color: #795548;\n}\n.swiper-pagination.color-brown .swiper-pagination-bullet-active,\n.theme-brown .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #795548;\n}\n.swiper-pagination.color-brown .swiper-pagination-progressbar,\n.theme-brown .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #795548;\n}\n.swiper-pagination.swiper-pagination-progress.bg-brown {\n  background-color: rgba(121, 85, 72, 0.25);\n}\n.swiper-button-next.color-brown,\n.swiper-container-rtl .swiper-button-prev.color-brown,\n.theme-brown .swiper-button-next,\n.theme-brown .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23795548'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-brown,\n.swiper-container-rtl .swiper-button-next.color-brown,\n.theme-brown .swiper-button-prev,\n.theme-brown .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23795548'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-brown .floating-button,\n.theme-brown .speed-dial-buttons a,\n.floating-button.theme-brown,\n.speed-dial-buttons a.theme-brown {\n  color: #fff;\n  background: #795548;\n}\nhtml:not(.watch-active-state) .theme-brown .floating-button:active,\nhtml:not(.watch-active-state) .theme-brown .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-brown:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-brown:active,\n.theme-brown .floating-button.active-state,\n.theme-brown .speed-dial-buttons a.active-state,\n.floating-button.theme-brown.active-state,\n.speed-dial-buttons a.theme-brown.active-state {\n  background: #5D4037;\n}\n.theme-brown .floating-button i,\n.theme-brown .speed-dial-buttons a i,\n.floating-button.theme-brown i,\n.speed-dial-buttons a.theme-brown i {\n  color: inherit;\n}\n.theme-brown .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-brown input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #795548;\n}\n.theme-brown .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-brown input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #795548;\n}\n.theme-brown .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-brown input[type=\"range\"]::-ms-thumb {\n  background-color: #795548;\n}\n.theme-brown .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-brown input[type=\"range\"]::-ms-fill-lower {\n  background-color: #795548;\n}\n.theme-brown .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-brown input[type=\"range\"]::-moz-range-thumb {\n  background-color: #795548;\n}\n.badge.theme-brown {\n  background-color: #795548;\n  color: #fff;\n}\n.theme-gray .button:not(.button-fill) {\n  color: #9e9e9e;\n}\n.theme-gray .navbar .button:not(.button-fill),\n.theme-gray.navbar .button:not(.button-fill),\n.theme-gray .toolbar .button:not(.button-fill),\n.theme-gray.toolbar .button:not(.button-fill),\n.theme-gray .subnavbar .button:not(.button-fill),\n.theme-gray.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-gray .button.button-fill {\n  background: #9e9e9e;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-gray .button.button-fill:active,\n.theme-gray .button.button-fill.active-state {\n  background: #616161;\n}\n.progressbar.theme-gray,\n.theme-gray .progressbar {\n  background-color: rgba(158, 158, 158, 0.5);\n}\n.progressbar.theme-gray span,\n.theme-gray .progressbar span {\n  background-color: #9e9e9e;\n}\n.progressbar-infinite.theme-gray,\n.theme-gray .progressbar-infinite {\n  background-color: rgba(158, 158, 158, 0.5);\n}\n.progressbar-infinite.theme-gray:after,\n.theme-gray .progressbar-infinite:after,\n.progressbar-infinite.theme-gray:before,\n.theme-gray .progressbar-infinite:before {\n  background-color: #9e9e9e;\n}\n.color-gray i.icon,\ni.icon.color-gray {\n  color: #9e9e9e;\n}\ni.icon-next.color-gray,\ni.icon-next.theme-gray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%239e9e9e'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-gray,\ni.icon-prev.theme-gray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%239e9e9e'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-gray,\ni.icon-back.theme-gray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%239e9e9e'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-gray,\ni.icon-forward.theme-gray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%239e9e9e'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-gray,\ni.icon-bars.theme-gray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%239e9e9e'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-gray a,\n.theme-gray .card a {\n  color: #9e9e9e;\n}\n.theme-gray .navbar,\n.navbar.theme-gray,\n.theme-gray .toolbar,\n.toolbar.theme-gray,\n.theme-gray .subnavbar,\n.subnavbar.theme-gray,\n.theme-gray .searchbar,\n.searchbar.theme-gray {\n  background-color: #9e9e9e;\n}\n.theme-gray .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-gray input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(158, 158, 158, 0.5);\n}\n.theme-gray .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-gray input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #9e9e9e;\n}\n.theme-gray label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-gray i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-gray label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-gray label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-gray label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-gray label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-gray label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-gray label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-gray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #9e9e9e;\n  background-color: #9e9e9e;\n}\n.theme-gray label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-gray i.icon-form-radio:after {\n  background-color: #9e9e9e;\n}\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-gray label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-gray label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-gray label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #9e9e9e;\n}\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-gray label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-gray label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-gray label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-gray label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-gray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #9e9e9e;\n}\n.theme-gray .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-gray input[type=\"checkbox\"]:checked ~ i {\n  border-color: #9e9e9e;\n  background-color: #9e9e9e;\n}\n.theme-gray .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-gray input[type=\"radio\"]:checked ~ i {\n  border-color: #9e9e9e;\n}\n.theme-gray .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-gray input[type=\"radio\"]:checked ~ i:after {\n  background-color: #9e9e9e;\n}\n.theme-gray .form-checkbox .ripple-wave,\n.theme-gray .form-radio .ripple-wave {\n  background: rgba(158, 158, 158, 0.5);\n}\n.theme-gray .focus-state .label,\n.theme-gray .focus-state .floating-label {\n  color: #9e9e9e;\n}\n.theme-gray .item-input-field.focus-state:after,\n.theme-gray .input-field.focus-state:after,\n.theme-gray .item-input-field.not-empty-state:after,\n.theme-gray .input-field.not-empty-state:after {\n  background: #9e9e9e;\n}\n.theme-gray .picker-calendar-day.picker-calendar-day-today span {\n  color: #9e9e9e;\n}\n.theme-gray .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #9e9e9e;\n  color: #fff;\n}\n.theme-gray .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #9e9e9e;\n}\n.theme-gray .picker-header {\n  background-color: #9e9e9e;\n}\n.theme-gray .modal-button {\n  color: #9e9e9e;\n}\n.theme-gray .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-gray .timeline-item-date {\n  background-color: #9e9e9e;\n}\n.theme-gray .timeline-year-title,\n.theme-gray .timeline-month-title {\n  background-color: #9e9e9e;\n}\n.theme-gray .statusbar-overlay {\n  background-color: #212121;\n}\n.theme-gray .data-table .data-table-header-selected,\n.data-table.theme-gray .data-table-header-selected {\n  background: rgba(158, 158, 158, 0.1);\n}\n.theme-gray .data-table .data-table-title-selected,\n.data-table.theme-gray .data-table-title-selected {\n  color: #9e9e9e;\n}\n.swiper-pagination.color-gray .swiper-pagination-bullet-active,\n.theme-gray .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #9e9e9e;\n}\n.swiper-pagination.color-gray .swiper-pagination-progressbar,\n.theme-gray .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #9e9e9e;\n}\n.swiper-pagination.swiper-pagination-progress.bg-gray {\n  background-color: rgba(158, 158, 158, 0.25);\n}\n.swiper-button-next.color-gray,\n.swiper-container-rtl .swiper-button-prev.color-gray,\n.theme-gray .swiper-button-next,\n.theme-gray .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%239e9e9e'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-gray,\n.swiper-container-rtl .swiper-button-next.color-gray,\n.theme-gray .swiper-button-prev,\n.theme-gray .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%239e9e9e'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-gray .floating-button,\n.theme-gray .speed-dial-buttons a,\n.floating-button.theme-gray,\n.speed-dial-buttons a.theme-gray {\n  color: #fff;\n  background: #9e9e9e;\n}\nhtml:not(.watch-active-state) .theme-gray .floating-button:active,\nhtml:not(.watch-active-state) .theme-gray .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-gray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-gray:active,\n.theme-gray .floating-button.active-state,\n.theme-gray .speed-dial-buttons a.active-state,\n.floating-button.theme-gray.active-state,\n.speed-dial-buttons a.theme-gray.active-state {\n  background: #616161;\n}\n.theme-gray .floating-button i,\n.theme-gray .speed-dial-buttons a i,\n.floating-button.theme-gray i,\n.speed-dial-buttons a.theme-gray i {\n  color: inherit;\n}\n.theme-gray .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-gray input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #9e9e9e;\n}\n.theme-gray .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-gray input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #9e9e9e;\n}\n.theme-gray .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-gray input[type=\"range\"]::-ms-thumb {\n  background-color: #9e9e9e;\n}\n.theme-gray .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-gray input[type=\"range\"]::-ms-fill-lower {\n  background-color: #9e9e9e;\n}\n.theme-gray .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-gray input[type=\"range\"]::-moz-range-thumb {\n  background-color: #9e9e9e;\n}\n.badge.theme-gray {\n  background-color: #9e9e9e;\n  color: #fff;\n}\n.theme-bluegray .button:not(.button-fill) {\n  color: #607d8b;\n}\n.theme-bluegray .navbar .button:not(.button-fill),\n.theme-bluegray.navbar .button:not(.button-fill),\n.theme-bluegray .toolbar .button:not(.button-fill),\n.theme-bluegray.toolbar .button:not(.button-fill),\n.theme-bluegray .subnavbar .button:not(.button-fill),\n.theme-bluegray.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-bluegray .button.button-fill {\n  background: #607d8b;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-bluegray .button.button-fill:active,\n.theme-bluegray .button.button-fill.active-state {\n  background: #455A64;\n}\n.progressbar.theme-bluegray,\n.theme-bluegray .progressbar {\n  background-color: rgba(96, 125, 139, 0.5);\n}\n.progressbar.theme-bluegray span,\n.theme-bluegray .progressbar span {\n  background-color: #607d8b;\n}\n.progressbar-infinite.theme-bluegray,\n.theme-bluegray .progressbar-infinite {\n  background-color: rgba(96, 125, 139, 0.5);\n}\n.progressbar-infinite.theme-bluegray:after,\n.theme-bluegray .progressbar-infinite:after,\n.progressbar-infinite.theme-bluegray:before,\n.theme-bluegray .progressbar-infinite:before {\n  background-color: #607d8b;\n}\n.color-bluegray i.icon,\ni.icon.color-bluegray {\n  color: #607d8b;\n}\ni.icon-next.color-bluegray,\ni.icon-next.theme-bluegray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23607d8b'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-bluegray,\ni.icon-prev.theme-bluegray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23607d8b'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-bluegray,\ni.icon-back.theme-bluegray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23607d8b'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-bluegray,\ni.icon-forward.theme-bluegray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23607d8b'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-bluegray,\ni.icon-bars.theme-bluegray {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23607d8b'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-bluegray a,\n.theme-bluegray .card a {\n  color: #607d8b;\n}\n.theme-bluegray .navbar,\n.navbar.theme-bluegray,\n.theme-bluegray .toolbar,\n.toolbar.theme-bluegray,\n.theme-bluegray .subnavbar,\n.subnavbar.theme-bluegray,\n.theme-bluegray .searchbar,\n.searchbar.theme-bluegray {\n  background-color: #607d8b;\n}\n.theme-bluegray .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-bluegray input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(96, 125, 139, 0.5);\n}\n.theme-bluegray .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-bluegray input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #607d8b;\n}\n.theme-bluegray label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-bluegray i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-bluegray label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-bluegray label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-bluegray label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-bluegray label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-bluegray label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-bluegray label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-bluegray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #607d8b;\n  background-color: #607d8b;\n}\n.theme-bluegray label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray i.icon-form-radio:after {\n  background-color: #607d8b;\n}\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #607d8b;\n}\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-bluegray label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-bluegray label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-bluegray input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #607d8b;\n}\n.theme-bluegray .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-bluegray input[type=\"checkbox\"]:checked ~ i {\n  border-color: #607d8b;\n  background-color: #607d8b;\n}\n.theme-bluegray .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-bluegray input[type=\"radio\"]:checked ~ i {\n  border-color: #607d8b;\n}\n.theme-bluegray .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-bluegray input[type=\"radio\"]:checked ~ i:after {\n  background-color: #607d8b;\n}\n.theme-bluegray .form-checkbox .ripple-wave,\n.theme-bluegray .form-radio .ripple-wave {\n  background: rgba(96, 125, 139, 0.5);\n}\n.theme-bluegray .focus-state .label,\n.theme-bluegray .focus-state .floating-label {\n  color: #607d8b;\n}\n.theme-bluegray .item-input-field.focus-state:after,\n.theme-bluegray .input-field.focus-state:after,\n.theme-bluegray .item-input-field.not-empty-state:after,\n.theme-bluegray .input-field.not-empty-state:after {\n  background: #607d8b;\n}\n.theme-bluegray .picker-calendar-day.picker-calendar-day-today span {\n  color: #607d8b;\n}\n.theme-bluegray .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #607d8b;\n  color: #fff;\n}\n.theme-bluegray .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #607d8b;\n}\n.theme-bluegray .picker-header {\n  background-color: #607d8b;\n}\n.theme-bluegray .modal-button {\n  color: #607d8b;\n}\n.theme-bluegray .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-bluegray .timeline-item-date {\n  background-color: #607d8b;\n}\n.theme-bluegray .timeline-year-title,\n.theme-bluegray .timeline-month-title {\n  background-color: #607d8b;\n}\n.theme-bluegray .statusbar-overlay {\n  background-color: #263238;\n}\n.theme-bluegray .data-table .data-table-header-selected,\n.data-table.theme-bluegray .data-table-header-selected {\n  background: rgba(96, 125, 139, 0.1);\n}\n.theme-bluegray .data-table .data-table-title-selected,\n.data-table.theme-bluegray .data-table-title-selected {\n  color: #607d8b;\n}\n.swiper-pagination.color-bluegray .swiper-pagination-bullet-active,\n.theme-bluegray .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #607d8b;\n}\n.swiper-pagination.color-bluegray .swiper-pagination-progressbar,\n.theme-bluegray .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #607d8b;\n}\n.swiper-pagination.swiper-pagination-progress.bg-bluegray {\n  background-color: rgba(96, 125, 139, 0.25);\n}\n.swiper-button-next.color-bluegray,\n.swiper-container-rtl .swiper-button-prev.color-bluegray,\n.theme-bluegray .swiper-button-next,\n.theme-bluegray .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23607d8b'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-bluegray,\n.swiper-container-rtl .swiper-button-next.color-bluegray,\n.theme-bluegray .swiper-button-prev,\n.theme-bluegray .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23607d8b'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-bluegray .floating-button,\n.theme-bluegray .speed-dial-buttons a,\n.floating-button.theme-bluegray,\n.speed-dial-buttons a.theme-bluegray {\n  color: #fff;\n  background: #607d8b;\n}\nhtml:not(.watch-active-state) .theme-bluegray .floating-button:active,\nhtml:not(.watch-active-state) .theme-bluegray .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-bluegray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-bluegray:active,\n.theme-bluegray .floating-button.active-state,\n.theme-bluegray .speed-dial-buttons a.active-state,\n.floating-button.theme-bluegray.active-state,\n.speed-dial-buttons a.theme-bluegray.active-state {\n  background: #455A64;\n}\n.theme-bluegray .floating-button i,\n.theme-bluegray .speed-dial-buttons a i,\n.floating-button.theme-bluegray i,\n.speed-dial-buttons a.theme-bluegray i {\n  color: inherit;\n}\n.theme-bluegray .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-bluegray input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #607d8b;\n}\n.theme-bluegray .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-bluegray input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #607d8b;\n}\n.theme-bluegray .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-bluegray input[type=\"range\"]::-ms-thumb {\n  background-color: #607d8b;\n}\n.theme-bluegray .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-bluegray input[type=\"range\"]::-ms-fill-lower {\n  background-color: #607d8b;\n}\n.theme-bluegray .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-bluegray input[type=\"range\"]::-moz-range-thumb {\n  background-color: #607d8b;\n}\n.badge.theme-bluegray {\n  background-color: #607d8b;\n  color: #fff;\n}\n.theme-white .button:not(.button-fill) {\n  color: #ffffff;\n}\n.theme-white .navbar .button:not(.button-fill),\n.theme-white.navbar .button:not(.button-fill),\n.theme-white .toolbar .button:not(.button-fill),\n.theme-white.toolbar .button:not(.button-fill),\n.theme-white .subnavbar .button:not(.button-fill),\n.theme-white.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-white .button.button-fill {\n  background: #ffffff;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-white .button.button-fill:active,\n.theme-white .button.button-fill.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.progressbar.theme-white,\n.theme-white .progressbar {\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.progressbar.theme-white span,\n.theme-white .progressbar span {\n  background-color: #ffffff;\n}\n.progressbar-infinite.theme-white,\n.theme-white .progressbar-infinite {\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.progressbar-infinite.theme-white:after,\n.theme-white .progressbar-infinite:after,\n.progressbar-infinite.theme-white:before,\n.theme-white .progressbar-infinite:before {\n  background-color: #ffffff;\n}\n.color-white i.icon,\ni.icon.color-white {\n  color: #ffffff;\n}\ni.icon-next.color-white,\ni.icon-next.theme-white {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-white,\ni.icon-prev.theme-white {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-white,\ni.icon-back.theme-white {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-white,\ni.icon-forward.theme-white {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-white,\ni.icon-bars.theme-white {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-white a,\n.theme-white .card a {\n  color: #ffffff;\n}\n.theme-white .navbar,\n.navbar.theme-white,\n.theme-white .toolbar,\n.toolbar.theme-white,\n.theme-white .subnavbar,\n.subnavbar.theme-white,\n.theme-white .searchbar,\n.searchbar.theme-white {\n  background-color: #ffffff;\n}\n.theme-white .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-white input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.theme-white .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-white input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #ffffff;\n}\n.theme-white label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-white i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-white label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-white label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-white label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-white label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-white label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-white label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-white input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #ffffff;\n  background-color: #ffffff;\n}\n.theme-white label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-white i.icon-form-radio:after {\n  background-color: #ffffff;\n}\n.theme-white label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-white label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-white label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-white label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-white label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-white label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #ffffff;\n}\n.theme-white label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-white label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-white label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-white label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-white label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-white label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-white input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #ffffff;\n}\n.theme-white .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-white input[type=\"checkbox\"]:checked ~ i {\n  border-color: #ffffff;\n  background-color: #ffffff;\n}\n.theme-white .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-white input[type=\"radio\"]:checked ~ i {\n  border-color: #ffffff;\n}\n.theme-white .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-white input[type=\"radio\"]:checked ~ i:after {\n  background-color: #ffffff;\n}\n.theme-white .form-checkbox .ripple-wave,\n.theme-white .form-radio .ripple-wave {\n  background: rgba(255, 255, 255, 0.5);\n}\n.theme-white .focus-state .label,\n.theme-white .focus-state .floating-label {\n  color: #ffffff;\n}\n.theme-white .item-input-field.focus-state:after,\n.theme-white .input-field.focus-state:after,\n.theme-white .item-input-field.not-empty-state:after,\n.theme-white .input-field.not-empty-state:after {\n  background: #ffffff;\n}\n.theme-white .picker-calendar-day.picker-calendar-day-today span {\n  color: #ffffff;\n}\n.theme-white .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #ffffff;\n  color: #fff;\n}\n.theme-white .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #ffffff;\n}\n.theme-white .picker-header {\n  background-color: #ffffff;\n}\n.theme-white .modal-button {\n  color: #ffffff;\n}\n.theme-white .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-white .timeline-item-date {\n  background-color: #ffffff;\n}\n.theme-white .timeline-year-title,\n.theme-white .timeline-month-title {\n  background-color: #ffffff;\n}\n.theme-white .statusbar-overlay {\n  background-color: #ffffff;\n}\n.theme-white .data-table .data-table-header-selected,\n.data-table.theme-white .data-table-header-selected {\n  background: rgba(255, 255, 255, 0.1);\n}\n.theme-white .data-table .data-table-title-selected,\n.data-table.theme-white .data-table-title-selected {\n  color: #ffffff;\n}\n.swiper-pagination.color-white .swiper-pagination-bullet-active,\n.theme-white .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #ffffff;\n}\n.swiper-pagination.color-white .swiper-pagination-progressbar,\n.theme-white .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #ffffff;\n}\n.swiper-pagination.swiper-pagination-progress.bg-white {\n  background-color: rgba(255, 255, 255, 0.25);\n}\n.swiper-button-next.color-white,\n.swiper-container-rtl .swiper-button-prev.color-white,\n.theme-white .swiper-button-next,\n.theme-white .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-white,\n.swiper-container-rtl .swiper-button-next.color-white,\n.theme-white .swiper-button-prev,\n.theme-white .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23ffffff'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-white .floating-button,\n.theme-white .speed-dial-buttons a,\n.floating-button.theme-white,\n.speed-dial-buttons a.theme-white {\n  color: #fff;\n  background: #ffffff;\n}\nhtml:not(.watch-active-state) .theme-white .floating-button:active,\nhtml:not(.watch-active-state) .theme-white .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-white:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-white:active,\n.theme-white .floating-button.active-state,\n.theme-white .speed-dial-buttons a.active-state,\n.floating-button.theme-white.active-state,\n.speed-dial-buttons a.theme-white.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.theme-white .floating-button i,\n.theme-white .speed-dial-buttons a i,\n.floating-button.theme-white i,\n.speed-dial-buttons a.theme-white i {\n  color: inherit;\n}\n.theme-white .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-white input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffffff;\n}\n.theme-white .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-white input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffffff;\n}\n.theme-white .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-white input[type=\"range\"]::-ms-thumb {\n  background-color: #ffffff;\n}\n.theme-white .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-white input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffffff;\n}\n.theme-white .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-white input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffffff;\n}\n.badge.theme-white {\n  background-color: #ffffff;\n  color: #fff;\n}\n.theme-black .button:not(.button-fill) {\n  color: #000000;\n}\n.theme-black .navbar .button:not(.button-fill),\n.theme-black.navbar .button:not(.button-fill),\n.theme-black .toolbar .button:not(.button-fill),\n.theme-black.toolbar .button:not(.button-fill),\n.theme-black .subnavbar .button:not(.button-fill),\n.theme-black.subnavbar .button:not(.button-fill) {\n  color: #fff;\n}\n.theme-black .button.button-fill {\n  background: #000000;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .theme-black .button.button-fill:active,\n.theme-black .button.button-fill.active-state {\n  background: #333;\n}\n.progressbar.theme-black,\n.theme-black .progressbar {\n  background-color: rgba(0, 0, 0, 0.5);\n}\n.progressbar.theme-black span,\n.theme-black .progressbar span {\n  background-color: #000000;\n}\n.progressbar-infinite.theme-black,\n.theme-black .progressbar-infinite {\n  background-color: rgba(0, 0, 0, 0.5);\n}\n.progressbar-infinite.theme-black:after,\n.theme-black .progressbar-infinite:after,\n.progressbar-infinite.theme-black:before,\n.theme-black .progressbar-infinite:before {\n  background-color: #000000;\n}\n.color-black i.icon,\ni.icon.color-black {\n  color: #000000;\n}\ni.icon-next.color-black,\ni.icon-next.theme-black {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23000000'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M10%206L8.59%207.41%2013.17%2012l-4.58%204.59L10%2018l6-6z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-prev.color-black,\ni.icon-prev.theme-black {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23000000'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M15.41%207.41L14%206l-6%206%206%206%201.41-1.41L10.83%2012z'%2F%3E%3Cpath%20d%3D'M0%200h24v24H0z'%20fill%3D'none'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-back.color-black,\ni.icon-back.theme-black {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M20%2011H7.83l5.59-5.59L12%204l-8%208%208%208%201.41-1.41L7.83%2013H20v-2z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-forward.color-black,\ni.icon-forward.theme-black {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M12%204l-1.41%201.41L16.17%2011H4v2h12.17l-5.58%205.59L12%2020l8-8z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n}\ni.icon-bars.color-black,\ni.icon-bars.theme-black {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M3%2018h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-black a,\n.theme-black .card a {\n  color: #000000;\n}\n.theme-black .navbar,\n.navbar.theme-black,\n.theme-black .toolbar,\n.toolbar.theme-black,\n.theme-black .subnavbar,\n.subnavbar.theme-black,\n.theme-black .searchbar,\n.searchbar.theme-black {\n  background-color: #000000;\n}\n.theme-black .label-switch input[type=\"checkbox\"]:checked + .checkbox,\n.label-switch.theme-black input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: rgba(0, 0, 0, 0.5);\n}\n.theme-black .label-switch input[type=\"checkbox\"]:checked + .checkbox:after,\n.label-switch.theme-black input[type=\"checkbox\"]:checked + .checkbox:after {\n  background-color: #000000;\n}\n.theme-black label.label-checkbox i.icon-form-checkbox:after,\nlabel.label-checkbox.theme-black i.icon-form-checkbox:after {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20fill%3D'%23ffffff'%20width%3D'24'%20height%3D'24'%20viewBox%3D'0%200%2024%2024'%3E%3Cpath%20d%3D'M9%2016.17L4.83%2012l-1.42%201.41L9%2019%2021%207l-1.41-1.41z'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-black label.label-checkbox input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"checkbox\"]:checked + .item-media i.icon-form-checkbox,\n.theme-black label.label-checkbox input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"radio\"]:checked + .item-media i.icon-form-checkbox,\n.theme-black label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-black label.label-checkbox input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"radio\"]:checked ~ .item-after i.icon-form-checkbox,\n.theme-black label.label-checkbox input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-checkbox,\n.theme-black label.label-checkbox input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox,\nlabel.label-checkbox.theme-black input[type=\"radio\"]:checked ~ .item-inner i.icon-form-checkbox {\n  border-color: #000000;\n  background-color: #000000;\n}\n.theme-black label.label-radio i.icon-form-radio:after,\nlabel.label-radio.theme-black i.icon-form-radio:after {\n  background-color: #000000;\n}\n.theme-black label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio,\n.theme-black label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked + .item-media i.icon-form-radio,\n.theme-black label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio,\n.theme-black label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio,\n.theme-black label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio,\n.theme-black label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio {\n  border-color: #000000;\n}\n.theme-black label.label-radio input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked + .item-media i.icon-form-radio:after,\n.theme-black label.label-radio input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked + .item-media i.icon-form-radio:after,\n.theme-black label.label-radio input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-black label.label-radio input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked ~ .item-after i.icon-form-radio:after,\n.theme-black label.label-radio input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"checkbox\"]:checked ~ .item-inner i.icon-form-radio:after,\n.theme-black label.label-radio input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after,\nlabel.label-radio.theme-black input[type=\"radio\"]:checked ~ .item-inner i.icon-form-radio:after {\n  background-color: #000000;\n}\n.theme-black .form-checkbox input[type=\"checkbox\"]:checked ~ i,\n.form-checkbox.theme-black input[type=\"checkbox\"]:checked ~ i {\n  border-color: #000000;\n  background-color: #000000;\n}\n.theme-black .form-radio input[type=\"radio\"]:checked ~ i,\n.form-radio.theme-black input[type=\"radio\"]:checked ~ i {\n  border-color: #000000;\n}\n.theme-black .form-radio input[type=\"radio\"]:checked ~ i:after,\n.form-radio.theme-black input[type=\"radio\"]:checked ~ i:after {\n  background-color: #000000;\n}\n.theme-black .form-checkbox .ripple-wave,\n.theme-black .form-radio .ripple-wave {\n  background: rgba(0, 0, 0, 0.5);\n}\n.theme-black .focus-state .label,\n.theme-black .focus-state .floating-label {\n  color: #000000;\n}\n.theme-black .item-input-field.focus-state:after,\n.theme-black .input-field.focus-state:after,\n.theme-black .item-input-field.not-empty-state:after,\n.theme-black .input-field.not-empty-state:after {\n  background: #000000;\n}\n.theme-black .picker-calendar-day.picker-calendar-day-today span {\n  color: #000000;\n}\n.theme-black .picker-calendar-day.picker-calendar-day-selected span {\n  background-color: #000000;\n  color: #fff;\n}\n.theme-black .picker-calendar-day.picker-calendar-day-has-events span:after {\n  background-color: #000000;\n}\n.theme-black .picker-header {\n  background-color: #000000;\n}\n.theme-black .modal-button {\n  color: #000000;\n}\n.theme-black .timeline-horizontal .timeline-item-date,\n.timeline-horizontal.theme-black .timeline-item-date {\n  background-color: #000000;\n}\n.theme-black .timeline-year-title,\n.theme-black .timeline-month-title {\n  background-color: #000000;\n}\n.theme-black .statusbar-overlay {\n  background-color: #000000;\n}\n.theme-black .data-table .data-table-header-selected,\n.data-table.theme-black .data-table-header-selected {\n  background: rgba(0, 0, 0, 0.1);\n}\n.theme-black .data-table .data-table-title-selected,\n.data-table.theme-black .data-table-title-selected {\n  color: #000000;\n}\n.swiper-pagination.color-black .swiper-pagination-bullet-active,\n.theme-black .swiper-pagination .swiper-pagination-bullet-active {\n  background-color: #000000;\n}\n.swiper-pagination.color-black .swiper-pagination-progressbar,\n.theme-black .swiper-pagination .swiper-pagination-progressbar {\n  background-color: #000000;\n}\n.swiper-pagination.swiper-pagination-progress.bg-black {\n  background-color: rgba(0, 0, 0, 0.25);\n}\n.swiper-button-next.color-black,\n.swiper-container-rtl .swiper-button-prev.color-black,\n.theme-black .swiper-button-next,\n.theme-black .swiper-container-rtl .swiper-button-prev {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M27%2C22L27%2C22L5%2C44l-2.1-2.1L22.8%2C22L2.9%2C2.1L5%2C0L27%2C22L27%2C22z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n}\n.swiper-button-prev.color-black,\n.swiper-container-rtl .swiper-button-next.color-black,\n.theme-black .swiper-button-prev,\n.theme-black .swiper-container-rtl .swiper-button-next {\n  background-image: url(\"data:image/svg+xml;charset=utf-8,%3Csvg%20xmlns%3D'http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg'%20viewBox%3D'0%200%2027%2044'%3E%3Cpath%20d%3D'M0%2C22L22%2C0l2.1%2C2.1L4.2%2C22l19.9%2C19.9L22%2C44L0%2C22L0%2C22L0%2C22z'%20fill%3D'%23000000'%2F%3E%3C%2Fsvg%3E\");\n}\n.theme-black .floating-button,\n.theme-black .speed-dial-buttons a,\n.floating-button.theme-black,\n.speed-dial-buttons a.theme-black {\n  color: #fff;\n  background: #000000;\n}\nhtml:not(.watch-active-state) .theme-black .floating-button:active,\nhtml:not(.watch-active-state) .theme-black .speed-dial-buttons a:active,\nhtml:not(.watch-active-state) .floating-button.theme-black:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.theme-black:active,\n.theme-black .floating-button.active-state,\n.theme-black .speed-dial-buttons a.active-state,\n.floating-button.theme-black.active-state,\n.speed-dial-buttons a.theme-black.active-state {\n  background: #333;\n}\n.theme-black .floating-button i,\n.theme-black .speed-dial-buttons a i,\n.floating-button.theme-black i,\n.speed-dial-buttons a.theme-black i {\n  color: inherit;\n}\n.theme-black .range-slider input[type=\"range\"]::-webkit-slider-thumb:before,\n.range-slider.theme-black input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #000000;\n}\n.theme-black .range-slider input[type=\"range\"]::-webkit-slider-thumb,\n.range-slider.theme-black input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #000000;\n}\n.theme-black .range-slider input[type=\"range\"]::-ms-thumb,\n.range-slider.theme-black input[type=\"range\"]::-ms-thumb {\n  background-color: #000000;\n}\n.theme-black .range-slider input[type=\"range\"]::-ms-fill-lower,\n.range-slider.theme-black input[type=\"range\"]::-ms-fill-lower {\n  background-color: #000000;\n}\n.theme-black .range-slider input[type=\"range\"]::-moz-range-thumb,\n.range-slider.theme-black input[type=\"range\"]::-moz-range-thumb {\n  background-color: #000000;\n}\n.badge.theme-black {\n  background-color: #000000;\n  color: #fff;\n}\n/*==========================\nFramework7 Color + Bg + Border\n==========================*/\n.color-red {\n  color: #f44336;\n}\n.list-block .item-link.list-button.color-red,\n.list-button.color-red,\n.list-block .item-link.color-red,\n.tabbar a.active.color-red,\na.color-red {\n  color: #f44336;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-red,\n.label-switch.color-red input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #f44336;\n}\n.button.color-red:not(.button-fill),\n.color-red.buttons-row .button:not(.button-fill) {\n  color: #f44336 !important;\n}\n.button.button-fill.bg-red,\n.button.button-fill.color-red {\n  background: #f44336 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-red:active,\nhtml:not(.watch-active-state) .button.button-fill.color-red:active,\n.button.button-fill.bg-red.active-state,\n.button.button-fill.color-red.active-state {\n  background: #D32F2F !important;\n}\n.progressbar.color-red,\n.progressbar.bg-red {\n  background-color: rgba(244, 67, 54, 0.5);\n}\n.progressbar.color-red span,\n.progressbar.bg-red span {\n  background-color: #f44336;\n}\n.progressbar-infinite.color-red,\n.progressbar-infinite.bg-red {\n  background-color: rgba(244, 67, 54, 0.5);\n}\n.progressbar-infinite.color-red:after,\n.progressbar-infinite.bg-red:after,\n.progressbar-infinite.color-red:before,\n.progressbar-infinite.bg-red:before {\n  background-color: #f44336;\n}\n.color-red i.icon,\ni.icon.color-red {\n  color: #f44336;\n}\n.preloader.color-red svg circle,\n.preloader.preloader-red svg circle {\n  stroke: #f44336;\n}\n.preloader.color-red .preloader-inner-gap,\n.preloader.preloader-red .preloader-inner-gap,\n.preloader.color-red .preloader-inner-half-circle,\n.preloader.preloader-red .preloader-inner-half-circle {\n  border-color: #f44336;\n}\n.bg-red,\na.bg-red,\n.list-block .swipeout-actions-left a.bg-red,\n.list-block .swipeout-actions-right a.bg-red {\n  background-color: #f44336;\n}\nhtml:not(.watch-active-state) .list-block .bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-red .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-red:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-red:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-red:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-red:active,\n.list-block .bg-red .item-link.active-state,\n.list-block a.bg-red .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-red .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-red .item-link.active-state,\n.list-block.bg-red .item-link.active-state,\n.list-blocka.bg-red .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-red .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-red .item-link.active-state,\n.list-block .item-link.bg-red.active-state,\n.list-block .item-linka.bg-red.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-red.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-red.active-state {\n  background: #D32F2F;\n}\n.border-red {\n  border-color: #f44336;\n}\n.list-block .border-red.item-inner:after,\n.list-block ul.border-red:after,\n.border-red:after,\n.list-block .border-red.item-inner:before,\n.list-block ul.border-red:before,\n.border-red:before {\n  background-color: #f44336;\n}\n.floating-button.color-red,\n.speed-dial-buttons a.color-red,\n.floating-button.bg-red,\n.speed-dial-buttons a.bg-red {\n  color: #fff;\n  background: #f44336;\n}\nhtml:not(.watch-active-state) .floating-button.color-red:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-red:active,\nhtml:not(.watch-active-state) .floating-button.bg-red:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-red:active,\n.floating-button.color-red.active-state,\n.speed-dial-buttons a.color-red.active-state,\n.floating-button.bg-red.active-state,\n.speed-dial-buttons a.bg-red.active-state {\n  background: #D32F2F;\n}\n.floating-button.color-red i,\n.speed-dial-buttons a.color-red i,\n.floating-button.bg-red i,\n.speed-dial-buttons a.bg-red i {\n  color: inherit;\n}\n.ripple-red .ripple-wave {\n  background-color: rgba(244, 67, 54, 0.3);\n}\n.range-slider.color-red input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #f44336;\n}\n.range-slider.color-red input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #f44336;\n}\n.range-slider.color-red input[type=\"range\"]::-ms-thumb {\n  background-color: #f44336;\n}\n.range-slider.color-red input[type=\"range\"]::-ms-fill-lower {\n  background-color: #f44336;\n}\n.range-slider.color-red input[type=\"range\"]::-moz-range-thumb {\n  background-color: #f44336;\n}\n.badge.color-red {\n  background-color: #f44336;\n  color: #fff;\n}\n.color-pink {\n  color: #e91e63;\n}\n.list-block .item-link.list-button.color-pink,\n.list-button.color-pink,\n.list-block .item-link.color-pink,\n.tabbar a.active.color-pink,\na.color-pink {\n  color: #e91e63;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-pink,\n.label-switch.color-pink input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #e91e63;\n}\n.button.color-pink:not(.button-fill),\n.color-pink.buttons-row .button:not(.button-fill) {\n  color: #e91e63 !important;\n}\n.button.button-fill.bg-pink,\n.button.button-fill.color-pink {\n  background: #e91e63 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-pink:active,\nhtml:not(.watch-active-state) .button.button-fill.color-pink:active,\n.button.button-fill.bg-pink.active-state,\n.button.button-fill.color-pink.active-state {\n  background: #C2185B !important;\n}\n.progressbar.color-pink,\n.progressbar.bg-pink {\n  background-color: rgba(233, 30, 99, 0.5);\n}\n.progressbar.color-pink span,\n.progressbar.bg-pink span {\n  background-color: #e91e63;\n}\n.progressbar-infinite.color-pink,\n.progressbar-infinite.bg-pink {\n  background-color: rgba(233, 30, 99, 0.5);\n}\n.progressbar-infinite.color-pink:after,\n.progressbar-infinite.bg-pink:after,\n.progressbar-infinite.color-pink:before,\n.progressbar-infinite.bg-pink:before {\n  background-color: #e91e63;\n}\n.color-pink i.icon,\ni.icon.color-pink {\n  color: #e91e63;\n}\n.preloader.color-pink svg circle,\n.preloader.preloader-pink svg circle {\n  stroke: #e91e63;\n}\n.preloader.color-pink .preloader-inner-gap,\n.preloader.preloader-pink .preloader-inner-gap,\n.preloader.color-pink .preloader-inner-half-circle,\n.preloader.preloader-pink .preloader-inner-half-circle {\n  border-color: #e91e63;\n}\n.bg-pink,\na.bg-pink,\n.list-block .swipeout-actions-left a.bg-pink,\n.list-block .swipeout-actions-right a.bg-pink {\n  background-color: #e91e63;\n}\nhtml:not(.watch-active-state) .list-block .bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-pink .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-pink:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-pink:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-pink:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-pink:active,\n.list-block .bg-pink .item-link.active-state,\n.list-block a.bg-pink .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-pink .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-pink .item-link.active-state,\n.list-block.bg-pink .item-link.active-state,\n.list-blocka.bg-pink .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-pink .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-pink .item-link.active-state,\n.list-block .item-link.bg-pink.active-state,\n.list-block .item-linka.bg-pink.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-pink.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-pink.active-state {\n  background: #C2185B;\n}\n.border-pink {\n  border-color: #e91e63;\n}\n.list-block .border-pink.item-inner:after,\n.list-block ul.border-pink:after,\n.border-pink:after,\n.list-block .border-pink.item-inner:before,\n.list-block ul.border-pink:before,\n.border-pink:before {\n  background-color: #e91e63;\n}\n.floating-button.color-pink,\n.speed-dial-buttons a.color-pink,\n.floating-button.bg-pink,\n.speed-dial-buttons a.bg-pink {\n  color: #fff;\n  background: #e91e63;\n}\nhtml:not(.watch-active-state) .floating-button.color-pink:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-pink:active,\nhtml:not(.watch-active-state) .floating-button.bg-pink:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-pink:active,\n.floating-button.color-pink.active-state,\n.speed-dial-buttons a.color-pink.active-state,\n.floating-button.bg-pink.active-state,\n.speed-dial-buttons a.bg-pink.active-state {\n  background: #C2185B;\n}\n.floating-button.color-pink i,\n.speed-dial-buttons a.color-pink i,\n.floating-button.bg-pink i,\n.speed-dial-buttons a.bg-pink i {\n  color: inherit;\n}\n.ripple-pink .ripple-wave {\n  background-color: rgba(233, 30, 99, 0.3);\n}\n.range-slider.color-pink input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #e91e63;\n}\n.range-slider.color-pink input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #e91e63;\n}\n.range-slider.color-pink input[type=\"range\"]::-ms-thumb {\n  background-color: #e91e63;\n}\n.range-slider.color-pink input[type=\"range\"]::-ms-fill-lower {\n  background-color: #e91e63;\n}\n.range-slider.color-pink input[type=\"range\"]::-moz-range-thumb {\n  background-color: #e91e63;\n}\n.badge.color-pink {\n  background-color: #e91e63;\n  color: #fff;\n}\n.color-purple {\n  color: #9c27b0;\n}\n.list-block .item-link.list-button.color-purple,\n.list-button.color-purple,\n.list-block .item-link.color-purple,\n.tabbar a.active.color-purple,\na.color-purple {\n  color: #9c27b0;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-purple,\n.label-switch.color-purple input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #9c27b0;\n}\n.button.color-purple:not(.button-fill),\n.color-purple.buttons-row .button:not(.button-fill) {\n  color: #9c27b0 !important;\n}\n.button.button-fill.bg-purple,\n.button.button-fill.color-purple {\n  background: #9c27b0 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-purple:active,\nhtml:not(.watch-active-state) .button.button-fill.color-purple:active,\n.button.button-fill.bg-purple.active-state,\n.button.button-fill.color-purple.active-state {\n  background: #7B1FA2 !important;\n}\n.progressbar.color-purple,\n.progressbar.bg-purple {\n  background-color: rgba(156, 39, 176, 0.5);\n}\n.progressbar.color-purple span,\n.progressbar.bg-purple span {\n  background-color: #9c27b0;\n}\n.progressbar-infinite.color-purple,\n.progressbar-infinite.bg-purple {\n  background-color: rgba(156, 39, 176, 0.5);\n}\n.progressbar-infinite.color-purple:after,\n.progressbar-infinite.bg-purple:after,\n.progressbar-infinite.color-purple:before,\n.progressbar-infinite.bg-purple:before {\n  background-color: #9c27b0;\n}\n.color-purple i.icon,\ni.icon.color-purple {\n  color: #9c27b0;\n}\n.preloader.color-purple svg circle,\n.preloader.preloader-purple svg circle {\n  stroke: #9c27b0;\n}\n.preloader.color-purple .preloader-inner-gap,\n.preloader.preloader-purple .preloader-inner-gap,\n.preloader.color-purple .preloader-inner-half-circle,\n.preloader.preloader-purple .preloader-inner-half-circle {\n  border-color: #9c27b0;\n}\n.bg-purple,\na.bg-purple,\n.list-block .swipeout-actions-left a.bg-purple,\n.list-block .swipeout-actions-right a.bg-purple {\n  background-color: #9c27b0;\n}\nhtml:not(.watch-active-state) .list-block .bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-purple .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-purple:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-purple:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-purple:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-purple:active,\n.list-block .bg-purple .item-link.active-state,\n.list-block a.bg-purple .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-purple .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-purple .item-link.active-state,\n.list-block.bg-purple .item-link.active-state,\n.list-blocka.bg-purple .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-purple .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-purple .item-link.active-state,\n.list-block .item-link.bg-purple.active-state,\n.list-block .item-linka.bg-purple.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-purple.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-purple.active-state {\n  background: #7B1FA2;\n}\n.border-purple {\n  border-color: #9c27b0;\n}\n.list-block .border-purple.item-inner:after,\n.list-block ul.border-purple:after,\n.border-purple:after,\n.list-block .border-purple.item-inner:before,\n.list-block ul.border-purple:before,\n.border-purple:before {\n  background-color: #9c27b0;\n}\n.floating-button.color-purple,\n.speed-dial-buttons a.color-purple,\n.floating-button.bg-purple,\n.speed-dial-buttons a.bg-purple {\n  color: #fff;\n  background: #9c27b0;\n}\nhtml:not(.watch-active-state) .floating-button.color-purple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-purple:active,\nhtml:not(.watch-active-state) .floating-button.bg-purple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-purple:active,\n.floating-button.color-purple.active-state,\n.speed-dial-buttons a.color-purple.active-state,\n.floating-button.bg-purple.active-state,\n.speed-dial-buttons a.bg-purple.active-state {\n  background: #7B1FA2;\n}\n.floating-button.color-purple i,\n.speed-dial-buttons a.color-purple i,\n.floating-button.bg-purple i,\n.speed-dial-buttons a.bg-purple i {\n  color: inherit;\n}\n.ripple-purple .ripple-wave {\n  background-color: rgba(156, 39, 176, 0.3);\n}\n.range-slider.color-purple input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #9c27b0;\n}\n.range-slider.color-purple input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #9c27b0;\n}\n.range-slider.color-purple input[type=\"range\"]::-ms-thumb {\n  background-color: #9c27b0;\n}\n.range-slider.color-purple input[type=\"range\"]::-ms-fill-lower {\n  background-color: #9c27b0;\n}\n.range-slider.color-purple input[type=\"range\"]::-moz-range-thumb {\n  background-color: #9c27b0;\n}\n.badge.color-purple {\n  background-color: #9c27b0;\n  color: #fff;\n}\n.color-deeppurple {\n  color: #673ab7;\n}\n.list-block .item-link.list-button.color-deeppurple,\n.list-button.color-deeppurple,\n.list-block .item-link.color-deeppurple,\n.tabbar a.active.color-deeppurple,\na.color-deeppurple {\n  color: #673ab7;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-deeppurple,\n.label-switch.color-deeppurple input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #673ab7;\n}\n.button.color-deeppurple:not(.button-fill),\n.color-deeppurple.buttons-row .button:not(.button-fill) {\n  color: #673ab7 !important;\n}\n.button.button-fill.bg-deeppurple,\n.button.button-fill.color-deeppurple {\n  background: #673ab7 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-deeppurple:active,\nhtml:not(.watch-active-state) .button.button-fill.color-deeppurple:active,\n.button.button-fill.bg-deeppurple.active-state,\n.button.button-fill.color-deeppurple.active-state {\n  background: #512DA8 !important;\n}\n.progressbar.color-deeppurple,\n.progressbar.bg-deeppurple {\n  background-color: rgba(103, 58, 183, 0.5);\n}\n.progressbar.color-deeppurple span,\n.progressbar.bg-deeppurple span {\n  background-color: #673ab7;\n}\n.progressbar-infinite.color-deeppurple,\n.progressbar-infinite.bg-deeppurple {\n  background-color: rgba(103, 58, 183, 0.5);\n}\n.progressbar-infinite.color-deeppurple:after,\n.progressbar-infinite.bg-deeppurple:after,\n.progressbar-infinite.color-deeppurple:before,\n.progressbar-infinite.bg-deeppurple:before {\n  background-color: #673ab7;\n}\n.color-deeppurple i.icon,\ni.icon.color-deeppurple {\n  color: #673ab7;\n}\n.preloader.color-deeppurple svg circle,\n.preloader.preloader-deeppurple svg circle {\n  stroke: #673ab7;\n}\n.preloader.color-deeppurple .preloader-inner-gap,\n.preloader.preloader-deeppurple .preloader-inner-gap,\n.preloader.color-deeppurple .preloader-inner-half-circle,\n.preloader.preloader-deeppurple .preloader-inner-half-circle {\n  border-color: #673ab7;\n}\n.bg-deeppurple,\na.bg-deeppurple,\n.list-block .swipeout-actions-left a.bg-deeppurple,\n.list-block .swipeout-actions-right a.bg-deeppurple {\n  background-color: #673ab7;\n}\nhtml:not(.watch-active-state) .list-block .bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-deeppurple .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-deeppurple:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-deeppurple:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-deeppurple:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-deeppurple:active,\n.list-block .bg-deeppurple .item-link.active-state,\n.list-block a.bg-deeppurple .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-deeppurple .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-deeppurple .item-link.active-state,\n.list-block.bg-deeppurple .item-link.active-state,\n.list-blocka.bg-deeppurple .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-deeppurple .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-deeppurple .item-link.active-state,\n.list-block .item-link.bg-deeppurple.active-state,\n.list-block .item-linka.bg-deeppurple.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-deeppurple.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-deeppurple.active-state {\n  background: #512DA8;\n}\n.border-deeppurple {\n  border-color: #673ab7;\n}\n.list-block .border-deeppurple.item-inner:after,\n.list-block ul.border-deeppurple:after,\n.border-deeppurple:after,\n.list-block .border-deeppurple.item-inner:before,\n.list-block ul.border-deeppurple:before,\n.border-deeppurple:before {\n  background-color: #673ab7;\n}\n.floating-button.color-deeppurple,\n.speed-dial-buttons a.color-deeppurple,\n.floating-button.bg-deeppurple,\n.speed-dial-buttons a.bg-deeppurple {\n  color: #fff;\n  background: #673ab7;\n}\nhtml:not(.watch-active-state) .floating-button.color-deeppurple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-deeppurple:active,\nhtml:not(.watch-active-state) .floating-button.bg-deeppurple:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-deeppurple:active,\n.floating-button.color-deeppurple.active-state,\n.speed-dial-buttons a.color-deeppurple.active-state,\n.floating-button.bg-deeppurple.active-state,\n.speed-dial-buttons a.bg-deeppurple.active-state {\n  background: #512DA8;\n}\n.floating-button.color-deeppurple i,\n.speed-dial-buttons a.color-deeppurple i,\n.floating-button.bg-deeppurple i,\n.speed-dial-buttons a.bg-deeppurple i {\n  color: inherit;\n}\n.ripple-deeppurple .ripple-wave {\n  background-color: rgba(103, 58, 183, 0.3);\n}\n.range-slider.color-deeppurple input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #673ab7;\n}\n.range-slider.color-deeppurple input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #673ab7;\n}\n.range-slider.color-deeppurple input[type=\"range\"]::-ms-thumb {\n  background-color: #673ab7;\n}\n.range-slider.color-deeppurple input[type=\"range\"]::-ms-fill-lower {\n  background-color: #673ab7;\n}\n.range-slider.color-deeppurple input[type=\"range\"]::-moz-range-thumb {\n  background-color: #673ab7;\n}\n.badge.color-deeppurple {\n  background-color: #673ab7;\n  color: #fff;\n}\n.color-indigo {\n  color: #3f51b5;\n}\n.list-block .item-link.list-button.color-indigo,\n.list-button.color-indigo,\n.list-block .item-link.color-indigo,\n.tabbar a.active.color-indigo,\na.color-indigo {\n  color: #3f51b5;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-indigo,\n.label-switch.color-indigo input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #3f51b5;\n}\n.button.color-indigo:not(.button-fill),\n.color-indigo.buttons-row .button:not(.button-fill) {\n  color: #3f51b5 !important;\n}\n.button.button-fill.bg-indigo,\n.button.button-fill.color-indigo {\n  background: #3f51b5 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-indigo:active,\nhtml:not(.watch-active-state) .button.button-fill.color-indigo:active,\n.button.button-fill.bg-indigo.active-state,\n.button.button-fill.color-indigo.active-state {\n  background: #303F9F !important;\n}\n.progressbar.color-indigo,\n.progressbar.bg-indigo {\n  background-color: rgba(63, 81, 181, 0.5);\n}\n.progressbar.color-indigo span,\n.progressbar.bg-indigo span {\n  background-color: #3f51b5;\n}\n.progressbar-infinite.color-indigo,\n.progressbar-infinite.bg-indigo {\n  background-color: rgba(63, 81, 181, 0.5);\n}\n.progressbar-infinite.color-indigo:after,\n.progressbar-infinite.bg-indigo:after,\n.progressbar-infinite.color-indigo:before,\n.progressbar-infinite.bg-indigo:before {\n  background-color: #3f51b5;\n}\n.color-indigo i.icon,\ni.icon.color-indigo {\n  color: #3f51b5;\n}\n.preloader.color-indigo svg circle,\n.preloader.preloader-indigo svg circle {\n  stroke: #3f51b5;\n}\n.preloader.color-indigo .preloader-inner-gap,\n.preloader.preloader-indigo .preloader-inner-gap,\n.preloader.color-indigo .preloader-inner-half-circle,\n.preloader.preloader-indigo .preloader-inner-half-circle {\n  border-color: #3f51b5;\n}\n.bg-indigo,\na.bg-indigo,\n.list-block .swipeout-actions-left a.bg-indigo,\n.list-block .swipeout-actions-right a.bg-indigo {\n  background-color: #3f51b5;\n}\nhtml:not(.watch-active-state) .list-block .bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-indigo .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-indigo:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-indigo:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-indigo:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-indigo:active,\n.list-block .bg-indigo .item-link.active-state,\n.list-block a.bg-indigo .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-indigo .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-indigo .item-link.active-state,\n.list-block.bg-indigo .item-link.active-state,\n.list-blocka.bg-indigo .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-indigo .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-indigo .item-link.active-state,\n.list-block .item-link.bg-indigo.active-state,\n.list-block .item-linka.bg-indigo.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-indigo.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-indigo.active-state {\n  background: #303F9F;\n}\n.border-indigo {\n  border-color: #3f51b5;\n}\n.list-block .border-indigo.item-inner:after,\n.list-block ul.border-indigo:after,\n.border-indigo:after,\n.list-block .border-indigo.item-inner:before,\n.list-block ul.border-indigo:before,\n.border-indigo:before {\n  background-color: #3f51b5;\n}\n.floating-button.color-indigo,\n.speed-dial-buttons a.color-indigo,\n.floating-button.bg-indigo,\n.speed-dial-buttons a.bg-indigo {\n  color: #fff;\n  background: #3f51b5;\n}\nhtml:not(.watch-active-state) .floating-button.color-indigo:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-indigo:active,\nhtml:not(.watch-active-state) .floating-button.bg-indigo:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-indigo:active,\n.floating-button.color-indigo.active-state,\n.speed-dial-buttons a.color-indigo.active-state,\n.floating-button.bg-indigo.active-state,\n.speed-dial-buttons a.bg-indigo.active-state {\n  background: #303F9F;\n}\n.floating-button.color-indigo i,\n.speed-dial-buttons a.color-indigo i,\n.floating-button.bg-indigo i,\n.speed-dial-buttons a.bg-indigo i {\n  color: inherit;\n}\n.ripple-indigo .ripple-wave {\n  background-color: rgba(63, 81, 181, 0.3);\n}\n.range-slider.color-indigo input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #3f51b5;\n}\n.range-slider.color-indigo input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #3f51b5;\n}\n.range-slider.color-indigo input[type=\"range\"]::-ms-thumb {\n  background-color: #3f51b5;\n}\n.range-slider.color-indigo input[type=\"range\"]::-ms-fill-lower {\n  background-color: #3f51b5;\n}\n.range-slider.color-indigo input[type=\"range\"]::-moz-range-thumb {\n  background-color: #3f51b5;\n}\n.badge.color-indigo {\n  background-color: #3f51b5;\n  color: #fff;\n}\n.color-blue {\n  color: #2196f3;\n}\n.list-block .item-link.list-button.color-blue,\n.list-button.color-blue,\n.list-block .item-link.color-blue,\n.tabbar a.active.color-blue,\na.color-blue {\n  color: #2196f3;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-blue,\n.label-switch.color-blue input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #2196f3;\n}\n.button.color-blue:not(.button-fill),\n.color-blue.buttons-row .button:not(.button-fill) {\n  color: #2196f3 !important;\n}\n.button.button-fill.bg-blue,\n.button.button-fill.color-blue {\n  background: #2196f3 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-blue:active,\nhtml:not(.watch-active-state) .button.button-fill.color-blue:active,\n.button.button-fill.bg-blue.active-state,\n.button.button-fill.color-blue.active-state {\n  background: #1976D2 !important;\n}\n.progressbar.color-blue,\n.progressbar.bg-blue {\n  background-color: rgba(33, 150, 243, 0.5);\n}\n.progressbar.color-blue span,\n.progressbar.bg-blue span {\n  background-color: #2196f3;\n}\n.progressbar-infinite.color-blue,\n.progressbar-infinite.bg-blue {\n  background-color: rgba(33, 150, 243, 0.5);\n}\n.progressbar-infinite.color-blue:after,\n.progressbar-infinite.bg-blue:after,\n.progressbar-infinite.color-blue:before,\n.progressbar-infinite.bg-blue:before {\n  background-color: #2196f3;\n}\n.color-blue i.icon,\ni.icon.color-blue {\n  color: #2196f3;\n}\n.preloader.color-blue svg circle,\n.preloader.preloader-blue svg circle {\n  stroke: #2196f3;\n}\n.preloader.color-blue .preloader-inner-gap,\n.preloader.preloader-blue .preloader-inner-gap,\n.preloader.color-blue .preloader-inner-half-circle,\n.preloader.preloader-blue .preloader-inner-half-circle {\n  border-color: #2196f3;\n}\n.bg-blue,\na.bg-blue,\n.list-block .swipeout-actions-left a.bg-blue,\n.list-block .swipeout-actions-right a.bg-blue {\n  background-color: #2196f3;\n}\nhtml:not(.watch-active-state) .list-block .bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-blue .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-blue:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-blue:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-blue:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-blue:active,\n.list-block .bg-blue .item-link.active-state,\n.list-block a.bg-blue .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-blue .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-blue .item-link.active-state,\n.list-block.bg-blue .item-link.active-state,\n.list-blocka.bg-blue .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-blue .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-blue .item-link.active-state,\n.list-block .item-link.bg-blue.active-state,\n.list-block .item-linka.bg-blue.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-blue.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-blue.active-state {\n  background: #1976D2;\n}\n.border-blue {\n  border-color: #2196f3;\n}\n.list-block .border-blue.item-inner:after,\n.list-block ul.border-blue:after,\n.border-blue:after,\n.list-block .border-blue.item-inner:before,\n.list-block ul.border-blue:before,\n.border-blue:before {\n  background-color: #2196f3;\n}\n.floating-button.color-blue,\n.speed-dial-buttons a.color-blue,\n.floating-button.bg-blue,\n.speed-dial-buttons a.bg-blue {\n  color: #fff;\n  background: #2196f3;\n}\nhtml:not(.watch-active-state) .floating-button.color-blue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-blue:active,\nhtml:not(.watch-active-state) .floating-button.bg-blue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-blue:active,\n.floating-button.color-blue.active-state,\n.speed-dial-buttons a.color-blue.active-state,\n.floating-button.bg-blue.active-state,\n.speed-dial-buttons a.bg-blue.active-state {\n  background: #1976D2;\n}\n.floating-button.color-blue i,\n.speed-dial-buttons a.color-blue i,\n.floating-button.bg-blue i,\n.speed-dial-buttons a.bg-blue i {\n  color: inherit;\n}\n.ripple-blue .ripple-wave {\n  background-color: rgba(33, 150, 243, 0.3);\n}\n.range-slider.color-blue input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #2196f3;\n}\n.range-slider.color-blue input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #2196f3;\n}\n.range-slider.color-blue input[type=\"range\"]::-ms-thumb {\n  background-color: #2196f3;\n}\n.range-slider.color-blue input[type=\"range\"]::-ms-fill-lower {\n  background-color: #2196f3;\n}\n.range-slider.color-blue input[type=\"range\"]::-moz-range-thumb {\n  background-color: #2196f3;\n}\n.badge.color-blue {\n  background-color: #2196f3;\n  color: #fff;\n}\n.color-lightblue {\n  color: #03a9f4;\n}\n.list-block .item-link.list-button.color-lightblue,\n.list-button.color-lightblue,\n.list-block .item-link.color-lightblue,\n.tabbar a.active.color-lightblue,\na.color-lightblue {\n  color: #03a9f4;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-lightblue,\n.label-switch.color-lightblue input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #03a9f4;\n}\n.button.color-lightblue:not(.button-fill),\n.color-lightblue.buttons-row .button:not(.button-fill) {\n  color: #03a9f4 !important;\n}\n.button.button-fill.bg-lightblue,\n.button.button-fill.color-lightblue {\n  background: #03a9f4 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-lightblue:active,\nhtml:not(.watch-active-state) .button.button-fill.color-lightblue:active,\n.button.button-fill.bg-lightblue.active-state,\n.button.button-fill.color-lightblue.active-state {\n  background: #0288D1 !important;\n}\n.progressbar.color-lightblue,\n.progressbar.bg-lightblue {\n  background-color: rgba(3, 169, 244, 0.5);\n}\n.progressbar.color-lightblue span,\n.progressbar.bg-lightblue span {\n  background-color: #03a9f4;\n}\n.progressbar-infinite.color-lightblue,\n.progressbar-infinite.bg-lightblue {\n  background-color: rgba(3, 169, 244, 0.5);\n}\n.progressbar-infinite.color-lightblue:after,\n.progressbar-infinite.bg-lightblue:after,\n.progressbar-infinite.color-lightblue:before,\n.progressbar-infinite.bg-lightblue:before {\n  background-color: #03a9f4;\n}\n.color-lightblue i.icon,\ni.icon.color-lightblue {\n  color: #03a9f4;\n}\n.preloader.color-lightblue svg circle,\n.preloader.preloader-lightblue svg circle {\n  stroke: #03a9f4;\n}\n.preloader.color-lightblue .preloader-inner-gap,\n.preloader.preloader-lightblue .preloader-inner-gap,\n.preloader.color-lightblue .preloader-inner-half-circle,\n.preloader.preloader-lightblue .preloader-inner-half-circle {\n  border-color: #03a9f4;\n}\n.bg-lightblue,\na.bg-lightblue,\n.list-block .swipeout-actions-left a.bg-lightblue,\n.list-block .swipeout-actions-right a.bg-lightblue {\n  background-color: #03a9f4;\n}\nhtml:not(.watch-active-state) .list-block .bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-lightblue .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-lightblue:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-lightblue:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-lightblue:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-lightblue:active,\n.list-block .bg-lightblue .item-link.active-state,\n.list-block a.bg-lightblue .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-lightblue .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-lightblue .item-link.active-state,\n.list-block.bg-lightblue .item-link.active-state,\n.list-blocka.bg-lightblue .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-lightblue .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-lightblue .item-link.active-state,\n.list-block .item-link.bg-lightblue.active-state,\n.list-block .item-linka.bg-lightblue.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-lightblue.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-lightblue.active-state {\n  background: #0288D1;\n}\n.border-lightblue {\n  border-color: #03a9f4;\n}\n.list-block .border-lightblue.item-inner:after,\n.list-block ul.border-lightblue:after,\n.border-lightblue:after,\n.list-block .border-lightblue.item-inner:before,\n.list-block ul.border-lightblue:before,\n.border-lightblue:before {\n  background-color: #03a9f4;\n}\n.floating-button.color-lightblue,\n.speed-dial-buttons a.color-lightblue,\n.floating-button.bg-lightblue,\n.speed-dial-buttons a.bg-lightblue {\n  color: #fff;\n  background: #03a9f4;\n}\nhtml:not(.watch-active-state) .floating-button.color-lightblue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-lightblue:active,\nhtml:not(.watch-active-state) .floating-button.bg-lightblue:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-lightblue:active,\n.floating-button.color-lightblue.active-state,\n.speed-dial-buttons a.color-lightblue.active-state,\n.floating-button.bg-lightblue.active-state,\n.speed-dial-buttons a.bg-lightblue.active-state {\n  background: #0288D1;\n}\n.floating-button.color-lightblue i,\n.speed-dial-buttons a.color-lightblue i,\n.floating-button.bg-lightblue i,\n.speed-dial-buttons a.bg-lightblue i {\n  color: inherit;\n}\n.ripple-lightblue .ripple-wave {\n  background-color: rgba(3, 169, 244, 0.3);\n}\n.range-slider.color-lightblue input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #03a9f4;\n}\n.range-slider.color-lightblue input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #03a9f4;\n}\n.range-slider.color-lightblue input[type=\"range\"]::-ms-thumb {\n  background-color: #03a9f4;\n}\n.range-slider.color-lightblue input[type=\"range\"]::-ms-fill-lower {\n  background-color: #03a9f4;\n}\n.range-slider.color-lightblue input[type=\"range\"]::-moz-range-thumb {\n  background-color: #03a9f4;\n}\n.badge.color-lightblue {\n  background-color: #03a9f4;\n  color: #fff;\n}\n.color-cyan {\n  color: #00bcd4;\n}\n.list-block .item-link.list-button.color-cyan,\n.list-button.color-cyan,\n.list-block .item-link.color-cyan,\n.tabbar a.active.color-cyan,\na.color-cyan {\n  color: #00bcd4;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-cyan,\n.label-switch.color-cyan input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #00bcd4;\n}\n.button.color-cyan:not(.button-fill),\n.color-cyan.buttons-row .button:not(.button-fill) {\n  color: #00bcd4 !important;\n}\n.button.button-fill.bg-cyan,\n.button.button-fill.color-cyan {\n  background: #00bcd4 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-cyan:active,\nhtml:not(.watch-active-state) .button.button-fill.color-cyan:active,\n.button.button-fill.bg-cyan.active-state,\n.button.button-fill.color-cyan.active-state {\n  background: #0097A7 !important;\n}\n.progressbar.color-cyan,\n.progressbar.bg-cyan {\n  background-color: rgba(0, 188, 212, 0.5);\n}\n.progressbar.color-cyan span,\n.progressbar.bg-cyan span {\n  background-color: #00bcd4;\n}\n.progressbar-infinite.color-cyan,\n.progressbar-infinite.bg-cyan {\n  background-color: rgba(0, 188, 212, 0.5);\n}\n.progressbar-infinite.color-cyan:after,\n.progressbar-infinite.bg-cyan:after,\n.progressbar-infinite.color-cyan:before,\n.progressbar-infinite.bg-cyan:before {\n  background-color: #00bcd4;\n}\n.color-cyan i.icon,\ni.icon.color-cyan {\n  color: #00bcd4;\n}\n.preloader.color-cyan svg circle,\n.preloader.preloader-cyan svg circle {\n  stroke: #00bcd4;\n}\n.preloader.color-cyan .preloader-inner-gap,\n.preloader.preloader-cyan .preloader-inner-gap,\n.preloader.color-cyan .preloader-inner-half-circle,\n.preloader.preloader-cyan .preloader-inner-half-circle {\n  border-color: #00bcd4;\n}\n.bg-cyan,\na.bg-cyan,\n.list-block .swipeout-actions-left a.bg-cyan,\n.list-block .swipeout-actions-right a.bg-cyan {\n  background-color: #00bcd4;\n}\nhtml:not(.watch-active-state) .list-block .bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-cyan .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-cyan:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-cyan:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-cyan:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-cyan:active,\n.list-block .bg-cyan .item-link.active-state,\n.list-block a.bg-cyan .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-cyan .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-cyan .item-link.active-state,\n.list-block.bg-cyan .item-link.active-state,\n.list-blocka.bg-cyan .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-cyan .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-cyan .item-link.active-state,\n.list-block .item-link.bg-cyan.active-state,\n.list-block .item-linka.bg-cyan.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-cyan.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-cyan.active-state {\n  background: #0097A7;\n}\n.border-cyan {\n  border-color: #00bcd4;\n}\n.list-block .border-cyan.item-inner:after,\n.list-block ul.border-cyan:after,\n.border-cyan:after,\n.list-block .border-cyan.item-inner:before,\n.list-block ul.border-cyan:before,\n.border-cyan:before {\n  background-color: #00bcd4;\n}\n.floating-button.color-cyan,\n.speed-dial-buttons a.color-cyan,\n.floating-button.bg-cyan,\n.speed-dial-buttons a.bg-cyan {\n  color: #fff;\n  background: #00bcd4;\n}\nhtml:not(.watch-active-state) .floating-button.color-cyan:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-cyan:active,\nhtml:not(.watch-active-state) .floating-button.bg-cyan:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-cyan:active,\n.floating-button.color-cyan.active-state,\n.speed-dial-buttons a.color-cyan.active-state,\n.floating-button.bg-cyan.active-state,\n.speed-dial-buttons a.bg-cyan.active-state {\n  background: #0097A7;\n}\n.floating-button.color-cyan i,\n.speed-dial-buttons a.color-cyan i,\n.floating-button.bg-cyan i,\n.speed-dial-buttons a.bg-cyan i {\n  color: inherit;\n}\n.ripple-cyan .ripple-wave {\n  background-color: rgba(0, 188, 212, 0.3);\n}\n.range-slider.color-cyan input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #00bcd4;\n}\n.range-slider.color-cyan input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #00bcd4;\n}\n.range-slider.color-cyan input[type=\"range\"]::-ms-thumb {\n  background-color: #00bcd4;\n}\n.range-slider.color-cyan input[type=\"range\"]::-ms-fill-lower {\n  background-color: #00bcd4;\n}\n.range-slider.color-cyan input[type=\"range\"]::-moz-range-thumb {\n  background-color: #00bcd4;\n}\n.badge.color-cyan {\n  background-color: #00bcd4;\n  color: #fff;\n}\n.color-teal {\n  color: #009688;\n}\n.list-block .item-link.list-button.color-teal,\n.list-button.color-teal,\n.list-block .item-link.color-teal,\n.tabbar a.active.color-teal,\na.color-teal {\n  color: #009688;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-teal,\n.label-switch.color-teal input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #009688;\n}\n.button.color-teal:not(.button-fill),\n.color-teal.buttons-row .button:not(.button-fill) {\n  color: #009688 !important;\n}\n.button.button-fill.bg-teal,\n.button.button-fill.color-teal {\n  background: #009688 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-teal:active,\nhtml:not(.watch-active-state) .button.button-fill.color-teal:active,\n.button.button-fill.bg-teal.active-state,\n.button.button-fill.color-teal.active-state {\n  background: #00897B !important;\n}\n.progressbar.color-teal,\n.progressbar.bg-teal {\n  background-color: rgba(0, 150, 136, 0.5);\n}\n.progressbar.color-teal span,\n.progressbar.bg-teal span {\n  background-color: #009688;\n}\n.progressbar-infinite.color-teal,\n.progressbar-infinite.bg-teal {\n  background-color: rgba(0, 150, 136, 0.5);\n}\n.progressbar-infinite.color-teal:after,\n.progressbar-infinite.bg-teal:after,\n.progressbar-infinite.color-teal:before,\n.progressbar-infinite.bg-teal:before {\n  background-color: #009688;\n}\n.color-teal i.icon,\ni.icon.color-teal {\n  color: #009688;\n}\n.preloader.color-teal svg circle,\n.preloader.preloader-teal svg circle {\n  stroke: #009688;\n}\n.preloader.color-teal .preloader-inner-gap,\n.preloader.preloader-teal .preloader-inner-gap,\n.preloader.color-teal .preloader-inner-half-circle,\n.preloader.preloader-teal .preloader-inner-half-circle {\n  border-color: #009688;\n}\n.bg-teal,\na.bg-teal,\n.list-block .swipeout-actions-left a.bg-teal,\n.list-block .swipeout-actions-right a.bg-teal {\n  background-color: #009688;\n}\nhtml:not(.watch-active-state) .list-block .bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-teal .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-teal:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-teal:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-teal:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-teal:active,\n.list-block .bg-teal .item-link.active-state,\n.list-block a.bg-teal .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-teal .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-teal .item-link.active-state,\n.list-block.bg-teal .item-link.active-state,\n.list-blocka.bg-teal .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-teal .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-teal .item-link.active-state,\n.list-block .item-link.bg-teal.active-state,\n.list-block .item-linka.bg-teal.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-teal.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-teal.active-state {\n  background: #00897B;\n}\n.border-teal {\n  border-color: #009688;\n}\n.list-block .border-teal.item-inner:after,\n.list-block ul.border-teal:after,\n.border-teal:after,\n.list-block .border-teal.item-inner:before,\n.list-block ul.border-teal:before,\n.border-teal:before {\n  background-color: #009688;\n}\n.floating-button.color-teal,\n.speed-dial-buttons a.color-teal,\n.floating-button.bg-teal,\n.speed-dial-buttons a.bg-teal {\n  color: #fff;\n  background: #009688;\n}\nhtml:not(.watch-active-state) .floating-button.color-teal:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-teal:active,\nhtml:not(.watch-active-state) .floating-button.bg-teal:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-teal:active,\n.floating-button.color-teal.active-state,\n.speed-dial-buttons a.color-teal.active-state,\n.floating-button.bg-teal.active-state,\n.speed-dial-buttons a.bg-teal.active-state {\n  background: #00897B;\n}\n.floating-button.color-teal i,\n.speed-dial-buttons a.color-teal i,\n.floating-button.bg-teal i,\n.speed-dial-buttons a.bg-teal i {\n  color: inherit;\n}\n.ripple-teal .ripple-wave {\n  background-color: rgba(0, 150, 136, 0.3);\n}\n.range-slider.color-teal input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #009688;\n}\n.range-slider.color-teal input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #009688;\n}\n.range-slider.color-teal input[type=\"range\"]::-ms-thumb {\n  background-color: #009688;\n}\n.range-slider.color-teal input[type=\"range\"]::-ms-fill-lower {\n  background-color: #009688;\n}\n.range-slider.color-teal input[type=\"range\"]::-moz-range-thumb {\n  background-color: #009688;\n}\n.badge.color-teal {\n  background-color: #009688;\n  color: #fff;\n}\n.color-green {\n  color: #4caf50;\n}\n.list-block .item-link.list-button.color-green,\n.list-button.color-green,\n.list-block .item-link.color-green,\n.tabbar a.active.color-green,\na.color-green {\n  color: #4caf50;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-green,\n.label-switch.color-green input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #4caf50;\n}\n.button.color-green:not(.button-fill),\n.color-green.buttons-row .button:not(.button-fill) {\n  color: #4caf50 !important;\n}\n.button.button-fill.bg-green,\n.button.button-fill.color-green {\n  background: #4caf50 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-green:active,\nhtml:not(.watch-active-state) .button.button-fill.color-green:active,\n.button.button-fill.bg-green.active-state,\n.button.button-fill.color-green.active-state {\n  background: #388E3C !important;\n}\n.progressbar.color-green,\n.progressbar.bg-green {\n  background-color: rgba(76, 175, 80, 0.5);\n}\n.progressbar.color-green span,\n.progressbar.bg-green span {\n  background-color: #4caf50;\n}\n.progressbar-infinite.color-green,\n.progressbar-infinite.bg-green {\n  background-color: rgba(76, 175, 80, 0.5);\n}\n.progressbar-infinite.color-green:after,\n.progressbar-infinite.bg-green:after,\n.progressbar-infinite.color-green:before,\n.progressbar-infinite.bg-green:before {\n  background-color: #4caf50;\n}\n.color-green i.icon,\ni.icon.color-green {\n  color: #4caf50;\n}\n.preloader.color-green svg circle,\n.preloader.preloader-green svg circle {\n  stroke: #4caf50;\n}\n.preloader.color-green .preloader-inner-gap,\n.preloader.preloader-green .preloader-inner-gap,\n.preloader.color-green .preloader-inner-half-circle,\n.preloader.preloader-green .preloader-inner-half-circle {\n  border-color: #4caf50;\n}\n.bg-green,\na.bg-green,\n.list-block .swipeout-actions-left a.bg-green,\n.list-block .swipeout-actions-right a.bg-green {\n  background-color: #4caf50;\n}\nhtml:not(.watch-active-state) .list-block .bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-green .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-green:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-green:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-green:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-green:active,\n.list-block .bg-green .item-link.active-state,\n.list-block a.bg-green .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-green .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-green .item-link.active-state,\n.list-block.bg-green .item-link.active-state,\n.list-blocka.bg-green .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-green .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-green .item-link.active-state,\n.list-block .item-link.bg-green.active-state,\n.list-block .item-linka.bg-green.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-green.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-green.active-state {\n  background: #388E3C;\n}\n.border-green {\n  border-color: #4caf50;\n}\n.list-block .border-green.item-inner:after,\n.list-block ul.border-green:after,\n.border-green:after,\n.list-block .border-green.item-inner:before,\n.list-block ul.border-green:before,\n.border-green:before {\n  background-color: #4caf50;\n}\n.floating-button.color-green,\n.speed-dial-buttons a.color-green,\n.floating-button.bg-green,\n.speed-dial-buttons a.bg-green {\n  color: #fff;\n  background: #4caf50;\n}\nhtml:not(.watch-active-state) .floating-button.color-green:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-green:active,\nhtml:not(.watch-active-state) .floating-button.bg-green:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-green:active,\n.floating-button.color-green.active-state,\n.speed-dial-buttons a.color-green.active-state,\n.floating-button.bg-green.active-state,\n.speed-dial-buttons a.bg-green.active-state {\n  background: #388E3C;\n}\n.floating-button.color-green i,\n.speed-dial-buttons a.color-green i,\n.floating-button.bg-green i,\n.speed-dial-buttons a.bg-green i {\n  color: inherit;\n}\n.ripple-green .ripple-wave {\n  background-color: rgba(76, 175, 80, 0.3);\n}\n.range-slider.color-green input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #4caf50;\n}\n.range-slider.color-green input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #4caf50;\n}\n.range-slider.color-green input[type=\"range\"]::-ms-thumb {\n  background-color: #4caf50;\n}\n.range-slider.color-green input[type=\"range\"]::-ms-fill-lower {\n  background-color: #4caf50;\n}\n.range-slider.color-green input[type=\"range\"]::-moz-range-thumb {\n  background-color: #4caf50;\n}\n.badge.color-green {\n  background-color: #4caf50;\n  color: #fff;\n}\n.color-lightgreen {\n  color: #8bc34a;\n}\n.list-block .item-link.list-button.color-lightgreen,\n.list-button.color-lightgreen,\n.list-block .item-link.color-lightgreen,\n.tabbar a.active.color-lightgreen,\na.color-lightgreen {\n  color: #8bc34a;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-lightgreen,\n.label-switch.color-lightgreen input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #8bc34a;\n}\n.button.color-lightgreen:not(.button-fill),\n.color-lightgreen.buttons-row .button:not(.button-fill) {\n  color: #8bc34a !important;\n}\n.button.button-fill.bg-lightgreen,\n.button.button-fill.color-lightgreen {\n  background: #8bc34a !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-lightgreen:active,\nhtml:not(.watch-active-state) .button.button-fill.color-lightgreen:active,\n.button.button-fill.bg-lightgreen.active-state,\n.button.button-fill.color-lightgreen.active-state {\n  background: #689F38 !important;\n}\n.progressbar.color-lightgreen,\n.progressbar.bg-lightgreen {\n  background-color: rgba(139, 195, 74, 0.5);\n}\n.progressbar.color-lightgreen span,\n.progressbar.bg-lightgreen span {\n  background-color: #8bc34a;\n}\n.progressbar-infinite.color-lightgreen,\n.progressbar-infinite.bg-lightgreen {\n  background-color: rgba(139, 195, 74, 0.5);\n}\n.progressbar-infinite.color-lightgreen:after,\n.progressbar-infinite.bg-lightgreen:after,\n.progressbar-infinite.color-lightgreen:before,\n.progressbar-infinite.bg-lightgreen:before {\n  background-color: #8bc34a;\n}\n.color-lightgreen i.icon,\ni.icon.color-lightgreen {\n  color: #8bc34a;\n}\n.preloader.color-lightgreen svg circle,\n.preloader.preloader-lightgreen svg circle {\n  stroke: #8bc34a;\n}\n.preloader.color-lightgreen .preloader-inner-gap,\n.preloader.preloader-lightgreen .preloader-inner-gap,\n.preloader.color-lightgreen .preloader-inner-half-circle,\n.preloader.preloader-lightgreen .preloader-inner-half-circle {\n  border-color: #8bc34a;\n}\n.bg-lightgreen,\na.bg-lightgreen,\n.list-block .swipeout-actions-left a.bg-lightgreen,\n.list-block .swipeout-actions-right a.bg-lightgreen {\n  background-color: #8bc34a;\n}\nhtml:not(.watch-active-state) .list-block .bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-lightgreen .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-lightgreen:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-lightgreen:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-lightgreen:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-lightgreen:active,\n.list-block .bg-lightgreen .item-link.active-state,\n.list-block a.bg-lightgreen .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-lightgreen .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-lightgreen .item-link.active-state,\n.list-block.bg-lightgreen .item-link.active-state,\n.list-blocka.bg-lightgreen .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-lightgreen .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-lightgreen .item-link.active-state,\n.list-block .item-link.bg-lightgreen.active-state,\n.list-block .item-linka.bg-lightgreen.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-lightgreen.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-lightgreen.active-state {\n  background: #689F38;\n}\n.border-lightgreen {\n  border-color: #8bc34a;\n}\n.list-block .border-lightgreen.item-inner:after,\n.list-block ul.border-lightgreen:after,\n.border-lightgreen:after,\n.list-block .border-lightgreen.item-inner:before,\n.list-block ul.border-lightgreen:before,\n.border-lightgreen:before {\n  background-color: #8bc34a;\n}\n.floating-button.color-lightgreen,\n.speed-dial-buttons a.color-lightgreen,\n.floating-button.bg-lightgreen,\n.speed-dial-buttons a.bg-lightgreen {\n  color: #fff;\n  background: #8bc34a;\n}\nhtml:not(.watch-active-state) .floating-button.color-lightgreen:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-lightgreen:active,\nhtml:not(.watch-active-state) .floating-button.bg-lightgreen:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-lightgreen:active,\n.floating-button.color-lightgreen.active-state,\n.speed-dial-buttons a.color-lightgreen.active-state,\n.floating-button.bg-lightgreen.active-state,\n.speed-dial-buttons a.bg-lightgreen.active-state {\n  background: #689F38;\n}\n.floating-button.color-lightgreen i,\n.speed-dial-buttons a.color-lightgreen i,\n.floating-button.bg-lightgreen i,\n.speed-dial-buttons a.bg-lightgreen i {\n  color: inherit;\n}\n.ripple-lightgreen .ripple-wave {\n  background-color: rgba(139, 195, 74, 0.3);\n}\n.range-slider.color-lightgreen input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #8bc34a;\n}\n.range-slider.color-lightgreen input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #8bc34a;\n}\n.range-slider.color-lightgreen input[type=\"range\"]::-ms-thumb {\n  background-color: #8bc34a;\n}\n.range-slider.color-lightgreen input[type=\"range\"]::-ms-fill-lower {\n  background-color: #8bc34a;\n}\n.range-slider.color-lightgreen input[type=\"range\"]::-moz-range-thumb {\n  background-color: #8bc34a;\n}\n.badge.color-lightgreen {\n  background-color: #8bc34a;\n  color: #fff;\n}\n.color-lime {\n  color: #cddc39;\n}\n.list-block .item-link.list-button.color-lime,\n.list-button.color-lime,\n.list-block .item-link.color-lime,\n.tabbar a.active.color-lime,\na.color-lime {\n  color: #cddc39;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-lime,\n.label-switch.color-lime input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #cddc39;\n}\n.button.color-lime:not(.button-fill),\n.color-lime.buttons-row .button:not(.button-fill) {\n  color: #cddc39 !important;\n}\n.button.button-fill.bg-lime,\n.button.button-fill.color-lime {\n  background: #cddc39 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-lime:active,\nhtml:not(.watch-active-state) .button.button-fill.color-lime:active,\n.button.button-fill.bg-lime.active-state,\n.button.button-fill.color-lime.active-state {\n  background: #AFB42B !important;\n}\n.progressbar.color-lime,\n.progressbar.bg-lime {\n  background-color: rgba(205, 220, 57, 0.5);\n}\n.progressbar.color-lime span,\n.progressbar.bg-lime span {\n  background-color: #cddc39;\n}\n.progressbar-infinite.color-lime,\n.progressbar-infinite.bg-lime {\n  background-color: rgba(205, 220, 57, 0.5);\n}\n.progressbar-infinite.color-lime:after,\n.progressbar-infinite.bg-lime:after,\n.progressbar-infinite.color-lime:before,\n.progressbar-infinite.bg-lime:before {\n  background-color: #cddc39;\n}\n.color-lime i.icon,\ni.icon.color-lime {\n  color: #cddc39;\n}\n.preloader.color-lime svg circle,\n.preloader.preloader-lime svg circle {\n  stroke: #cddc39;\n}\n.preloader.color-lime .preloader-inner-gap,\n.preloader.preloader-lime .preloader-inner-gap,\n.preloader.color-lime .preloader-inner-half-circle,\n.preloader.preloader-lime .preloader-inner-half-circle {\n  border-color: #cddc39;\n}\n.bg-lime,\na.bg-lime,\n.list-block .swipeout-actions-left a.bg-lime,\n.list-block .swipeout-actions-right a.bg-lime {\n  background-color: #cddc39;\n}\nhtml:not(.watch-active-state) .list-block .bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-lime .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-lime:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-lime:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-lime:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-lime:active,\n.list-block .bg-lime .item-link.active-state,\n.list-block a.bg-lime .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-lime .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-lime .item-link.active-state,\n.list-block.bg-lime .item-link.active-state,\n.list-blocka.bg-lime .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-lime .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-lime .item-link.active-state,\n.list-block .item-link.bg-lime.active-state,\n.list-block .item-linka.bg-lime.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-lime.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-lime.active-state {\n  background: #AFB42B;\n}\n.border-lime {\n  border-color: #cddc39;\n}\n.list-block .border-lime.item-inner:after,\n.list-block ul.border-lime:after,\n.border-lime:after,\n.list-block .border-lime.item-inner:before,\n.list-block ul.border-lime:before,\n.border-lime:before {\n  background-color: #cddc39;\n}\n.floating-button.color-lime,\n.speed-dial-buttons a.color-lime,\n.floating-button.bg-lime,\n.speed-dial-buttons a.bg-lime {\n  color: #fff;\n  background: #cddc39;\n}\nhtml:not(.watch-active-state) .floating-button.color-lime:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-lime:active,\nhtml:not(.watch-active-state) .floating-button.bg-lime:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-lime:active,\n.floating-button.color-lime.active-state,\n.speed-dial-buttons a.color-lime.active-state,\n.floating-button.bg-lime.active-state,\n.speed-dial-buttons a.bg-lime.active-state {\n  background: #AFB42B;\n}\n.floating-button.color-lime i,\n.speed-dial-buttons a.color-lime i,\n.floating-button.bg-lime i,\n.speed-dial-buttons a.bg-lime i {\n  color: inherit;\n}\n.ripple-lime .ripple-wave {\n  background-color: rgba(205, 220, 57, 0.3);\n}\n.range-slider.color-lime input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #cddc39;\n}\n.range-slider.color-lime input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #cddc39;\n}\n.range-slider.color-lime input[type=\"range\"]::-ms-thumb {\n  background-color: #cddc39;\n}\n.range-slider.color-lime input[type=\"range\"]::-ms-fill-lower {\n  background-color: #cddc39;\n}\n.range-slider.color-lime input[type=\"range\"]::-moz-range-thumb {\n  background-color: #cddc39;\n}\n.badge.color-lime {\n  background-color: #cddc39;\n  color: #fff;\n}\n.color-yellow {\n  color: #ffeb3b;\n}\n.list-block .item-link.list-button.color-yellow,\n.list-button.color-yellow,\n.list-block .item-link.color-yellow,\n.tabbar a.active.color-yellow,\na.color-yellow {\n  color: #ffeb3b;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-yellow,\n.label-switch.color-yellow input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #ffeb3b;\n}\n.button.color-yellow:not(.button-fill),\n.color-yellow.buttons-row .button:not(.button-fill) {\n  color: #ffeb3b !important;\n}\n.button.button-fill.bg-yellow,\n.button.button-fill.color-yellow {\n  background: #ffeb3b !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-yellow:active,\nhtml:not(.watch-active-state) .button.button-fill.color-yellow:active,\n.button.button-fill.bg-yellow.active-state,\n.button.button-fill.color-yellow.active-state {\n  background: #FBC02D !important;\n}\n.progressbar.color-yellow,\n.progressbar.bg-yellow {\n  background-color: rgba(255, 235, 59, 0.5);\n}\n.progressbar.color-yellow span,\n.progressbar.bg-yellow span {\n  background-color: #ffeb3b;\n}\n.progressbar-infinite.color-yellow,\n.progressbar-infinite.bg-yellow {\n  background-color: rgba(255, 235, 59, 0.5);\n}\n.progressbar-infinite.color-yellow:after,\n.progressbar-infinite.bg-yellow:after,\n.progressbar-infinite.color-yellow:before,\n.progressbar-infinite.bg-yellow:before {\n  background-color: #ffeb3b;\n}\n.color-yellow i.icon,\ni.icon.color-yellow {\n  color: #ffeb3b;\n}\n.preloader.color-yellow svg circle,\n.preloader.preloader-yellow svg circle {\n  stroke: #ffeb3b;\n}\n.preloader.color-yellow .preloader-inner-gap,\n.preloader.preloader-yellow .preloader-inner-gap,\n.preloader.color-yellow .preloader-inner-half-circle,\n.preloader.preloader-yellow .preloader-inner-half-circle {\n  border-color: #ffeb3b;\n}\n.bg-yellow,\na.bg-yellow,\n.list-block .swipeout-actions-left a.bg-yellow,\n.list-block .swipeout-actions-right a.bg-yellow {\n  background-color: #ffeb3b;\n}\nhtml:not(.watch-active-state) .list-block .bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-yellow .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-yellow:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-yellow:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-yellow:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-yellow:active,\n.list-block .bg-yellow .item-link.active-state,\n.list-block a.bg-yellow .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-yellow .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-yellow .item-link.active-state,\n.list-block.bg-yellow .item-link.active-state,\n.list-blocka.bg-yellow .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-yellow .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-yellow .item-link.active-state,\n.list-block .item-link.bg-yellow.active-state,\n.list-block .item-linka.bg-yellow.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-yellow.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-yellow.active-state {\n  background: #FBC02D;\n}\n.border-yellow {\n  border-color: #ffeb3b;\n}\n.list-block .border-yellow.item-inner:after,\n.list-block ul.border-yellow:after,\n.border-yellow:after,\n.list-block .border-yellow.item-inner:before,\n.list-block ul.border-yellow:before,\n.border-yellow:before {\n  background-color: #ffeb3b;\n}\n.floating-button.color-yellow,\n.speed-dial-buttons a.color-yellow,\n.floating-button.bg-yellow,\n.speed-dial-buttons a.bg-yellow {\n  color: #fff;\n  background: #ffeb3b;\n}\nhtml:not(.watch-active-state) .floating-button.color-yellow:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-yellow:active,\nhtml:not(.watch-active-state) .floating-button.bg-yellow:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-yellow:active,\n.floating-button.color-yellow.active-state,\n.speed-dial-buttons a.color-yellow.active-state,\n.floating-button.bg-yellow.active-state,\n.speed-dial-buttons a.bg-yellow.active-state {\n  background: #FBC02D;\n}\n.floating-button.color-yellow i,\n.speed-dial-buttons a.color-yellow i,\n.floating-button.bg-yellow i,\n.speed-dial-buttons a.bg-yellow i {\n  color: inherit;\n}\n.ripple-yellow .ripple-wave {\n  background-color: rgba(255, 235, 59, 0.3);\n}\n.range-slider.color-yellow input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffeb3b;\n}\n.range-slider.color-yellow input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffeb3b;\n}\n.range-slider.color-yellow input[type=\"range\"]::-ms-thumb {\n  background-color: #ffeb3b;\n}\n.range-slider.color-yellow input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffeb3b;\n}\n.range-slider.color-yellow input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffeb3b;\n}\n.badge.color-yellow {\n  background-color: #ffeb3b;\n  color: #fff;\n}\n.color-amber {\n  color: #ffc107;\n}\n.list-block .item-link.list-button.color-amber,\n.list-button.color-amber,\n.list-block .item-link.color-amber,\n.tabbar a.active.color-amber,\na.color-amber {\n  color: #ffc107;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-amber,\n.label-switch.color-amber input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #ffc107;\n}\n.button.color-amber:not(.button-fill),\n.color-amber.buttons-row .button:not(.button-fill) {\n  color: #ffc107 !important;\n}\n.button.button-fill.bg-amber,\n.button.button-fill.color-amber {\n  background: #ffc107 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-amber:active,\nhtml:not(.watch-active-state) .button.button-fill.color-amber:active,\n.button.button-fill.bg-amber.active-state,\n.button.button-fill.color-amber.active-state {\n  background: #FFA000 !important;\n}\n.progressbar.color-amber,\n.progressbar.bg-amber {\n  background-color: rgba(255, 193, 7, 0.5);\n}\n.progressbar.color-amber span,\n.progressbar.bg-amber span {\n  background-color: #ffc107;\n}\n.progressbar-infinite.color-amber,\n.progressbar-infinite.bg-amber {\n  background-color: rgba(255, 193, 7, 0.5);\n}\n.progressbar-infinite.color-amber:after,\n.progressbar-infinite.bg-amber:after,\n.progressbar-infinite.color-amber:before,\n.progressbar-infinite.bg-amber:before {\n  background-color: #ffc107;\n}\n.color-amber i.icon,\ni.icon.color-amber {\n  color: #ffc107;\n}\n.preloader.color-amber svg circle,\n.preloader.preloader-amber svg circle {\n  stroke: #ffc107;\n}\n.preloader.color-amber .preloader-inner-gap,\n.preloader.preloader-amber .preloader-inner-gap,\n.preloader.color-amber .preloader-inner-half-circle,\n.preloader.preloader-amber .preloader-inner-half-circle {\n  border-color: #ffc107;\n}\n.bg-amber,\na.bg-amber,\n.list-block .swipeout-actions-left a.bg-amber,\n.list-block .swipeout-actions-right a.bg-amber {\n  background-color: #ffc107;\n}\nhtml:not(.watch-active-state) .list-block .bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-amber .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-amber:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-amber:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-amber:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-amber:active,\n.list-block .bg-amber .item-link.active-state,\n.list-block a.bg-amber .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-amber .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-amber .item-link.active-state,\n.list-block.bg-amber .item-link.active-state,\n.list-blocka.bg-amber .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-amber .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-amber .item-link.active-state,\n.list-block .item-link.bg-amber.active-state,\n.list-block .item-linka.bg-amber.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-amber.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-amber.active-state {\n  background: #FFA000;\n}\n.border-amber {\n  border-color: #ffc107;\n}\n.list-block .border-amber.item-inner:after,\n.list-block ul.border-amber:after,\n.border-amber:after,\n.list-block .border-amber.item-inner:before,\n.list-block ul.border-amber:before,\n.border-amber:before {\n  background-color: #ffc107;\n}\n.floating-button.color-amber,\n.speed-dial-buttons a.color-amber,\n.floating-button.bg-amber,\n.speed-dial-buttons a.bg-amber {\n  color: #fff;\n  background: #ffc107;\n}\nhtml:not(.watch-active-state) .floating-button.color-amber:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-amber:active,\nhtml:not(.watch-active-state) .floating-button.bg-amber:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-amber:active,\n.floating-button.color-amber.active-state,\n.speed-dial-buttons a.color-amber.active-state,\n.floating-button.bg-amber.active-state,\n.speed-dial-buttons a.bg-amber.active-state {\n  background: #FFA000;\n}\n.floating-button.color-amber i,\n.speed-dial-buttons a.color-amber i,\n.floating-button.bg-amber i,\n.speed-dial-buttons a.bg-amber i {\n  color: inherit;\n}\n.ripple-amber .ripple-wave {\n  background-color: rgba(255, 193, 7, 0.3);\n}\n.range-slider.color-amber input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffc107;\n}\n.range-slider.color-amber input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffc107;\n}\n.range-slider.color-amber input[type=\"range\"]::-ms-thumb {\n  background-color: #ffc107;\n}\n.range-slider.color-amber input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffc107;\n}\n.range-slider.color-amber input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffc107;\n}\n.badge.color-amber {\n  background-color: #ffc107;\n  color: #fff;\n}\n.color-orange {\n  color: #ff9800;\n}\n.list-block .item-link.list-button.color-orange,\n.list-button.color-orange,\n.list-block .item-link.color-orange,\n.tabbar a.active.color-orange,\na.color-orange {\n  color: #ff9800;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-orange,\n.label-switch.color-orange input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #ff9800;\n}\n.button.color-orange:not(.button-fill),\n.color-orange.buttons-row .button:not(.button-fill) {\n  color: #ff9800 !important;\n}\n.button.button-fill.bg-orange,\n.button.button-fill.color-orange {\n  background: #ff9800 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-orange:active,\nhtml:not(.watch-active-state) .button.button-fill.color-orange:active,\n.button.button-fill.bg-orange.active-state,\n.button.button-fill.color-orange.active-state {\n  background: #F57C00 !important;\n}\n.progressbar.color-orange,\n.progressbar.bg-orange {\n  background-color: rgba(255, 152, 0, 0.5);\n}\n.progressbar.color-orange span,\n.progressbar.bg-orange span {\n  background-color: #ff9800;\n}\n.progressbar-infinite.color-orange,\n.progressbar-infinite.bg-orange {\n  background-color: rgba(255, 152, 0, 0.5);\n}\n.progressbar-infinite.color-orange:after,\n.progressbar-infinite.bg-orange:after,\n.progressbar-infinite.color-orange:before,\n.progressbar-infinite.bg-orange:before {\n  background-color: #ff9800;\n}\n.color-orange i.icon,\ni.icon.color-orange {\n  color: #ff9800;\n}\n.preloader.color-orange svg circle,\n.preloader.preloader-orange svg circle {\n  stroke: #ff9800;\n}\n.preloader.color-orange .preloader-inner-gap,\n.preloader.preloader-orange .preloader-inner-gap,\n.preloader.color-orange .preloader-inner-half-circle,\n.preloader.preloader-orange .preloader-inner-half-circle {\n  border-color: #ff9800;\n}\n.bg-orange,\na.bg-orange,\n.list-block .swipeout-actions-left a.bg-orange,\n.list-block .swipeout-actions-right a.bg-orange {\n  background-color: #ff9800;\n}\nhtml:not(.watch-active-state) .list-block .bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-orange .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-orange:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-orange:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-orange:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-orange:active,\n.list-block .bg-orange .item-link.active-state,\n.list-block a.bg-orange .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-orange .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-orange .item-link.active-state,\n.list-block.bg-orange .item-link.active-state,\n.list-blocka.bg-orange .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-orange .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-orange .item-link.active-state,\n.list-block .item-link.bg-orange.active-state,\n.list-block .item-linka.bg-orange.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-orange.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-orange.active-state {\n  background: #F57C00;\n}\n.border-orange {\n  border-color: #ff9800;\n}\n.list-block .border-orange.item-inner:after,\n.list-block ul.border-orange:after,\n.border-orange:after,\n.list-block .border-orange.item-inner:before,\n.list-block ul.border-orange:before,\n.border-orange:before {\n  background-color: #ff9800;\n}\n.floating-button.color-orange,\n.speed-dial-buttons a.color-orange,\n.floating-button.bg-orange,\n.speed-dial-buttons a.bg-orange {\n  color: #fff;\n  background: #ff9800;\n}\nhtml:not(.watch-active-state) .floating-button.color-orange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-orange:active,\nhtml:not(.watch-active-state) .floating-button.bg-orange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-orange:active,\n.floating-button.color-orange.active-state,\n.speed-dial-buttons a.color-orange.active-state,\n.floating-button.bg-orange.active-state,\n.speed-dial-buttons a.bg-orange.active-state {\n  background: #F57C00;\n}\n.floating-button.color-orange i,\n.speed-dial-buttons a.color-orange i,\n.floating-button.bg-orange i,\n.speed-dial-buttons a.bg-orange i {\n  color: inherit;\n}\n.ripple-orange .ripple-wave {\n  background-color: rgba(255, 152, 0, 0.3);\n}\n.range-slider.color-orange input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ff9800;\n}\n.range-slider.color-orange input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ff9800;\n}\n.range-slider.color-orange input[type=\"range\"]::-ms-thumb {\n  background-color: #ff9800;\n}\n.range-slider.color-orange input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ff9800;\n}\n.range-slider.color-orange input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ff9800;\n}\n.badge.color-orange {\n  background-color: #ff9800;\n  color: #fff;\n}\n.color-deeporange {\n  color: #ff5722;\n}\n.list-block .item-link.list-button.color-deeporange,\n.list-button.color-deeporange,\n.list-block .item-link.color-deeporange,\n.tabbar a.active.color-deeporange,\na.color-deeporange {\n  color: #ff5722;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-deeporange,\n.label-switch.color-deeporange input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #ff5722;\n}\n.button.color-deeporange:not(.button-fill),\n.color-deeporange.buttons-row .button:not(.button-fill) {\n  color: #ff5722 !important;\n}\n.button.button-fill.bg-deeporange,\n.button.button-fill.color-deeporange {\n  background: #ff5722 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-deeporange:active,\nhtml:not(.watch-active-state) .button.button-fill.color-deeporange:active,\n.button.button-fill.bg-deeporange.active-state,\n.button.button-fill.color-deeporange.active-state {\n  background: #E64A19 !important;\n}\n.progressbar.color-deeporange,\n.progressbar.bg-deeporange {\n  background-color: rgba(255, 87, 34, 0.5);\n}\n.progressbar.color-deeporange span,\n.progressbar.bg-deeporange span {\n  background-color: #ff5722;\n}\n.progressbar-infinite.color-deeporange,\n.progressbar-infinite.bg-deeporange {\n  background-color: rgba(255, 87, 34, 0.5);\n}\n.progressbar-infinite.color-deeporange:after,\n.progressbar-infinite.bg-deeporange:after,\n.progressbar-infinite.color-deeporange:before,\n.progressbar-infinite.bg-deeporange:before {\n  background-color: #ff5722;\n}\n.color-deeporange i.icon,\ni.icon.color-deeporange {\n  color: #ff5722;\n}\n.preloader.color-deeporange svg circle,\n.preloader.preloader-deeporange svg circle {\n  stroke: #ff5722;\n}\n.preloader.color-deeporange .preloader-inner-gap,\n.preloader.preloader-deeporange .preloader-inner-gap,\n.preloader.color-deeporange .preloader-inner-half-circle,\n.preloader.preloader-deeporange .preloader-inner-half-circle {\n  border-color: #ff5722;\n}\n.bg-deeporange,\na.bg-deeporange,\n.list-block .swipeout-actions-left a.bg-deeporange,\n.list-block .swipeout-actions-right a.bg-deeporange {\n  background-color: #ff5722;\n}\nhtml:not(.watch-active-state) .list-block .bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-deeporange .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-deeporange:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-deeporange:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-deeporange:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-deeporange:active,\n.list-block .bg-deeporange .item-link.active-state,\n.list-block a.bg-deeporange .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-deeporange .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-deeporange .item-link.active-state,\n.list-block.bg-deeporange .item-link.active-state,\n.list-blocka.bg-deeporange .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-deeporange .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-deeporange .item-link.active-state,\n.list-block .item-link.bg-deeporange.active-state,\n.list-block .item-linka.bg-deeporange.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-deeporange.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-deeporange.active-state {\n  background: #E64A19;\n}\n.border-deeporange {\n  border-color: #ff5722;\n}\n.list-block .border-deeporange.item-inner:after,\n.list-block ul.border-deeporange:after,\n.border-deeporange:after,\n.list-block .border-deeporange.item-inner:before,\n.list-block ul.border-deeporange:before,\n.border-deeporange:before {\n  background-color: #ff5722;\n}\n.floating-button.color-deeporange,\n.speed-dial-buttons a.color-deeporange,\n.floating-button.bg-deeporange,\n.speed-dial-buttons a.bg-deeporange {\n  color: #fff;\n  background: #ff5722;\n}\nhtml:not(.watch-active-state) .floating-button.color-deeporange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-deeporange:active,\nhtml:not(.watch-active-state) .floating-button.bg-deeporange:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-deeporange:active,\n.floating-button.color-deeporange.active-state,\n.speed-dial-buttons a.color-deeporange.active-state,\n.floating-button.bg-deeporange.active-state,\n.speed-dial-buttons a.bg-deeporange.active-state {\n  background: #E64A19;\n}\n.floating-button.color-deeporange i,\n.speed-dial-buttons a.color-deeporange i,\n.floating-button.bg-deeporange i,\n.speed-dial-buttons a.bg-deeporange i {\n  color: inherit;\n}\n.ripple-deeporange .ripple-wave {\n  background-color: rgba(255, 87, 34, 0.3);\n}\n.range-slider.color-deeporange input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ff5722;\n}\n.range-slider.color-deeporange input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ff5722;\n}\n.range-slider.color-deeporange input[type=\"range\"]::-ms-thumb {\n  background-color: #ff5722;\n}\n.range-slider.color-deeporange input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ff5722;\n}\n.range-slider.color-deeporange input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ff5722;\n}\n.badge.color-deeporange {\n  background-color: #ff5722;\n  color: #fff;\n}\n.color-brown {\n  color: #795548;\n}\n.list-block .item-link.list-button.color-brown,\n.list-button.color-brown,\n.list-block .item-link.color-brown,\n.tabbar a.active.color-brown,\na.color-brown {\n  color: #795548;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-brown,\n.label-switch.color-brown input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #795548;\n}\n.button.color-brown:not(.button-fill),\n.color-brown.buttons-row .button:not(.button-fill) {\n  color: #795548 !important;\n}\n.button.button-fill.bg-brown,\n.button.button-fill.color-brown {\n  background: #795548 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-brown:active,\nhtml:not(.watch-active-state) .button.button-fill.color-brown:active,\n.button.button-fill.bg-brown.active-state,\n.button.button-fill.color-brown.active-state {\n  background: #5D4037 !important;\n}\n.progressbar.color-brown,\n.progressbar.bg-brown {\n  background-color: rgba(121, 85, 72, 0.5);\n}\n.progressbar.color-brown span,\n.progressbar.bg-brown span {\n  background-color: #795548;\n}\n.progressbar-infinite.color-brown,\n.progressbar-infinite.bg-brown {\n  background-color: rgba(121, 85, 72, 0.5);\n}\n.progressbar-infinite.color-brown:after,\n.progressbar-infinite.bg-brown:after,\n.progressbar-infinite.color-brown:before,\n.progressbar-infinite.bg-brown:before {\n  background-color: #795548;\n}\n.color-brown i.icon,\ni.icon.color-brown {\n  color: #795548;\n}\n.preloader.color-brown svg circle,\n.preloader.preloader-brown svg circle {\n  stroke: #795548;\n}\n.preloader.color-brown .preloader-inner-gap,\n.preloader.preloader-brown .preloader-inner-gap,\n.preloader.color-brown .preloader-inner-half-circle,\n.preloader.preloader-brown .preloader-inner-half-circle {\n  border-color: #795548;\n}\n.bg-brown,\na.bg-brown,\n.list-block .swipeout-actions-left a.bg-brown,\n.list-block .swipeout-actions-right a.bg-brown {\n  background-color: #795548;\n}\nhtml:not(.watch-active-state) .list-block .bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-brown .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-brown:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-brown:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-brown:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-brown:active,\n.list-block .bg-brown .item-link.active-state,\n.list-block a.bg-brown .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-brown .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-brown .item-link.active-state,\n.list-block.bg-brown .item-link.active-state,\n.list-blocka.bg-brown .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-brown .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-brown .item-link.active-state,\n.list-block .item-link.bg-brown.active-state,\n.list-block .item-linka.bg-brown.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-brown.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-brown.active-state {\n  background: #5D4037;\n}\n.border-brown {\n  border-color: #795548;\n}\n.list-block .border-brown.item-inner:after,\n.list-block ul.border-brown:after,\n.border-brown:after,\n.list-block .border-brown.item-inner:before,\n.list-block ul.border-brown:before,\n.border-brown:before {\n  background-color: #795548;\n}\n.floating-button.color-brown,\n.speed-dial-buttons a.color-brown,\n.floating-button.bg-brown,\n.speed-dial-buttons a.bg-brown {\n  color: #fff;\n  background: #795548;\n}\nhtml:not(.watch-active-state) .floating-button.color-brown:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-brown:active,\nhtml:not(.watch-active-state) .floating-button.bg-brown:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-brown:active,\n.floating-button.color-brown.active-state,\n.speed-dial-buttons a.color-brown.active-state,\n.floating-button.bg-brown.active-state,\n.speed-dial-buttons a.bg-brown.active-state {\n  background: #5D4037;\n}\n.floating-button.color-brown i,\n.speed-dial-buttons a.color-brown i,\n.floating-button.bg-brown i,\n.speed-dial-buttons a.bg-brown i {\n  color: inherit;\n}\n.ripple-brown .ripple-wave {\n  background-color: rgba(121, 85, 72, 0.3);\n}\n.range-slider.color-brown input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #795548;\n}\n.range-slider.color-brown input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #795548;\n}\n.range-slider.color-brown input[type=\"range\"]::-ms-thumb {\n  background-color: #795548;\n}\n.range-slider.color-brown input[type=\"range\"]::-ms-fill-lower {\n  background-color: #795548;\n}\n.range-slider.color-brown input[type=\"range\"]::-moz-range-thumb {\n  background-color: #795548;\n}\n.badge.color-brown {\n  background-color: #795548;\n  color: #fff;\n}\n.color-gray {\n  color: #9e9e9e;\n}\n.list-block .item-link.list-button.color-gray,\n.list-button.color-gray,\n.list-block .item-link.color-gray,\n.tabbar a.active.color-gray,\na.color-gray {\n  color: #9e9e9e;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-gray,\n.label-switch.color-gray input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #9e9e9e;\n}\n.button.color-gray:not(.button-fill),\n.color-gray.buttons-row .button:not(.button-fill) {\n  color: #9e9e9e !important;\n}\n.button.button-fill.bg-gray,\n.button.button-fill.color-gray {\n  background: #9e9e9e !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-gray:active,\nhtml:not(.watch-active-state) .button.button-fill.color-gray:active,\n.button.button-fill.bg-gray.active-state,\n.button.button-fill.color-gray.active-state {\n  background: #616161 !important;\n}\n.progressbar.color-gray,\n.progressbar.bg-gray {\n  background-color: rgba(158, 158, 158, 0.5);\n}\n.progressbar.color-gray span,\n.progressbar.bg-gray span {\n  background-color: #9e9e9e;\n}\n.progressbar-infinite.color-gray,\n.progressbar-infinite.bg-gray {\n  background-color: rgba(158, 158, 158, 0.5);\n}\n.progressbar-infinite.color-gray:after,\n.progressbar-infinite.bg-gray:after,\n.progressbar-infinite.color-gray:before,\n.progressbar-infinite.bg-gray:before {\n  background-color: #9e9e9e;\n}\n.color-gray i.icon,\ni.icon.color-gray {\n  color: #9e9e9e;\n}\n.preloader.color-gray svg circle,\n.preloader.preloader-gray svg circle {\n  stroke: #9e9e9e;\n}\n.preloader.color-gray .preloader-inner-gap,\n.preloader.preloader-gray .preloader-inner-gap,\n.preloader.color-gray .preloader-inner-half-circle,\n.preloader.preloader-gray .preloader-inner-half-circle {\n  border-color: #9e9e9e;\n}\n.bg-gray,\na.bg-gray,\n.list-block .swipeout-actions-left a.bg-gray,\n.list-block .swipeout-actions-right a.bg-gray {\n  background-color: #9e9e9e;\n}\nhtml:not(.watch-active-state) .list-block .bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-gray .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-gray:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-gray:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-gray:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-gray:active,\n.list-block .bg-gray .item-link.active-state,\n.list-block a.bg-gray .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-gray .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-gray .item-link.active-state,\n.list-block.bg-gray .item-link.active-state,\n.list-blocka.bg-gray .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-gray .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-gray .item-link.active-state,\n.list-block .item-link.bg-gray.active-state,\n.list-block .item-linka.bg-gray.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-gray.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-gray.active-state {\n  background: #616161;\n}\n.border-gray {\n  border-color: #9e9e9e;\n}\n.list-block .border-gray.item-inner:after,\n.list-block ul.border-gray:after,\n.border-gray:after,\n.list-block .border-gray.item-inner:before,\n.list-block ul.border-gray:before,\n.border-gray:before {\n  background-color: #9e9e9e;\n}\n.floating-button.color-gray,\n.speed-dial-buttons a.color-gray,\n.floating-button.bg-gray,\n.speed-dial-buttons a.bg-gray {\n  color: #fff;\n  background: #9e9e9e;\n}\nhtml:not(.watch-active-state) .floating-button.color-gray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-gray:active,\nhtml:not(.watch-active-state) .floating-button.bg-gray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-gray:active,\n.floating-button.color-gray.active-state,\n.speed-dial-buttons a.color-gray.active-state,\n.floating-button.bg-gray.active-state,\n.speed-dial-buttons a.bg-gray.active-state {\n  background: #616161;\n}\n.floating-button.color-gray i,\n.speed-dial-buttons a.color-gray i,\n.floating-button.bg-gray i,\n.speed-dial-buttons a.bg-gray i {\n  color: inherit;\n}\n.ripple-gray .ripple-wave {\n  background-color: rgba(158, 158, 158, 0.3);\n}\n.range-slider.color-gray input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #9e9e9e;\n}\n.range-slider.color-gray input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #9e9e9e;\n}\n.range-slider.color-gray input[type=\"range\"]::-ms-thumb {\n  background-color: #9e9e9e;\n}\n.range-slider.color-gray input[type=\"range\"]::-ms-fill-lower {\n  background-color: #9e9e9e;\n}\n.range-slider.color-gray input[type=\"range\"]::-moz-range-thumb {\n  background-color: #9e9e9e;\n}\n.badge.color-gray {\n  background-color: #9e9e9e;\n  color: #fff;\n}\n.color-bluegray {\n  color: #607d8b;\n}\n.list-block .item-link.list-button.color-bluegray,\n.list-button.color-bluegray,\n.list-block .item-link.color-bluegray,\n.tabbar a.active.color-bluegray,\na.color-bluegray {\n  color: #607d8b;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-bluegray,\n.label-switch.color-bluegray input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #607d8b;\n}\n.button.color-bluegray:not(.button-fill),\n.color-bluegray.buttons-row .button:not(.button-fill) {\n  color: #607d8b !important;\n}\n.button.button-fill.bg-bluegray,\n.button.button-fill.color-bluegray {\n  background: #607d8b !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-bluegray:active,\nhtml:not(.watch-active-state) .button.button-fill.color-bluegray:active,\n.button.button-fill.bg-bluegray.active-state,\n.button.button-fill.color-bluegray.active-state {\n  background: #455A64 !important;\n}\n.progressbar.color-bluegray,\n.progressbar.bg-bluegray {\n  background-color: rgba(96, 125, 139, 0.5);\n}\n.progressbar.color-bluegray span,\n.progressbar.bg-bluegray span {\n  background-color: #607d8b;\n}\n.progressbar-infinite.color-bluegray,\n.progressbar-infinite.bg-bluegray {\n  background-color: rgba(96, 125, 139, 0.5);\n}\n.progressbar-infinite.color-bluegray:after,\n.progressbar-infinite.bg-bluegray:after,\n.progressbar-infinite.color-bluegray:before,\n.progressbar-infinite.bg-bluegray:before {\n  background-color: #607d8b;\n}\n.color-bluegray i.icon,\ni.icon.color-bluegray {\n  color: #607d8b;\n}\n.preloader.color-bluegray svg circle,\n.preloader.preloader-bluegray svg circle {\n  stroke: #607d8b;\n}\n.preloader.color-bluegray .preloader-inner-gap,\n.preloader.preloader-bluegray .preloader-inner-gap,\n.preloader.color-bluegray .preloader-inner-half-circle,\n.preloader.preloader-bluegray .preloader-inner-half-circle {\n  border-color: #607d8b;\n}\n.bg-bluegray,\na.bg-bluegray,\n.list-block .swipeout-actions-left a.bg-bluegray,\n.list-block .swipeout-actions-right a.bg-bluegray {\n  background-color: #607d8b;\n}\nhtml:not(.watch-active-state) .list-block .bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-bluegray .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-bluegray:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-bluegray:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-bluegray:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-bluegray:active,\n.list-block .bg-bluegray .item-link.active-state,\n.list-block a.bg-bluegray .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-bluegray .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-bluegray .item-link.active-state,\n.list-block.bg-bluegray .item-link.active-state,\n.list-blocka.bg-bluegray .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-bluegray .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-bluegray .item-link.active-state,\n.list-block .item-link.bg-bluegray.active-state,\n.list-block .item-linka.bg-bluegray.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-bluegray.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-bluegray.active-state {\n  background: #455A64;\n}\n.border-bluegray {\n  border-color: #607d8b;\n}\n.list-block .border-bluegray.item-inner:after,\n.list-block ul.border-bluegray:after,\n.border-bluegray:after,\n.list-block .border-bluegray.item-inner:before,\n.list-block ul.border-bluegray:before,\n.border-bluegray:before {\n  background-color: #607d8b;\n}\n.floating-button.color-bluegray,\n.speed-dial-buttons a.color-bluegray,\n.floating-button.bg-bluegray,\n.speed-dial-buttons a.bg-bluegray {\n  color: #fff;\n  background: #607d8b;\n}\nhtml:not(.watch-active-state) .floating-button.color-bluegray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-bluegray:active,\nhtml:not(.watch-active-state) .floating-button.bg-bluegray:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-bluegray:active,\n.floating-button.color-bluegray.active-state,\n.speed-dial-buttons a.color-bluegray.active-state,\n.floating-button.bg-bluegray.active-state,\n.speed-dial-buttons a.bg-bluegray.active-state {\n  background: #455A64;\n}\n.floating-button.color-bluegray i,\n.speed-dial-buttons a.color-bluegray i,\n.floating-button.bg-bluegray i,\n.speed-dial-buttons a.bg-bluegray i {\n  color: inherit;\n}\n.ripple-bluegray .ripple-wave {\n  background-color: rgba(96, 125, 139, 0.3);\n}\n.range-slider.color-bluegray input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #607d8b;\n}\n.range-slider.color-bluegray input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #607d8b;\n}\n.range-slider.color-bluegray input[type=\"range\"]::-ms-thumb {\n  background-color: #607d8b;\n}\n.range-slider.color-bluegray input[type=\"range\"]::-ms-fill-lower {\n  background-color: #607d8b;\n}\n.range-slider.color-bluegray input[type=\"range\"]::-moz-range-thumb {\n  background-color: #607d8b;\n}\n.badge.color-bluegray {\n  background-color: #607d8b;\n  color: #fff;\n}\n.color-white {\n  color: #ffffff;\n}\n.list-block .item-link.list-button.color-white,\n.list-button.color-white,\n.list-block .item-link.color-white,\n.tabbar a.active.color-white,\na.color-white {\n  color: #ffffff;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-white,\n.label-switch.color-white input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #ffffff;\n}\n.button.color-white:not(.button-fill),\n.color-white.buttons-row .button:not(.button-fill) {\n  color: #ffffff !important;\n}\n.button.button-fill.bg-white,\n.button.button-fill.color-white {\n  background: #ffffff !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-white:active,\nhtml:not(.watch-active-state) .button.button-fill.color-white:active,\n.button.button-fill.bg-white.active-state,\n.button.button-fill.color-white.active-state {\n  background: rgba(0, 0, 0, 0.1) !important;\n}\n.progressbar.color-white,\n.progressbar.bg-white {\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.progressbar.color-white span,\n.progressbar.bg-white span {\n  background-color: #ffffff;\n}\n.progressbar-infinite.color-white,\n.progressbar-infinite.bg-white {\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.progressbar-infinite.color-white:after,\n.progressbar-infinite.bg-white:after,\n.progressbar-infinite.color-white:before,\n.progressbar-infinite.bg-white:before {\n  background-color: #ffffff;\n}\n.color-white i.icon,\ni.icon.color-white {\n  color: #ffffff;\n}\n.preloader.color-white svg circle,\n.preloader.preloader-white svg circle {\n  stroke: #ffffff;\n}\n.preloader.color-white .preloader-inner-gap,\n.preloader.preloader-white .preloader-inner-gap,\n.preloader.color-white .preloader-inner-half-circle,\n.preloader.preloader-white .preloader-inner-half-circle {\n  border-color: #ffffff;\n}\n.bg-white,\na.bg-white,\n.list-block .swipeout-actions-left a.bg-white,\n.list-block .swipeout-actions-right a.bg-white {\n  background-color: #ffffff;\n}\nhtml:not(.watch-active-state) .list-block .bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-white .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-white:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-white:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-white:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-white:active,\n.list-block .bg-white .item-link.active-state,\n.list-block a.bg-white .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-white .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-white .item-link.active-state,\n.list-block.bg-white .item-link.active-state,\n.list-blocka.bg-white .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-white .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-white .item-link.active-state,\n.list-block .item-link.bg-white.active-state,\n.list-block .item-linka.bg-white.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-white.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-white.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.border-white {\n  border-color: #ffffff;\n}\n.list-block .border-white.item-inner:after,\n.list-block ul.border-white:after,\n.border-white:after,\n.list-block .border-white.item-inner:before,\n.list-block ul.border-white:before,\n.border-white:before {\n  background-color: #ffffff;\n}\n.floating-button.color-white,\n.speed-dial-buttons a.color-white,\n.floating-button.bg-white,\n.speed-dial-buttons a.bg-white {\n  color: #fff;\n  background: #ffffff;\n}\nhtml:not(.watch-active-state) .floating-button.color-white:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-white:active,\nhtml:not(.watch-active-state) .floating-button.bg-white:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-white:active,\n.floating-button.color-white.active-state,\n.speed-dial-buttons a.color-white.active-state,\n.floating-button.bg-white.active-state,\n.speed-dial-buttons a.bg-white.active-state {\n  background: rgba(0, 0, 0, 0.1);\n}\n.floating-button.color-white i,\n.speed-dial-buttons a.color-white i,\n.floating-button.bg-white i,\n.speed-dial-buttons a.bg-white i {\n  color: inherit;\n}\n.ripple-white .ripple-wave {\n  background-color: rgba(255, 255, 255, 0.3);\n}\n.range-slider.color-white input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #ffffff;\n}\n.range-slider.color-white input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #ffffff;\n}\n.range-slider.color-white input[type=\"range\"]::-ms-thumb {\n  background-color: #ffffff;\n}\n.range-slider.color-white input[type=\"range\"]::-ms-fill-lower {\n  background-color: #ffffff;\n}\n.range-slider.color-white input[type=\"range\"]::-moz-range-thumb {\n  background-color: #ffffff;\n}\n.badge.color-white {\n  background-color: #ffffff;\n  color: #fff;\n}\n.color-black {\n  color: #000000;\n}\n.list-block .item-link.list-button.color-black,\n.list-button.color-black,\n.list-block .item-link.color-black,\n.tabbar a.active.color-black,\na.color-black {\n  color: #000000;\n}\n.label-switch input[type=\"checkbox\"]:checked + .checkbox.color-black,\n.label-switch.color-black input[type=\"checkbox\"]:checked + .checkbox {\n  background-color: #000000;\n}\n.button.color-black:not(.button-fill),\n.color-black.buttons-row .button:not(.button-fill) {\n  color: #000000 !important;\n}\n.button.button-fill.bg-black,\n.button.button-fill.color-black {\n  background: #000000 !important;\n  color: #fff;\n}\nhtml:not(.watch-active-state) .button.button-fill.bg-black:active,\nhtml:not(.watch-active-state) .button.button-fill.color-black:active,\n.button.button-fill.bg-black.active-state,\n.button.button-fill.color-black.active-state {\n  background: #333 !important;\n}\n.progressbar.color-black,\n.progressbar.bg-black {\n  background-color: rgba(0, 0, 0, 0.5);\n}\n.progressbar.color-black span,\n.progressbar.bg-black span {\n  background-color: #000000;\n}\n.progressbar-infinite.color-black,\n.progressbar-infinite.bg-black {\n  background-color: rgba(0, 0, 0, 0.5);\n}\n.progressbar-infinite.color-black:after,\n.progressbar-infinite.bg-black:after,\n.progressbar-infinite.color-black:before,\n.progressbar-infinite.bg-black:before {\n  background-color: #000000;\n}\n.color-black i.icon,\ni.icon.color-black {\n  color: #000000;\n}\n.preloader.color-black svg circle,\n.preloader.preloader-black svg circle {\n  stroke: #000000;\n}\n.preloader.color-black .preloader-inner-gap,\n.preloader.preloader-black .preloader-inner-gap,\n.preloader.color-black .preloader-inner-half-circle,\n.preloader.preloader-black .preloader-inner-half-circle {\n  border-color: #000000;\n}\n.bg-black,\na.bg-black,\n.list-block .swipeout-actions-left a.bg-black,\n.list-block .swipeout-actions-right a.bg-black {\n  background-color: #000000;\n}\nhtml:not(.watch-active-state) .list-block .bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block a.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-left a.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block .list-block .swipeout-actions-right a.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-blocka.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-left a.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block.list-block .swipeout-actions-right a.bg-black .item-link:active,\nhtml:not(.watch-active-state) .list-block .item-link.bg-black:active,\nhtml:not(.watch-active-state) .list-block .item-linka.bg-black:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-left a.bg-black:active,\nhtml:not(.watch-active-state) .list-block .item-link.list-block .swipeout-actions-right a.bg-black:active,\n.list-block .bg-black .item-link.active-state,\n.list-block a.bg-black .item-link.active-state,\n.list-block .list-block .swipeout-actions-left a.bg-black .item-link.active-state,\n.list-block .list-block .swipeout-actions-right a.bg-black .item-link.active-state,\n.list-block.bg-black .item-link.active-state,\n.list-blocka.bg-black .item-link.active-state,\n.list-block.list-block .swipeout-actions-left a.bg-black .item-link.active-state,\n.list-block.list-block .swipeout-actions-right a.bg-black .item-link.active-state,\n.list-block .item-link.bg-black.active-state,\n.list-block .item-linka.bg-black.active-state,\n.list-block .item-link.list-block .swipeout-actions-left a.bg-black.active-state,\n.list-block .item-link.list-block .swipeout-actions-right a.bg-black.active-state {\n  background: #333;\n}\n.border-black {\n  border-color: #000000;\n}\n.list-block .border-black.item-inner:after,\n.list-block ul.border-black:after,\n.border-black:after,\n.list-block .border-black.item-inner:before,\n.list-block ul.border-black:before,\n.border-black:before {\n  background-color: #000000;\n}\n.floating-button.color-black,\n.speed-dial-buttons a.color-black,\n.floating-button.bg-black,\n.speed-dial-buttons a.bg-black {\n  color: #fff;\n  background: #000000;\n}\nhtml:not(.watch-active-state) .floating-button.color-black:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.color-black:active,\nhtml:not(.watch-active-state) .floating-button.bg-black:active,\nhtml:not(.watch-active-state) .speed-dial-buttons a.bg-black:active,\n.floating-button.color-black.active-state,\n.speed-dial-buttons a.color-black.active-state,\n.floating-button.bg-black.active-state,\n.speed-dial-buttons a.bg-black.active-state {\n  background: #333;\n}\n.floating-button.color-black i,\n.speed-dial-buttons a.color-black i,\n.floating-button.bg-black i,\n.speed-dial-buttons a.bg-black i {\n  color: inherit;\n}\n.ripple-black .ripple-wave {\n  background-color: rgba(0, 0, 0, 0.3);\n}\n.range-slider.color-black input[type=\"range\"]::-webkit-slider-thumb:before {\n  background-color: #000000;\n}\n.range-slider.color-black input[type=\"range\"]::-webkit-slider-thumb {\n  background-color: #000000;\n}\n.range-slider.color-black input[type=\"range\"]::-ms-thumb {\n  background-color: #000000;\n}\n.range-slider.color-black input[type=\"range\"]::-ms-fill-lower {\n  background-color: #000000;\n}\n.range-slider.color-black input[type=\"range\"]::-moz-range-thumb {\n  background-color: #000000;\n}\n.badge.color-black {\n  background-color: #000000;\n  color: #fff;\n}\n", ""]);

	// exports


/***/ }),

/***/ 399:
/*!*******************************************!*\
  !*** ./modules/MailWebclient/js/Cache.js ***!
  \*******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Pulse = __webpack_require__(/*! modules/CoreWebclient/js/Pulse.js */ 400),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		ConfirmPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/ConfirmPopup.js */ 196),
		
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		Prefetcher = null,
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CFolderListModel = __webpack_require__(/*! modules/MailWebclient/js/models/CFolderListModel.js */ 428),
		CUidListModel = __webpack_require__(/*! modules/MailWebclient/js/models/CUidListModel.js */ 430),
		
		MainTab = App.isNewTab() && window.opener && window.opener.MainTabMailMethods
	;

	/**
	 * @constructor
	 */
	function CMailCache()
	{
		this.currentAccountId = AccountList.currentId;

		this.currentAccountId.subscribe(function (iCurrAccountId) {
			var
				oAccount = AccountList.getAccount(iCurrAccountId),
				oFolderList = this.oFolderListItems[iCurrAccountId]
			;
			if (oAccount)
			{
				oAccount.quotaRecieved(false);
				
				this.messagesLoadingError(false);
				
				if (oFolderList)
				{
					this.folderList(oFolderList);
				}
				else
				{
					this.messagesLoading(true);
					this.folderList(new CFolderListModel());
					this.messages([]);
					this.currentMessage(null);
					this.getFolderList(iCurrAccountId);
				}
			}
			else
			{
				this.folderList(new CFolderListModel());
			}
		}, this);
		
		this.editedAccountId = AccountList.editedId;
		this.editedAccountId.subscribe(function (iEditedAccountId) {
			var oFolderList = this.oFolderListItems[iEditedAccountId];
			
			if (oFolderList)
			{
				this.editedFolderList(oFolderList);
			}
			else if (this.currentAccountId() !== iEditedAccountId)
			{
				this.editedFolderList(new CFolderListModel());
				this.getFolderList(iEditedAccountId);
			}
		}, this);
		
		this.oFolderListItems = {};

		this.quotaChangeTrigger = ko.observable(false);
		
		this.checkMailStarted = ko.observable(false);
		this.checkMailStartedAccountId = ko.observable(0);
		
		this.folderList = ko.observable(new CFolderListModel());
		this.folderListLoading = ko.observableArray([]);
		
		this.editedFolderList = ko.observable(new CFolderListModel());

		this.newMessagesCount = ko.computed(function () {
			var oInbox = this.folderList().inboxFolder();
			return oInbox ? oInbox.unseenMessageCount() : 0;
		}, this);

		this.messages = ko.observableArray([]);
		this.messages.subscribe(function () {
			if (this.messages().length > 0)
			{
				this.messagesLoadingError(false);
			}
		}, this);
		
		this.uidList = ko.observable(new CUidListModel());
		this.page = ko.observable(1);
		
		this.messagesLoading = ko.observable(false);
		this.messagesLoadingError = ko.observable(false);
		
		this.currentMessage = ko.observable(null);
		
		this.nextMessageUid = ko.observable('');
		this.prevMessageUid = ko.observable('');

		this.savingDraftUid = ko.observable('');
		this.editedDraftUid = ko.observable('');
		this.disableComposeAutosave = ko.observable(false);
		
		this.aResponseHandlers = [];

		this.iAutoCheckMailTimer = -1;
		
		this.waitForUnseenMessages = ko.observable(true);
		
		this.iSetMessagesSeenCount = 0;
		
		App.subscribeEvent('ReceiveAjaxResponse::after', _.bind(function (oParams) {
			// restart autorefresh after restoring Internet connection
			if (!this.checkMailStarted() && oParams.Response.Method === 'Ping' && oParams.Response.Module === 'Core' && oParams.Response.Result)
			{
				this.setAutocheckmailTimer();
			}
		}, this));
	}

	CMailCache.prototype.requirePrefetcher = function ()
	{
		Prefetcher = __webpack_require__(/*! modules/MailWebclient/js/Prefetcher.js */ 431);
	};

	/**
	 * @public
	 */
	CMailCache.prototype.init = function ()
	{
		Ajax.registerOnAllRequestsClosedHandler(function () {
			// Delay not to reset these flags between two related requests (e.g. 'GetRelevantFoldersInformation' and 'GetMessages')
			_.delay(function () {
				if (!Ajax.hasOpenedRequests())
				{
					MailCache.checkMailStarted(false);
					MailCache.folderListLoading.removeAll();
				}
			}, 10);
		});
		
		if (MainTab)
		{
			this.oFolderListItems = MainTab.getFolderListItems();
			this.uidList(MainTab.getUidList());
			
			if (window.name)
			{
				var iAccountId = Types.pInt(window.name);
				
				if (iAccountId === 0)
				{
					iAccountId = MainTab.getComposedMessageAccountId(window.name);
				}
				
				if (iAccountId !== 0)
				{
					this.currentAccountId(iAccountId);
				}
			}
			this.currentAccountId.valueHasMutated();
			this.initPrevNextSubscribes();
		}
		else
		{
			this.currentAccountId.valueHasMutated();
		}
	};

	CMailCache.prototype.initPrevNextSubscribes = function ()
	{
		this.bInThreadLevel = false;
		
		this.currentMessage.subscribe(this.calcNextMessageUid, this);
		this.uidList.subscribe(this.calcNextMessageUid, this);
		
		this.currentMessage.subscribe(this.calcPrevMessageUid, this);
		this.uidList.subscribe(this.calcPrevMessageUid, this);
	};

	CMailCache.prototype.calcNextMessageUid = function ()
	{
		var
			sCurrentUid = '',
			sNextUid = '',
			oFolder = null,
			oParentMessage = null,
			bThreadLevel = false
		;
		
		if (this.currentMessage())
		{
			bThreadLevel = this.currentMessage().threadPart() && this.currentMessage().threadParentUid() !== '';
			oFolder = this.folderList().getFolderByFullName(this.currentMessage().folder());
			sCurrentUid = this.currentMessage().uid();
			if (this.bInThreadLevel || bThreadLevel)
			{
				this.bInThreadLevel = true;
				if (bThreadLevel)
				{
					oParentMessage = oFolder.getMessageByUid(this.currentMessage().threadParentUid());
					if (oParentMessage)
					{
						_.each(oParentMessage.threadUids(), function (sUid, iIndex, aCollection) {
							if (sUid === sCurrentUid && iIndex > 0)
							{
								sNextUid = aCollection[iIndex - 1];
							}
						});
						if (!Types.isNonEmptyString(sNextUid))
						{
							sNextUid = oParentMessage.uid();
						}
					}
				}
			}
			else
			{
				_.each(this.uidList().collection(), function (sUid, iIndex, aCollection) {
					if (sUid === sCurrentUid && iIndex > 0)
					{
						sNextUid = aCollection[iIndex - 1] || '';
					}
				});
				if (sNextUid === '' && MainTab)
				{
					this.requirePrefetcher();
					Prefetcher.prefetchNextPage(sCurrentUid);
				}
			}
		}
		this.nextMessageUid(sNextUid);
	};

	CMailCache.prototype.calcPrevMessageUid = function ()
	{
		var
			sCurrentUid = this.currentMessage() ? this.currentMessage().uid() : '',
			sPrevUid = '',
			oFolder = null,
			oParentMessage = null,
			bThreadLevel = false
		;

		if (this.currentMessage())
		{
			bThreadLevel = this.currentMessage().threadPart() && this.currentMessage().threadParentUid() !== '';
			oFolder = this.folderList().getFolderByFullName(this.currentMessage().folder());
			sCurrentUid = this.currentMessage().uid();
			if (this.bInThreadLevel || bThreadLevel)
			{
				this.bInThreadLevel = true;
				if (bThreadLevel)
				{
					oParentMessage = oFolder.getMessageByUid(this.currentMessage().threadParentUid());
					if (oParentMessage)
					{
						_.each(oParentMessage.threadUids(), function (sUid, iIndex, aCollection) {
							if (sUid === sCurrentUid && (iIndex + 1) < aCollection.length)
							{
								sPrevUid = aCollection[iIndex + 1] || '';
							}
						});
					}
				}
				else if (this.currentMessage().threadCount() > 0)
				{
					sPrevUid = this.currentMessage().threadUids()[0];
				}
			}
			else
			{
				_.each(this.uidList().collection(), function (sUid, iIndex, aCollection) {
					if (sUid === sCurrentUid && (iIndex + 1) < aCollection.length)
					{
						sPrevUid = aCollection[iIndex + 1] || '';
					}
				});
				if (sPrevUid === '' && MainTab)
				{
					this.requirePrefetcher();
					Prefetcher.prefetchPrevPage(sCurrentUid);
				}
			}
		}
		
		this.prevMessageUid(sPrevUid);
	};

	CMailCache.prototype.getCurrentFolder = function ()
	{
		return this.folderList().currentFolder();
	};

	/**
	 * @param {number} iAccountId
	 * @param {string} sFolderFullName
	 */
	CMailCache.prototype.getFolderByFullName = function (iAccountId, sFolderFullName)
	{
		var
			oFolderList = this.oFolderListItems[iAccountId]
		;
		
		if (oFolderList)
		{
			return oFolderList.getFolderByFullName(sFolderFullName);
		}
		
		return null;
	};

	CMailCache.prototype.checkCurrentFolderList = function ()
	{
		var
			oCurrAccount = AccountList.getCurrent(),
			oFolderList = oCurrAccount ? this.oFolderListItems[oCurrAccount.id()] : null
		;
		
		if (oCurrAccount && !oFolderList && !this.messagesLoading())
		{
			this.messagesLoading(true);
			this.messagesLoadingError(false);
			this.getFolderList(oCurrAccount.id());
		}
	};

	/**
	 * @param {number} iAccountID
	 */
	CMailCache.prototype.getFolderList = function (iAccountID)
	{
		var oAccount = AccountList.getAccount(iAccountID);
		
		if (oAccount)
		{
			this.folderListLoading.push(iAccountID);

			Ajax.send('GetFolders', { 'AccountID': iAccountID }, this.onGetFoldersResponse, this);
		}
		else if (iAccountID === this.currentAccountId())
		{
			this.messagesLoading(false);
		}
	};

	/**
	 * @param {number} iAccountId
	 * @param {string} sFullName
	 * @param {string} sUid
	 * @param {string} sReplyType
	 */
	CMailCache.prototype.markMessageReplied = function (iAccountId, sFullName, sUid, sReplyType)
	{
		var
			oFolderList = this.oFolderListItems[iAccountId],
			oFolder = null
		;
		
		if (oFolderList)
		{
			oFolder = oFolderList.getFolderByFullName(sFullName);
			if (oFolder)
			{
				oFolder.markMessageReplied(sUid, sReplyType);
			}
		}
	};

	/**
	 * @param {Object} oMessage
	 */
	CMailCache.prototype.hideThreads = function (oMessage)
	{
		var oAccount = AccountList.getCurrent();
		if (oAccount && oAccount.threadingIsAvailable() && oMessage.folder() === this.folderList().currentFolderFullName() && !oMessage.threadOpened())
		{
			this.folderList().currentFolder().hideThreadMessages(oMessage);
		}
	};

	/**
	 * @param {string} sFolderFullName
	 */
	CMailCache.prototype.showOpenedThreads = function (sFolderFullName)
	{
		this.messages(this.getMessagesWithThreads(sFolderFullName, this.uidList(), this.messages()));
	};

	/**
	 * @param {Object} oUidList
	 * @returns {Boolean}
	 */
	CMailCache.prototype.useThreadingInCurrentList = function (oUidList)
	{
		oUidList = oUidList || this.uidList();
		
		var
			oAccount = AccountList.getCurrent(),
			oCurrFolder = this.folderList().currentFolder(),
			bFolderWithoutThreads = oCurrFolder && oCurrFolder.withoutThreads(),
			bNotSearchOrFilters = oUidList.search() === '' && oUidList.filters() === ''
		;
		
		return oAccount && oAccount.threadingIsAvailable() && !bFolderWithoutThreads && bNotSearchOrFilters;
	};

	/**
	 * @param {string} sFolderFullName
	 * @param {Object} oUidList
	 * @param {Array} aOrigMessages
	 */
	CMailCache.prototype.getMessagesWithThreads = function (sFolderFullName, oUidList, aOrigMessages)
	{
		var
			aExtMessages = [],
			aMessages = [],
			oCurrFolder = this.folderList().currentFolder()
		;
		
		if (oCurrFolder && sFolderFullName === oCurrFolder.fullName() && this.useThreadingInCurrentList(oUidList))
		{
			aMessages = _.filter(aOrigMessages, function (oMess) {
				return !oMess.threadPart();
			});

			_.each(aMessages, function (oMess) {
				var aThreadMessages = [];
				aExtMessages.push(oMess);
				if (oMess.threadCount() > 0)
				{
					if (oMess.threadOpened())
					{
						aThreadMessages = this.folderList().currentFolder().getThreadMessages(oMess);
						aExtMessages = _.union(aExtMessages, aThreadMessages);
					}
					oCurrFolder.computeThreadData(oMess);
				}
			}, this);
			
			return aExtMessages;
		}
		
		return aOrigMessages;
	};

	/**
	 * @param {Object} oUidList
	 * @param {number} iOffset
	 * @param {Object} oMessages
	 * @param {boolean} bFillMessages
	 */
	CMailCache.prototype.setMessagesFromUidList = function (oUidList, iOffset, oMessages, bFillMessages)
	{
		var
			aUids = oUidList.getUidsForOffset(iOffset, oMessages),
			aMessages = _.map(aUids, function (sUid) {
				return oMessages[sUid];
			}, this),
			iMessagesCount = aMessages.length
		;
		
		if (bFillMessages)
		{
			this.messages(this.getMessagesWithThreads(this.folderList().currentFolderFullName(), oUidList, aMessages));
			
			if ((iOffset + iMessagesCount < oUidList.resultCount()) &&
				(iMessagesCount < Settings.MailsPerPage) &&
				(oUidList.filters() !== Enums.FolderFilter.Unseen || this.waitForUnseenMessages()))
			{
				this.messagesLoading(true);
			}

			if (this.currentMessage() && (this.currentMessage().deleted() ||
				this.currentMessage().folder() !== this.folderList().currentFolderFullName()))
			{
				this.currentMessage(null);
			}
		}

		return aUids;
	};

	/**
	 * @param {boolean} bAbortPrevious
	 */
	CMailCache.prototype.executeCheckMail = function (bAbortPrevious)
	{
		var
			oFolderList = this.oFolderListItems[this.currentAccountId()],
			aFoldersFromAccount = AccountList.getCurrentFetchersAndFiltersFolderNames(),
			aFolders = oFolderList ? [oFolderList.inboxFolderFullName(), oFolderList.spamFolderFullName(), oFolderList.currentFolderFullName()] : [],
			iAccountID = oFolderList ? oFolderList.iAccountId : 0,
			bCurrentAccountCheckmailStarted = this.checkMailStarted() && (this.checkMailStartedAccountId() === iAccountID),
			oParameters = null
		;
		
		if (App.getUserRole() !== Enums.UserRole.Anonymous && (bAbortPrevious || !Ajax.hasOpenedRequests('GetRelevantFoldersInformation') || !bCurrentAccountCheckmailStarted) && (aFolders.length > 0))
		{
			aFolders = _.uniq(_.compact(_.union(aFolders, aFoldersFromAccount)));
			oParameters = {
				'Folders': aFolders,
				'AccountID': iAccountID
			};
			
			this.checkMailStarted(true);
			this.checkMailStartedAccountId(iAccountID);
			if (AccountList.getAccount(iAccountID))
			{
				Ajax.send('GetRelevantFoldersInformation', oParameters, this.onGetRelevantFoldersInformationResponse, this);
			}
		}
	};

	CMailCache.prototype.setAutocheckmailTimer = function ()
	{
		clearTimeout(this.iAutoCheckMailTimer);
		
		if (!App.isNewTab() && UserSettings.AutoRefreshIntervalMinutes > 0)
		{
			this.iAutoCheckMailTimer = setTimeout(function () {
				if (!MailCache.isSearchExecuting())
				{
					MailCache.checkMessageFlags();
					MailCache.executeCheckMail(false);
				}
			}, UserSettings.AutoRefreshIntervalMinutes * 60 * 1000);
		}
	};

	CMailCache.prototype.isSearchExecuting = function ()
	{
		var
			oRequest = Ajax.getOpenedRequest('GetMessages'),
			oParameters = oRequest && oRequest.Parameters
		;
		return oParameters && oParameters.Search !== '';
	};

	CMailCache.prototype.checkMessageFlags = function ()
	{
		var
			oInbox = this.folderList().inboxFolder(),
			aUids = oInbox ? oInbox.getFlaggedMessageUids() : [],
			oParameters = {
				'Folder': this.folderList().inboxFolderFullName(),
				'Uids': aUids
			}
		;
		
		if (aUids.length > 0)
		{
			Ajax.send('GetMessagesFlags', oParameters, this.onGetMessagesFlagsResponse, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onGetMessagesFlagsResponse = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oFolderList = this.oFolderListItems[oParameters.AccountID],
			oInbox = (oFolderList) ? oFolderList.inboxFolder() : null
		;
		
		if (oInbox)
		{
			if (oResponse.Result)
			{
				_.each(oResponse.Result, function (aFlags, sUid) {
					if (_.indexOf(aFlags, '\\flagged') === -1)
					{
						oInbox.setMessageUnflaggedByUid(sUid);
					}
				});
			}
			oInbox.removeFlaggedMessageListsFromCache();
			this.requirePrefetcher();
			Prefetcher.prefetchStarredMessageList();
		}
	};

	/**
	 * @param {string} sFolder
	 * @param {number} iPage
	 * @param {string} sSearch
	 * @param {string=} sFilter
	 */
	CMailCache.prototype.changeCurrentMessageList = function (sFolder, iPage, sSearch, sFilter)
	{
		this.requestCurrentMessageList(sFolder, iPage, sSearch, sFilter, true);
	};

	/**
	 * @param {string} sFolder
	 * @param {number} iPage
	 * @param {string} sSearch
	 * @param {string=} sFilter
	 * @param {boolean=} bFillMessages
	 */
	CMailCache.prototype.requestCurrentMessageList = function (sFolder, iPage, sSearch, sFilter, bFillMessages)
	{
		var
			oRequestData = this.requestMessageList(sFolder, iPage, sSearch, sFilter || '', true, (bFillMessages || false)),
			iCheckmailIntervalMilliseconds = UserSettings.AutoRefreshIntervalMinutes * 60 * 1000,
			iFolderUpdateDiff = oRequestData.Folder.relevantInformationLastMoment ? moment().diff(oRequestData.Folder.relevantInformationLastMoment) : iCheckmailIntervalMilliseconds + 1
		;
		
		this.uidList(oRequestData.UidList);
		this.page(iPage);
		
		this.messagesLoading(oRequestData.RequestStarted);
		this.messagesLoadingError(false);
		
		if (!oRequestData.RequestStarted && iCheckmailIntervalMilliseconds > 0 && iFolderUpdateDiff > iCheckmailIntervalMilliseconds)
		{
			this.executeCheckMail(true);
		}
	};

	/**
	 * @param {string} sFolder
	 * @param {number} iPage
	 * @param {string} sSearch
	 * @param {string} sFilters
	 * @param {boolean} bCurrent
	 * @param {boolean} bFillMessages
	 */
	CMailCache.prototype.requestMessageList = function (sFolder, iPage, sSearch, sFilters, bCurrent, bFillMessages)
	{
		var
			oFolderList = this.oFolderListItems[this.currentAccountId()],
			oFolder = (oFolderList) ? oFolderList.getFolderByFullName(sFolder) : null,
			bFolderWithoutThreads = oFolder && oFolder.withoutThreads(),
			oAccount = AccountList.getCurrent(),
			bUseThreading = oAccount && oAccount.threadingIsAvailable() && !bFolderWithoutThreads && sSearch === '' && sFilters === '',
			oUidList = (oFolder) ? oFolder.getUidList(sSearch, sFilters) : null,
			bCacheIsEmpty = oUidList && oUidList.resultCount() === -1,
			iOffset = (iPage - 1) * Settings.MailsPerPage,
			oParameters = {
				'Folder': sFolder,
				'Offset': iOffset,
				'Limit': Settings.MailsPerPage,
				'Search': sSearch,
				'Filters': sFilters,
				'UseThreading': bUseThreading
			},
			bStartRequest = false,
			bDataExpected = false,
			fCallBack = bCurrent ? this.onCurrentGetMessagesResponse : this.onGetMessagesResponse,
			aUids = []
		;
		
		if (oFolder.type() === Enums.FolderTypes.Inbox && sFilters === '')
		{
			oParameters['InboxUidnext'] = oFolder.sUidNext;
		}
		else
		{
			oParameters['InboxUidnext'] = '';
		}
		
		if (bCacheIsEmpty && oUidList.search() === this.uidList().search() && oUidList.filters() === this.uidList().filters())
		{
			oUidList = this.uidList();
		}
		if (oUidList)
		{
			aUids = this.setMessagesFromUidList(oUidList, iOffset, oFolder.oMessages, bFillMessages);
		}
		
		if (oUidList)
		{
			bDataExpected = 
				(bCacheIsEmpty) ||
				((iOffset + aUids.length < oUidList.resultCount()) && (aUids.length < Settings.MailsPerPage))
			;
			bStartRequest = oFolder.hasChanges() || bDataExpected;
		}
		
		if (bStartRequest)
		{
			Ajax.send('GetMessages', oParameters, fCallBack, this);
		}
		else
		{
			this.waitForUnseenMessages(false);
		}
		
		return {UidList: oUidList, RequestStarted: bStartRequest, DataExpected: bDataExpected, Folder: oFolder};
	};

	CMailCache.prototype.executeEmptyTrash = function ()
	{
		var oFolder = this.folderList().trashFolder();
		if (oFolder)
		{
			oFolder.emptyFolder();
		}
	};

	CMailCache.prototype.executeEmptySpam = function ()
	{
		var oFolder = this.folderList().spamFolder();
		if (oFolder)
		{
			oFolder.emptyFolder();
		}
	};

	/**
	 * @param {Object} oFolder
	 */
	CMailCache.prototype.onClearFolder = function (oFolder)
	{
		if (oFolder && oFolder.selected())
		{
			this.messages.removeAll();
			this.currentMessage(null);
			var oUidList = (oFolder) ? oFolder.getUidList(this.uidList().search(), this.uidList().filters()) : null;
			if (oUidList)
			{
				this.uidList(oUidList);
			}
			else
			{
				this.uidList(new CUidListModel());
			}
			
			// GetRelevantFoldersInformation-request aborted during folder cleaning, not to get the wrong information.
			// So here indicates that chekmail is over.
			this.checkMailStarted(false);
			this.setAutocheckmailTimer();
		}
	};

	CMailCache.prototype.getOpenedDraftUids = function ()
	{
		var
			aOpenedWins = WindowOpener.getOpenedWindows(),
			aDraftUids = _.map(aOpenedWins, function (oWin) {
				return (oWin.SlaveTabMailMethods && (window.location.origin === oWin.location.origin)) ? oWin.SlaveTabMailMethods.getEditedDraftUid() : '';
			})
		;

		if (Popups.hasOpenedMinimizedPopups())
		{
			aDraftUids.push(this.editedDraftUid());
		}

		return _.uniq(_.compact(aDraftUids));
	};

	/*
	 * @param {array} aUids
	 */
	CMailCache.prototype.closeComposesWithDraftUids = function (aUids)
	{
		var aOpenedWins = WindowOpener.getOpenedWindows();
		
		_.each(aOpenedWins, function (oWin) {
			if (oWin.SlaveTabMailMethods && (window.location.origin === oWin.location.origin) && -1 !== $.inArray(oWin.SlaveTabMailMethods.getEditedDraftUid(), aUids))
			{
				oWin.close();
			}
		});

		if (-1 !== $.inArray(this.editedDraftUid(), aUids))
		{
			var ComposeUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Compose.js */ 408);
			if (_.isFunction(ComposeUtils.closeComposePopup))
			{
				ComposeUtils.closeComposePopup();
			}
		}
	};

	/**
	 * @param {string} sToFolderFullName
	 * @param {Array} aUids
	 */
	CMailCache.prototype.moveMessagesToFolder = function (sToFolderFullName, aUids)
	{
		if (aUids.length > 0)
		{
			var
				oCurrFolder = this.folderList().currentFolder(),
				bDraftsFolder = oCurrFolder && oCurrFolder.type() === Enums.FolderTypes.Drafts,
				aOpenedDraftUids = bDraftsFolder && this.getOpenedDraftUids(),
				bTryToDeleteEditedDraft = bDraftsFolder && _.find(aUids, _.bind(function (sUid) {
					return -1 !== $.inArray(sUid, aOpenedDraftUids);
				}, this)),
				oToFolder = this.folderList().getFolderByFullName(sToFolderFullName),
				oParameters = {
					'Folder': oCurrFolder ? oCurrFolder.fullName() : '',
					'ToFolder': sToFolderFullName,
					'Uids': aUids.join(',')
				},
				oDiffs = null,
				fMoveMessages = _.bind(function () {
					if (this.uidList().filters() === Enums.FolderFilter.Unseen && this.uidList().resultCount() > Settings.MailsPerPage)
					{
						this.waitForUnseenMessages(true);
					}
					
					oDiffs = oCurrFolder.markDeletedByUids(aUids);
					oToFolder.addMessagesCountsDiff(oDiffs.MinusDiff, oDiffs.UnseenMinusDiff);

					oToFolder.recivedAnim(true);

					this.excludeDeletedMessages();

					oToFolder.markHasChanges();
					
					Ajax.send('MoveMessages', oParameters, this.onMoveMessagesResponse, this);
				}, this)
			;

			if (oCurrFolder && oToFolder)
			{
				if (bTryToDeleteEditedDraft)
				{
					this.disableComposeAutosave(true);
					Popups.showPopup(ConfirmPopup, [TextUtils.i18n('MAILWEBCLIENT/CONFIRM_MESSAGE_FOR_DELETE_IS_EDITED'), 
						_.bind(function (bOk) {
							if (bOk)
							{
								this.closeComposesWithDraftUids(aUids);
								fMoveMessages();
							}
							this.disableComposeAutosave(false);
						}, this), 
						'', TextUtils.i18n('MAILWEBCLIENT/ACTION_CLOSE_DELETE_DRAFT')
					]);
				}
				else
				{
					fMoveMessages();
				}
			}
		}
	};

	CMailCache.prototype.copyMessagesToFolder = function (sToFolderFullName, aUids)
	{
		if (aUids.length > 0)
		{
			var
				oCurrFolder = this.folderList().currentFolder(),
				oToFolder = this.folderList().getFolderByFullName(sToFolderFullName),
				oParameters = {
					'Folder': oCurrFolder ? oCurrFolder.fullName() : '',
					'ToFolder': sToFolderFullName,
					'Uids': aUids.join(',')
				}
			;

			if (oCurrFolder && oToFolder)
			{
				oToFolder.recivedAnim(true);

				oToFolder.markHasChanges();

				Ajax.send('CopyMessages', oParameters, this.onCopyMessagesResponse, this);

	//			if (oToFolder && oToFolder.type() === Enums.FolderTypes.Trash)
	//			{
	//				AfterLogicApi.runPluginHook('copy-messages-to-trash',
	//					[AccountList.currentId(), oParameters.Folder, aUids]);
	//			}
	//
	//			if (oToFolder && oToFolder.type() === Enums.FolderTypes.Spam)
	//			{
	//				AfterLogicApi.runPluginHook('copy-messages-to-spam',
	//					[AccountList.currentId(), oParameters.Folder, aUids]);
	//			}
			}
		}
	};

	CMailCache.prototype.excludeDeletedMessages = function ()
	{
		_.delay(_.bind(function () {
			
			var
				oCurrFolder = this.folderList().currentFolder(),
				iOffset = (this.page() - 1) * Settings.MailsPerPage
			;
			
			this.setMessagesFromUidList(this.uidList(), iOffset, oCurrFolder.oMessages, true);
			
		}, this), 500);
	};

	/**
	 * @param {number} iAccountID
	 * @param {string} sFolderFullName
	 * @param {string} sDraftUid
	 */
	CMailCache.prototype.removeOneMessageFromCacheForFolder = function (iAccountID, sFolderFullName, sDraftUid)
	{
		var
			oFolderList = this.oFolderListItems[iAccountID],
			oFolder = oFolderList ? oFolderList.getFolderByFullName(sFolderFullName) : null
		;
		
		if (oFolder && oFolder.type() === Enums.FolderTypes.Drafts)
		{
			oFolder.markDeletedByUids([sDraftUid]);
			oFolder.commitDeleted([sDraftUid]);
		}
	};

	/**
	 * @param {number} iAccountID
	 * @param {string} sFolderFullName
	 */
	CMailCache.prototype.startMessagesLoadingWhenDraftSaving = function (iAccountID, sFolderFullName)
	{
		var
			oFolderList = this.oFolderListItems[iAccountID],
			oFolder = oFolderList ? oFolderList.getFolderByFullName(sFolderFullName) : null
		;
		
		if ((oFolder && oFolder.type() === Enums.FolderTypes.Drafts) && oFolder.selected())
		{
			this.messagesLoading(true);
		}
	};

	/**
	 * @param {number} iAccountID
	 * @param {string} sFolderFullName
	 */
	CMailCache.prototype.removeMessagesFromCacheForFolder = function (iAccountID, sFolderFullName)
	{
		var
			oFolderList = this.oFolderListItems[iAccountID],
			oFolder = oFolderList ? oFolderList.getFolderByFullName(sFolderFullName) : null,
			sCurrFolderFullName = oFolderList ? oFolderList.currentFolderFullName() : null
		;
		if (oFolder)
		{
			oFolder.markHasChanges();
			if (this.currentAccountId() === iAccountID && sFolderFullName === sCurrFolderFullName)
			{
				this.requestCurrentMessageList(sCurrFolderFullName, this.page(), this.uidList().search(), '', true);
			}
		}
	};

	/**
	 * @param {Array} aUids
	 */
	CMailCache.prototype.deleteMessages = function (aUids)
	{
		var
			oCurrFolder = this.folderList().currentFolder()
		;

		if (oCurrFolder)
		{
			this.deleteMessagesFromFolder(oCurrFolder, aUids);
		}
	};

	/**
	 * @param {Object} oFolder
	 * @param {Array} aUids
	 */
	CMailCache.prototype.deleteMessagesFromFolder = function (oFolder, aUids)
	{
		var oParameters = {
			'Folder': oFolder.fullName(),
			'Uids': aUids.join(',')
		};

		oFolder.markDeletedByUids(aUids);

		this.excludeDeletedMessages();

		Ajax.send('DeleteMessages', oParameters, this.onMoveMessagesResponse, this);
		
	//	AfterLogicApi.runPluginHook('delete-messages', 
	//		[AccountList.currentId(), oParameters.Folder, aUids]);
	};

	/**
	 * @param {boolean} bAlwaysForSender
	 */
	CMailCache.prototype.showExternalPictures = function (bAlwaysForSender)
	{
		var
			aFrom = [],
			oFolder = null
		;
			
		if (this.currentMessage())
		{
			aFrom = this.currentMessage().oFrom.aCollection;
			oFolder = this.folderList().getFolderByFullName(this.currentMessage().folder());

			if (bAlwaysForSender && aFrom.length > 0)
			{
				oFolder.alwaysShowExternalPicturesForSender(aFrom[0].sEmail);
			}
			else
			{
				oFolder.showExternalPictures(this.currentMessage().uid());
			}
		}
	};

	/**
	 * @param {string|null} sUid
	 * @param {string} sFolder
	 */
	CMailCache.prototype.setCurrentMessage = function (sUid, sFolder)
	{
		var
			oCurrFolder = this.folderList().currentFolder(),
			oMessage = null
		;
		
		if (App.isNewTab() && (!oCurrFolder || oCurrFolder.fullName() !== sFolder))
		{
			this.folderList().setCurrentFolder(sFolder, '');
			oCurrFolder = this.folderList().currentFolder();
		}
		
		if (oCurrFolder && sUid)
		{
			oMessage = oCurrFolder.oMessages[sUid];
		}
		
		if (oMessage && !oMessage.deleted())
		{
			this.currentMessage(oMessage);
			if (!this.currentMessage().seen())
			{
				this.executeGroupOperation('SetMessagesSeen', [this.currentMessage().uid()], 'seen', true);
			}
			oCurrFolder.getCompletelyFilledMessage(sUid, this.onCurrentMessageResponse, this);
		}
		else
		{
			this.currentMessage(null);
			if (App.isNewTab() && oCurrFolder)
			{
				oCurrFolder.getCompletelyFilledMessage(sUid, this.onCurrentMessageResponse, this);
			}
		}
	};

	/**
	 * @param {Object} oMessage
	 * @param {string} sUid
	 */
	CMailCache.prototype.onCurrentMessageResponse = function (oMessage, sUid)
	{
		var sCurrentUid = this.currentMessage() ? this.currentMessage().uid() : '';
		
		if (oMessage === null && sCurrentUid === sUid)
		{
			this.currentMessage(null);
		}
		else if (oMessage && sCurrentUid === sUid)
		{
			this.currentMessage.valueHasMutated();
		}
		else if (App.isNewTab() && oMessage && this.currentMessage() === null)
		{
			this.currentMessage(oMessage);
		}
	};

	/**
	 * @param {string} sFullName
	 * @param {string} sUid
	 * @param {Function} fResponseHandler
	 * @param {Object} oContext
	 */
	CMailCache.prototype.getMessage = function (sFullName, sUid, fResponseHandler, oContext)
	{
		var
			oFolder = this.folderList().getFolderByFullName(sFullName)
		;
		
		if (oFolder)
		{
			oFolder.getCompletelyFilledMessage(sUid, fResponseHandler, oContext);
		}
	};

	/**
	 * @param {string} sMethod
	 * @param {Array} aUids
	 * @param {string} sField
	 * @param {boolean} bSetAction
	 */
	CMailCache.prototype.executeGroupOperation = function (sMethod, aUids, sField, bSetAction)
	{
		var
			oCurrFolder = this.folderList().currentFolder(),
			oParameters = {
				'Folder': oCurrFolder ? oCurrFolder.fullName() : '',
				'Uids': aUids.join(','),
				'SetAction': bSetAction
			},
			iOffset = (this.page() - 1) * Settings.MailsPerPage,
			iUidsCount = aUids.length,
			iStarredCount = this.folderList().oStarredFolder ? this.folderList().oStarredFolder.messageCount() : 0,
			oStarredUidList = oCurrFolder ? oCurrFolder.getUidList('', Enums.FolderFilter.Flagged) : null,
			fCallback = (sMethod === 'SetMessagesSeen') ? this.onSetMessagesSeenResponse : function () {}
		;

		if (oCurrFolder)
		{
			if (sMethod === 'SetMessagesSeen')
			{
				this.iSetMessagesSeenCount++;
			}
			Ajax.send(sMethod, oParameters, fCallback, this);

			oCurrFolder.executeGroupOperation(sField, aUids, bSetAction);
			
			if (oCurrFolder.type() === Enums.FolderTypes.Inbox && sField === 'flagged')
			{
				if (this.uidList().filters() === Enums.FolderFilter.Flagged)
				{
					if (!bSetAction)
					{
						this.uidList().deleteUids(aUids);
						if (this.folderList().oStarredFolder)
						{
							this.folderList().oStarredFolder.messageCount(oStarredUidList.resultCount());
						}
					}
				}
				else
				{
					oCurrFolder.removeFlaggedMessageListsFromCache();
					if (this.uidList().search() === '' && this.folderList().oStarredFolder)
					{
						if (bSetAction)
						{
							this.folderList().oStarredFolder.messageCount(iStarredCount + iUidsCount);
						}
						else
						{
							this.folderList().oStarredFolder.messageCount((iStarredCount - iUidsCount > 0) ? iStarredCount - iUidsCount : 0);
						}
					}
				}
			}
				
			if (sField === 'seen')
			{
				oCurrFolder.removeUnseenMessageListsFromCache();
			}
			
			if (this.uidList().filters() !== Enums.FolderFilter.Unseen || this.waitForUnseenMessages())
			{
				this.setMessagesFromUidList(this.uidList(), iOffset, oCurrFolder.oMessages, true);
			}
		}
	};

	/**
	 * private
	 */

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onSetMessagesSeenResponse = function (oResponse, oRequest)
	{
		this.iSetMessagesSeenCount--;
		if (this.iSetMessagesSeenCount < 0)
		{
			this.iSetMessagesSeenCount = 0;
		}
		if (this.folderList().currentFolder() && this.iSetMessagesSeenCount === 0 && (this.uidList().filters() !== Enums.FolderFilter.Unseen || this.waitForUnseenMessages()))
		{
			this.requestCurrentMessageList(this.folderList().currentFolder().fullName(), this.page(), this.uidList().search(), this.uidList().filters(), false);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onGetFoldersResponse = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oFolderList = new CFolderListModel(),
			iAccountId = oParameters.AccountID,
			oFolderListOld = this.oFolderListItems[iAccountId],
			oNamedFolderListOld = oFolderListOld ? oFolderListOld.oNamedCollection : {}
		;		

		if (oResponse.Result === false)
		{
			Api.showErrorByCode(oResponse);
			
			if (oParameters.AccountID === this.currentAccountId() && this.messages().length === 0)
			{
				this.messagesLoading(false);
				this.messagesLoadingError(true);
			}
		}
		else
		{
			oFolderList.parse(iAccountId, oResponse.Result, oNamedFolderListOld);
			if (oFolderListOld)
			{
				oFolderList.oStarredFolder.messageCount(oFolderListOld.oStarredFolder.messageCount());
			}
			this.oFolderListItems[iAccountId] = oFolderList;

			setTimeout(_.bind(this.getAllFoldersRelevantInformation, this, iAccountId), 2000);

			if (this.currentAccountId() === iAccountId)
			{
				this.folderList(oFolderList);
			}
			if (this.editedAccountId() === iAccountId)
			{
				this.editedFolderList(oFolderList);
			}
		}
		
		this.folderListLoading.remove(iAccountId);
	};

	/**
	 * @param {number} iAccountId
	 */
	CMailCache.prototype.getAllFoldersRelevantInformation = function (iAccountId)
	{
		var
			oFolderList = this.oFolderListItems[iAccountId],
			aFolders = oFolderList ? oFolderList.getFoldersWithoutCountInfo() : [],
			oParameters = {
				'Folders': aFolders,
				'AccountID': iAccountId
			}
		;
		
		if (aFolders.length > 0 && AccountList.getAccount(iAccountId))
		{
			Ajax.send('GetRelevantFoldersInformation', oParameters, this.onGetRelevantFoldersInformationResponse, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onGetRelevantFoldersInformationResponse = function (oResponse, oRequest)
	{
		var
			bCheckMailStarted = false,
			oParameters = oRequest.Parameters,
			iAccountId = oParameters.AccountID,
			oFolderList = this.oFolderListItems[iAccountId],
			sCurrentFolderName = this.folderList().currentFolderFullName(),
			bSameAccount = this.currentAccountId() === iAccountId
		;
		
		if (oResponse.Result === false)
		{
			Api.showErrorByCode(oResponse);
			if (Ajax.hasOpenedRequests('GetRelevantFoldersInformation'))
			{
				bCheckMailStarted = true;
			}
		}
		else
		{
			if (oFolderList)
			{
				_.each(oResponse.Result && oResponse.Result.Counts, function(aData, sFullName) {
					if (_.isArray(aData) && aData.length > 3)
					{
						var
							iCount = aData[0],
							iUnseenCount = aData[1],
							sUidNext = aData[2],
							sHash = aData[3],
							bFolderHasChanges = false,
							bSameFolder = false,
							oFolder = null
						;

						oFolder = oFolderList.getFolderByFullName(sFullName);
						if (oFolder)
						{
							bSameFolder = bSameAccount && oFolder.fullName() === sCurrentFolderName;
							bFolderHasChanges = oFolder.setRelevantInformation(sUidNext, sHash, iCount, iUnseenCount, bSameFolder);
							if (bSameFolder && bFolderHasChanges && this.uidList().filters() !== Enums.FolderFilter.Unseen)
							{
								this.requestCurrentMessageList(oFolder.fullName(), this.page(), this.uidList().search(), this.uidList().filters(), false);
								bCheckMailStarted = true;
							}
						}
					}
				}, this);
				
				oFolderList.countsCompletelyFilled(true);
			}
		}
		
		this.checkMailStarted(bCheckMailStarted);
		if (!this.checkMailStarted())
		{
			this.setAutocheckmailTimer();
		}
	};

	/**
	 * @param {Object} oResponse
	 */
	CMailCache.prototype.showNotificationsForNewMessages = function (oResponse)
	{
		var
			sCurrentFolderName = this.folderList().currentFolderFullName(),
			iNewLength = 0,
			sUid = '',
			oParameters = {},
			sFrom = '',
			aBody = []
		;
		
		if (oResponse.Result.New && oResponse.Result.New.length > 0)
		{
			iNewLength = oResponse.Result.New.length;
			sUid = oResponse.Result.New[0].Uid;
			oParameters = {
				action:'show',
				icon: 'static/styles/images/logo_140x140.png',
				title: TextUtils.i18n('MAILWEBCLIENT/INFO_NEW_MESSAGES_PLURAL', {
					'COUNT': iNewLength
				}, null, iNewLength),
				timeout: 5000,
				callback: function () {
					window.focus();
					Routing.setHash(LinksUtils.getMailbox(sCurrentFolderName, 1, sUid, '', ''));
				}
			};

			if (iNewLength === 1)
			{
				if (Types.isNonEmptyString(oResponse.Result.New[0].Subject))
				{
					aBody.push(TextUtils.i18n('MAILWEBCLIENT/LABEL_SUBJECT') + ': ' + oResponse.Result.New[0].Subject);
				}
				
				sFrom = (_.map(oResponse.Result.New[0].From, function(oFrom) {
					return oFrom.DisplayName !== '' ? oFrom.DisplayName : oFrom.Email;
				})).join(', ');
				if (Types.isNonEmptyString(sFrom))
				{
					aBody.push(TextUtils.i18n('MAILWEBCLIENT/LABEL_FROM') + ': ' + sFrom);
				}
				
				oParameters.body = aBody.join('\r\n');
			}

			Utils.desktopNotify(oParameters);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onCurrentGetMessagesResponse = function (oResponse, oRequest)
	{
		this.checkMailStarted(false);

		if (!oResponse.Result)
		{
			Api.showErrorByCode(oResponse);
			if (this.messagesLoading() === true && (this.messages().length === 0 || oResponse.ErrorCode !== Enums.Errors.NotDisplayedError))
			{
				this.messagesLoadingError(true);
			}
			this.messagesLoading(false);
			this.setAutocheckmailTimer();
		}
		else
		{
			this.messagesLoadingError(false);
			this.parseMessageList(oResponse, oRequest);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onGetMessagesResponse = function (oResponse, oRequest)
	{
		if (oResponse && oResponse.Result)
		{
			this.parseMessageList(oResponse, oRequest);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.parseMessageList = function (oResponse, oRequest)
	{
		var
			oResult = oResponse.Result,
			oParameters = oRequest.Parameters,
			iAccountId = oParameters.AccountID,
			oFolderList = this.oFolderListItems[iAccountId],
			oFolder = null,
			oUidList = null,
			bTrustThreadInfo = oParameters.UseThreading,
			bHasFolderChanges = false,
			bCurrentFolder = this.currentAccountId() === iAccountId &&
					this.folderList().currentFolderFullName() === oResult.FolderName,
			bCurrentList = bCurrentFolder &&
					this.uidList().search() === oResult.Search &&
					this.uidList().filters() === oResult.Filters,
			bCurrentPage = this.page() === ((oResult.Offset / Settings.MailsPerPage) + 1),
			aNewFolderMessages = []
		;
		
		this.showNotificationsForNewMessages(oResponse);
		
		if (oResult !== false && oResult['@Object'] === 'Collection/MessageCollection')
		{
			oFolder = oFolderList.getFolderByFullName(oResult.FolderName);
			
			// perform before getUidList, because in case of a mismatch the uid list will be pre-cleaned
			oFolder.setRelevantInformation(oResult.UidNext.toString(), oResult.FolderHash, 
				oResult.MessageCount, oResult.MessageUnseenCount, bCurrentFolder && !bCurrentList);
			bHasFolderChanges = oFolder.hasChanges();
			oFolder.removeAllMessageListsFromCacheIfHasChanges();
			
			oUidList = oFolder.getUidList(oResult.Search, oResult.Filters);
			oUidList.setUidsAndCount(oResult);
			_.each(oResult['@Collection'], function (oRawMessage) {
				var oFolderMessage = oFolder.parseAndCacheMessage(oRawMessage, false, bTrustThreadInfo);
				aNewFolderMessages.push(oFolderMessage);
			}, this);
			
	//		AfterLogicApi.runPluginHook('response-custom-messages', 
	//			[oParameters.AccountID, oFolder.fullName(), aNewFolderMessages]);

			if (bCurrentList)
			{
				this.uidList(oUidList);
				if (bCurrentPage && (oUidList.filters() !== Enums.FolderFilter.Unseen || this.waitForUnseenMessages()))
				{
					this.messagesLoading(false);
					this.waitForUnseenMessages(false);
					this.setMessagesFromUidList(oUidList, oResult.Offset, oFolder.oMessages, true);
					if (!this.messagesLoading())
					{
						this.setAutocheckmailTimer();
					}
				}
			}
			
			if (bHasFolderChanges && bCurrentFolder && (!bCurrentList || !bCurrentPage) && this.uidList().filters() !== Enums.FolderFilter.Unseen)
			{
				this.requestCurrentMessageList(this.folderList().currentFolderFullName(), this.page(), this.uidList().search(), this.uidList().filters(), false);
			}
			
			if (oFolder.type() === Enums.FolderTypes.Inbox && oUidList.filters() === Enums.FolderFilter.Flagged &&
				oUidList.search() === '' && this.folderList().oStarredFolder)
			{
				this.folderList().oStarredFolder.messageCount(oUidList.resultCount());
				this.folderList().oStarredFolder.hasExtendedInfo(true);
			}
		}
	};

	CMailCache.prototype.increaseStarredCount = function ()
	{
		if (this.folderList().oStarredFolder)
		{
			this.folderList().oStarredFolder.increaseCountIfHasNotInfo();
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onMoveMessagesResponse = function (oResponse, oRequest)
	{
		var
			oResult = oResponse.Result,
			oParameters = oRequest.Parameters,
			oFolder = this.folderList().getFolderByFullName(oParameters.Folder),
			oToFolder = this.folderList().getFolderByFullName(oParameters.ToFolder),
			bToFolderTrash = (oToFolder && (oToFolder.type() === Enums.FolderTypes.Trash)),
			bToFolderSpam = (oToFolder && (oToFolder.type() === Enums.FolderTypes.Spam)),
			oDiffs = null,
			sConfirm = bToFolderTrash ? TextUtils.i18n('MAILWEBCLIENT/CONFIRM_MESSAGES_DELETE_WITHOUT_TRASH') :
				TextUtils.i18n('MAILWEBCLIENT/CONFIRM_MESSAGES_MARK_SPAM_WITHOUT_SPAM'),
			fDeleteMessages = _.bind(function (bResult) {
				if (bResult && oFolder)
				{
					this.deleteMessagesFromFolder(oFolder, oParameters.Uids.split(','));
				}
			}, this),
			oCurrFolder = this.folderList().currentFolder(),
			sCurrFolderFullName = oCurrFolder.fullName(),
			bFillMessages = false
		;
		
		if (oResult === false)
		{
			oDiffs = oFolder.revertDeleted(oParameters.Uids.split(','));
			if (oToFolder)
			{
				oToFolder.addMessagesCountsDiff(-oDiffs.PlusDiff, -oDiffs.UnseenPlusDiff);
				if (oResponse.ErrorCode === Enums.MailErrors.CannotMoveMessageQuota && (bToFolderTrash || bToFolderSpam))
				{
					if (Types.isNonEmptyString(oResponse.ErrorMessage))
					{
						sConfirm += ' (' + oResponse.ErrorMessage + ')';
					}
					Popups.showPopup(ConfirmPopup, [sConfirm, fDeleteMessages]);
				}
				else
				{
					Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_MOVING_MESSAGES'));
				}
			}
			else
			{
				Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_DELETING_MESSAGES'));
			}
			bFillMessages = true;
		}
		else
		{
			oFolder.commitDeleted(oParameters.Uids.split(','));
			_.each(oParameters.Uids.split(','), function (sUid) {
				Routing.replaceHashWithoutMessageUid(sUid);
			});
		}
		
		if (sCurrFolderFullName === oFolder.fullName() || oToFolder && sCurrFolderFullName === oToFolder.fullName())
		{
			oCurrFolder.markHasChanges();
			switch (this.uidList().filters())
			{
				case Enums.FolderFilter.Flagged:
					break;
				case Enums.FolderFilter.Unseen:
					if (this.waitForUnseenMessages())
					{
						this.requestCurrentMessageList(sCurrFolderFullName, this.page(), this.uidList().search(), this.uidList().filters(), bFillMessages);
					}
					break;
				default:
					this.requestCurrentMessageList(sCurrFolderFullName, this.page(), this.uidList().search(), this.uidList().filters(), bFillMessages);
					break;
			}
		}
		else if (sCurrFolderFullName !== oFolder.fullName())
		{
			this.requirePrefetcher();
			Prefetcher.startFolderPrefetch(oFolder);
		}
		else if (oToFolder && sCurrFolderFullName !== oToFolder.fullName())
		{
			this.requirePrefetcher();
			Prefetcher.startFolderPrefetch(oToFolder);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMailCache.prototype.onCopyMessagesResponse = function (oResponse, oRequest)
	{
		var
			oResult = oResponse.Result,
			oParameters = oRequest.Parameters,
			oFolder = this.folderList().getFolderByFullName(oParameters.Folder),
			oToFolder = this.folderList().getFolderByFullName(oParameters.ToFolder),
			oCurrFolder = this.folderList().currentFolder(),
			sCurrFolderFullName = oCurrFolder.fullName()
		;

		if (oResult === false)
		{
			Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_COPYING_MESSAGES'));
		}

		if (sCurrFolderFullName === oFolder.fullName() || oToFolder && sCurrFolderFullName === oToFolder.fullName())
		{
			oCurrFolder.markHasChanges();
			this.requestCurrentMessageList(sCurrFolderFullName, this.page(), this.uidList().search(), '', false);
		}
		else if (sCurrFolderFullName !== oFolder.fullName())
		{
			this.requirePrefetcher();
			Prefetcher.startFolderPrefetch(oFolder);
		}
		else if (oToFolder && sCurrFolderFullName !== oToFolder.fullName())
		{
			this.requirePrefetcher();
			Prefetcher.startFolderPrefetch(oToFolder);
		}
	};

	/**
	 * @param {string} sSearch
	 */
	CMailCache.prototype.searchMessagesInCurrentFolder = function (sSearch)
	{
		var
			sFolder = this.folderList().currentFolderFullName() || 'INBOX',
			sUid = this.currentMessage() ? this.currentMessage().uid() : '',
			sFilters = this.uidList().filters()
		;
		
		Routing.setHash(LinksUtils.getMailbox(sFolder, 1, sUid, sSearch, sFilters));
	};

	/**
	 * @param {string} sSearch
	 */
	CMailCache.prototype.searchMessagesInInbox = function (sSearch)
	{
		Routing.setHash(LinksUtils.getMailbox(this.folderList().inboxFolderFullName() || 'INBOX', 1, '', sSearch, ''));
	};

	CMailCache.prototype.getFolderHash = function (sFolder)
	{
		return Routing.buildHashFromArray(LinksUtils.getMailbox(sFolder, 1, '', '', ''));
	};

	CMailCache.prototype.countMessages = function (oCountedFolder)
	{
		var aSubfoldersMessagesCount = [],
			fCountRecursively = function(oFolder)
			{

				_.each(oFolder.subfolders(), function(oSubFolder, iKey) {
					if(oSubFolder.subscribed())
					{
						aSubfoldersMessagesCount.push(oSubFolder.unseenMessageCount());
						if (oSubFolder.subfolders().length && oSubFolder.subscribed())
						{
							fCountRecursively(oSubFolder);
						}
					}
				}, this);
			}
		;

		if (oCountedFolder.expanded() || oCountedFolder.bNamespace)
		{
			oCountedFolder.subfoldersMessagesCount(0);
		}
		else
		{
			fCountRecursively(oCountedFolder);
			oCountedFolder.subfoldersMessagesCount(
				_.reduce(aSubfoldersMessagesCount, function(memo, num){ return memo + num; }, 0)
			);
		}

	};

	CMailCache.prototype.changeDatesInMessages = function () {
		_.each(this.oFolderListItems, function (oFolderList) {
			_.each(oFolderList.oNamedCollection, function (oFolder) {
				_.each(oFolder.oMessages, function (oMessage) {
					oMessage.updateMomentDate();
				}, this);
			});
		});
	};

	/**
	 * Clears messages cache for specified account.
	 * @param {number} iAccountId
	 */
	CMailCache.prototype.clearMessagesCache = function (iAccountId)
	{
		var oFolderList = this.oFolderListItems[iAccountId];
		
		_.each(oFolderList.collection(), function (oFolder) {
			oFolder.markHasChanges();
			oFolder.removeAllMessageListsFromCacheIfHasChanges();
		}, this);
		
		if (iAccountId === this.currentAccountId())
		{
			this.messages([]);
		}
	};

	var MailCache = new CMailCache();

	Pulse.registerDayOfMonthFunction(_.bind(MailCache.changeDatesInMessages, MailCache));

	UserSettings.timeFormat.subscribe(MailCache.changeDatesInMessages, MailCache);
	UserSettings.dateFormat.subscribe(MailCache.changeDatesInMessages, MailCache);

	module.exports = MailCache;


/***/ }),

/***/ 400:
/*!*******************************************!*\
  !*** ./modules/CoreWebclient/js/Pulse.js ***!
  \*******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		aEveryMinuteFunctions = [],
		aDayOfMonthFunctions = [],
		koNowDayOfMonth = ko.observable(moment().date())
	;

	window.setInterval(function () {
		_.each(aEveryMinuteFunctions, function (fEveryMinute) {
			fEveryMinute();
		});
		
		koNowDayOfMonth(moment().date());
	}, 1000 * 60); // every minute

	koNowDayOfMonth.subscribe(function () {
		_.each(aDayOfMonthFunctions, function (fDayOfMonth) {
			fDayOfMonth();
		});
	}, this);

	module.exports = {
		registerEveryMinuteFunction: function (fEveryMinute)
		{
			if ($.isFunction(fEveryMinute))
			{
				aEveryMinuteFunctions.push(fEveryMinute);
			}
		},
		registerDayOfMonthFunction: function (fDayOfMonth)
		{
			if ($.isFunction(fDayOfMonth))
			{
				aDayOfMonthFunctions.push(fDayOfMonth);
			}
		}
	};

/***/ }),

/***/ 401:
/*!*************************************************!*\
  !*** ./modules/MailWebclient/js/utils/Links.js ***!
  \*************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		LinksUtils = {}
	;

	/**
	 * @param {string} sTemp
	 * 
	 * @return {boolean}
	 */
	function IsPageParam(sTemp)
	{
		return ('p' === sTemp.substr(0, 1) && (/^[1-9][\d]*$/).test(sTemp.substr(1)));
	};

	/**
	 * @param {string} sTemp
	 * 
	 * @return {boolean}
	 */
	function IsMsgParam(sTemp)
	{
		return ('msg' === sTemp.substr(0, 3) && (/^[1-9][\d]*$/).test(sTemp.substr(3)));
	};

	/**
	 * @param {string=} sFolder = 'INBOX'
	 * @param {number=} iPage = 1
	 * @param {string=} sUid = ''
	 * @param {string=} sSearch = ''
	 * @param {string=} sFilters = ''
	 * @param {string=} sCustom = ''
	 * @return {Array}
	 */
	LinksUtils.getMailbox = function (sFolder, iPage, sUid, sSearch, sFilters, sCustom)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			aResult = [Settings.HashModuleName, oCurrAccount ? oCurrAccount.hash() : '']
		;
		
		iPage = Types.pInt(iPage, 1);
		sUid = Types.pString(sUid);
		sSearch = Types.pString(sSearch);
		sFilters = Types.pString(sFilters);

		if (sFolder && '' !== sFolder)
		{
			aResult.push(sFolder);
		}
		
		if (sFilters && '' !== sFilters)
		{
			aResult.push('filter:' + sFilters);
		}
		
		if (1 < iPage)
		{
			aResult.push('p' + iPage);
		}

		if (sUid && '' !== sUid)
		{
			aResult.push('msg' + sUid);
		}

		if (sSearch && '' !== sSearch)
		{
			aResult.push(sSearch);
		}
		
		if (sCustom && '' !== sCustom)
		{
			aResult.push('custom:' + sCustom);
		}
		
		return aResult;
	};

	/**
	 * @param {Array} aParamsToParse
	 * 
	 * @return {Object}
	 */
	LinksUtils.parseMailbox = function (aParamsToParse)
	{
		var
			bMailtoCompose = aParamsToParse.length > 0 && aParamsToParse[0] === 'compose' && aParamsToParse[1] === 'to',
			aParams = bMailtoCompose ? [] : aParamsToParse,
			sAccountHash = '',
			sFolder = 'INBOX',
			iPage = 1,
			sUid = '',
			sSearch = '',
			sFilters = '',
			sCustom = '',
			sTemp = '',
			iIndex = 0
		;
		
		if (Types.isNonEmptyArray(aParams))
		{
			sAccountHash = Types.pString(aParams[iIndex]);
			iIndex++;
		}

		if (Types.isNonEmptyArray(aParams))
		{
			sFolder = Types.pString(aParams[iIndex]);
			iIndex++;

			if (aParams.length > iIndex)
			{
				sTemp = Types.pString(aParams[iIndex]);
				if (sTemp === 'filter:' + Enums.FolderFilter.Flagged)
				{
					sFilters = Enums.FolderFilter.Flagged;
					iIndex++;
				}
				if (sTemp === 'filter:' + Enums.FolderFilter.Unseen)
				{
					sFilters = Enums.FolderFilter.Unseen;
					iIndex++;
				}
			}

			if (aParams.length > iIndex)
			{
				sTemp = Types.pString(aParams[iIndex]);
				if (IsPageParam(sTemp))
				{
					iPage = Types.pInt(sTemp.substr(1));
					if (iPage <= 0)
					{
						iPage = 1;
					}
					iIndex++;
				}
			}
			
			if (aParams.length > iIndex)
			{
				sTemp = Types.pString(aParams[iIndex]);
				if (IsMsgParam(sTemp))
				{
					sUid = sTemp.substr(3);
					iIndex++;
				}
			}

			if (aParams.length > iIndex)
			{
				sTemp = Types.pString(aParams[iIndex]);
				if ('custom:' !== sTemp.substr(0, 7))
				{
					sSearch = sTemp;
					iIndex++;
				}
			}
			
			if (aParams.length > iIndex)
			{
				sTemp = Types.pString(aParams[iIndex]);
				if ('custom:' === sTemp.substr(0, 7))
				{
					sCustom = sTemp.substr(7);
				}
			}
		}
		
		return {
			'MailtoCompose': bMailtoCompose,
			'AccountHash': sAccountHash,
			'Folder': sFolder,
			'Page': iPage,
			'Uid': sUid,
			'Search': sSearch,
			'Filters': sFilters,
			'Custom': sCustom
		};
	};

	/**
	 * @param {string} sFolder
	 * @param {string} sUid
	 * @return {Array}
	 */
	LinksUtils.getViewMessage = function (sFolder, sUid)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-view', sAccountHash, sFolder, 'msg' + sUid];
	};

	/**
	 * @return {Array}
	 */
	LinksUtils.getCompose = function ()
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-compose', sAccountHash];
	};

	/**
	 * @param {string} sType
	 * @param {string} sFolder
	 * @param {string} sUid
	 * 
	 * @return {Array}
	 */
	LinksUtils.getComposeFromMessage = function (sType, sFolder, sUid)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-compose', sAccountHash, sType, sFolder, sUid];
	};

	/**
	 * @param {string} sTo
	 * 
	 * @return {Array}
	 */
	LinksUtils.getComposeWithToField = function (sTo)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-compose', sAccountHash, 'to', sTo];
	};

	/**
	 * @param {string} sType
	 * @param {Object} oObject
	 * @returns {Array}
	 */
	LinksUtils.getComposeWithObject = function (sType, oObject)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-compose', sAccountHash, sType, oObject];
	};

	/**
	 * @param {string} sFolderName
	 * @param {string} sUid
	 * @param {object} oObject
	 * @returns {Array}
	 */
	LinksUtils.getComposeWithEmlObject = function (sFolderName, sUid, oObject)
	{
		var
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
			oCurrAccount = AccountList.getCurrent(),
			sAccountHash = oCurrAccount ? oCurrAccount.hash() : ''
		;
		return [Settings.HashModuleName + '-compose', sAccountHash, Enums.ReplyType.ForwardAsAttach, sFolderName, sUid, oObject];
	};

	/**
	 * @param {array} aParams
	 * @returns {object}
	 */
	LinksUtils.parseCompose = function (aParams)
	{
		var
			sAccountHash = (aParams.length > 0) ? aParams[0] : '',
			sRouteType = (aParams.length > 1) ? aParams[1] : '',
			oObject = ((sRouteType === 'vcard' || sRouteType === Enums.ReplyType.ForwardAsAttach || sRouteType === 'attachments') && aParams.length > 2) ? 
						(sRouteType === Enums.ReplyType.ForwardAsAttach ? aParams[4] : aParams[2]) : null,
			oToAddr = (sRouteType === 'to' && aParams.length > 2) ? LinksUtils.parseToAddr(aParams[2]) : null,
			bMessage = ((sRouteType === Enums.ReplyType.Reply || sRouteType === Enums.ReplyType.ReplyAll 
						|| sRouteType === Enums.ReplyType.Resend || sRouteType === Enums.ReplyType.Forward 
						|| sRouteType === 'drafts' || sRouteType === Enums.ReplyType.ForwardAsAttach) && aParams.length > 2),
			sFolderName = bMessage ? aParams[2] : '',
			sUid = bMessage ? aParams[3] : ''
		;
		
		return {
			'AccountHash': sAccountHash,
			'RouteType': sRouteType,
			'ToAddr': oToAddr,
			'Object': oObject,
			'MessageFolderName': sFolderName,
			'MessageUid': sUid
		};
	};

	/**
	 * @param {?} mToAddr
	 * @returns {Object}
	 */
	LinksUtils.parseToAddr = function (mToAddr)
	{
		var
			sToAddr = decodeURI(Types.pString(mToAddr)),
			bHasMailTo = sToAddr.indexOf('mailto:') !== -1,
			aMailto = [],
			aMessageParts = [],
			sSubject = '',
			sCcAddr = '',
			sBccAddr = '',
			sBody = ''
		;
		
		if (bHasMailTo)
		{
			aMailto = sToAddr.replace(/^mailto:/, '').split('?');
			sToAddr = aMailto[0];
			if (aMailto.length === 2)
			{
				aMessageParts = aMailto[1].split('&');
				_.each(aMessageParts, function (sPart) {
					var aParts = sPart.split('=');
					if (aParts.length === 2)
					{
						switch (aParts[0].toLowerCase())
						{
							case 'subject': sSubject = aParts[1]; break;
							case 'cc': sCcAddr = aParts[1]; break;
							case 'bcc': sBccAddr = aParts[1]; break;
							case 'body': sBody = aParts[1]; break;
						}
					}
				});
			}
		}
		
		return {
			'to': sToAddr,
			'hasMailto': bHasMailTo,
			'subject': sSubject,
			'cc': sCcAddr,
			'bcc': sBccAddr,
			'body': sBody
		};
	};

	module.exports = LinksUtils;


/***/ }),

/***/ 402:
/*!*************************************************!*\
  !*** ./modules/MailWebclient/js/AccountList.js ***!
  \*************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		MainTab = App.isNewTab() && window.opener ? window.opener.MainTabMailMethods : null,
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		CoreAjax = __webpack_require__(/*! modules/CoreWebclient/js/Ajax.js */ 186),
		
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CAccountModel = __webpack_require__(/*! modules/MailWebclient/js/models/CAccountModel.js */ 404),
		CFetcherModel = __webpack_require__(/*! modules/MailWebclient/js/models/CFetcherModel.js */ 426),
		CIdentityModel = __webpack_require__(/*! modules/MailWebclient/js/models/CIdentityModel.js */ 427)
	;

	/**
	 * @constructor
	 */
	function CAccountListModel()
	{
		this.collection = ko.observableArray([]);
	}

	/**
	 * @param {string} sHash
	 */
	CAccountListModel.prototype.getAccountByHash = function (sHash)
	{
		return _.find(this.collection(), function (oAcct) {
			return oAcct.hash() === sHash;
		}, this);
	};

	/**
	 * @param {string} sNewCurrentHash
	 */
	CAccountListModel.prototype.changeCurrentAccountByHash = function (sNewCurrentHash)
	{
		var oAccount = this.getAccountByHash(sNewCurrentHash);
		
		if (oAccount && oAccount.id() !== this.currentId())
		{
			this.changeCurrentAccount(oAccount.id(), false);
		}
	};

	/**
	 * Changes current account. Sets hash to show new account data.
	 * 
	 * @param {number} iNewCurrentId
	 * @param {boolean} bPassToMail
	 */
	CAccountListModel.prototype.changeCurrentAccount = function (iNewCurrentId, bPassToMail)
	{
		var
			oCurrentAccount = this.getCurrent(),
			oNewCurrentAccount = this.getAccount(iNewCurrentId)
		;

		if (oNewCurrentAccount && this.currentId() !== iNewCurrentId)
		{
			if (oCurrentAccount)
			{
				oCurrentAccount.isCurrent(false);
			}
			this.currentId(iNewCurrentId);
			oNewCurrentAccount.isCurrent(true);
		}
		else if (!oCurrentAccount)
		{
			this.currentId(0);
		}
		
		if (bPassToMail)
		{
			Routing.setHash(LinksUtils.getMailbox());
		}
	};

	/**
	 * @param {string} sNewEditedHash
	 */
	CAccountListModel.prototype.changeEditedAccountByHash = function (sNewEditedHash)
	{
		var oAccount = this.getAccountByHash(sNewEditedHash);
		
		if (oAccount && oAccount.id() !== this.editedId())
		{
			this.changeEditedAccount(oAccount.id());
		}
	};

	/**
	 * Changes editable account.
	 * 
	 * @param {number} iNewEditedId
	 */
	CAccountListModel.prototype.changeEditedAccount = function (iNewEditedId)
	{
		var
			oEditedAccount = this.getEdited(),
			oNewEditedAccount = this.getAccount(iNewEditedId)
		;
		
		if (oNewEditedAccount && this.editedId() !== iNewEditedId)
		{
			if (oEditedAccount)
			{
				oEditedAccount.isEdited(false);
			}
			this.editedId(iNewEditedId);
			oNewEditedAccount.isEdited(true);
		}
		else if (!oEditedAccount)
		{
			this.editedId(0);
		}
	};

	CAccountListModel.prototype.getDefaultFriendlyName = function()
	{
		var
			oCurrAccount = this.getCurrent(),
			oDefIdentity = _.find(oCurrAccount && oCurrAccount.identities() || [], function (oIdnt) {
				return oIdnt.isDefault();
			}) || oCurrAccount
		;
		
		return oDefIdentity ? oDefIdentity.friendlyName() || oDefIdentity.email() : '';
	};

	/**
	 * @param {type} sHash
	 * @returns {Object}
	 */
	CAccountListModel.prototype.getIdentityByHash = function(sHash)
	{
		var oIdentity = null;
		
		_.each(this.collection(), function (oAccount) {
			if (!oIdentity)
			{
				oIdentity = _.find(oAccount.identities() || [], function (oIdnt) {
					return oIdnt.hash() === sHash;
				});
			}
		}, this);
		
		return oIdentity;
	};

	/**
	 * @param {type} sHash
	 * @returns {Object}
	 */
	CAccountListModel.prototype.getFetcherByHash = function(sHash)
	{
		var oFoundFetcher = null;
		
		_.each(this.collection(), function (oAccount) {
			if (!oFoundFetcher)
			{
				oFoundFetcher = _.find(oAccount.fetchers(), function (oFetcher) {
					return oFetcher.hash() === sHash;
				});
			}
		}, this);
		
		return oFoundFetcher;
	};

	/**
	 * Fills the collection of accounts.
	 * @param {Array} aAccounts
	 */
	CAccountListModel.prototype.parse = function (aAccounts)
	{
		if (_.isArray(aAccounts))
		{
			this.collection(_.map(aAccounts, function (oRawAccount)
			{
				return new CAccountModel(oRawAccount);
			}));
			this.initObservables(this.collection().length > 0 ? this.collection()[0].id() : 0);
		}
	};

	/**
	 * @param {int} iCurrentId
	 */
	CAccountListModel.prototype.initObservables = function (iCurrentId)
	{
		var oCurrAccount = this.getAccount(iCurrentId);
		if (oCurrAccount)
		{
			oCurrAccount.isCurrent(true);
			oCurrAccount.isEdited(true);
		}

		this.currentId = ko.observable(iCurrentId);
		this.editedId = ko.observable(iCurrentId);
	};

	/**
	 * @return {boolean}
	 */
	CAccountListModel.prototype.hasAccount = function ()
	{
		return this.collection().length > 0;
	};

	/**
	 * @param {number} iId
	 * 
	 * @return {Object|undefined}
	 */
	CAccountListModel.prototype.getAccount = function (iId)
	{
		var oAccount = _.find(this.collection(), function (oAcct) {
			return oAcct.id() === iId;
		}, this);
		
		/**	@type {Object|undefined} */
		return oAccount;
	};

	/**
	 * @return {Object|undefined}
	 */
	CAccountListModel.prototype.getCurrent = function ()
	{
		return this.getAccount(this.currentId());
	};

	/**
	 * @return {Object|undefined}
	 */
	CAccountListModel.prototype.getEdited = function ()
	{
		return this.getAccount(this.editedId());
	};

	/**
	 * @param {number=} iAccountId
	 * @return {string}
	 */
	CAccountListModel.prototype.getEmail = function (iAccountId)
	{
		iAccountId = iAccountId || this.currentId();
		
		var
			sEmail = '',
			oAccount = this.getAccount(iAccountId)
		;
		
		if (oAccount)
		{
			sEmail = oAccount.email();
		}
		
		return sEmail;
	};

	/**
	 * @param {Object} oAccount
	 */
	CAccountListModel.prototype.addAccount = function (oAccount)
	{
		this.collection.push(oAccount);
	};

	/**
	 * @param {number} iId
	 */
	CAccountListModel.prototype.deleteAccount = function (iId)
	{
		this.collection.remove(function (oAcct) { return oAcct.id() === iId; });
		
		var iFirstAccId = this.collection().length > 0 ? this.collection()[0].id() : 0;
		this.changeCurrentAccount(iFirstAccId, false);
		this.changeEditedAccount(iFirstAccId);
	};

	/**
	 * @param {number} iId
	 * 
	 * @return {boolean}
	 */
	CAccountListModel.prototype.hasAccountWithId = function (iId)
	{
		var oAccount = _.find(this.collection(), function (oAcct) {
			return oAcct.id() === iId;
		}, this);

		return !!oAccount;
	};

	CAccountListModel.prototype.populateFetchersIdentities = function ()
	{
		this.populateFetchers();
		this.populateIdentities();
	};

	CAccountListModel.prototype.populateFetchers = function ()
	{
		if (Settings.AllowFetchers)
		{
			CoreAjax.send(Settings.FetchersServerModuleName, 'GetFetchers', { 'AccountID': this.editedId() }, this.onGetFetchersResponse, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CAccountListModel.prototype.onGetFetchersResponse = function (oResponse, oRequest)
	{
		var oFetchers = {};
		
		if (Types.isNonEmptyArray(oResponse.Result))
		{
			_.each(oResponse.Result, function (oData) {
				var oFetcher = new CFetcherModel();
				oFetcher.parse(oData);
				if (!oFetchers[oFetcher.accountId()])
				{
					oFetchers[oFetcher.accountId()] = [];
				}
				oFetchers[oFetcher.accountId()].push(oFetcher);
			});
		}
		
		_.each(this.collection(), function (oAccount) {
			var aFetchers = Types.isNonEmptyArray(oFetchers[oAccount.id()]) ? oFetchers[oAccount.id()] : [];
			oAccount.fetchers(aFetchers);
		}, this);
	};

	/**
	 * @param {function} fAfterPopulateIdentities
	 */
	CAccountListModel.prototype.populateIdentities = function (fAfterPopulateIdentities)
	{
		if (Settings.AllowIdentities && this.collection().length >= 1)
		{
			Ajax.send('GetIdentities', null, function (oResponse, oRequest) {
				this.onGetIdentitiesResponse(oResponse, oRequest);
				if (_.isFunction(fAfterPopulateIdentities))
				{
					fAfterPopulateIdentities();
				}
			}, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CAccountListModel.prototype.onGetIdentitiesResponse = function (oResponse, oRequest)
	{
		var oIdentities = {};
		
		if (Types.isNonEmptyArray(oResponse.Result))
		{
			_.each(oResponse.Result, function (oIdentityData) {
				var
					oIdentity = new CIdentityModel(),
					iAccountId = -1
				;

				oIdentity.parse(oIdentityData);
				iAccountId = oIdentity.accountId();
				if (!oIdentities[iAccountId])
				{
					oIdentities[iAccountId] = [];
				}
				oIdentities[iAccountId].push(oIdentity);
			});
		}

		_.each(this.collection(), function (oAccount) {
			var
				aIdentities = oIdentities[oAccount.id()],
				oIdentity = new CIdentityModel()
			;

			if (!Types.isNonEmptyArray(aIdentities))
			{
				aIdentities = [];
			}

			oIdentity.parse({
				'@Object': 'Object/Aurora\\Modules\\Mail\\Classes\\Identity',
				AccountPart: true,
				Default: !_.find(aIdentities, function(oIdentity){ return oIdentity.isDefault(); }),
				Email: oAccount.email(),
				FriendlyName: oAccount.friendlyName(),
				IdAccount: oAccount.id(),
				EntityId: oAccount.id() * 100000,
				Signature: oAccount.signature(),
				UseSignature: oAccount.useSignature()
			});
			aIdentities.unshift(oIdentity);

			oAccount.identities(aIdentities);
		});
	};

	/**
	 * @param {Object} oSrcAccounts
	 */
	CAccountListModel.prototype.populateIdentitiesFromSourceAccount = function (oSrcAccounts)
	{
		if (oSrcAccounts)
		{
			_.each(this.collection(), function (oAccount) {
				var oSrcAccount = oSrcAccounts.getAccount(oAccount.id());
				if (oSrcAccount)
				{
					oAccount.fetchers(oSrcAccount.fetchers());
					oAccount.identities(oSrcAccount.identities());
					oAccount.signature(oSrcAccount.signature());
					oAccount.useSignature(oSrcAccount.useSignature());
				}
			});
		}
	};

	CAccountListModel.prototype.getAccountsEmails = function ()
	{
		return _.uniq(_.map(this.collection(), function (oAccount) {
			return oAccount.email();
		}));
	};

	CAccountListModel.prototype.getAllFullEmails = function ()
	{
		var aFullEmails = [];
		
		_.each(this.collection(), function (oAccount) {
			if (oAccount)
			{
				if (Types.isNonEmptyArray(oAccount.identities()))
				{
					_.each(oAccount.identities(), function (oIdentity) {
						aFullEmails.push(oIdentity.fullEmail());
					});
				}
				else
				{
					aFullEmails.push(oAccount.fullEmail());
				}
				
				_.each(oAccount.fetchers(), function (oFetcher) {
					if (oFetcher.isEnabled() && oFetcher.isOutgoingEnabled() && oFetcher.fullEmail() !== '')
					{
						aFullEmails.push(oFetcher.fullEmail());
					}
				});
			}
		});
		
		return aFullEmails;
	};

	CAccountListModel.prototype.getCurrentFetchersAndFiltersFolderNames = function ()
	{
		var
			oAccount = this.getCurrent(),
			aFolders = []
		;
		
		if (oAccount)
		{
			if (oAccount.filters())
			{
				_.each(oAccount.filters().collection(), function (oFilter) {
					aFolders.push(oFilter.folder());
				}, this);
			}

			_.each(oAccount.fetchers(), function (oFetcher) {
				aFolders.push(oFetcher.folder());
			}, this);
		}
		
		return aFolders;
	};

	/**
	 * @param {Array} aEmails
	 * @returns {string}
	 */
	CAccountListModel.prototype.getAttendee = function (aEmails)
	{
		var
			aAccountsEmails = [],
			sAttendee = ''
		;
		
		_.each(this.collection(), function (oAccount) {
			if (oAccount.isCurrent())
			{
				aAccountsEmails = _.union([oAccount.email()], oAccount.getFetchersIdentitiesEmails(), aAccountsEmails);
			}
			else
			{
				aAccountsEmails = _.union(aAccountsEmails, [oAccount.email()], oAccount.getFetchersIdentitiesEmails());
			}
		});
		
		aAccountsEmails = _.uniq(aAccountsEmails);
		
		_.each(aAccountsEmails, _.bind(function (sAccountEmail) {
			if (sAttendee === '')
			{
				var sFoundEmail = _.find(aEmails, function (sEmail) {
					return (sEmail === sAccountEmail);
				});
				if (sFoundEmail === sAccountEmail)
				{
					sAttendee = sAccountEmail;
				}
			}
		}, this));
		
		return sAttendee;
	};

	var AccountList = new CAccountListModel();

	if (window.auroraAppData.Mail && _.isArray(window.auroraAppData.Mail.Accounts))
	{
		AccountList.parse(window.auroraAppData.Mail.Accounts);
	}
	else
	{
		AccountList.parse([]);
	}

	if (MainTab)
	{
		AccountList.populateIdentitiesFromSourceAccount(MainTab.getAccountList());
	}

	module.exports = AccountList;


/***/ }),

/***/ 403:
/*!******************************************!*\
  !*** ./modules/MailWebclient/js/Ajax.js ***!
  \******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		Ajax = __webpack_require__(/*! modules/CoreWebclient/js/Ajax.js */ 186),
		
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
	;

	Ajax.registerAbortRequestHandler(Settings.ServerModuleName, function (oRequest, oOpenedRequest) {
		var
			oParameters = oRequest.Parameters,
			oOpenedParameters = oOpenedRequest.Parameters
		;
		
		switch (oRequest.Method)
		{
			case 'MoveMessages':
			case 'DeleteMessages':
				return	oOpenedRequest.Method === 'GetMessage' || 
						oOpenedRequest.Method === 'GetMessages' && oOpenedParameters.Folder === oParameters.Folder;
			case 'GetMessages':
			case 'SetMessagesSeen':
			case 'SetMessageFlagged':
				return oOpenedRequest.Method === 'GetMessages' && oOpenedParameters.Folder === oParameters.Folder;
			case 'SetAllMessagesSeen':
				return (oOpenedRequest.Method === 'GetMessages' || oOpenedRequest.Method === 'GetMessages') &&
						oOpenedParameters.Folder === oParameters.Folder;
			case 'ClearFolder':
				// GetRelevantFoldersInformation-request aborted during folder cleaning, not to get the wrong information.
				return	oOpenedRequest.Method === 'GetRelevantFoldersInformation' || 
						oOpenedRequest.Method === 'GetMessages' && oOpenedParameters.Folder === oParameters.Folder;
			case 'GetRelevantFoldersInformation':
				return oOpenedRequest.Method === 'GetRelevantFoldersInformation' && oParameters.AccountID === oOpenedParameters.AccountID;
			case 'GetMessagesFlags':
				return oOpenedRequest.Method === 'GetMessagesFlags';
		}
		
		return false;
	});

	module.exports = {
		getOpenedRequest: function (sMethod) {
			Ajax.getOpenedRequest('Mail', sMethod);
		},
		hasOpenedRequests: function (sMethod) {
			Ajax.hasOpenedRequests('Mail', sMethod);
		},
		registerOnAllRequestsClosedHandler: Ajax.registerOnAllRequestsClosedHandler,
		send: function (sMethod, oParameters, fResponseHandler, oContext) {
			var
				MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
				iTimeout = (sMethod === 'GetMessagesBodies') ? 100000 : undefined
			;
			if (oParameters && !oParameters.AccountID)
			{
				oParameters.AccountID = MailCache.currentAccountId();
			}
			Ajax.send(Settings.ServerModuleName, sMethod, oParameters, fResponseHandler, oContext, iTimeout);
		}
	};


/***/ }),

/***/ 404:
/*!**********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CAccountModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		Ajax = null,
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = null,
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		ConfirmPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/ConfirmPopup.js */ 196),
		
		CFiltersModel = __webpack_require__(/*! modules/MailWebclient/js/models/CFiltersModel.js */ 405),
		CServerModel = __webpack_require__(/*! modules/MailWebclient/js/models/CServerModel.js */ 407),
		
		AccountList = null,
		Cache = null,
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
	;

	/**
	 * @constructor
	 * @param {object} oData
	 */
	function CAccountModel(oData)
	{
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179);
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403);
		
		this.id = ko.observable(Types.pInt(oData.AccountID));
		this.email = ko.observable(Types.pString(oData.Email));
		this.friendlyName = ko.observable(Types.pString(oData.FriendlyName));
		this.incomingLogin = ko.observable(Types.pString(oData.IncomingLogin));
		this.signature = ko.observable(Types.pString(oData.Signature));
		this.useSignature = ko.observable(!!oData.UseSignature);
		this.serverId = ko.observable(Types.pInt(oData.ServerId));
		this.oServer = new CServerModel(oData.Server);
		this.useToAuthorize = ko.observable(!!oData.UseToAuthorize);
		this.canBeUsedToAuthorize = ko.observable(!!oData.CanBeUsedToAuthorize);
		this.useThreading = ko.observable(!!oData.UseThreading);
		this.useThreading.subscribe(function () {
			this.requireCache();
			Cache.clearMessagesCache(this.id());
		}, this);
		this.bSaveRepliesToCurrFolder = !!oData.SaveRepliesToCurrFolder;
		
		this.isCurrent = ko.observable(false);
		this.isEdited = ko.observable(false);
		
		this.hash = ko.computed(function () {
			return Utils.getHash(this.id() + this.email());
		}, this);
		this.passwordSpecified = ko.observable(true);
		
		this.extensions = ko.observableArray([]);
		this.fetchers = ko.observableArray([]);
		this.identities = ko.observable(null);
		this.autoresponder = ko.observable(null);
		this.forward = ko.observable(null);
		this.filters = ko.observable(null);

		this.quota = ko.observable(0);
		this.usedSpace = ko.observable(0);
		this.quotaRecieved = ko.observable(false);

		this.fullEmail = ko.computed(function () {
			return AddressUtils.getFullEmail(this.friendlyName(), this.email());
		}, this);
		
		this.extensionsRequested = ko.observable(true);
		
		this.bDefault = Settings.AllowDefaultAccountForUser && this.email() === App.getUserPublicId();
	}

	CAccountModel.prototype.threadingIsAvailable = function ()
	{
		return this.oServer.bEnableThreading && this.useThreading();
	};

	CAccountModel.prototype.updateFromServer = function (oData)
	{
		this.email(Types.pString(oData.Email));
		this.friendlyName(Types.pString(oData.FriendlyName));
		this.incomingLogin(Types.pString(oData.IncomingLogin));
		this.serverId(Types.pInt(oData.ServerId));
		this.oServer = new CServerModel(oData.Server);
		this.useToAuthorize(!!oData.UseToAuthorize);
		this.useThreading(!!oData.UseThreading);
		this.bSaveRepliesToCurrFolder = !!oData.SaveRepliesToCurrFolder;
	};

	CAccountModel.prototype.requireAccounts = function ()
	{
		if (AccountList === null)
		{
			AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402);
		}
	};

	CAccountModel.prototype.requireCache = function ()
	{
		if (Cache === null)
		{
			Cache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399);
		}
	};

	/**
	 * @param {Object} oResult
	 * @param {Object} oRequest
	 */
	CAccountModel.prototype.onGetQuotaResponse = function (oResult, oRequest)
	{
		if (_.isArray(oResult.Result) && 1 < oResult.Result.length)
		{
			this.quota(Types.pInt(oResult.Result[1]));
			this.usedSpace(Types.pInt(oResult.Result[0]));
			
			this.requireCache();
			Cache.quotaChangeTrigger(!Cache.quotaChangeTrigger());
		}
		
		this.quotaRecieved(true);
	};

	CAccountModel.prototype.updateQuotaParams = function ()
	{
		if (UserSettings.ShowQuotaBar)
		{
			Ajax.send('GetQuota', { 'AccountID': this.id() }, this.onGetQuotaResponse, this);
		}
	};

	/**
	 * @param {Object} oResult
	 * @param {Object} oRequest
	 */
	CAccountModel.prototype.onGetExtensionsResponse = function (oResult, oRequest)
	{
		var
			bResult = !!oResult.Result,
			aExtensions = bResult ? oResult.Result.Extensions : []
		;
		
		if (bResult)
		{
			this.setExtensions(aExtensions);
			this.extensionsRequested(true);
		}
	};

	/**
	 * @param {Array} aExtensions
	 */
	CAccountModel.prototype.setExtensions = function(aExtensions)
	{
		if (_.isArray(aExtensions))
		{
			this.extensions(aExtensions);
		}
	};

	/**
	 * @param {string} sExtension
	 * 
	 * return {boolean}
	 */
	CAccountModel.prototype.extensionExists = function(sExtension)
	{
		return (_.indexOf(this.extensions(), sExtension) === -1) ? false : true;
	};

	/**
	 * @param {string} sFriendlyName
	 */
	CAccountModel.prototype.updateFriendlyName = function (sFriendlyName)
	{
		this.friendlyName(sFriendlyName);
	};

	CAccountModel.prototype.changeAccount = function()
	{
		this.requireAccounts();
		AccountList.changeCurrentAccount(this.id(), true);
	};

	CAccountModel.prototype.getDefaultIdentity = function()
	{
		return _.find(this.identities() || [], function (oIdentity) {
			return oIdentity.isDefault();
		});
	};

	/**
	 * @returns {Array}
	 */
	CAccountModel.prototype.getFetchersIdentitiesEmails = function()
	{
		var
			aIdentities = this.identities() || [],
			aEmails = []
		;
		
		_.each(this.fetchers(), function (oFetcher) {
			aEmails.push(oFetcher.email());
		});
		
		_.each(aIdentities, function (oIdentity) {
			aEmails.push(oIdentity.email());
		});
		
		return aEmails;
	};

	/**
	 * Shows popup to confirm removing if it can be removed.
	 */
	CAccountModel.prototype.remove = function()
	{
		var fCallBack = _.bind(this.confirmedRemove, this);
		
		if (!this.bDefault)
		{
			Popups.showPopup(ConfirmPopup, [TextUtils.i18n('MAILWEBCLIENT/CONFIRM_REMOVE_ACCOUNT'), fCallBack, this.email()]);
		}
	};

	/**
	 * Sends a request to the server for deletion account if received confirmation from the user.
	 * 
	 * @param {boolean} bOkAnswer
	 */
	CAccountModel.prototype.confirmedRemove = function(bOkAnswer)
	{
		if (bOkAnswer)
		{
			Ajax.send('DeleteAccount', { 'AccountID': this.id() }, this.onAccountDeleteResponse, this);
		}
	};

	/**
	 * Receives response from the server and removes account from js-application if removal operation on the server was successful.
	 * 
	 * @param {Object} oResponse Response obtained from the server.
	 * @param {Object} oRequest Parameters has been transferred to the server.
	 */
	CAccountModel.prototype.onAccountDeleteResponse = function (oResponse, oRequest)
	{
		if (!oResponse.Result)
		{
			Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_REMOVE_ACCOUNT'));
		}
		else
		{
			var ComposeUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Compose.js */ 408);
			if (_.isFunction(ComposeUtils.closeComposePopup))
			{
				ComposeUtils.closeComposePopup();
			}
			
			this.requireAccounts();
			AccountList.deleteAccount(this.id());
		}
	};

	CAccountModel.prototype.requestFilters = function ()
	{
		Ajax.send('GetFilters', { 'AccountID': this.id() }, this.onGetFiltersResponse, this);
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CAccountModel.prototype.onGetFiltersResponse = function (oResponse, oRequest)
	{
		var oFilters = new CFiltersModel();
		if (oResponse.Result)
		{
			oFilters.parse(this.id(), oResponse.Result);
		}
		this.filters(oFilters);
	};

	module.exports = CAccountModel;


/***/ }),

/***/ 405:
/*!**********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CFiltersModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		CFilterModel = __webpack_require__(/*! modules/MailWebclient/js/models/CFilterModel.js */ 406)
	;

	/**
	 * @constructor
	 */
	function CFiltersModel()
	{
		this.iAccountId = 0;
		this.collection = ko.observableArray([]);
	}

	/**
	 * @param {number} iAccountId
	 * @param {Object} oData
	 */
	CFiltersModel.prototype.parse = function (iAccountId, oData)
	{
		var 
			iIndex = 0,
			iLen = oData.length,
			oSieveFilter = null
		;

		this.iAccountId = iAccountId;
		
		if (_.isArray(oData))
		{
			for (iLen = oData.length; iIndex < iLen; iIndex++)
			{	
				oSieveFilter =  new CFilterModel(iAccountId);
				oSieveFilter.parse(oData[iIndex]);
				this.collection.push(oSieveFilter);
			}
		}
	};

	module.exports = CFiltersModel;

/***/ }),

/***/ 406:
/*!*********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CFilterModel.js ***!
  \*********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44)
	;

	/**
	 * @param {number} iAccountID
	 * @constructor
	 */
	function CFilterModel(iAccountID)
	{
		this.iAccountId = iAccountID;
		
		this.enable = ko.observable(true).extend({'reversible': true});
		
		this.field = ko.observable('').extend({'reversible': true}); //map to Field
		this.condition = ko.observable('').extend({'reversible': true});
		this.filter = ko.observable('').extend({'reversible': true});
		this.action = ko.observable('').extend({'reversible': true});
		this.folder = ko.observable('').extend({'reversible': true});
	}

	/**
	 * @param {Object} oData
	 */
	CFilterModel.prototype.parse = function (oData)
	{
		this.enable(!!oData.Enable);

		this.field(Types.pInt(oData.Field));
		this.condition(Types.pInt(oData.Condition));
		this.filter(Types.pString(oData.Filter));
		this.action(Types.pInt(oData.Action));
		this.folder(Types.pString(oData.FolderFullName));
		this.commit();
	};

	CFilterModel.prototype.revert = function ()
	{
		this.enable.revert();
		this.field.revert();
		this.condition.revert();
		this.filter.revert();
		this.action.revert();
		this.folder.revert();
	};

	CFilterModel.prototype.commit = function ()
	{
		this.enable.commit();
		this.field.commit();
		this.condition.commit();
		this.filter.commit();
		this.action.commit();
		this.folder.commit();
	};

	CFilterModel.prototype.toString = function ()
	{
		var aState = [
			this.enable(),
			this.field(),
			this.condition(),
			this.filter(),
			this.action(),
			this.folder()
		];
		
		return aState.join(':');	
	};

	module.exports = CFilterModel;


/***/ }),

/***/ 407:
/*!*********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CServerModel.js ***!
  \*********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44)
	;

	function CServerModel(oServer)
	{
		this.iId = oServer ? Types.pInt(oServer.EntityId) || Types.pInt(oServer.ServerId) : 0;
		this.sName = oServer ? Types.pString(oServer.Name) : '';
		this.sIncomingServer = oServer ? Types.pString(oServer.IncomingServer) : '';
		this.iIncomingPort = oServer ? Types.pInt(oServer.IncomingPort) : 143;
		this.bIncomingUseSsl = oServer ? !!oServer.IncomingUseSsl : false;
		this.sOutgoingServer = oServer ? Types.pString(oServer.OutgoingServer) : '';
		this.iOutgoingPort = oServer ? Types.pInt(oServer.OutgoingPort) : 25;
		this.bOutgoingUseSsl = oServer ? !!oServer.OutgoingUseSsl : false;
		this.sDomains = oServer ? Types.pString(oServer.Domains) : '';
		this.sSmtpAuthType = oServer ? Types.pString(oServer.SmtpAuthType) : window.Enums.SmtpAuthType.UseUserCredentials;
		this.sSmtpLogin = oServer ? Types.pString(oServer.SmtpLogin) : '';
		this.sSmtpPassword = oServer ? Types.pString(oServer.SmtpPassword) : '';
		this.bEnableSieve = oServer ? !!oServer.EnableSieve : false;
		this.iSievePort = oServer && oServer.SievePort ? Types.pInt(oServer.SievePort) : 4190;
		this.bEnableThreading = oServer ? !!oServer.EnableThreading : false;
		this.bUseFullEmailAddressAsLogin = oServer ? !!oServer.UseFullEmailAddressAsLogin : true;
	}

	module.exports = CServerModel;


/***/ }),

/***/ 408:
/*!***************************************************!*\
  !*** ./modules/MailWebclient/js/utils/Compose.js ***!
  \***************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		ComposeUtils = (App.isMobile() || App.isNewTab()) ? __webpack_require__(/*! modules/MailWebclient/js/utils/ScreenCompose.js */ 409) : __webpack_require__(/*! modules/MailWebclient/js/utils/PopupCompose.js */ 410)
	;

	module.exports = ComposeUtils;

/***/ }),

/***/ 409:
/*!*********************************************************!*\
  !*** ./modules/MailWebclient/js/utils/ScreenCompose.js ***!
  \*********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		
		ScreenComposeUtils = {}
	;

	ScreenComposeUtils.composeMessage = function ()
	{
		Routing.setHash(LinksUtils.getCompose());
	};

	/**
	 * @param {string} sFolder
	 * @param {string} sUid
	 */
	ScreenComposeUtils.composeMessageFromDrafts = function (sFolder, sUid)
	{
		var aParams = LinksUtils.getComposeFromMessage('drafts', sFolder, sUid);
		Routing.setHash(aParams);
	};

	/**
	 * @param {string} sReplyType
	 * @param {string} sFolder
	 * @param {string} sUid
	 */
	ScreenComposeUtils.composeMessageAsReplyOrForward = function (sReplyType, sFolder, sUid)
	{
		var aParams = LinksUtils.getComposeFromMessage(sReplyType, sFolder, sUid);
		Routing.setHash(aParams);
	};

	/**
	 * @param {string} sToAddresses
	 */
	ScreenComposeUtils.composeMessageToAddresses = function (sToAddresses)
	{
		var aParams = LinksUtils.getComposeWithToField(sToAddresses);
		Routing.setHash(aParams);
	};

	/**
	 * @param {Object} oVcard
	 */
	ScreenComposeUtils.composeMessageWithVcard = function (oVcard)
	{
		var aParams = ['vcard', oVcard];
		Routing.goDirectly(LinksUtils.getCompose(), aParams);
	};

	/**
	 * @param {Object} oMessage
	 */
	ScreenComposeUtils.composeMessageWithEml = function (oMessage)
	{
		var aParams = LinksUtils.getComposeWithEmlObject(oMessage.folder(), oMessage.uid(), oMessage);
		aParams.shift();
		aParams.shift();
		Routing.goDirectly(LinksUtils.getCompose(), aParams);
	};

	/**
	 * @param {Array} aFileItems
	 */
	ScreenComposeUtils.composeMessageWithAttachments = function (aFileItems)
	{
		var aParams = LinksUtils.getComposeWithObject('attachments', aFileItems);
		Routing.goDirectly(LinksUtils.getCompose(), aParams);
	};

	module.exports = ScreenComposeUtils;

/***/ }),

/***/ 410:
/*!********************************************************!*\
  !*** ./modules/MailWebclient/js/utils/PopupCompose.js ***!
  \********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		
		PopupComposeUtils = {}
	;

	function GetComposePopup()
	{
		return __webpack_require__(/*! modules/MailWebclient/js/popups/ComposePopup.js */ 411);
	}

	PopupComposeUtils.composeMessage = function ()
	{
		Popups.showPopup(GetComposePopup());
	};

	/**
	 * @param {string} sFolder
	 * @param {string} sUid
	 */
	PopupComposeUtils.composeMessageFromDrafts = function (sFolder, sUid)
	{
		var aParams = LinksUtils.getComposeFromMessage('drafts', sFolder, sUid);
		aParams.shift();
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	/**
	 * @param {string} sReplyType
	 * @param {string} sFolder
	 * @param {string} sUid
	 */
	PopupComposeUtils.composeMessageAsReplyOrForward = function (sReplyType, sFolder, sUid)
	{
		var aParams = LinksUtils.getComposeFromMessage(sReplyType, sFolder, sUid);
		aParams.shift();
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	/**
	 * @param {string} sToAddresses
	 */
	PopupComposeUtils.composeMessageToAddresses = function (sToAddresses)
	{
		var aParams = LinksUtils.getComposeWithToField(sToAddresses);
		aParams.shift();
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	/**
	 * @param {Object} oVcard
	 */
	PopupComposeUtils.composeMessageWithVcard = function (oVcard)
	{
		var aParams = ['vcard', oVcard];
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	/**
	 * @param {Object} oMessage
	 */
	PopupComposeUtils.composeMessageWithEml = function (oMessage)
	{
		var aParams = LinksUtils.getComposeWithEmlObject(oMessage.folder(), oMessage.uid(), oMessage);
		aParams.shift();
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	/**
	 * @param {Array} aFileItems
	 */
	PopupComposeUtils.composeMessageWithAttachments = function (aFileItems)
	{
		var aParams = LinksUtils.getComposeWithObject('attachments', aFileItems);
		aParams.shift();
		Popups.showPopup(GetComposePopup(), [aParams]);
	};

	PopupComposeUtils.closeComposePopup = function ()
	{
		Popups.showPopup(GetComposePopup(), [['close']]);
	};

	module.exports = PopupComposeUtils;

/***/ }),

/***/ 411:
/*!*********************************************************!*\
  !*** ./modules/MailWebclient/js/popups/ComposePopup.js ***!
  \*********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		CAbstractPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/CAbstractPopup.js */ 189),
		ConfirmAnotherMessageComposedPopup = __webpack_require__(/*! modules/MailWebclient/js/popups/ConfirmAnotherMessageComposedPopup.js */ 412),
		
		CComposeView = __webpack_require__(/*! modules/MailWebclient/js/views/CComposeView.js */ 413)
	;

	/**
	 * @constructor
	 * @extends CComposePopup
	 */
	function CComposePopup()
	{
		CAbstractPopup.call(this);
		
		CComposeView.call(this);
		
		this.minimized = ko.observable(false);
		
		this.fPreventBackspace = function (ev) {
			var
				bBackspace = ev.which === $.ui.keyCode.BACKSPACE,
				bInput = ev.target.tagName === 'INPUT' || ev.target.tagName === 'TEXTAREA',
				bEditableDiv = ev.target.tagName === 'DIV' && $(ev.target).attr('contenteditable') === 'true'
			;
			
			if (bBackspace && !bInput && !bEditableDiv)
			{
				ev.preventDefault();
				ev.stopPropagation();
			}
		};
		
		this.minimized.subscribe(function () {
			if (this.minimized())
			{
				this.preventBackspaceOff();
			}
			else if (this.shown())
			{
				this.preventBackspaceOn();
			}
		}, this);
		
		this.minimizedTitle = ko.computed(function () {
			return this.subject() || TextUtils.i18n('MAILWEBCLIENT/HEADING_MINIMIZED_NEW_MESSAGE');
		}, this);
	}

	_.extendOwn(CComposePopup.prototype, CAbstractPopup.prototype);

	_.extendOwn(CComposePopup.prototype, CComposeView.prototype);

	CComposePopup.prototype.PopupTemplate = 'MailWebclient_ComposePopup';

	CComposePopup.prototype.preventBackspaceOn = function ()
	{
		$(document).on('keydown', this.fPreventBackspace);
	};

	CComposePopup.prototype.preventBackspaceOff = function ()
	{
		$(document).off('keydown', this.fPreventBackspace);
	};

	CComposePopup.prototype.onClose = function ()
	{
		this.preventBackspaceOff();
	};

	/**
	 * @param {Array} aParams
	 */
	CComposePopup.prototype.onOpen = function (aParams)
	{
		aParams = aParams || [];
		
		if (aParams.length === 1 && aParams[0] === 'close')
		{
			this.closePopup();
		}
		else
		{
			var
				bOpeningSameDraft = aParams.length === 3 && aParams[0] === 'drafts' && aParams[2] === this.draftUid(),
				bWasMinimized = this.minimized()
			;
			
			this.maximize();
			if (this.shown() || bWasMinimized)
			{
				if (aParams.length > 0 && !bOpeningSameDraft)
				{
					if (this.hasUnsavedChanges())
					{
						this.disableAutosave(true);
						Popups.showPopup(ConfirmAnotherMessageComposedPopup, [_.bind(function (sAnswer) {
							switch (sAnswer)
							{
								case Enums.AnotherMessageComposedAnswer.Discard:
									this.onRoute(aParams);
									break;
								case Enums.AnotherMessageComposedAnswer.SaveAsDraft:
									if (this.hasUnsavedChanges())
									{
										this.executeSave(true, false);
									}
									this.onRoute(aParams);
									break;
								case Enums.AnotherMessageComposedAnswer.Cancel:
									break;
							}
							this.disableAutosave(false);
						}, this)]);
					}
					else
					{
						this.onRoute(aParams);
					}
				}
				else if (!bWasMinimized)
				{
					this.onRoute(aParams);
				}

				this.oHtmlEditor.clearUndoRedo();
			}
			else
			{
				this.onRoute(aParams);
			}
			this.preventBackspaceOn();
		}
	};

	CComposePopup.prototype.minimize = function ()
	{
		this.minimized(true);
		this.$popupDom.addClass('minimized');
	};

	CComposePopup.prototype.maximize = function ()
	{
		this.minimized(false);
		this.$popupDom.removeClass('minimized');
	};

	CComposePopup.prototype.saveAndClose = function ()
	{
		if (this.hasUnsavedChanges())
		{
			this.saveCommand();
		}

		this.closePopup();
	};

	CComposePopup.prototype.cancelPopup = function ()
	{
		if (this.hasUnsavedChanges())
		{
			this.minimize();
		}
		else
		{
			this.closePopup();
		}
	};

	/**
	 * @param {Object} oEvent
	 */
	CComposePopup.prototype.onEscHandler = function (oEvent)
	{
		var
			bHtmlEditorHasOpenedPopup = this.oHtmlEditor.hasOpenedPopup(),
			bOnFileInput = !Browser.ie && oEvent.target && (oEvent.target.tagName.toLowerCase() === 'input') && (oEvent.target.type.toLowerCase() === 'file')
		;
		
		if (bOnFileInput)
		{
			oEvent.target.blur();
		}
		
		if (Popups.hasOnlyOneOpenedPopup() && !bHtmlEditorHasOpenedPopup && !bOnFileInput)
		{
			this.minimize();
		}
		
		if (bHtmlEditorHasOpenedPopup)
		{
			this.oHtmlEditor.closeAllPopups();
		}
	};

	module.exports = new CComposePopup();


/***/ }),

/***/ 412:
/*!*******************************************************************************!*\
  !*** ./modules/MailWebclient/js/popups/ConfirmAnotherMessageComposedPopup.js ***!
  \*******************************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		
		CAbstractPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/CAbstractPopup.js */ 189)
	;

	/**
	 * @constructor
	 */
	function CConfirmAnotherMessageComposedPopup()
	{
		CAbstractPopup.call(this);
		
		this.fConfirmCallback = null;
		this.shown = false;
	}

	_.extendOwn(CConfirmAnotherMessageComposedPopup.prototype, CAbstractPopup.prototype);

	CConfirmAnotherMessageComposedPopup.prototype.PopupTemplate = 'MailWebclient_ConfirmAnotherMessageComposedPopup';

	/**
	 * @param {Function} fConfirmCallback
	 */
	CConfirmAnotherMessageComposedPopup.prototype.onOpen = function (fConfirmCallback)
	{
		this.fConfirmCallback = $.isFunction(fConfirmCallback) ? fConfirmCallback : null;
		this.shown = true;
	};

	CConfirmAnotherMessageComposedPopup.prototype.onClose = function ()
	{
		this.shown = false;
	};

	CConfirmAnotherMessageComposedPopup.prototype.onDiscardClick = function ()
	{
		if (this.shown && this.fConfirmCallback)
		{
			this.fConfirmCallback(Enums.AnotherMessageComposedAnswer.Discard);
		}

		this.closePopup();
	};

	CConfirmAnotherMessageComposedPopup.prototype.onSaveAsDraftClick = function ()
	{
		if (this.shown && this.fConfirmCallback)
		{
			this.fConfirmCallback(Enums.AnotherMessageComposedAnswer.SaveAsDraft);
		}

		this.closePopup();
	};

	CConfirmAnotherMessageComposedPopup.prototype.cancelPopup = function ()
	{
		if (this.fConfirmCallback)
		{
			this.fConfirmCallback(Enums.AnotherMessageComposedAnswer.Cancel);
		}

		this.closePopup();
	};

	CConfirmAnotherMessageComposedPopup.prototype.onEnterHandler = function ()
	{
		this.onSaveAsDraftClick();
	};

	module.exports = new CConfirmAnotherMessageComposedPopup();

/***/ }),

/***/ 413:
/*!********************************************************!*\
  !*** ./modules/MailWebclient/js/views/CComposeView.js ***!
  \********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),

		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		FilesUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Files.js */ 365),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178),
		CJua = __webpack_require__(/*! modules/CoreWebclient/js/CJua.js */ 264),
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		CAbstractScreenView = __webpack_require__(/*! modules/CoreWebclient/js/views/CAbstractScreenView.js */ 193),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		AlertPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/AlertPopup.js */ 188),
		SelectFilesPopup = ModulesManager.run('FilesWebclient', 'getSelectFilesPopup'),
		
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		SendingUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Sending.js */ 414),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		CoreAjax = __webpack_require__(/*! modules/CoreWebclient/js/Ajax.js */ 186),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		MainTabExtMethods = __webpack_require__(/*! modules/MailWebclient/js/MainTabExtMethods.js */ 418),
		SenderSelector = __webpack_require__(/*! modules/MailWebclient/js/SenderSelector.js */ 420),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CMessageModel = __webpack_require__(/*! modules/MailWebclient/js/models/CMessageModel.js */ 421),
		CAttachmentModel = __webpack_require__(/*! modules/MailWebclient/js/models/CAttachmentModel.js */ 422),
		
		CHtmlEditorView = __webpack_require__(/*! modules/MailWebclient/js/views/CHtmlEditorView.js */ 423),
		
		MainTab = App.isNewTab() && window.opener && window.opener.MainTabMailMethods,
		
		$html = $('html')
	;

	/**
	 * @constructor
	 */
	function CComposeView()
	{
		CAbstractScreenView.call(this, 'MailWebclient');
		
		this.browserTitle = ko.computed(function () {
			return AccountList.getEmail() + ' - ' + TextUtils.i18n('MAILWEBCLIENT/HEADING_COMPOSE_BROWSER_TAB');
		});
		
		var self = this;

		this.toAddrDom = ko.observable();
		this.toAddrDom.subscribe(function () {
			this.initInputosaurus(this.toAddrDom, this.toAddr, this.lockToAddr, 'to');
		}, this);
		this.ccAddrDom = ko.observable();
		this.ccAddrDom.subscribe(function () {
			this.initInputosaurus(this.ccAddrDom, this.ccAddr, this.lockCcAddr, 'cc');
		}, this);
		this.bccAddrDom = ko.observable();
		this.bccAddrDom.subscribe(function () {
			this.initInputosaurus(this.bccAddrDom, this.bccAddr, this.lockBccAddr, 'bcc');
		}, this);

		this.folderList = MailCache.folderList;
		this.folderList.subscribe(function () {
			this.getMessageOnRoute();
		}, this);

		this.bNewTab = App.isNewTab();
		this.bDemo = UserSettings.IsDemo;

		this.sending = ko.observable(false);
		this.saving = ko.observable(false);

		this.oHtmlEditor = new CHtmlEditorView(false, this);

		this.visibleBcc = ko.observable(false);
		this.visibleBcc.subscribe(function () {
			$html.toggleClass('screen-compose-bcc', this.visibleCc());
			_.defer(_.bind(function () {
				$(this.bccAddrDom()).inputosaurus('resizeInput');
			}, this));
		}, this);
		this.visibleCc = ko.observable(false);
		this.visibleCc.subscribe(function () {
			$html.toggleClass('screen-compose-cc', this.visibleCc());
			_.defer(_.bind(function () {
				$(this.ccAddrDom()).inputosaurus('resizeInput');
			}, this));
		}, this);

		this.sendReadingConfirmation = ko.observable(false).extend({'reversible': true});

		this.composeUploaderButton = ko.observable(null);
		this.composeUploaderButton.subscribe(function () {
			this.initUploader();
		}, this);
		this.composeUploaderDropPlace = ko.observable(null);
		this.composeUploaderBodyDragOver = ko.observable(false);
		this.composeUploaderDragOver = ko.observable(false);
		this.allowDragNDrop = ko.observable(false);
		this.uploaderBodyDragOver = ko.computed(function () {
			return this.allowDragNDrop() && this.composeUploaderBodyDragOver();
		}, this);
		this.uploaderDragOver = ko.computed(function () {
			return this.allowDragNDrop() && this.composeUploaderDragOver();
		}, this);

		this.selectedImportance = ko.observable(Enums.Importance.Normal).extend({'reversible': true});

		this.senderAccountId = SenderSelector.senderAccountId;
		this.senderList = SenderSelector.senderList;
		this.visibleFrom = ko.computed(function () {
			return this.senderList().length > 1;
		}, this);
		this.selectedSender = SenderSelector.selectedSender;
		this.selectedFetcherOrIdentity = SenderSelector.selectedFetcherOrIdentity;
		this.selectedFetcherOrIdentity.subscribe(function () {
			if (!this.oHtmlEditor.isEditing())
			{
				this.oHtmlEditor.clearUndoRedo();
			}
		}, this);

		this.signature = ko.observable('');
		this.prevSignature = ko.observable(null);
		ko.computed(function () {
			var sSignature = SendingUtils.getClearSignature(this.senderAccountId(), this.selectedFetcherOrIdentity());

			if (this.prevSignature() === null)
			{
				this.prevSignature(sSignature);
				this.signature(sSignature);
			}
			else
			{
				this.prevSignature(this.signature());
				this.signature(sSignature);
				this.oHtmlEditor.changeSignatureContent(this.signature(), this.prevSignature());
			}
		}, this);

		this.lockToAddr = ko.observable(false);
		this.toAddr = ko.observable('').extend({'reversible': true});
		this.toAddr.subscribe(function () {
			if (!this.lockToAddr())
			{
				$(this.toAddrDom()).val(this.toAddr());
				$(this.toAddrDom()).inputosaurus('refresh');
			}
		}, this);
		this.lockCcAddr = ko.observable(false);
		this.ccAddr = ko.observable('').extend({'reversible': true});
		this.ccAddr.subscribe(function () {
			if (!this.lockCcAddr())
			{
				$(this.ccAddrDom()).val(this.ccAddr());
				$(this.ccAddrDom()).inputosaurus('refresh');
			}
		}, this);
		this.lockBccAddr = ko.observable(false);
		this.bccAddr = ko.observable('').extend({'reversible': true});
		this.bccAddr.subscribe(function () {
			if (!this.lockBccAddr())
			{
				$(this.bccAddrDom()).val(this.bccAddr());
				$(this.bccAddrDom()).inputosaurus('refresh');
			}
		}, this);
		this.recipientEmails = ko.computed(function () {
			var
				aRecip = [this.toAddr(), this.ccAddr(), this.bccAddr()].join(',').split(','),
				aEmails = []
			;
			_.each(aRecip, function (sRecip) {
				var
					sTrimmedRecip = $.trim(sRecip),
					oRecip = null
				;
				if (sTrimmedRecip !== '')
				{
					oRecip = AddressUtils.getEmailParts(sTrimmedRecip);
					if (oRecip.email)
					{
						aEmails.push(oRecip.email);
					}
				}
			});
			return aEmails;
		}, this);
		this.subject = ko.observable('').extend({'reversible': true});
		this.plainText = ko.observable(false);
		this.textBody = ko.observable('');
		this.textBody.subscribe(function () {
			this.oHtmlEditor.setText(this.textBody(), this.plainText());
			this.oHtmlEditor.commit();
		}, this);

		this.focusedField = ko.observable();
		this.oHtmlEditor.textFocused.subscribe(function () {
			if (this.oHtmlEditor.textFocused())
			{
				this.focusedField('text');
			}
		}, this);
		this.subjectFocused = ko.observable(false);
		this.subjectFocused.subscribe(function () {
			if (this.subjectFocused())
			{
				this.focusedField('subject');
			}
		}, this);

		this.draftUid = ko.observable('');
		this.draftUid.subscribe(function () {
			MailCache.editedDraftUid(this.draftUid());
		}, this);
		this.draftInfo = ko.observableArray([]);
		this.routeType = ko.observable('');
		this.routeParams = ko.observableArray([]);
		this.inReplyTo = ko.observable('');
		this.references = ko.observable('');

		this.bUploadStatus = false;
		this.iUploadAttachmentsTimer = 0;
		this.messageUploadAttachmentsStarted = ko.observable(false);

		this.messageUploadAttachmentsStarted.subscribe(function (bValue) {
			window.clearTimeout(self.iUploadAttachmentsTimer);
			if (bValue)
			{
				self.iUploadAttachmentsTimer = window.setTimeout(function () {
					self.bUploadStatus = true;
					Screens.showLoading(TextUtils.i18n('MAILWEBCLIENT/INFO_ATTACHMENTS_LOADING'));
				}, 4000);
			}
			else
			{
				if (self.bUploadStatus)
				{
					self.iUploadAttachmentsTimer = window.setTimeout(function () {
						self.bUploadStatus = false;
						Screens.hideLoading();
					}, 1000);
				}
				else
				{
					Screens.hideLoading();
				}
			}
		}, this);

		this.attachments = ko.observableArray([]);
		this.attachmentsChanged = ko.observable(false);
		this.attachments.subscribe(function () {
			this.attachmentsChanged(true);
		}, this);
		this.notUploadedAttachments = ko.computed(function () {
			return _.filter(this.attachments(), function (oAttach) {
				return !oAttach.uploaded();
			});
		}, this);

		this.allAttachmentsUploaded = ko.computed(function () {
			return this.notUploadedAttachments().length === 0 && !this.messageUploadAttachmentsStarted();
		}, this);

		this.notInlineAttachments = ko.computed(function () {
			return _.filter(this.attachments(), function (oAttach) {
				return !oAttach.linked();
			});
		}, this);
		this.notInlineAttachments.subscribe(function () {
			$html.toggleClass('screen-compose-attachments', this.notInlineAttachments().length > 0);
		}, this);

		this.allowStartSending = ko.computed(function() {
			return !this.saving();
		}, this);
		this.allowStartSending.subscribe(function () {
			if (this.allowStartSending() && this.requiresPostponedSending())
			{
				SendingUtils.sendPostponedMail(this.draftUid());
				this.requiresPostponedSending(false);
			}
		}, this);
		this.requiresPostponedSending = ko.observable(false);

		// file uploader
		this.oJua = null;

		this.isDraftsCleared = ko.observable(false);

		this.backToListOnSendOrSave = ko.observable(false);

		this.composeShown = ko.computed(function () {
			return !!this.opened && this.opened() || !!this.shown && this.shown();
		}, this);
		
		this.toolbarControllers = ko.observableArray([]);
		this.disableHeadersEdit = ko.computed(function () {
			var bDisableHeadersEdit = false;
			
			_.each(this.toolbarControllers(), function (oController) {
				bDisableHeadersEdit = bDisableHeadersEdit || !!oController.disableHeadersEdit && oController.disableHeadersEdit();
			});
			
			return bDisableHeadersEdit;
		}, this);
		ko.computed(function () {
			var bDisableBodyEdit = false;
			
			_.each(this.toolbarControllers(), function (oController) {
				bDisableBodyEdit = bDisableBodyEdit || !!oController.disableBodyEdit && oController.disableBodyEdit();
			});
			
			this.oHtmlEditor.setDisableEdit(bDisableBodyEdit);
		}, this);
		
		this.disableAutosave = ko.observable(false);
		// Autosave interval is automatically cleared when compose is not shown or message is sending/saving or 
		// it's disabled by compose screen or one of controllers. After changins these parameters autosave
		// interval might be started again.
		if (Settings.AllowAutosaveInDrafts && Settings.AutoSaveIntervalSeconds > 0)
		{
			this.iAutosaveInterval = -1;
			ko.computed(function () {
				var bAllowAutosave = this.composeShown() && !this.sending() && !this.saving() && !this.disableAutosave() && !MailCache.disableComposeAutosave();
				_.each(this.toolbarControllers(), function (oController) {
					bAllowAutosave = bAllowAutosave && !(!!oController.disableAutosave && oController.disableAutosave());
				});

				window.clearInterval(this.iAutosaveInterval);
				
				if (bAllowAutosave)
				{
					this.iAutosaveInterval = window.setInterval(_.bind(this.executeSave, this, true), Settings.AutoSaveIntervalSeconds * 1000);
				}
			}, this);
		}

		this.backToListCommand = Utils.createCommand(this, this.executeBackToList);
		this.sendCommand = Utils.createCommand(this, this.executeSend, this.isEnableSending);
		this.saveCommand = Utils.createCommand(this, this.executeSaveCommand, this.isEnableSaving);

		this.messageFields = ko.observable(null);
		this.bottomPanel = ko.observable(null);

		this.sHotkeysHintsViewTemplate = !Browser.mobileDevice ? 'MailWebclient_Compose_HotkeysHintsView' : '';
		this.sPopupButtonsViewTemplate = !App.isNewTab() ? 'MailWebclient_Compose_PopupButtonsView' : '';

		this.aHotkeys = [
			{ value: 'Ctrl+Enter', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_SEND_HOTKEY') },
			{ value: 'Ctrl+S', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_SAVE_HOTKEY') },
			{ value: 'Ctrl+Z', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_UNDO_HOTKEY') },
			{ value: 'Ctrl+Y', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_REDO_HOTKEY') },
			{ value: 'Ctrl+K', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_LINK_HOTKEY') },
			{ value: 'Ctrl+B', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_BOLD_HOTKEY') },
			{ value: 'Ctrl+I', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_ITALIC_HOTKEY') },
			{ value: 'Ctrl+U', action: TextUtils.i18n('MAILWEBCLIENT/LABEL_UNDERLINE_HOTKEY') }
		];

		this.bAllowFiles = !!SelectFilesPopup;

		this.ignoreHasUnsavedChanges = ko.observable(false);
		this.changedInPreviousWindow = ko.observable(false);

		this.hasUnsavedChanges = ko.computed(function () {
			return !this.ignoreHasUnsavedChanges() && this.isChanged() && this.isEnableSaving();
		}, this);

		this.saveAndCloseTooltip = ko.computed(function () {
			return this.hasUnsavedChanges() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_SAVE_CLOSE') : TextUtils.i18n('MAILWEBCLIENT/ACTION_CLOSE');
		}, this);

		this.splitterDom = ko.observable();

		this.headersCompressed = ko.observable(false);
		this.allowCcBccSwitchers = ko.computed(function () {
			return !this.disableHeadersEdit() && !this.headersCompressed();
		}, this);
		
		this.registerOwnToolbarControllers();
		
		App.broadcastEvent('MailWebclient::ConstructView::after', {'Name': this.ViewConstructorName, 'View': this});
	}

	_.extendOwn(CComposeView.prototype, CAbstractScreenView.prototype);

	CComposeView.prototype.ViewTemplate = App.isNewTab() ? 'MailWebclient_ComposeScreenView' : 'MailWebclient_ComposeView';
	CComposeView.prototype.ViewConstructorName = 'CComposeView';

	/**
	 * Determines if sending a message is allowed.
	 */
	CComposeView.prototype.isEnableSending = function ()
	{
		var
			bRecipientIsEmpty = this.toAddr().length === 0 && this.ccAddr().length === 0 && this.bccAddr().length === 0,
			bFoldersLoaded = this.folderList() && this.folderList().iAccountId !== 0
		;

		return bFoldersLoaded && !this.sending() && !bRecipientIsEmpty && this.allAttachmentsUploaded();
	};

	/**
	 * Determines if saving a message is allowed.
	 */
	CComposeView.prototype.isEnableSaving = function ()
	{
		var bFoldersLoaded = this.folderList() && this.folderList().iAccountId !== 0;

		return this.composeShown() && bFoldersLoaded && !this.sending() && !this.saving();
	};

	/**
	 * @param {Object} koAddrDom
	 * @param {Object} koAddr
	 * @param {Object} koLockAddr
	 * @param {string} sFocusedField
	 */
	CComposeView.prototype.initInputosaurus = function (koAddrDom, koAddr, koLockAddr, sFocusedField)
	{
		if (koAddrDom() && $(koAddrDom()).length > 0)
		{
			$(koAddrDom()).inputosaurus({
				width: 'auto',
				parseOnBlur: true,
				autoCompleteSource: ModulesManager.run('ContactsWebclient', 'getSuggestionsAutocompleteComposeCallback') || function () {},
				autoCompleteDeleteItem: ModulesManager.run('ContactsWebclient', 'getSuggestionsAutocompleteDeleteHandler') || function () {},
				autoCompleteAppendTo: $(koAddrDom()).closest('td'),
				change : _.bind(function (ev) {
					koLockAddr(true);
					this.setRecipient(koAddr, ev.target.value);
					koLockAddr(false);
				}, this),
				copy: _.bind(function (sVal) {
					this.inputosaurusBuffer = sVal;
				}, this),
				paste: _.bind(function () {
					var sInputosaurusBuffer = this.inputosaurusBuffer || '';
					this.inputosaurusBuffer = '';
					return sInputosaurusBuffer;
				}, this),
				focus: _.bind(this.focusedField, this, sFocusedField),
				mobileDevice: Browser.mobileDevice
			});
		}
	};

	/**
	 * Colapse from to table.
	 */
	CComposeView.prototype.changeHeadersCompressed = function ()
	{
		this.headersCompressed(!this.headersCompressed());
	};

	/**
	 * Executes after applying bindings.
	 */
	CComposeView.prototype.onBind = function ()
	{
		ModulesManager.run('SessionTimeoutWeblient', 'registerFunction', [_.bind(this.executeSave, this, false)]);

		if (!App.isMobile())
		{
			this.hotKeysBind();
		}
	};

	CComposeView.prototype.hotKeysBind = function ()
	{
		(this.$popupDom || this.$viewDom).on('keydown', $.proxy(function(ev) {

			if (ev && ev.ctrlKey && !ev.altKey && !ev.shiftKey)
			{
				var
					nKey = ev.keyCode,
					bComputed = this.composeShown() && (!this.minimized || !this.minimized()) && ev && ev.ctrlKey
				;

				if (bComputed && nKey === Enums.Key.s)
				{
					ev.preventDefault();
					ev.returnValue = false;

					if (this.isEnableSaving())
					{
						this.saveCommand();
					}
				}
				else if (bComputed && nKey === Enums.Key.Enter && this.toAddr() !== '')
				{
					this.sendCommand();
				}
			}

		},this));
	};

	CComposeView.prototype.getMessageOnRoute = function ()
	{
		var oParams = LinksUtils.parseCompose(this.routeParams());
		if (this.routeType() !== '' && oParams.MessageFolderName && oParams.MessageUid)
		{
			MailCache.getMessage(oParams.MessageFolderName, oParams.MessageUid, this.onMessageResponse, this);
		}
	};

	/**
	 * Executes if the view model shows. Requests a folder list from the server to know the full names
	 * of the folders Drafts and Sent Items.
	 */
	CComposeView.prototype.onShow = function ()
	{
		var sFocusedField = this.focusedField();

		$(this.splitterDom()).trigger('resize');
		$(this.bottomPanel()).trigger('resize');

		if (!this.oHtmlEditor.isInitialized())
		{
			this.oHtmlEditor.init(this.textBody(), this.plainText(), '7');
			this.oHtmlEditor.commit();
		}

		this.initUploader();

		this.backToListOnSendOrSave(false);

		this.focusedField(sFocusedField);//oHtmlEditor initialization puts focus on it and changes the variable focusedField

		$html.addClass('screen-compose');

		if (this.oJua)
		{
			this.oJua.setDragAndDropEnabledStatus(true);
		}
	};

	CComposeView.prototype.reset = function ()
	{
		this.plainText(false);
		
		this.bUploadStatus = false;
		window.clearTimeout(this.iUploadAttachmentsTimer);
		this.messageUploadAttachmentsStarted(false);

		this.draftUid('');
		this.draftInfo.removeAll();
		this.setDataFromMessage(new CMessageModel());

		this.isDraftsCleared(false);
		
		this.ignoreHasUnsavedChanges(false);
	};

	/**
	 * Executes if routing was changed.
	 *
	 * @param {Array} aParams
	 */
	CComposeView.prototype.onRoute = function (aParams)
	{
		var oParams = LinksUtils.parseCompose(aParams);
		
		// should be the first action to set right account id in new tab
		AccountList.changeCurrentAccountByHash(oParams.AccountHash);
		
		this.reset();
		
		this.routeType(oParams.RouteType);
		switch (this.routeType())
		{
			case Enums.ReplyType.ForwardAsAttach:
				this.routeParams(aParams);
				this.fillDefault(oParams);
			case Enums.ReplyType.Reply:
			case Enums.ReplyType.ReplyAll:
			case Enums.ReplyType.Resend:
			case Enums.ReplyType.Forward:
			case 'drafts':
				this.routeParams(aParams);
				if (this.folderList().iAccountId !== 0)
				{
					this.getMessageOnRoute();
				}
				break;
			default:
				this.routeParams(aParams);
				this.fillDefault(oParams);
				break;
		}
	};

	CComposeView.prototype.fillDefault = function (oParams)
	{
		var
			sSignature = SendingUtils.getSignatureText(this.senderAccountId(), this.selectedFetcherOrIdentity(), true),
			oComposedMessage = MainTab ? MainTab.getComposedMessage(window.name) : null,
			oToAddr = oParams.ToAddr
		;

		if (oComposedMessage)
		{
			this.setMessageDataInNewTab(oComposedMessage);
			if (this.changedInPreviousWindow())
			{
				_.defer(_.bind(this.executeSave, this, true));
			}
		}
		else if (sSignature !== '')
		{
			this.textBody('<br /><br />' + sSignature + '<br />');
		}

		if (oToAddr)
		{
			this.setRecipient(this.toAddr, oToAddr.to);
			if (oToAddr.hasMailto)
			{
				this.subject(oToAddr.subject);
				this.setRecipient(this.ccAddr, oToAddr.cc);
				this.setRecipient(this.bccAddr, oToAddr.bcc);
				if (oToAddr.body !== '')
				{
					this.textBody('<div>' + oToAddr.body + '</div>');
				}
			}
		}

		if (this.routeType() === 'vcard' && oParams.Object)
		{
			this.addContactAsAttachment(oParams.Object);
		}

		if (this.routeType() === Enums.ReplyType.ForwardAsAttach && oParams.Object)
		{
			this.addMessageAsAttachment(oParams.Object);
		}

		if (this.routeType() === 'attachments' && oParams.Object)
		{
			this.addAttachments(oParams.Object);
		}

		_.defer(_.bind(function () {
			this.focusAfterFilling();
		}, this));

		this.visibleCc(this.ccAddr() !== '');
		this.visibleBcc(this.bccAddr() !== '');
		this.commit(true);
	};

	CComposeView.prototype.focusToAddr = function ()
	{
		$(this.toAddrDom()).inputosaurus('focus');
	};

	CComposeView.prototype.focusCcAddr = function ()
	{
		$(this.ccAddrDom()).inputosaurus('focus');
	};

	CComposeView.prototype.focusBccAddr = function ()
	{
		$(this.bccAddrDom()).inputosaurus('focus');
	};

	CComposeView.prototype.focusAfterFilling = function ()
	{
		switch (this.focusedField())
		{
			case 'to':
				this.focusToAddr();
				break;
			case 'cc':
				this.visibleCc(true);
				this.focusCcAddr();
				break;
			case 'bcc':
				this.visibleBcc(true);
				this.focusBccAddr();
				break;
			case 'subject':
				this.subjectFocused(true);
				break;
			case 'text':
				this.oHtmlEditor.setFocus();
				break;
			default:
				if (this.toAddr().length === 0)
				{
					this.focusToAddr();
				}
				else if (this.subject().length === 0)
				{
					this.subjectFocused(true);
				}
				else
				{
					this.oHtmlEditor.setFocus();
				}
				break;
		}
	};

	/**
	 * Executes if view model was hidden.
	 */
	CComposeView.prototype.onHide = function ()
	{
		if (!_.isFunction(this.closePopup) && this.hasUnsavedChanges())
		{
			this.executeSave(true);
		}

		this.headersCompressed(false);

		this.routeParams([]);

		this.subjectFocused(false);
		this.focusedField('');

		this.messageUploadAttachmentsStarted(false);

		$html.removeClass('screen-compose').removeClass('screen-compose-cc').removeClass('screen-compose-bcc').removeClass('screen-compose-attachments');

		if (this.oJua)
		{
			this.oJua.setDragAndDropEnabledStatus(false);
		}
	};

	/**
	 * @param {Object} koRecipient
	 * @param {string} sRecipient
	 */
	CComposeView.prototype.setRecipient = function (koRecipient, sRecipient)
	{
		if (koRecipient() === sRecipient)
		{
			koRecipient.valueHasMutated();
		}
		else
		{
			koRecipient(sRecipient);
		}
	};

	/**
	 * @param {Object} oMessage
	 */
	CComposeView.prototype.onMessageResponse = function (oMessage)
	{
		var oReplyData = null;

		if (oMessage === null)
		{
			this.setDataFromMessage(new CMessageModel());
		}
		else
		{
			switch (this.routeType())
			{
				case Enums.ReplyType.Reply:
				case Enums.ReplyType.ReplyAll:
					SenderSelector.setFetcherOrIdentityByReplyMessage(oMessage);

					oReplyData = SendingUtils.getReplyDataFromMessage(oMessage, this.routeType(), this.senderAccountId(), this.selectedFetcherOrIdentity(), true);

					this.draftInfo(oReplyData.DraftInfo);
					this.draftUid(oReplyData.DraftUid);
					this.setRecipient(this.toAddr, oReplyData.To);
					this.setRecipient(this.ccAddr, oReplyData.Cc);
					this.setRecipient(this.bccAddr, oReplyData.Bcc);
					this.subject(oReplyData.Subject);
					this.textBody(oReplyData.Text);
					this.attachments(oReplyData.Attachments);
					this.inReplyTo(oReplyData.InReplyTo);
					this.references(oReplyData.References);
					break;

				case Enums.ReplyType.ForwardAsAttach:
					oReplyData = SendingUtils.getReplyDataFromMessage(oMessage, this.routeType(), this.senderAccountId(), this.selectedFetcherOrIdentity(), true);
					this.draftInfo(oReplyData.DraftInfo);
					this.draftUid(oReplyData.DraftUid);
					this.inReplyTo(oReplyData.InReplyTo);
					this.references(oReplyData.References);
					break;
				
				case Enums.ReplyType.Forward:
					SenderSelector.setFetcherOrIdentityByReplyMessage(oMessage);

					oReplyData = SendingUtils.getReplyDataFromMessage(oMessage, this.routeType(), this.senderAccountId(), this.selectedFetcherOrIdentity(), true);

					this.draftInfo(oReplyData.DraftInfo);
					this.draftUid(oReplyData.DraftUid);
					this.setRecipient(this.toAddr, oReplyData.To);
					this.setRecipient(this.ccAddr, oReplyData.Cc);
					this.subject(oReplyData.Subject);
					this.textBody(oReplyData.Text);
					this.attachments(oReplyData.Attachments);
					this.inReplyTo(oReplyData.InReplyTo);
					this.references(oReplyData.References);
					break;

				case Enums.ReplyType.Resend:
					this.setDataFromMessage(oMessage);
					break;

				case 'drafts':
					this.draftUid(oMessage.uid());
					this.setDataFromMessage(oMessage);
					break;
			}

			if (this.routeType() !== Enums.ReplyType.ForwardAsAttach && this.attachments().length > 0)
			{
				this.requestAttachmentsTempName();
			}
			
			this.routeType('');
		}

		this.visibleCc(this.ccAddr() !== '');
		this.visibleBcc(this.bccAddr() !== '');
		this.commit(true);

		_.defer(_.bind(function () {
			this.focusAfterFilling();
		}, this));
	};

	/**
	 * @param {Object} oMessage
	 */
	CComposeView.prototype.setDataFromMessage = function (oMessage)
	{
		var
			sTextBody = '',
			oFetcherOrIdentity = SendingUtils.getFirstFetcherOrIdentityByRecipientsOrDefault(oMessage.oFrom.aCollection, oMessage.accountId())
		;

		SenderSelector.changeSenderAccountId(oMessage.accountId(), oFetcherOrIdentity);

		if (oMessage.isPlain())
		{
			sTextBody = oMessage.textRaw();
		}
		else
		{
			sTextBody = oMessage.getConvertedHtml();
		}
		this.draftInfo(oMessage.draftInfo());
		this.inReplyTo(oMessage.inReplyTo());
		this.references(oMessage.references());
		this.setRecipient(this.toAddr, oMessage.oTo.getFull());
		this.setRecipient(this.ccAddr, oMessage.oCc.getFull());
		this.setRecipient(this.bccAddr, oMessage.oBcc.getFull());
		this.subject(oMessage.subject());
		this.attachments(oMessage.attachments());
		this.plainText(oMessage.isPlain());
		this.textBody(sTextBody);
		this.selectedImportance(oMessage.importance());
		this.sendReadingConfirmation(oMessage.readingConfirmationAddressee() !== '');
		
		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.doAfterPopulatingMessage))
			{
				oController.doAfterPopulatingMessage({
					bDraft: !!oMessage.folderObject() && (oMessage.folderObject().type() === Enums.FolderTypes.Drafts),
					bPlain: oMessage.isPlain(),
					sRawText: oMessage.textRaw(),
					iSensitivity: oMessage.sensitivity()
				});
			}
		});
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onDataAsAttachmentUpload = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oResult = oResponse.Result,
			sHash = oParameters.Hash,
			oAttachment = _.find(this.attachments(), function (oAttach) {
				return oAttach.hash() === sHash;
			})
		;

		this.messageUploadAttachmentsStarted(false);

		if (oAttachment)
		{
			if (oResult && oResult.Attachment)
			{
				oAttachment.parseFromUpload(oResult.Attachment);
			}
			else
			{
				oAttachment.errorFromUpload();
			}
		}
	};

	CComposeView.prototype.addAttachments = function (aFiles)
	{
		_.each(aFiles, _.bind(function (oFileData) {
			var oAttach = new CAttachmentModel();
			oAttach.parseFromUpload(oFileData);
			this.attachments.push(oAttach);
		}, this));
	};

	/**
	 * @param {Array} aFiles
	 */
	CComposeView.prototype.addFilesAsAttachment = function (aFiles)
	{
		var
			oAttach = null,
			aHashes = []
		;

		_.each(aFiles, function (oFile) {
			oAttach = new CAttachmentModel();
			oAttach.fileName(oFile.fileName());
			oAttach.hash(oFile.hash());
			oAttach.thumbUrlInQueue(oFile.thumbUrlInQueue());
			oAttach.uploadStarted(true);

			this.attachments.push(oAttach);

			aHashes.push(oFile.hash());
		}, this);

		if (aHashes.length > 0)
		{
			this.messageUploadAttachmentsStarted(true);

			CoreAjax.send('Files', 'GetFilesForUpload', { 'Hashes': aHashes }, this.onFilesUpload, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onFilesUpload = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			aResult = oResponse.Result,
			aHashes = oParameters.Hashes
		;
		
		this.messageUploadAttachmentsStarted(false);
		if (_.isArray(aResult))
		{
			_.each(aResult, function (oFileData) {
				var oAttachment = _.find(this.attachments(), function (oAttach) {
					return oAttach.hash() === oFileData.Hash;
				});

				if (oAttachment)
				{
					oAttachment.parseFromUpload(oFileData);
					oAttachment.hash(oFileData.NewHash);
				}
			}, this);
		}
		else
		{
			_.each(aHashes, function (sHash) {
				var oAttachment = _.find(this.attachments(), function (oAttach) {
					return oAttach.hash() === sHash;
				});

				if (oAttachment)
				{
					oAttachment.errorFromUpload();
				}
			}, this);
		}
	};

	/**
	 * @param {Object} oMessage
	 */
	CComposeView.prototype.addMessageAsAttachment = function (oMessage)
	{
		var
			oAttach = new CAttachmentModel(),
			oParameters = null
		;
		
		if (oMessage)
		{
			oAttach.fileName(oMessage.subject() + '.eml');
			oAttach.uploadStarted(true);
			
			this.attachments.push(oAttach);
			
			oParameters = {
				'MessageFolder': oMessage.folder(),
				'MessageUid': oMessage.uid(),
				'FileName': oAttach.fileName()
			};
			
			this.messageUploadAttachmentsStarted(true);
			
			Ajax.send('SaveMessageAsTempFile', oParameters, this.onSaveMessageAsTempFile, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onSaveMessageAsTempFile = function (oResponse, oRequest)
	{
		var
			oResult = oResponse.Result,
			sFileName = oRequest.Parameters.FileName,
			oAttach = null
		;
		
		this.messageUploadAttachmentsStarted(false);
		
		if (oResult)
		{
			oAttach = _.find(this.attachments(), function (oAttach) {
				return oAttach.fileName() === sFileName && oAttach.uploadStarted();
			});
			
			if (oAttach)
			{
				oAttach.parseFromUpload(oResult, oRequest.Parameters.MessageFolder, oRequest.Parameters.MessageUid);
			}
		}
		else
		{
			oAttach = _.find(this.attachments(), function (oAttach) {
				return oAttach.fileName() === sFileName && oAttach.uploadStarted();
			});
			
			if (oAttach)
			{
				oAttach.errorFromUpload();
			}
		}
	};

	/**
	 * @param {Object} oContact
	 */
	CComposeView.prototype.addContactAsAttachment = function (oContact)
	{
		var
			oAttach = new CAttachmentModel(),
			oParameters = null
		;

		if (oContact)
		{
			oAttach.fileName('contact-' + oContact.idContact() + '.vcf');
			oAttach.uploadStarted(true);

			this.attachments.push(oAttach);

			oParameters = {
				'ContactId': oContact.idContact(),
				'Global': oContact.global() ? '1' : '0',
				'Name': oAttach.fileName(),
				'SharedWithAll': oContact.sharedToAll() ? '1' : '0'
			};

			this.messageUploadAttachmentsStarted(true);

			Ajax.send('ContactVCardUpload', oParameters, this.onContactVCardUpload, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onContactVCardUpload = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oResult = oResponse.Result,
			oAttach = null
		;

		this.messageUploadAttachmentsStarted(false);

		if (oResult)
		{
			oAttach = _.find(this.attachments(), function (oAttach) {
				return oAttach.fileName() === oResult.Name && oAttach.uploadStarted();
			});

			if (oAttach)
			{
				oAttach.parseFromUpload(oResult);
			}
		}
		else
		{
			oAttach = _.find(this.attachments(), function (oAttach) {
				return oAttach.fileName() === oParameters.Name && oAttach.uploadStarted();
			});

			if (oAttach)
			{
				oAttach.errorFromUpload();
			}
		}
	};

	CComposeView.prototype.requestAttachmentsTempName = function ()
	{
		var
			aHash = _.map(this.attachments(), function (oAttach) {
				oAttach.uploadUid(oAttach.hash());
				oAttach.uploadStarted(true);
				return oAttach.hash();
			})
		;

		if (aHash.length > 0)
		{
			this.messageUploadAttachmentsStarted(true);
			Ajax.send('SaveAttachmentsAsTempFiles', { 'Attachments': aHash }, this.onMessageUploadAttachmentsResponse, this);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onMessageUploadAttachmentsResponse = function (oResponse, oRequest)
	{
		var aHashes = oRequest.Parameters.Attachments;

		this.messageUploadAttachmentsStarted(false);

		if (oResponse.Result)
		{
			_.each(oResponse.Result, _.bind(this.setAttachTepmNameByHash, this));
		}
		else
		{
			_.each(aHashes, function (sHash) {
				var oAttachment = _.find(this.attachments(), function (oAttach) {
					return oAttach.hash() === sHash;
				});
				
				if (oAttachment)
				{
					oAttachment.errorFromUpload();
				}
			}, this);
			Screens.showError(TextUtils.i18n('MAILWEBCLIENT/ERROR_UPLOAD_FORWARD_ATTACHMENTS'));
		}
	};

	/**
	 * @param {string} sHash
	 * @param {string} sTempName
	 */
	CComposeView.prototype.setAttachTepmNameByHash = function (sHash, sTempName)
	{
		_.each(this.attachments(), function (oAttach) {
			if (oAttach.hash() === sHash)
			{
				oAttach.tempName(sTempName);
				oAttach.uploadStarted(false);
			}
		});
	};

	/**
	 * @param {Object} oParameters
	 */
	CComposeView.prototype.setMessageDataInNewTab = function (oParameters)
	{
		this.draftInfo(oParameters.draftInfo);
		this.draftUid(oParameters.draftUid);
		this.inReplyTo(oParameters.inReplyTo);
		this.references(oParameters.references);
		this.setRecipient(this.toAddr, oParameters.toAddr);
		this.setRecipient(this.ccAddr, oParameters.ccAddr);
		this.setRecipient(this.bccAddr, oParameters.bccAddr);
		this.subject(oParameters.subject);
		this.attachments(_.map(oParameters.attachments, function (oRawAttach) {
			var oAttach = new CAttachmentModel();
			oAttach.parse(oRawAttach);
			return oAttach;
		}, this));
		this.plainText(oParameters.plainText);
		this.textBody(oParameters.textBody);
		this.selectedImportance(oParameters.selectedImportance);
		this.sendReadingConfirmation(oParameters.sendReadingConfirmation);
		this.changedInPreviousWindow(oParameters.changedInPreviousWindow);

		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.doAfterApplyingMainTabParameters))
			{
				oController.doAfterApplyingMainTabParameters(oParameters);
			}
		});
		
		SenderSelector.changeSenderAccountId(oParameters.senderAccountId, oParameters.selectedFetcherOrIdentity);
		this.focusedField(oParameters.focusedField);
	};

	/**
	 * @param {boolean=} bOnlyCurrentWindow = false
	 */
	CComposeView.prototype.commit = function (bOnlyCurrentWindow)
	{
		this.toAddr.commit();
		this.ccAddr.commit();
		this.bccAddr.commit();
		this.subject.commit();
		this.selectedImportance.commit();
		this.sendReadingConfirmation.commit();
		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.commit))
			{
				oController.commit();
			}
		});
		this.oHtmlEditor.commit();
		this.attachmentsChanged(false);
		if (!bOnlyCurrentWindow)
		{
			this.changedInPreviousWindow(false);
		}
	};

	CComposeView.prototype.isChanged = function ()
	{
		var
			bToAddrChanged = this.toAddr.changed(),
			bCcAddrChanged = this.ccAddr.changed(),
			bBccAddrChanged = this.bccAddr.changed(),
			bSubjectChanged = this.subject.changed(),
			bImportanceChanged = this.selectedImportance.changed(),
			bReadConfChanged = this.sendReadingConfirmation.changed(),
			bControllersChanged = false,
			bHtmlChanged = this.oHtmlEditor.textChanged(),
			bAttachmentsChanged = this.attachmentsChanged(),
			bChangedInPreviousWindow = this.changedInPreviousWindow()
		;
		
		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.isChanged))
			{
				bControllersChanged = bControllersChanged || oController.isChanged();
			}
		});
		
		return bToAddrChanged || bCcAddrChanged || bBccAddrChanged || bSubjectChanged || 
				bImportanceChanged || bReadConfChanged || bControllersChanged || bHtmlChanged ||
				bAttachmentsChanged || bChangedInPreviousWindow;
	};

	CComposeView.prototype.executeBackToList = function ()
	{
		if (App.isNewTab())
		{
			window.close();
		}
		else if (!!this.shown && this.shown())
		{
			Routing.setPreviousHash();
		}
		this.backToListOnSendOrSave(false);
	};

	/**
	 * Creates new attachment for upload.
	 *
	 * @param {string} sFileUid
	 * @param {Object} oFileData
	 */
	CComposeView.prototype.onFileUploadSelect = function (sFileUid, oFileData)
	{
		var oAttach;

		if (FilesUtils.showErrorIfAttachmentSizeLimit(oFileData.FileName, Types.pInt(oFileData.Size)))
		{
			return false;
		}
		
		oAttach = new CAttachmentModel();
		oAttach.onUploadSelect(sFileUid, oFileData);
		this.attachments.push(oAttach);

		return true;
	};

	/**
	 * Returns attachment found by uid.
	 *
	 * @param {string} sFileUid
	 */
	CComposeView.prototype.getAttachmentByUid = function (sFileUid)
	{
		return _.find(this.attachments(), function (oAttach) {
			return oAttach.uploadUid() === sFileUid;
		});
	};

	/**
	 * Finds attachment by uid. Calls it's function to start upload.
	 *
	 * @param {string} sFileUid
	 */
	CComposeView.prototype.onFileUploadStart = function (sFileUid)
	{
		var oAttach = this.getAttachmentByUid(sFileUid);

		if (oAttach)
		{
			oAttach.onUploadStart();
		}
	};

	/**
	 * Finds attachment by uid. Calls it's function to progress upload.
	 *
	 * @param {string} sFileUid
	 * @param {number} iUploadedSize
	 * @param {number} iTotalSize
	 */
	CComposeView.prototype.onFileUploadProgress = function (sFileUid, iUploadedSize, iTotalSize)
	{
		var oAttach = this.getAttachmentByUid(sFileUid);

		if (oAttach)
		{
			oAttach.onUploadProgress(iUploadedSize, iTotalSize);
		}
	};

	/**
	 * Finds attachment by uid. Calls it's function to complete upload.
	 *
	 * @param {string} sFileUid
	 * @param {boolean} bResponseReceived
	 * @param {Object} oResult
	 */
	CComposeView.prototype.onFileUploadComplete = function (sFileUid, bResponseReceived, oResult)
	{
		var oAttach = this.getAttachmentByUid(sFileUid);

		if (oAttach)
		{
			oAttach.onUploadComplete(sFileUid, bResponseReceived, oResult);
		}
	};

	/**
	 * Finds attachment by uid. Calls it's function to cancel upload.
	 *
	 * @param {string} sFileUid
	 */
	CComposeView.prototype.onFileRemove = function (sFileUid)
	{
		var oAttach = this.getAttachmentByUid(sFileUid);

		if (this.oJua)
		{
			this.oJua.cancel(sFileUid);
		}

		this.attachments.remove(oAttach);
	};

	/**
	 * Initializes file uploader.
	 */
	CComposeView.prototype.initUploader = function ()
	{
		if (this.composeShown() && this.composeUploaderButton() && this.oJua === null)
		{
			this.oJua = new CJua({
				'action': '?/Api/',
				'name': 'jua-uploader',
				'queueSize': 2,
				'clickElement': this.composeUploaderButton(),
				'hiddenElementsPosition': UserSettings.IsRTL ? 'right' : 'left',
				'dragAndDropElement': this.composeUploaderDropPlace(),
				'disableAjaxUpload': false,
				'disableFolderDragAndDrop': false,
				'disableDragAndDrop': false,
				'hidden': _.extendOwn({
					'Module': Settings.ServerModuleName,
					'Method': 'UploadAttachment',
					'Parameters':  function () {
						return JSON.stringify({
							'AccountID': MailCache.currentAccountId()
						});
					}
				}, App.getCommonRequestParameters())
			});

			this.oJua
				.on('onDragEnter', _.bind(this.composeUploaderDragOver, this, true))
				.on('onDragLeave', _.bind(this.composeUploaderDragOver, this, false))
				.on('onBodyDragEnter', _.bind(this.composeUploaderBodyDragOver, this, true))
				.on('onBodyDragLeave', _.bind(this.composeUploaderBodyDragOver, this, false))
				.on('onProgress', _.bind(this.onFileUploadProgress, this))
				.on('onSelect', _.bind(this.onFileUploadSelect, this))
				.on('onStart', _.bind(this.onFileUploadStart, this))
				.on('onComplete', _.bind(this.onFileUploadComplete, this))
			;
			
			this.allowDragNDrop(this.oJua.isDragAndDropSupported());
		}
	};

	/**
	 * @param {boolean} bRemoveSignatureAnchor
	 */
	CComposeView.prototype.getSendSaveParameters = function (bRemoveSignatureAnchor)
	{
		var
			oAttachments = SendingUtils.convertAttachmentsForSending(this.attachments()),
			oParameters = null
		;

		_.each(this.oHtmlEditor.getUploadedImagesData(), function (oAttach) {
			oAttachments[oAttach.TempName] = [oAttach.Name, oAttach.CID, '1', '1'];
		});

		oParameters = {
			'AccountID': this.senderAccountId(),
			'FetcherID': this.selectedFetcherOrIdentity() && this.selectedFetcherOrIdentity().FETCHER ? this.selectedFetcherOrIdentity().id() : '',
			'IdentityID': this.selectedFetcherOrIdentity() && !this.selectedFetcherOrIdentity().FETCHER ? this.selectedFetcherOrIdentity().id() : '',
			'DraftInfo': this.draftInfo(),
			'DraftUid': this.draftUid(),
			'To': this.toAddr(),
			'Cc': this.ccAddr(),
			'Bcc': this.bccAddr(),
			'Subject': this.subject(),
			'Text': this.plainText() ? this.oHtmlEditor.getPlainText() : this.oHtmlEditor.getText(bRemoveSignatureAnchor),
			'IsHtml': !this.plainText(),
			'Importance': this.selectedImportance(),
			'SendReadingConfirmation': this.sendReadingConfirmation(),
			'Attachments': oAttachments,
			'InReplyTo': this.inReplyTo(),
			'References': this.references()
		};
		
		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.doAfterPreparingSendMessageParameters))
			{
				oController.doAfterPreparingSendMessageParameters(oParameters);
			}
		});
		
		return oParameters;
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CComposeView.prototype.onSendOrSaveMessageResponse = function (oResponse, oRequest)
	{
		var
			oResData = SendingUtils.onSendOrSaveMessageResponse(oResponse, oRequest, this.requiresPostponedSending()),
			oParameters = oRequest.Parameters
		;

		this.commit();

		switch (oResData.Method)
		{
			case 'SaveMessage':
				if (oResData.Result && oParameters.DraftUid === this.draftUid())
				{
					this.draftUid(Types.pString(oResData.NewUid));
					
					if (this instanceof CComposeView)// it is screen, not popup
					{
						Routing.replaceHashDirectly(LinksUtils.getComposeFromMessage('drafts', oParameters.DraftFolder, this.draftUid()));
					}
				}
				this.saving(false);
				break;
			case 'SendMessage':
				if (oResData.Result)
				{
					if (this.backToListOnSendOrSave())
					{
						if (_.isFunction(this.closePopup))
						{
							this.closePopup();
						}
						else
						{
							this.executeBackToList();
						}
					}
				}
				this.sending(false);
				break;
		}
	};

	CComposeView.prototype.verifyDataForSending = function ()
	{
		var
			aToIncorrect = AddressUtils.getIncorrectEmailsFromAddressString(this.toAddr()),
			aCcIncorrect = AddressUtils.getIncorrectEmailsFromAddressString(this.ccAddr()),
			aBccIncorrect = AddressUtils.getIncorrectEmailsFromAddressString(this.bccAddr()),
			aIncorrect = _.union(aToIncorrect, aCcIncorrect, aBccIncorrect),
			aEncodedIncorrect = _.map(aIncorrect, function (sIncorrect) {
				return TextUtils.encodeHtml(sIncorrect);
			}),
			sWarning = TextUtils.i18n('MAILWEBCLIENT/ERROR_INPUT_CORRECT_EMAILS') + aEncodedIncorrect.join(', ')
		;

		if (aIncorrect.length > 0)
		{
			Popups.showPopup(AlertPopup, [sWarning]);
			return false;
		}

		return true;
	};

	/**
	 * @param {mixed} mParam
	 */
	CComposeView.prototype.executeSend = function (mParam)
	{
		var
			bCancelSend = false,
			fContinueSending = _.bind(function () {
				this.sending(true);
				this.requiresPostponedSending(!this.allowStartSending());
				
				SendingUtils.send('SendMessage', this.getSendSaveParameters(true), true, this.onSendOrSaveMessageResponse, this, this.requiresPostponedSending());
				
				this.backToListOnSendOrSave(true);
			}, this)
		;

		if (this.isEnableSending() && this.verifyDataForSending())
		{
			_.each(this.toolbarControllers(), function (oController) {
				if (_.isFunction(oController.doBeforeSend))
				{
					bCancelSend = bCancelSend || oController.doBeforeSend(fContinueSending);
				}
			});
			
			if (!bCancelSend)
			{
				fContinueSending();
			}
		}
	};

	CComposeView.prototype.executeSaveCommand = function ()
	{
		this.executeSave(false);
	};

	/**
	 * @param {boolean=} bAutosave = false
	 * @param {boolean=} bWaitResponse = true
	 */
	CComposeView.prototype.executeSave = function (bAutosave, bWaitResponse)
	{
		bAutosave = !!bAutosave;
		bWaitResponse = (bWaitResponse === undefined) ? true : bWaitResponse;

		var
			fOnSaveMessageResponse = bWaitResponse ? this.onSendOrSaveMessageResponse : SendingUtils.onSendOrSaveMessageResponse,
			oContext = bWaitResponse ? this : SendingUtils,
			fSave = _.bind(function (bSave) {
				if (bSave)
				{
					this.saving(bWaitResponse);
					SendingUtils.send('SaveMessage', this.getSendSaveParameters(false), !bAutosave, fOnSaveMessageResponse, oContext);
				}
			}, this),
			bCancelSaving = false
		;

		if (this.isEnableSaving())
		{
			if (!bAutosave || this.isChanged())
			{
				if (!bAutosave)
				{
					_.each(this.toolbarControllers(), function (oController) {
						if (_.isFunction(oController.doBeforeSave))
						{
							bCancelSaving = bCancelSaving || oController.doBeforeSave(fSave);
						}
					}, this);
				}
				if (!bCancelSaving)
				{
					fSave(true);
				}
			}

			this.backToListOnSendOrSave(true);
		}
	};

	/**
	 * Changes visibility of bcc field.
	 */
	CComposeView.prototype.changeBccVisibility = function ()
	{
		this.visibleBcc(!this.visibleBcc());

		if (this.visibleBcc())
		{
			this.focusBccAddr();
		}
		else
		{
			this.focusToAddr();
		}

	};

	/**
	 * Changes visibility of bcc field.
	 */
	CComposeView.prototype.changeCcVisibility = function ()
	{
		this.visibleCc(!this.visibleCc());

		if (this.visibleCc())
		{
			this.focusCcAddr();
		}
		else
		{
			this.focusToAddr();
		}
	};

	CComposeView.prototype.getMessageDataForNewTab = function ()
	{
		var
			aAttachments = _.map(this.attachments(), function (oAttach)
			{
				return {
					'@Object': 'Object/Aurora\\Modules\\Mail\\Classes\\Attachment',
					'FileName': oAttach.fileName(),
					'TempName': oAttach.tempName(),
					'MimeType': oAttach.mimeType(),
					'MimePartIndex': oAttach.mimePartIndex(),
					'EstimatedSize': oAttach.size(),
					'CID': oAttach.cid(),
					'ContentLocation': oAttach.contentLocation(),
					'IsInline': oAttach.inline(),
					'IsLinked': oAttach.linked(),
					'Hash': oAttach.hash()
				};
			}),
			oParameters = null
		;

		oParameters = {
			accountId: this.senderAccountId(),
			draftInfo: this.draftInfo(),
			draftUid: this.draftUid(),
			inReplyTo: this.inReplyTo(),
			references: this.references(),
			senderAccountId: this.senderAccountId(),
			selectedFetcherOrIdentity: this.selectedFetcherOrIdentity(),
			toAddr: this.toAddr(),
			ccAddr: this.ccAddr(),
			bccAddr: this.bccAddr(),
			subject: this.subject(),
			attachments: aAttachments,
			plainText: this.plainText(),
			textBody: this.plainText() ? this.oHtmlEditor.getPlainText() : this.oHtmlEditor.getText(),
			selectedImportance: this.selectedImportance(),
			sendReadingConfirmation: this.sendReadingConfirmation(),
			changedInPreviousWindow: this.isChanged(),
			focusedField: this.focusedField()
		};
		
		_.each(this.toolbarControllers(), function (oController) {
			if (_.isFunction(oController.doAfterPreparingMainTabParameters))
			{
				oController.doAfterPreparingMainTabParameters(oParameters);
			}
		});
		
		return oParameters;
	};

	CComposeView.prototype.openInNewWindow = function ()
	{
		var
			sWinName = 'id' + Math.random().toString(),
			oMessageParametersFromCompose = {},
			oWin = null,
			sHash = Routing.buildHashFromArray(LinksUtils.getCompose())
		;

		this.ignoreHasUnsavedChanges(true);
		oMessageParametersFromCompose = this.getMessageDataForNewTab();

		if (this.draftUid().length > 0 && !this.isChanged())
		{
			sHash = Routing.buildHashFromArray(LinksUtils.getComposeFromMessage('drafts', MailCache.folderList().draftsFolderFullName(), this.draftUid(), true));
			oWin = WindowOpener.openTab('?message-newtab' + sHash);
		}
		else if (!this.isChanged())
		{
			if (this.routeParams().length > 0)
			{
				sHash = Routing.buildHashFromArray(_.union([Settings.HashModuleName + '-compose'], this.routeParams()));
			}
			oWin = WindowOpener.openTab('?message-newtab' + sHash);
		}
		else
		{
			MainTabExtMethods.passComposedMessage(sWinName, oMessageParametersFromCompose);
			oWin = WindowOpener.openTab('?message-newtab' + sHash, sWinName);
		}

		this.commit();

		if (_.isFunction(this.closePopup))
		{
			this.closePopup();
		}
		else
		{
			this.executeBackToList();
		}
	};

	CComposeView.prototype.onShowFilesPopupClick = function ()
	{
		if (this.bAllowFiles)
		{
			Popups.showPopup(SelectFilesPopup, [_.bind(this.addFilesAsAttachment, this)]);
		}
	};

	CComposeView.prototype.registerOwnToolbarControllers = function ()
	{
		this.registerToolbarController({
			ViewTemplate: 'MailWebclient_Compose_BackButtonView',
			sId: 'back',
			bOnlyMobile: true,
			backToListCommand: this.backToListCommand
		});
		this.registerToolbarController({
			ViewTemplate: 'MailWebclient_Compose_SendButtonView',
			sId: 'send',
			bAllowMobile: true,
			sendCommand: this.sendCommand
		});
		this.registerToolbarController({
			ViewTemplate: 'MailWebclient_Compose_SaveButtonView',
			sId: 'save',
			bAllowMobile: true,
			saveCommand: this.saveCommand
		});
		this.registerToolbarController({
			ViewTemplate: 'MailWebclient_Compose_ImportanceDropdownView',
			sId: 'importance',
			selectedImportance: this.selectedImportance
		});
		this.registerToolbarController({
			ViewTemplate: 'MailWebclient_Compose_ConfirmationCheckboxView',
			sId: 'confirmation',
			sendReadingConfirmation: this.sendReadingConfirmation
		});
	};

	/**
	 * @param {Object} oController
	 */
	CComposeView.prototype.registerToolbarController = function (oController)
	{
		var
			bAllowRegister = App.isMobile() ? (oController.bOnlyMobile || oController.bAllowMobile) : (!oController.bOnlyMobile),
			iLastIndex = Settings.ComposeToolbarOrder.length
		;
		
		if (bAllowRegister)
		{
			this.toolbarControllers.push(oController);
			this.toolbarControllers(_.sortBy(this.toolbarControllers(), function (oContr) {
				var iIndex = _.indexOf(Settings.ComposeToolbarOrder, oContr.sId);
				return iIndex !== -1 ? iIndex : iLastIndex;
			}));
			if (_.isFunction(oController.assignComposeExtInterface))
			{
				oController.assignComposeExtInterface(this.getExtInterface());
			}
		}
	};

	/**
	 * @returns {Object}
	 */
	CComposeView.prototype.getExtInterface = function ()
	{
		return {
			isHtml: _.bind(function () {
				return !this.plainText();
			}, this),
			hasAttachments: _.bind(function () {
				return this.notInlineAttachments().length > 0;
			}, this),
			getPlainText: _.bind(this.oHtmlEditor.getPlainText, this.oHtmlEditor),
			getFromEmail: _.bind(function () {
				return AccountList.getEmail(this.senderAccountId());
			}, this),
			getRecipientEmails: _.bind(function () {
				return this.recipientEmails();
			}, this),
			
			saveSilently: _.bind(this.executeSave, this, true),
			setPlainTextMode: _.bind(this.plainText, this, true),
			setPlainText: _.bind(function (sText) {
				this.textBody(sText);
			}, this),
			setHtmlTextMode: _.bind(this.plainText, this, false),
			setHtmlText: _.bind(function (sHtml) {
				this.textBody(sHtml);
			}, this),
			undoHtml: _.bind(this.oHtmlEditor.undoAndClearRedo, this.oHtmlEditor)
		};
	};

	module.exports = CComposeView;


/***/ }),

/***/ 414:
/*!***************************************************!*\
  !*** ./modules/MailWebclient/js/utils/Sending.js ***!
  \***************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		
		CAddressModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CAddressModel.js */ 415),
		CAddressListModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CAddressListModel.js */ 416),
		
		MessageUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Message.js */ 417),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		MainTab = App.isNewTab() && window.opener && window.opener.MainTabMailMethods,
		
		SendingUtils = {
			sReplyText: '',
			sReplyDraftUid: '',
			oPostponedMailData: null
		}
	;

	/**
	 * @param {string} sText
	 * @param {string} sDraftUid
	 */
	SendingUtils.setReplyData = function (sText, sDraftUid)
	{
		this.sReplyText = sText;
		this.sReplyDraftUid = sDraftUid;
	};

	/**
	 * @param {string} sMethod
	 * @param {Object} oParameters
	 * @param {boolean} bShowLoading
	 * @param {Function} fSendMessageResponseHandler
	 * @param {Object} oSendMessageResponseContext
	 * @param {boolean=} bPostponedSending = false
	 */
	SendingUtils.send = function (sMethod, oParameters, bShowLoading, fSendMessageResponseHandler, oSendMessageResponseContext, bPostponedSending)
	{
		var
			iAccountID = oParameters.AccountID,
			oAccount = AccountList.getAccount(iAccountID),
			oFolderList = MailCache.oFolderListItems[iAccountID],
			sLoadingMessage = '',
			sSentFolder = oFolderList ? oFolderList.sentFolderFullName() : '',
			sDraftFolder = oFolderList ? oFolderList.draftsFolderFullName() : '',
			sCurrEmail = oAccount ? oAccount.email() : '',
			bSelfRecipient = (oParameters.To.indexOf(sCurrEmail) > -1 || oParameters.Cc.indexOf(sCurrEmail) > -1 || 
				oParameters.Bcc.indexOf(sCurrEmail) > -1)
		;
		
		if (oAccount.bSaveRepliesToCurrFolder && !bSelfRecipient && Types.isNonEmptyArray(oParameters.DraftInfo, 3))
		{
			sSentFolder = oParameters.DraftInfo[2];
		}
		
		oParameters.Method = sMethod;
		oParameters.ShowReport = bShowLoading;
		
		switch (sMethod)
		{
			case 'SendMessage':
				sLoadingMessage = TextUtils.i18n('COREWEBCLIENT/INFO_SENDING');
				oParameters.SentFolder = sSentFolder;
				if (oParameters.DraftUid !== '')
				{
					oParameters.DraftFolder = sDraftFolder;
					if (MainTab)
					{
						MainTab.removeOneMessageFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder, oParameters.DraftUid);
						MainTab.replaceHashWithoutMessageUid(oParameters.DraftUid);
					}
					else
					{
						MailCache.removeOneMessageFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder, oParameters.DraftUid);
						Routing.replaceHashWithoutMessageUid(oParameters.DraftUid);
					}
				}
				break;
			case 'SaveMessage':
				sLoadingMessage = TextUtils.i18n('MAILWEBCLIENT/INFO_SAVING');
				oParameters.DraftFolder = sDraftFolder;
				MailCache.savingDraftUid(oParameters.DraftUid);
				if (MainTab)
				{
					MainTab.startMessagesLoadingWhenDraftSaving(oParameters.AccountID, oParameters.DraftFolder);
					MainTab.replaceHashWithoutMessageUid(oParameters.DraftUid);
				}
				else
				{
					MailCache.startMessagesLoadingWhenDraftSaving(oParameters.AccountID, oParameters.DraftFolder);
					Routing.replaceHashWithoutMessageUid(oParameters.DraftUid);
				}
				break;
		}
		
		if (bShowLoading)
		{
			Screens.showLoading(sLoadingMessage);
		}
		
		if (bPostponedSending)
		{
			this.postponedMailData = {
				'Parameters': oParameters,
				'SendMessageResponseHandler': fSendMessageResponseHandler,
				'SendMessageResponseContext': oSendMessageResponseContext
			};
		}
		else
		{
			Ajax.send(sMethod, oParameters, fSendMessageResponseHandler, oSendMessageResponseContext);
		}
	};

	/**
	 * @param {string} sDraftUid
	 */
	SendingUtils.sendPostponedMail = function (sDraftUid)
	{
		var
			oData = this.postponedMailData,
			oParameters = oData.Parameters,
			iAccountID = oParameters.AccountID,
			oFolderList = MailCache.oFolderListItems[iAccountID],
			sDraftFolder = oFolderList ? oFolderList.draftsFolderFullName() : ''
		;
		
		if (sDraftUid !== '')
		{
			oParameters.DraftUid = sDraftUid;
			oParameters.DraftFolder = sDraftFolder;
			if (MainTab)
			{
				MainTab.removeOneMessageFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder, oParameters.DraftUid);
				MainTab.replaceHashWithoutMessageUid(oParameters.DraftUid);
			}
			else
			{
				MailCache.removeOneMessageFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder, oParameters.DraftUid);
				Routing.replaceHashWithoutMessageUid(oParameters.DraftUid);
			}
		}
		
		if (this.postponedMailData)
		{
			Ajax.send(oParameters.Method, oParameters, oData.SendMessageResponseHandler, oData.SendMessageResponseContext);
			this.postponedMailData = null;
		}
	};

	/**
	 * @param {string} sMethod
	 * @param {string} sText
	 * @param {string} sDraftUid
	 * @param {Function} fSendMessageResponseHandler
	 * @param {Object} oSendMessageResponseContext
	 * @param {boolean} bRequiresPostponedSending
	 */
	SendingUtils.sendReplyMessage = function (sMethod, sText, sDraftUid, fSendMessageResponseHandler, 
															oSendMessageResponseContext, bRequiresPostponedSending)
	{
		var
			oParameters = null,
			oMessage = MailCache.currentMessage(),
			aRecipients = [],
			oFetcherOrIdentity = null
		;

		if (oMessage)
		{
			aRecipients = oMessage.oTo.aCollection.concat(oMessage.oCc.aCollection);
			oFetcherOrIdentity = this.getFirstFetcherOrIdentityByRecipientsOrDefault(aRecipients, oMessage.accountId());

			oParameters = this.getReplyDataFromMessage(oMessage, Enums.ReplyType.ReplyAll, oMessage.accountId(), oFetcherOrIdentity, false, sText, sDraftUid);

			oParameters.AccountID = oMessage.accountId();

			if (oFetcherOrIdentity)
			{
				oParameters.FetcherID = oFetcherOrIdentity && oFetcherOrIdentity.FETCHER ? oFetcherOrIdentity.id() : '';
				oParameters.IdentityID = oFetcherOrIdentity && !oFetcherOrIdentity.FETCHER ? oFetcherOrIdentity.id() : '';
			}

			oParameters.Bcc = '';
			oParameters.Importance = Enums.Importance.Normal;
			oParameters.SendReadingConfirmation = false;
			oParameters.IsQuickReply = true;
			oParameters.IsHtml = true;

			oParameters.Attachments = this.convertAttachmentsForSending(oParameters.Attachments);

			this.send(sMethod, oParameters, false, fSendMessageResponseHandler, oSendMessageResponseContext, bRequiresPostponedSending);
		}
	};

	/**
	 * @param {Array} aAttachments
	 * 
	 * @return {Object}
	 */
	SendingUtils.convertAttachmentsForSending = function (aAttachments)
	{
		var oAttachments = {};
		
		_.each(aAttachments, function (oAttach) {
			oAttachments[oAttach.tempName()] = [
				oAttach.fileName(),
				oAttach.linked() ? oAttach.cid() : '',
				oAttach.inline() ? '1' : '0',
				oAttach.linked() ? '1' : '0',
				oAttach.contentLocation()
			];
		});
		
		return oAttachments;
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 * @param {boolean} bRequiresPostponedSending
	 * 
	 * @return {Object}
	 */
	SendingUtils.onSendOrSaveMessageResponse = function (oResponse, oRequest, bRequiresPostponedSending)
	{
		var
			oParameters = oRequest.Parameters,
			bResult = !!oResponse.Result,
			sFullName, sUid, sReplyType
		;

		if (!bRequiresPostponedSending)
		{
			Screens.hideLoading();
		}
		
		switch (oRequest.Method)
		{
			case 'SaveMessage':
				if (!bResult)
				{
					if (oParameters.ShowReport)
					{
						Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_MESSAGE_SAVING'));
					}
				}
				else
				{
					if (oParameters.ShowReport && !bRequiresPostponedSending)
					{
						Screens.showReport(TextUtils.i18n('MAILWEBCLIENT/REPORT_MESSAGE_SAVED'));
					}

					if (!oResponse.Result.NewUid)
					{
						Settings.AllowAutosaveInDrafts = false;
					}
				}
				break;
			case 'SendMessage':
				if (!bResult)
				{
					Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_MESSAGE_SENDING'));
				}
				else
				{
					if (oParameters.IsQuickReply)
					{
						Screens.showReport(TextUtils.i18n('MAILWEBCLIENT/REPORT_MESSAGE_SENT'));
					}
					else
					{
						if (MainTab)
						{
							MainTab.showReport(TextUtils.i18n('MAILWEBCLIENT/REPORT_MESSAGE_SENT'));
						}
						else
						{
							Screens.showReport(TextUtils.i18n('MAILWEBCLIENT/REPORT_MESSAGE_SENT'));
						}
					}

					if (_.isArray(oParameters.DraftInfo) && oParameters.DraftInfo.length === 3)
					{
						sReplyType = oParameters.DraftInfo[0];
						sUid = oParameters.DraftInfo[1];
						sFullName = oParameters.DraftInfo[2];
						MailCache.markMessageReplied(oParameters.AccountID, sFullName, sUid, sReplyType);
					}
				}
				
				if (oParameters.SentFolder)
				{
					if (MainTab)
					{
						MainTab.removeMessagesFromCacheForFolder(oParameters.AccountID, oParameters.SentFolder);
					}
					else
					{
						MailCache.removeMessagesFromCacheForFolder(oParameters.AccountID, oParameters.SentFolder);
					}
				}
				
				break;
		}

		if (oParameters.DraftFolder && !bRequiresPostponedSending)
		{
			if (MainTab)
			{
				MainTab.removeMessagesFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder);
			}
			else
			{
				MailCache.removeMessagesFromCacheForFolder(oParameters.AccountID, oParameters.DraftFolder);
			}
		}
		
		return {Method: oRequest.Method, Result: bResult, NewUid: oResponse.Result ? oResponse.Result.NewUid : ''};
	};

	/**
	 * @param {Object} oMessage
	 * @param {string} sReplyType
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * @param {boolean} bPasteSignatureAnchor
	 * @param {string} sText
	 * @param {string} sDraftUid
	 * 
	 * @return {Object}
	 */
	SendingUtils.getReplyDataFromMessage = function (oMessage, sReplyType, iAccountId,
														oFetcherOrIdentity, bPasteSignatureAnchor, sText, sDraftUid)
	{
		var
			oReplyData = {
				DraftInfo: [],
				DraftUid: '',
				To: '',
				Cc: '',
				Bcc: '',
				Subject: '',
				Attachments: [],
				InReplyTo: oMessage.messageId(),
				References: this.getReplyReferences(oMessage)
			},
			aAttachmentsLink = [],
			sToAddr = oMessage.oReplyTo.getFull(),
			sTo = oMessage.oTo.getFull()
		;
		
		if (sToAddr === '' || oMessage.oFrom.getFirstEmail() === oMessage.oReplyTo.getFirstEmail() && oMessage.oReplyTo.getFirstName() === '')
		{
			sToAddr = oMessage.oFrom.getFull();
		}
		
		if (!sText || sText === '')
		{
			sText = this.sReplyText;
			this.sReplyText = '';
		}
		
		if (sReplyType === 'forward')
		{
			oReplyData.Text = sText + this.getForwardMessageBody(oMessage, iAccountId, oFetcherOrIdentity);
		}
		else if (sReplyType === 'resend')
		{
			oReplyData.Text = oMessage.getConvertedHtml();
			oReplyData.Cc = oMessage.cc();
			oReplyData.Bcc = oMessage.bcc();
		}
		else
		{
			oReplyData.Text = sText + GetReplyMessageBody.call(this, oMessage, iAccountId, oFetcherOrIdentity, bPasteSignatureAnchor);
		}
		
		if (sDraftUid)
		{
			oReplyData.DraftUid = sDraftUid;
		}
		else
		{
			oReplyData.DraftUid = this.sReplyDraftUid;
			this.sReplyDraftUid = '';
		}

		switch (sReplyType)
		{
			case Enums.ReplyType.Reply:
				oReplyData.DraftInfo = [Enums.ReplyType.Reply, oMessage.uid(), oMessage.folder()];
				oReplyData.To = sToAddr;
				oReplyData.Subject = this.getReplySubject(oMessage.subject(), true);
				aAttachmentsLink = _.filter(oMessage.attachments(), function (oAttach) {
					return oAttach.linked();
				});
				break;
			case Enums.ReplyType.ReplyAll:
				oReplyData.DraftInfo = [Enums.ReplyType.ReplyAll, oMessage.uid(), oMessage.folder()];
				oReplyData.To = sToAddr;
				oReplyData.Cc = GetReplyAllCcAddr(oMessage, iAccountId, oFetcherOrIdentity);
				oReplyData.Subject = this.getReplySubject(oMessage.subject(), true);
				aAttachmentsLink = _.filter(oMessage.attachments(), function (oAttach) {
					return oAttach.linked();
				});
				break;
			case Enums.ReplyType.Resend:
				oReplyData.DraftInfo = [Enums.ReplyType.Resend, oMessage.uid(), oMessage.folder(), oMessage.cc(), oMessage.bcc()];
				oReplyData.To = sTo;
				oReplyData.Subject = oMessage.subject();
				aAttachmentsLink = oMessage.attachments();
				break;
			case Enums.ReplyType.ForwardAsAttach:
			case Enums.ReplyType.Forward:
				oReplyData.DraftInfo = [Enums.ReplyType.Forward, oMessage.uid(), oMessage.folder()];
				oReplyData.Subject = this.getReplySubject(oMessage.subject(), false);
				aAttachmentsLink = oMessage.attachments();
				break;
		}
		
		_.each(aAttachmentsLink, function (oAttachLink) {
			if (oAttachLink.getCopy)
			{
				var oCopy = oAttachLink.getCopy();
				oReplyData.Attachments.push(oCopy);
			}
		});

		return oReplyData;
	};

	/**
	 * Prepares and returns references for reply message.
	 *
	 * @param {Object} oMessage
	 * 
	 * @return {string}
	 */
	SendingUtils.getReplyReferences = function (oMessage)
	{
		var
			sRef = oMessage.references(),
			sInR = oMessage.messageId(),
			sPos = sRef.indexOf(sInR)
		;

		if (sPos === -1)
		{
			sRef += ' ' + sInR;
		}

		return sRef;
	};

	/**
	 * @param {Object} oMessage
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * @param {boolean} bPasteSignatureAnchor
	 * 
	 * @return {string}
	 */
	function GetReplyMessageBody(oMessage, iAccountId, oFetcherOrIdentity, bPasteSignatureAnchor)
	{
		var
			sReplyTitle = TextUtils.i18n('MAILWEBCLIENT/TEXT_REPLY_MESSAGE', {
				'DATE': oMessage.oDateModel.getDate(),
				'TIME': oMessage.oDateModel.getTime(),
				'SENDER': TextUtils.encodeHtml(oMessage.oFrom.getFull())
			}),
			sReplyBody = '<br /><br />' + this.getSignatureText(iAccountId, oFetcherOrIdentity, bPasteSignatureAnchor) + '<br /><br />' +
				'<div data-anchor="reply-title">' + sReplyTitle + '</div><blockquote>' + oMessage.getConvertedHtml() + '</blockquote>'
		;

		return sReplyBody;
	}

	/**
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * 
	 * @return {string}
	 */
	SendingUtils.getClearSignature = function (iAccountId, oFetcherOrIdentity)
	{
		var
			oAccount = AccountList.getAccount(iAccountId),
			sSignature = ''
		;

		if (oFetcherOrIdentity && oFetcherOrIdentity.accountId() === iAccountId && oFetcherOrIdentity.useSignature())
		{
			sSignature = oFetcherOrIdentity.signature();
		}
		else if (oAccount && oAccount.useSignature())
		{
			sSignature = oAccount.signature();
		}

		return sSignature;
	};

	/**
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * @param {boolean} bPasteSignatureAnchor
	 * 
	 * @return {string}
	 */
	SendingUtils.getSignatureText = function (iAccountId, oFetcherOrIdentity, bPasteSignatureAnchor)
	{
		var sSignature = this.getClearSignature(iAccountId, oFetcherOrIdentity);

		if (bPasteSignatureAnchor)
		{
			return '<div data-anchor="signature">' + sSignature + '</div>';
		}

		return '<div>' + sSignature + '</div>';
	};

	/**
	 * @param {Array} aRecipients
	 * @param {number} iAccountId
	 * 
	 * @return Object
	 */
	SendingUtils.getFirstFetcherOrIdentityByRecipientsOrDefault = function (aRecipients, iAccountId)
	{
		var
			oAccount = AccountList.getAccount(iAccountId),
			aList = this.getAccountFetchersIdentitiesList(oAccount),
			aEqualEmailList = [],
			oFoundFetcherOrIdentity = null
		;

		_.each(aRecipients, function (oAddr) {
			if (!oFoundFetcherOrIdentity)
			{
				aEqualEmailList = _.filter(aList, function (oItem) {
					return oAddr.sEmail === oItem.email;
				});
				
				switch (aEqualEmailList.length)
				{
					case 0:
						break;
					case 1:
						oFoundFetcherOrIdentity = aEqualEmailList[0];
						break;
					default:
						oFoundFetcherOrIdentity = _.find(aEqualEmailList, function (oItem) {
							return oAddr.sEmail === oItem.email && oAddr.sName === oItem.name;
						});
						
						if (!oFoundFetcherOrIdentity)
						{
							oFoundFetcherOrIdentity = _.find(aEqualEmailList, function (oItem) {
								return oItem.isDefault;
							});
							if (!oFoundFetcherOrIdentity)
							{
								oFoundFetcherOrIdentity = aEqualEmailList[0];
							}
						}
						break;
				}
			}
		});
		
		if (!oFoundFetcherOrIdentity)
		{
			oFoundFetcherOrIdentity = _.find(aList, function (oItem) {
				return oItem.isDefault;
			});
		}
		
		return oFoundFetcherOrIdentity && oFoundFetcherOrIdentity.result;
	};

	/**
	 * @param {Object} oAccount
	 * @returns {Array}
	 */
	SendingUtils.getAccountFetchersIdentitiesList = function (oAccount)
	{
		var aList = [];
		
		if (oAccount)
		{
			_.each(oAccount.fetchers(), function (oFetcher) {
				aList.push({
					'email': oFetcher.email(),
					'name': oFetcher.userName(),
					'isDefault': false,
					'result': oFetcher
				});
			});
			
			_.each(oAccount.identities(), function (oIdnt) {
				aList.push({
					'email': oIdnt.email(),
					'name': oIdnt.friendlyName(),
					'isDefault': oIdnt.isDefault(),
					'result': oIdnt
				});
			});
		}

		return aList;
	};

	/**
	 * @param {Object} oMessage
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * 
	 * @return {string}
	 */
	SendingUtils.getForwardMessageBody = function (oMessage, iAccountId, oFetcherOrIdentity)
	{
		var
			sCcAddr = TextUtils.encodeHtml(oMessage.oCc.getFull()),
			sCcPart = (sCcAddr !== '') ? TextUtils.i18n('MAILWEBCLIENT/TEXT_FORWARD_MESSAGE_CCPART', {'CCADDR': sCcAddr}) : '',
			sForwardTitle = TextUtils.i18n('MAILWEBCLIENT/TEXT_FORWARD_MESSAGE', {
				'FROMADDR': TextUtils.encodeHtml(oMessage.oFrom.getFull()),
				'TOADDR': TextUtils.encodeHtml(oMessage.oTo.getFull()),
				'CCPART': sCcPart,
				'FULLDATE': oMessage.oDateModel.getFullDate(),
				'SUBJECT': TextUtils.encodeHtml(oMessage.subject())
			}),
			sForwardBody = '<br /><br />' + this.getSignatureText(iAccountId, oFetcherOrIdentity, true) + '<br /><br />' + 
				'<div data-anchor="reply-title">' + sForwardTitle + '</div><br /><br />' + oMessage.getConvertedHtml()
		;

		return sForwardBody;
	};

	SendingUtils.hasReplyAllCcAddrs = function (oMessage)
	{
		var
			iAccountId = oMessage.accountId(),
			aRecipients = oMessage.oTo.aCollection.concat(oMessage.oCc.aCollection),
			oFetcherOrIdentity = this.getFirstFetcherOrIdentityByRecipientsOrDefault(aRecipients, oMessage.accountId()),
			sCcAddrs = GetReplyAllCcAddr(oMessage, iAccountId, oFetcherOrIdentity)
		;
		return sCcAddrs !== '';
	};

	/**
	 * Prepares and returns cc address for reply message.
	 *
	 * @param {Object} oMessage
	 * @param {number} iAccountId
	 * @param {Object} oFetcherOrIdentity
	 * 
	 * @return {string}
	 */
	function GetReplyAllCcAddr(oMessage, iAccountId, oFetcherOrIdentity)
	{
		var
			oAddressList = new CAddressListModel(),
			aAddrCollection = _.union(oMessage.oTo.aCollection, oMessage.oCc.aCollection, 
				oMessage.oBcc.aCollection),
			oCurrAccount = _.find(AccountList.collection(), function (oAccount) {
				return oAccount.id() === iAccountId;
			}, this),
			oCurrAccAddress = new CAddressModel(),
			oFetcherAddress = new CAddressModel()
		;

		oCurrAccAddress.sEmail = oCurrAccount.email();
		oFetcherAddress.sEmail = oFetcherOrIdentity ? oFetcherOrIdentity.email() : '';
		oAddressList.addCollection(aAddrCollection);
		oAddressList.excludeCollection(_.union(oMessage.oFrom.aCollection, [oCurrAccAddress, oFetcherAddress]));

		return oAddressList.getFull();
	}

	/**
	 * Obtains a subject of the message, which is the answer (reply or forward):
	 * - adds the prefix "Re" of "Fwd" if the language is English, otherwise - their translation
	 * - joins "Re" and "Fwd" prefixes if it is allowed for application in settings
	 * 
	 * @param {string} sSubject Subject of the message, the answer to which is composed
	 * @param {boolean} bReply If **true** the prefix will be "Re", otherwise - "Fwd"
	 *
	 * @return {string}
	 */
	SendingUtils.getReplySubject = function (sSubject, bReply)
	{
		var
			sRePrefix = TextUtils.i18n('MAILWEBCLIENT/TEXT_REPLY_PREFIX'),
			sFwdPrefix = TextUtils.i18n('MAILWEBCLIENT/TEXT_FORWARD_PREFIX'),
			sPrefix = bReply ? sRePrefix : sFwdPrefix,
			sReSubject = sPrefix + ': ' + sSubject
		;
		
		if (Settings.JoinReplyPrefixes)
		{
			sReSubject = MessageUtils.joinReplyPrefixesInSubject(sReSubject, sRePrefix, sFwdPrefix);
		}
		
		return sReSubject;
	};

	/**
	 * @param {string} sPlain
	 * 
	 * @return {string}
	 */
	SendingUtils.getHtmlFromText = function (sPlain)
	{
		return sPlain
			.replace(/&/g, '&amp;').replace(/>/g, '&gt;').replace(/</g, '&lt;')
			.replace(/\r/g, '').replace(/\n/g, '<br />')
		;
	};

	module.exports = SendingUtils;


/***/ }),

/***/ 415:
/*!**********************************************************!*\
  !*** ./modules/CoreWebclient/js/models/CAddressModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44)
	;

	/**
	 * @constructor
	 */
	function CAddressModel()
	{
		this.sName = '';
		/** @type {string} */
		this.sEmail = '';
		
		this.sDisplay = '';
		this.sFull = '';
		
		this.loaded = ko.observable(false);
		this.found = ko.observable(false);
	}

	/**
	 * @param {Object} oData
	 */
	CAddressModel.prototype.parse = function (oData)
	{
		if (oData !== null)
		{
			this.sName = Types.pString(oData.DisplayName);
			this.sEmail = Types.pString(oData.Email);
			this.sDisplay = (this.sName.length > 0) ? this.sName : this.sEmail;
			this.sFull = AddressUtils.getFullEmail(this.sName, this.sEmail);
		}
	};

	/**
	 * @return {string}
	 */
	CAddressModel.prototype.getEmail = function ()
	{
		return this.sEmail;
	};

	/**
	 * @return {string}
	 */
	CAddressModel.prototype.getName = function ()
	{
		return this.sName;
	};

	/**
	 * @return {string}
	 */
	CAddressModel.prototype.getDisplay = function ()
	{
		return this.sDisplay;
	};

	/**
	 * @return {string}
	 */
	CAddressModel.prototype.getFull = function ()
	{
		return this.sFull;
	};

	module.exports = CAddressModel;


/***/ }),

/***/ 416:
/*!**************************************************************!*\
  !*** ./modules/CoreWebclient/js/models/CAddressListModel.js ***!
  \**************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		
		CAddressModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CAddressModel.js */ 415)
	;

	/**
	 * @constructor
	 */
	function CAddressListModel()
	{
		this.aCollection = [];
	}

	/**
	 * @param {object} oData
	 */
	CAddressListModel.prototype.parse = function (oData)
	{
		var aCollection = oData ? oData['@Collection'] : [];
		
		this.aCollection = [];
		
		if (_.isArray(aCollection))
		{
			this.aCollection = _.map(aCollection, function (oItem) {
				var oAddress = new CAddressModel();
				oAddress.parse(oItem);
				return oAddress;
			});
		}
	};

	/**
	 * @param {Array} aCollection
	 */
	CAddressListModel.prototype.addCollection = function (aCollection)
	{
		_.each(aCollection, function (oAddress) {
			var oFoundAddress = _.find(this.aCollection, function (oThisAddress) {
				return oAddress.sEmail === oThisAddress.sEmail;
			});
			
			if (!oFoundAddress)
			{
				this.aCollection.push(oAddress);
			}
		}, this);
	};

	/**
	 * @param {Array} aCollection
	 */
	CAddressListModel.prototype.excludeCollection = function (aCollection)
	{
		_.each(aCollection, function (oAddress) {
			this.aCollection = _.filter(this.aCollection, function (oThisAddress) {
				return oAddress.sEmail !== oThisAddress.sEmail;
			});
		}, this);
	};

	/**
	 * @return {string}
	 */
	CAddressListModel.prototype.getFirstEmail = function ()
	{
		if (this.aCollection.length > 0)
		{
			return this.aCollection[0].getEmail();
		}
		
		return '';
	};

	/**
	 * @return {string}
	 */
	CAddressListModel.prototype.getFirstName = function ()
	{
		if (this.aCollection.length > 0)
		{
			return this.aCollection[0].getName();
		}
		
		return '';
	};

	/**
	 * @return {string}
	 */
	CAddressListModel.prototype.getFirstDisplay = function ()
	{
		if (this.aCollection.length > 0)
		{
			return this.aCollection[0].getDisplay();
		}
		
		return '';
	};

	/**
	 * @param {string=} sMeReplacement
	 * @param {string=} sMyAccountEmail
	 * 
	 * @return {string}
	 */
	CAddressListModel.prototype.getDisplay = function (sMeReplacement, sMyAccountEmail)
	{
		var aAddresses = _.map(this.aCollection, function (oAddress) {
			if (sMeReplacement && sMyAccountEmail === oAddress.sEmail)
			{
				return sMeReplacement;
			}
			return oAddress.getDisplay(sMeReplacement);
		});
		
		return aAddresses.join(', ');
	};

	/**
	 * @return {string}
	 */
	CAddressListModel.prototype.getFull = function ()
	{
		var aAddresses = _.map(this.aCollection, function (oAddress) {
			return oAddress.getFull();
		});
		
		return aAddresses.join(', ');
	};

	/**
	 * @return {Array}
	 */
	CAddressListModel.prototype.getEmails = function ()
	{
		var aEmails = _.map(this.aCollection, function (oAddress) {
			return oAddress.getEmail();
		});
		
		return aEmails;
	};

	module.exports = CAddressListModel;

/***/ }),

/***/ 417:
/*!***************************************************!*\
  !*** ./modules/MailWebclient/js/utils/Message.js ***!
  \***************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		MessageUtils = {}
	;

	/**
	 * Displays embedded images, which have cid on the list.
	 *
	 * @param {object} $html JQuery element containing message body html
	 * @param {array} aAttachments Array of objects having fields
	 *		- CID
	 *		- ContentLocation
	 *		- ViewLink
	 * @param {array} aFoundCids Array of string cids
	 * @param {string=} sAppPath = '' Path to be connected to the ViewLink of every attachment
	 */
	MessageUtils.showInlinePictures = function ($html, aAttachments, aFoundCids, sAppPath)
	{
		var
			fFindAttachmentByCid = function (sCid) {
				return _.find(aAttachments, function (oAttachment) {
					return oAttachment.CID === sCid;
				});
			},
			fFindAttachmentByContentLocation = function (sContentLocation) {
				return _.find(aAttachments, function (oAttachment) {
					return oAttachment.ContentLocation === sContentLocation;
				});
			}
		;

		if (typeof sAppPath !== 'string')
		{
			sAppPath = '';
		}

		if (aFoundCids.length > 0)
		{
			$('[data-x-src-cid]', $html).each(function () {
				var
					sCid = $(this).attr('data-x-src-cid'),
					oAttachment = fFindAttachmentByCid(sCid)
				;
				if (oAttachment && oAttachment.ViewLink.length > 0)
				{
					$(this).attr('src', sAppPath + oAttachment.ViewLink);
				}
			});

			$('[data-x-style-cid]', $html).each(function () {
				var
					sStyle = '',
					sName = $(this).attr('data-x-style-cid-name'),
					sCid = $(this).attr('data-x-style-cid'),
					oAttachment = fFindAttachmentByCid(sCid)
				;

				if (oAttachment && oAttachment.ViewLink.length > 0 && '' !== sName)
				{
					sStyle = $.trim($(this).attr('style'));
					sStyle = '' === sStyle ? '' : (';' === sStyle.substr(-1) ? sStyle + ' ' : sStyle + '; ');
					$(this).attr('style', sStyle + sName + ': url(\'' + oAttachment.ViewLink + '\')');
				}
			});
		}

		$('[data-x-src-location]', $html).each(function () {

			var
				sLocation = $(this).attr('data-x-src-location'),
				oAttachment = fFindAttachmentByContentLocation(sLocation)
			;

			if (!oAttachment)
			{
				oAttachment = fFindAttachmentByCid(sLocation);
			}

			if (oAttachment && oAttachment.ViewLink.length > 0)
			{
				$(this).attr('src', sAppPath + oAttachment.ViewLink);
			}
		});
	};

	/**
	 * Displays external images.
	 *
	 * @param {object} $html JQuery element containing message body html
	 */
	MessageUtils.showExternalPictures = function ($html)
	{
		$('[data-x-src]', $html).each(function () {
			$(this).attr('src', $(this).attr('data-x-src')).removeAttr('data-x-src');
		});

		$('[data-x-style-url]', $html).each(function () {
			var sStyle = $.trim($(this).attr('style'));
			sStyle = '' === sStyle ? '' : (';' === sStyle.substr(-1) ? sStyle + ' ' : sStyle + '; ');
			$(this).attr('style', sStyle + $(this).attr('data-x-style-url')).removeAttr('data-x-style-url');
		});
	};

	/**
	 * Joins "Re" and "Fwd" prefixes in the message subject.
	 * 
	 * @param {string} sSubject The message subject.
	 * @param {string} sRePrefix "Re" prefix translated into the language of the application.
	 * @param {string} sFwdPrefix "Fwd" prefix translated into the language of the application.
	 */
	MessageUtils.joinReplyPrefixesInSubject = function (sSubject, sRePrefix, sFwdPrefix)
	{
		var
			aRePrefixes = [sRePrefix.toUpperCase()],
			aFwdPrefixes = [sFwdPrefix.toUpperCase()],
			sPrefixes = _.union(aRePrefixes, aFwdPrefixes).join('|'),
			sReSubject = '',
			aParts = sSubject.split(':'),
			aResParts = [],
			sSubjectEnd = ''
		;

		_.each(aParts, function (sPart) {
			if (sSubjectEnd.length === 0)
			{
				var
					sPartUpper = $.trim(sPart.toUpperCase()),
					bRe = _.indexOf(aRePrefixes, sPartUpper) !== -1,
					bFwd = _.indexOf(aFwdPrefixes, sPartUpper) !== -1,
					iCount = 1,
					oLastResPart = (aResParts.length > 0) ? aResParts[aResParts.length - 1] : null
				;

				if (!bRe && !bFwd)
				{
					var oMatch = (new window.RegExp('^\\s?(' + sPrefixes + ')\\s?[\\[\\(]([\\d]+)[\\]\\)]$', 'gi')).exec(sPartUpper);
					if (oMatch && oMatch.length === 3)
					{
						bRe = _.indexOf(aRePrefixes, oMatch[1].toUpperCase()) !== -1;
						bFwd = _.indexOf(aFwdPrefixes, oMatch[1].toUpperCase()) !== -1;
						iCount = Types.pInt(oMatch[2]);
					}
				}

				if (bRe)
				{
					if (oLastResPart && oLastResPart.prefix === sRePrefix)
					{
						oLastResPart.count += iCount;
					}
					else
					{
						aResParts.push({prefix: sRePrefix, count: iCount});
					}
				}
				else if (bFwd)
				{
					if (oLastResPart && oLastResPart.prefix === sFwdPrefix)
					{
						oLastResPart.count += iCount;
					}
					else
					{
						aResParts.push({prefix: sFwdPrefix, count: iCount});
					}
				}
				else
				{
					sSubjectEnd = sPart;
				}
			}
			else
			{
				sSubjectEnd += ':' + sPart;
			}
		});

		_.each(aResParts, function (sResPart) {
			if (sResPart.count === 1)
			{
				sReSubject += sResPart.prefix + ': ';
			}
			else
			{
				sReSubject += sResPart.prefix + '[' + sResPart.count + ']: ';
			}
		});
		sReSubject += $.trim(sSubjectEnd);
		
		return sReSubject;
	};

	module.exports = MessageUtils;


/***/ }),

/***/ 418:
/*!*******************************************************!*\
  !*** ./modules/MailWebclient/js/MainTabExtMethods.js ***!
  \*******************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		
		MailUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Mail.js */ 419),
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		
		aComposedMessages = [],
		aReplyData = []
	;

	if (App.isNewTab())
	{
		var SlaveTabMailMethods = {
			getEditedDraftUid: function () {
				return MailCache.editedDraftUid();
			}
		};
		
		window.SlaveTabMailMethods = SlaveTabMailMethods;
		
		module.exports = {};
	}
	else
	{
		var MainTabMailMethods = {
			showReport: function (sText) {
				Screens.showReport(sText);
			},
			getAccountList: function () {
				return AccountList;
			},
			getFolderListItems: function () {
				return MailCache.oFolderListItems;
			},
			getUidList: function () {
				return MailCache.uidList();
			},
			getComposedMessageAccountId: function (sWindowName) {
				var oComposedMessage = aComposedMessages[sWindowName];
				return oComposedMessage ? oComposedMessage.accountId : 0;
			},
			getComposedMessage: function (sWindowName) {
				var oComposedMessage = aComposedMessages[sWindowName];
				delete aComposedMessages[sWindowName];
				return oComposedMessage;
			},
			removeOneMessageFromCacheForFolder: function (iAccountId, sDraftFolder, sDraftUid) {
				MailCache.removeOneMessageFromCacheForFolder(iAccountId, sDraftFolder, sDraftUid);
			},
			replaceHashWithoutMessageUid: function (sDraftUid) {
				Routing.replaceHashWithoutMessageUid(sDraftUid);
			},
			startMessagesLoadingWhenDraftSaving: function (iAccountId, sDraftFolder) {
				MailCache.startMessagesLoadingWhenDraftSaving(iAccountId, sDraftFolder);
			},
			removeMessagesFromCacheForFolder: function (iAccountID, sSentFolder) {
				MailCache.removeMessagesFromCacheForFolder(iAccountID, sSentFolder);
			},
			searchMessagesInCurrentFolder: function (sSearch) {
				MailCache.searchMessagesInCurrentFolder(sSearch);
			},
			getReplyData: function (sUniq) {
				var oReplyData = aReplyData[sUniq];
				delete aReplyData[sUniq];
				return oReplyData;
			},
			deleteMessage: function (sUid, fAfterDelete) {
				MailUtils.deleteMessages([sUid], fAfterDelete);
			}
		};

		window.MainTabMailMethods = MainTabMailMethods;

		module.exports = {
			passReplyData: function (sUniq, oReplyData) {
				aReplyData[sUniq] = oReplyData;
			},
			passComposedMessage: function (sWinName, oComposedMessage) {
				aComposedMessages[sWinName] = oComposedMessage;
			}
		};
	}


/***/ }),

/***/ 419:
/*!************************************************!*\
  !*** ./modules/MailWebclient/js/utils/Mail.js ***!
  \************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		$ = __webpack_require__(/*! jquery */ 1),
				
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		ConfirmPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/ConfirmPopup.js */ 196),
		
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		
		MailUtils = {}
	;

	/**
	 * Moves the specified messages in the current folder to the Trash or delete permanently 
	 * if the current folder is Trash or Spam.
	 * 
	 * @param {Array} aUids
	 * @param {Function=} fAfterDelete
	 */
	MailUtils.deleteMessages = function (aUids, fAfterDelete)
	{
		if (!$.isFunction(fAfterDelete))
		{
			fAfterDelete = function () {};
		}
		
		var
			oFolderList = MailCache.folderList(),
			sCurrFolder = oFolderList.currentFolderFullName(),
			oTrash = oFolderList.trashFolder(),
			bInTrash =(oTrash && sCurrFolder === oTrash.fullName()),
			oSpam = oFolderList.spamFolder(),
			bInSpam = (oSpam && sCurrFolder === oSpam.fullName()),
			fDeleteMessages = function (bResult) {
				if (bResult)
				{
					MailCache.deleteMessages(aUids);
					fAfterDelete();
				}
			}
		;
		
		if (bInSpam)
		{
			MailCache.deleteMessages(aUids);
			fAfterDelete();
		}
		else if (bInTrash)
		{
			Popups.showPopup(ConfirmPopup, [
				TextUtils.i18n('MAILWEBCLIENT/CONFIRM_DELETE_MESSAGES_PLURAL', {}, null, aUids.length), 
				fDeleteMessages, '', TextUtils.i18n('COREWEBCLIENT/ACTION_DELETE')
			]);
		}
		else if (oTrash)
		{
			MailCache.moveMessagesToFolder(oTrash.fullName(), aUids);
			fAfterDelete();
		}
		else if (!oTrash)
		{
			Popups.showPopup(ConfirmPopup, [TextUtils.i18n('MAILWEBCLIENT/CONFIRM_MESSAGES_DELETE_NO_TRASH_FOLDER'), fDeleteMessages]);
		}
	};

	MailUtils.registerMailto = function (bRegisterOnce)
	{
		if (window.navigator && $.isFunction(window.navigator.registerProtocolHandler) && (!bRegisterOnce || Storage.getData('MailtoAsked') !== true))
		{
			window.navigator.registerProtocolHandler(
				'mailto',
				UrlUtils.getAppPath() + '#mail/compose/to/%s',
				UserSettings.SiteName !== '' ? UserSettings.SiteName : 'WebMail'
			);

			Storage.setData('MailtoAsked', true);
		}
	};

	module.exports = MailUtils;


/***/ }),

/***/ 420:
/*!****************************************************!*\
  !*** ./modules/MailWebclient/js/SenderSelector.js ***!
  \****************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
				
		SendingUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Sending.js */ 414),
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402)
	;

	function CSenderSelector()
	{
		this.senderList = ko.observableArray([]);
		
		this.senderAccountId = ko.observable(AccountList.currentId());
		this.selectedFetcherOrIdentity = ko.observable(null);
		this.lockSelectedSender = ko.observable(false);
		this.selectedSender = ko.observable('');
		this.selectedSender.subscribe(function () {
			if (!this.lockSelectedSender())
			{
				var
					oAccount = AccountList.getAccount(this.senderAccountId()),
					sId = this.selectedSender(),
					oFetcherOrIdentity = null
				;
				
				if (Types.isNonEmptyString(sId))
				{
					if (sId.indexOf('fetcher') === 0)
					{
						sId = sId.replace('fetcher', '');
						oFetcherOrIdentity = _.find(oAccount.fetchers(), function (oFetcher) {
							return oFetcher.id() === Types.pInt(sId);
						});
					}
					else
					{
						oFetcherOrIdentity = _.find(oAccount.identities(), function (oIdnt) {
							return oIdnt.id() === Types.pInt(sId);
						});
					}
				}
				
				if (oFetcherOrIdentity)
				{
					this.selectedFetcherOrIdentity(oFetcherOrIdentity);
				}
			}
		}, this);
	}

	CSenderSelector.prototype.changeSelectedSender = function (oFetcherOrIdentity)
	{
		if (oFetcherOrIdentity)
		{
			var sSelectedSenderId = Types.pString(oFetcherOrIdentity.id());

			if (oFetcherOrIdentity.FETCHER)
			{
				sSelectedSenderId = 'fetcher' + sSelectedSenderId;
			}

			if (_.find(this.senderList(), function (oItem) {return oItem.id === sSelectedSenderId;}))
			{
				this.lockSelectedSender(true);
				this.selectedSender(sSelectedSenderId);
				this.selectedFetcherOrIdentity(oFetcherOrIdentity);
				this.lockSelectedSender(false);
			}
		}
	};

	/**
	 * @param {number} iId
	 * @param {string=} oFetcherOrIdentity
	 */
	CSenderSelector.prototype.changeSenderAccountId = function (iId, oFetcherOrIdentity)
	{
		var bChanged = false;
		if (this.senderAccountId() !== iId)
		{
			if (AccountList.hasAccountWithId(iId))
			{
				this.senderAccountId(iId);
				bChanged = true;
			}
			else if (!AccountList.hasAccountWithId(this.senderAccountId()))
			{
				this.senderAccountId(AccountList.currentId());
				bChanged = true;
			}
		}
		
		if (bChanged || this.senderList().length === 0)
		{
			this.fillSenderList(oFetcherOrIdentity);
			bChanged = true;
		}
			
		if (!bChanged && oFetcherOrIdentity)
		{
			this.changeSelectedSender(oFetcherOrIdentity);
		}
	};

	/**
	 * @param {string=} oFetcherOrIdentity
	 */
	CSenderSelector.prototype.fillSenderList = function (oFetcherOrIdentity)
	{
		var
			aSenderList = [],
			oAccount = AccountList.getAccount(this.senderAccountId())
		;

		if (oAccount)
		{
			if (_.isArray(oAccount.identities()))
			{
				_.each(oAccount.identities(), function (oIdentity) {
					aSenderList.push({fullEmail: oIdentity.fullEmail(), id: Types.pString(oIdentity.id())});
				}, this);
			}

			if (oAccount.identitiesSubscribtion)
			{
				oAccount.identitiesSubscribtion.dispose();
			}
			oAccount.identitiesSubscribtion = oAccount.identities.subscribe(function () {
				this.fillSenderList(oFetcherOrIdentity);
				this.changeSelectedSender(oAccount.getDefaultIdentity());
			}, this);

			_.each(oAccount.fetchers(), function (oFetcher) {
				var sFullEmail = oFetcher.fullEmail();
				if (oFetcher.isEnabled() && oFetcher.isOutgoingEnabled() && sFullEmail.length > 0)
				{
					aSenderList.push({fullEmail: sFullEmail, id: 'fetcher' + oFetcher.id()});
				}
			}, this);
			
			if (oAccount.fetchersSubscribtion)
			{
				oAccount.fetchersSubscribtion.dispose();
			}
			oAccount.fetchersSubscribtion = oAccount.fetchers.subscribe(function () {
				this.fillSenderList(oFetcherOrIdentity);
			}, this);
		}

		this.senderList(aSenderList);

		this.changeSelectedSender(oFetcherOrIdentity);
	};

	/**
	 * @param {Object} oMessage
	 */
	CSenderSelector.prototype.setFetcherOrIdentityByReplyMessage = function (oMessage)
	{
		var
			aRecipients = oMessage.oTo.aCollection.concat(oMessage.oCc.aCollection),
			oFetcherOrIdentity = SendingUtils.getFirstFetcherOrIdentityByRecipientsOrDefault(aRecipients, oMessage.accountId())
		;
		
		if (oFetcherOrIdentity)
		{
			this.changeSelectedSender(oFetcherOrIdentity);
		}
	};

	module.exports = new CSenderSelector();


/***/ }),

/***/ 421:
/*!**********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CMessageModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		FilesUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Files.js */ 365),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		
		CAddressListModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CAddressListModel.js */ 416),
		CDateModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CDateModel.js */ 304),
		
		MessageUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Message.js */ 417),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = null,
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CAttachmentModel = __webpack_require__(/*! modules/MailWebclient/js/models/CAttachmentModel.js */ 422),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179)
	;

	/**
	 * @constructor
	 */
	function CMessageModel()
	{
		this.accountId = ko.observable(AccountList.currentId());
		this.folder = ko.observable('');
		this.uid = ko.observable('');
		this.sUniq = '';
		
		this.subject = ko.observable('');
		this.emptySubject = ko.computed(function () {
			return ($.trim(this.subject()) === '');
		}, this);
		this.subjectForDisplay = ko.computed(function () {
			return this.emptySubject() ? TextUtils.i18n('MAILWEBCLIENT/LABEL_NO_SUBJECT') : this.subject();
		}, this);
		this.messageId = ko.observable('');
		this.size = ko.observable(0);
		this.friendlySize = ko.computed(function () {
			return TextUtils.getFriendlySize(this.size());
		}, this);
		this.textSize = ko.observable(0);
		this.oDateModel = new CDateModel();
		this.fullDate = ko.observable('');
		this.oFrom = new CAddressListModel();
		this.fullFrom = ko.observable('');
		this.oTo = new CAddressListModel();
		this.to = ko.observable('');
		this.fromOrToText = ko.observable('');
		this.oCc = new CAddressListModel();
		this.cc = ko.observable('');
		this.oBcc = new CAddressListModel();
		this.bcc = ko.observable('');
		this.oReplyTo = new CAddressListModel();
		
		this.seen = ko.observable(false);
		
		this.flagged = ko.observable(false);
		this.partialFlagged = ko.observable(false);
		this.answered = ko.observable(false);
		this.forwarded = ko.observable(false);
		this.hasAttachments = ko.observable(false);
		this.hasIcalAttachment = ko.observable(false);
		this.hasVcardAttachment = ko.observable(false);

		this.folderObject = ko.computed(function () {
			this.requireMailCache();
			return MailCache.getFolderByFullName(this.accountId(), this.folder());
		}, this);
		this.threadsAllowed = ko.computed(function () {
			var
				oAccount = AccountList.getAccount(this.accountId()),
				oFolder = this.folderObject(),
				bFolderWithoutThreads = oFolder && (oFolder.type() === Enums.FolderTypes.Drafts || 
					oFolder.type() === Enums.FolderTypes.Spam || oFolder.type() === Enums.FolderTypes.Trash)
			;
			return oAccount && oAccount.threadingIsAvailable() && !bFolderWithoutThreads;
		}, this);
		this.otherSendersAllowed = ko.computed(function () {
			var oFolder = this.folderObject();
			return oFolder && (oFolder.type() !== Enums.FolderTypes.Drafts) && (oFolder.type() !== Enums.FolderTypes.Sent);
		}, this);
		
		this.threadPart = ko.observable(false);
		this.threadPart.subscribe(function () {
			if (this.threadPart())
			{
				this.partialFlagged(false);
			}
		}, this);
		this.threadParentUid = ko.observable('');
		
		this.threadUids = ko.observableArray([]);
		this.threadCount = ko.computed(function () {
			return this.threadUids().length;
		}, this);
		this.threadUnreadCount = ko.observable(0);
		this.threadOpened = ko.observable(false);
		this.threadLoading = ko.observable(false);
		this.threadLoadingVisible = ko.computed(function () {
			return this.threadsAllowed() && this.threadOpened() && this.threadLoading();
		}, this);
		this.threadCountVisible = ko.computed(function () {
			return this.threadsAllowed() && this.threadCount() > 0 && !this.threadLoading();
		}, this);
		this.threadCountHint = ko.computed(function () {
			if (this.threadCount() > 0)
			{
				if (this.threadOpened())
				{
					return  TextUtils.i18n('MAILWEBCLIENT/ACTION_FOLD_THREAD');
				}
				else
				{
					if (this.threadUnreadCount() > 0)
					{
						return  TextUtils.i18n('MAILWEBCLIENT/ACTION_UNFOLD_THREAD_WITH_UNREAD', {}, null, this.threadUnreadCount());
					}
					else
					{
						return  TextUtils.i18n('MAILWEBCLIENT/ACTION_UNFOLD_THREAD');
					}
				}
			}
			return '';
		}, this);
		this.threadCountForLoad = ko.observable(5);
		this.threadNextLoadingVisible = ko.observable(false);
		this.threadNextLoadingLinkVisible = ko.observable(false);
		this.threadFunctionLoadNext = null;
		this.threadShowAnimation = ko.observable(false);
		this.threadHideAnimation = ko.observable(false);
		
		this.importance = ko.observable(Enums.Importance.Normal);
		this.draftInfo = ko.observableArray([]);
		this.hash = ko.observable('');
		this.sDownloadAsEmlUrl = '';

		this.completelyFilled = ko.observable(false);

		this.checked = ko.observable(false);
		this.checked.subscribe(function (bChecked) {
			this.requireMailCache();
			if (!this.threadOpened() && MailCache.useThreadingInCurrentList())
			{
				var
					oFolder = MailCache.folderList().getFolderByFullName(this.folder())
				;
				_.each(this.threadUids(), function (sUid) {
					var oMessage = oFolder.oMessages[sUid];
					if (oMessage)
					{
						oMessage.checked(bChecked);
					}
				});
			}
		}, this);
		this.selected = ko.observable(false);
		this.deleted = ko.observable(false); // temporary removal until it was confirmation from the server to delete

		this.trimmed = ko.observable(false);
		this.trimmedTextSize = ko.observable(0);
		this.inReplyTo = ko.observable('');
		this.references = ko.observable('');
		this.readingConfirmationAddressee = ko.observable('');
		this.sensitivity = ko.observable(Enums.Sensitivity.Nothing);
		this.isPlain = ko.observable(false);
		this.text = ko.observable('');
		this.textBodyForNewWindow = ko.observable('');
		this.$text = null;
		this.rtl = ko.observable(false);
		this.hasExternals = ko.observable(false);
		this.isExternalsShown = ko.observable(false);
		this.isExternalsAlwaysShown = ko.observable(false);
		this.foundCids = ko.observableArray([]);
		this.attachments = ko.observableArray([]);
		this.usesAttachmentString = false;
		this.safety = ko.observable(false);
		this.sourceHeaders = ko.observable('');

		this.date = ko.observable('');
		
		this.textRaw = ko.observable('');
		
		this.domMessageForPrint = ko.observable(null);
		
		this.Custom = {};
	}

	CMessageModel.prototype.requireMailCache = function ()
	{
		if (MailCache === null)
		{
			MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399);
		}
	};

	/**
	 * @param {Object} oWin
	 */
	CMessageModel.prototype.viewMessage = function (oWin)
	{
		var
			oDomText = this.getDomText(UrlUtils.getAppPath()),
			sHtml = ''
		;
		
		this.textBodyForNewWindow(oDomText.html());
		sHtml = $(this.domMessageForPrint()).html();
		
		if (oWin)
		{
			$(oWin.document.body).html(sHtml);
			oWin.focus();
			_.each(this.attachments(), function (oAttach) {
				var oLink = $(oWin.document.body).find("[data-hash='download-" + oAttach.hash() + "']");
				if (oAttach.hasAction('download'))
				{
					oLink.on('click', _.bind(oAttach.executeAction, oAttach, 'download'));
				}
				else
				{
					oLink.hide();
				}
				
				oLink = $(oWin.document.body).find("[data-hash='view-" + oAttach.hash() + "']");
				if (oAttach.hasAction('view'))
				{
					oLink.on('click', _.bind(oAttach.executeAction, oAttach, 'view'));
				}
				else
				{
					oLink.hide();
				}
			}, this);
		}
	};

	/**
	 * Fields accountId, folder, oTo & oFrom should be filled.
	 */
	CMessageModel.prototype.fillFromOrToText = function ()
	{
		this.requireMailCache();
		var
			oFolder = MailCache.getFolderByFullName(this.accountId(), this.folder()),
			oAccount = AccountList.getAccount(this.accountId())
		;
		
		if (oFolder.type() === Enums.FolderTypes.Drafts || oFolder.type() === Enums.FolderTypes.Sent)
		{
			this.fromOrToText(this.oTo.getDisplay(TextUtils.i18n('MAILWEBCLIENT/LABEL_ME_RECIPIENT'), oAccount.email()));
		}
		else
		{
			this.fromOrToText(this.oFrom.getDisplay(TextUtils.i18n('MAILWEBCLIENT/LABEL_ME_SENDER'), oAccount.email()));
		}
	};

	/**
	 * @param {Array} aChangedThreadUids
	 * @param {number} iLoadedMessagesCount
	 */
	CMessageModel.prototype.changeThreadUids = function (aChangedThreadUids, iLoadedMessagesCount)
	{
		this.threadUids(aChangedThreadUids);
		this.threadLoading(iLoadedMessagesCount < Math.min(this.threadUids().length, this.threadCountForLoad()));
	};

	/**
	 * @param {Function} fLoadNext
	 */
	CMessageModel.prototype.showNextLoadingLink = function (fLoadNext)
	{
		if (this.threadNextLoadingLinkVisible())
		{
			this.threadNextLoadingVisible(true);
			this.threadFunctionLoadNext = fLoadNext;
		}
	};

	CMessageModel.prototype.increaseThreadCountForLoad = function ()
	{
		this.threadCountForLoad(this.threadCountForLoad() + 5);
		this.requireMailCache();
		MailCache.showOpenedThreads(this.folder());
	};

	CMessageModel.prototype.loadNextMessages = function ()
	{
		if (this.threadFunctionLoadNext)
		{
			this.threadFunctionLoadNext();
			this.threadNextLoadingLinkVisible(false);
			this.threadFunctionLoadNext = null;
		}
	};

	/**
	 * @param {number} iShowThrottle
	 * @param {string} sParentUid
	 */
	CMessageModel.prototype.markAsThreadPart = function (iShowThrottle, sParentUid)
	{
		var self = this;
		
		this.threadPart(true);
		this.threadParentUid(sParentUid);
		this.threadUids([]);
		this.threadNextLoadingVisible(false);
		this.threadNextLoadingLinkVisible(true);
		this.threadFunctionLoadNext = null;
		this.threadHideAnimation(false);
		
		setTimeout(function () {
			self.threadShowAnimation(true);
		}, iShowThrottle);
	};

	/**
	 * @param {AjaxMessageResponse} oData
	 * @param {number} iAccountId
	 * @param {boolean} bThreadPart
	 * @param {boolean} bTrustThreadInfo
	 */
	CMessageModel.prototype.parse = function (oData, iAccountId, bThreadPart, bTrustThreadInfo)
	{
		var
			sHtml = '',
			sPlain = ''
		;

		if (bTrustThreadInfo)
		{
			this.threadPart(bThreadPart);
		}
		if (!this.threadPart())
		{
			this.threadParentUid('');
		}
		
		if (oData['@Object'] === 'Object/MessageListItem')
		{
			this.seen(!!oData.IsSeen);
			this.flagged(!!oData.IsFlagged);
			this.answered(!!oData.IsAnswered);
			this.forwarded(!!oData.IsForwarded);
			
			if (oData.Custom)
			{
				this.Custom = oData.Custom;
			}
		}
		
		if (oData['@Object'] === 'Object/Message' || oData['@Object'] === 'Object/MessageListItem')
		{
			this.Custom.Sensitivity = oData.Sensitivity;
			
			this.accountId(iAccountId);
			this.folder(oData.Folder);
			this.uid(Types.pString(oData.Uid));
			this.sUniq = this.accountId() + this.folder() + this.uid();
			
			this.subject(Types.pString(oData.Subject));
			this.messageId(Types.pString(oData.MessageId));
			this.size(oData.Size);
			this.textSize(oData.TextSize);
			this.oDateModel.parse(oData.TimeStampInUTC);
			this.oFrom.parse(oData.From);
			this.oTo.parse(oData.To);
			this.fillFromOrToText();
			this.oCc.parse(oData.Cc);
			this.oBcc.parse(oData.Bcc);
			this.oReplyTo.parse(oData.ReplyTo);
			
			this.fullDate(this.oDateModel.getFullDate());
			this.fullFrom(this.oFrom.getFull());
			this.to(this.oTo.getFull());
			this.cc(this.oCc.getFull());
			this.bcc(this.oBcc.getFull());
			
			this.hasAttachments(!!oData.HasAttachments);
			this.hasIcalAttachment(!!oData.HasIcalAttachment);
			this.hasVcardAttachment(!!oData.HasVcardAttachment);
			
			if (oData['@Object'] === 'Object/MessageListItem' && bTrustThreadInfo)
			{
				this.threadUids(_.map(oData.Threads, function (iUid) {
					return iUid.toString();
				}, this));
			}
			
			this.importance(Types.pInt(oData.Importance));
			if (!Enums.has('Importance', this.importance()))
			{
				this.importance(Enums.Importance.Normal);
			}
			this.sensitivity(Types.pInt(oData.Sensitivity));
			if (!Enums.has('Sensitivity', this.sensitivity()))
			{
				this.sensitivity(Enums.Sensitivity.Nothing);
			}
			if (_.isArray(oData.DraftInfo))
			{
				this.draftInfo(oData.DraftInfo);
			}
			this.hash(Types.pString(oData.Hash));
			this.sDownloadAsEmlUrl = Types.pString(oData.DownloadAsEmlUrl);
			
			if (oData['@Object'] === 'Object/Message')
			{
				this.trimmed(oData.Trimmed);
				this.trimmedTextSize(oData.TrimmedTextSize);
				this.inReplyTo(oData.InReplyTo);
				this.references(oData.References);
				this.readingConfirmationAddressee(Types.pString(oData.ReadingConfirmationAddressee));
				sHtml = Types.pString(oData.Html);
				sPlain = Types.pString(oData.Plain);
				if (sHtml !== '')
				{
					this.textRaw(oData.HtmlRaw);
					this.text(sHtml);
					this.isPlain(false);
				}
				else
				{
					this.textRaw(oData.PlainRaw);
					this.text(sPlain !== '' ? '<div>' + sPlain + '</div>' : '');
					this.isPlain(true);
				}
				this.$text = null;
				this.isExternalsShown(false);
				this.rtl(oData.Rtl);
				this.hasExternals(!!oData.HasExternals);
				this.foundCids(oData.FoundedCIDs);
				this.parseAttachments(oData.Attachments, iAccountId);
				this.safety(oData.Safety);
				this.sourceHeaders(oData.Headers);
				
				this.aExtend = oData.Extend;
				this.completelyFilled(true);

				App.broadcastEvent('MailWebclient::ParseMessage::after', {
					msg: this
				});
			}
			
			this.updateMomentDate();
		}
	};

	CMessageModel.prototype.updateMomentDate = function ()
	{
		this.date(this.oDateModel.getShortDate(moment().clone().subtract(1, 'days').format('L') ===
			moment.unix(this.oDateModel.getTimeStampInUTC()).format('L')));
	};

	/**
	 * @param {string=} sAppPath = ''
	 * @param {boolean=} bForcedShowPictures
	 * 
	 * return {Object}
	 */
	CMessageModel.prototype.getDomText = function (sAppPath, bForcedShowPictures)
	{
		var $text = this.$text;
		
		sAppPath = sAppPath || '';
		
		if (this.$text === null || sAppPath !== '')
		{
			if (this.completelyFilled())
			{
				this.$text = $(this.text());
				
				this.showInlinePictures(sAppPath);
				if (this.safety() === true)
				{
					this.alwaysShowExternalPicturesForSender();
				}
				
				if (bForcedShowPictures && this.isExternalsShown())
				{
					this.showExternalPictures();
				}
				
				$text = this.$text;
			}
			else
			{
				$text = $('');
			}
		}
		
		//returns a clone, because it uses both in the parent window and the new
		return $text.clone();
	};

	/**
	 * @param {string=} sAppPath = ''
	 * @param {boolean=} bForcedShowPictures
	 * 
	 * return {string}
	 */
	CMessageModel.prototype.getConvertedHtml = function (sAppPath, bForcedShowPictures)
	{
		var oDomText = this.getDomText(sAppPath, bForcedShowPictures);
		return (oDomText.length > 0) ? oDomText.wrap('<p>').parent().html() : '';
	};

	/**
	 * Parses attachments.
	 *
	 * @param {object} oData
	 * @param {number} iAccountId
	 */
	CMessageModel.prototype.parseAttachments = function (oData, iAccountId)
	{
		var aCollection = oData ? oData['@Collection'] : [];
		
		this.attachments([]);
		
		if (Types.isNonEmptyArray(aCollection))
		{
			this.attachments(_.map(aCollection, function (oRawAttach) {
				var oAttachment = new CAttachmentModel();
				oAttachment.setMessageData(this.folder(), this.uid());
				oAttachment.parse(oRawAttach, this.folder(), this.uid());
				return oAttachment;
			}, this));
		}
	};

	/**
	 * Parses an array of email addresses.
	 *
	 * @param {Array} aData
	 * @return {Array}
	 */
	CMessageModel.prototype.parseAddressArray = function (aData)
	{
		var
			aAddresses = []
		;

		if (_.isArray(aData))
		{
			aAddresses = _.map(aData, function (oRawAddress) {
				var oAddress = new CAddressModel();
				oAddress.parse(oRawAddress);
				return oAddress;
			});
		}

		return aAddresses;
	};

	/**
	 * Displays embedded images, which have cid on the list.
	 * 
	 * @param {string} sAppPath
	 */
	CMessageModel.prototype.showInlinePictures = function (sAppPath)
	{
		var aAttachments = _.map(this.attachments(), function (oAttachment) {
			return {
				CID: oAttachment.cid(),
				ContentLocation: oAttachment.contentLocation(),
				ViewLink: oAttachment.getActionUrl('view')
			};
		});
		
		MessageUtils.showInlinePictures(this.$text, aAttachments, this.foundCids(), sAppPath);
	};

	/**
	 * Displays external images.
	 */
	CMessageModel.prototype.showExternalPictures = function ()
	{
		MessageUtils.showExternalPictures(this.$text);
		
		this.isExternalsShown(true);
	};

	/**
	 * Sets a flag that external images are always displayed.
	 */
	CMessageModel.prototype.alwaysShowExternalPicturesForSender = function ()
	{
		if (this.completelyFilled())
		{
			this.isExternalsAlwaysShown(true);
			if (!this.isExternalsShown())
			{
				this.showExternalPictures();
			}
		}
	};

	CMessageModel.prototype.openThread = function ()
	{
		if (this.threadCountVisible())
		{
			var sFolder = this.folder();

			this.threadOpened(!this.threadOpened());
			this.requireMailCache();
			if (this.threadOpened())
			{
				MailCache.showOpenedThreads(sFolder);
			}
			else
			{
				MailCache.hideThreads(this);
				setTimeout(function () {
					MailCache.showOpenedThreads(sFolder);
				}, 500);
			}
		}
	};

	/**
	 * @returns {Array}
	 */
	CMessageModel.prototype.getAttachmentsHashes = function ()
	{
		var
			aNotInlineAttachments = _.filter(this.attachments(), function (oAttach) {
				return !oAttach.linked();
			}),
			aHashes = _.map(aNotInlineAttachments, function (oAttach) {
				return oAttach.hash();
			})
		;

		return aHashes;
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMessageModel.prototype.onSaveAttachmentsToFilesResponse = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			iSavedCount = 0,
			iTotalCount = oParameters.Attachments.length
		;
		
		if (oResponse.Result)
		{
			_.each(oParameters.Attachments, function (sHash) {
				if (oResponse.Result[sHash] !== undefined)
				{
					iSavedCount++;
				}
			});
		}
		
		if (iSavedCount === 0)
		{
			Screens.showError(TextUtils.i18n('MAILWEBCLIENT/ERROR_CANT_SAVE_ATTACHMENTS_TO_FILES'));
		}
		else if (iSavedCount < iTotalCount)
		{
			Screens.showError(TextUtils.i18n('MAILWEBCLIENT/ERROR_SOME_ATTACHMENTS_WERE_NOT_SAVED', {
				'SAVED_COUNT': iSavedCount,
				'TOTAL_COUNT': iTotalCount
			}));
		}
		else
		{
			Screens.showReport(TextUtils.i18n('MAILWEBCLIENT/REPORT_ATTACHMENTS_SAVED_TO_FILES'));
		}
	};

	CMessageModel.prototype.downloadAllAttachmentsSeparately = function ()
	{
		_.each(this.attachments(), function (oAttach) {
			if (!oAttach.linked())
			{
				oAttach.executeAction('download');
			}
		});
	};

	/**
	 * Uses for logging.
	 * 
	 * @returns {Object}
	 */
	CMessageModel.prototype.toJSON = function ()
	{
		return {
			uid: this.uid(),
			accountId: this.accountId(),
			to: this.to(),
			subject: this.subject(),
			threadPart: this.threadPart(),
			threadUids: this.threadUids(),
			threadOpened: this.threadOpened()
		};
	};

	module.exports = CMessageModel;


/***/ }),

/***/ 422:
/*!*************************************************************!*\
  !*** ./modules/MailWebclient/js/models/CAttachmentModel.js ***!
  \*************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		CAbstractFileModel = __webpack_require__(/*! modules/CoreWebclient/js/models/CAbstractFileModel.js */ 364),
		
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403)
	;

	/**
	 * @constructor
	 * @extends CCommonFileModel
	 */
	function CAttachmentModel()
	{
		this.folderName = ko.observable('');
		this.messageUid = ko.observable('');
		
		this.cid = ko.observable('');
		this.contentLocation = ko.observable('');
		this.inline = ko.observable(false);
		this.linked = ko.observable(false);
		this.mimePartIndex = ko.observable('');

		this.messagePart = ko.observable(null);
		
		CAbstractFileModel.call(this);
		
		this.isMessageType = ko.computed(function () {
			this.mimeType();
			this.mimePartIndex();
			return (this.mimeType() === 'message/rfc822');
		}, this);
	}

	_.extendOwn(CAttachmentModel.prototype, CAbstractFileModel.prototype);

	CAttachmentModel.prototype.getNewInstance = function ()
	{
		return new CAttachmentModel();
	};

	CAttachmentModel.prototype.getCopy = function ()
	{
		var oCopy = new CAttachmentModel();
		
		oCopy.copyProperties(this);
		
		return oCopy;
	};

	CAttachmentModel.prototype.copyProperties = function (oSource)
	{
		this.fileName(oSource.fileName());
		this.tempName(oSource.tempName());
		this.size(oSource.size());
		this.hash(oSource.hash());
		this.mimeType(oSource.mimeType());
		this.cid(oSource.cid());
		this.contentLocation(oSource.contentLocation());
		this.inline(oSource.inline());
		this.linked(oSource.linked());
		this.thumbnailSrc(oSource.thumbnailSrc());
		this.thumbnailLoaded(oSource.thumbnailLoaded());
		this.statusText(oSource.statusText());
		this.uploaded(oSource.uploaded());
		this.oActionsData = oSource.oActionsData;
		this.actions(oSource.actions());
		this.thumbUrlInQueue(oSource.thumbUrlInQueue());
	};

	/**
	 * Parses attachment data from server.
	 *
	 * @param {AjaxAttachmenResponse} oData
	 */
	CAttachmentModel.prototype.additionalParse = function (oData)
	{
		this.mimePartIndex(Types.pString(oData.MimePartIndex));

		this.cid(Types.pString(oData.CID));
		this.contentLocation(Types.pString(oData.ContentLocation));
		this.inline(!!oData.IsInline);
		this.linked(!!oData.IsLinked);
	};

	/**
	 * @param {string} sFolderName
	 * @param {string} sMessageUid
	 */
	CAttachmentModel.prototype.setMessageData = function (sFolderName, sMessageUid)
	{
		this.folderName(sFolderName);
		this.messageUid(sMessageUid);
	};

	/**
	 * @param {Object} oResult
	 * @param {Object} oRequest
	 */
	CAttachmentModel.prototype.onGetMessageResponse = function (oResult, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oResult = oResult.Result,
			CMessageModel = __webpack_require__(/*! modules/MailWebclient/js/models/CMessageModel.js */ 421),
			oMessage = new CMessageModel()
		;
		
		if (oResult && this.oNewWindow)
		{
			oMessage.parse(oResult, oParameters.AccountID, false, true);
			this.messagePart(oMessage);
			this.messagePart().viewMessage(this.oNewWindow);
			this.oNewWindow = undefined;
		}
	};

	/**
	 * Starts viewing attachment on click.
	 */
	CAttachmentModel.prototype.viewFile = function ()
	{
		if (this.isMessageType())
		{
			this.viewMessageFile();
		}
		else
		{
			this.viewCommonFile();
		}
	};

	/**
	 * Starts viewing attachment on click.
	 */
	CAttachmentModel.prototype.viewMessageFile = function ()
	{
		var
			oWin = null,
			sLoadingText = '<div style="margin: 30px; text-align: center; font: normal 14px Tahoma;">' + 
				TextUtils.i18n('COREWEBCLIENT/INFO_LOADING') + '</div>'
		;
		
		oWin = WindowOpener.open('', this.fileName());
		if (oWin)
		{
			if (this.messagePart())
			{
				this.messagePart().viewMessage(oWin);
			}
			else
			{
				$(oWin.document.body).html(sLoadingText);
				this.oNewWindow = oWin;

				Ajax.send('GetMessage', {
					'Folder': this.folderName(),
					'Uid': this.messageUid(),
					'Rfc822MimeIndex': this.mimePartIndex()
				}, this.onGetMessageResponse, this);
			}
			
			oWin.focus();
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {string} sFileUid
	 */
	CAttachmentModel.prototype.fillDataAfterUploadComplete = function (oResponse, sFileUid)
	{
		this.cid(Types.pString(sFileUid));
		if (oResponse && oResponse.Result && oResponse.Result.Attachment)
		{
			this.tempName(Types.pString(oResponse.Result.Attachment.TempName));
			this.mimeType(Types.pString(oResponse.Result.Attachment.MimeType));
			this.size(Types.pInt(oResponse.Result.Attachment.Size));
			this.hash(Types.pString(oResponse.Result.Attachment.Hash));
			this.parseActions(oResponse.Result.Attachment);
		}
	};

	/**
	 * Parses contact attachment data from server.
	 *
	 * @param {Object} oData
	 * @param {string} sMessageFolder
	 * @param {string} sMessageUid
	 */
	CAttachmentModel.prototype.parseFromUpload = function (oData, sMessageFolder, sMessageUid)
	{
		this.setMessageData(sMessageFolder, sMessageUid);

		this.fileName(Types.pString(oData.Name));
		this.tempName(oData.TempName ? Types.pString(oData.TempName) : this.fileName());
		this.mimeType(Types.pString(oData.MimeType));
		this.size(Types.pInt(oData.Size));

		this.hash(Types.pString(oData.Hash));
		this.parseActions(oData);

		this.uploadUid(this.hash());
		this.uploaded(true);
		
		this.uploadStarted(false);
	};

	CAttachmentModel.prototype.parseActions = function (oData)
	{
		this.commonParseActions(oData);
		
		if (this.isMessageType())
		{
			if (this.folderName() !== '' && this.messageUid() !== '')
			{
				if (!this.hasAction('view'))
				{
					this.actions.unshift('view');
				}
				this.otherTemplates.push({
					name: 'MailWebclient_PrintMessageView',
					data: this.messagePart
				});
			}
			else
			{
				this.actions(_.without(this.actions(), 'view'));
			}
		}
		
		App.broadcastEvent('MailWebclient::ParseFile::after', this);
	};

	CAttachmentModel.prototype.errorFromUpload = function ()
	{
		this.uploaded(true);
		this.uploadError(true);
		this.uploadStarted(false);
		this.statusText(TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_UNKNOWN'));
	};

	module.exports = CAttachmentModel;


/***/ }),

/***/ 423:
/*!***********************************************************!*\
  !*** ./modules/MailWebclient/js/views/CHtmlEditorView.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178),
		CJua = __webpack_require__(/*! modules/CoreWebclient/js/CJua.js */ 264),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		AlertPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/AlertPopup.js */ 188),
		
		CAttachmentModel = __webpack_require__(/*! modules/MailWebclient/js/models/CAttachmentModel.js */ 422),
		CCrea = __webpack_require__(/*! modules/MailWebclient/js/CCrea.js */ 424),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CColorPickerView = __webpack_require__(/*! modules/MailWebclient/js/views/CColorPickerView.js */ 425)
	;

	/**
	 * @constructor
	 * @param {boolean} bInsertImageAsBase64
	 * @param {Object=} oParent
	 */
	function CHtmlEditorView(bInsertImageAsBase64, oParent)
	{
		this.oParent = oParent;
		
		this.creaId = 'creaId' + Math.random().toString().replace('.', '');
		this.textFocused = ko.observable(false);
		this.workareaDom = ko.observable();
		this.uploaderAreaDom = ko.observable();
		this.editorUploaderBodyDragOver = ko.observable(false);
		
		this.htmlEditorDom = ko.observable();
		this.toolbarDom = ko.observable();
		this.colorPickerDropdownDom = ko.observable();
		this.insertLinkDropdownDom = ko.observable();
		this.insertImageDropdownDom = ko.observable();

	    this.isFWBold = ko.observable(false);
	    this.isFSItalic = ko.observable(false);
	    this.isTDUnderline = ko.observable(false);
	    this.isTDStrikeThrough = ko.observable(false);
	    this.isEnumeration = ko.observable(false);
	    this.isBullets = ko.observable(false);

		this.isEnable = ko.observable(true);
		this.isEnable.subscribe(function () {
			if (this.oCrea)
			{
				this.oCrea.setEditable(this.isEnable());
			}
		}, this);

		this.bInsertImageAsBase64 = bInsertImageAsBase64;
		this.bAllowFileUpload = !(bInsertImageAsBase64 && window.File === undefined);
		this.bAllowInsertImage = Settings.AllowInsertImage;
		this.lockFontSubscribing = ko.observable(false);
		this.bAllowImageDragAndDrop = !Browser.ie10AndAbove;

		this.aFonts = ['Arial', 'Arial Black', 'Courier New', 'Tahoma', 'Times New Roman', 'Verdana'];
		this.sDefaultFont = Settings.DefaultFontName;
		this.correctFontFromSettings();
		this.selectedFont = ko.observable('');
		this.selectedFont.subscribe(function () {
			if (this.oCrea && !this.lockFontSubscribing() && !this.inactive())
			{
				this.oCrea.fontName(this.selectedFont());
			}
		}, this);

		this.iDefaultSize = Settings.DefaultFontSize;
		this.selectedSize = ko.observable(0);
		this.selectedSize.subscribe(function () {
			if (this.oCrea && !this.lockFontSubscribing() && !this.inactive())
			{
				this.oCrea.fontSize(this.selectedSize());
			}
		}, this);

		this.visibleInsertLinkPopup = ko.observable(false);
		this.linkForInsert = ko.observable('');
		this.linkFocused = ko.observable(false);
		this.visibleLinkPopup = ko.observable(false);
		this.linkPopupDom = ko.observable(null);
		this.linkHrefDom = ko.observable(null);
		this.linkHref = ko.observable('');
		this.visibleLinkHref = ko.observable(false);

		this.visibleImagePopup = ko.observable(false);
		this.visibleImagePopup.subscribe(function () {
			this.onImageOut();
		}, this);
		this.imagePopupTop = ko.observable(0);
		this.imagePopupLeft = ko.observable(0);
		this.imageSelected = ko.observable(false);
		
		this.tooltipText = ko.observable('');
		this.tooltipPopupTop = ko.observable(0);
		this.tooltipPopupLeft = ko.observable(0);

		this.visibleInsertImagePopup = ko.observable(false);
		this.imageUploaderButton = ko.observable(null);
		this.aUploadedImagesData = [];
		this.imagePathFromWeb = ko.observable('');

		this.visibleFontColorPopup = ko.observable(false);
		this.oFontColorPickerView = new CColorPickerView(TextUtils.i18n('MAILWEBCLIENT/LABEL_TEXT_COLOR'), this.setTextColorFromPopup, this);
		this.oBackColorPickerView = new CColorPickerView(TextUtils.i18n('MAILWEBCLIENT/LABEL_BACKGROUND_COLOR'), this.setBackColorFromPopup, this);

		this.inactive = ko.observable(false);
		this.sPlaceholderText = '';
		
		this.bAllowChangeInputDirection = UserSettings.IsRTL || Settings.AllowChangeInputDirection;
		this.disableEdit = ko.observable(false);
		
		this.textChanged = ko.observable(false);
	}

	CHtmlEditorView.prototype.ViewTemplate = 'MailWebclient_HtmlEditorView';

	CHtmlEditorView.prototype.setInactive = function (bInactive)
	{
		this.inactive(bInactive);
		if (this.inactive())
		{
			this.setPlaceholder();
		}
		else
		{
			this.removePlaceholder();
		}
	};

	CHtmlEditorView.prototype.setPlaceholder = function ()
	{
		var sText = this.removeAllTags(this.getText());
		if (sText === '' || sText === '&nbsp;')
		{
			this.setText('<span>' + this.sPlaceholderText + '</span>');
			if (this.oCrea)
			{
				this.oCrea.setBlur();
			}
		}
	};

	CHtmlEditorView.prototype.removePlaceholder = function ()
	{
		var sText = this.oCrea ? this.removeAllTags(this.oCrea.getText(false)) : '';
		if (sText === this.sPlaceholderText)
		{
			this.setText('');
			if (this.oCrea)
			{
				this.oCrea.setFocus(true);
			}
		}
	};

	CHtmlEditorView.prototype.hasOpenedPopup = function ()
	{
		return this.visibleInsertLinkPopup() || this.visibleLinkPopup() || this.visibleImagePopup() || this.visibleInsertImagePopup() || this.visibleFontColorPopup();
	};
		
	CHtmlEditorView.prototype.setDisableEdit = function (bDisableEdit)
	{
		this.disableEdit(!!bDisableEdit);
	};

	CHtmlEditorView.prototype.correctFontFromSettings = function ()
	{
		var
			sDefaultFont = this.sDefaultFont,
			bFinded = false
		;
		
		_.each(this.aFonts, function (sFont) {
			if (sFont.toLowerCase() === sDefaultFont.toLowerCase())
			{
				sDefaultFont = sFont;
				bFinded = true;
			}
		});
		
		if (bFinded)
		{
			this.sDefaultFont = sDefaultFont;
		}
		else
		{
			this.aFonts.push(sDefaultFont);
		}
	};

	/**
	 * @param {Object} $link
	 */
	CHtmlEditorView.prototype.showLinkPopup = function ($link)
	{
		var
			$workarea = $(this.workareaDom()),
			$composePopup = $workarea.closest('.panel.compose'),
			oWorkareaPos = $workarea.position(),
			oPos = $link.position(),
			iHeight = $link.height(),
			iLeft = Math.round(oPos.left + oWorkareaPos.left),
			iTop = Math.round(oPos.top + iHeight + oWorkareaPos.top)
		;

		this.linkHref($link.attr('href') || $link.text());
		$(this.linkPopupDom()).css({
			'left': iLeft,
			'top': iTop
		});
		$(this.linkHrefDom()).css({
			'left': iLeft,
			'top': iTop
		});
		
		if (!Browser.firefox && $composePopup.length === 1)
		{
			$(this.linkPopupDom()).css({
				'max-width': ($composePopup.width() - iLeft - 40) + 'px',
				'white-space': 'pre-line',
				'word-wrap': 'break-word'
			});
		}
		
		this.visibleLinkPopup(true);
	};

	CHtmlEditorView.prototype.hideLinkPopup = function ()
	{
		this.visibleLinkPopup(false);
	};

	CHtmlEditorView.prototype.showChangeLink = function ()
	{
		this.visibleLinkHref(true);
		this.hideLinkPopup();
	};

	CHtmlEditorView.prototype.changeLink = function ()
	{
		this.oCrea.changeLink(this.linkHref());
		this.hideChangeLink();
	};

	CHtmlEditorView.prototype.hideChangeLink = function ()
	{
		this.visibleLinkHref(false);
	};

	/**
	 * @param {jQuery} $image
	 * @param {Object} oEvent
	 */
	CHtmlEditorView.prototype.showImagePopup = function ($image, oEvent)
	{
		var
			$workarea = $(this.workareaDom()),
			oWorkareaPos = $workarea.position(),
			oWorkareaOffset = $workarea.offset()
		;
		
		this.imagePopupLeft(Math.round(oEvent.pageX + oWorkareaPos.left - oWorkareaOffset.left));
		this.imagePopupTop(Math.round(oEvent.pageY + oWorkareaPos.top - oWorkareaOffset.top));

		this.visibleImagePopup(true);
	};

	CHtmlEditorView.prototype.hideImagePopup = function ()
	{
		this.visibleImagePopup(false);
	};

	CHtmlEditorView.prototype.resizeImage = function (sSize)
	{
		var oParams = {
			'width': 'auto',
			'height': 'auto'
		};
		
		switch (sSize)
		{
			case Enums.HtmlEditorImageSizes.Small:
				oParams.width = '300px';
				break;
			case Enums.HtmlEditorImageSizes.Medium:
				oParams.width = '600px';
				break;
			case Enums.HtmlEditorImageSizes.Large:
				oParams.width = '1200px';
				break;
			case Enums.HtmlEditorImageSizes.Original:
				oParams.width = 'auto';
				break;
		}
		
		this.oCrea.changeCurrentImage(oParams);
		
		this.visibleImagePopup(false);
	};

	CHtmlEditorView.prototype.onImageOver = function (oEvent)
	{
		if (oEvent.target.nodeName === 'IMG' && !this.visibleImagePopup())
		{
			this.imageSelected(true);
			
			this.tooltipText(TextUtils.i18n('MAILWEBCLIENT/ACTION_CLICK_TO_EDIT_IMAGE'));
			
			var 
				self = this,
				$workarea = $(this.workareaDom())
			;
			
			$workarea.bind('mousemove.image', function (oEvent) {

				var
					oWorkareaPos = $workarea.position(),
					oWorkareaOffset = $workarea.offset()
				;

				self.tooltipPopupTop(Math.round(oEvent.pageY + oWorkareaPos.top - oWorkareaOffset.top));
				self.tooltipPopupLeft(Math.round(oEvent.pageX + oWorkareaPos.left - oWorkareaOffset.left));
			});
		}
		
		return true;
	};

	CHtmlEditorView.prototype.onImageOut = function (oEvent)
	{
		if (this.imageSelected())
		{
			this.imageSelected(false);
			
			var $workarea = $(this.workareaDom());
			$workarea.unbind('mousemove.image');
		}
		
		return true;
	};

	CHtmlEditorView.prototype.commit = function ()
	{
		this.textChanged(false);
	};

	/**
	 * @param {string} sText
	 * @param {boolean} bPlain
	 * @param {string} sTabIndex
	 * @param {string} sPlaceholderText
	 */
	CHtmlEditorView.prototype.init = function (sText, bPlain, sTabIndex, sPlaceholderText)
	{
		this.sPlaceholderText = sPlaceholderText || '';
		
		if (this.oCrea)
		{
			this.oCrea.$container = $('#' + this.oCrea.oOptions.creaId);
			// in case if knockoutjs destroyed dom element with html editor
			if (this.oCrea.$container.children().length === 0)
			{
				this.oCrea.start(this.isEnable());
			}
		}
		else
		{
			$(document.body).on('click', _.bind(function (oEvent) {
				var oParent = $(oEvent.target).parents('span.dropdown_helper');
				if (oParent.length === 0)
				{
					this.closeAllPopups(true);
				}
			}, this));

			this.initEditorUploader();
			
			this.oCrea = new CCrea({
				'creaId': this.creaId,
				'fontNameArray': this.aFonts,
				'defaultFontName': this.sDefaultFont,
				'defaultFontSize': this.iDefaultSize,
				'isRtl': UserSettings.IsRTL,
				'enableDrop': false,
				'onChange': _.bind(this.textChanged, this, true),
				'onCursorMove': _.bind(this.setFontValuesFromText, this),
				'onFocus': _.bind(this.onCreaFocus, this),
				'onBlur': _.bind(this.onCreaBlur, this),
				'onUrlIn': _.bind(this.showLinkPopup, this),
				'onUrlOut': _.bind(this.hideLinkPopup, this),
				'onImageSelect': _.bind(this.showImagePopup, this),
				'onImageBlur': _.bind(this.hideImagePopup, this),
				'onItemOver': (Browser.mobileDevice || App.isMobile()) ? null : _.bind(this.onImageOver, this),
				'onItemOut': (Browser.mobileDevice || App.isMobile()) ? null : _.bind(this.onImageOut, this),
				'openInsertLinkDialog': _.bind(this.insertLink, this),
				'onUrlClicked': true
			});
			this.oCrea.start(this.isEnable());
		}

		this.oCrea.setTabIndex(sTabIndex);
		this.clearUndoRedo();
		this.setText(sText, bPlain);
		this.setFontValuesFromText();
		this.aUploadedImagesData = [];
		this.selectedFont(this.sDefaultFont);
		this.selectedSize(this.iDefaultSize);
	};

	CHtmlEditorView.prototype.isInitialized = function ()
	{
		return !!this.oCrea;
	};

	CHtmlEditorView.prototype.setFocus = function ()
	{
		if (this.oCrea)
		{
			this.oCrea.setFocus(false);
		}
	};

	/**
	 * @param {string} sNewSignatureContent
	 * @param {string} sOldSignatureContent
	 */
	CHtmlEditorView.prototype.changeSignatureContent = function (sNewSignatureContent, sOldSignatureContent)
	{
		if (this.oCrea)
		{
			this.oCrea.changeSignatureContent(sNewSignatureContent, sOldSignatureContent);
		}
	};

	CHtmlEditorView.prototype.setFontValuesFromText = function ()
	{
		this.lockFontSubscribing(true);
	    this.isFWBold(this.oCrea.getIsBold());
	    this.isFSItalic(this.oCrea.getIsItalic());
	    this.isTDUnderline(this.oCrea.getIsUnderline());
	    this.isTDStrikeThrough(this.oCrea.getIsStrikeThrough());
	    this.isEnumeration(this.oCrea.getIsEnumeration());
	    this.isBullets(this.oCrea.getIsBullets());
		this.selectedFont(this.oCrea.getFontName());
		this.selectedSize(this.oCrea.getFontSizeInNumber().toString());
		this.lockFontSubscribing(false);
	};

	CHtmlEditorView.prototype.isUndoAvailable = function ()
	{
		if (this.oCrea)
		{
			return this.oCrea.isUndoAvailable();
		}

		return false;
	};

	CHtmlEditorView.prototype.getPlainText = function ()
	{
		if (this.oCrea)
		{
			return this.oCrea.getPlainText();
		}

		return '';
	};

	/**
	 * @param {boolean=} bRemoveSignatureAnchor = false
	 */
	CHtmlEditorView.prototype.getText = function (bRemoveSignatureAnchor)
	{
		var
			sText = this.oCrea ? this.oCrea.getText(bRemoveSignatureAnchor) : ''
		;
		return (this.sPlaceholderText !== '' && this.removeAllTags(sText) === this.sPlaceholderText) ? '' : sText;
	};

	/**
	 * @param {string} sText
	 * @param {boolean} bPlain
	 */
	CHtmlEditorView.prototype.setText = function (sText, bPlain)
	{
		if (this.oCrea)
		{
			if (bPlain)
			{
				this.oCrea.setPlainText(sText);
			}
			else
			{
				this.oCrea.setText(sText);
			}
			if (this.inactive() && sText === '')
			{
				this.setPlaceholder();
			}
		}
	};

	CHtmlEditorView.prototype.undoAndClearRedo = function ()
	{
		if (this.oCrea)
		{
			this.oCrea.undo();
			this.oCrea.clearRedo();
		}
	};

	CHtmlEditorView.prototype.clearUndoRedo = function ()
	{
		if (this.oCrea)
		{
			this.oCrea.clearUndoRedo();
		}
	};

	CHtmlEditorView.prototype.isEditing = function ()
	{
		return this.oCrea ? this.oCrea.bEditing : false;
	};

	/**
	 * @param {string} sText
	 */
	CHtmlEditorView.prototype.removeAllTags = function (sText)
	{
		return sText.replace(/<style>.*<\/style>/g, '').replace(/<[^>]*>/g, '');
	};

	CHtmlEditorView.prototype.onCreaFocus = function ()
	{
		if (this.oCrea)
		{
			this.closeAllPopups();
			this.textFocused(true);
		}
	};

	CHtmlEditorView.prototype.onCreaBlur = function ()
	{
		if (this.oCrea)
		{
			this.textFocused(false);
		}
	};

	CHtmlEditorView.prototype.onEscHandler = function ()
	{
		if (!Popups.hasOpenedMaximizedPopups())
		{
			this.closeAllPopups();
		}
	};

	/**
	 * @param {boolean} bWithoutLinkPopup
	 */
	CHtmlEditorView.prototype.closeAllPopups = function (bWithoutLinkPopup)
	{
		bWithoutLinkPopup = !!bWithoutLinkPopup;
		if (!bWithoutLinkPopup)
		{
			this.visibleLinkPopup(false);
		}
		this.visibleInsertLinkPopup(false);
		this.visibleImagePopup(false);
		this.visibleInsertImagePopup(false);
		this.visibleFontColorPopup(false);
	};

	/**
	 * @param {string} sHtml
	 */
	CHtmlEditorView.prototype.insertHtml = function (sHtml)
	{
		if (this.oCrea)
		{
			if (!this.oCrea.isFocused())
			{
				this.oCrea.setFocus(true);
			}
			
			this.oCrea.insertHtml(sHtml, false);
		}
	};

	/**
	 * @param {Object} oViewModel
	 * @param {Object} oEvent
	 */

	CHtmlEditorView.prototype.insertLink = function (oViewModel, oEvent)
	{
		if (!this.inactive() && !this.visibleInsertLinkPopup())
		{
			oEvent.stopPropagation();
			this.linkForInsert(this.oCrea.getSelectedText());
			this.closeAllPopups();
			this.visibleInsertLinkPopup(true);
			this.linkFocused(true);
		}
	};

	/**
	 * @param {Object} oCurrentViewModel
	 * @param {Object} event
	 */
	CHtmlEditorView.prototype.insertLinkFromPopup = function (oCurrentViewModel, event)
	{
		if (this.linkForInsert().length > 0)
		{
			if (AddressUtils.isCorrectEmail(this.linkForInsert()))
			{
				this.oCrea.insertEmailLink(this.linkForInsert());
			}
			else
			{
				this.oCrea.insertLink(this.linkForInsert());
			}
		}
		
		this.closeInsertLinkPopup(oCurrentViewModel, event);
	};

	/**
	 * @param {Object} oCurrentViewModel
	 * @param {Object} event
	 */
	CHtmlEditorView.prototype.closeInsertLinkPopup = function (oCurrentViewModel, event)
	{
		this.visibleInsertLinkPopup(false);
		if (event)
		{
			event.stopPropagation();
		}
	};

	CHtmlEditorView.prototype.textColor = function (oViewModel, oEvent)
	{
		if (!this.inactive())
		{
			this.closeAllPopups();
			if (!this.visibleFontColorPopup())
			{
				oEvent.stopPropagation();
				this.visibleFontColorPopup(true);
				this.oFontColorPickerView.onShow();
				this.oBackColorPickerView.onShow();
			}
		}
	};

	/**
	 * @param {string} sColor
	 * @return string
	 */
	CHtmlEditorView.prototype.colorToHex = function (sColor)
	{
		if (sColor.substr(0, 1) === '#')
		{
			return sColor;
		}

		/*jslint bitwise: true*/
		var
			aDigits = /(.*?)rgb\((\d+), (\d+), (\d+)\)/.exec(sColor),
			iRed = Types.pInt(aDigits[2]),
			iGreen = Types.pInt(aDigits[3]),
			iBlue = Types.pInt(aDigits[4]),
			iRgb = iBlue | (iGreen << 8) | (iRed << 16),
			sRgb = iRgb.toString(16)
		;
		/*jslint bitwise: false*/

		while (sRgb.length < 6)
		{
			sRgb = '0' + sRgb;
		}

		return aDigits[1] + '#' + sRgb;
	};

	/**
	 * @param {string} sColor
	 */
	CHtmlEditorView.prototype.setTextColorFromPopup = function (sColor)
	{
		this.oCrea.textColor(this.colorToHex(sColor));
		this.closeAllPopups();
	};

	/**
	 * @param {string} sColor
	 */
	CHtmlEditorView.prototype.setBackColorFromPopup = function (sColor)
	{
		this.oCrea.backgroundColor(this.colorToHex(sColor));
		this.closeAllPopups();
	};

	CHtmlEditorView.prototype.insertImage = function (oViewModel, oEvent)
	{
		if (!this.inactive() && Settings.AllowInsertImage && !this.visibleInsertImagePopup())
		{
			oEvent.stopPropagation();
			this.imagePathFromWeb('');
			this.closeAllPopups();
			this.visibleInsertImagePopup(true);
			this.initUploader();
		}

		return true;
	};

	/**
	 * @param {Object} oCurrentViewModel
	 * @param {Object} event
	 */
	CHtmlEditorView.prototype.insertWebImageFromPopup = function (oCurrentViewModel, event)
	{
		if (Settings.AllowInsertImage && this.imagePathFromWeb().length > 0)
		{
			this.oCrea.insertImage(this.imagePathFromWeb());
		}

		this.closeInsertImagePopup(oCurrentViewModel, event);
	};

	/**
	 * @param {string} sUid
	 * @param oAttachmentData
	 */
	CHtmlEditorView.prototype.insertComputerImageFromPopup = function (sUid, oAttachmentData)
	{
		var
			oAttachment = new CAttachmentModel(),
			sViewLink = '',
			bResult = false
		;
		
		oAttachment.parse(oAttachmentData);
		sViewLink = oAttachment.getActionUrl('view');
		
		if (Settings.AllowInsertImage && sViewLink.length > 0)
		{
			bResult = this.oCrea.insertImage(sViewLink);
			if (bResult)
			{
				$(this.oCrea.$editableArea)
					.find('img[src="' + sViewLink + '"]')
					.attr('data-x-src-cid', sUid)
				;

				oAttachmentData.CID = sUid;
				this.aUploadedImagesData.push(oAttachmentData);
			}
		}

		this.closeInsertImagePopup();
	};

	CHtmlEditorView.prototype.getUploadedImagesData = function ()
	{
		return this.aUploadedImagesData;
	};

	/**
	 * @param {?=} oCurrentViewModel
	 * @param {?=} event
	 */
	CHtmlEditorView.prototype.closeInsertImagePopup = function (oCurrentViewModel, event)
	{
		this.visibleInsertImagePopup(false);
		if (event)
		{
			event.stopPropagation();
		}
	};

	/**
	 * Initializes file uploader.
	 */
	CHtmlEditorView.prototype.initUploader = function ()
	{
		if (this.imageUploaderButton() && !this.oJua)
		{
			this.oJua = new CJua({
				'action': '?/Api/',
				'name': 'jua-uploader',
				'queueSize': 2,
				'clickElement': this.imageUploaderButton(),
				'hiddenElementsPosition': UserSettings.IsRTL ? 'right' : 'left',
				'disableMultiple': true,
				'disableAjaxUpload': false,
				'disableDragAndDrop': true,
				'hidden': _.extendOwn({
					'Module': Settings.ServerModuleName,
					'Method': 'UploadAttachment',
					'Parameters':  function () {
						return JSON.stringify({
							'AccountID': MailCache.currentAccountId()
						});
					}
				}, App.getCommonRequestParameters())
			});

			if (this.bInsertImageAsBase64)
			{
				this.oJua
					.on('onSelect', _.bind(this.onEditorDrop, this))
				;
			}
			else
			{
				this.oJua
					.on('onSelect', _.bind(this.onFileUploadSelect, this))
					.on('onComplete', _.bind(this.onFileUploadComplete, this))
				;
			}
		}
	};

	/**
	 * Initializes file uploader for editor.
	 */
	CHtmlEditorView.prototype.initEditorUploader = function ()
	{
		if (Settings.AllowInsertImage && this.uploaderAreaDom() && !this.editorUploader)
		{
			var
				fBodyDragEnter = null,
				fBodyDragOver = null
			;

			if (this.oParent && this.oParent.composeUploaderDragOver && this.oParent.onFileUploadProgress &&
					this.oParent.onFileUploadStart && this.oParent.onFileUploadComplete)
			{
				fBodyDragEnter = _.bind(function () {
					this.editorUploaderBodyDragOver(true);
					this.oParent.composeUploaderDragOver(true);
				}, this);

				fBodyDragOver = _.bind(function () {
					this.editorUploaderBodyDragOver(false);
					this.oParent.composeUploaderDragOver(false);
				}, this);

				this.editorUploader = new CJua({
					'action': '?/Api/',
					'name': 'jua-uploader',
					'queueSize': 1,
					'dragAndDropElement': this.bAllowImageDragAndDrop ? this.uploaderAreaDom() : null,
					'disableMultiple': true,
					'disableAjaxUpload': false,
					'disableDragAndDrop': !this.bAllowImageDragAndDrop,
					'hidden': _.extendOwn({
						'Module': Settings.ServerModuleName,
						'Method': 'UploadAttachment',
						'Parameters':  function () {
							return JSON.stringify({
								'AccountID': MailCache.currentAccountId()
							});
						}
					}, App.getCommonRequestParameters())
				});

				this.editorUploader
					.on('onDragEnter', _.bind(this.oParent.composeUploaderDragOver, this.oParent, true))
					.on('onDragLeave', _.bind(this.oParent.composeUploaderDragOver, this.oParent, false))
					.on('onBodyDragEnter', fBodyDragEnter)
					.on('onBodyDragLeave', fBodyDragOver)
					.on('onProgress', _.bind(this.oParent.onFileUploadProgress, this.oParent))
					.on('onSelect', _.bind(this.onEditorDrop, this))
					.on('onStart', _.bind(this.oParent.onFileUploadStart, this.oParent))
					.on('onComplete', _.bind(this.oParent.onFileUploadComplete, this.oParent))
				;
			}
			else
			{
				fBodyDragEnter = _.bind(this.editorUploaderBodyDragOver, this, true);
				fBodyDragOver = _.bind(this.editorUploaderBodyDragOver, this, false);

				this.editorUploader = new CJua({
					'queueSize': 1,
					'dragAndDropElement': this.bAllowImageDragAndDrop ? this.uploaderAreaDom() : null,
					'disableMultiple': true,
					'disableAjaxUpload': false,
					'disableDragAndDrop': !this.bAllowImageDragAndDrop
				});

				this.editorUploader
					.on('onBodyDragEnter', fBodyDragEnter)
					.on('onBodyDragLeave', fBodyDragOver)
					.on('onSelect', _.bind(this.onEditorDrop, this))
				;
			}
		}
	};

	CHtmlEditorView.prototype.isDragAndDropSupported = function ()
	{
		return this.editorUploader ? this.editorUploader.isDragAndDropSupported() : false;
	};

	CHtmlEditorView.prototype.onEditorDrop = function (sUid, oData) {
		var 
			oReader = null,
			oFile = null,
			self = this,
			bCreaFocused = false,
			hash = Math.random().toString(),
			sId = ''
		;
		
		if (oData && oData.File && (typeof oData.File.type === 'string'))
		{
			if (Settings.AllowInsertImage && 0 === oData.File.type.indexOf('image/'))
			{
				oFile = oData.File;
				if (Settings.ImageUploadSizeLimit > 0 && oFile.size > Settings.ImageUploadSizeLimit)
				{
					Popups.showPopup(AlertPopup, [TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_SIZE')]);
				}
				else
				{
					oReader = new window.FileReader();
					bCreaFocused = this.oCrea.isFocused();
					if (!bCreaFocused)
					{
						this.oCrea.setFocus(true);
					}

					sId = oFile.name + '_' + hash;
					this.oCrea.insertHtml('<img id="' + sId + '" src="./static/styles/images/wait.gif" />', true);
					if (!bCreaFocused)
					{
						this.oCrea.fixFirefoxCursorBug();
					}

					oReader.onload = function (oEvent) {
						self.oCrea.changeImageSource(sId, oEvent.target.result);
					};

					oReader.readAsDataURL(oFile);
				}
			}
			else
			{
				if (this.oParent && this.oParent.onFileUploadSelect)
				{
					this.oParent.onFileUploadSelect(sUid, oData);
					return true;
				}
				else if (!Browser.ie10AndAbove)
				{
					Popups.showPopup(AlertPopup, [TextUtils.i18n('MAILWEBCLIENT/ERROR_NOT_IMAGE_CHOOSEN')]);
				}
			}
		}
		
		return false;
	};

	/**
	 * @param {Object} oFile
	 */
	CHtmlEditorView.prototype.isFileImage = function (oFile)
	{
		if (typeof oFile.Type === 'string')
		{
			return (-1 !== oFile.Type.indexOf('image'));
		}
		else
		{
			var
				iDotPos = oFile.FileName.lastIndexOf('.'),
				sExt = oFile.FileName.substr(iDotPos + 1),
				aImageExt = ['jpg', 'jpeg', 'gif', 'tif', 'tiff', 'png']
			;

			return (-1 !== $.inArray(sExt, aImageExt));
		}
	};

	/**
	 * @param {string} sUid
	 * @param {Object} oFile
	 */
	CHtmlEditorView.prototype.onFileUploadSelect = function (sUid, oFile)
	{
		if (!this.isFileImage(oFile))
		{
			Popups.showPopup(AlertPopup, [TextUtils.i18n('MAILWEBCLIENT/ERROR_NOT_IMAGE_CHOOSEN')]);
			return false;
		}
		
		this.closeInsertImagePopup();
		return true;
	};

	/**
	 * @param {string} sUid
	 * @param {boolean} bResponseReceived
	 * @param {Object} oData
	 */
	CHtmlEditorView.prototype.onFileUploadComplete = function (sUid, bResponseReceived, oData)
	{
		var sError = '';
		
		if (oData && oData.Result)
		{
			if (oData.Result.Error)
			{
				sError = oData.Result.Error === 'size' ?
					TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_SIZE') :
					TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_UNKNOWN');

				Popups.showPopup(AlertPopup, [sError]);
			}
			else
			{
				this.oCrea.setFocus(true);
				this.insertComputerImageFromPopup(sUid, oData.Result.Attachment);
			}
		}
		else
		{
			Popups.showPopup(AlertPopup, [TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_UNKNOWN')]);
		}
	};

	CHtmlEditorView.prototype.undo = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.undo();
		}
		return false;
	};

	CHtmlEditorView.prototype.redo = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.redo();
		}
		return false;
	};

	CHtmlEditorView.prototype.bold = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.bold();
			this.isFWBold(!this.isFWBold());
		}
		return false;
	};

	CHtmlEditorView.prototype.italic = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.italic();
			this.isFSItalic(!this.isFSItalic());
		}
		return false;
	};

	CHtmlEditorView.prototype.underline = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.underline();
			this.isTDUnderline(!this.isTDUnderline());
		}
		return false;
	};

	CHtmlEditorView.prototype.strikeThrough = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.strikeThrough();
			this.isTDStrikeThrough(!this.isTDStrikeThrough());
		}
		return false;
	};

	CHtmlEditorView.prototype.numbering = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.numbering();
	        this.isBullets(false);
	        this.isEnumeration(!this.isEnumeration());
		}
	    return false;
	};

	CHtmlEditorView.prototype.bullets = function ()
	{
	    if (!this.inactive())
		{
	        this.oCrea.bullets();
	        this.isEnumeration(false);
	        this.isBullets(!this.isBullets());
	    }
		return false;
	};

	CHtmlEditorView.prototype.removeFormat = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.removeFormat();
		}
		return false;
	};

	CHtmlEditorView.prototype.setRtlDirection = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.setRtlDirection();
		}
		return false;
	};

	CHtmlEditorView.prototype.setLtrDirection = function ()
	{
		if (!this.inactive())
		{
			this.oCrea.setLtrDirection();
		}
		return false;
	};

	module.exports = CHtmlEditorView;


/***/ }),

/***/ 424:
/*!*******************************************!*\
  !*** ./modules/MailWebclient/js/CCrea.js ***!
  \*******************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
	    _ = __webpack_require__(/*! underscore */ 2),
	    $ = __webpack_require__(/*! jquery */ 1),

	    Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),

	    Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178)
	;

	/**
	 * @constructor
	 *
	 * @param {Object} oOptions
	 */
	function CCrea(oOptions)
	{
	    this.oOptions = _.extend({
	        'creaId': 'creaId',
	        'fontNameArray': ['Tahoma'],
	        'defaultFontName': 'Tahoma',
	        'defaultFontSize': 3,
	        'dropableArea': null,
	        'isRtl': false,
	        'onChange': function () {},
	        'onCursorMove': function () {},
	        'onFocus': function () {},
	        'onBlur': function () {},
	        'onUrlIn': function () {},
	        'onUrlOut': function () {},
	        'onImageSelect': function () {},
	        'onImageBlur': function () {},
	        'onItemOver':  null,
	        'onItemOut':  null,
	        'openInsertLinkDialog':  function () {},
	        'onUrlClicked': false
	    }, (typeof oOptions === 'undefined') ? {} : oOptions);
	}

	/**
	 * @type {Object}
	 */
	CCrea.prototype.oOptions = {};

	/**
	 * @type {Object}
	 */
	CCrea.prototype.$container = null;

	/**
	 * @type {Object}
	 */
	CCrea.prototype.$editableArea = null;

	CCrea.prototype.aEditableAreaHtml = [];

	CCrea.prototype.iUndoRedoPosition = 0;

	CCrea.prototype.bEditable = false;

	CCrea.prototype.bFocused = false;

	CCrea.prototype.bEditing = false;

	/**
	 * @type {Array}
	 */
	CCrea.prototype.aSizes = [
	    {inNumber: 1, inPixels: 10},
	    {inNumber: 2, inPixels: 13},
	    {inNumber: 3, inPixels: 16},
	    {inNumber: 4, inPixels: 18},
	    {inNumber: 5, inPixels: 24},
	    {inNumber: 6, inPixels: 32},
	    {inNumber: 7, inPixels: 48}
	];

	CCrea.prototype.bInUrl = false;

	CCrea.prototype.oCurrLink = null;

	CCrea.prototype.oCurrImage = null;

	CCrea.prototype.bInImage = false;

	CCrea.prototype.sBasicFontName = '';
	CCrea.prototype.sBasicFontSize = '';
	CCrea.prototype.sBasicDirection = '';

	/**
	 * Creates editable area.
	 *
	 * @param {boolean} bEditable
	 */
	CCrea.prototype.start = function (bEditable)
	{
	    function isValidURL(sUrl)
	    {
	        var oRegExp = /^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/;

	        return oRegExp.test(sUrl);
	    }

	    function isCorrectEmail(sValue)
	    {
	        return !!(sValue.match(/^[A-Z0-9\"!#\$%\^\{\}`~&'\+\-=_\.]+@[A-Z0-9\.\-]+$/i));
	    }

	    this.$container = $('#' + this.oOptions.creaId);
	    this.$editableArea = $('<div></div>').addClass('crea-content-editable')
	        .prop('contentEditable', 'true').appendTo(this.$container);

	    var self = this;

	    this.$editableArea.on('focus', function () {
	        self.bFocused = true;
	    });
	    this.$editableArea.on('blur', function () {
	        self.bFocused = false;
	        //self.editableSave(); //Undo/Redo fix
	    });

	    this.$editableArea.on('click', 'img', function (ev) {
	        var oImage = $(this);
	        self.bInImage = true;
	        self.oCurrImage = oImage;
	        self.oOptions.onImageSelect(oImage, ev);
	        ev.stopPropagation();
	    });
	    this.$editableArea.on('click', function (ev) {
	        self.bInImage = false;
	        self.oCurrImage = null;
	        self.oOptions.onImageBlur();
	    });

	    if (self.oOptions.onItemOver !== null)
	    {
	        this.$editableArea.on('mouseover', function (ev) {
	            self.oOptions.onItemOver(ev);
	        });
	    }
	    if (self.oOptions.onItemOver !== null)
	    {
	        this.$editableArea.on('mouseout', function (ev) {
	            self.oOptions.onItemOut(ev);
	        });
	    }

	    this.$editableArea.on('cut paste', function () {
	        self.bEditing = true;
	        self.editableSave();
	        _.defer(function () {
	            self.editableSave();
	        });
	    });
	    this.$editableArea.on('paste', function (oEvent) {
	        oEvent = oEvent.originalEvent || oEvent;

	        if (oEvent.clipboardData)
	        {
	            var
	                sText = oEvent.clipboardData.getData('text/plain'),
	                sHtml = oEvent.clipboardData.getData('text/html'),
	                aHtml
	            ;

	            if (self.pasteImage(oEvent))
	            {
	                oEvent.preventDefault();
	            }
	            else
	            {
	                if (isValidURL(sText))
	                {
	                    oEvent.preventDefault();
	                    self.execCom('insertHTML', '<a href="' + sText + '">' + sText + '</a>');
	                }
	                else if (isCorrectEmail(sText))
	                {
	                    oEvent.preventDefault();
	                    self.execCom('insertHTML', '<a href="mailto:' + sText + '">' + sText + '</a>');
	                }
	                else if (sHtml !== '')
	                {
	                    oEvent.preventDefault();

	                    aHtml = sHtml.split(/<!--StartFragment-->|<!--EndFragment-->/gi);
	                    if (aHtml.length === 3)
	                    {
	                        sHtml = aHtml[1];
	                    }
	                    sHtml = self.replacePToBr(sHtml);

	                    self.execCom('insertHTML', sHtml);
	                }
	            }
	        }
	    });
	    this.$editableArea.on('keydown', function(oEvent) {
	        var
	            iKey = oEvent.keyCode || oEvent.which || oEvent.charCode || 0,
	            bCtrlKey = oEvent.ctrlKey || oEvent.metaKey,
	            bAltKey =  oEvent.altKey,
	            bShiftKey = oEvent.shiftKey,
	            sLink = ''
	        ;

	        self.bEditing = true;

	        if((bShiftKey && bCtrlKey && iKey === Enums.Key.z) || (bCtrlKey && iKey === Enums.Key.y))
	        {
	            oEvent.preventDefault();

	            self.editableRedo();
	        }
	        else if(bCtrlKey && !bAltKey && iKey === Enums.Key.z)
	        {
	            oEvent.preventDefault();

	            self.editableUndo();
	        }
	        else if (bCtrlKey && (iKey === Enums.Key.k || iKey === Enums.Key.b || iKey === Enums.Key.i || iKey === Enums.Key.u))
	        {
	            oEvent.preventDefault();
	            switch (iKey)
	            {
	                case Enums.Key.k:
	                    sLink = self.getSelectedText();
	                    if (isValidURL(sLink))
	                    {
	                        self.insertLink(sLink);
	                    }
	                    else if (isCorrectEmail(sLink))
	                    {
	                        self.insertLink('mailto:' + sLink);
	                    }
	                    else
	                    {
	                        self.oOptions.openInsertLinkDialog();
	                    }
	                    break;
	                case Enums.Key.b:
	                    self.bold();
	                    break;
	                case Enums.Key.i:
	                    self.italic();
	                    break;
	                case Enums.Key.u:
	                    self.underline();
	                    break;
	            }
	        }
	        else if (!bAltKey && !bShiftKey && !bCtrlKey)
	        {
	            if (iKey === Enums.Key.Del || iKey === Enums.Key.Backspace)
	            {
	                self.editableSave();
	            }
	        }
	    });
	    this.$editableArea.on('keyup', function(oEvent) {
	        var
	            iKey = oEvent.keyCode || oEvent.which || oEvent.charCode || 0,
	            bCtrlKey = oEvent.ctrlKey || oEvent.metaKey,
	            bAltKey =  oEvent.altKey,
	            bShiftKey = oEvent.shiftKey
	        ;
	        if (!bAltKey && !bShiftKey && !bCtrlKey)
	        {
	            if (iKey === Enums.Key.Space || iKey === Enums.Key.Enter || iKey === Enums.Key.Del || iKey === Enums.Key.Backspace)
	            {
	                self.editableSave();
	            }
	            else
	            {
	                self.oOptions.onChange();
	            }
	        }
	    });

	    this.initContentEditable();
	    this.setEditable(bEditable);
	};

	CCrea.prototype.clearUndoRedo = function ()
	{
	    this.aEditableAreaHtml = [];
	    this.iUndoRedoPosition = 0;
	    this.bEditing = false;
	};

	CCrea.prototype.isUndoAvailable = function ()
	{
	    return this.iUndoRedoPosition > 0;
	};

	CCrea.prototype.clearRedo = function ()
	{
	    this.aEditableAreaHtml = this.aEditableAreaHtml.slice(0, this.iUndoRedoPosition + 1);
	};

	CCrea.prototype.editableSave = function ()
	{
	    var
	        sEditableHtml = this.$editableArea.html(),
	        oLastSaved = _.last(this.aEditableAreaHtml),
	        sLastSaved = oLastSaved ? oLastSaved[0] : ''
	    ;
		
	    if (sEditableHtml !== sLastSaved)
	    {
	        this.clearRedo();
	        this.aEditableAreaHtml.push([sEditableHtml, this.getCaretPos(this.$editableArea[0])]);
	        this.iUndoRedoPosition = this.aEditableAreaHtml.length - 1;
	        this.oOptions.onChange();
	    }
	};

	CCrea.prototype.editableUndo = function ()
	{
	    var
	        sEditableHtml = this.$editableArea.html(),
	        oCurrSaved = this.aEditableAreaHtml[this.iUndoRedoPosition],
	        sCurrSaved = oCurrSaved ? oCurrSaved[0] : ''
	    ;
	    if (sEditableHtml !== sCurrSaved)
	    {
	        this.editableSave();
	    }

	    if (this.iUndoRedoPosition > 0)
	    {
	        this.iUndoRedoPosition--;
	        this.$editableArea.html(this.aEditableAreaHtml[this.iUndoRedoPosition]);
	        this.setCaretPos(this.$editableArea[0], this.aEditableAreaHtml[this.iUndoRedoPosition][1]);
	    }
	};

	CCrea.prototype.editableRedo = function ()
	{
	    if (this.iUndoRedoPosition < (this.aEditableAreaHtml.length - 1))
	    {
	        this.iUndoRedoPosition++;
	        this.$editableArea.html(this.aEditableAreaHtml[this.iUndoRedoPosition]);
	        this.setCaretPos(this.$editableArea[0], this.aEditableAreaHtml[this.iUndoRedoPosition] ? this.aEditableAreaHtml[this.iUndoRedoPosition][1] : {});
	    }
	};

	CCrea.prototype.getCaretPos = function (oContainerEl)
	{
	    var
	        oSel = null,
	        oRange = {},
	        oPreSelectionRange = {},
	        iStart = 0,
	        oCaretPos = {}
	    ;

	    if (window.getSelection && document.createRange)
	    {
	        oSel = window.getSelection();
	        if (oSel.rangeCount > 0)
	        {
	            oRange = oSel.getRangeAt(0);
	            oPreSelectionRange = oRange.cloneRange();
	            oPreSelectionRange.selectNodeContents(oContainerEl);
	            oPreSelectionRange.setEnd(oRange.startContainer, oRange.startOffset);
	            iStart = oPreSelectionRange.toString().length;
	            oCaretPos = {
	                start: iStart,
	                end: iStart + oRange.toString().length
	            };
	        }
	    }
	    else if (document.selection && document.body.createTextRange)
	    {
	        oRange = document.selection.createRange();
	        oPreSelectionRange = document.body.createTextRange();
	        oPreSelectionRange.moveToElementText(oContainerEl);
	        if (typeof(oPreSelectionRange.setEndPoint) === 'function')
	        {
	            oPreSelectionRange.setEndPoint("EndToStart", oRange);
	        }
	        iStart = oPreSelectionRange.text.length;
	        oCaretPos = {
	            start: iStart,
	            end: iStart + oRange.text.length
	        };
	    }

	    return oCaretPos;
	};

	CCrea.prototype.setCaretPos = function(oContainerEl, oSavedSel)
	{
	    if (window.getSelection && document.createRange)
	    {
	        var
	            oNodeStack = [oContainerEl],
	            oNode = {},
	            oSel = {},
	            bFoundStart = false,
	            bStop = false,
	            iCharIndex = 0,
	            iNextCharIndex = 0,
	            iChildNodes = 0,
	            oRange = document.createRange()
	        ;

	        oRange.setStart(oContainerEl, 0);
	        oRange.collapse(true);

	        oNode = oNodeStack.pop();

	        while (!bStop && oNode)
	        {
	            if (oNode.nodeType === 3)
	            {
	                iNextCharIndex = iCharIndex + oNode.length;
	                if (!bFoundStart && oSavedSel.start >= iCharIndex && oSavedSel.start <= iNextCharIndex)
	                {
	                    oRange.setStart(oNode, oSavedSel.start - iCharIndex);
	                    bFoundStart = true;
	                }
	                if (bFoundStart && oSavedSel.end >= iCharIndex && oSavedSel.end <= iNextCharIndex)
	                {
	                    oRange.setEnd(oNode, oSavedSel.end - iCharIndex);
	                    bStop = true;
	                }
	                iCharIndex = iNextCharIndex;
	            }
	            else
	            {
	                iChildNodes = oNode.childNodes.length;
	                while (iChildNodes--)
	                {
	                    oNodeStack.push(oNode.childNodes[iChildNodes]);
	                }
	            }
	            oNode = oNodeStack.pop();
	        }

	        oSel = window.getSelection();
	        oSel.removeAllRanges();
	        oSel.addRange(oRange);
	    }
	    else if (document.selection && document.body.createTextRange)
	    {
	        var oTextRange = document.body.createTextRange();

	        oTextRange.moveToElementText(oContainerEl);
	        oTextRange.collapse(true);
	        oTextRange.moveEnd("character", oSavedSel.end);
	        oTextRange.moveStart("character", oSavedSel.start);
	        oTextRange.select();
	    }
	};

	/**
	 * Sets tab index.
	 *
	 * @param {string} sTabIndex
	 */
	CCrea.prototype.setTabIndex = function (sTabIndex)
	{
	    if (sTabIndex)
	    {
	        this.$editableArea.attr('tabindex', sTabIndex);
	    }
	};

	/**
	 * Initializes properties.
	 */
	CCrea.prototype.initContentEditable = function ()
	{
	    this.$editableArea.bind({
	        'mousemove': _.bind(this.storeSelectionPosition, this),
	        'mouseup': _.bind(this.onCursorMove, this),
	        'keydown': _.bind(this.onButtonPressed, this),
	        'keyup': _.bind(this.onCursorMove, this),
	        'click': _.bind(this.onClickWith, this),
	        'focus': this.oOptions.onFocus,
	        'blur': this.oOptions.onBlur
	    });

	    if (window.File && window.FileReader && window.FileList)
	    {
	        if (this.oOptions.enableDrop) {
	            this.$editableArea.bind({
	                'dragover': _.bind(this.onDragOver, this),
	                'dragleave': _.bind(this.onDragLeave, this),
	                'drop': _.bind(this.onFileSelect, this)
	            });
	        }
	    }

	    var self = this,
	        lazyScroll = _.debounce(function () {
	            self.oCurrLink = null;
	            self.bInUrl = false;
	            self.oOptions.onUrlOut();
	        }, 300);
	    $('html, body').on('scroll', lazyScroll);
	};

	/**
	 * Starts cursor move handlers.
	 * @param {Object} ev
	 */
	CCrea.prototype.onCursorMove = function (ev)
	{
	    var iKey = -1;
	    if (window.event)
	    {
	        iKey = window.event.keyCode;
	    }
	    else if (ev)
	    {
	        iKey = ev.which;
	    }

	    if (iKey === 13) // Enter
	    {
	        this.breakQuotes(ev);
	    }

	    if (iKey === 17) // Cntr
	    {
	        this.$editableArea.find('a').css('cursor', 'inherit');
	    }

	    if (iKey === 8) // BackSpace
	    {
	        this.uniteWithNextQuote(ev);
	    }

	    if (iKey === 46 && Browser.chrome) // Delete
	    {
	        this.uniteWithPrevQuote(ev);
	    }


	    this.storeSelectionPosition();
	    this.oOptions.onCursorMove();
	};

	/**
	 * Starts when clicked.
	 * @param {Object} oEvent
	 */
	CCrea.prototype.onClickWith = function (oEvent)
	{
	    if(oEvent.ctrlKey) {
	        if (oEvent.target.nodeName === 'A'){
	            window.open(oEvent.target.href,'_blank');
	        }
	    }
	    this.checkAnchorNode();
	};

	/**
	 * Starts when key pressed.
	 * @param {Object} oEvent
	 */
	CCrea.prototype.onButtonPressed = function (oEvent)
	{
	    var iKey = -1;
	    if (window.event)
	    {
	        iKey = window.event.keyCode;
	    }
	    else if (oEvent)
	    {
	        iKey = oEvent.which;
	    }

	    if (iKey === 17) // Cntr
	    {
	        this.$editableArea.find('a').css('cursor', 'pointer');
	    }
	};

	/**
	 * Starts cursor move handlers.
	 * @param {Object} oEvent
	 */
	CCrea.prototype.onFileSelect = function (oEvent)
	{
	    oEvent = (oEvent && oEvent.originalEvent ?
	            oEvent.originalEvent : oEvent) || window.event;

	    if (oEvent)
	    {
	        oEvent.stopPropagation();
	        oEvent.preventDefault();

	        var
	            oReader = null,
	            oFile = null,
	            aFiles = (oEvent.files || (oEvent.dataTransfer ? oEvent.dataTransfer.files : null)),
	            self = this
	        ;

	        if (aFiles && 1 === aFiles.length && this.checkIsImage(aFiles[0]))
	        {
	            oFile = aFiles[0];

	            oReader = new window.FileReader();
	            oReader.onload = (function () {
	                return function (oEvent) {
	                    self.insertImage(oEvent.target.result);
	                };
	            }());

	            oReader.readAsDataURL(oFile);
	        }
	    }
	};

	CCrea.prototype.onDragLeave = function ()
	{
	    this.$editableArea.removeClass('editorDragOver');
	};

	/**
	 * @param {Object} oEvent
	 */
	CCrea.prototype.onDragOver = function (oEvent)
	{
	    oEvent.stopPropagation();
	    oEvent.preventDefault();

	    this.$editableArea.addClass('editorDragOver');
	};

	/**
	 * @param {Object} oEvent
	 * @returns {Boolean}
	 */
	CCrea.prototype.pasteImage = function (oEvent)
	{
	    var
	        oClipboardItems = oEvent.clipboardData && oEvent.clipboardData.items,
	        self = this,
	        bImagePasted = false
	    ;

	    if (window.File && window.FileReader && window.FileList && oClipboardItems)
	    {
	        _.each(oClipboardItems, function (oItem) {
	            if (self.checkIsImage(oItem) && oItem['getAsFile']) {
	                var
	                    oReader = null,
	                    oFile = oItem['getAsFile']()
	                ;
	                if (oFile)
	                {
	                    oReader = new window.FileReader();
	                    oReader.onload = (function () {
	                        return function (oEvent) {
	                            self.insertImage(oEvent.target.result);
	                        };
	                    }());

	                    oReader.readAsDataURL(oFile);
	                    bImagePasted = true;
	                }
	            }
	        });
	    }

	    return bImagePasted;
	};

	/**
	 * @param {Object} oItem
	 * @return {boolean}
	 */
	CCrea.prototype.checkIsImage = function (oItem)
	{
	    return oItem && oItem.type && 0 === oItem.type.indexOf('image/');
	};

	/**
	 * Sets plain text to rich editor.
	 *
	 * @param {string} sText
	 */
	CCrea.prototype.setPlainText = function (sText)
	{
	    if (typeof sText !== 'string')
	    {
	        sText = '';
	    }

	    if (this.$editableArea)
	    {
	        this.$editableArea.empty().text(sText).css('white-space', 'pre');
	        this.editableSave();
	    }
	};

	/**
	 * Sets text to rich editor.
	 *
	 * @param {string} sText
	 */
	CCrea.prototype.setText = function (sText)
	{
	    if (typeof sText !== 'string')
	    {
	        sText = '';
	    }

	    if (this.$editableArea)
	    {
	        if (sText.length === 0)
	        {
	            sText = '<br />';
	        }

	        var
	            oText = $(sText),
	            oOuter = $(sText),
	            oChildren = oOuter.children(),
	            oInner = oChildren.first(),
	            bOuterWrapper = oOuter.length === 1 && oOuter.data('crea') === 'font-wrapper',
	            bInnerWrapper = oOuter.length === 1 && oChildren.length === 1 &&
	                oOuter.data('xDivType') === 'body' && oInner.data('crea') === 'font-wrapper'
	        ;

	        if (bOuterWrapper)
	        {
	            this.setBasicStyles(oOuter.css('font-family'), oOuter.css('font-size'), oOuter.css('direction'));
	            oText = oOuter.contents();
	        }
	        else if (bInnerWrapper)
	        {
	            this.setBasicStyles(oInner.css('font-family'), oInner.css('font-size'), oInner.css('direction'));
	            oText = oInner.contents();
	        }
	        else
	        {
	            this.setBasicStyles(this.oOptions.defaultFontName, this.convertFontSizeToPixels(this.oOptions.defaultFontSize), this.oOptions.isRtl ? 'rtl' : 'ltr');
	        }

	        this.$editableArea.empty().append(oText).css('white-space', 'normal');
			this.clearUndoRedo();
	        this.editableSave();
	    }
	};

	/**
	 * @param {string} sFontName
	 * @param {string} sFontSize
	 * @param {string} sDirection
	 */
	CCrea.prototype.setBasicStyles = function (sFontName, sFontSize, sDirection)
	{
	    this.sBasicFontName = sFontName;
	    this.sBasicFontSize = sFontSize;
	    this.sBasicDirection = sDirection;

	    this.$editableArea.css({
	        'font-family': this.getFontNameWithFamily(this.sBasicFontName),
	        'font-size': this.sBasicFontSize,
	        'direction': this.sBasicDirection
	    });
	};

	/**
	 * @param {string} sText
	 * @returns {string}
	 */
	CCrea.prototype.replacePToBr = function (sText)
	{
	    return sText.replace(/<\/p>/gi, '<br />').replace(/<p [^>]*>/gi, '').replace(/<p>/gi, '');
	};

	/**
	 * Gets plain text from rich editor.
	 *
	 * @return {string}
	 */
	CCrea.prototype.getPlainText = function ()
	{
	    var sVal = '';

	    if (this.$editableArea)
	    {
	        sVal = this.$editableArea.html()
	            .replace(/<style[^>]*>[^<]*<\/style>/gi, '\n')
	            .replace(/<br *\/{0,1}>/gi, '\n')
	            .replace(/<\/p>/gi, '\n')
	            .replace(/<a [^>]*href="([^"]*?)"[^>]*>(.*?)<\/a>/gi, '$2 ($1)')
	            .replace(/<[^>]*>/g, '')
	            .replace(/&nbsp;/g, ' ')
	            .replace(/&lt;/g, '<')
	            .replace(/&gt;/g, '>')
	            .replace(/&amp;/g, '&')
	            .replace(/&quot;/g, '"')
	        ;
	    }

	    return sVal;
	};

	/**
	 * Gets text from rich editor.
	 *
	 * @param {boolean=} bRemoveSignatureAnchor = false
	 * @return {string}
	 */
	CCrea.prototype.getText = function (bRemoveSignatureAnchor)
	{
	    var
	        $Anchor = null,
	        sVal = ''
	    ;

	    if (this.$editableArea && this.$editableArea.length > 0)
	    {
	        if (bRemoveSignatureAnchor)
	        {
	            $Anchor = this.$editableArea.find('div[data-anchor="signature"]');
	            $Anchor.removeAttr('data-anchor');
	        }

	        sVal = this.$editableArea.html();
	        sVal = this.replacePToBr(sVal);
	        sVal = '<div data-crea="font-wrapper" style="font-family: ' + this.sBasicFontName + '; font-size: ' + this.sBasicFontSize + '; direction: ' + this.sBasicDirection + '">' + sVal + '</div>';
	    }

	    return sVal;
	};

	/**
	 * @param {string} sNewSignatureContent
	 * @param {string} sOldSignatureContent
	 */
	CCrea.prototype.changeSignatureContent = function (sNewSignatureContent, sOldSignatureContent)
	{
	    var
	        $Anchor = this.$editableArea.find('div[data-anchor="signature"]'),
	        $NewSignature = $(sNewSignatureContent).closest('div[data-crea="font-wrapper"]'),
	        $OldSignature = $(sOldSignatureContent).closest('div[data-crea="font-wrapper"]'),
	        sClearOldSignature, sClearNewSignature,
	        sAnchorHtml,
	        $SignatureContainer,
	        $SignatureBlockquoteParent,
	        sFoundOldSignature,
	        $AnchorBlockquoteParent
	    ;

	    /*** there is a signature container in the message ***/
	    if ($Anchor.length > 0)
	    {
	        sAnchorHtml = $Anchor.html();
	        /*** previous signature is empty -> append to the container a new signature ***/
	        if (sOldSignatureContent === '')
	        {
	            $Anchor.html(sAnchorHtml + sNewSignatureContent);
	        }
	        /*** previous signature was found in the container -> replace it with a new ***/
	        else if (sAnchorHtml.indexOf(sOldSignatureContent) !== -1)
	        {
	            $Anchor.html(sAnchorHtml.replace(sOldSignatureContent, sNewSignatureContent));
	        }
	        /*** new signature is found in the container -> do nothing ***/
	        else if (sAnchorHtml.indexOf(sNewSignatureContent) !== -1)
	        {
	        }
	        else
	        {
	            sClearOldSignature = ($NewSignature.length === 0 || $OldSignature.length === 0) ? sOldSignatureContent : $OldSignature.html();
	            sClearNewSignature = ($NewSignature.length === 0 || $OldSignature.length === 0) ? sNewSignatureContent : $NewSignature.html();
	            /*** found a previous signature without wrapper -> replace it with a new ***/
	            if (sAnchorHtml.indexOf(sClearOldSignature) !== -1)
	            {
	                $Anchor.html(sAnchorHtml.replace(sClearOldSignature, sNewSignatureContent));
	            }
	            /*** found a new signature without wrapper -> do nothing ***/
	            else if (sAnchorHtml.indexOf(sClearNewSignature) !== -1)
	            {
	            }
	            else
	            {
	                /*** append the new signature to the end of the container ***/
	                $Anchor.html(sAnchorHtml + sNewSignatureContent);
	            }
	        }
	    }
	    /*** there is NO signature container in the message ***/
	    else
	    {
	        sFoundOldSignature = sOldSignatureContent;
			try
			{
				$SignatureContainer = this.$editableArea.find('*:contains("' + sFoundOldSignature + '")');
			}
			catch (oErr)
			{
				$SignatureContainer = $('');
			}
	        if ($SignatureContainer.length === 0 && $OldSignature.length > 0)
	        {
	            sFoundOldSignature = $OldSignature.html();
				try
				{
					$SignatureContainer = this.$editableArea.find('*:contains("' + sFoundOldSignature + '")');
				}
				catch (oErr)
				{
					$SignatureContainer = $('');
				}
	        }

	        if ($SignatureContainer.length > 0)
	        {
	            $SignatureContainer = $($SignatureContainer[0]);
	            $SignatureBlockquoteParent = $SignatureContainer.closest('blockquote');
	        }

	        if ($SignatureBlockquoteParent && $SignatureBlockquoteParent.length === 0)
	        {
	            $SignatureContainer.html($SignatureContainer.html().replace(sFoundOldSignature, sNewSignatureContent));
	        }
	        else
	        {
	            $Anchor = this.$editableArea.find('div[data-anchor="reply-title"]');
	            $AnchorBlockquoteParent = ($Anchor.length > 0) ? $($Anchor[0]).closest('blockquote') : $Anchor;
	            if ($Anchor.length === 0 || $AnchorBlockquoteParent.length > 0)
	            {
	                $Anchor = this.$editableArea.find('blockquote');
	            }

	            if ($Anchor.length > 0)
	            {
	                $($Anchor[0]).before($('<br /><div data-anchor="signature">' + sNewSignatureContent + '</div><br />'));
	            }
	            else
	            {
	                this.$editableArea.append($('<br /><div data-anchor="signature">' + sNewSignatureContent + '</div><br />'));
	            }
	        }
	    }

	    this.editableSave();
	};

	/**
	 * @return {boolean}
	 */
	CCrea.prototype.isFocused = function ()
	{
	    return this.bFocused;
	};

	/**
	 * Sets focus.
	 * @param {boolean} bKeepCurrent
	 */
	CCrea.prototype.setFocus = function (bKeepCurrent)
	{
	    var
	        aContents = this.$editableArea.contents(),
	        iTextNodeType = 3,
	        oTextNode = null,
	        sText = ''
	    ;

	    this.$editableArea.focus();
	    if (bKeepCurrent && _.isArray(this.aRanges) && this.aRanges.length > 0)
	    {
	        this.restoreSelectionPosition();
	    }
	    else if (aContents.length > 0)
	    {
	        if (aContents[0].nodeType === iTextNodeType)
	        {
	            oTextNode = $(aContents[0]);
	        }
	        else
	        {
	            oTextNode = $(document.createTextNode(''));
	            $(aContents[0]).before(oTextNode);
	        }

	        sText = oTextNode.text();
	        this.setCursorPosition(oTextNode[0], sText.length);
	    }
	};

	CCrea.prototype.setBlur = function ()
	{
	    this.$editableArea.blur();
	};

	/**
	 * @param {boolean} bEditable
	 */
	CCrea.prototype.setEditable = function (bEditable)
	{
	    if (bEditable)
	    {
	        this.enableContentEditable();
	    }
	    else
	    {
	        this.disableContentEditable();
	    }
	};

	CCrea.prototype.disableContentEditable = function ()
	{
	    this.bEditable = false;
	    this.$editableArea.prop('contentEditable', 'false');
	};

	CCrea.prototype.enableContentEditable = function ()
	{
	    this.$editableArea.prop('contentEditable', 'true');
	    setTimeout(_.bind(function () {this.bEditable = true;}, this), 0);
	};

	CCrea.prototype.fixFirefoxCursorBug = function ()
	{
	    if (Browser.firefox)
	    {
	        this.disableContentEditable();

	        setTimeout(_.bind(function () {this.enableContentEditable();}, this), 0);
	    }
	};

	CCrea.prototype.setRtlDirection = function ()
	{
	    this.setBasicStyles(this.sBasicFontName, this.sBasicFontSize, 'rtl');
	};

	CCrea.prototype.setLtrDirection = function ()
	{
	    this.setBasicStyles(this.sBasicFontName, this.sBasicFontSize, 'ltr');
	};

	CCrea.prototype.pasteHtmlAtCaret = function (html)
	{
	    var sel, range;
	    if (window.getSelection) {
	        // IE9 and non-IE
	        sel = window.getSelection();
	        if (sel.getRangeAt && sel.rangeCount) {
	            range = sel.getRangeAt(0);
	            range.deleteContents();

	            // Range.createContextualFragment() would be useful here but is
	            // only relatively recently standardized and is not supported in
	            // some browsers (IE9, for one)
	            var el = document.createElement("div");
	            el.innerHTML = html;
	            var frag = document.createDocumentFragment(), node, lastNode;
	            while ( (node = el.firstChild) ) {
	                lastNode = frag.appendChild(node);
	            }
	            range.insertNode(frag);

	            // Preserve the selection
	            if (lastNode) {
	                range = range.cloneRange();
	                range.setStartAfter(lastNode);
	                range.collapse(true);
	                sel.removeAllRanges();
	                sel.addRange(range);
	            }
	        }
	    } else if (document.selection && document.selection.type !== "Control") {
	        // IE < 9
	        range = document.selection.createRange();
	        if (range && range.pasteHTML)
	        {
	            range.pasteHTML(html);
	        }
	    }
	};

	/**
	 * Executes command.
	 *
	 * @param {string} sCmd
	 * @param {string=} sParam
	 * @param {boolean=} bDontAddToHistory
	 * @return {boolean}
	 */
	CCrea.prototype.execCom = function (sCmd, sParam, bDontAddToHistory)
	{
	    var
	        bRes = false,
	        oRange
	    ;

	    if (this.bEditable)
	    {
	        this.editableSave();

	        if (Browser.opera)
	        {
	            this.restoreSelectionPosition();
	        }

	        if ('insertHTML' === sCmd && Browser.ie)
	        {
	            this.pasteHtmlAtCaret(sParam);
	        }
	        else
	        {
	            if (typeof sParam === 'undefined')
	            {
	                bRes = window.document.execCommand(sCmd);
	            }
	            else
	            {
	                bRes = window.document.execCommand(sCmd, false, sParam);
	            }
	        }

	        if (Browser.chrome)
	        {
	            // Chrome need to resave the selection after the operation.
	            this.storeSelectionPosition();
	            if (sCmd === 'insertHTML' && this.aRanges.length > 0)
	            {
	                // Chrome selects line after inserted text. Disable do it.
	                oRange = this.aRanges[0];
	                oRange.setEnd(oRange.startContainer, oRange.startOffset);
	                this.restoreSelectionPosition();
	            }
	        }

	        if (!bDontAddToHistory)
	        {
	            this.editableSave();
	        }
	    }
	    return bRes;
	};

	/**
	 * Inserts html.
	 *
	 * @param {string} sHtml
	 * @param {boolean} bDontAddToHistory
	 */
	CCrea.prototype.insertHtml = function (sHtml, bDontAddToHistory)
	{
	    this.execCom('insertHTML', sHtml, bDontAddToHistory);
	};

	/**
	 * @param {string} sId
	 * @param {string} sSrc
	 */
	CCrea.prototype.changeImageSource = function (sId, sSrc)
	{
	    this.$editableArea.find('img[id="' + sId + '"]').attr('src', sSrc);
	    this.editableSave();
	};

	/**
	 * Inserts link.
	 *
	 * @param {string} sLink
	 */
	CCrea.prototype.insertEmailLink = function (sLink)
	{
	    this.restoreSelectionPosition();
	    if (this.getSelectedText() === '')
	    {
	        this.execCom('insertHTML', '<a href="mailto:' + sLink + '">' + sLink + '</a>');
	    }
	    else
	    {
	        this.insertLink('mailto:' + sLink);
	    }
	};

	/**
	 * Inserts link.
	 *
	 * @param {string} sLink
	 */
	CCrea.prototype.insertLink = function (sLink)
	{
	    sLink = this.normaliseURL(sLink);
	    this.restoreSelectionPosition(sLink);

	    if (this.getSelectedText() === '' && Browser.ie)
	    {
	        this.execCom('insertHTML', '<a href="' + sLink + '">' + sLink + '</a>');
	    }
	    else
	    {
	        var sCmd = Browser.ie8AndBelow ? 'CreateLink' : 'createlink';
	        this.execCom(sCmd, sLink);
	    }

	    this.changeFocusLink(sLink);
	};

	/**
	 * Removes link.
	 */
	CCrea.prototype.removeLink = function ()
	{
	    var sCmd = Browser.ie8AndBelow ? 'Unlink' : 'unlink';
	    this.execCom(sCmd);
	};

	/**
	 * Inserts image.
	 *
	 * @param {string} sImage
	 * @return {boolean}
	 */
	CCrea.prototype.insertImage = function (sImage)
	{
	    var sCmd = Browser.ie8AndBelow ? 'InsertImage' : 'insertimage';
	    if (!this.isFocused())
	    {
	        this.setFocus(true);
	    }
	    else
	    {
	        this.restoreSelectionPosition();
	    }

	    return this.execCom(sCmd, sImage);
	};

	/**
	 * Inserts ordered list.
	 */
	CCrea.prototype.numbering = function ()
	{
	    this.execCom('InsertOrderedList');
	};

	/**
	 * Inserts unordered list.
	 */
	CCrea.prototype.bullets = function ()
	{
	    this.execCom('InsertUnorderedList');
	};

	/**
	 * Inserts horizontal line.
	 */
	CCrea.prototype.horizontalLine = function ()
	{
	    this.execCom('InsertHorizontalRule');
	};

	/**
	 * @param {string} sFontName
	 */
	CCrea.prototype.getFontNameWithFamily = function (sFontName)
	{
	    var sFamily = '';

	    switch (sFontName)
	    {
	        case 'Arial':
	        case 'Arial Black':
	        case 'Tahoma':
	        case 'Verdana':
	            sFamily = ', sans-serif';
	            break;
	        case 'Courier New':
	            sFamily = ', monospace';
	            break;
	        case 'Times New Roman':
	            sFamily = ', serif';
	            break;
	    }

	    return sFontName + sFamily;
	};

	/**
	 * Sets font name.
	 *
	 * @param {string} sFontName
	 */
	CCrea.prototype.fontName = function (sFontName)
	{
	    var bFirstTime = !this.aRanges;



	    this.setFocus(true);
	    this.execCom('FontName', this.getFontNameWithFamily(sFontName));

	    if (bFirstTime)
	    {
	        this.setBasicStyles(sFontName, this.sBasicFontSize, this.sBasicDirection);
	    }
	};

	/**
	 * Sets font size.
	 *
	 * @param {string} sFontSize
	 */
	CCrea.prototype.fontSize = function (sFontSize)
	{
	    var bFirstTime = !this.aRanges;

	    this.setFocus(true);
	    this.execCom('FontSize', sFontSize);

	    if (bFirstTime)
	    {
	        this.setBasicStyles(this.sBasicFontName, this.convertFontSizeToPixels(sFontSize), this.sBasicDirection);
	    }
	};

	/**
	 * Sets bold style.
	 */
	CCrea.prototype.bold = function ()
	{
	    this.execCom('Bold');
	    this.$editableArea.focus();
	};

	/**
	 * Sets italic style.
	 */
	CCrea.prototype.italic = function ()
	{
	    this.execCom('Italic');
	    this.$editableArea.focus();
	};

	/**
	 * Sets underline style.
	 */
	CCrea.prototype.underline = function ()
	{
	    this.execCom('Underline');
	    this.$editableArea.focus();
	};

	/**
	 * Sets strikethrough style.
	 */
	CCrea.prototype.strikeThrough = function ()
	{
	    this.execCom('StrikeThrough');
	    this.$editableArea.focus();
	};

	CCrea.prototype.undo = function ()
	{
	    this.editableUndo();
	};

	CCrea.prototype.redo = function ()
	{
	    this.editableRedo();
	};

	/**
	 * Sets left justify.
	 */
	CCrea.prototype.alignLeft = function ()
	{
	    this.execCom('JustifyLeft');
	};

	/**
	 * Sets center justify.
	 */
	CCrea.prototype.center = function ()
	{
	    this.execCom('JustifyCenter');
	};

	/**
	 * Sets right justify.
	 */
	CCrea.prototype.alignRight = function ()
	{
	    this.execCom('JustifyRight');
	};

	/**
	 * Sets full justify.
	 */
	CCrea.prototype.justify = function ()
	{
	    this.execCom('JustifyFull');
	};

	/**
	 * Sets text color.
	 *
	 * @param {string} sFontColor
	 */
	CCrea.prototype.textColor = function (sFontColor)
	{
	    this.execCom('ForeColor', sFontColor);
	    this.$editableArea.focus();
	};

	/**
	 * Sets background color.
	 *
	 * @param {string} sBackColor
	 */
	CCrea.prototype.backgroundColor = function (sBackColor)
	{
	    var sCmd = Browser.ie ? 'BackColor' : 'hilitecolor';
	    this.execCom(sCmd, sBackColor);
	    this.$editableArea.focus();
	};

	/**
	 * Removes format.
	 */
	CCrea.prototype.removeFormat = function ()
	{
	    this.execCom('removeformat');
	    this.$editableArea.focus();
	};

	/**
	 * Gets font name from selected text.
	 *
	 * @return {string}
	 */
	CCrea.prototype.getFontName = function ()
	{
	    if (this.bEditable)
	    {
	        var
	            sFontName = window.document.queryCommandValue('FontName'),
	            sValidFontName = this.sBasicFontName,
	            sFindedFontName = ''
	        ;

	        if (typeof sFontName === 'string')
	        {
	            sFontName = sFontName.replace(/'/g, '');
	            $.each(this.oOptions.fontNameArray, function (iIndex, sFont) {
	                if (sFontName.indexOf(sFont) > -1 || sFontName.indexOf(sFont.toLowerCase()) > -1)
	                {
	                    sFindedFontName = sFont;
	                }
	            });

	            if (sFindedFontName !== '')
	            {
	                sValidFontName = sFindedFontName;
	            }
	        }
	    }

	    return sValidFontName;
	};

	/**
	 * Gets is font-weight bold.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsBold = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsBold = window.document.queryCommandState('bold');
	    }

	    return bIsBold;
	};

	/**
	 * Gets is font-style italic.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsItalic = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsItalic = window.document.queryCommandState('italic');
	    }

	    return bIsItalic;
	};

	/**
	 * Gets is text-decoration underline.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsUnderline = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsUnderline = window.document.queryCommandState('underline');
	    }

	    return bIsUnderline;
	};

	/**
	 * Gets is ordered list active.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsEnumeration = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsEnumeration = window.document.queryCommandState('insertOrderedList');
	    }

	    return bIsEnumeration;
	};

	/**
	 * Gets is unordered list active.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsBullets = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsBullets = window.document.queryCommandState('insertUnorderedList');
	    }

	    return bIsBullets;
	};

	/**
	 * Gets is text-decoration strike-through.
	 *
	 * @return {boolean}
	 */
	CCrea.prototype.getIsStrikeThrough = function ()
	{
	    if (this.bEditable)
	    {
	        var bIsStrikeThrough = window.document.queryCommandState('StrikeThrough');
	    }

	    return bIsStrikeThrough;
	};

	/**
	 * @param {number} iFontSizeInNumber
	 *
	 * @return {string}
	 */
	CCrea.prototype.convertFontSizeToPixels = function (iFontSizeInNumber)
	{
	    var iFontSizeInPixels = 0;

	    $.each(this.aSizes, function (iIndex, oSize) {
	        if (iFontSizeInPixels === 0 && iFontSizeInNumber <= oSize.inNumber)
	        {
	            iFontSizeInPixels = oSize.inPixels;
	        }
	    });

	    return iFontSizeInPixels + 'px';
	};

	/**
	 * @param {string} sFontSizeInPixels
	 *
	 * @return {number}
	 */
	CCrea.prototype.convertFontSizeToNumber = function (sFontSizeInPixels)
	{
	    var
	        iFontSizeInPixels = Types.pInt(sFontSizeInPixels),
	        iFontSizeInNumber = 0
	    ;

	    if (iFontSizeInPixels > 0)
	    {
	        $.each(this.aSizes, function (iIndex, oSize) {
	            if (iFontSizeInNumber === 0 && iFontSizeInPixels <= oSize.inPixels)
	            {
	                iFontSizeInNumber = oSize.inNumber;
	            }
	        });
	    }

	    return iFontSizeInNumber;
	};

	/**
	 * Gets font size from selected text.
	 *
	 * @return {number}
	 */
	CCrea.prototype.getFontSizeInNumber = function ()
	{
	    var
	        sFontSizeInNumber = '',
	        iFontSizeInNumber = 0
	    ;

	    if (this.bEditable)
	    {
	        sFontSizeInNumber = window.document.queryCommandValue('FontSize');
	        iFontSizeInNumber = Types.pInt(sFontSizeInNumber);
	    }

	    if (isNaN(iFontSizeInNumber) || iFontSizeInNumber <= 0)
	    {
	        iFontSizeInNumber = this.convertFontSizeToNumber(this.sBasicFontSize);
	    }

	    return iFontSizeInNumber;
	};

	/**
	 * @param {string} sHref
	 */
	CCrea.prototype.changeLink = function (sHref)
	{
	    var
	        sNormHref = this.normaliseURL(sHref),
	        oCurrLink = $(this.oCurrLink)
	    ;

	    if (this.oCurrLink)
	    {
	        if (oCurrLink.attr('href') === oCurrLink.text())
	        {
	            oCurrLink.text(sNormHref);
	        }
	        if (this.oCurrLink.tagName === 'A')
	        {
	            oCurrLink.attr('href', sNormHref);
	        }
	        else
	        {
	            oCurrLink.parent().attr('href', sNormHref);
	        }

	        this.oCurrLink = null;
	        this.bInUrl = false;
	    }
	};

	CCrea.prototype.removeCurrentLink = function ()
	{
	    if (this.oCurrLink && document.createRange && window.getSelection)
	    {
	        var
	            oRange = document.createRange(),
	            oSel = window.getSelection()
	        ;

	        oRange.selectNodeContents(this.oCurrLink);
	        oSel.removeAllRanges();
	        oSel.addRange(oRange);

	        this.removeLink();
	        this.oCurrLink = null;
	        this.bInUrl = false;
	        this.oOptions.onUrlOut();
	    }
	};

	/**
	 * Fix for FF - execCommand inserts broken link, if it is present not Latin.
	 *
	 * @param {string} sLink
	 */
	CCrea.prototype.changeFocusLink = function (sLink)
	{
	    var
	        oSel = null,
	        oFocusNode = null
	    ;

	    if (Browser.firefox && window.getSelection)
	    {
	        oSel = window.getSelection();
	        oFocusNode = oSel.focusNode ? oSel.focusNode.parentElement : null;
	        if (oFocusNode && oFocusNode.tagName === 'A')
	        {
	            $(oFocusNode).attr('href', sLink);
	        }
	    }
	};

	CCrea.prototype.removeCurrentImage = function ()
	{
	    if (this.oCurrImage)
	    {
	        this.oCurrImage.remove();
	        this.oCurrImage = null;
	        this.bInImage = false;
	        this.oOptions.onImageBlur();
	    }
	};

	CCrea.prototype.changeCurrentImage = function (aParams)
	{
	    if (this.oCurrImage && aParams !== undefined)
	    {
	        var image = this.oCurrImage;
	        $.each(aParams, function (key, value) {
	            image.css(key, value);
	        });
	    }
	};

	CCrea.prototype.showImageTooltip = function (aParams)
	{
	    if (this.oCurrImage && aParams !== undefined)
	    {
	        var image = this.oCurrImage;
	        $.each(aParams, function (key, value) {
	            image.css(key, value);
	        });
	    }
	};

	/**
	 * @param {string} sText
	 * @return {string}
	 */
	CCrea.prototype.normaliseURL = function (sText)
	{
	    return sText.search(/^https?:\/\/|^mailto:|^tel:/g) !== -1 ? sText : 'http://' + sText;
	};

	/**
	 * @return {string}
	 */
	CCrea.prototype.getSelectedText = function ()
	{
	    var
	        sText = '',
	        oSel = null
	    ;

	    if (window.getSelection)
	    {
	        oSel = window.getSelection();
	        if (oSel.rangeCount > 0)
	        {
	            sText = oSel.getRangeAt(0).toString();
	        }
	    }

	    return sText;
	};

	/**
	 * Stores selection position.
	 */
	CCrea.prototype.storeSelectionPosition = function ()
	{
	    var aNewRanges = this.getSelectionRanges();
	    if (_.isArray(aNewRanges) && aNewRanges.length > 0)
	    {
	        this.aRanges = aNewRanges;
	    }
	};

	/**
	 * @return {Array}
	 */
	CCrea.prototype.editableIsActive = function ()
	{
	    return !!($(document.activeElement).hasClass('crea-content-editable') || $(document.activeElement).children().first().hasClass('crea-content-editable'));
	};

	/**
	 * @return {Array}
	 */
	CCrea.prototype.getSelectionRanges = function ()
	{
	    var aRanges = [];

	    if (window.getSelection && this.editableIsActive())
	    {
	        var
	            oSel = window.getSelection(),
	            oRange = null,
	            iIndex = 0,
	            iLen = oSel.rangeCount
	        ;

	        for (; iIndex < iLen; iIndex++)
	        {
	            oRange = oSel.getRangeAt(iIndex);
	            aRanges.push(oRange);
	        }
	    }

	    return aRanges;
	};


	CCrea.prototype.checkAnchorNode = function ()
	{
	    if (window.getSelection && this.editableIsActive())
	    {
	        var
	            oSel = window.getSelection(),
	            oCurrLink = null
	        ;

	        if (oSel.anchorNode && (oSel.anchorNode.parentElement || oSel.anchorNode.parentNode))
	        {
	            oCurrLink = oSel.anchorNode.parentElement || oSel.anchorNode.parentNode;

	            if (oCurrLink.tagName === 'A' || oCurrLink.parentNode.tagName === 'A' || oCurrLink.parentElement.tagName === 'A')
	            {
	                if (!this.bInUrl || oCurrLink !== this.oCurrLink)
	                {
	                    this.oCurrLink = oCurrLink;
	                    this.bInUrl = true;
	                    this.oOptions.onUrlIn($(oCurrLink));
	                }
	                else if (this.bInUrl && oCurrLink === this.oCurrLink)
	                {
	                    this.oCurrLink = null;
	                    this.bInUrl = false;
	                    this.oOptions.onUrlOut();
	                }
	            }
	            else if (this.bInUrl)
	            {
	                this.oCurrLink = null;
	                this.bInUrl = false;
	                this.oOptions.onUrlOut();
	            }
	        }
	    }
	};

	/**
	 * Restores selection position.
	 *
	 * @param {string} sText
	 */
	CCrea.prototype.restoreSelectionPosition = function (sText)
	{
	    var
	        sRangeText = '',
	        oSel = null,
	        oRange = null,
	        oNode = null
	    ;

	    sRangeText = this.setSelectionRanges(this.aRanges);
	    if (window.getSelection && _.isArray(this.aRanges))
	    {
	        sText = (sText !== undefined) ? sText : '';
	        if (Browser.firefox && sRangeText === '' && sText !== '')
	        {
	            if (window.getSelection && window.getSelection().getRangeAt)
	            {
	                oSel = window.getSelection();
	                if (oSel.getRangeAt && oSel.rangeCount > 0)
	                {
	                    oRange = oSel.getRangeAt(0);
	                    oNode = oRange.createContextualFragment(sText);
	                    oRange.insertNode(oNode);
	                }
	            }
	            else if (document.selection && document.selection.createRange)
	            {
	                document.selection.createRange().pasteHTML(sText);
	            }
	        }
	    }
	};

	/**
	 * @param {Array} aRanges
	 * @return {string}
	 */
	CCrea.prototype.setSelectionRanges = function (aRanges)
	{
	    var
	        oSel = null,
	        oRange = null,
	        iIndex = 0,
	        iLen = 0,
	        sRangeText = ''
	    ;

	    if (window.getSelection && _.isArray(aRanges))
	    {
	        iLen = aRanges.length;

	        oSel = window.getSelection();

	        if (!Browser.ie10AndAbove)
	        {
	            oSel.removeAllRanges();
	        }

	        for (; iIndex < iLen; iIndex++)
	        {
	            oRange = aRanges[iIndex];
	            if (oRange)
	            {
	                oSel.addRange(oRange);
	                sRangeText += '' + oRange;
	            }
	        }

	    }

	    return sRangeText;
	};

	CCrea.prototype.uniteWithNextQuote = function ()
	{
	    var
	        oSel = window.getSelection ? window.getSelection() : null,
	        eFocused = oSel ? oSel.focusNode : null,
	        eBlock = eFocused ? this.getLastBlockQuote(eFocused) : null,
	        oNext = eBlock ? $(eBlock).next() : null,
	        eNext = (oNext && oNext.length > 0 && oNext[0].tagName === 'BLOCKQUOTE') ? oNext[0] : null,
	        aChildren = [],
	        iIndex = 0,
	        iLen = 0,
	        eChild = null
	    ;

	    if (eBlock && eNext)
	    {
	        $('<br />').appendTo(eBlock);

	        aChildren = $(eNext).contents();
	        iLen = aChildren.length;

	        for (iIndex = 0; iIndex < iLen; iIndex++)
	        {
	            eChild = aChildren[iIndex];
	            $(eChild).appendTo(eBlock);
	        }

	        $(eNext).remove();
	    }
	};

	CCrea.prototype.uniteWithPrevQuote = function ()
	{
	    var
	        oSel = window.getSelection ? window.getSelection() : null,
	        eFocused = oSel ? oSel.focusNode : null,
	        eBlock = eFocused ? this.getLastBlockQuote(eFocused) : null
	    ;

	    this.getPrevAndUnite(eBlock);
	    this.getPrevAndUnite(eBlock);
	};

	/**
	 * @param {Object} eBlock
	 */
	CCrea.prototype.getPrevAndUnite = function (eBlock)
	{
	    var
	        oPrev = eBlock ? $(eBlock).prev() : null,
	        ePrev = (oPrev && oPrev.length > 0 && oPrev[0].tagName === 'BLOCKQUOTE') ? oPrev[0] : null,
	        aChildren = [],
	        iIndex = 0,
	        iLen = 0,
	        eChild = null
	    ;

	    if (eBlock && ePrev)
	    {
	        $('<br />').prependTo(eBlock);

	        aChildren = $(ePrev).contents();
	        iLen = aChildren.length;

	        for (iIndex = iLen - 1; iIndex > 0; iIndex--)
	        {
	            eChild = aChildren[iIndex];
	            $(eChild).prependTo(eBlock);
	        }

	        $(ePrev).remove();
	    }
	};

	/**
	 * @param {Object} eFocused
	 * @return {Object}
	 */
	CCrea.prototype.getLastBlockQuote = function (eFocused)
	{
	    var
	        eCurrent = eFocused,
	        eBlock = null
	    ;

	    while (eCurrent && eCurrent.parentNode)
	    {
	        if (eCurrent.tagName === 'BLOCKQUOTE')
	        {
	            eBlock = eCurrent;
	        }
	        eCurrent = eCurrent.parentNode;
	    }

	    return eBlock;
	};

	/**
	 * @param {Object} ev
	 */
	CCrea.prototype.breakQuotes = function (ev)
	{
	    var
	        oSel = window.getSelection ? window.getSelection() : null,
	        eFocused = oSel ? oSel.focusNode : null,
	        eBlock = eFocused ? this.getLastBlockQuote(eFocused) : null
	    ;

	    if (eFocused && eBlock)
	    {
	        this.breakBlocks(eFocused, eBlock, oSel.focusOffset);
	    }
	};

	/**
	 * @param {Object} eStart
	 * @param {number} iStartOffset
	 */
	CCrea.prototype.setCursorPosition = function (eStart, iStartOffset)
	{
	    if (document.createRange && window.getSelection)
	    {
	        var
	            oRange = document.createRange(),
	            oSel = window.getSelection()
	        ;

	        oSel.removeAllRanges();

	        oRange.setStart(eStart, iStartOffset);
	        oRange.setEnd(eStart, iStartOffset);
	        oRange.collapse(true);

	        oSel.addRange(oRange);

	        this.aRanges = [oRange];
	    }
	};

	/**
	 * @param {Object} eNode
	 * @return {Object}
	 */
	CCrea.prototype.cloneNode = function (eNode)
	{
	    var
	        $clonedNode = null,
	        sTagName = ''
	    ;

	    try
	    {
	        $clonedNode = $(eNode).clone();
	    }
	    catch (er)
	    {
	        sTagName = eNode.tagName;
	        $clonedNode = $('<' + sTagName + '></' + sTagName + '>');
	    }

	    return $clonedNode;
	};

	/**
	 * @param {Object} eFocused
	 * @param {Object} eBlock
	 * @param {number} iFocusOffset
	 */
	CCrea.prototype.breakBlocks = function (eFocused, eBlock, iFocusOffset)
	{
	    var
	        eCurrent = eFocused,
	        eCurChild = null,
	        aChildren = [],
	        iIndex = 0,
	        iLen = 0,
	        eChild = null,
	        bBeforeCurrent = true,
	        $firstParent = null,
	        $secondParent = null,
	        $first = null,
	        $second = null,
	        bLast = false,
	        bContinue = true,
	        $span = null
	    ;

	    while (bContinue && eCurrent.parentNode)
	    {
	        $first = $firstParent;
	        $second = $secondParent;

	        $firstParent = this.cloneNode(eCurrent).empty();
	        $secondParent = this.cloneNode(eCurrent).empty();

	        aChildren = $(eCurrent).contents();
	        iLen = aChildren.length;
	        bBeforeCurrent = true;

	        if (eCurChild === null)
	        {
	            eCurChild = aChildren[iFocusOffset];
	        }
	        if (iLen === 0)
	        {
	            $firstParent = null;
	        }

	        for (iIndex = 0; iIndex < iLen; iIndex++)
	        {
	            eChild = aChildren[iIndex];
	            if (eChild === eCurChild)
	            {
	                if ($first === null)
	                {
	                    if (!(iIndex === iFocusOffset && eChild.tagName === 'BR'))
	                    {
	                        $(eChild).appendTo($secondParent);
	                    }
	                }
	                else
	                {
	                    if ($first.html().length > 0)
	                    {
	                        $first.appendTo($firstParent);
	                    }

	                    $second.appendTo($secondParent);
	                }
	                bBeforeCurrent = false;
	            }
	            else if (bBeforeCurrent)
	            {
	                $(eChild).appendTo($firstParent);
	            }
	            else
	            {
	                $(eChild).appendTo($secondParent);
	            }
	        }

	        bLast = (eBlock === eCurrent);
	        if (bLast)
	        {
	            bContinue = false;
	        }

	        eCurChild = eCurrent;
	        eCurrent = eCurrent.parentNode;
	    }

	    if ($firstParent !== null && $secondParent !== null)
	    {
	        $firstParent.insertBefore($(eBlock));
	        $span = $('<span>&nbsp;</span>').insertBefore($(eBlock));
	        $('<br>').insertBefore($(eBlock));
	        $secondParent.insertBefore($(eBlock));

	        $(eBlock).remove();
	        this.setCursorPosition($span[0], 0);
	    }
	};

	module.exports = CCrea;


/***/ }),

/***/ 425:
/*!************************************************************!*\
  !*** ./modules/MailWebclient/js/views/CColorPickerView.js ***!
  \************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		$ = __webpack_require__(/*! jquery */ 1)
	;

	/**
	 * @constructor
	 * @param {string} sCaption
	 * @param {Function} fPickHandler
	 * @param {Object} oPickContext
	 */
	function CColorPickerView(sCaption, fPickHandler, oPickContext)
	{
		this.aGreyColors = ['rgb(0, 0, 0)', 'rgb(68, 68, 68)', 'rgb(102, 102, 102)', 'rgb(153, 153, 153)',
			'rgb(204, 204, 204)', 'rgb(238, 238, 238)', 'rgb(243, 243, 243)', 'rgb(255, 255, 255)'];
		
		this.aBrightColors = ['rgb(255, 0, 0)', 'rgb(255, 153, 0)', 'rgb(255, 255, 0)', 'rgb(0, 255, 0)', 
			'rgb(0, 255, 255)', 'rgb(0, 0, 255)', 'rgb(153, 0, 255)', 'rgb(255, 0, 255)'];
		
		this.aColorLines = [
			['rgb(244, 204, 204)', 'rgb(252, 229, 205)', 'rgb(255, 242, 204)', 'rgb(217, 234, 211)', 
					'rgb(208, 224, 227)', 'rgb(207, 226, 243)', 'rgb(217, 210, 233)', 'rgb(234, 209, 220)'],
			['rgb(234, 153, 153)', 'rgb(249, 203, 156)', 'rgb(255, 229, 153)', 'rgb(182, 215, 168)', 
					'rgb(162, 196, 201)', 'rgb(159, 197, 232)', 'rgb(180, 167, 214)', 'rgb(213, 166, 189)'],
			['rgb(224, 102, 102)', 'rgb(246, 178, 107)', 'rgb(255, 217, 102)', 'rgb(147, 196, 125)', 
					'rgb(118, 165, 175)', 'rgb(111, 168, 220)', 'rgb(142, 124, 195)', 'rgb(194, 123, 160)'],
			['rgb(204, 0, 0)', 'rgb(230, 145, 56)', 'rgb(241, 194, 50)', 'rgb(106, 168, 79)', 
					'rgb(69, 129, 142)', 'rgb(61, 133, 198)', 'rgb(103, 78, 167)', 'rgb(166, 77, 121)'],
			['rgb(153, 0, 0)', 'rgb(180, 95, 6)', 'rgb(191, 144, 0)', 'rgb(56, 118, 29)', 
					'rgb(19, 79, 92)', 'rgb(11, 83, 148)', 'rgb(53, 28, 117)', 'rgb(116, 27, 71)'],
			['rgb(102, 0, 0)', 'rgb(120, 63, 4)', 'rgb(127, 96, 0)', 'rgb(39, 78, 19)', 
					'rgb(12, 52, 61)', 'rgb(7, 55, 99)', 'rgb(32, 18, 77)', 'rgb(76, 17, 48)']
		];
		
		this.caption = sCaption;
		this.pickHandler = fPickHandler;
		this.pickContext = oPickContext;
		
		this.colorPickerDom = ko.observable(null);
	}

	CColorPickerView.prototype.ViewTemplate = 'MailWebclient_ColorPickerView';

	CColorPickerView.prototype.onShow = function ()
	{
		$(this.colorPickerDom()).find('span.color-item').on('click', _.bind(function (oEv)
		{
			oEv.stopPropagation();
			this.setColorFromPopup($(oEv.target).data('color'));
		}, this));
	};

	/**
	 * @param {string} sColor
	 */
	CColorPickerView.prototype.setColorFromPopup = function (sColor)
	{
		this.pickHandler.call(this.pickContext, sColor);
	};

	module.exports = CColorPickerView;

/***/ }),

/***/ 426:
/*!**********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CFetcherModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213)
	;

	/**
	 * @constructor
	 */
	function CFetcherModel()
	{
		this.FETCHER = true; // constant
		
		this.id = ko.observable(0);
		this.accountId = ko.observable(0);
		this.hash = ko.computed(function () {
			return Utils.getHash(this.accountId() + 'fetcher' + this.id());
		}, this);
		this.isEnabled = ko.observable(false);
		this.isLocked = ko.observable(false).extend({'autoResetToFalse': 1000});
		this.email = ko.observable('');
		this.userName = ko.observable('');
		this.folder = ko.observable('');
		this.useSignature = ko.observable(false);
		this.signature = ko.observable('');
		this.incomingServer = ko.observable('');
		this.incomingPort = ko.observable(0);
		this.incomingUseSsl = ko.observable(false);
		this.incomingLogin = ko.observable('');
		this.leaveMessagesOnServer = ko.observable('');
		this.isOutgoingEnabled = ko.observable(false);
		this.outgoingServer = ko.observable('');
		this.outgoingPort = ko.observable(0);
		this.outgoingUseSsl = ko.observable(false);
		this.outgoingUseAuth = ko.observable(false);
		
		this.fullEmail = ko.computed(function () {
			return AddressUtils.getFullEmail(this.userName(), this.email());
		}, this);
	}

	/**
	 * @param {Object} oData
	 */
	CFetcherModel.prototype.parse = function (oData)
	{
		this.id(Types.pInt(oData.EntityId));
		this.accountId(Types.pInt(oData.IdAccount));
		this.isEnabled(!!oData.IsEnabled);
		this.isLocked(!!oData.IsLocked);
		this.email(Types.pString(oData.Email));
		this.userName(Types.pString(oData.Name));
		this.folder(Types.pString(oData.Folder));
		this.useSignature(!!oData.UseSignature);
		this.signature(Types.pString(oData.Signature));
		this.incomingServer(Types.pString(oData.IncomingServer));
		this.incomingPort(Types.pInt(oData.IncomingPort));
		this.incomingUseSsl(!!oData.IncomingUseSsl);
		this.incomingLogin(Types.pString(oData.IncomingLogin));
		this.leaveMessagesOnServer(!!oData.LeaveMessagesOnServer);
		this.isOutgoingEnabled(!!oData.IsOutgoingEnabled);
		this.outgoingServer(Types.pString(oData.OutgoingServer));
		this.outgoingPort(Types.pInt(oData.OutgoingPort));
		this.outgoingUseSsl(!!oData.OutgoingUseSsl);
		this.outgoingUseAuth(!!oData.OutgoingUseAuth);
	};

	module.exports = CFetcherModel;


/***/ }),

/***/ 427:
/*!***********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CIdentityModel.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		AddressUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Address.js */ 201),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213)
	;

	/**
	 * @constructor
	 */
	function CIdentityModel()
	{
		this.bAccountPart = false;
		this.isDefault = ko.observable(false);
		this.email = ko.observable('');
		this.friendlyName = ko.observable('');
		this.fullEmail = ko.computed(function () {
			return AddressUtils.getFullEmail(this.friendlyName(), this.email());
		}, this);
		this.accountId = ko.observable(-1);
		this.id = ko.observable(-1);
		this.signature = ko.observable('');
		this.useSignature = ko.observable(false);
		this.hash = ko.computed(function () {
			return Utils.getHash(this.accountId() + 'identity' + this.id());
		}, this);
	}

	/**
	 * @param {Object} oData
	 */
	CIdentityModel.prototype.parse = function (oData)
	{
		if (oData['@Object'] === 'Object/Aurora\\Modules\\Mail\\Classes\\Identity')
		{
			this.bAccountPart = !!oData.AccountPart;
			this.isDefault(!!oData.Default);
			this.email(Types.pString(oData.Email));
			this.friendlyName(Types.pString(oData.FriendlyName));
			this.accountId(Types.pInt(oData.IdAccount));
			this.id(Types.pInt(oData.EntityId));
			this.signature(Types.pString(oData.Signature));
			this.useSignature(!!oData.UseSignature);
		}
	};

	module.exports = CIdentityModel;


/***/ }),

/***/ 428:
/*!*************************************************************!*\
  !*** ./modules/MailWebclient/js/models/CFolderListModel.js ***!
  \*************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		CFolderModel = __webpack_require__(/*! modules/MailWebclient/js/models/CFolderModel.js */ 429)
	;

	/**
	 * @constructor
	 */
	function CFolderListModel()
	{
		this.iAccountId = 0;
		this.initialized = ko.observable(false);

		this.bExpandFolders = false;
		this.expandNames = ko.observableArray([]);
		this.collection = ko.observableArray([]);
		this.options = ko.observableArray([]);
		this.sNamespaceFolder = '';
		this.oStarredFolder = null;

		this.oNamedCollection = {};
		this.aLinedCollection = [];

		var
			self = this,
			fSetSystemType = function (iType) {
				return function (oFolder) {
					if (oFolder)
					{
						oFolder.type(iType);
					}
				};
			},
			fFullNameHelper = function (fFolder) {
				return {
					'read': function () {
						this.collection();
						return fFolder() ? fFolder().fullName() : '';
					},
					'write': function (sValue) {
						fFolder(this.getFolderByFullName(sValue));
					},
					'owner': self
				};
			}
		;

		this.currentFolder = ko.observable(null);

		this.inboxFolder = ko.observable(null);
		this.sentFolder = ko.observable(null);
		this.draftsFolder = ko.observable(null);
		this.spamFolder = ko.observable(null);
		this.trashFolder = ko.observable(null);
		
		this.countsCompletelyFilled = ko.observable(false);

		this.inboxFolder.subscribe(fSetSystemType(Enums.FolderTypes.User), this, 'beforeChange');
		this.sentFolder.subscribe(fSetSystemType(Enums.FolderTypes.User), this, 'beforeChange');
		this.draftsFolder.subscribe(fSetSystemType(Enums.FolderTypes.User), this, 'beforeChange');
		this.spamFolder.subscribe(fSetSystemType(Enums.FolderTypes.User), this, 'beforeChange');
		this.trashFolder.subscribe(fSetSystemType(Enums.FolderTypes.User), this, 'beforeChange');
		
		this.inboxFolder.subscribe(fSetSystemType(Enums.FolderTypes.Inbox));
		this.sentFolder.subscribe(fSetSystemType(Enums.FolderTypes.Sent));
		this.draftsFolder.subscribe(fSetSystemType(Enums.FolderTypes.Drafts));
		this.spamFolder.subscribe(fSetSystemType(Enums.FolderTypes.Spam));
		this.trashFolder.subscribe(fSetSystemType(Enums.FolderTypes.Trash));
		
		this.inboxFolderFullName = ko.computed(fFullNameHelper(this.inboxFolder));
		this.sentFolderFullName = ko.computed(fFullNameHelper(this.sentFolder));
		this.draftsFolderFullName = ko.computed(fFullNameHelper(this.draftsFolder));
		this.spamFolderFullName = ko.computed(fFullNameHelper(this.spamFolder));
		this.trashFolderFullName = ko.computed(fFullNameHelper(this.trashFolder));
		
		this.currentFolderFullName = ko.computed(fFullNameHelper(this.currentFolder));
		this.currentFolderType = ko.computed(function () {
			return this.currentFolder() ? this.currentFolder().type() : Enums.FolderTypes.User;
		}, this);
		
		this.sDelimiter = '';
	}

	CFolderListModel.prototype.getTotalMessageCount = function ()
	{
		var iCount = 0;
		
		_.each(this.oNamedCollection, function (oFolder) {
			iCount += oFolder.messageCount();
		}, this);
		
		return iCount;
	};

	/**
	 * @returns {Array}
	 */
	CFolderListModel.prototype.getFoldersWithoutCountInfo = function ()
	{
		var aFolders = _.compact(_.map(this.oNamedCollection, function(oFolder, sFullName) {
			if (oFolder.bCanBeSelected && !oFolder.hasExtendedInfo())
			{
				return sFullName;
			}
			
			return null;
		}));
		
		return aFolders;
	};

	/**
	 * @param {string} sFolderFullName
	 * @param {string} sFilters
	 */
	CFolderListModel.prototype.setCurrentFolder = function (sFolderFullName, sFilters)
	{
		var
			oFolder = this.getFolderByFullName(sFolderFullName)
		;
		
		if (oFolder === null)
		{
			oFolder = this.inboxFolder();
		}
		
		if (oFolder !== null)
		{
			if (this.currentFolder())
			{
				this.currentFolder().selected(false);
				if (this.oStarredFolder)
				{
					this.oStarredFolder.selected(false);
				}
			}
			
			this.currentFolder(oFolder);
			if (sFilters === Enums.FolderFilter.Flagged)
			{
				if (this.oStarredFolder)
				{
					this.oStarredFolder.selected(true);
				}
			}
			else
			{
				this.currentFolder().selected(true);
			}
		}
	};

	/**
	 * Returns a folder, found by the full name.
	 * 
	 * @param {string} sFolderFullName
	 * @returns {CFolderModel|null}
	 */
	CFolderListModel.prototype.getFolderByFullName = function (sFolderFullName)
	{
		var oFolder = this.oNamedCollection[sFolderFullName];
		
		return oFolder ? oFolder : null;
	};

	CFolderListModel.prototype.renameFolder = function (sFullName, sNewFullName, sNewFullNameHash)
	{
		var oFolder = this.oNamedCollection[sFullName];
		oFolder.fullName(sNewFullName);
		oFolder.fullNameHash(sNewFullNameHash);
		this.oNamedCollection[sNewFullName] = oFolder;
		this.oNamedCollection[sFullName] = undefined;
	};

	/**
	 * Calls a recursive parsing of the folder tree.
	 * 
	 * @param {number} iAccountId
	 * @param {Object} oData
	 * @param {Object} oNamedFolderListOld
	 */
	CFolderListModel.prototype.parse = function (iAccountId, oData, oNamedFolderListOld)
	{
		var
			sNamespace = Types.pString(oData.Namespace),
			aCollection = oData.Folders['@Collection']
		;
		if (sNamespace.length > 0)
		{
			this.sNamespaceFolder = sNamespace.substring(0, sNamespace.length - 1);
		}
		
		this.iAccountId = iAccountId;
		this.initialized(true);

		this.bExpandFolders = Settings.AllowExpandFolders && !Storage.hasData('folderAccordion');
		if (!Storage.hasData('folderAccordion'))
		{
			Storage.setData('folderAccordion', []);
		}
		
		this.oNamedCollection = {};
		this.aLinedCollection = [];
		this.collection(this.parseRecursively(aCollection, oNamedFolderListOld));
	};

	/**
	 * Recursively parses the folder tree.
	 * 
	 * @param {Array} aRawCollection
	 * @param {Object} oNamedFolderListOld
	 * @param {number=} iLevel
	 * @param {string=} sParentFullName
	 * @returns {Array}
	 */
	CFolderListModel.prototype.parseRecursively = function (aRawCollection, oNamedFolderListOld, iLevel, sParentFullName)
	{
		var
			aParsedCollection = [],
			iIndex = 0,
			iLen = 0,
			oFolder = null,
			oFolderOld = null,
			sFolderFullName = '',
			oSubFolders = null,
			aSubfolders = []
		;

		sParentFullName = sParentFullName || '';
		
		if (iLevel === undefined)
		{
			iLevel = -1;
		}

		iLevel++;
		if (_.isArray(aRawCollection))
		{
			for (iLen = aRawCollection.length; iIndex < iLen; iIndex++)
			{
				sFolderFullName = Types.pString(aRawCollection[iIndex].FullNameRaw);
				oFolderOld = oNamedFolderListOld[sFolderFullName];
				oFolder = new CFolderModel(this.iAccountId);
				oSubFolders = oFolder.parse(aRawCollection[iIndex], sParentFullName, this.sNamespaceFolder);
				if (oFolderOld && oFolderOld.hasExtendedInfo() && !oFolder.hasExtendedInfo())
				{
					oFolder.setRelevantInformation(oFolderOld.sUidNext, oFolderOld.sHash, 
						oFolderOld.messageCount(), oFolderOld.unseenMessageCount(), false);
				}

				if (this.bExpandFolders && oSubFolders !== null)
				{
					oFolder.expanded(true);
					this.expandNames().push(Types.pString(aRawCollection[iIndex].Name));
				}

				oFolder.setLevel(iLevel);

				switch (oFolder.type())
				{
					case Enums.FolderTypes.Inbox:
						this.inboxFolder(oFolder);
						this.sDelimiter = oFolder.sDelimiter;
						break;
					case Enums.FolderTypes.Sent:
						this.sentFolder(oFolder);
						break;
					case Enums.FolderTypes.Drafts:
						this.draftsFolder(oFolder);
						break;
					case Enums.FolderTypes.Trash:
						this.trashFolder(oFolder);
						break;
					case Enums.FolderTypes.Spam:
						this.spamFolder(oFolder);
						break;
				}

				this.oNamedCollection[oFolder.fullName()] = oFolder;
				this.aLinedCollection.push(oFolder);
				aParsedCollection.push(oFolder);
				
				if (oSubFolders === null && oFolder.type() === Enums.FolderTypes.Inbox)
				{
					this.createStarredFolder(oFolder.fullName(), iLevel);
					if (this.oStarredFolder)
					{
						aParsedCollection.push(this.oStarredFolder);
					}
				}
				else if (oSubFolders !== null)
				{
					aSubfolders = this.parseRecursively(oSubFolders['@Collection'], oNamedFolderListOld, iLevel, oFolder.fullName());
					if(oFolder.type() === Enums.FolderTypes.Inbox)
					{
						if (oFolder.bNamespace)
						{
							this.createStarredFolder(oFolder.fullName(), iLevel + 1);
							if (this.oStarredFolder)
							{
								aSubfolders.unshift(this.oStarredFolder);
							}
						}
						else
						{
							this.createStarredFolder(oFolder.fullName(), iLevel);
							if (this.oStarredFolder)
							{
								aParsedCollection.push(this.oStarredFolder);
							}
						}
					}
					oFolder.subfolders(aSubfolders);
				}
			}

			if (this.bExpandFolders)
			{
				Storage.setData('folderAccordion', this.expandNames());
			}
		}

		return aParsedCollection;
	};

	/**
	 * @param {string} sFullName
	 * @param {number} iLevel
	 */
	CFolderListModel.prototype.createStarredFolder = function (sFullName, iLevel)
	{
		this.oStarredFolder = new CFolderModel(this.iAccountId);
		this.oStarredFolder.initStarredFolder(iLevel, sFullName);
	};

	CFolderListModel.prototype.repopulateLinedCollection = function ()
	{
		var self = this;
		
		function fPopuplateLinedCollection(aFolders)
		{
			_.each(aFolders, function (oFolder) {
				self.aLinedCollection.push(oFolder);
				if (oFolder.subfolders().length > 0)
				{
					fPopuplateLinedCollection(oFolder.subfolders());
				}
			});
		}
		
		this.aLinedCollection = [];
		
		fPopuplateLinedCollection(this.collection());
		
		return this.aLinedCollection;
	};

	/**
	 * @param {string} sFirstItem
	 * @param {boolean=} bEnableSystem = false
	 * @param {boolean=} bHideInbox = false
	 * @param {boolean=} bIgnoreCanBeSelected = false
	 * @param {boolean=} bIgnoreUnsubscribed = false
	 * @returns {Array}
	 */
	CFolderListModel.prototype.getOptions = function (sFirstItem, bEnableSystem, bHideInbox, bIgnoreCanBeSelected, bIgnoreUnsubscribed)
	{
		bEnableSystem = !!bEnableSystem;
		bHideInbox = !!bHideInbox;
		bIgnoreCanBeSelected = !!bIgnoreCanBeSelected;
		bIgnoreUnsubscribed = !!bIgnoreUnsubscribed;
		
		var
			sDeepPrefix = '\u00A0\u00A0\u00A0\u00A0',
			aCollection = []
		;
		
		_.each(this.aLinedCollection, function (oFolder) {
			if (oFolder && !oFolder.bVirtual && (!bHideInbox || Enums.FolderTypes.Inbox !== oFolder.type()) && (!bIgnoreUnsubscribed || oFolder.subscribed()))
			{
				var sPrefix = (new Array(oFolder.iLevel + 1)).join(sDeepPrefix);
				aCollection.push({
					'name': oFolder.name(),
					'fullName': oFolder.fullName(),
					'displayName': sPrefix + oFolder.name(),
					'translatedDisplayName': sPrefix + oFolder.displayName(),
					'disable': !bEnableSystem && oFolder.isSystem() || !bIgnoreCanBeSelected && !oFolder.bCanBeSelected
				});
			}
		});
		
		if (sFirstItem !== '')
		{
			aCollection.unshift({
				'name': sFirstItem,
				'fullName': '',
				'displayName': sFirstItem,
				'translatedDisplayName': sFirstItem,
				'disable': false
			});
		}

		return aCollection;
	};

	module.exports = CFolderListModel;


/***/ }),

/***/ 429:
/*!*********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CFolderModel.js ***!
  \*********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		ConfirmPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/ConfirmPopup.js */ 196),
		
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = null,
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CMessageModel = __webpack_require__(/*! modules/MailWebclient/js/models/CMessageModel.js */ 421),
		CUidListModel = __webpack_require__(/*! modules/MailWebclient/js/models/CUidListModel.js */ 430)
	;

	/**
	 * @constructor
	 * @param {number} iAccountId
	 */
	function CFolderModel(iAccountId)
	{
		this.iAccountId = iAccountId;
		this.bNamespace = false;
		this.iLevel = 0;

		/** From server **/
		this.sDelimiter = '';
		this.bExists = true;
		/** Extended **/
		this.sUidNext = '';
		this.sHash = '';
		this.messageCount = ko.observable(0);
		this.unseenMessageCount = ko.observable(0);
		this.sRealUnseenMessageCount = 0;
		this.hasExtendedInfo = ko.observable(false);
		/** Extended **/
		this.fullName = ko.observable('');
		this.fullNameHash = ko.observable('');
		this.bSelectable = true;
		this.subscribed = ko.observable(true);
		this.name = ko.observable('');
		this.nameForEdit = ko.observable('');
		this.subfolders = ko.observableArray([]);
		this.subfoldersMessagesCount = ko.observable(0);
		this.type = ko.observable(Enums.FolderTypes.User);
		/** From server **/
		
		this.bVirtual = false;	// Indicates if the folder does not exist on mail server and uses as place for filtered message list.
								// At the moment the application supports only one type of virtual folders - for starred messages.
		this.selected = ko.observable(false); // Indicates if the folder is selected on mail screen.
		this.expanded = ko.observable(false); // Indicates if subfolders are shown on mail screen.
		this.recivedAnim = ko.observable(false).extend({'autoResetToFalse': 500}); // Starts the animation for displaying moving messages to the folder on mail screen.

		this.edited = ko.observable(false); // Indicates if the folder name is edited now on settings screen.

		this.oMessages = {};
		
		this.oUids = {};

		this.aResponseHandlers = [];
		
		this.aRequestedUids = [];
		this.aRequestedThreadUids = [];
		this.requestedLists = [];
		
		this.hasChanges = ko.observable(false);
		
		this.relevantInformationLastMoment = null;
	}

	CFolderModel.prototype.requireMailCache = function ()
	{
		if (MailCache === null)
		{
			MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399);
		}
	};

	/**
	 * @param {number} iLevel
	 */
	CFolderModel.prototype.setLevel = function (iLevel)
	{
		this.iLevel = iLevel;
	};

	/**
	 * @param {string} sUid
	 * @returns {Object}
	 */
	CFolderModel.prototype.getMessageByUid = function (sUid)
	{
		return this.oMessages[sUid];
	};

	/**
	 * @returns {Array}
	 */
	CFolderModel.prototype.getFlaggedMessageUids = function ()
	{
		var aUids = [];
		_.each(this.oMessages, function (oMessage) {
			if (oMessage.flagged())
			{
				aUids.push(oMessage.uid());
			}
		});
		return aUids;
	};

	/**
	 * @param {string} sUid
	 */
	CFolderModel.prototype.setMessageUnflaggedByUid = function (sUid)
	{
		var oMessage = this.oMessages[sUid];
		if (oMessage)
		{
			oMessage.flagged(false);
		}
	};

	/**
	 * @param {Object} oMessage
	 */
	CFolderModel.prototype.hideThreadMessages = function (oMessage)
	{
		_.each(oMessage.threadUids(), function (sThreadUid) {
			var oMess = this.oMessages[sThreadUid];
			if (oMess)
			{
				if (!oMess.deleted())
				{
					oMess.threadShowAnimation(false);
					oMess.threadHideAnimation(true);
					
					setTimeout(function () {
						oMess.threadHideAnimation(false);
					}, 1000);
				}
			}
		}, this);
	};

	/**
	 * @param {Object} oMessage
	 */
	CFolderModel.prototype.getThreadMessages = function (oMessage)
	{
		var
			aLoadedMessages = [],
			aUidsForLoad = [],
			aChangedThreadUids = [],
			iCount = 0,
			oLastMessage = null,
			iShowThrottle = 50
		;
		
		_.each(oMessage.threadUids(), function (sThreadUid) {
			if (iCount < oMessage.threadCountForLoad())
			{
				var oMess = this.oMessages[sThreadUid];
				if (oMess)
				{
					if (!oMess.deleted())
					{
						oMess.markAsThreadPart(iShowThrottle, oMessage.uid());
						aLoadedMessages.push(oMess);
						aChangedThreadUids.push(oMess.uid());
						iCount++;
						oLastMessage = oMess;
					}
				}
				else
				{
					aUidsForLoad.push(sThreadUid);
					aChangedThreadUids.push(sThreadUid);
					iCount++;
				}
			}
			else
			{
				aChangedThreadUids.push(sThreadUid);
			}
		}, this);
		
		if (!oMessage.threadLoading())
		{
			this.loadThreadMessages(aUidsForLoad);
		}
		
		oMessage.changeThreadUids(aChangedThreadUids, aLoadedMessages.length);
		
		if (oLastMessage && aLoadedMessages.length < oMessage.threadUids().length)
		{
			oLastMessage.showNextLoadingLink(_.bind(oMessage.increaseThreadCountForLoad, oMessage));
		}
		
		this.addThreadUidsToUidLists(oMessage.uid(), oMessage.threadUids());
		
		return aLoadedMessages;
	};

	/**
	 * @param {Object} oMessage
	 */
	CFolderModel.prototype.computeThreadData = function (oMessage)
	{
		var
			iUnreadCount = 0,
			bPartialFlagged = false,
			aSenders = [],
			aEmails = [],
			sMainEmail = oMessage.oFrom.getFirstEmail()
		;
		
		_.each(oMessage.threadUids(), function (sThreadUid) {
			var
				oThreadMessage = this.oMessages[sThreadUid],
				sThreadEmail = ''
			;
			
			if (oThreadMessage && !oThreadMessage.deleted())
			{
				if (!oThreadMessage.seen())
				{
					iUnreadCount++;
				}
				if (oThreadMessage.flagged())
				{
					bPartialFlagged = true;
				}
				
				sThreadEmail = oThreadMessage.oFrom.getFirstEmail();
				if ((sThreadEmail !== sMainEmail) && (-1 === $.inArray(sThreadEmail, aEmails)))
				{
					aEmails.push(sThreadEmail);
					if (sThreadEmail === AccountList.getEmail())
					{
						aSenders.push(TextUtils.i18n('MAILWEBCLIENT/LABEL_ME_SENDER'));
					}
					else
					{
						aSenders.push(oThreadMessage.oFrom.getFirstDisplay());
					}
				}
			}
		}, this);
		
		oMessage.threadUnreadCount(iUnreadCount);
		oMessage.partialFlagged(bPartialFlagged);
	};

	/**
	 * 
	 * @param {string} sUid
	 * @param {Array} aThreadUids
	 */
	CFolderModel.prototype.addThreadUidsToUidLists = function (sUid, aThreadUids)
	{
		_.each(this.oUids, function (oUidSearchList) {
			_.each(oUidSearchList, function (oUidList) {
				oUidList.addThreadUids(sUid, aThreadUids);
			});
		});
	};

	/**
	 * @param {Array} aUidsForLoad
	 */
	CFolderModel.prototype.loadThreadMessages = function (aUidsForLoad)
	{
		if (aUidsForLoad.length > 0)
		{
			var oParameters = {
				'Folder': this.fullName(),
				'Uids': aUidsForLoad
			};

			Ajax.send('GetMessagesByUids', oParameters, this.onGetMessagesByUidsResponse, this);
		}
	};

	/**
	 * @param {Array} aMessages
	 */
	CFolderModel.prototype.getThreadCheckedUidsFromList = function (aMessages)
	{
		var
			oFolder = this,
			aThreadUids = []
		;
		
		_.each(aMessages, function (oMessage) {
			if (oMessage.threadCount() > 0 && !oMessage.threadOpened())
			{
				_.each(oMessage.threadUids(), function (sUid) {
					var oThreadMessage = oFolder.oMessages[sUid];
					if (oThreadMessage && !oThreadMessage.deleted() && oThreadMessage.checked())
					{
						aThreadUids.push(sUid);
					}
				});
			}
		});
		
		return aThreadUids;
	};

	/**
	 * @param {Object} oRawMessage
	 * @param {boolean} bThreadPart
	 * @param {boolean} bTrustThreadInfo
	 */
	CFolderModel.prototype.parseAndCacheMessage = function (oRawMessage, bThreadPart, bTrustThreadInfo)
	{
		var
			sUid = oRawMessage.Uid.toString(),
			bNewMessage = !this.oMessages[sUid],
			oMessage = bNewMessage ? new CMessageModel() : this.oMessages[sUid]
		;
		
		oMessage.parse(oRawMessage, this.iAccountId, bThreadPart, bTrustThreadInfo);
		if (this.type() === Enums.FolderTypes.Inbox && bNewMessage && oMessage.flagged())
		{
			this.requireMailCache();
			MailCache.increaseStarredCount();
		}
		
		this.oMessages[oMessage.uid()] = oMessage;
		
		return oMessage;
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CFolderModel.prototype.onGetMessagesByUidsResponse = function (oResponse, oRequest)
	{
		var oResult = oResponse.Result;
		
		if (oResult && oResult['@Object'] === 'Collection/MessageCollection')
		{
			_.each(oResult['@Collection'], function (oRawMessage) {
				this.parseAndCacheMessage(oRawMessage, true, true);
			}, this);
			
			this.requireMailCache();
			MailCache.showOpenedThreads(this.fullName());
		}
	};

	/**
	 * Adds uids of requested messages.
	 * 
	 * @param {Array} aUids
	 */
	CFolderModel.prototype.addRequestedUids = function (aUids)
	{
		this.aRequestedUids = _.union(this.aRequestedUids, aUids);
	};

	/**
	 * @param {string} sUid
	 */
	CFolderModel.prototype.hasUidBeenRequested = function (sUid)
	{
		return _.indexOf(this.aRequestedUids, sUid) !== -1;
	};

	/**
	 * Adds uids of requested thread message headers.
	 * 
	 * @param {Array} aUids
	 */
	CFolderModel.prototype.addRequestedThreadUids = function (aUids)
	{
		this.aRequestedThreadUids = _.union(this.aRequestedThreadUids, aUids);
	};

	/**
	 * @param {string} sUid
	 */
	CFolderModel.prototype.hasThreadUidBeenRequested = function (sUid)
	{
		return _.indexOf(this.aRequestedThreadUids, sUid) !== -1;
	};

	/**
	 * @param {Object} oParams
	 */
	CFolderModel.prototype.hasListBeenRequested = function (oParams)
	{
		var
			aFindedParams = _.where(this.requestedLists, oParams),
			bHasParams = aFindedParams.length > 0
		;
		
		if (!bHasParams)
		{
			this.requestedLists.push(oParams);
		}
		return bHasParams;
	};

	/**
	 * @param {string} sUid
	 * @param {string} sReplyType
	 */
	CFolderModel.prototype.markMessageReplied = function (sUid, sReplyType)
	{
		var oMsg = this.oMessages[sUid];
		
		if (oMsg)
		{
			switch (sReplyType)
			{
				case Enums.ReplyType.Reply:
				case Enums.ReplyType.ReplyAll:
					oMsg.answered(true);
					break;
				case Enums.ReplyType.Forward:
				case Enums.ReplyType.ForwardAsAttach:
					oMsg.forwarded(true);
					break;
			}
		}
	};

	CFolderModel.prototype.removeAllMessages = function ()
	{
		var oUidList = null;
		
		this.oMessages = {};
		this.oUids = {};

		this.messageCount(0);
		this.unseenMessageCount(0);
		this.sRealUnseenMessageCount = 0;
		
		oUidList = this.getUidList('', '');
		oUidList.resultCount(0);
	};

	CFolderModel.prototype.removeAllMessageListsFromCacheIfHasChanges = function ()
	{
		if (this.hasChanges())
		{
			this.oUids = {};
			this.requestedLists = [];
			this.aRequestedThreadUids = [];
			this.hasChanges(false);
		}
	};

	CFolderModel.prototype.removeFlaggedMessageListsFromCache = function ()
	{
		_.each(this.oUids, function (oSearchUids, sSearch) {
			delete this.oUids[sSearch][Enums.FolderFilter.Flagged];
		}, this);
	};

	CFolderModel.prototype.removeUnseenMessageListsFromCache = function ()
	{
		_.each(this.oUids, function (oSearchUids, sSearch) {
			delete this.oUids[sSearch][Enums.FolderFilter.Unseen];
		}, this);
	};

	/**
	 * @param {string} sUidNext
	 * @param {string} sHash
	 * @param {number} iMsgCount
	 * @param {number} iMsgUnseenCount
	 * @param {boolean} bUpdateOnlyRealData
	 */
	CFolderModel.prototype.setRelevantInformation = function (sUidNext, sHash, iMsgCount, iMsgUnseenCount, bUpdateOnlyRealData)
	{
		var hasChanges = this.hasExtendedInfo() && (this.sHash !== sHash || this.sRealUnseenMessageCount !== iMsgUnseenCount);
		
		if (!bUpdateOnlyRealData)
		{
			this.sUidNext = sUidNext;
		}
		this.sHash = sHash; // if different, either new messages were appeared, or some messages were deleted
		if (!this.hasExtendedInfo() || !bUpdateOnlyRealData)
		{
			this.messageCount(iMsgCount);
			this.unseenMessageCount(iMsgUnseenCount);
			if (iMsgUnseenCount === 0) { this.unseenMessageCount.valueHasMutated(); } //fix for folder count summing
		}
		this.sRealUnseenMessageCount = iMsgUnseenCount;
		this.hasExtendedInfo(true);

		if (hasChanges)
		{
			this.markHasChanges();
		}
		
		this.relevantInformationLastMoment = moment(); // Date and time of last updating of the folder information.
		
		return hasChanges;
	};

	CFolderModel.prototype.increaseCountIfHasNotInfo = function ()
	{
		if (!this.hasExtendedInfo())
		{
			this.messageCount(this.messageCount() + 1);
		}
	};

	CFolderModel.prototype.markHasChanges = function ()
	{
		this.hasChanges(true);
	};

	/**
	 * @param {number} iDiff
	 * @param {number} iUnseenDiff
	 */
	CFolderModel.prototype.addMessagesCountsDiff = function (iDiff, iUnseenDiff)
	{
		var
			iCount = this.messageCount() + iDiff,
			iUnseenCount = this.unseenMessageCount() + iUnseenDiff
		;

		if (iCount < 0)
		{
			iCount = 0;
		}
		this.messageCount(iCount);

		if (iUnseenCount < 0)
		{
			iUnseenCount = 0;
		}
		if (iUnseenCount > iCount)
		{
			iUnseenCount = iCount;
		}
		this.unseenMessageCount(iUnseenCount);
	};

	/**
	 * @param {Array} aUids
	 */
	CFolderModel.prototype.markDeletedByUids = function (aUids)
	{
		var
			iMinusDiff = 0,
			iUnseenMinusDiff = 0
		;

		_.each(aUids, function (sUid)
		{
			var oMessage = this.oMessages[sUid];

			if (oMessage)
			{
				iMinusDiff++;
				if (!oMessage.seen())
				{
					iUnseenMinusDiff++;
				}
				oMessage.deleted(true);
			}

		}, this);

		this.addMessagesCountsDiff(-iMinusDiff, -iUnseenMinusDiff);
		
		return {MinusDiff: iMinusDiff, UnseenMinusDiff: iUnseenMinusDiff};
	};

	/**
	 * @param {Array} aUids
	 */
	CFolderModel.prototype.revertDeleted = function (aUids)
	{
		var
			iPlusDiff = 0,
			iUnseenPlusDiff = 0
		;

		_.each(aUids, function (sUid)
		{
			var oMessage = this.oMessages[sUid];

			if (oMessage && oMessage.deleted())
			{
				iPlusDiff++;
				if (!oMessage.seen())
				{
					iUnseenPlusDiff++;
				}
				oMessage.deleted(false);
			}

		}, this);

		this.addMessagesCountsDiff(iPlusDiff, iUnseenPlusDiff);

		return {PlusDiff: iPlusDiff, UnseenPlusDiff: iUnseenPlusDiff};
	};

	/**
	 * @param {Array} aUids
	 */
	CFolderModel.prototype.commitDeleted = function (aUids)
	{
		_.each(aUids, _.bind(function (sUid) {
			delete this.oMessages[sUid];
		}, this));
		
		_.each(this.oUids, function (oUidSearchList) {
			_.each(oUidSearchList, function (oUidList) {
				oUidList.deleteUids(aUids);
			});
		});
	};

	/**
	 * @param {string} sSearch
	 * @param {string} sFilters
	 */
	CFolderModel.prototype.getUidList = function (sSearch, sFilters)
	{
		var
			oUidList = null
		;
		
		if (this.oUids[sSearch] === undefined)
		{
			this.oUids[sSearch] = {};
		}
		
		if (this.oUids[sSearch][sFilters] === undefined)
		{
			oUidList = new CUidListModel();
			oUidList.search(sSearch);
			oUidList.filters(sFilters);
			this.oUids[sSearch][sFilters] = oUidList;
		}
		
		return this.oUids[sSearch][sFilters];
	};

	/**
	 * @param {number} iLevel
	 * @param {string} sFullName
	 */
	CFolderModel.prototype.initStarredFolder = function (iLevel, sFullName)
	{
		this.bVirtual = true;
		this.setLevel(iLevel);
		this.fullName(sFullName);
		this.name(TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_STARRED'));
		this.type(Enums.FolderTypes.Starred);
		this.initSubscriptions('');
		this.initComputedFields(true);
	};

	/**
	 * @param {Object} oData
	 * @param {string} sParentFullName
	 * @param {string} sNamespaceFolder
	 */
	CFolderModel.prototype.parse = function (oData, sParentFullName, sNamespaceFolder)
	{
		var
			sName = '',
			iType = Enums.FolderTypes.User,
			aFolders = Storage.getData('folderAccordion') || []
		;

		if (oData['@Object'] === 'Object/Folder')
		{
			sName = Types.pString(oData.Name);
			
			this.name(sName);
			this.nameForEdit(sName);
			this.fullName(Types.pString(oData.FullNameRaw));
			this.fullNameHash(Types.pString(oData.FullNameHash));
			this.sDelimiter = oData.Delimiter;
			
			iType = Types.pInt(oData.Type);
			if (Settings.AllowSpamFolder || iType !== Enums.FolderTypes.Spam)
			{
				this.type(oData.Type);
			}
			this.bNamespace = (sNamespaceFolder === this.fullName());
			
			this.subscribed(oData.IsSubscribed);
			this.bSelectable = oData.IsSelectable;
			this.bExists = oData.Exists;
			
			if (oData.Extended)
			{
				this.setRelevantInformation(oData.Extended.UidNext.toString(), oData.Extended.Hash, 
					oData.Extended.MessageCount, oData.Extended.MessageUnseenCount, false);
			}

			if (_.find(aFolders, function (sFolder) { return sFolder === this.name(); }, this))
			{
				this.expanded(true);
			}

			this.initSubscriptions(sParentFullName);
			this.initComputedFields();
			
			return oData.SubFolders;
		}

		return null;
	};

	/**
	 * @param {string} sParentFullName
	 */
	CFolderModel.prototype.initSubscriptions = function (sParentFullName)
	{
		this.requireMailCache();
		this.unseenMessageCount.subscribe(function () {
			_.delay(_.bind(function () {
				MailCache.countMessages(this);
			},this), 1000);
		}, this);
		
		this.subscribed.subscribe(function () {
			if (sParentFullName)
			{
				var oParentFolder = MailCache.folderList().getFolderByFullName(sParentFullName);
				if(oParentFolder)
				{
					MailCache.countMessages(oParentFolder);
				}
			}
		}, this);
		
		this.edited.subscribe(function (bEdited) {
			if (bEdited === false)
			{
				this.nameForEdit(this.name());
			}
		}, this);
		
		this.hasChanges.subscribe(function () {
			this.requestedLists = [];
		}, this);
	};

	CFolderModel.prototype.initComputedFields = function ()
	{
		this.routingHash = ko.computed(function () {
			// At the moment the application supports only one type of virtual folders - for starred messages.
			if (this.bVirtual)
			{
				return Routing.buildHashFromArray(LinksUtils.getMailbox(this.fullName(), 1, '', '', Enums.FolderFilter.Flagged));
			}
			else
			{
				return Routing.buildHashFromArray(LinksUtils.getMailbox(this.fullName()));
			}
		}, this);
		
		this.isSystem = ko.computed(function () {
			return this.type() !== Enums.FolderTypes.User;
		}, this);

		this.showUnseenMessages = ko.computed(function () {
			return this.type() !== Enums.FolderTypes.Drafts;
		}, this);
		
		this.withoutThreads = ko.computed(function () {
			return	this.type() === Enums.FolderTypes.Drafts || 
					this.type() === Enums.FolderTypes.Spam ||
					this.type() === Enums.FolderTypes.Trash;
		}, this);

		this.enableEmptyFolder = ko.computed(function () {
			return (this.type() === Enums.FolderTypes.Spam ||
					this.type() === Enums.FolderTypes.Trash) &&
					this.messageCount() > 0;
		}, this);

		this.virtualEmpty = ko.computed(function () {
			return this.bVirtual && this.messageCount() === 0;
		}, this);
		
		// indicates if folder has at least one subscribed subfolder
		this.hasSubscribedSubfolders = ko.computed(function () {
			return _.any(this.subfolders(), function (oFolder) {
				return oFolder.subscribed();
			});
		}, this);

		// indicates if folder can be expanded, i.e. folder is not namespace and has at least one subscribed subfolder
		this.canExpand = ko.computed(function () {
			return !this.bNamespace && this.hasSubscribedSubfolders();
		}, this);
		
		this.messageCountToShow = ko.computed(function () {
			if (!App.isMobile() && this.canExpand())
			{
				return (this.showUnseenMessages()) ? this.unseenMessageCount() + this.subfoldersMessagesCount() : this.messageCount();
			}
			else
			{
				return (this.showUnseenMessages()) ? this.unseenMessageCount() : this.messageCount();
			}
		}, this);
		
		this.visible = ko.computed(function () {
			return this.subscribed() || this.isSystem() || (this.hasSubscribedSubfolders() && (!this.bExists || !this.bSelectable));
		}, this);

		this.bCanBeSelected = this.bExists && this.bSelectable;
		
		this.canSubscribe = ko.computed(function () {
			return !this.isSystem() && this.bCanBeSelected;
		}, this);
		
		this.canDelete = ko.computed(function () {
			return (!this.isSystem() && this.hasExtendedInfo() && this.messageCount() === 0 && this.subfolders().length === 0);
		}, this);

		this.canRename = ko.computed(function () {
			return (this.bCanBeSelected && !this.isSystem());
		}, this);

		this.subscribeButtonHint = ko.computed(function () {
			if (this.canSubscribe())
			{
				return this.subscribed() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_HIDE_FOLDER') : TextUtils.i18n('MAILWEBCLIENT/ACTION_SHOW_FOLDER');
			}
			return '';
		}, this);
		
		this.deleteButtonHint = ko.computed(function () {
			return this.canDelete() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_DELETE_FOLDER') : '';
		}, this);
		
		this.usedAs = ko.computed(function () {
			switch (this.type())
			{
				case Enums.FolderTypes.Inbox:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_USED_AS_INBOX');
				case Enums.FolderTypes.Sent:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_USED_AS_SENT');
				case Enums.FolderTypes.Drafts:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_USED_AS_DRAFTS');
				case Enums.FolderTypes.Trash:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_USED_AS_TRASH');
				case Enums.FolderTypes.Spam:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_USED_AS_SPAM');
			}
			return '';
		}, this);

		this.displayName = ko.computed(function () {
			switch (this.type())
			{
				case Enums.FolderTypes.Inbox:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_INBOX');
				case Enums.FolderTypes.Sent:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_SENT');
				case Enums.FolderTypes.Drafts:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_DRAFTS');
				case Enums.FolderTypes.Trash:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_TRASH');
				case Enums.FolderTypes.Spam:
					return TextUtils.i18n('MAILWEBCLIENT/LABEL_FOLDER_SPAM');
			}
			return this.name();
		}, this);
		
		this.unseenMessagesTitle = ko.computed(function () {
			return this.showUnseenMessages() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_SHOW_UNREAD_MESSAGES') : '';
		}, this);
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CFolderModel.prototype.onGetMessageResponse = function (oResponse, oRequest)
	{
		var
			oResult = oResponse.Result,
			oParameters = oRequest.Parameters,
			oHand = null,
			sUid = oResult ? oResult.Uid.toString() : oParameters.Uid.toString(),
			oMessage = this.oMessages[sUid],
			bSelected = oMessage ? oMessage.selected() : false
		;
		
		if (!oResult)
		{
			if (bSelected)
			{
				Api.showErrorByCode(oResponse, TextUtils.i18n('COREWEBCLIENT/ERROR_UNKNOWN'));
				Routing.replaceHashWithoutMessageUid(sUid);
			}
			
			oMessage = null;
		}
		else
		{
			oMessage = this.parseAndCacheMessage(oResult, false, false);
		}

		oHand = this.aResponseHandlers[sUid];
		if (oHand)
		{
			oHand.handler.call(oHand.context, oMessage, sUid);
			delete this.aResponseHandlers[sUid];
		}
	};

	/**
	 * @param {string} sUid
	 * @param {Function} fResponseHandler
	 * @param {Object} oContext
	 */
	CFolderModel.prototype.getCompletelyFilledMessage = function (sUid, fResponseHandler, oContext)
	{
		var
			oMessage = this.oMessages[sUid],
			oParameters = {
				'AccountID': oMessage ? oMessage.accountId() : 0,
				'Folder': this.fullName(),
				'Uid': sUid
			}
		;

		if (sUid.length > 0)
		{
			if (!oMessage || !oMessage.completelyFilled() || oMessage.trimmed())
			{
				if (fResponseHandler && oContext)
				{
					this.aResponseHandlers[sUid] = {handler: fResponseHandler, context: oContext};
				}
				
				Ajax.send('GetMessage', oParameters, this.onGetMessageResponse, this);
			}
			else if (fResponseHandler && oContext)
			{
				fResponseHandler.call(oContext, oMessage, sUid);
			}
		}
	};

	/**
	 * @param {string} sUid
	 */
	CFolderModel.prototype.showExternalPictures = function (sUid)
	{
		var oMessage = this.oMessages[sUid];

		if (oMessage !== undefined)
		{
			oMessage.showExternalPictures();
		}
	};

	/**
	 * @param {string} sEmail
	 */
	CFolderModel.prototype.alwaysShowExternalPicturesForSender = function (sEmail)
	{
		_.each(this.oMessages, function (oMessage)
		{
			var aFrom = oMessage.oFrom.aCollection;
			if (aFrom.length > 0 && aFrom[0].sEmail === sEmail)
			{
				oMessage.alwaysShowExternalPicturesForSender();
			}
		}, this);
	};

	/**
	 * @param {string} sField
	 * @param {Array} aUids
	 * @param {boolean} bSetAction
	 */
	CFolderModel.prototype.executeGroupOperation = function (sField, aUids, bSetAction)
	{
		var iUnseenDiff = 0;

		_.each(this.oMessages, function (oMessage)
		{
			if (aUids.length > 0)
			{
				_.each(aUids, function (sUid)
				{
					if (oMessage && oMessage.uid() === sUid && oMessage[sField]() !== bSetAction)
					{
						oMessage[sField](bSetAction);
						iUnseenDiff++;
					}
				});
			}
			else
			{
				oMessage[sField](bSetAction);
			}
		});

		if (aUids.length === 0)
		{
			iUnseenDiff = (bSetAction) ? this.unseenMessageCount() : this.messageCount() - this.unseenMessageCount();
		}

		if (sField === 'seen' && iUnseenDiff > 0)
		{
			if (bSetAction)
			{
				this.addMessagesCountsDiff(0, -iUnseenDiff);
			}
			else
			{
				this.addMessagesCountsDiff(0, iUnseenDiff);
			}
			this.markHasChanges();
		}
	};

	CFolderModel.prototype.emptyFolder = function ()
	{
		var
			sWarning = TextUtils.i18n('MAILWEBCLIENT/CONFIRM_EMPTY_FOLDER'),
			fCallBack = _.bind(this.clearFolder, this)
		;
		
		if (this.enableEmptyFolder())
		{
			Popups.showPopup(ConfirmPopup, [sWarning, fCallBack]);
		}
	};

	/**
	 * @param {boolean} bOkAnswer
	 */
	CFolderModel.prototype.clearFolder = function (bOkAnswer)
	{
		if (this.enableEmptyFolder() && bOkAnswer)
		{
			Ajax.send('ClearFolder', { 'Folder': this.fullName() });

			this.removeAllMessages();

			this.requireMailCache();
			MailCache.onClearFolder(this);
		}
	};

	/**
	 * @param {Object} oFolder
	 * @param {Object} oEvent
	 */
	CFolderModel.prototype.onAccordion = function (oFolder, oEvent)
	{
		var
			bExpanded = !this.expanded(),
			aFolders = Storage.getData('folderAccordion') || []
		;

		if (bExpanded)
		{
			aFolders.push(this.name());
		}
		else
		{
			// remove current folder from expanded folders
			aFolders = _.reject(aFolders, function (sFolder) { return sFolder === this.name(); }, this);
		}

		Storage.setData('folderAccordion', aFolders);
		this.expanded(bExpanded);

		this.requireMailCache();
		MailCache.countMessages(this);
		
		if (oEvent)
		{
			oEvent.stopPropagation();
		}
	};

	CFolderModel.prototype.executeUnseenFilter = function ()
	{
		var bNotChanged = false;
		
		if (this.messageCountToShow() > this.unseenMessageCount())
		{
			this.onAccordion();
		}
		
		if (this.showUnseenMessages() && this.unseenMessageCount() > 0)
		{
			this.requireMailCache();
			MailCache.waitForUnseenMessages(true);
			bNotChanged = Routing.setHash(LinksUtils.getMailbox(this.fullName(), 1, '', '', Enums.FolderFilter.Unseen));

			if (bNotChanged)
			{
				MailCache.changeCurrentMessageList(this.fullName(), 1, '', Enums.FolderFilter.Unseen);
			}
			return false;
		}
		
		return true;
	};

	CFolderModel.prototype.onDeleteClick = function ()
	{
		var
			sWarning = TextUtils.i18n('MAILWEBCLIENT/CONFIRM_DELETE_FOLDER'),
			fCallBack = _.bind(this.deleteAfterConfirm, this)
		;
		
		if (this.canDelete())
		{
			Popups.showPopup(ConfirmPopup, [sWarning, fCallBack]);
		}
		else
		{
			App.broadcastEvent('MailWebclient::AttemptDeleteNonemptyFolder');
		}
	};

	/**
	 * @param {boolean} bOkAnswer
	 */
	CFolderModel.prototype.deleteAfterConfirm = function (bOkAnswer)
	{
		if (bOkAnswer)
		{
			var
				oFolderList = MailCache.editedFolderList(),
				sFolderFullName = this.fullName(),
				fRemoveFolder = function (oFolder) {
					if (sFolderFullName === oFolder.fullName())
					{
						return true;
					}
					oFolder.subfolders.remove(fRemoveFolder);
					return false;
				}
			;

			oFolderList.collection.remove(fRemoveFolder);

			Ajax.send('DeleteFolder', {
				'AccountID': AccountList.editedId(),
				'Folder': this.fullName()
			}, function (oResponse) {
				if (!oResponse.Result)
				{
					Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_DELETE_FOLDER'));
					MailCache.getFolderList(AccountList.editedId());
				}
			}, this);
		}
	};

	CFolderModel.prototype.onSubscribeClick = function ()
	{
		if (this.canSubscribe())
		{
			var
				oParameters = {
					'AccountID': AccountList.editedId(),
					'Folder': this.fullName(),
					'SetAction': !this.subscribed()
				}
			;

			this.subscribed(!this.subscribed());
			
			Ajax.send('SubscribeFolder', oParameters, function (oResponse) {
				if (!oResponse.Result)
				{
					if (this.subscribed())
					{
						Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_SUBSCRIBE_FOLDER'));
					}
					else
					{
						Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_UNSUBSCRIBE_FOLDER'));
					}
					MailCache.getFolderList(AccountList.editedId());
				}
			}, this);
		}
	};

	CFolderModel.prototype.afterMove = function (aParents)
	{
		_.each(aParents, function (oParent) {
			if (oParent.constructor.name === 'CAccountFoldersPaneView')
			{
				oParent.afterMove();
			}
		});
	};

	CFolderModel.prototype.cancelNameEdit = function ()
	{
		this.edited(false);
	};

	CFolderModel.prototype.applyNameEdit = function ()
	{
		if (this.name() !== this.nameForEdit())
		{
			var
				oParameters = {
					'AccountID': AccountList.editedId(),
					'PrevFolderFullNameRaw': this.fullName(),
					'NewFolderNameInUtf8': this.nameForEdit()
				}
			;

			Ajax.send('RenameFolder', oParameters, _.bind(this.onResponseFolderRename, this), this);
			this.name(this.nameForEdit());
		}
		
		this.edited(false);
	};

	CFolderModel.prototype.onResponseFolderRename = function (oResponse, oRequest)
	{
		if (!oResponse || !oResponse.Result)
		{
			Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_RENAME_FOLDER'));
			MailCache.getFolderList(AccountList.editedId());
		}
		else if (oResponse && oResponse.Result && oResponse.Result.FullName)
		{
			var oFolderList = MailCache.editedFolderList();
			oFolderList.renameFolder(this.fullName(), oResponse.Result.FullName, oResponse.Result.FullNameHash);
		}
	};

	module.exports = CFolderModel;


/***/ }),

/***/ 430:
/*!**********************************************************!*\
  !*** ./modules/MailWebclient/js/models/CUidListModel.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
	;

	/**
	 * @constructor
	 * 
	 * !!!Attention!!!
	 * It is not used underscore, because the collection may contain undefined-elements.
	 * They have their own importance. But all underscore-functions removes them automatically.
	 */
	function CUidListModel()
	{
		this.resultCount = ko.observable(-1);
		
		this.search = ko.observable('');
		this.filters = ko.observable('');
		
		this.collection = ko.observableArray([]);
		
		this.threadUids = {};
	}

	/**
	 * @param {string} sUid
	 * @param {Array} aThreadUids
	 */
	CUidListModel.prototype.addThreadUids = function (sUid, aThreadUids)
	{
		if (-1 !== _.indexOf(this.collection(), sUid))
		{
			this.threadUids[sUid] = aThreadUids;
		}
	};

	/**
	 * @param {Object} oResult
	 */
	CUidListModel.prototype.setUidsAndCount = function (oResult)
	{
		if (oResult['@Object'] === 'Collection/MessageCollection')
		{
			_.each(oResult.Uids, function (sUid, iIndex) {
				
				this.collection()[iIndex + oResult.Offset] = sUid.toString();

			}, this);

			this.resultCount(oResult.MessageResultCount);
		}
	};

	/**
	 * @param {number} iOffset
	 * @param {Object} oMessages
	 */
	CUidListModel.prototype.getUidsForOffset = function (iOffset, oMessages)
	{
		var
			iIndex = 0,
			iLen = this.collection().length,
			sUid = '',
			iExistsCount = 0,
			aUids = [],
			oMsg = null
		;
		
		for(; iIndex < iLen; iIndex++)
		{
			if (iIndex >= iOffset && iExistsCount < Settings.MailsPerPage) {
				sUid = this.collection()[iIndex];
				oMsg = oMessages[sUid];

				if (oMsg && !oMsg.deleted() || sUid === undefined)
				{
					iExistsCount++;
					if (sUid !== undefined)
					{
						aUids.push(sUid);
					}
				}
			}
		}
		
		return aUids;
	};

	/**
	 * @param {Array} aUids
	 */
	CUidListModel.prototype.deleteUids = function (aUids)
	{
		var
			iIndex = 0,
			iLen = this.collection().length,
			sUid = '',
			aNewCollection = [],
			iDiff = 0
		;
		
		for (; iIndex < iLen; iIndex++)
		{
			sUid = this.collection()[iIndex];
			if (_.indexOf(aUids, sUid) === -1)
			{
				aNewCollection.push(sUid);
			}
			else
			{
				iDiff++;
			}
		}
		
		this.collection(aNewCollection);
		this.resultCount(this.resultCount() - iDiff);
	};

	module.exports = CUidListModel;

/***/ }),

/***/ 431:
/*!************************************************!*\
  !*** ./modules/MailWebclient/js/Prefetcher.js ***!
  \************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		
		Prefetcher = {},
		bFetchersIdentitiesPrefetched = false
	;

	Prefetcher.prefetchFetchersIdentities = function ()
	{
		if (!App.isNewTab() && !bFetchersIdentitiesPrefetched && (Settings.AllowFetchers || Settings.AllowIdentities))
		{
			AccountList.populateFetchersIdentities();
			bFetchersIdentitiesPrefetched = true;
			
			return true;
		}
		return false;
	};

	Prefetcher.prefetchAccountFilters = function ()
	{
		var oAccount = AccountList.getCurrent();
		
		if (oAccount && !oAccount.filters() && Settings.AllowFilters)
		{
			oAccount.requestFilters();
		}
	};

	Prefetcher.prefetchStarredMessageList = function ()
	{
		var
			oFolderList = MailCache.folderList(),
			oInbox = oFolderList ? oFolderList.inboxFolder() : null,
			oRes = null
		;

		if (oInbox && !oInbox.hasChanges())
		{
			oRes = MailCache.requestMessageList(oInbox.fullName(), 1, '', Enums.FolderFilter.Flagged, false, false);
		}

		return oRes && oRes.RequestStarted;
	};

	Prefetcher.prefetchUnseenMessageList = function ()
	{
		var
			oFolderList = MailCache.folderList(),
			oInbox = oFolderList ? oFolderList.inboxFolder() : null,
			oRes = null
		;

		if (oInbox && !oInbox.hasChanges())
		{
			oRes = MailCache.requestMessageList(oInbox.fullName(), 1, '', Enums.FolderFilter.Unseen, false, false);
		}

		return oRes && oRes.RequestStarted;
	};

	/**
	 * @param {string} sCurrentUid
	 */
	Prefetcher.prefetchNextPage = function (sCurrentUid)
	{
		var
			oUidList = MailCache.uidList(),
			iIndex = _.indexOf(oUidList.collection(), sCurrentUid),
			iPage = Math.ceil(iIndex/Settings.MailsPerPage) + 1
		;
		this.startPagePrefetch(iPage - 1);
	};

	/**
	 * @param {string} sCurrentUid
	 */
	Prefetcher.prefetchPrevPage = function (sCurrentUid)
	{
		var
			oUidList = MailCache.uidList(),
			iIndex = _.indexOf(oUidList.collection(), sCurrentUid),
			iPage = Math.ceil((iIndex + 1)/Settings.MailsPerPage) + 1
		;
		this.startPagePrefetch(iPage);
	};

	/**
	 * @param {number} iPage
	 */
	Prefetcher.startPagePrefetch = function (iPage)
	{
		var
			oCurrFolder = MailCache.folderList().currentFolder(),
			oUidList = MailCache.uidList(),
			iOffset = (iPage - 1) * Settings.MailsPerPage,
			bPageExists = iPage > 0 && iOffset < oUidList.resultCount(),
			oParams = null,
			oRequestData = null
		;
		
		if (oCurrFolder && !oCurrFolder.hasChanges() && bPageExists)
		{
			oParams = {
				folder: oCurrFolder.fullName(),
				page: iPage,
				search: oUidList.search()
			};
			
			if (!oCurrFolder.hasListBeenRequested(oParams))
			{
				oRequestData = MailCache.requestMessageList(oParams.folder, oParams.page, oParams.search, '', false, false);
			}
		}
		
		return oRequestData && oRequestData.RequestStarted;
	};

	Prefetcher.startOtherFoldersPrefetch = function ()
	{
		var
			oFolderList = MailCache.folderList(),
			sCurrFolder = oFolderList.currentFolderFullName(),
			aFoldersFromAccount = AccountList.getCurrentFetchersAndFiltersFolderNames(),
			aSystemFolders = oFolderList ? [oFolderList.inboxFolderFullName(), oFolderList.sentFolderFullName(), oFolderList.draftsFolderFullName(), oFolderList.spamFolderFullName()] : [],
			aOtherFolders = (aFoldersFromAccount.length < 3) ? this.getOtherFolderNames(3 - aFoldersFromAccount.length) : [],
			aFolders = _.uniq(_.compact(_.union(aSystemFolders, aFoldersFromAccount, aOtherFolders))),
			bPrefetchStarted = false
		;

		_.each(aFolders, _.bind(function (sFolder) {
			if (!bPrefetchStarted && sCurrFolder !== sFolder)
			{
				bPrefetchStarted = this.startFolderPrefetch(oFolderList.getFolderByFullName(sFolder));
			}
		}, this));

		return bPrefetchStarted;
	};

	/**
	 * @param {number} iCount
	 * @returns {Array}
	 */
	Prefetcher.getOtherFolderNames = function (iCount)
	{
		var
			oInbox = MailCache.folderList().inboxFolder(),
			aInboxSubFolders = oInbox ? oInbox.subfolders() : [],
			aOtherFolders = _.filter(MailCache.folderList().collection(), function (oFolder) {
				return !oFolder.isSystem();
			}, this),
			aFolders = _.first(_.union(aInboxSubFolders, aOtherFolders), iCount)
		;
		
		return _.map(aFolders, function (oFolder) {
			return oFolder.fullName();
		});
	};

	/**
	 * @param {Object} oFolder
	 */
	Prefetcher.startFolderPrefetch = function (oFolder)
	{
		var
			iPage = 1,
			sSearch = '',
			oParams = {
				folder: oFolder ? oFolder.fullName() : '',
				page: iPage,
				search: sSearch
			},
			oRequestData = null
		;

		if (oFolder && !oFolder.hasListBeenRequested(oParams))
		{
			oRequestData = MailCache.requestMessageList(oParams.folder, oParams.page, oParams.search, '', false, false);
		}

		return !!oRequestData && oRequestData.RequestStarted;
	};

	Prefetcher.startThreadListPrefetch = function ()
	{
		var
			aUidsForLoad = [],
			oCurrFolder = MailCache.getCurrentFolder()
		;

		_.each(MailCache.messages(), function (oCacheMess) {
			if (oCacheMess.threadCount() > 0)
			{
				_.each(oCacheMess.threadUids(), function (sThreadUid) {
					var oThreadMess = oCurrFolder.oMessages[sThreadUid];
					if (!oThreadMess && !oCurrFolder.hasThreadUidBeenRequested(sThreadUid))
					{
						aUidsForLoad.push(sThreadUid);
					}
				});
			}
		}, this);

		if (aUidsForLoad.length > 0)
		{
			aUidsForLoad = aUidsForLoad.slice(0, Settings.MailsPerPage);
			oCurrFolder.addRequestedThreadUids(aUidsForLoad);
			oCurrFolder.loadThreadMessages(aUidsForLoad);
			return true;
		}

		return false;
	};

	Prefetcher.startMessagesPrefetch = function ()
	{
		var
			iAccountId = MailCache.currentAccountId(),
			oCurrFolder = MailCache.getCurrentFolder(),
			iTotalSize = 0,
			iMaxSize = Settings.MaxMessagesBodiesSizeToPrefetch,
			aUids = [],
			oParameters = null,
			iJsonSizeOf1Message = 2048,
			fFillUids = function (oMsg) {
				var
					bNotFilled = (!oMsg.deleted() && !oMsg.completelyFilled()),
					bUidNotAdded = !_.find(aUids, function (sUid) {
						return sUid === oMsg.uid();
					}, this),
					bHasNotBeenRequested = !oCurrFolder.hasUidBeenRequested(oMsg.uid())
				;

				if (iTotalSize < iMaxSize && bNotFilled && bUidNotAdded && bHasNotBeenRequested)
				{
					aUids.push(oMsg.uid());
					iTotalSize += oMsg.trimmedTextSize() + iJsonSizeOf1Message;
				}
			}
		;

		if (oCurrFolder && oCurrFolder.selected())
		{
			_.each(MailCache.messages(), fFillUids);
			_.each(oCurrFolder.oMessages, fFillUids);

			if (aUids.length > 0)
			{
				oCurrFolder.addRequestedUids(aUids);

				oParameters = {
					'AccountID': iAccountId,
					'Folder': oCurrFolder.fullName(),
					'Uids': aUids
				};

				Ajax.send('GetMessagesBodies', oParameters, this.onGetMessagesBodiesResponse, this);
				return true;
			}
		}

		return false;
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	Prefetcher.onGetMessagesBodiesResponse = function (oResponse, oRequest)
	{
		var
			oParameters = oRequest.Parameters,
			oFolder = MailCache.getFolderByFullName(oParameters.AccountID, oParameters.Folder)
		;
		
		if (_.isArray(oResponse.Result))
		{
			_.each(oResponse.Result, function (oRawMessage) {
				oFolder.parseAndCacheMessage(oRawMessage, false, false);
			});
		}
	};

	Prefetcher.prefetchAccountQuota = function ()
	{
		var
			oAccount = AccountList.getCurrent(),
			bNeedQuotaRequest = oAccount && !oAccount.quotaRecieved()
		;
		
		if (UserSettings.ShowQuotaBar && bNeedQuotaRequest)
		{
			oAccount.updateQuotaParams();
			return true;
		}
		
		return false;
	};

	module.exports = {
		startMin: function () {
			var bPrefetchStarted = false;
			
			bPrefetchStarted = Prefetcher.prefetchFetchersIdentities();
			
			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchAccountFilters();
			}
			
			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchStarredMessageList();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchAccountQuota();
			}
			
			return bPrefetchStarted;
		},
		startAll: function () {
			var bPrefetchStarted = false;
			
			bPrefetchStarted = Prefetcher.prefetchFetchersIdentities();
			
			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchAccountFilters();
			}
			
			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.startMessagesPrefetch();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.startThreadListPrefetch();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchStarredMessageList();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.startPagePrefetch(MailCache.page() + 1);
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.startPagePrefetch(MailCache.page() - 1);
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchUnseenMessageList();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.prefetchAccountQuota();
			}

			if (!bPrefetchStarted)
			{
				bPrefetchStarted = Prefetcher.startOtherFoldersPrefetch();
			}
			
			return bPrefetchStarted;
		},
		prefetchStarredMessageList: function () {
			Prefetcher.prefetchStarredMessageList();
		},
		startFolderPrefetch: function (oFolder) {
			Prefetcher.startFolderPrefetch(oFolder);
		},
		prefetchNextPage: function (sCurrentUid) {
			Prefetcher.prefetchNextPage(sCurrentUid);
		},
		prefetchPrevPage: function (sCurrentUid) {
			Prefetcher.prefetchPrevPage(sCurrentUid);
		}
	};


/***/ }),

/***/ 432:
/*!************************************************!*\
  !*** ./modules/MailWebclient/js/koBindings.js ***!
  \************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		ComposeMessageToAddressesFunc = ModulesManager.run('MailWebclient', 'getComposeMessageToAddresses')
	;

	if ($.isFunction(ComposeMessageToAddressesFunc))
	{
		ko.bindingHandlers.makeLinkComposeMailTo = {
			'update': function (oElement, fValueAccessor, fAllBindingsAccessor, oViewModel, bindingContext) {
				var
					$Element = $(oElement),
					sFullEmail = fValueAccessor()
				;

				$Element.show();
				if (!$Element.hasClass('button'))
				{
					$Element.addClass('link');
				}
				$Element.click(function () {
					ComposeMessageToAddressesFunc(sFullEmail);
				});
			}
		};
	}

	ko.bindingHandlers.moveToFolderFilter = {

		'init': function (oElement, fValueAccessor, allBindingsAccessor, viewModel, bindingContext) {
			var
				jqElement = $(oElement),
				oCommand = fValueAccessor(),
				jqContainer = $(oElement).find(oCommand['container']),
				aOptions = _.isArray(oCommand['options']) ? oCommand['options'] : oCommand['options'](),
				sFolderName = oCommand['value'] ? oCommand['value']() : '',
				oFolderOption = _.find(aOptions, function (oOption) {
					return oOption[oCommand['optionsValue']] === sFolderName;
				})
			;

			if (!oFolderOption)
			{
				sFolderName = '';
				oCommand['value']('');
			}

			jqElement.removeClass('expand');
			
			jqContainer.empty();

			_.each(aOptions, function (oOption) {
				var jqOption = $('<span class="item"></span>')
					.text(oOption[oCommand['optionsText']])
					.data('value', oOption[oCommand['optionsValue']]);

				if (sFolderName === oOption[oCommand['optionsValue']])
				{
					jqOption.addClass('selected');
				}
				
				oOption['jq'] = jqOption;
				
				jqContainer.append(jqOption);
			});
			
			jqContainer.on('click', '.item', function () {
				var sFolderName = $(this).data('value');
				oCommand['value'](sFolderName);
			});

			jqElement.click(function () {
				jqElement.toggleClass('expand');

				if (jqElement.hasClass('expand'))
				{
					_.defer(function () {
						$(document).one('click', function () {
							jqElement.removeClass('expand');
						});
					});
				}
			});
		},
		'update': function (oElement, fValueAccessor) {
			var
				jqElement = $(oElement),
				oCommand = fValueAccessor(),
				aOptions = _.isArray(oCommand['options']) ? oCommand['options'] : oCommand['options'](),
				sFolderName = oCommand['value'] ? oCommand['value']() : '',
				oFolderOption = _.find(aOptions, function (oOption) {
					return oOption[oCommand['optionsValue']] === sFolderName;
				}),
				jqText = jqElement.find('.link')
			;
			
			_.each(aOptions, function (oOption) {
				if (oOption['jq'])
				{
					oOption['jq'].toggleClass('selected', sFolderName === oOption[oCommand['optionsValue']]);
				}
			});
			
			if (oFolderOption)
			{
				jqText.text($.trim(oFolderOption[oCommand['optionsText']]));
			}
		}
	};


/***/ }),

/***/ 433:
/*!**********************************************************!*\
  !*** ./modules/MailMobileWebclient/js/views/MailView.js ***!
  \**********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		
		CFolderListView = __webpack_require__(/*! modules/MailMobileWebclient/js/views/CFolderListView.js */ 434),
		
		CMailView = __webpack_require__(/*! modules/MailWebclient/js/views/CMailView.js */ 435),
		$ = __webpack_require__(/*! jquery */ 1);
	;

	/**
	 * @constructor
	 */
	function CMailMobileView()
	{
		CMailView.call(this);
		
		this.oFolderList = new CFolderListView();
		this.oMessageList.ViewTemplate = 'MailMobileWebclient_MessagesView';
		this.oMessageList.oPageSwitcher.ViewTemplate = 'CoreMobileWebclient_PageSwitcherView'
		this.oBaseMessagePaneView.ViewTemplate = 'MailMobileWebclient_MessagePaneView';
		
		this.selectedPanel = ko.observable(Enums.MobilePanel.Items);
		MailCache.currentMessage.subscribe(function () {
			this.gotoMessagePane();
		}, this);
		
		this.appsDom = null;
		this.showApps = ko.observable(false);
		
		this.init();
		
		MailCache.currentAccountId.subscribe(function () {
			this.selectedPanel(Enums.MobilePanel.Items);
		}, this);
	}

	_.extendOwn(CMailMobileView.prototype, CMailView.prototype);

	CMailMobileView.prototype.ViewTemplate = 'MailMobileWebclient_MailView';
	CMailMobileView.prototype.ViewConstructorName = 'CMailMobileView';

	CMailMobileView.prototype.init = function ()
	{
		this.selectedPanel.subscribe(function (value) {
			var bOpen = value === Enums.MobilePanel.Groups;

			$('body').toggleClass('with-panel-left-reveal', bOpen).toggleClass('panel-closing', !bOpen);
		});
		
		var self = this;
		this.appsDom = $('#apps-list');
		this.appsDom.on('click', function () {
			self.showApps(false);
		});
		
		this.showApps.subscribe(function (value) {
			$('body').toggleClass('with-panel-right-cover', value);
		}, this);
	};

	CMailMobileView.prototype.togleFolderList = function (oData, oEvent, bValue)
	{
		var 
			bValue = bValue || this.selectedPanel() !== Enums.MobilePanel.Groups,
			newPanel = bValue ? Enums.MobilePanel.Groups : Enums.MobilePanel.Items
		;
		this.changeSelectedPanel(newPanel);
	};

	CMailMobileView.prototype.gotoFolderList = function ()
	{
		this.changeSelectedPanel(Enums.MobilePanel.Groups);
	};

	CMailMobileView.prototype.gotoMessageList = function ()
	{
		this.changeSelectedPanel(Enums.MobilePanel.Items);
		
		var
			sFolder = this.folderList().currentFolderFullName(),
			iPage = this.oMessageList.oPageSwitcher.currentPage(),
			sSearch = this.oMessageList.search(),
			sFilters = this.oMessageList.filters()
		;
		
		this.oMessageList.changeRoutingForMessageList(sFolder, iPage, '', sSearch, sFilters);
		
		return true;
	};

	CMailMobileView.prototype.gotoMessagePane = function ()
	{
		if (MailCache.currentMessage())
		{
			this.changeSelectedPanel(Enums.MobilePanel.View);
		}
		else
		{
			this.gotoMessageList();
		}
	};

	/**
	 * @param {number} iPanel
	 */
	CMailMobileView.prototype.changeSelectedPanel = function (iPanel)
	{
		this.selectedPanel(iPanel);
	};

	module.exports = new CMailMobileView();


/***/ }),

/***/ 434:
/*!*****************************************************************!*\
  !*** ./modules/MailMobileWebclient/js/views/CFolderListView.js ***!
  \*****************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399)
	;

	/**
	 * @constructor
	 */
	function CFolderListView()
	{
		this.accounts = AccountList.collection;
		
		this.folderList = MailCache.folderList;
		
		this.quotaProc = ko.observable(-1);
		this.quotaDesc = ko.observable('');

		if (UserSettings.ShowQuotaBar)
		{
			ko.computed(function () {

				MailCache.quotaChangeTrigger();

				var
					oAccount = AccountList.getCurrent(),
					iQuota = oAccount ? oAccount.quota() : 0,
					iUsed = oAccount ? oAccount.usedSpace() : 0,
					iProc = 0 < iQuota ? Math.ceil((iUsed / iQuota) * 100) : -1
				;

				iProc = 100 < iProc ? 100 : iProc;

				this.quotaProc(iProc);
				this.quotaDesc(-1 < iProc ?
					TextUtils.i18n('COREWEBCLIENT/INFO_QUOTA', {
						'PROC': iProc,
						'QUOTA': TextUtils.getFriendlySize(iQuota * 1024)
					}) : '');

				return true;

			}, this);
		}
	}

	CFolderListView.prototype.ViewTemplate = 'MailMobileWebclient_FoldersView';

	module.exports = CFolderListView;


/***/ }),

/***/ 435:
/*!*****************************************************!*\
  !*** ./modules/MailWebclient/js/views/CMailView.js ***!
  \*****************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		CAbstractScreenView = __webpack_require__(/*! modules/CoreWebclient/js/views/CAbstractScreenView.js */ 193),
		
		ComposeUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Compose.js */ 408),
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CFolderListView = __webpack_require__(/*! modules/MailWebclient/js/views/CFolderListView.js */ 436),
		CMessageListView = __webpack_require__(/*! modules/MailWebclient/js/views/CMessageListView.js */ 438),
		MessagePaneView = __webpack_require__(/*! modules/MailWebclient/js/views/MessagePaneView.js */ 439)
	;

	/**
	 * @constructor
	 */
	function CMailView()
	{
		CAbstractScreenView.call(this, 'MailWebclient');
		
		App.broadcastEvent('MailWebclient::ConstructView::before', {'Name': this.ViewConstructorName, 'View': this, 'MailCache': MailCache});
		
		this.browserTitle = ko.computed(function () {
			return AccountList.getEmail() + ' - ' + TextUtils.i18n('MAILWEBCLIENT/HEADING_BROWSER_TAB');
		});
		
		this.folderList = MailCache.folderList;
		this.domFoldersMoveTo = ko.observable(null);
		
		this.openMessageInNewWindowBound = _.bind(this.openMessageInNewWindow, this);
		
		this.oFolderList = new CFolderListView();
		this.oMessageList = new CMessageListView(this.openMessageInNewWindowBound);
		
		this.oBaseMessagePaneView = MessagePaneView;
		this.messagePane = ko.observable(this.oBaseMessagePaneView);
		this.messagePane().openMessageInNewWindowBound = this.openMessageInNewWindowBound;
		this.messagePane.subscribe(function () {
			this.bindMessagePane();
		}, this);

		this.isEnableGroupOperations = this.oMessageList.isEnableGroupOperations;

		this.composeLink = ko.observable(Routing.buildHashFromArray(LinksUtils.getCompose()));
		this.sCustomBigButtonModule = '';
		this.fCustomBigButtonHandler = null;
		this.customBigButtonText = ko.observable('');
		this.bigButtonCommand = Utils.createCommand(this, function () {
			if (_.isFunction(this.fCustomBigButtonHandler))
			{
				this.fCustomBigButtonHandler();
			}
			else
			{
				this.executeCompose();
			}
		});
		this.bigButtonText = ko.computed(function () {
			if (this.customBigButtonText() !== '')
			{
				return this.customBigButtonText();
			}
			return TextUtils.i18n('MAILWEBCLIENT/ACTION_NEW_MESSAGE');
		}, this);

		this.checkMailCommand = Utils.createCommand(this, this.executeCheckMail);
		this.checkMailIndicator = ko.observable(true).extend({ throttle: 50 });
		ko.computed(function () {
			this.checkMailIndicator(MailCache.checkMailStarted() || MailCache.messagesLoading());
		}, this);
		this.customModulesDisabledMark = ko.observableArray([]);
		this.visibleMarkTool = ko.computed(function () {
			return !Types.isNonEmptyArray(this.customModulesDisabledMark());
		}, this);
		this.markAsReadCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeMarkAsRead, this.isEnableGroupOperations);
		this.markAsUnreadCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeMarkAsUnread, this.isEnableGroupOperations);
		this.markAllReadCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeMarkAllRead);
		this.customModulesDisabledMove = ko.observableArray([]);
		this.visibleMoveTool = ko.computed(function () {
			return !Types.isNonEmptyArray(this.customModulesDisabledMove());
		}, this);
		this.moveToFolderCommand = Utils.createCommand(this, function () {}, this.isEnableGroupOperations);
	//	this.copyToFolderCommand = Utils.createCommand(this, function () {}, this.isEnableGroupOperations);
		this.deleteCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeDelete, this.isEnableGroupOperations);
		this.selectedCount = ko.computed(function () {
			return this.oMessageList.checkedUids().length;
		}, this);
		this.emptyTrashCommand = Utils.createCommand(MailCache, MailCache.executeEmptyTrash, this.oMessageList.isNotEmptyList);
		this.emptySpamCommand = Utils.createCommand(MailCache, MailCache.executeEmptySpam, this.oMessageList.isNotEmptyList);
		this.spamCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeSpam, this.isEnableGroupOperations);
		this.notSpamCommand = Utils.createCommand(this.oMessageList, this.oMessageList.executeNotSpam, this.isEnableGroupOperations);

		this.isVisibleReplyTool = ko.computed(function () {
			return (this.folderList().currentFolder() &&
				this.folderList().currentFolderFullName().length > 0 &&
				this.folderList().currentFolderType() !== Enums.FolderTypes.Drafts &&
				this.folderList().currentFolderType() !== Enums.FolderTypes.Sent);
		}, this);

		this.isVisibleForwardTool = ko.computed(function () {
			return (this.folderList().currentFolder() &&
				this.folderList().currentFolderFullName().length > 0 &&
				this.folderList().currentFolderType() !== Enums.FolderTypes.Drafts);
		}, this);

		this.isSpamFolder = ko.computed(function () {
			return this.folderList().currentFolderType() === Enums.FolderTypes.Spam;
		}, this);
		
		this.customModulesDisabledSpam = ko.observableArray([]);
		this.allowedSpamAction = ko.computed(function () {
			return Settings.AllowSpamFolder && !this.isSpamFolder() && !Types.isNonEmptyArray(this.customModulesDisabledSpam());
		}, this);
		
		this.allowedNotSpamAction = ko.computed(function () {
			return Settings.AllowSpamFolder && this.isSpamFolder();
		}, this);
		
		this.isTrashFolder = ko.computed(function () {
			return this.folderList().currentFolderType() === Enums.FolderTypes.Trash;
		}, this);

		this.jqPanelHelper = null;
		
		App.broadcastEvent('MailWebclient::ConstructView::after', {'Name': this.ViewConstructorName, 'View': this});
	}

	_.extendOwn(CMailView.prototype, CAbstractScreenView.prototype);

	CMailView.prototype.ViewTemplate = 'MailWebclient_MailView';
	CMailView.prototype.ViewConstructorName = 'CMailView';

	/**
	 * Checks if there are changes in Mail screen.
	 * @returns {Boolean}
	 */
	CMailView.prototype.hasUnsavedChanges = function ()
	{
		return this.messagePane() && _.isFunction(this.messagePane().hasUnsavedChanges) && this.messagePane().hasUnsavedChanges();
	};

	/**
	 * Discards changes in Mail screen.
	 */
	CMailView.prototype.discardChanges = function ()
	{
		if (this.messagePane() && _.isFunction(this.messagePane().discardChanges))
		{
			this.messagePane().discardChanges();
		}
	};

	CMailView.prototype.setCustomPreviewPane = function (sModuleName, oPreviewPane)
	{
		if (this.messagePane().__customModuleName !== sModuleName)
		{
			oPreviewPane.__customModuleName = sModuleName;
			this.messagePane(oPreviewPane);
		}
	};

	CMailView.prototype.removeCustomPreviewPane = function (sModuleName)
	{
		if (this.messagePane().__customModuleName === sModuleName)
		{
			this.messagePane(this.oBaseMessagePaneView);
		}
	};

	CMailView.prototype.setCustomBigButton = function (sModuleName, fHandler, sText)
	{
		this.sCustomBigButtonModule = sModuleName;
		this.fCustomBigButtonHandler = fHandler;
		this.customBigButtonText(sText);
	};

	CMailView.prototype.removeCustomBigButton = function (sModuleName)
	{
		if (this.sCustomBigButtonModule === sModuleName)
		{
			this.sCustomBigButtonModule = '';
			this.fCustomBigButtonHandler = null;
			this.customBigButtonText('');
		}
	};

	CMailView.prototype.resetDisabledTools = function (sModuleName, aDisabledTools)
	{
		if ($.inArray('spam', aDisabledTools) !== -1)
		{
			this.customModulesDisabledSpam(_.union(this.customModulesDisabledSpam(), [sModuleName]));
		}
		else
		{
			this.customModulesDisabledSpam(_.without(this.customModulesDisabledSpam(), sModuleName));
		}
		if ($.inArray('move', aDisabledTools) !== -1)
		{
			this.customModulesDisabledMove(_.union(this.customModulesDisabledMove(), [sModuleName]));
		}
		else
		{
			this.customModulesDisabledMove(_.without(this.customModulesDisabledMove(), sModuleName));
		}
		if ($.inArray('mark', aDisabledTools) !== -1)
		{
			this.customModulesDisabledMark(_.union(this.customModulesDisabledMark(), [sModuleName]));
		}
		else
		{
			this.customModulesDisabledMark(_.without(this.customModulesDisabledMark(), sModuleName));
		}
	};

	CMailView.prototype.executeCompose = function ()
	{
		ComposeUtils.composeMessage();
	};

	CMailView.prototype.executeCheckMail = function ()
	{
		MailCache.checkMessageFlags();
		MailCache.executeCheckMail(true);
	};

	/**
	 * @param {object} oMessage
	 */
	CMailView.prototype.openMessageInNewWindow = function (oMessage)
	{
		if (oMessage)
		{
			var
				sFolder = oMessage.folder(),
				sUid = oMessage.uid(),
				oFolder = this.folderList().getFolderByFullName(sFolder),
				bDraftFolder = (oFolder.type() === Enums.FolderTypes.Drafts),
				sHash = ''
			;

			if (bDraftFolder)
			{
				sHash = Routing.buildHashFromArray(LinksUtils.getComposeFromMessage('drafts', sFolder, sUid));
			}
			else
			{
				sHash = Routing.buildHashFromArray(LinksUtils.getViewMessage(sFolder, sUid));
				if (_.isFunction(this.messagePane().passReplyDataToNewTab))
				{
					this.messagePane().passReplyDataToNewTab(oMessage.sUniq);
				}
			}

			WindowOpener.openTab('?message-newtab' + sHash);
		}
	};

	/**
	 * @param {Object} oData
	 * @param {Object} oEvent
	 */
	CMailView.prototype.resizeDblClick = function (oData, oEvent)
	{
		oEvent.preventDefault();
		if (oEvent.stopPropagation)
		{
			oEvent.stopPropagation();
		}
		else
		{
			oEvent.cancelBubble = true;
		}

		Utils.removeSelection();
		if (!this.jqPanelHelper)
		{
			this.jqPanelHelper = $('.MailLayout .panel_helper');
		}
		this.jqPanelHelper.trigger('resize', [600, 'max']);
	};

	/**
	 * @param {Array} aParams
	 */
	CMailView.prototype.onRoute = function (aParams)
	{
		if (!AccountList.hasAccount())
		{
			Routing.replaceHash(['settings', 'mail-accounts', 'account', 'create']);
			return;
		}
		
		var oParams = LinksUtils.parseMailbox(aParams);
		
		AccountList.changeCurrentAccountByHash(oParams.AccountHash);
		
		this.oMessageList.onRoute(aParams);
		if (_.isFunction(this.messagePane().onRoute))
		{
			this.messagePane().onRoute(aParams, oParams);
		}
		
		if (oParams.MailtoCompose)
		{
			ComposeUtils.composeMessageToAddresses(aParams[2]);
			Routing.replaceHash(LinksUtils.getMailbox());
		}
	};

	CMailView.prototype.onShow = function ()
	{
		this.oMessageList.onShow();
		if (_.isFunction(this.messagePane().onShow))
		{
			this.messagePane().onShow();
		}
	};

	CMailView.prototype.onHide = function ()
	{
		this.oMessageList.onHide();
		if (_.isFunction(this.messagePane().onHide))
		{
			this.messagePane().onHide();
		}
	};

	CMailView.prototype.bindMessagePane = function ()
	{
		if (_.isFunction(this.messagePane().onBind))
		{
			this.messagePane().onBind(this.$viewDom);
			this.messagePane().__bound = true;
		}
	};

	CMailView.prototype.onBind = function ()
	{
		var
			koFolderList = this.folderList,
			oMessageList = this.oMessageList
		;

		this.oMessageList.onBind(this.$viewDom);
		this.bindMessagePane();

		$(this.domFoldersMoveTo()).on('click', 'span.folder', function (oEvent) {
			var sClickedFolder = $(this).data('folder');
			if (koFolderList().currentFolderFullName() !== sClickedFolder)
			{
				if (oEvent.ctrlKey)
				{
					oMessageList.executeCopyToFolder(sClickedFolder);
				}
				else
				{
					oMessageList.executeMoveToFolder(sClickedFolder);
				}
			}
		});

		if (!App.isMobile())
		{
			this.hotKeysBind();
		}
	};

	CMailView.prototype.hotKeysBind = function ()
	{
		$(document).on('keydown', $.proxy(function(ev) {
			var
				sKey = ev.keyCode,
				bComputed = ev && !ev.ctrlKey && !ev.altKey && !ev.shiftKey && !Utils.isTextFieldFocused() && this.shown(),
				oList = this.oMessageList,
				oFirstMessage = oList.collection()[0],
				bGotoSearch = oFirstMessage && MailCache.currentMessage() && oFirstMessage.uid() === MailCache.currentMessage().uid()
			;
			
			if (bComputed && sKey === Enums.Key.s || bComputed && bGotoSearch && sKey === Enums.Key.Up)
			{
				ev.preventDefault();
				this.searchFocus();
			}
			else if (oList.isFocused() && ev && sKey === Enums.Key.Down && oFirstMessage)
			{
				ev.preventDefault();
				oList.isFocused(false);
				oList.routeForMessage(oFirstMessage);
			}
			else if (bComputed && sKey === Enums.Key.n)
			{
				this.executeCompose();
				ev.preventDefault();
			}
		},this));
	};

	CMailView.prototype.routeMessageView = function (sFolderName, iUid)
	{
		Routing.setHash(LinksUtils.getMailbox(sFolderName, this.oMessageList.oPageSwitcher.currentPage(), iUid));
	};

	/**
	 * @param {Object} oMessage
	 * @param {boolean} bCtrl
	 */
	CMailView.prototype.dragAndDropHelper = function (oMessage, bCtrl)
	{
		if (oMessage)
		{
			oMessage.checked(true);
		}

		var
			oHelper = Utils.draggableItems(),
			aUids = this.oMessageList.checkedOrSelectedUids(),
			iCount = aUids.length
		;
			
		oHelper.data('p7-message-list-folder', this.folderList().currentFolderFullName());
		oHelper.data('p7-message-list-uids', aUids);

		$('.count-text', oHelper).text(TextUtils.i18n('MAILWEBCLIENT/LABEL_DRAG_MESSAGES_PLURAL', {
			'COUNT': bCtrl ? '+ ' + iCount : iCount
		}, null, iCount));

		return oHelper;
	};

	/**
	 * @param {Object} oToFolder
	 * @param {Object} oEvent
	 * @param {Object} oUi
	 */
	CMailView.prototype.messagesDrop = function (oToFolder, oEvent, oUi)
	{
		if (oToFolder)
		{
			var
				oHelper = oUi && oUi.helper ? oUi.helper : null,
				sFolder = oHelper ? oHelper.data('p7-message-list-folder') : '',
				aUids = oHelper ? oHelper.data('p7-message-list-uids') : null
			;

			if ('' !== sFolder && null !== aUids)
			{
				Utils.uiDropHelperAnim(oEvent, oUi);
				if(oEvent.ctrlKey)
				{
					this.oMessageList.executeCopyToFolder(oToFolder.fullName());
				}
				else
				{
					this.oMessageList.executeMoveToFolder(oToFolder.fullName());
				}
				
				this.uncheckMessages();
			}
		}
	};

	CMailView.prototype.searchFocus = function ()
	{
		if (this.oMessageList.selector.useKeyboardKeys() && !Utils.isTextFieldFocused())
		{
			this.oMessageList.isFocused(true);
		}
	};

	CMailView.prototype.onVolumerClick = function (oVm, oEv)
	{
		oEv.stopPropagation();
	};

	CMailView.prototype.uncheckMessages = function ()
	{
		_.each(MailCache.messages(), function(oMessage) {
			oMessage.checked(false);
		});
	};

	module.exports = CMailView;


/***/ }),

/***/ 436:
/*!***********************************************************!*\
  !*** ./modules/MailWebclient/js/views/CFolderListView.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		CreateFolderPopup = __webpack_require__(/*! modules/MailWebclient/js/popups/CreateFolderPopup.js */ 437),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
	;

	/**
	 * @constructor
	 */
	function CFolderListView()
	{
		this.folderList = MailCache.folderList;
		
		this.manageFoldersHash = ko.computed(function () {
			if (ModulesManager.isModuleEnabled('SettingsWebclient'))
			{
				var
					oCurrentAccount = AccountList.getCurrent()
				;
				if (oCurrentAccount)
				{
					return Routing.buildHashFromArray(['settings', 'mail-accounts', 'account', oCurrentAccount.hash(), 'folders']);
				}
			}
			return '#';
		}, this);
		
		this.quotaProc = ko.observable(-1);
		this.quotaDesc = ko.observable('');

		if (UserSettings.ShowQuotaBar)
		{
			ko.computed(function () {

				MailCache.quotaChangeTrigger();

				var
					oAccount = AccountList.getCurrent(),
					iQuota = oAccount ? oAccount.quota() : 0,
					iUsed = oAccount ? oAccount.usedSpace() : 0,
					iProc = 0 < iQuota ? Math.ceil((iUsed / iQuota) * 100) : -1
				;

				iProc = 100 < iProc ? 100 : iProc;

				this.quotaProc(iProc);
				this.quotaDesc(-1 < iProc ?
					TextUtils.i18n('COREWEBCLIENT/INFO_QUOTA', {
						'PROC': iProc,
						'QUOTA': TextUtils.getFriendlySize(iQuota * 1024)
					}) : '');

				return true;

			}, this);
		}
		
		this.visibleNewFolderButton = ko.computed(function () {
			return Settings.AllowAddNewFolderOnMainScreen && this.folderList().collection().length > 0;
		}, this);
	}

	CFolderListView.prototype.ViewTemplate = 'MailWebclient_FoldersView';

	CFolderListView.prototype.addNewFolder = function ()
	{
		Popups.showPopup(CreateFolderPopup);
	};

	module.exports = CFolderListView;


/***/ }),

/***/ 437:
/*!**************************************************************!*\
  !*** ./modules/MailWebclient/js/popups/CreateFolderPopup.js ***!
  \**************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		
		CAbstractPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/CAbstractPopup.js */ 189),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		MailCache = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399)
	;

	/**
	 * @constructor
	 */
	function CCreateFolderPopup()
	{
		CAbstractPopup.call(this);
		
		this.isCreating = ko.observable(false);
		MailCache.folderListLoading.subscribe(function () {
			var bListLoading = MailCache.folderListLoading.indexOf(MailCache.editedFolderList().iAccountId) !== -1;
			if (!bListLoading && this.isCreating())
			{
				if ($.isFunction(this.fCallback))
				{
					this.fCallback(this.folderName(), this.parentFolder());
				}
				this.isCreating(false);
				this.closePopup();
			}
		}, this);

		this.options = ko.observableArray([]);

		this.parentFolder = ko.observable('');
		this.folderName = ko.observable('');
		this.folderNameFocus = ko.observable(false);
		
		this.fCallback = null;

		this.defaultOptionsAfterRender = Utils.defaultOptionsAfterRender;
	}

	_.extendOwn(CCreateFolderPopup.prototype, CAbstractPopup.prototype);

	CCreateFolderPopup.prototype.PopupTemplate = 'MailWebclient_Settings_CreateFolderPopup';

	/**
	 * @param {Function} fCallback
	 */
	CCreateFolderPopup.prototype.onOpen = function (fCallback)
	{
		this.options(MailCache.editedFolderList().getOptions(TextUtils.i18n('MAILWEBCLIENT/LABEL_NO_PARENT_FOLDER'), true, false, true));
		
		this.fCallback = fCallback;
		this.folderName('');
		this.folderNameFocus(true);
	};

	CCreateFolderPopup.prototype.create = function ()
	{
		var
			sParentFolder = (this.parentFolder() === '' ? MailCache.editedFolderList().sNamespaceFolder : this.parentFolder()),
			oParameters = {
				'AccountID': AccountList.editedId(),
				'FolderNameInUtf8': this.folderName(),
				'FolderParentFullNameRaw': sParentFolder,
				'Delimiter': MailCache.editedFolderList().sDelimiter
			}
		;

		this.folderNameFocus(false);
		this.isCreating(true);

		Ajax.send('CreateFolder', oParameters, this.onCreateFolderResponse, this);
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CCreateFolderPopup.prototype.onCreateFolderResponse = function (oResponse, oRequest)
	{
		if (!oResponse.Result)
		{
			this.isCreating(false);
			Api.showErrorByCode(oResponse, TextUtils.i18n('MAILWEBCLIENT/ERROR_CREATE_FOLDER'));
		}
		else
		{
			MailCache.getFolderList(AccountList.editedId());
		}
	};

	CCreateFolderPopup.prototype.cancelPopup = function ()
	{
		if (!this.isCreating())
		{
			if ($.isFunction(this.fCallback))
			{
				this.fCallback('', '');
			}
			this.closePopup();
		}
	};

	module.exports = new CCreateFolderPopup();


/***/ }),

/***/ 438:
/*!************************************************************!*\
  !*** ./modules/MailWebclient/js/views/CMessageListView.js ***!
  \************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		DateUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Date.js */ 263),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178),
		CJua = __webpack_require__(/*! modules/CoreWebclient/js/CJua.js */ 264),
		CSelector = __webpack_require__(/*! modules/CoreWebclient/js/CSelector.js */ 298),
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		
		CPageSwitcherView = __webpack_require__(/*! modules/CoreWebclient/js/views/CPageSwitcherView.js */ 243),
		
		ComposeUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Compose.js */ 408),
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		MailUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Mail.js */ 419),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		MailCache  = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings  = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392)
	;

	__webpack_require__(/*! jquery-ui/ui/widgets/datepicker */ 278);

	/**
	 * @constructor
	 * 
	 * @param {Function} fOpenMessageInNewWindowBound
	 */
	function CMessageListView(fOpenMessageInNewWindowBound)
	{
		this.uploaderArea = ko.observable(null);
		this.bDragActive = ko.observable(false);
		this.bDragActiveComp = ko.computed(function () {
			return this.bDragActive();
		}, this);

		this.openMessageInNewWindowBound = fOpenMessageInNewWindowBound;
		
		this.isFocused = ko.observable(false);

		this.messagesContainer = ko.observable(null);

		this.searchInput = ko.observable('');
		this.searchInputFrom = ko.observable('');
		this.searchInputTo = ko.observable('');
		this.searchInputSubject = ko.observable('');
		this.searchInputText = ko.observable('');
		this.searchSpan = ko.observable('');
		this.highlightTrigger = ko.observable('');

		this.currentMessage = MailCache.currentMessage;
		this.currentMessage.subscribe(function () {
			this.isFocused(false);
			this.selector.itemSelected(this.currentMessage());
		}, this);

		this.folderList = MailCache.folderList;
		this.folderList.subscribe(this.onFolderListSubscribe, this);
		this.folderFullName = ko.observable('');
		this.folderType = ko.observable(Enums.FolderTypes.User);
		this.filters = ko.observable('');

		this.uidList = MailCache.uidList;
		this.uidList.subscribe(function () {
			if (this.uidList().searchCountSubscription)
			{
				this.uidList().searchCountSubscription.dispose();
				this.uidList().searchCountSubscription = undefined;
			}
			this.uidList().searchCountSubscription = this.uidList().resultCount.subscribe(function () {
				if (this.uidList().resultCount() >= 0)
				{
					this.oPageSwitcher.setCount(this.uidList().resultCount());
				}
			}, this);
			
			if (this.uidList().resultCount() >= 0)
			{
				this.oPageSwitcher.setCount(this.uidList().resultCount());
			}
		}, this);

		this.useThreading = ko.computed(function () {
			var
				oAccount = AccountList.getCurrent(),
				oFolder = this.folderList().currentFolder(),
				bFolderWithoutThreads = oFolder && oFolder.withoutThreads(),
				bNotSearchOrFilters = this.uidList().search() === '' && this.uidList().filters() === ''
			;
			
			return oAccount && oAccount.threadingIsAvailable() && !bFolderWithoutThreads && bNotSearchOrFilters;
		}, this);

		this.collection = MailCache.messages;
		
		this._search = ko.observable('');
		this.search = ko.computed({
			'read': function () {
				return $.trim(this._search());
			},
			'write': this._search,
			'owner': this
		});

		this.isEmptyList = ko.computed(function () {
			return this.collection().length === 0;
		}, this);

		this.isNotEmptyList = ko.computed(function () {
			return this.collection().length !== 0;
		}, this);

		this.isSearch = ko.computed(function () {
			return this.search().length > 0;
		}, this);

		this.isUnseenFilter = ko.computed(function () {
			return this.filters() === Enums.FolderFilter.Unseen;
		}, this);

		this.isLoading = MailCache.messagesLoading;

		this.isError = MailCache.messagesLoadingError;

		this.visibleInfoLoading = ko.computed(function () {
			return !this.isSearch() && this.isLoading();
		}, this);
		this.visibleInfoSearchLoading = ko.computed(function () {
			return this.isSearch() && this.isLoading();
		}, this);
		this.visibleInfoSearchList = ko.computed(function () {
			return this.isSearch() && !this.isUnseenFilter() && !this.isLoading() && !this.isEmptyList();
		}, this);
		this.visibleInfoMessageListEmpty = ko.computed(function () {
			return !this.isLoading() && !this.isSearch() && (this.filters() === '') && this.isEmptyList() && !this.isError();
		}, this);
		this.visibleInfoStarredFolderEmpty = ko.computed(function () {
			return !this.isLoading() && !this.isSearch() && (this.filters() === Enums.FolderFilter.Flagged) && this.isEmptyList() && !this.isError();
		}, this);
		this.visibleInfoSearchEmpty = ko.computed(function () {
			return this.isSearch() && !this.isUnseenFilter() && this.isEmptyList() && !this.isError() && !this.isLoading();
		}, this);
		this.visibleInfoMessageListError = ko.computed(function () {
			return !this.isSearch() && this.isError();
		}, this);
		this.visibleInfoSearchError = ko.computed(function () {
			return this.isSearch() && this.isError();
		}, this);
		this.visibleInfoUnseenFilterList = ko.computed(function () {
			return this.isUnseenFilter() && (this.isLoading() || !this.isEmptyList());
		}, this);
		this.visibleInfoUnseenFilterEmpty = ko.computed(function () {
			return this.isUnseenFilter() && this.isEmptyList() && !this.isError() && !this.isLoading();
		}, this);

		this.searchText = ko.computed(function () {

			return TextUtils.i18n('MAILWEBCLIENT/INFO_SEARCH_RESULT', {
				'SEARCH': this.calculateSearchStringForDescription(),
				'FOLDER': this.folderList().currentFolder() ? TextUtils.encodeHtml(this.folderList().currentFolder().displayName()) : ''
			});
			
		}, this);

		this.unseenFilterText = ko.computed(function () {

			if (this.search() === '')
			{
				return TextUtils.i18n('MAILWEBCLIENT/INFO_UNREAD_MESSAGES', {
					'FOLDER': this.folderList().currentFolder() ? TextUtils.encodeHtml(this.folderList().currentFolder().displayName()) : ''
				});
			}
			else
			{
				return TextUtils.i18n('MAILWEBCLIENT/INFO_UNREAD_MESSAGES_SEARCH_RESULT', {
					'SEARCH': this.calculateSearchStringForDescription(),
					'FOLDER': this.folderList().currentFolder() ? TextUtils.encodeHtml(this.folderList().currentFolder().displayName()) : ''
				});
			}
			
		}, this);

		this.unseenFilterEmptyText = ko.computed(function () {

			if (this.search() === '')
			{
				return TextUtils.i18n('MAILWEBCLIENT/INFO_NO_UNREAD_MESSAGES');
			}
			else
			{
				return TextUtils.i18n('MAILWEBCLIENT/INFO_NO_UNREAD_MESSAGES_FOUND');
			}
			
		}, this);

		this.isEnableGroupOperations = ko.observable(false).extend({'throttle': 250});

		this.selector = new CSelector(
			this.collection,
			_.bind(this.routeForMessage, this),
			_.bind(this.onDeletePress, this),
			_.bind(this.onMessageDblClick, this),
			_.bind(this.onEnterPress, this),
			null,
			false,
			false,
			false,
			false,
			false // don't select new item before routing executed
		);

		this.checkedUids = ko.computed(function () {
			var
				aChecked = this.selector.listChecked(),
				aCheckedUids = _.map(aChecked, function (oItem) {
					return oItem.uid();
				}),
				oFolder = MailCache.folderList().currentFolder(),
				aThreadCheckedUids = oFolder ? oFolder.getThreadCheckedUidsFromList(aChecked) : [],
				aUids = _.union(aCheckedUids, aThreadCheckedUids)
			;

			return aUids;
		}, this);
		
		this.checkedOrSelectedUids = ko.computed(function () {
			var aChecked = this.checkedUids();
			if (aChecked.length === 0 && MailCache.currentMessage() && !MailCache.currentMessage().deleted())
			{
				aChecked = [MailCache.currentMessage().uid()];
			}
			return aChecked;
		}, this);

		ko.computed(function () {
			this.isEnableGroupOperations(0 < this.selector.listCheckedOrSelected().length);
		}, this);

		this.checkAll = this.selector.koCheckAll();
		this.checkAllIncomplite = this.selector.koCheckAllIncomplete();

		this.pageSwitcherLocked = ko.observable(false);
		this.oPageSwitcher = new CPageSwitcherView(0, Settings.MailsPerPage);
		this.oPageSwitcher.currentPage.subscribe(function (iPage) {
			var
				sFolder = this.folderList().currentFolderFullName(),
				sUid = !App.isMobile() && this.currentMessage() ? this.currentMessage().uid() : '',
				sSearch = this.search()
			;
			
			if (!this.pageSwitcherLocked())
			{
				this.changeRoutingForMessageList(sFolder, iPage, sUid, sSearch, this.filters());
			}
		}, this);
		this.currentPage = ko.observable(0);
		
		// to the message list does not twitch
		if (Browser.firefox || Browser.ie)
		{
			this.listChangedThrottle = ko.observable(false).extend({'throttle': 10});
		}
		else
		{
			this.listChangedThrottle = ko.observable(false);
		}
		
		this.firstCompleteCollection = ko.observable(true);
		this.collection.subscribe(function () {
			if (this.collection().length > 0)
			{
				if (Types.isNonEmptyArray(this.aRouteParams))
				{
					this.onRoute(this.aRouteParams);
					this.aRouteParams = [];
				}
				else
				{
					this.firstCompleteCollection(false);
				}
			}
		}, this);
		this.listChanged = ko.computed(function () {
			return [
				this.firstCompleteCollection(),
				MailCache.currentAccountId(),
				this.folderFullName(),
				this.filters(),
				this.search(),
				this.oPageSwitcher.currentPage()
			];
		}, this);
		
		this.listChanged.subscribe(function() {
			this.listChangedThrottle(!this.listChangedThrottle());
		}, this);

		this.bAdvancedSearch = ko.observable(false);
		this.searchAttachmentsCheckbox = ko.observable(false);
		this.searchAttachments = ko.observable('');
		this.searchAttachments.subscribe(function(sText) {
			this.searchAttachmentsCheckbox(!!sText);
		}, this);
		
		this.searchAttachmentsFocus = ko.observable(false);
		this.searchFromFocus = ko.observable(false);
		this.searchSubjectFocus = ko.observable(false);
		this.searchToFocus = ko.observable(false);
		this.searchTextFocus = ko.observable(false);
		this.searchTrigger = ko.observable(null);
		this.searchDateStartFocus = ko.observable(false);
		this.searchDateEndFocus = ko.observable(false);
		this.searchDateStartDom = ko.observable(null);
		this.searchDateStart = ko.observable('');
		this.searchDateEndDom = ko.observable(null);
		this.searchDateEnd = ko.observable('');
		this.dateFormatDatePicker = 'yy.mm.dd';
		this.attachmentsPlaceholder = ko.computed(function () {
			return TextUtils.i18n('MAILWEBCLIENT/LABEL_HAS_ATTACHMENTS');
		}, this);

		_.delay(_.bind(function(){
			this.createDatePickerObject(this.searchDateStartDom(), this.searchDateStart);
			this.createDatePickerObject(this.searchDateEndDom(), this.searchDateEnd);
		}, this), 1000);
		
		this.customMessageItemViewTemplate = ko.observable('');
		
		App.broadcastEvent('MailWebclient::ConstructView::after', {'Name': this.ViewConstructorName, 'View': this, 'MailCache': MailCache});
	}

	CMessageListView.prototype.ViewTemplate = 'MailWebclient_MessagesView';
	CMessageListView.prototype.ViewConstructorName = 'CMessageListView';

	CMessageListView.prototype.addNewAccount = function ()
	{
		App.Api.createMailAccount(AccountList.getEmail());
	};

	CMessageListView.prototype.createDatePickerObject = function (oElement, value)
	{
		$(oElement).datepicker({
			showOtherMonths: true,
			selectOtherMonths: true,
			monthNames: DateUtils.getMonthNamesArray(),
			dayNamesMin: TextUtils.i18n('COREWEBCLIENT/LIST_DAY_NAMES_MIN').split(' '),
			nextText: '',
			prevText: '',
			firstDay: Types.pInt(ModulesManager.run('CalendarWebclient', 'getWeekStartsOn')),
			showOn: 'focus',
			dateFormat: this.dateFormatDatePicker,
			onClose: function (sValue) {
				if (ko.isObservable(value)) {
					value(sValue);
				}
			}
		});

		$(oElement).mousedown(function() {
			$('#ui-datepicker-div').toggle();
		});
	};

	/**
	 * @param {string} sFolder
	 * @param {number} iPage
	 * @param {string} sUid
	 * @param {string} sSearch
	 * @param {string} sFilters
	 */
	CMessageListView.prototype.changeRoutingForMessageList = function (sFolder, iPage, sUid, sSearch, sFilters)
	{
		var bSame = Routing.setHash(LinksUtils.getMailbox(sFolder, iPage, sUid, sSearch, sFilters));
		
		if (bSame && sSearch.length > 0 && this.search() === sSearch)
		{
			this.listChangedThrottle(!this.listChangedThrottle());
		}
	};

	/**
	 * @param {CMessageModel} oMessage
	 */
	CMessageListView.prototype.onEnterPress = function (oMessage)
	{
		oMessage.openThread();
	};

	/**
	 * @param {CMessageModel} oMessage
	 */
	CMessageListView.prototype.onMessageDblClick = function (oMessage)
	{
		if (!this.isSavingDraft(oMessage))
		{
			var
				oFolder = this.folderList().getFolderByFullName(oMessage.folder()),
				oParams = { Message: oMessage, Cancel: false }
			;
			
			App.broadcastEvent('MailWebclient::MessageDblClick::before', oParams);

			if (!oParams.Cancel)
			{
				if (oFolder.type() === Enums.FolderTypes.Drafts)
				{
					ComposeUtils.composeMessageFromDrafts(oMessage.folder(), oMessage.uid());
				}
				else
				{
					this.openMessageInNewWindowBound(oMessage);
				}
			}
		}
	};

	CMessageListView.prototype.onFolderListSubscribe = function ()
	{
		this.setCurrentFolder();
		this.requestMessageList();
	};

	/**
	 * @param {Array} aParams
	 */
	CMessageListView.prototype.onShow = function (aParams)
	{
		this.selector.useKeyboardKeys(true);
		this.oPageSwitcher.show();

		if (this.oJua)
		{
			this.oJua.setDragAndDropEnabledStatus(true);
		}
	};

	/**
	 * @param {Array} aParams
	 */
	CMessageListView.prototype.onHide = function (aParams)
	{
		this.selector.useKeyboardKeys(false);
		this.oPageSwitcher.hide();

		if (this.oJua)
		{
			this.oJua.setDragAndDropEnabledStatus(false);
		}
	};

	/**
	 * @param {Array} aParams
	 */
	CMessageListView.prototype.onRoute = function (aParams)
	{
		var
			oParams = LinksUtils.parseMailbox(aParams),
			bRouteChanged = this.currentPage() !== oParams.Page ||
				this.folderFullName() !== oParams.Folder ||
				this.filters() !== oParams.Filters || (oParams.Filters === Enums.FolderFilter.Unseen && MailCache.waitForUnseenMessages()) ||
				this.search() !== oParams.Search,
			bMailsPerPageChanged = Settings.MailsPerPage !== this.oPageSwitcher.perPage()
		;
		
		this.pageSwitcherLocked(true);
		if (this.folderFullName() !== oParams.Folder || this.search() !== oParams.Search || this.filters() !== oParams.Filters)
		{
			this.oPageSwitcher.clear();
		}
		else
		{
			this.oPageSwitcher.setPage(oParams.Page, Settings.MailsPerPage);
		}
		this.pageSwitcherLocked(false);
		
		if (oParams.Page !== this.oPageSwitcher.currentPage())
		{
			if (this.folderList().iAccountId === 0)
			{
				this.aRouteParams = aParams;
			}
			else
			{
				Routing.replaceHash(LinksUtils.getMailbox(oParams.Folder, this.oPageSwitcher.currentPage(), oParams.Uid, oParams.Search, oParams.Filters));
			}
		}

		this.currentPage(this.oPageSwitcher.currentPage());
		this.folderFullName(oParams.Folder);
		this.filters(oParams.Filters);
		this.search(oParams.Search);
		this.searchInput(this.search());
		this.searchSpan.notifySubscribers();

		this.setCurrentFolder();
		
		if (bRouteChanged || bMailsPerPageChanged || this.collection().length === 0)
		{
			if (oParams.Filters === Enums.FolderFilter.Unseen)
			{
				MailCache.waitForUnseenMessages(true);
			}
			this.requestMessageList();
		}

		this.highlightTrigger.notifySubscribers(true);
	};

	CMessageListView.prototype.setCurrentFolder = function ()
	{
		this.folderList().setCurrentFolder(this.folderFullName(), this.filters());
		this.folderType(MailCache.folderList().currentFolderType());
	};

	CMessageListView.prototype.requestMessageList = function ()
	{
		var
			sFullName = this.folderList().currentFolderFullName(),
			iPage = this.oPageSwitcher.currentPage()
		;
		
		if (sFullName.length > 0)
		{
			MailCache.changeCurrentMessageList(sFullName, iPage, this.search(), this.filters());
		}
		else
		{
			MailCache.checkCurrentFolderList();
		}
	};

	CMessageListView.prototype.calculateSearchStringFromAdvancedForm  = function ()
	{
		var
			sFrom = this.searchInputFrom(),
			sTo = this.searchInputTo(),
			sSubject = this.searchInputSubject(),
			sText = this.searchInputText(),
			bAttachmentsCheckbox = this.searchAttachmentsCheckbox(),
			sDateStart = this.searchDateStart(),
			sDateEnd = this.searchDateEnd(),
			aOutput = [],
			fEsc = function (sText) {

				sText = $.trim(sText).replace(/"/g, '\\"');
				
				if (-1 < sText.indexOf(' ') || -1 < sText.indexOf('"'))
				{
					sText = '"' + sText + '"';
				}
				
				return sText;
			}
		;

		if (sFrom !== '')
		{
			aOutput.push('from:' + fEsc(sFrom));
		}

		if (sTo !== '')
		{
			aOutput.push('to:' + fEsc(sTo));
		}

		if (sSubject !== '')
		{
			aOutput.push('subject:' + fEsc(sSubject));
		}
		
		if (sText !== '')
		{
			aOutput.push('text:' + fEsc(sText));
		}

		if (bAttachmentsCheckbox)
		{
			aOutput.push('has:attachments');
		}

		if (sDateStart !== '' || sDateEnd !== '')
		{
			aOutput.push('date:' + fEsc(sDateStart) + '/' + fEsc(sDateEnd));
		}

		return aOutput.join(' ');
	};

	CMessageListView.prototype.onSearchClick = function ()
	{
		var
			sFolder = this.folderList().currentFolderFullName(),
			iPage = 1,
			sSearch = this.searchInput()
		;
		
		if (this.bAdvancedSearch())
		{
			sSearch = this.calculateSearchStringFromAdvancedForm();
			this.searchInput(sSearch);
			this.bAdvancedSearch(false);
		}
		this.changeRoutingForMessageList(sFolder, iPage, '', sSearch, this.filters());
	};

	CMessageListView.prototype.onRetryClick = function ()
	{
		this.requestMessageList();
	};

	CMessageListView.prototype.onClearSearchClick = function ()
	{
		var
			sFolder = this.folderList().currentFolderFullName(),
			sUid = this.currentMessage() ? this.currentMessage().uid() : '',
			sSearch = '',
			iPage = 1
		;

		this.clearAdvancedSearch();
		this.changeRoutingForMessageList(sFolder, iPage, sUid, sSearch, this.filters());
	};

	CMessageListView.prototype.onClearFilterClick = function ()
	{
		var
			sFolder = this.folderList().currentFolderFullName(),
			sUid = this.currentMessage() ? this.currentMessage().uid() : '',
			sSearch = '',
			iPage = 1,
			sFilters = ''
		;

		this.clearAdvancedSearch();
		this.changeRoutingForMessageList(sFolder, iPage, sUid, sSearch, sFilters);
	};

	CMessageListView.prototype.onStopSearchClick = function ()
	{
		this.onClearSearchClick();
	};

	/**
	 * @param {Object} oMessage
	 */
	CMessageListView.prototype.isSavingDraft = function (oMessage)
	{
		var oFolder = this.folderList().currentFolder();
		
		return (oFolder.type() === Enums.FolderTypes.Drafts) && (oMessage.uid() === MailCache.savingDraftUid());
	};

	/**
	 * @param {Object} oMessage
	 */
	CMessageListView.prototype.routeForMessage = function (oMessage)
	{
		if (oMessage !== null && !this.isSavingDraft(oMessage))
		{
			var
				oFolder = this.folderList().currentFolder(),
				sFolder = this.folderList().currentFolderFullName(),
				iPage = this.oPageSwitcher.currentPage(),
				sUid = oMessage.uid(),
				sSearch = this.search()
			;
			
			if (sUid !== '')
			{
				if (App.isMobile() && oFolder.type() === Enums.FolderTypes.Drafts)
				{
					Routing.setHash(LinksUtils.getComposeFromMessage('drafts', oMessage.folder(), oMessage.uid()));
				}
				else
				{
					this.changeRoutingForMessageList(sFolder, iPage, sUid, sSearch, this.filters());
					if (App.isMobile() && MailCache.currentMessage() && sUid === MailCache.currentMessage().uid())
					{
						MailCache.currentMessage.valueHasMutated();
					}
				}
			}
		}
	};

	/**
	 * @param {Object} $viewDom
	 */
	CMessageListView.prototype.onBind = function ($viewDom)
	{
		var
			self = this,
			fStopPopagation = _.bind(function (oEvent) {
				if (oEvent && oEvent.stopPropagation)
				{
					oEvent.stopPropagation();
				}
			}, this)
		;

		$('.message_list', $viewDom)
			.on('click', function ()
			{
				self.isFocused(false);
			})
			.on('click', '.message_sub_list .item .flag', function (oEvent)
			{
				self.onFlagClick(ko.dataFor(this));
				if (oEvent && oEvent.stopPropagation)
				{
					oEvent.stopPropagation();
				}
			})
			.on('dblclick', '.message_sub_list .item .flag', fStopPopagation)
			.on('click', '.message_sub_list .item .thread-pin', fStopPopagation)
			.on('dblclick', '.message_sub_list .item .thread-pin', fStopPopagation)
		;

		this.selector.initOnApplyBindings(
			'.message_sub_list .item',
			'.message_sub_list .item.selected',
			'.message_sub_list .item .custom_checkbox',
			$('.message_list', $viewDom),
			$('.message_list_scroll.scroll-inner', $viewDom)
		);

		this.initUploader();
	};

	/**
	 * Puts / removes the message flag by clicking on it.
	 *
	 * @param {Object} oMessage
	 */
	CMessageListView.prototype.onFlagClick = function (oMessage)
	{
		if (!this.isSavingDraft(oMessage))
		{
			MailCache.executeGroupOperation('SetMessageFlagged', [oMessage.uid()], 'flagged', !oMessage.flagged());
		}
	};

	/**
	 * Marks the selected messages read.
	 */
	CMessageListView.prototype.executeMarkAsRead = function ()
	{
		MailCache.executeGroupOperation('SetMessagesSeen', this.checkedOrSelectedUids(), 'seen', true);
	};

	/**
	 * Marks the selected messages unread.
	 */
	CMessageListView.prototype.executeMarkAsUnread = function ()
	{
		MailCache.executeGroupOperation('SetMessagesSeen', this.checkedOrSelectedUids(), 'seen', false);
	};

	/**
	 * Marks Read all messages in a folder.
	 */
	CMessageListView.prototype.executeMarkAllRead = function ()
	{
		MailCache.executeGroupOperation('SetAllMessagesSeen', [], 'seen', true);
	};

	/**
	 * Moves the selected messages in the current folder in the specified.
	 * 
	 * @param {string} sToFolder
	 */
	CMessageListView.prototype.executeMoveToFolder = function (sToFolder)
	{
		MailCache.moveMessagesToFolder(sToFolder, this.checkedOrSelectedUids());
	};

	CMessageListView.prototype.executeCopyToFolder = function (sToFolder)
	{
		MailCache.copyMessagesToFolder(sToFolder, this.checkedOrSelectedUids());
	};

	/**
	 * Calls for the selected messages delete operation. Called from the keyboard.
	 * 
	 * @param {Array} aMessages
	 */
	CMessageListView.prototype.onDeletePress = function (aMessages)
	{
		var aUids = _.map(aMessages, function (oMessage)
		{
			return oMessage.uid();
		});

		if (aUids.length > 0)
		{
			MailUtils.deleteMessages(aUids);
		}
	};

	/**
	 * Calls for the selected messages delete operation. Called by the mouse click on the delete button.
	 */
	CMessageListView.prototype.executeDelete = function ()
	{
		MailUtils.deleteMessages(this.checkedOrSelectedUids());
	};

	/**
	 * Moves the selected messages from the current folder to the folder Spam.
	 */
	CMessageListView.prototype.executeSpam = function ()
	{
		var sSpamFullName = this.folderList().spamFolderFullName();

		if (this.folderList().currentFolderFullName() !== sSpamFullName)
		{
			MailCache.moveMessagesToFolder(sSpamFullName, this.checkedOrSelectedUids());
		}
	};

	/**
	 * Moves the selected messages from the Spam folder to folder Inbox.
	 */
	CMessageListView.prototype.executeNotSpam = function ()
	{
		var oInbox = this.folderList().inboxFolder();

		if (oInbox && this.folderList().currentFolderFullName() !== oInbox.fullName())
		{
			MailCache.moveMessagesToFolder(oInbox.fullName(), this.checkedOrSelectedUids());
		}
	};

	CMessageListView.prototype.clearAdvancedSearch = function ()
	{
		this.searchInputFrom('');
		this.searchInputTo('');
		this.searchInputSubject('');
		this.searchInputText('');
		this.bAdvancedSearch(false);
		this.searchAttachmentsCheckbox(false);
		this.searchAttachments('');
		this.searchDateStart('');
		this.searchDateEnd('');
	};

	CMessageListView.prototype.onAdvancedSearchClick = function ()
	{
		this.bAdvancedSearch(!this.bAdvancedSearch());
	};

	CMessageListView.prototype.calculateSearchStringForDescription = function ()
	{
		return '<span class="part">' + TextUtils.encodeHtml(this.search()) + '</span>';
	};

	CMessageListView.prototype.initUploader = function ()
	{
		var self = this;

		if (this.uploaderArea())
		{
			this.oJua = new CJua({
				'action': '?/Api/',
				'name': 'jua-uploader',
				'queueSize': 2,
				'dragAndDropElement': this.uploaderArea(),
				'disableAjaxUpload': false,
				'disableFolderDragAndDrop': false,
				'disableDragAndDrop': false,
				'hidden': _.extendOwn({
					'Module': Settings.ServerModuleName,
					'Method': 'UploadMessage',
					'Parameters':  function () {
						return JSON.stringify({
							'AccountID': MailCache.currentAccountId(),
							'Folder': self.folderFullName()
						});
					}
				}, App.getCommonRequestParameters())
			});

			this.oJua
				.on('onDrop', _.bind(this.onFileDrop, this))
				.on('onComplete', _.bind(this.onFileUploadComplete, this))
				.on('onBodyDragEnter', _.bind(this.bDragActive, this, true))
				.on('onBodyDragLeave', _.bind(this.bDragActive, this, false))
			;
		}
	};

	CMessageListView.prototype.onFileDrop = function (oData)
	{
		if (!(oData && oData.File && oData.File.type && oData.File.type.indexOf('message/') === 0))
		{
			Screens.showError(TextUtils.i18n('MAILWEBCLIENT/ERROR_FILE_NOT_EML'));
		}
	};

	CMessageListView.prototype.onFileUploadComplete = function (sFileUid, bResponseReceived, oResponse)
	{
		var bSuccess = bResponseReceived && oResponse && !oResponse.ErrorCode;

		if (bSuccess)
		{
			MailCache.executeCheckMail(true);
		}
		else
		{
			Api.showErrorByCode(oResponse, TextUtils.i18n('COREWEBCLIENT/ERROR_UPLOAD_FILE'));
		}
	};

	module.exports = CMessageListView;


/***/ }),

/***/ 439:
/*!***********************************************************!*\
  !*** ./modules/MailWebclient/js/views/MessagePaneView.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		MainTabExtMethods = __webpack_require__(/*! modules/MailWebclient/js/MainTabExtMethods.js */ 418),
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		Pulse = __webpack_require__(/*! modules/CoreWebclient/js/Pulse.js */ 400),
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190),
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		WindowOpener = __webpack_require__(/*! modules/CoreWebclient/js/WindowOpener.js */ 195),
		
		CAbstractScreenView = __webpack_require__(/*! modules/CoreWebclient/js/views/CAbstractScreenView.js */ 193),
		
		ComposeUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Compose.js */ 408),
		LinksUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Links.js */ 401),
		MailUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Mail.js */ 419),
		SendingUtils = __webpack_require__(/*! modules/MailWebclient/js/utils/Sending.js */ 414),
		
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402),
		Ajax = __webpack_require__(/*! modules/MailWebclient/js/Ajax.js */ 403),
		MailCache  = __webpack_require__(/*! modules/MailWebclient/js/Cache.js */ 399),
		Settings = __webpack_require__(/*! modules/MailWebclient/js/Settings.js */ 392),
		
		CAttachmentModel = __webpack_require__(/*! modules/MailWebclient/js/models/CAttachmentModel.js */ 422),
		
		MainTab = App.isNewTab() && window.opener && window.opener.MainTabMailMethods
	;

	/**
	 * @constructor
	 */
	function CMessagePaneView()
	{
		CAbstractScreenView.call(this, 'MailWebclient');
		
		this.bNewTab = App.isNewTab();
		this.isLoading = ko.observable(false);

		MailCache.folderList.subscribe(this.onFolderListSubscribe, this);
		this.messages = MailCache.messages;
		this.messages.subscribe(this.onMessagesSubscribe, this);
		this.currentMessage = MailCache.currentMessage;
		this.currentMessage.subscribe(this.onCurrentMessageSubscribe, this);
		UserSettings.timeFormat.subscribe(this.onCurrentMessageSubscribe, this);
		UserSettings.dateFormat.subscribe(this.onCurrentMessageSubscribe, this);
		this.displayedMessageUid = ko.observable('');
		
		this.browserTitle = ko.computed(function () {
			var
				oMessage = this.currentMessage(),
				sSubject = oMessage ? oMessage.subject() : '',
				sPrefix = sSubject ? sSubject + ' - ' : ''
			;
			return sPrefix + AccountList.getEmail() + ' - ' + TextUtils.i18n('MAILWEBCLIENT/HEADING_MESSAGE_BROWSER_TAB');
		}, this);
		
		this.isCurrentMessage = ko.computed(function () {
			return !!this.currentMessage();
		}, this);
		
		this.isCurrentMessageLoaded = ko.computed(function () {
			return this.isCurrentMessage() && !this.isLoading();
		}, this);
		
		this.visibleNoMessageSelectedText = ko.computed(function () {
			return this.messages().length > 0 && !this.isCurrentMessage();
		}, this);
		
		this.prevMessageUid = MailCache.prevMessageUid;
		this.nextMessageUid = MailCache.nextMessageUid;

		this.isEnablePrevMessage = ko.computed(function () {
			return App.isNewTab() && Types.isNonEmptyString(this.prevMessageUid());
		}, this);
		this.isEnableNextMessage = ko.computed(function () {
			return App.isNewTab() && Types.isNonEmptyString(this.nextMessageUid());
		}, this);
		
		this.isEnableDelete = this.isCurrentMessage;
		this.isEnableReply = this.isCurrentMessageLoaded;
		this.isEnableReplyAll = this.isCurrentMessageLoaded;
		this.isEnableResend = this.isCurrentMessageLoaded;
		this.isEnableForward = this.isCurrentMessageLoaded;
		this.isEnablePrint = this.isCurrentMessageLoaded;
		this.isEnableSave = function () {
			return this.isCurrentMessage() && this.currentMessage().sDownloadAsEmlUrl !== '';
		};
		
		this.deleteCommand = Utils.createCommand(this, this.executeDeleteMessage, this.isEnableDelete);
		this.prevMessageCommand = Utils.createCommand(this, this.executePrevMessage, this.isEnablePrevMessage);
		this.nextMessageCommand = Utils.createCommand(this, this.executeNextMessage, this.isEnableNextMessage);
		this.replyCommand = Utils.createCommand(this, this.executeReply, this.isEnableReply);
		this.replyAllCommand = Utils.createCommand(this, this.executeReplyAll, this.isEnableReplyAll);
		this.resendCommand = Utils.createCommand(this, this.executeResend, this.isEnableResend);
		this.forwardCommand = Utils.createCommand(this, this.executeForward, this.isEnableForward);
		this.printCommand = Utils.createCommand(this, this.executePrint, this.isEnablePrint);
		this.saveCommand = Utils.createCommand(this, this.executeSave, this.isEnableSave);
		this.forwardAsAttachment = Utils.createCommand(this, this.executeForwardAsAttachment, this.isCurrentMessageLoaded);
		this.moreCommand = Utils.createCommand(this, null, this.isCurrentMessageLoaded);
		this.moreSectionCommands = ko.observableArray([]);
		App.broadcastEvent('MailWebclient::AddMoreSectionCommand', _.bind(function (oCommand) {
			var oNewCommand = _.extend({'Text': '', 'CssClass': '', 'Handler': function () {}}, oCommand);
			oNewCommand.Command = Utils.createCommand(this, oNewCommand.Handler, this.isCurrentMessageLoaded);
			this.moreSectionCommands.push(oNewCommand);
		}, this));

		this.visiblePicturesControl = ko.observable(false);
		this.visibleShowPicturesLink = ko.observable(false);
		
		this.visibleConfirmationControl = ko.computed(function () {
			return (this.currentMessage() && this.currentMessage().readingConfirmationAddressee() !== '');
		}, this);
		
		this.isCurrentNotDraftOrSent = ko.computed(function () {
			var oCurrFolder = MailCache.folderList().currentFolder();
			return (oCurrFolder && oCurrFolder.fullName().length > 0 &&
				oCurrFolder.type() !== Enums.FolderTypes.Drafts &&
				oCurrFolder.type() !== Enums.FolderTypes.Sent);
		}, this);

		this.isCurrentSentFolder = ko.computed(function () {
			var oCurrFolder = MailCache.folderList().currentFolder();
			return !!oCurrFolder && oCurrFolder.fullName().length > 0 && oCurrFolder.type() === Enums.FolderTypes.Sent;
		}, this);

		this.isCurrentNotDraftFolder = ko.computed(function () {
			var oCurrFolder = MailCache.folderList().currentFolder();
			return !!oCurrFolder && oCurrFolder.fullName().length > 0 && oCurrFolder.type() !== Enums.FolderTypes.Drafts;
		}, this);

		this.isVisibleReplyTool = this.isCurrentNotDraftOrSent;
		this.isVisibleResendTool = this.isCurrentSentFolder;
		this.isVisibleForwardTool = this.isCurrentNotDraftFolder;

		this.uid = ko.observable('');
		this.folder = ko.observable('');
		this.folder.subscribe(function () {
			if (this.jqPanelHelper)
			{
				this.jqPanelHelper.trigger('resize', [null, 'min', null, true]);
			}
		}, this);
		this.subject = ko.observable('');
		this.emptySubject = ko.computed(function () {
			return ($.trim(this.subject()) === '');
		}, this);
		this.subjectForDisplay = ko.computed(function () {
			return this.emptySubject() ? TextUtils.i18n('MAILWEBCLIENT/LABEL_NO_SUBJECT') : this.subject();
		}, this);
		this.importance = ko.observable(Enums.Importance.Normal);
		this.oFromAddr = ko.observable(null);
		this.from = ko.observable('');
		this.fromEmail = ko.observable('');
		this.fullFrom = ko.observable('');
		this.to = ko.observable('');
		this.aToAddr = ko.observableArray([]);
		this.cc = ko.observable('');
		this.aCcAddr = ko.observableArray([]);
		this.bcc = ko.observable('');
		this.aBccAddr = ko.observableArray([]);
		this.allRecipients = ko.observableArray([]);
		this.currentAccountEmail = ko.observable();
		this.meSender = TextUtils.i18n('MAILWEBCLIENT/LABEL_ME_SENDER');
		this.meRecipient = TextUtils.i18n('MAILWEBCLIENT/LABEL_ME_RECIPIENT');
		
		this.fullDate = ko.observable('');
		this.midDate = ko.observable('');

		this.textBody = ko.observable('');
		this.textBodyForNewWindow = ko.observable('');
		this.domTextBody = ko.observable(null);
		this.rtlMessage = ko.observable(false);
		
		this.contentHasFocus = ko.observable(false);

		this.topControllers = ko.observableArray();
		this.bodyControllers = ko.observableArray();
		this.controllers = ko.computed(function () {
			return _.union(this.topControllers(), this.bodyControllers());
		}, this);
		App.broadcastEvent('MailWebclient::RegisterMessagePaneController', _.bind(function (oController, sPlace) {
			this.registerController(oController, sPlace);
		}, this));
		
		this.fakeHeader = ko.computed(function () {
			var topControllersVisible = !!_.find(this.topControllers(), function (oController) {
				return !!oController.visible && oController.visible();
			});
			return !(this.visiblePicturesControl() || this.visibleConfirmationControl() || topControllersVisible);
		}, this);

		this.sAttachmentsSwitcherViewTemplate = App.isMobile() ? 'MailWebclient_Message_AttachmentsSwitcherView' : '';
		this.sQuickReplyViewTemplate = App.isMobile() ? '' : 'MailWebclient_Message_QuickReplyView';
		
		this.attachments = ko.observableArray([]);
		this.usesAttachmentString = true;
		this.attachmentsInString = ko.computed(function () {
			return _.map(this.attachments(), function (oAttachment) {
				return oAttachment.fileName();
			}, this).join(', ');
		}, this);
		this.notInlineAttachments = ko.computed(function () {
			return _.filter(this.attachments(), function (oAttach) {
				return !oAttach.linked();
			});
		}, this);
		
		this.allAttachmentsDownloadMethods = ko.observableArray([]);
		this.visibleDownloadAllAttachmentsSeparately = ko.computed(function () {
			return this.notInlineAttachments().length > 1;
		}, this);
		this.visibleExtendedDownload = ko.computed(function () {
			return !App.isMobile() && (this.visibleDownloadAllAttachmentsSeparately() 
					|| this.allAttachmentsDownloadMethods().length > 0);
		}, this);
		App.broadcastEvent('MailWebclient::AddAllAttachmentsDownloadMethod', _.bind(function (oMethod) {
			this.allAttachmentsDownloadMethods.push(oMethod);
		}, this));
		
		this.detailsVisible = ko.observable(Storage.getData('MessageDetailsVisible') === '1');
		this.detailsTooltip = ko.computed(function () {
			return this.detailsVisible() ? TextUtils.i18n('COREWEBCLIENT/ACTION_HIDE_DETAILS') : TextUtils.i18n('COREWEBCLIENT/ACTION_SHOW_DETAILS');
		}, this);

		this.hasNotInlineAttachments = ko.computed(function () {
			return this.notInlineAttachments().length > 0;
		}, this);
		
		this.hasBodyText = ko.computed(function () {
			return this.textBody().length > 0;
		}, this);

		this.visibleAddMenu = ko.observable(false);
		
		// Quick Reply Part
		
		this.replyText = ko.observable('');
		this.replyTextFocus = ko.observable(false);
		this.replyPaneVisible = ko.computed(function () {
			return this.currentMessage() && this.currentMessage().completelyFilled();
		}, this);
		this.replySendingStarted = ko.observable(false);
		this.replySavingStarted = ko.observable(false);
		this.replyAutoSavingStarted = ko.observable(false);
		this.requiresPostponedSending = ko.observable(false);
		this.replyAutoSavingStarted.subscribe(function () {
			if (!this.replyAutoSavingStarted() && this.requiresPostponedSending())
			{
				SendingUtils.sendPostponedMail(this.replyDraftUid());
				this.requiresPostponedSending(false);
			}
		}, this);
		this.hasReplyAllCcAddrs = ko.observable(false);
		this.placeholderText = ko.computed(function () {
			return this.hasReplyAllCcAddrs() ? TextUtils.i18n('MAILWEBCLIENT/LABEL_QUICK_REPLY_ALL') : TextUtils.i18n('MAILWEBCLIENT/LABEL_QUICK_REPLY');
		}, this);
		this.sendButtonText = ko.computed(function () {
			return this.hasReplyAllCcAddrs() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_SEND_ALL') : TextUtils.i18n('MAILWEBCLIENT/ACTION_SEND');
		}, this);
		
		ko.computed(function () {
			if (!this.replyTextFocus() || this.replyAutoSavingStarted() || this.replySavingStarted() || this.replySendingStarted())
			{
				this.stopAutosaveTimer();
			}
			if (this.replyTextFocus() && !this.replyAutoSavingStarted() && !this.replySavingStarted() && !this.replySendingStarted())
			{
				this.startAutosaveTimer();
			}
		}, this);
		
		this.saveButtonText = ko.computed(function () {
			return this.replyAutoSavingStarted() ? TextUtils.i18n('MAILWEBCLIENT/ACTION_SAVE_IN_PROGRESS') : TextUtils.i18n('MAILWEBCLIENT/ACTION_SAVE');
		}, this);
		this.replyDraftUid = ko.observable('');
		this.replyLoadingText = ko.computed(function () {
			if (this.replySendingStarted())
			{
				return TextUtils.i18n('COREWEBCLIENT/INFO_SENDING');
			}
			else if (this.replySavingStarted())
			{
				return TextUtils.i18n('MAILWEBCLIENT/INFO_SAVING');
			}
			return '';
		}, this);
		
		this.isEnableSendQuickReply = ko.computed(function () {
			return this.isCurrentMessageLoaded() && this.replyText() !== '' && !this.replySendingStarted();
		}, this);
		this.isEnableSaveQuickReply = ko.computed(function () {
			return this.isEnableSendQuickReply() && !this.replySavingStarted() && !this.replyAutoSavingStarted();
		}, this);
		
		this.saveQuickReplyCommand = Utils.createCommand(this, this.executeSaveQuickReply, this.isEnableSaveQuickReply);
		this.sendQuickReplyCommand = Utils.createCommand(this, this.executeSendQuickReply, this.isEnableSendQuickReply);

		this.domMessageHeader = ko.observable(null);
		this.domQuickReply = ko.observable(null);
		
		this.domMessageForPrint = ko.observable(null);
		
		// to have time to take action "Open full reply form" before the animation starts
		this.replyTextFocusThrottled = ko.observable(false).extend({'throttle': 50});
		
		this.replyTextFocus.subscribe(function () {
			this.replyTextFocusThrottled(this.replyTextFocus());
		}, this);
		
		this.isQuickReplyActive = ko.computed(function () {
			return this.replyText().length > 0 || this.replyTextFocusThrottled();
		}, this);

		//*** Quick Reply Part

		this.jqPanelHelper = null;
		
		this.visibleAttachments = ko.observable(false);
		this.showMessage = function () {
			this.visibleAttachments(false);
		};
		this.showAttachments = function () {
			this.visibleAttachments(true);
		};
		
		this.sDefaultFontName = Settings.DefaultFontName;
		
		Pulse.registerDayOfMonthFunction(_.bind(this.updateMomentDate, this));
		
		App.broadcastEvent('MailWebclient::ConstructView::after', {'Name': 'CMessagePaneView', 'View': this});
	}

	_.extendOwn(CMessagePaneView.prototype, CAbstractScreenView.prototype);

	CMessagePaneView.prototype.ViewTemplate = App.isNewTab() ? 'MailWebclient_MessagePaneScreenView' : 'MailWebclient_MessagePaneView';
	CMessagePaneView.prototype.ViewConstructorName = 'CMessagePaneView';

	/**
	 * @param {object} oData
	 * @param {object} oEvent
	 */
	CMessagePaneView.prototype.resizeDblClick = function (oData, oEvent)
	{
		if (oEvent.target.className !== '' && !!oEvent.target.className.search(/add_contact|icon|link|title|subject|link|date|from/))
		{
			Utils.calmEvent(oEvent);
			Utils.removeSelection();
			if (!this.jqPanelHelper)
			{
				this.jqPanelHelper = $('.MailLayout .panel_helper');
			}
			this.jqPanelHelper.trigger('resize', [5, 'min', true]);
		}
	};

	CMessagePaneView.prototype.notifySender = function ()
	{
		if (this.currentMessage() && this.currentMessage().readingConfirmationAddressee() !== '')
		{
			var sText = TextUtils.i18n('MAILWEBCLIENT/LABEL_RETURN_RECEIPT_MAIL_TEXT', {
				'EMAIL': AccountList.getEmail(),
				'SUBJECT': this.subject()
			}).replace(/\\r\\n/g, '\n');
			Ajax.send('SendMessage', {
				'To': this.currentMessage().readingConfirmationAddressee(),
				'Subject': TextUtils.i18n('MAILWEBCLIENT/LABEL_RETURN_RECEIPT_MAIL_SUBJECT'),
				'Text': sText,
				'ConfirmFolder': this.currentMessage().folder(),
				'ConfirmUid': this.currentMessage().uid()
			});
			this.currentMessage().readingConfirmationAddressee('');
		}
	};

	CMessagePaneView.prototype.onFolderListSubscribe = function ()
	{
		if (App.isNewTab())
		{
			this.onMessagesSubscribe();
		}
	};

	CMessagePaneView.prototype.onMessagesSubscribe = function ()
	{
		if (!this.currentMessage() && this.uid().length > 0)
		{
			MailCache.setCurrentMessage(this.uid(), this.folder());
		}
	};

	/**
	 * @param {string} sUniq
	 */
	CMessagePaneView.prototype.passReplyDataToNewTab = function (sUniq)
	{
		if (this.currentMessage() && this.currentMessage().sUniq === sUniq && this.replyText() !== '')
		{
			MainTabExtMethods.passReplyData(sUniq, {
				'ReplyText': this.replyText(),
				'ReplyDraftUid': this.replyDraftUid()
			});
			
			this.replyText('');
			this.replyDraftUid('');
		}
	};

	CMessagePaneView.prototype.onCurrentMessageSubscribe = function ()
	{
		var
			oMessage = this.currentMessage(),
			oAccount = oMessage ? AccountList.getAccount(oMessage.accountId()) : null,
			oReplyData = null
		;
		
		if (MainTab && oMessage)
		{
			oReplyData = MainTab.getReplyData(oMessage.sUniq);
			if (oReplyData)
			{
				this.replyText(oReplyData.ReplyText);
				this.replyDraftUid(oReplyData.ReplyDraftUid);
			}
		}
		else if (!oMessage || oMessage.uid() !== this.displayedMessageUid())
		{
			this.replyText('');
			this.replyDraftUid('');
		}
		
		if (oMessage && this.uid() === oMessage.uid())
		{
			this.hasReplyAllCcAddrs(SendingUtils.hasReplyAllCcAddrs(oMessage));
			
			this.subject(oMessage.subject());
			this.importance(oMessage.importance());
			this.from(oMessage.oFrom.getDisplay());
			this.fromEmail(oMessage.oFrom.getFirstEmail());

			this.fullFrom(oMessage.oFrom.getFull());
			if (oMessage.oFrom.aCollection.length > 0)
			{
				this.oFromAddr(oMessage.oFrom.aCollection[0]);
			}
			else
			{
				this.oFromAddr(null);
			}
			
			this.to(oMessage.oTo.getFull());
			this.aToAddr(oMessage.oTo.aCollection);
			this.cc(oMessage.oCc.getFull());
			this.aCcAddr(oMessage.oCc.aCollection);
			this.bcc(oMessage.oBcc.getFull());
			this.aBccAddr(oMessage.oBcc.aCollection);

			this.currentAccountEmail(oAccount.email());
			this.allRecipients(_.uniq(_.union(this.aToAddr(), this.aCcAddr(), this.aBccAddr())));

			this.midDate(oMessage.oDateModel.getMidDate());
			this.fullDate(oMessage.oDateModel.getFullDate());

			this.isLoading(oMessage.uid() !== '' && !oMessage.completelyFilled());
			
			this.setMessageBody();
			
			this.rtlMessage(oMessage.rtl());

			if (App.isNewTab())
			{
				/*jshint onevar: false*/
				var aAtachments = [];
				/*jshint onevar: true*/

				_.each(oMessage.attachments(), _.bind(function (oAttach) {
					var oCopy = new CAttachmentModel();
					oCopy.copyProperties(oAttach);
					aAtachments.push(oCopy);
				}, this));
				
				this.attachments(aAtachments);
			}
			else
			{
				this.attachments(oMessage.attachments());
			}

			if (!oMessage.completelyFilled() || oMessage.trimmed())
			{
				/*jshint onevar: false*/
				var oSubscribedField = !oMessage.completelyFilled() ? oMessage.completelyFilled : oMessage.trimmed;
				/*jshint onevar: true*/
				if (App.isNewTab())
				{
					oMessage.completelyFilledNewTabSubscription = oSubscribedField.subscribe(this.onCurrentMessageSubscribe, this);
				}
				else
				{
					oMessage.completelyFilledSubscription = oSubscribedField.subscribe(this.onCurrentMessageSubscribe, this);
				}
			}
			else if (oMessage.completelyFilledSubscription)
			{
				oMessage.completelyFilledSubscription.dispose();
				oMessage.completelyFilledSubscription = undefined;
			}
			else if (oMessage.completelyFilledNewTabSubscription)
			{
				oMessage.completelyFilledNewTabSubscription.dispose();
				oMessage.completelyFilledNewTabSubscription = undefined;
			}
		}
		else
		{
			this.hasReplyAllCcAddrs(false);
			
			this.isLoading(false);
			$(this.domTextBody()).empty().data('displayed-message-uid', '');
			this.displayedMessageUid('');
			this.rtlMessage(false);
			
			// cannot use removeAll, because the attachments of messages are passed by reference 
			// and the call to removeAll removes attachments from message in the cache too.
			this.attachments([]);
			this.visiblePicturesControl(false);
			this.visibleShowPicturesLink(false);
		}
		
		this.doAfterPopulatingMessage();
	};

	CMessagePaneView.prototype.updateMomentDate = function ()
	{
		var oMessage = this.currentMessage();
		if (oMessage && oMessage.oDateModel)
		{
			this.midDate(oMessage.oDateModel.getMidDate());
			this.fullDate(oMessage.oDateModel.getFullDate());
		}
	};

	CMessagePaneView.prototype.setMessageBody = function ()
	{
		if (this.currentMessage())
		{
			var
				oMessage = this.currentMessage(),
				sText = oMessage.text(),
				$body = $(this.domTextBody()),
				oDom = null,
				sHtml = '',
				sLen = sText.length,
				sMaxLen = 5000000,
				aCollapsedStatuses = []
			;

			this.textBody(sText);
			
			if ($body.data('displayed-message-uid') === oMessage.uid())
			{
				aCollapsedStatuses = this.getBlockquotesStatus();
			}

			$body.empty();

			if (oMessage.isPlain() || sLen > sMaxLen)
			{
				$body.html(sText);

				this.visiblePicturesControl(false);
			}
			else
			{
				oDom = oMessage.getDomText();
				sHtml = oDom.length > 0 ? oDom.html() : '';

				$body.append(sHtml);

				this.visiblePicturesControl(oMessage.hasExternals() && !oMessage.isExternalsAlwaysShown());
				this.visibleShowPicturesLink(!oMessage.isExternalsShown());

				if (!TextUtils.htmlStartsWithBlockquote(sHtml))
				{
					this.doHidingBlockquotes(aCollapsedStatuses);
				}
			}

			$body.data('displayed-message-uid', oMessage.uid());
			this.displayedMessageUid(oMessage.uid());
		}
	};

	CMessagePaneView.prototype.getBlockquotesStatus = function ()
	{
		var aCollapsedStatuses = [];
		
		$($('blockquote', $(this.domTextBody())).get()).each(function () {
			var $blockquote = $(this);
			
			if ($blockquote.hasClass('blockquote_before_toggle'))
			{
				aCollapsedStatuses.push($blockquote.hasClass('collapsed'));
			}
		});
		
		return aCollapsedStatuses;
	};

	/**
	 * @param {Array} aCollapsedStatuses
	 */
	CMessagePaneView.prototype.doHidingBlockquotes = function (aCollapsedStatuses)
	{
		var
			iMinHeightForHide = 120,
			iHiddenHeight = 80,
			iStatusIndex = 0
		;
		
		$($('blockquote', $(this.domTextBody())).get()).each(function () {
			var
				$blockquote = $(this),
				$parentBlockquotes = $blockquote.parents('blockquote'),
				$switchButton = $('<span class="blockquote_toggle"></span>').html(TextUtils.i18n('MAILWEBCLIENT/ACTION_SHOW_QUOTED_TEXT')),
				bHidden = true
			;
			if ($parentBlockquotes.length === 0)
			{
				if ($blockquote.height() > iMinHeightForHide)
				{
					$blockquote
						.addClass('blockquote_before_toggle')
						.after($switchButton)
						.wrapInner('<div class="blockquote_content"></div>')
					;
					$switchButton.bind('click', function () {
						if (bHidden)
						{
							$blockquote.height('auto');
							$switchButton.html(TextUtils.i18n('MAILWEBCLIENT/ACTION_HIDE_QUOTED_TEXT'));
							bHidden = false;
						}
						else
						{
							$blockquote.height(iHiddenHeight);
							$switchButton.html(TextUtils.i18n('MAILWEBCLIENT/ACTION_SHOW_QUOTED_TEXT'));
							bHidden = true;
						}
						
						$blockquote.toggleClass('collapsed', bHidden);
					});
					if (iStatusIndex < aCollapsedStatuses.length)
					{
						bHidden = aCollapsedStatuses[iStatusIndex];
						iStatusIndex++;
					}
					$blockquote.height(bHidden ? iHiddenHeight : 'auto').toggleClass('collapsed', bHidden);
				}
			}
		});
	};

	/**
	 * @param {Array} aParams
	 */
	CMessagePaneView.prototype.onRoute = function (aParams)
	{
		var oParams = LinksUtils.parseMailbox(aParams);
		
		AccountList.changeCurrentAccountByHash(oParams.AccountHash);
		
		if (this.replyText() !== '' && this.uid() !== oParams.Uid)
		{
			this.saveReplyMessage(false);
		}

		this.uid(oParams.Uid);
		this.folder(oParams.Folder);
		MailCache.setCurrentMessage(this.uid(), this.folder());
		
		this.contentHasFocus(true);
	};

	CMessagePaneView.prototype.showPictures = function ()
	{
		MailCache.showExternalPictures(false);
		this.visibleShowPicturesLink(false);
		this.setMessageBody();
	};

	CMessagePaneView.prototype.alwaysShowPictures = function ()
	{
		var sEmail = this.currentMessage() ? this.currentMessage().oFrom.getFirstEmail() : '';

		if (sEmail.length > 0)
		{
			Ajax.send('SetEmailSafety', {'Email': sEmail});
		}

		MailCache.showExternalPictures(true);
		this.visiblePicturesControl(false);
		this.setMessageBody();
	};

	CMessagePaneView.prototype.openInNewWindow = function ()
	{
		this.openMessageInNewWindowBound(this.currentMessage());
	};

	CMessagePaneView.prototype.getReplyHtmlText = function ()
	{
		return '<div style="font-family: ' + this.sDefaultFontName + '; font-size: 16px">' + SendingUtils.getHtmlFromText(this.replyText()) + '</div>';
	};

	/**
	 * @param {string} sReplyType
	 */
	CMessagePaneView.prototype.executeReplyOrForward = function (sReplyType)
	{
		if (this.currentMessage())
		{
			SendingUtils.setReplyData(this.getReplyHtmlText(), this.replyDraftUid());
			
			this.replyText('');
			this.replyDraftUid('');
			
			ComposeUtils.composeMessageAsReplyOrForward(sReplyType, this.currentMessage().folder(), this.currentMessage().uid());
		}
	};

	CMessagePaneView.prototype.executeDeleteMessage = function ()
	{
		if (this.currentMessage())
		{
			if (MainTab)
			{
				MainTab.deleteMessage(this.currentMessage().uid(), function () { window.close(); });
			}
			else if (App.isMobile())
			{
				MailUtils.deleteMessages([this.currentMessage().uid()], App);
			}
		}
	};

	CMessagePaneView.prototype.executePrevMessage = function ()
	{
		if (this.isEnablePrevMessage())
		{
			Routing.setHash(LinksUtils.getViewMessage(MailCache.folderList().currentFolderFullName(), this.prevMessageUid()));
		}
	};

	CMessagePaneView.prototype.executeNextMessage = function ()
	{
		if (this.isEnableNextMessage())
		{
			Routing.setHash(LinksUtils.getViewMessage(MailCache.folderList().currentFolderFullName(), this.nextMessageUid()));
		}
	};

	CMessagePaneView.prototype.executeReply = function ()
	{
		this.executeReplyOrForward(Enums.ReplyType.Reply);
	};

	CMessagePaneView.prototype.executeReplyAll = function ()
	{
		this.executeReplyOrForward(Enums.ReplyType.ReplyAll);
	};

	CMessagePaneView.prototype.executeResend = function ()
	{
		this.executeReplyOrForward(Enums.ReplyType.Resend);
	};

	CMessagePaneView.prototype.executeForward = function ()
	{
		this.executeReplyOrForward(Enums.ReplyType.Forward);
	};

	CMessagePaneView.prototype.executePrint = function ()
	{
		var
			oMessage = this.currentMessage(),
			oWin = oMessage ? WindowOpener.open('', this.subject() + '-print') : null,
			sHtml = ''
		;

		if (oMessage && oWin)
		{
			this.textBodyForNewWindow(oMessage.getConvertedHtml(UrlUtils.getAppPath(), true));
			sHtml = $(this.domMessageForPrint()).html();

			$(oWin.document.body).html(sHtml);
			oWin.print();
		}
	};

	CMessagePaneView.prototype.executeSave = function ()
	{
		if (this.isEnableSave())
		{
			UrlUtils.downloadByUrl(this.currentMessage().sDownloadAsEmlUrl);
		}
	};

	CMessagePaneView.prototype.executeForwardAsAttachment = function ()
	{
		if (this.currentMessage())
		{
			ComposeUtils.composeMessageWithEml(this.currentMessage());
		}
	};

	CMessagePaneView.prototype.changeAddMenuVisibility = function ()
	{
		var bVisibility = !this.visibleAddMenu();
		this.visibleAddMenu(bVisibility);
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CMessagePaneView.prototype.onSendOrSaveMessageResponse = function (oResponse, oRequest)
	{
		var oResData = SendingUtils.onSendOrSaveMessageResponse(oResponse, oRequest, this.requiresPostponedSending());
		switch (oResData.Method)
		{
			case 'SendMessage':
				this.replySendingStarted(false);
				if (oResData.Result)
				{
					this.replyText('');
				}
				break;
			case 'SaveMessage':
				if (oResData.Result)
				{
					this.replyDraftUid(oResData.NewUid);
				}
				this.replySavingStarted(false);
				this.replyAutoSavingStarted(false);
				break;
		}
	};

	CMessagePaneView.prototype.executeSendQuickReply = function ()
	{
		if (this.isEnableSendQuickReply())
		{
			this.replySendingStarted(true);
			this.requiresPostponedSending(this.replyAutoSavingStarted());
			SendingUtils.sendReplyMessage('SendMessage', this.getReplyHtmlText(), this.replyDraftUid(), 
				this.onSendOrSaveMessageResponse, this, this.requiresPostponedSending());

			this.replyTextFocus(false);
		}
	};

	CMessagePaneView.prototype.executeSaveQuickReply = function ()
	{
		this.saveReplyMessage(false);
	};

	/**
	 * @param {Boolean} bAutosave
	 */
	CMessagePaneView.prototype.saveReplyMessage = function (bAutosave)
	{
		if (this.isEnableSaveQuickReply())
		{
			if (bAutosave)
			{
				this.replyAutoSavingStarted(true);
			}
			else
			{
				this.replySavingStarted(true);
			}
			SendingUtils.sendReplyMessage('SaveMessage', this.getReplyHtmlText(), this.replyDraftUid(), 
				this.onSendOrSaveMessageResponse, this);
		}
	};

	/**
	 * Stops autosave.
	 */
	CMessagePaneView.prototype.stopAutosaveTimer = function ()
	{
		window.clearTimeout(this.autoSaveTimer);
	};

	/**
	 * Starts autosave.
	 */
	CMessagePaneView.prototype.startAutosaveTimer = function ()
	{
		if (this.isEnableSaveQuickReply())
		{
			var fSave = _.bind(this.saveReplyMessage, this, true);
			this.stopAutosaveTimer();
			if (Settings.AllowAutosaveInDrafts)
			{
				this.autoSaveTimer = window.setTimeout(fSave, Settings.AutoSaveIntervalSeconds * 1000);
			}
		}
	};

	CMessagePaneView.prototype.executeAllAttachmentsDownloadMethod = function (fHandler)
	{
		if (this.currentMessage())
		{
			fHandler(this.currentMessage().accountId(), this.currentMessage().getAttachmentsHashes());
		}
	};

	CMessagePaneView.prototype.downloadAllAttachmentsSeparately = function ()
	{
		if (this.currentMessage())
		{
			this.currentMessage().downloadAllAttachmentsSeparately();
		}
	};

	CMessagePaneView.prototype.onShow = function ()
	{
		this.bShown = true;
	};

	CMessagePaneView.prototype.onHide = function ()
	{
		this.bShown = false;
	};

	/**
	 * @param {Object} $MailViewDom
	 */
	CMessagePaneView.prototype.onBind = function ($MailViewDom)
	{
		ModulesManager.run('SessionTimeoutWeblient', 'registerFunction', [_.bind(function () {
			if (this.replyText() !== '')
			{
				this.saveReplyMessage(false);
			}
		}, this)]);

		this.$MailViewDom = _.isUndefined($MailViewDom) ? this.$viewDom : $MailViewDom;
		
		this.$MailViewDom.on('mousedown', 'a', function (oEvent) {
			if (oEvent && 3 !== oEvent['which'])
			{
				var sHref = $(this).attr('href');
				if (sHref && 'mailto:' === sHref.toString().toLowerCase().substr(0, 7))
				{
					ComposeUtils.composeMessageToAddresses(sHref.toString());
					return false;
				}
			}

			return true;
		});

		if (!App.isMobile())
		{
			this.hotKeysBind();
		}
	};

	CMessagePaneView.prototype.hotKeysBind = function ()
	{
		$(document).on('keydown', $.proxy(function(ev) {

			var	bComputed = this.bShown && ev && !ev.ctrlKey && !ev.shiftKey &&
				!Utils.isTextFieldFocused() && this.isEnableReply();

			if (bComputed && ev.keyCode === Enums.Key.q)
			{
				ev.preventDefault();
				this.replyTextFocus(true);
			}
			else if (bComputed && ev.keyCode === Enums.Key.r)
			{
				this.executeReply();
			}
		}, this));
	};

	CMessagePaneView.prototype.showSourceHeaders = function ()
	{
		var
			oMessage = this.currentMessage(),
			oWin = oMessage && oMessage.completelyFilled() ? WindowOpener.open('', this.subject() + '-headers') : null
		;

		if (oWin)
		{
			$(oWin.document.body).html('<pre>' + TextUtils.encodeHtml(oMessage.sourceHeaders()) + '</pre>');
		}
	};

	CMessagePaneView.prototype.switchDetailsVisibility = function ()
	{
		this.detailsVisible(!this.detailsVisible());
		Storage.setData('MessageDetailsVisible', this.detailsVisible() ? '1' : '0');
	};

	/**
	 * @param {Object} oController
	 * @param {string} sPlace
	 */
	CMessagePaneView.prototype.registerController = function (oController, sPlace) {
		switch (sPlace)
		{
			case 'BeforeMessageHeaders':
				this.topControllers.push(oController);
				break
			case 'BeforeMessageBody':
				this.bodyControllers.push(oController);
				break
		}
		
		if ($.isFunction(oController.assignMessagePaneExtInterface))
		{
			oController.assignMessagePaneExtInterface(this.getExtInterface());
		}
	};

	/**
	 * @returns {Object}
	 */
	CMessagePaneView.prototype.getExtInterface = function ()
	{
		return {
			changeText: _.bind(function (sText) {
				var oMessage = this.currentMessage();
				if (oMessage && this.isCurrentMessageLoaded())
				{
					oMessage.text(sText);
					oMessage.$text = null;
					this.setMessageBody();
				}
			}, this)
		};
	};

	CMessagePaneView.prototype.doAfterPopulatingMessage = function ()
	{
		var
			oMessage = this.currentMessage(),
			bLoaded = oMessage && this.isCurrentMessageLoaded(),
			oMessageProps = bLoaded ? {
				aToEmails: oMessage.oTo.getEmails(),
				bPlain: oMessage.isPlain(),
				sRawText: oMessage.textRaw(),
				sText: oMessage.text(),
				sAccountEmail: AccountList.getEmail(oMessage.accountId()),
				sFromEmail: oMessage.oFrom.getFirstEmail(),
				iSensitivity: oMessage.sensitivity(),
				aExtend: oMessage.aExtend
			} : null
		;
		
		_.each(this.controllers(), _.bind(function (oController) {
			if ($.isFunction(oController.doAfterPopulatingMessage))
			{
				oController.doAfterPopulatingMessage(oMessageProps);
			}
		}, this));
		
		ModulesManager.run('ContactsWebclient', 'applyContactsCards', [this.$MailViewDom.find('span.address')]);
	};

	module.exports = new CMessagePaneView();


/***/ }),

/***/ 440:
/*!****************************************************************!*\
  !*** ./modules/MailMobileWebclient/js/views/HeaderItemView.js ***!
  \****************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		
		CAbstractHeaderItemView = __webpack_require__(/*! modules/CoreWebclient/js/views/CHeaderItemView.js */ 280),
				
		AccountList = __webpack_require__(/*! modules/MailWebclient/js/AccountList.js */ 402)
	;

	function CHeaderItemView()
	{
		CAbstractHeaderItemView.call(this, TextUtils.i18n('MAILMOBILEWEBCLIENT/ACTION_SHOW_MAIL'));
		
		this.accounts = AccountList.collection;
	}

	_.extendOwn(CHeaderItemView.prototype, CAbstractHeaderItemView.prototype);

	CHeaderItemView.prototype.ViewTemplate = 'MailMobileWebclient_HeaderItemView';

	var HeaderItemView = new CHeaderItemView();

	HeaderItemView.allowChangeTitle(true);

	module.exports = HeaderItemView;


/***/ })

});