webpackJsonp([39],{

/***/ 243:
/*!*************************************************************!*\
  !*** ./modules/CoreWebclient/js/views/CPageSwitcherView.js ***!
  \*************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179)
	;

	/**
	 * @constructor
	 * @param {number} iCount
	 * @param {number} iPerPage
	 */
	function CPageSwitcherView(iCount, iPerPage)
	{
		this.bShown = false;
		
		this.currentPage = ko.observable(1);
		this.count = ko.observable(iCount);
		this.perPage = ko.observable(iPerPage);
		this.firstPage = ko.observable(1);
		this.lastPage = ko.observable(1);

		this.pagesCount = ko.computed(function () {
			var iCount = this.perPage() > 0 ? Math.ceil(this.count() / this.perPage()) : 0;
			return (iCount > 0) ? iCount : 1;
		}, this);

		ko.computed(function () {

			var
				iAllLimit = 20,
				iLimit = 4,
				iPagesCount = this.pagesCount(),
				iCurrentPage = this.currentPage(),
				iStart = iCurrentPage,
				iEnd = iCurrentPage
			;

			if (iPagesCount > 1)
			{
				while (true)
				{
					iAllLimit--;
					
					if (1 < iStart)
					{
						iStart--;
						iLimit--;
					}

					if (0 === iLimit)
					{
						break;
					}

					if (iPagesCount > iEnd)
					{
						iEnd++;
						iLimit--;
					}

					if (0 === iLimit)
					{
						break;
					}

					if (0 === iAllLimit)
					{
						break;
					}
				}
			}

			this.firstPage(iStart);
			this.lastPage(iEnd);
			
		}, this);

		this.visibleFirst = ko.computed(function () {
			return (this.firstPage() > 1);
		}, this);

		this.visibleLast = ko.computed(function () {
			return (this.lastPage() < this.pagesCount());
		}, this);

		this.clickPage = _.bind(this.clickPage, this);

		this.pages = ko.computed(function () {
			var
				iIndex = this.firstPage(),
				aPages = []
			;

			if (this.firstPage() < this.lastPage())
			{
				for (; iIndex <= this.lastPage(); iIndex++)
				{
					aPages.push({
						number: iIndex,
						current: (iIndex === this.currentPage()),
						clickFunc: this.clickPage
					});
				}
			}

			return aPages;
		}, this);
		
		if (!App.isMobile())
		{
			this.hotKeysBind();
		}
	}

	CPageSwitcherView.prototype.ViewTemplate = 'CoreWebclient_PageSwitcherView';

	CPageSwitcherView.prototype.hotKeysBind = function ()
	{
		$(document).on('keydown', $.proxy(function(ev) {
			if (this.bShown && !Utils.isTextFieldFocused())
			{
				var sKey = ev.keyCode;
				if (ev.ctrlKey && sKey === Enums.Key.Left)
				{
					this.clickPreviousPage();
				}
				else if (ev.ctrlKey && sKey === Enums.Key.Right)
				{
					this.clickNextPage();
				}
			}
		},this));
	};

	CPageSwitcherView.prototype.hide = function ()
	{
		this.bShown = false;
	};

	CPageSwitcherView.prototype.show = function ()
	{
		this.bShown = true;
	};

	CPageSwitcherView.prototype.clear = function ()
	{
		this.currentPage(1);
		this.count(0);
	};

	/**
	 * @param {number} iCount
	 */
	CPageSwitcherView.prototype.setCount = function (iCount)
	{
		this.count(iCount);
		if (this.currentPage() > this.pagesCount())
		{
			this.currentPage(this.pagesCount());
		}
	};

	/**
	 * @param {number} iPage
	 * @param {number} iPerPage
	 */
	CPageSwitcherView.prototype.setPage = function (iPage, iPerPage)
	{
		this.perPage(iPerPage);
		if (iPage > this.pagesCount())
		{
			this.currentPage(this.pagesCount());
		}
		else
		{
			this.currentPage(iPage);
		}
	};

	/**
	 * @param {Object} oPage
	 */
	CPageSwitcherView.prototype.clickPage = function (oPage)
	{
		var iPage = oPage.number;
		if (iPage < 1)
		{
			iPage = 1;
		}
		if (iPage > this.pagesCount())
		{
			iPage = this.pagesCount();
		}
		this.currentPage(iPage);
	};

	CPageSwitcherView.prototype.clickFirstPage = function ()
	{
		this.currentPage(1);
	};

	CPageSwitcherView.prototype.clickPreviousPage = function ()
	{
		var iPrevPage = this.currentPage() - 1;
		if (iPrevPage < 1)
		{
			iPrevPage = 1;
		}
		this.currentPage(iPrevPage);
	};

	CPageSwitcherView.prototype.clickNextPage = function ()
	{
		var iNextPage = this.currentPage() + 1;
		if (iNextPage > this.pagesCount())
		{
			iNextPage = this.pagesCount();
		}
		this.currentPage(iNextPage);
	};

	CPageSwitcherView.prototype.clickLastPage = function ()
	{
		this.currentPage(this.pagesCount());
	};

	module.exports = CPageSwitcherView;


/***/ }),

/***/ 255:
/*!**************************************************!*\
  !*** ./modules/CalendarWebclient/js/Settings.js ***!
  \**************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44)
	;

	module.exports = {
		ServerModuleName: 'Calendar',
		HashModuleName: 'calendar',
		ServerMeetingsPluginName: 'CalendarMeetingsPlugin',
		ServerCorporateCalendarName: 'CorporateCalendar',
		
		AddDescriptionToTitle: false,
		AllowAppointments: true,
		AllowShare: false,
		AllowTasks: true,
		DefaultTab: '3', // 1 - day, 2 - week, 3 - month
		HighlightWorkingDays: true,
		HighlightWorkingHours: true,
		PublicCalendarId: '',
		WeekStartsOn: '0', // 0 - sunday
		WorkdayEnds: '18',
		WorkdayStarts: '9',
		
		/**
		 * Initializes settings from AppData object sections.
		 * 
		 * @param {Object} oAppData Object contained modules settings.
		 */
		init: function (oAppData)
		{
			var
				oAppDataSection = oAppData[this.ServerModuleName],
				oAppMeetingsDataSection = oAppData[this.ServerMeetingsPluginName],
				oAppCorporateCalendarDataSection = oAppData[this.ServerCorporateCalendarName]
			;
			
			if (!_.isEmpty(oAppDataSection))
			{
				this.AddDescriptionToTitle = Types.pBool(oAppDataSection.AddDescriptionToTitle, this.AddDescriptionToTitle);
				if (this.AddDescriptionToTitle)
				{
					$('html').addClass('AddDescriptionToTitle');
				}
				if (!_.isEmpty(oAppCorporateCalendarDataSection))
				{
					this.AllowShare = Types.pBool(oAppCorporateCalendarDataSection.AllowShare, this.AllowShare);
				}
				this.AllowTasks = Types.pBool(oAppDataSection.AllowTasks, this.AllowTasks);
				this.DefaultTab = Types.pString(oAppDataSection.DefaultTab, this.DefaultTab); // 1 - day, 2 - week, 3 - month
				this.HighlightWorkingDays = Types.pBool(oAppDataSection.HighlightWorkingDays, this.HighlightWorkingDays);
				this.HighlightWorkingHours = Types.pBool(oAppDataSection.HighlightWorkingHours, this.HighlightWorkingHours);
				this.PublicCalendarId = Types.pString(oAppDataSection.PublicCalendarId, this.PublicCalendarId);
				this.WeekStartsOn = Types.pString(oAppDataSection.WeekStartsOn, this.WeekStartsOn); // 0 - sunday
				this.WorkdayEnds = Types.pString(oAppDataSection.WorkdayEnds, this.WorkdayEnds);
				this.WorkdayStarts = Types.pString(oAppDataSection.WorkdayStarts, this.WorkdayStarts);
			}
			if (!_.isEmpty(oAppMeetingsDataSection))
			{
				this.AllowAppointments = Types.pBool(oAppMeetingsDataSection.AllowAppointments, this.AllowAppointments);
			}
		},
		
		/**
		 * Updates new settings values after saving on server.
		 * 
		 * @param {boolean} bHighlightWorkingDays
		 * @param {boolean} bHighlightWorkingHours
		 * @param {number} iWorkDayStarts
		 * @param {number} iWorkDayEnds
		 * @param {number} iWeekStartsOn
		 * @param {number} iDefaultTab
		 */
		update: function (bHighlightWorkingDays, bHighlightWorkingHours, iWorkDayStarts, iWorkDayEnds, iWeekStartsOn, iDefaultTab)
		{
			this.DefaultTab = iDefaultTab.toString();
			this.HighlightWorkingDays = bHighlightWorkingDays;
			this.HighlightWorkingHours = bHighlightWorkingHours;
			this.WeekStartsOn = iWeekStartsOn.toString();
			this.WorkdayEnds = iWorkDayEnds.toString();
			this.WorkdayStarts = iWorkDayStarts.toString();
		}
	};


/***/ }),

/***/ 263:
/*!************************************************!*\
  !*** ./modules/CoreWebclient/js/utils/Date.js ***!
  \************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
				
		DateUtils = {}
	;

	DateUtils.getMonthNamesArray = function ()
	{
		var
			aMonthes = TextUtils.i18n('COREWEBCLIENT/LIST_MONTH_NAMES').split(' '),
			iLen = 12,
			iIndex = aMonthes.length
		;
		
		for (; iIndex < iLen; iIndex++)
		{
			aMonthes[iIndex] = '';
		}
		
		return aMonthes;
	};

	/**
	 * @param {number} iMonth
	 * @param {number} iYear
	 * 
	 * @return {number}
	 */
	DateUtils.daysInMonth = function (iMonth, iYear)
	{
		if (0 < iMonth && 13 > iMonth && 0 < iYear)
		{
			return new Date(iYear, iMonth, 0).getDate();
		}

		return 31;
	};

	module.exports = DateUtils;


/***/ }),

/***/ 267:
/*!***************************************************************!*\
  !*** ./modules/CalendarWebclient/js/popups/EditEventPopup.js ***!
  \***************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		DateUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Date.js */ 263),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		Api = __webpack_require__(/*! modules/CoreWebclient/js/Api.js */ 181),
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
		Screens = __webpack_require__(/*! modules/CoreWebclient/js/Screens.js */ 183),
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		CAbstractPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/CAbstractPopup.js */ 189),
		AlertPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/AlertPopup.js */ 188),
		ConfirmPopup = __webpack_require__(/*! modules/CoreWebclient/js/popups/ConfirmPopup.js */ 196),
		
		CalendarUtils = __webpack_require__(/*! modules/CalendarWebclient/js/utils/Calendar.js */ 268),
		
		Ajax = __webpack_require__(/*! modules/CalendarWebclient/js/Ajax.js */ 269),
		CalendarCache = __webpack_require__(/*! modules/CalendarWebclient/js/Cache.js */ 270),
		Settings = __webpack_require__(/*! modules/CalendarWebclient/js/Settings.js */ 255)
	;

	/**
	 * @constructor
	 */
	function CEditEventPopup()
	{
		CAbstractPopup.call(this);
		
		this.modified = false;
		this.isPublic = App.isPublic();
		this.isEditable = ko.observable(false);
		this.isEditableReminders = ko.observable(false);
		this.selectedCalendarIsShared = ko.observable(false);
		this.selectedCalendarIsEditable = ko.observable(false);

		this.callbackSave = null;
		this.callbackDelete = null;
		this.timeFormatMoment = 'HH:mm';
		this.dateFormatMoment = 'MM/DD/YYYY';
		this.dateFormatDatePicker = 'mm/dd/yy';
		this.ampmTimeFormat = ko.observable(false);

		this.calendarId = ko.observable(null);
		this.id = ko.observable(null);
		this.uid = ko.observable(null);
		this.recurrenceId = ko.observable(null);
		this.allEvents = ko.observable(Enums.CalendarEditRecurrenceEvent.AllEvents);

		this.isMyEvent = ko.observable(false);

		this.startDom = ko.observable(null);
		this.endDom = ko.observable(null);
		this.repeatEndDom = ko.observable(null);

		this.yearlyDayText = ko.observable('');
		this.monthlyDayText = ko.observable('');

		this.subject = ko.observable('').extend({'disableLinebreaks': true});
		this.description = ko.observable('');

		this.lockSelectStartEndDate = ko.observable(false);
		
		this.startDate = ko.observable('');
		this.startTime = ko.observable('');
		this.startTime.subscribe(function () {
			this.selectStartDate();
		}, this);
		this.allDay = ko.observable(false);
		this.allDay.subscribe(function () {
			if (!this.allDay())
			{
				this.setActualTime();
			}
		}, this);

		this.endDate = ko.observable('');
		this.endTime = ko.observable('');
		this.endTime.subscribe(function () {
			this.selectEndDate();
		}, this);

		this.repeatEndDate = ko.observable('');

		this.isEvOneDay = ko.observable(true);
		this.isEvOneTime = ko.observable(true);

		this.isRepeat = ko.observable(false);

		this.location = ko.observable('').extend({'disableLinebreaks': true});

		this.repeatPeriodOptions = ko.observableArray(this.getDisplayedPeriods());
		this.repeatWeekIntervalOptions = ko.observableArray([1, 2, 3, 4]);
		this.defaultAlarms = ko.observableArray([5, 10, 15, 30, 60, 120, 180, 240, 300, 360, 420, 480, 540, 600, 660, 720, 1080, 1440, 2880, 4320, 5760, 10080, 20160]);
		this.alarmOptions = ko.observableArray([]);
		this.timeOptions = ko.observableArray(CalendarUtils.getTimeListStepHalfHour((UserSettings.timeFormat() !== Enums.TimeFormat.F24) ? 'hh:mm A' : 'HH:mm'));
		UserSettings.timeFormat.subscribe(function () {
			this.timeOptions(CalendarUtils.getTimeListStepHalfHour((UserSettings.timeFormat() !== Enums.TimeFormat.F24) ? 'hh:mm A' : 'HH:mm'));
		}, this);

		this.displayedAlarms = ko.observableArray([]);
		this.displayedAlarms.subscribe(function () {
			this.disableAlarms();
		}, this);

		this.excluded = ko.observable(false);
		this.repeatPeriod = ko.observable(Enums.CalendarRepeatPeriod.None);
		this.repeatPeriod.subscribe(function (iRepeatPeriod) {
			this.setDayOfWeek();
			this.isRepeat(!!iRepeatPeriod);
		}, this);
		this.repeatInterval = ko.observable(1);
		this.repeatCount = ko.observable(null);
		this.repeatWeekNum = ko.observable(null);

		this.weekMO = ko.observable(false);
		this.weekTU = ko.observable(false);
		this.weekWE = ko.observable(false);
		this.weekTH = ko.observable(false);
		this.weekFR = ko.observable(false);
		this.weekSA = ko.observable(false);
		this.weekSU = ko.observable(false);

		this.always = ko.observable(1);

		this.appointment = ko.observable(false);
		this.attendees = ko.observableArray([]);
		this.attenderStatus = ko.observable(0);
		this.owner = ko.observable('');
		this.ownerName = ko.observable('');

		this.recivedAnim = ko.observable(false).extend({'autoResetToFalse': 500});
		this.whomAnimate = ko.observable('');
		this.guestAutocompleteItem = ko.observable(null);
		this.guestAutocomplete = ko.observable('');
		this.guestEmailFocus = ko.observable(false);
		this.guestAutocomplete.subscribe(function (sItem) {
			if (sItem === '')
			{
				this.guestAutocompleteItem(null);
			}
		}, this);

		this.condition = ko.observable('');

		this.autosizeTrigger = ko.observable(true);

		this.calendars = null;

		this.calendarsList = ko.observableArray([]);
		this.calendarColor = ko.observable('');
		this.selectedCalendarId = ko.observable('');
		this.selectedCalendarName = ko.observable('');
		this.selectedCalendarId.subscribe(function (sValue) {
			if (sValue)
			{
				var oCalendar = this.calendars.getCalendarById(sValue);
				
				this.selectedCalendarName(oCalendar.name());
				this.selectedCalendarIsShared(oCalendar.isShared());
				this.selectedCalendarIsEditable(oCalendar.isEditable());
				this.changeCalendarColor(sValue);
			}
		}, this);
		
		this.subjectFocus = ko.observable(false);

		this.descriptionFocus = ko.observable(false);
		this.locationFocus = ko.observable(false);

		this.dateEdit = ko.observable(false);
		this.repeatEdit = ko.observable(false);
		this.guestsEdit = ko.observable(false);
		this.isEditForm = ko.computed(function () {
			return !!this.id();
		}, this);

		this.callbackAttendeeActionDecline = null;

		this.bAllowAppointments = Settings.AllowAppointments;
		this.bAllowTasks = Settings.AllowTasks;

		this.eventType = ko.observable('VEVENT');
		this.status = ko.observable(false);
		this.isTask = ko.observable(false);
		this.isTaskApp = ko.observable(false);
		this.withDate = ko.observable(true);

		this.isTask.subscribe(function(value) {
			this.eventType(value ? 'VTODO' : 'VEVENT');
		}, this);

		this.allChanges = ko.computed(function () {
			this.subject();
			this.description();
			this.location();
			this.isRepeat();
			this.allDay();
			this.repeatPeriod();
			this.repeatInterval();
			this.repeatCount();
			this.repeatWeekNum();
			this.startDate();
			this.startTime();
			this.endDate();
			this.endTime();
			this.repeatEndDate();
			this.displayedAlarms();
			this.weekMO();
			this.weekTU();
			this.weekWE();
			this.weekTH();
			this.weekFR();
			this.weekSA();
			this.weekSU();
			this.always();
			this.attendees();
			this.selectedCalendarId();
			this.status();
			this.isTask();
			this.withDate();
			
			this.modified = true;
		}, this);

		this.aReminderPhrase = TextUtils.i18n('CALENDARWEBCLIENT/INFO_REMINDER').split('%');

		this.isAppointmentButtonsVisible = ko.observable(false);
	}

	_.extendOwn(CEditEventPopup.prototype, CAbstractPopup.prototype);

	CEditEventPopup.prototype.PopupTemplate = 'CalendarWebclient_EditEventPopup';

	/**
	 * @param {Object} oElement
	 * @param {Function} fSelect
	 */
	CEditEventPopup.prototype.createDatePickerObject = function (oElement, fSelect)
	{
		$(oElement).datepicker({
			showOtherMonths: true,
			selectOtherMonths: true,
			monthNames: DateUtils.getMonthNamesArray(),
			dayNamesMin: TextUtils.i18n('COREWEBCLIENT/LIST_DAY_NAMES_MIN').split(' '),
			nextText: '',
			prevText: '',
			firstDay: Settings.WeekStartsOn,
			showOn: 'both',
			buttonText: '',
			buttonImage: './static/styles/images/calendar-icon.png',
			buttonImageOnly: true,
			dateFormat: this.dateFormatDatePicker,
			onSelect: fSelect
		});

		$(oElement).mousedown(function() {
			$('#ui-datepicker-div').toggle();
		});
	};

	CEditEventPopup.prototype.initializeDatePickers = function ()
	{
		this.createDatePickerObject(this.startDom(), this.selectStartDate.bind(this));
		this.createDatePickerObject(this.endDom(), this.selectEndDate.bind(this));
		this.createDatePickerObject(this.repeatEndDom(), function () {});

		this.startDom().datepicker('option', 'dateFormat', this.dateFormatDatePicker);
		this.endDom().datepicker('option', 'dateFormat', this.dateFormatDatePicker);
		this.repeatEndDom().datepicker('option', 'dateFormat', this.dateFormatDatePicker);
	};

	/**
	 * @param {Object} oParameters
	 */
	CEditEventPopup.prototype.onOpen = function (oParameters)
	{
		var
			owner = App.getUserPublicId(),
			oEndMomentDate = null,
			oStartMomentDate = null,
			sAttendee = '',
			oCalendar = null,
			sCalendarOwner = '',
			oToday = moment()
		;

		this.withDate(!!oParameters.Start && !!oParameters.End);

		if (!oParameters.Start && !oParameters.End)
		{
			if (oToday.minutes() > 30)
			{
				oToday.add(60 - oToday.minutes(), 'minutes');
			}
			else
			{
				oToday.minutes(30);
			}
			oToday
				.seconds(0)
				.milliseconds(0);	
			oParameters.Start = oToday;
			oParameters.End = oToday.clone().add(30, 'minutes');
		}
		oEndMomentDate = oParameters.End ? oParameters.End.clone() : null;
		oStartMomentDate = oParameters.Start ? oParameters.Start.clone() : null;
		
		this.iDiffInMinutes = null;

		this.eventType(oParameters.Type || 'VEVENT');
		this.isTask(this.eventType() === 'VTODO');

		this.calendarId(oParameters.SelectedCalendar);
		this.calendars = oParameters.Calendars;

		oCalendar = this.calendars.getCalendarById(this.calendarId());
		if (oCalendar)
		{
			sCalendarOwner = oCalendar.owner();
		}

		this.callbackSave = oParameters.CallbackSave;
		this.callbackDelete = oParameters.CallbackDelete;
		this.callbackAttendeeActionDecline = oParameters.CallbackAttendeeActionDecline;

		this.timeFormatMoment = oParameters.TimeFormat;
		this.dateFormatMoment = Utils.getDateFormatForMoment(oParameters.DateFormat);
		this.dateFormatDatePicker = CalendarUtils.getDateFormatForDatePicker(oParameters.DateFormat);
		
		this.ampmTimeFormat(UserSettings.timeFormat() !== Enums.TimeFormat.F24);
		
		this.initializeDatePickers();
		
		this.allDay(oParameters.AllDay);
		
		if (oStartMomentDate)
		{
			this.setStartDate(oStartMomentDate, true);
			this.startTime(oStartMomentDate.format(this.timeFormatMoment));
		}
		if (oEndMomentDate && this.allDay())
		{
			oEndMomentDate.subtract(1, 'days');
		}
		if (!oEndMomentDate && oStartMomentDate)
		{
			oEndMomentDate = oStartMomentDate;
		}
		if (oEndMomentDate)
		{
			this.setEndDate(oEndMomentDate, true);
			this.endTime(oEndMomentDate.format(this.timeFormatMoment));
		}

		if (this.calendars)
		{
			this.calendarsList(
				_.filter(
					this.calendars.collection(),
					function(oItem){ 
						return oItem.isEditable(); 
					}
				)
			);
		}
		this.selectedCalendarId(oParameters.SelectedCalendar);
		this.selectedCalendarId.valueHasMutated();

		this.changeCalendarColor(this.selectedCalendarId());
		
		// parameters for event editing only (not for creating)
		this.id(oParameters.ID || null);
		this.uid(oParameters.Uid || null);
		this.recurrenceId(oParameters.RecurrenceId || null);
		
		this.subject(oParameters.Subject || '');
		
		this.status(oParameters.Status || false);
		this.location(oParameters.Location || '');
		this.description(oParameters.Description || '');
		this.allEvents(oParameters.AllEvents || Enums.CalendarEditRecurrenceEvent.AllEvents);
		
		this.isTaskApp(oParameters.IsTaskApp || false);

		this.populateAlarms(oParameters.Alarms);

		this.appointment(oParameters.Appointment);

		this.attendees(oParameters.Attendees || []);

		if ($.isFunction(App.getAttendee))
		{
			sAttendee = App.getAttendee(this.attendees());
		}

		this.isMyEvent(sAttendee !== owner && (owner === oParameters.Owner || owner === sCalendarOwner));
		this.editableSwitch(this.selectedCalendarIsShared(), this.selectedCalendarIsEditable(), this.isMyEvent());

		this.setCurrentAttenderStatus(sAttendee, oParameters.Attendees || []);

		this.owner(oParameters.Owner || owner);
		
		this.ownerName(oParameters.OwnerName || (this.isMyEvent() && this.owner() === owner ? owner : ''));
		this.guestAutocomplete('');

		this.excluded(oParameters.Excluded || false);
		this.repeatRuleParse(oParameters.RRule || null);

		if (this.id() === null)
		{
			this.subjectFocus(true);
		}

		this.autosizeTrigger.notifySubscribers(true);
		
		this.modified = false;

		this.isAppointmentButtonsVisible(this.appointment() && this.selectedCalendarIsEditable() && _.find(this.attendees(), function(oAttendee){ return oAttendee.email === owner; }));
	};

	/**
	 * @param {string} sId
	 */
	CEditEventPopup.prototype.changeCalendarColor = function (sId)
	{
		if ($.isFunction(this.calendars.getCalendarById))
		{
			var oCalendar = this.calendars.getCalendarById(sId);
			if (oCalendar)
			{
				this.calendarColor('');
				this.calendarColor(oCalendar.color());
			}
		}
	};

	CEditEventPopup.prototype.onIsTaskClick = function ()
	{
		this.eventType(this.eventType() === 'VTODO' ? 'VEVENT' : 'VTODO');
	};

	CEditEventPopup.prototype.onSaveClick = function ()
	{
		if (this.subject() === '')
		{
			Popups.showPopup(AlertPopup, [TextUtils.i18n('CALENDARWEBCLIENT/ERROR_SUBJECT_BLANK'),
				_.bind(function () {
					this.subjectFocus(true);
				}, this)]);
		}
		else
		{
			if (this.callbackSave)
			{
				var
					iPeriod = Types.pInt(this.repeatPeriod()),
					sDate = '',
					iUnixDate = null,
					iInterval = 0,
					oStart = moment(this.getDateTime(this.startDom(), this.startTime())),
					oEnd = moment(this.getDateTime(this.endDom(), this.endTime())),
					oEventData = {
						calendarId: this.calendarId(),
						newCalendarId: this.selectedCalendarId(),
						id: this.id(),
						uid: this.uid(),
						recurrenceId: this.recurrenceId(),
						allEvents:  this.allEvents(),
						subject: this.subject(),
						title: CalendarUtils.getTitleForEvent(this.subject(), this.description()),
						allDay: this.allDay(),
						location: this.location(),
						description: this.description(),
						alarms: this.getAlarmsArray(this.displayedAlarms()),
						attendees: this.attendees(),
						owner: this.owner(),
						modified: this.modified,
						type: this.eventType(),
						status: this.status(),
						withDate: this.withDate()
					},
					iAlways = Types.pInt(this.always())
				;
				
				if (this.allDay())
				{
					oEnd.add(1, 'days');
				}
				
				oEventData.start = oStart;
				oEventData.end = oEnd;

				if (iPeriod)
				{
					sDate = this.repeatEndDom().datepicker('getDate');
					iUnixDate = sDate ? moment(sDate).unix() : null;
					iInterval = this.repeatInterval();

					if (iPeriod === Enums.CalendarRepeatPeriod.Daily && iAlways === Enums.CalendarAlways.Disable)
					{
						oEventData.rrule = {
							byDays: [],
							count: null,
							end: 2,
							interval: 1,
							period: iPeriod,
							until: iUnixDate,
							weekNum: null
						};
					}
					else if (iPeriod === Enums.CalendarRepeatPeriod.Weekly && iAlways === Enums.CalendarAlways.Disable)
					{
						this.setDayOfWeek();

						oEventData.rrule = {
							byDays: this.getDays(),
							count: null,
							end: 2,
							interval: iInterval,
							period: iPeriod,
							until: iUnixDate,
							weekNum: null
						};
					}
					else if (iPeriod === Enums.CalendarRepeatPeriod.Monthly)
					{
						oEventData.rrule = {
							byDays: [],
							count: null,
							end: 0,
							interval: 1,
							period: iPeriod,
							until: null,
							weekNum: null
						};
					}
					else if (iPeriod === Enums.CalendarRepeatPeriod.Yearly)
					{
						oEventData.rrule = {
							byDays: [],
							count: null,
							end: 0,
							interval: 1,
							period: iPeriod,
							until: null,
							weekNum: null
						};
					}
					else if (iPeriod === Enums.CalendarRepeatPeriod.Daily && iAlways === Enums.CalendarAlways.Enable)
					{
						oEventData.rrule = {
							byDays: [],
							count: null,
							end: 3,
							interval: 1,
							period: iPeriod,
							until: iUnixDate,
							weekNum: null
						};
					}
					else if (iPeriod === Enums.CalendarRepeatPeriod.Weekly && iAlways === Enums.CalendarAlways.Enable)
					{
						this.setDayOfWeek();

						oEventData.rrule = {
							byDays: this.getDays(),
							count: null,
							end: 3,
							interval: iInterval,
							period: iPeriod,
							until: iUnixDate,
							weekNum: null
						};
					}
				}

				this.callbackSave(oEventData);
			}

			this.closePopup();
		}
	};

	CEditEventPopup.prototype.onEscHandler = function ()
	{
		if (this.dateEdit())
		{
			this.dateEdit(false);
		}
		else
		{
			this.closePopup();
		}
	};

	CEditEventPopup.prototype.onClose = function ()
	{
		this.hideAll();
		this.cleanAll();
	};

	CEditEventPopup.prototype.hideAll = function ()
	{
		this.dateEdit(false);
		this.repeatEdit(false);
		this.guestsEdit(false);
	};

	CEditEventPopup.prototype.cleanAll = function ()
	{
		if (this.isTask())
		{
			this.withDate(false);
		}
		else
		{
			this.withDate(true);
		}
		this.isTask(false);
		this.subject('');
		this.description('');
		this.location('');
		this.isRepeat(false);
		this.allDay(false);
		this.repeatPeriod(Enums.CalendarRepeatPeriod.None);
		this.repeatInterval(1);
		this.repeatCount(null);
		this.repeatWeekNum(null);
		this.startDate('');
		this.startTime('');
		this.endDate('');
		this.endTime('');
		this.repeatEndDate('');
		this.displayedAlarms([]);
		this.weekMO(false);
		this.weekTU(false);
		this.weekWE(false);
		this.weekTH(false);
		this.weekFR(false);
		this.weekSA(false);
		this.weekSU(false);
		this.attendees([]);
		this.always(1);
		this.selectedCalendarId('');

		this.attendees([]);
	};

	CEditEventPopup.prototype.onDeleteClick = function ()
	{
		if (this.callbackDelete)
		{
			var
				oEventData = {
					calendarId: this.selectedCalendarId(),
					id: this.id(),
					uid: this.uid(),
					recurrenceId: this.recurrenceId(),
					allEvents:  this.allEvents(),
					subject: this.subject(),
					title: CalendarUtils.getTitleForEvent(this.subject(), this.description()),
					start: moment(this.getDateTime(this.startDom(), this.startTime())),
					end: moment(this.getDateTime(this.endDom(), this.endTime())),
					allDay: this.allDay(),
					location: this.location(),
					description: this.description()
				}
			;

			this.callbackDelete(oEventData);
		}
		this.closePopup();
	};

	/**
	 * @param {Object} oModel
	 * @param {Object} oEv
	 */
	CEditEventPopup.prototype.showDates = function (oModel, oEv)
	{
		oEv.stopPropagation();
		this.dateEdit(!this.dateEdit());
	};

	CEditEventPopup.prototype.showGuests = function ()
	{
		if (this.attendees().length > 0)
		{
			var
				sConfirm = TextUtils.i18n('CALENDARWEBCLIENT/CONFIRM_REMOVE_ALL_ATTENDEES'),
				fAction = _.bind(function (bResult) {
					if (bResult)
					{
						this.guestsEdit(false);
						this.guestEmailFocus(false);
						this.attendees([]);
					}
				}, this)
			;

			Popups.showPopup(ConfirmPopup, [sConfirm, fAction]);

		}
		else
		{
			this.guestsEdit(!this.guestsEdit());
			this.guestEmailFocus(!this.guestEmailFocus());
		}
	};

	CEditEventPopup.prototype.onAddGuestClick = function ()
	{
		var
			oGuestAutocompleteItem = this.guestAutocompleteItem(),
			sGuestAutocomplete = this.guestAutocomplete(),
			oItem = oGuestAutocompleteItem || {name: '', email: sGuestAutocomplete},
			bIsInvited = _.any(this.attendees(), function (oEl) {
				return oEl.email === oItem.email;
			})
		;

		if (oItem.email === '')
		{
			Screens.showError(TextUtils.i18n('CALENDARWEBCLIENT/ERROR_EMAIL_BLANK'));
		}
		else if (oItem.email === this.owner())
		{
			this.recivedAnim(true);
		}
		else if (bIsInvited)
		{
			this.recivedAnim(true);
		}
		else
		{
			this.attendees.push(
				{
					status: 0,
					name: oItem.name,
					email: oItem.email
				}
			);
		}

		this.whomAnimate(oItem.email);
		this.guestAutocomplete('');

		this.guestEmailFocus(true);
	};

	/**
	 * @param {Array} aAlarms
	 */
	CEditEventPopup.prototype.populateAlarms = function (aAlarms)
	{
		if (aAlarms)
		{
			this.alarmOptions(this.getDisplayedAlarms(_.union(this.defaultAlarms(), aAlarms)));
			this.displayedAlarms(this.getDisplayedAlarms(aAlarms));
		}
		else
		{
			this.alarmOptions(this.getDisplayedAlarms(this.defaultAlarms()));
		}
	};

	/**
	 * @param {Array} aMinutes
	 */
	CEditEventPopup.prototype.getDisplayedAlarms = function (aMinutes)
	{
		var aDisplayedAlarms = [];

		if (aMinutes)
		{
			_.each(aMinutes, function (iMinutes, iIdx) {
				var
					koAlarm = this['alarm' + iMinutes] = ko.observable(iMinutes),
					sText = ''
				;
				
				koAlarm.subscribe(function () {
					//alarm observable value not actual
					this.disableAlarms();
					this.modified = true;
				}, this);

				if (iMinutes > 0 && iMinutes < 60)
				{
					sText = (TextUtils.i18n('COREWEBCLIENT/LABEL_MINUTES_PLURAL', {'COUNT': iMinutes}, null, iMinutes));
				}
				else if (iMinutes >= 60 && iMinutes < 1440)
				{
					sText = (TextUtils.i18n('CALENDARWEBCLIENT/LABEL_HOURS_PLURAL', {'COUNT': iMinutes / 60}, null, iMinutes / 60));
				}
				else if (iMinutes >= 1440 && iMinutes < 10080)
				{
					sText = (TextUtils.i18n('CALENDARWEBCLIENT/LABEL_DAYS_PLURAL', {'COUNT': iMinutes / 1440}, null, iMinutes / 1440));
				}
				else
				{
					sText = (TextUtils.i18n('CALENDARWEBCLIENT/LABEL_WEEKS_PLURAL', {'COUNT': iMinutes / 10080}, null, iMinutes / 10080));
				}

				aDisplayedAlarms.push({
					'value': iMinutes,
					'alarm': koAlarm,
					'text': sText,
					'isDisabled': false
				});

			}, this);
		}

		return _.sortBy(aDisplayedAlarms, function(oAlarm){ return oAlarm.value; });
	};

	CEditEventPopup.prototype.getDisplayedPeriods = function ()
	{
		return [
			{
				label: TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_NEVER'),
				value: 0
			},
			{
				label: TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_DAILY'),
				value: 1
			},
			{
				label: TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_WEEKLY'),
				value: 2
			},
			{
				label: TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_MONTHLY'),
				value: 3
			},
			{
				label: TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_YEARLY'),
				value: 4
			}
		];
	};

	/**
	 * @param {Array} aDisplayedAlarms
	 */
	CEditEventPopup.prototype.getAlarmsArray = function (aDisplayedAlarms)
	{
		var aAlarms = [];

		_.each(aDisplayedAlarms, function (oAlarm, iIdx) {
			aAlarms.push(oAlarm.alarm());
		}, this);

		return _.sortBy(aAlarms, function (num) {return -num;});
	};

	CEditEventPopup.prototype.addFirstAlarm = function ()
	{
		if (!this.displayedAlarms().length)
		{
			this.displayedAlarms(this.getDisplayedAlarms([this.alarmOptions()[0].value]));
		}
		else
		{
			var
				sConfirm = TextUtils.i18n('CALENDARWEBCLIENT/CONFIRM_REMOVE_ALL_ALARMS'),
				fAction = _.bind(function (bResult) {
					if (bResult)
					{
						this.displayedAlarms.removeAll();
					}
				}, this)
			;

			Popups.showPopup(ConfirmPopup, [sConfirm, fAction]);
		}
	};

	CEditEventPopup.prototype.addAlarm = function ()
	{
		var
			oDisplayedAlarm,
			aSortedAlarms,
			iMinutes = 0
		;

		aSortedAlarms = _.sortBy(this.displayedAlarms(), function (oAlarm) {return oAlarm.alarm();});

		_.each(aSortedAlarms, function (oAlarm) {

			var nAlarmMinutes = oAlarm.alarm();

			if (nAlarmMinutes !== 5 && iMinutes <= 5)
			{
				iMinutes = 5;
			}
			else if (nAlarmMinutes !== 10 && iMinutes <= 10)
			{
				iMinutes = 10;
			}
			else if (nAlarmMinutes !== 15 && iMinutes <= 15)
			{
				iMinutes = 15;
			}
			else if (nAlarmMinutes !== 30 && iMinutes <= 30)
			{
				iMinutes = 30;
			}
			else if (nAlarmMinutes !== 1440 && iMinutes <= 1440)
			{
				iMinutes = 1440;
			}
		});

		oDisplayedAlarm = this.getDisplayedAlarms([iMinutes])[0];

		this['alarm' + iMinutes] = ko.observable(iMinutes);
		this.displayedAlarms.push(oDisplayedAlarm);
	};

	/**
	 * @param {Object} oItem
	 */
	CEditEventPopup.prototype.removeAlarm = function (oItem)
	{
		this.displayedAlarms.remove(oItem);
	};

	/**
	 * @param {Object} oItem
	 */
	CEditEventPopup.prototype.removeGuest = function (oItem)
	{
		this.attendees.remove(oItem);
	};

	CEditEventPopup.prototype.disableAlarms = function ()
	{
		_.each(this.alarmOptions(), function (oAlarm, iIdx) {
			oAlarm.isDisabled = _.any(this.displayedAlarms(), function (oItem) {
				return oItem.alarm() === oAlarm.value;
			});
		}, this);

		this.alarmOptions.valueHasMutated();
	};

	/**
	 * @param {object} oRequest
	 * @param {function} fResponse
	 */
	CEditEventPopup.prototype.autocompleteCallback = function (oRequest, fResponse)
	{
		var fAutocompleteCallback = ModulesManager.run('ContactsWebclient', 'getSuggestionsAutocompleteCallback');
		
		if ($.isFunction(fAutocompleteCallback))
		{
			this.guestAutocompleteItem(null);
			fAutocompleteCallback(oRequest, fResponse, this.owner(), false);
		}
	};

	/**
	 * @param {Object} oRepeatRule
	 */
	CEditEventPopup.prototype.repeatRuleParse = function (oRepeatRule)
	{
		var allEvents = this.allEvents();

		this.repeatEndDom().datepicker('option', 'minDate', this.getDateTime(this.endDom()));

		if(oRepeatRule && allEvents === Enums.CalendarEditRecurrenceEvent.AllEvents)
		{
			if (oRepeatRule.until)
			{
				this.repeatEndDom().datepicker('setDate', new Date(oRepeatRule.until * 1000));
			}

			if (oRepeatRule.byDays.length)
			{
				_.each(oRepeatRule.byDays, function (sItem) {
					this['week' + sItem](true);
				}, this);
			}
			this.repeatPeriod(oRepeatRule.period);
			this.repeatInterval(oRepeatRule.interval);
			this.repeatCount(oRepeatRule.count);
			this.repeatWeekNum(oRepeatRule.weekNum);
			this.always(oRepeatRule.end === 3 ? 1 : 0);
		}
	};

	CEditEventPopup.prototype.getDays = function ()
	{
		var aDays = [];

		if (this.weekMO()) {aDays.push('MO');}
		if (this.weekTU()) {aDays.push('TU');}
		if (this.weekWE()) {aDays.push('WE');}
		if (this.weekTH()) {aDays.push('TH');}
		if (this.weekFR()) {aDays.push('FR');}
		if (this.weekSA()) {aDays.push('SA');}
		if (this.weekSU()) {aDays.push('SU');}

		return aDays;
	};

	CEditEventPopup.prototype.onMainPanelClick = function ()
	{
		if (this.dateEdit())
		{
			this.dateEdit(false);
		}
	};

	/**
	 * @param {string} sDate
	 */
	CEditEventPopup.prototype.getDateWithoutYearIfMonthWord = function (sDate)
	{
		var
			aDate = sDate.split(' '),
			oNowMoment = moment(),
			oNowYear = oNowMoment.format('YYYY')
		;
		
		if (aDate.length === 3 && oNowYear === aDate[2])
		{
			return aDate[0] + ' ' + aDate[1];
		}
		return sDate;
	};

	/**
	 * @param {Object} oMomentDate
	 * @param {boolean} bChangeInDatepicker
	 */
	CEditEventPopup.prototype.setStartDate = function (oMomentDate, bChangeInDatepicker)
	{
		if (bChangeInDatepicker)
		{
			this.startDom().datepicker('setDate', oMomentDate.toDate());
		}
		this.startDate(this.getDateWithoutYearIfMonthWord($(this.startDom()).val()));
		
		this.yearlyDayText(TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_YEARLY_DAYMONTH', {'DAYMONTH': oMomentDate.format(this.getDateMonthFormat())}));
		this.monthlyDayText(TextUtils.i18n('CALENDARWEBCLIENT/LABEL_REPEAT_MONTHLY_DAY', {'DAY': oMomentDate.format('DD')}));
	};

	CEditEventPopup.prototype.selectStartDate = function ()
	{
		if (!this.lockSelectStartEndDate() && this.startDate() && this.endDate())
		{
			this.lockSelectStartEndDate(true);
			
			var
				oStartDate = this.getDateTime(this.startDom(), this.startTime()),
				oStartMomentDate = moment(oStartDate),
				
				oEndDate = this.getDateTime(this.endDom(), this.endTime()),
				oEndMomentDate = moment(oEndDate)
			;
			
			if (Types.isNumber(this.iDiffInMinutes))
			{
				oEndMomentDate = oStartMomentDate.clone().add(this.iDiffInMinutes, 'minutes');
				oEndDate = oEndMomentDate.toDate();
				this.setEndDate(oEndMomentDate, true);
				this.endTime(oEndMomentDate.format(this.timeFormatMoment));
			}
			
			if (oEndMomentDate.diff(oStartMomentDate, 'minutes') < 0)
			{
				this.setEndDate(oStartMomentDate, true);
				this.endTime(oStartMomentDate.format(this.timeFormatMoment));
			}

			this.isEvOneDay(oEndMomentDate.diff(oStartMomentDate, 'days') === 0);
			this.isEvOneTime(oEndMomentDate.diff(oStartMomentDate, 'minutes') === 0);
			
			this.setStartDate(oStartMomentDate, false);
			this.startTime(oStartMomentDate.format(this.timeFormatMoment));
			
			this.lockSelectStartEndDate(false);
		}
	};

	/**
	 * @return {string}
	 */
	CEditEventPopup.prototype.getDateMonthFormat = function ()
	{
		var sDateMonthFormat = this.dateFormatMoment.slice(0,-5);
		
		if ($.inArray(sDateMonthFormat, ['MM/DD', 'DD/MM', 'DD MMMM']) === -1)
		{
			sDateMonthFormat = 'MM/DD';
		}
		
		return sDateMonthFormat;
	};

	/**
	 * @param {Object} oMomentDate
	 * @param {boolean} bChangeInDatepicker
	 */
	CEditEventPopup.prototype.setEndDate = function (oMomentDate, bChangeInDatepicker)
	{
		if (bChangeInDatepicker)
		{
			this.endDom().datepicker('setDate', oMomentDate.toDate());
		}
		this.endDate(this.getDateWithoutYearIfMonthWord($(this.endDom()).val()));
	};

	CEditEventPopup.prototype.selectEndDate = function ()
	{
		if (!this.lockSelectStartEndDate() && this.endDate() && this.startDate())
		{
			this.lockSelectStartEndDate(true);
			
			var
				oStartDate = this.getDateTime(this.startDom(), this.startTime()),
				oStartMomentDate = moment(oStartDate),
				
				oEndDate = this.getDateTime(this.endDom(), this.endTime()),
				oEndMomentDate = moment(oEndDate)
			;
			
			this.iDiffInMinutes = oEndMomentDate.diff(oStartMomentDate, 'minutes');
			
			if (this.iDiffInMinutes < 0)
			{
				this.setStartDate(oEndMomentDate, true);
				this.startTime(oEndMomentDate.format(this.timeFormatMoment));
				this.iDiffInMinutes = 0;
			}

			this.isEvOneDay(oEndMomentDate.diff(oStartMomentDate, 'days') === 0);
			this.isEvOneTime(oEndMomentDate.diff(oStartMomentDate, 'minutes') === 0);

			this.setEndDate(oEndMomentDate, false);
			this.endTime(oEndMomentDate.format(this.timeFormatMoment));
			this.repeatEndDom().datepicker('option', 'minDate', oEndDate);

			if (!this.isRepeat())
			{
				this.repeatEndDom().datepicker('setDate', oEndMomentDate.add(7, 'days').toDate());
			}
			
			this.lockSelectStartEndDate(false);
		}
	};

	/**
	 * @param {Object} oInput
	 * @param {string} sTime
	 * @return {Date}
	 */
	CEditEventPopup.prototype.getDateTime = function (oInput, sTime)
	{
		sTime = sTime ? moment(sTime, this.timeFormatMoment).format('HH:mm') : '';
		
		var
			oDate = oInput.datepicker('getDate'),
			aTime = sTime ? sTime.split(':') : []
		;
		
		if (aTime.length === 2)
		{
			oDate.setHours(aTime[0]);
			oDate.setMinutes(aTime[1]);
		}

		return oDate;
	};

	CEditEventPopup.prototype.setActualTime = function ()
	{
		if (!this.lockSelectStartEndDate() && this.endDate() && this.startDate())
		{
			this.lockSelectStartEndDate(true);
			
			var
				oNowMomentDate = moment(),
				sNowTime = oNowMomentDate.format(this.timeFormatMoment),
				
				oStartDate = this.getDateTime(this.startDom(), sNowTime),
				oStartMomentDate = moment(oStartDate),
				
				oEndDate = this.getDateTime(this.endDom(), sNowTime),
				oEndMomentDate = moment(oEndDate)
			;
			
			if (oStartMomentDate.minutes() > 30)
			{
				oStartMomentDate.add((60 - oStartMomentDate.minutes()), 'minutes');
				oEndMomentDate.add((90 - oEndMomentDate.minutes()), 'minutes');
			}
			else
			{
				oStartMomentDate.add((30 - oStartMomentDate.minutes()), 'minutes');
				oEndMomentDate.add((60 - oEndMomentDate.minutes()), 'minutes');
			}
			
			this.iDiffInMinutes = oEndMomentDate.diff(oStartMomentDate, 'minutes');
			
			this.setStartDate(oStartMomentDate, true);
			this.startTime(oStartMomentDate.format(this.timeFormatMoment));
			
			this.setEndDate(oEndMomentDate, true);
			this.endTime(oEndMomentDate.format(this.timeFormatMoment));
			
			this.lockSelectStartEndDate(false);
		}
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CEditEventPopup.prototype.onSetAppointmentActionResponse = function (oResponse, oRequest)
	{
		if (!oResponse.Result)
		{
			Api.showErrorByCode(oResponse, TextUtils.i18n('COREWEBCLIENT/ERROR_UNKNOWN'));
		}
	};

	/**
	 * @param {string} sDecision
	 */
	CEditEventPopup.prototype.setAppointmentAction = function (sDecision)
	{
		var
			iDecision = Enums.IcalConfigInt.NeedsAction,
			aAttendees = this.attendees(),
			sEmail = App.getAttendee ?	App.getAttendee(this.attendees()) :	'',
			oAttendee = _.find(this.attendees(), function(oAttendee){
				return oAttendee.email === sEmail; 
			}, this),
			oCalendar = this.calendars.getCalendarById(this.selectedCalendarId()),
			oParameters = {
				'AppointmentAction': sDecision,
				'CalendarId': this.selectedCalendarId(),
				'EventId': this.uid(),
				'Attendee': sEmail
			}
		;

		if (oAttendee)
		{
			switch (sDecision)
			{
				case Enums.IcalConfig.Accepted:
					iDecision = Enums.IcalConfigInt.Accepted;
					CalendarCache.markIcalAccepted(this.uid());
					break;
				case Enums.IcalConfig.Tentative:
					iDecision = Enums.IcalConfigInt.Tentative;
					CalendarCache.markIcalTentative(this.uid());
					break;
				case Enums.IcalConfig.Declined:
					iDecision = Enums.IcalConfigInt.Declined;
					CalendarCache.markIcalNonexistent(this.uid());
					break;
			}
			Ajax.send('SetAppointmentAction', oParameters, this.onSetAppointmentActionResponse, this, 'CalendarMeetingsPlugin');

			oAttendee.status = iDecision;
			this.attendees([]);
			this.attendees(aAttendees);
			this.setCurrentAttenderStatus(oAttendee.email, this.attendees());
			if (sDecision === Enums.IcalConfig.Declined && oCalendar && 
					this.callbackAttendeeActionDecline && $.isFunction(this.callbackAttendeeActionDecline))
			{
				this.callbackAttendeeActionDecline(oCalendar,  this.id());
				this.closePopup();
			}
		}
	};

	/**
	 * @param {boolean} bShared
	 * @param {boolean} bEditable
	 * @param {boolean} bMyEvent
	 */
	CEditEventPopup.prototype.editableSwitch = function (bShared, bEditable, bMyEvent)
	{
		this.isEditable(bShared && bEditable || bMyEvent);
		this.isEditableReminders(bEditable);
	};

	/**
	 * @param {string} sCurrentEmail
	 * @param {Array} aAttendees
	 */
	CEditEventPopup.prototype.setCurrentAttenderStatus = function (sCurrentEmail, aAttendees)
	{
		var oCurrentAttender = _.find(aAttendees, function(oAttender){ 
			return oAttender.email === sCurrentEmail; 
		});

		this.attenderStatus(oCurrentAttender ? oCurrentAttender.status : 0);
	};

	CEditEventPopup.prototype.getAttenderTextStatus = function (sStatus)
	{
		switch (sStatus)
		{
			case 0:
				sStatus = 'pending';
				break;
			case 1:
				sStatus = 'accepted';
				break;
			case 2:
				sStatus = 'declined';
				break;
			case 3:
				sStatus = 'tentative';
				break;
		}
		return sStatus;
	};

	CEditEventPopup.prototype.setDayOfWeek = function ()
	{
		if (this.repeatPeriod() === Enums.CalendarRepeatPeriod.Weekly && !this.getDays().length)
		{
			var iDayOfWeek = this.getDateTime(this.startDom()).getUTCDay();
			
			switch (iDayOfWeek)
			{
				case 0:
					this.weekMO(true);
					break;
				case 1:
					this.weekTU(true);
					break;
				case 2:
					this.weekWE(true);
					break;
				case 3:
					this.weekTH(true);
					break;
				case 4:
					this.weekFR(true);
					break;
				case 5:
					this.weekSA(true);
					break;
				case 6:
					this.weekSU(true);
					break;
			}
		}
	};

	CEditEventPopup.prototype.switchTask = function (isTask)
	{
		this.isTask(isTask);
	}

	module.exports = new CEditEventPopup();


/***/ }),

/***/ 268:
/*!********************************************************!*\
  !*** ./modules/CalendarWebclient/js/utils/Calendar.js ***!
  \********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		moment = __webpack_require__(/*! moment */ 51),
		
		Settings = __webpack_require__(/*! modules/CalendarWebclient/js/Settings.js */ 255),
		
		CalendarUtils = {}
	;

	CalendarUtils = {};

	/**
	 * Generates a list of time to display in calendar settings.
	 * 
	 * @param {string} sTimeFormatMoment
	 * @returns {Array}
	 */
	CalendarUtils.getTimeListStepHour = function (sTimeFormatMoment)
	{
		var aTimeList = [
			'01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00',
			'11:00', '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00',
			'21:00', '22:00', '23:00', '00:00'
		];
		
		return _.map(aTimeList, function (sTime) {
			var
				oMoment = moment(sTime, 'HH:mm'),
				sText = oMoment.format(sTimeFormatMoment),
				sValue = oMoment.format('H')
			;
			if (sTime === '00:00')
			{
				sValue = '24';
			}
			return {text: sText, value: sValue};
		});
	};

	/**
	 * Generates a list of time to display in create/edit event popup.
	 * 
	 * @param {string} sTimeFormatMoment
	 * @returns {Array}
	 */
	CalendarUtils.getTimeListStepHalfHour = function (sTimeFormatMoment)
	{
		var aTimeList = [
			'00:00', '00:30', '01:00', '01:30', '02:00', '02:30', '03:00', '03:30', '04:00', '04:30',
			'05:00', '05:30', '06:00', '06:30', '07:00', '07:30', '08:00', '08:30', '09:00', '09:30',
			'10:00', '10:30', '11:00', '11:30', '12:00', '12:30', '13:00', '13:30', '14:00', '14:30',
			'15:00', '15:30', '16:00', '16:30', '17:00', '17:30', '18:00', '18:30', '19:00', '19:30',
			'20:00', '20:30', '21:00', '21:30', '22:00', '22:30', '23:00', '23:30'
		];
		
		return _.map(aTimeList, function (sTime) {
			var
				oMoment = moment(sTime, 'HH:mm'),
				sText = oMoment.format(sTimeFormatMoment)
			;
			return {text: sText, value: sText};
		});
	};

	/**
	 * @param {string} sDateFormat
	 * 
	 * @return string
	 */
	CalendarUtils.getDateFormatForDatePicker = function (sDateFormat)
	{
		var sDatePickerDateFormat = 'mm/dd/yy';
		
		switch (sDateFormat)
		{
			case 'MM/DD/YYYY':
				sDatePickerDateFormat = 'mm/dd/yy';
				break;
			case 'DD/MM/YYYY':
				sDatePickerDateFormat = 'dd/mm/yy';
				break;
			case 'DD Month YYYY':
				sDatePickerDateFormat = 'dd MM yy';
				break;
		}
		
		return sDatePickerDateFormat;
	};

	/**
	 * @param {string} sSubject
	 * @param {string} sDescription
	 * 
	 * @return {string}
	 */
	CalendarUtils.getTitleForEvent = function (sSubject, sDescription)
	{
		if (Settings.AddDescriptionToTitle)
		{
			return $.trim((sSubject + ' ' + sDescription).replace(/[\n\r]/g, ' '));
		}
		else
		{
			var
				sTitle = sSubject ? $.trim(sSubject.replace(/[\n\r]/, ' ')) : '',
				iFirstSpacePos = sTitle.indexOf(' ', 180)
			;

			if (iFirstSpacePos >= 0)
			{
				sTitle = sTitle.substring(0, iFirstSpacePos) + '...';
			}

			if (sTitle.length > 200)
			{
				sTitle = sTitle.substring(0, 200) + '...';
			}

			return sTitle;
		}
	};

	module.exports = CalendarUtils;

/***/ }),

/***/ 269:
/*!**********************************************!*\
  !*** ./modules/CalendarWebclient/js/Ajax.js ***!
  \**********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		Ajax = __webpack_require__(/*! modules/CoreWebclient/js/Ajax.js */ 186),
		
		Settings = __webpack_require__(/*! modules/CalendarWebclient/js/Settings.js */ 255)
	;

	Ajax.registerAbortRequestHandler(Settings.ServerModuleName, function (oRequest, oOpenedRequest) {
		switch (oRequest.Method)
		{
			case 'UpdateEvent':
				var
					oParameters = oRequest.Parameters,
					oOpenedParameters = oOpenedRequest.Parameters
				;
				return	oOpenedRequest.Method === 'UpdateEvent' && 
						oOpenedParameters.calendarId === oParameters.calendarId && 
						oOpenedParameters.uid === oParameters.uid;
			case 'GetCalendars':
				return oOpenedRequest.Method === 'GetCalendars';
			case 'GetEvents':
				return oOpenedRequest.Method === 'GetEvents';
		}
		
		return false;
	});

	module.exports = {
		send: function (sMethod, oParameters, fResponseHandler, oContext, sServerModuleName) {
			Ajax.send(
				sServerModuleName ? sServerModuleName : Settings.ServerModuleName,
				sMethod,
				oParameters,
				fResponseHandler,
				oContext
			);
		}
	};


/***/ }),

/***/ 270:
/*!***********************************************!*\
  !*** ./modules/CalendarWebclient/js/Cache.js ***!
  \***********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		ko = __webpack_require__(/*! knockout */ 46),
		_ = __webpack_require__(/*! underscore */ 2),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		
		Ajax = __webpack_require__(/*! modules/CalendarWebclient/js/Ajax.js */ 269)
	;

	/**
	 * @constructor
	 */
	function CCalendarCache()
	{
		// uses only for ical-attachments
		this.calendars = ko.observableArray([]);
		this.calendarsLoadingStarted = ko.observable(false);
		
		this.icalAttachments = [];
		
		this.recivedAnim = ko.observable(false).extend({'autoResetToFalse': 500});
		
		this.calendarSettingsChanged = ko.observable(false);
		this.calendarChanged = ko.observable(false);
	}

	/**
	 * @param {Object} oIcal
	 */
	CCalendarCache.prototype.addIcal = function (oIcal)
	{
		_.each(this.icalAttachments, function (oIcalItem) {
			if (oIcalItem.uid() === oIcal.uid())
			{
				if (oIcal.sSequence >= oIcalItem.sSequence)
				{
					oIcalItem.lastModification(false);
				}
				else
				{
					oIcal.lastModification(false);
				}
			}
		});
		this.icalAttachments.push(oIcal);
		if (this.calendars().length === 0)
		{
			this.requestCalendarList();
		}
	};

	/**
	 * @param {string} sFile
	 */
	CCalendarCache.prototype.getIcal = function (sFile)
	{
		return _.find(this.icalAttachments, function (oIcal) {
			return (sFile === oIcal.file());
		});
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oRequest
	 */
	CCalendarCache.prototype.onGetCalendarsResponse = function (oResponse, oRequest)
	{
		if (oResponse && oResponse.Result && oResponse.Result.Calendars)
		{
			var
				sCurrentEmail = App.currentAccountEmail ? App.currentAccountEmail() : '',
				aEditableCalendars = _.filter(oResponse.Result.Calendars, function (oCalendar) {
					return oCalendar.Owner === sCurrentEmail ||
						oCalendar.Access === Enums.CalendarAccess.Full ||
						oCalendar.Access === Enums.CalendarAccess.Write;
				})
			;
			this.calendars(_.map(aEditableCalendars, function (oCalendar) {
				return {'name': oCalendar.Name + ' <' + oCalendar.Owner + '>', 'id': oCalendar.Id};
			}));
		}
		
		this.calendarsLoadingStarted(false);
	};

	CCalendarCache.prototype.requestCalendarList = function ()
	{
		if (!this.calendarsLoadingStarted())
		{
			Ajax.send('GetCalendars', null, this.onGetCalendarsResponse, this);
			
			this.calendarsLoadingStarted(true);
		}
	};

	/**
	 * @param {string} sFile
	 * @param {string} sType
	 * @param {string} sCancelDecision
	 * @param {string} sReplyDecision
	 * @param {string} sCalendarId
	 * @param {string} sSelectedCalendar
	 */
	CCalendarCache.prototype.markIcalTypeByFile = function (sFile, sType, sCancelDecision, sReplyDecision,
															sCalendarId, sSelectedCalendar)
	{
		_.each(this.icalAttachments, function (oIcal) {
			if (sFile === oIcal.file())
			{
				oIcal.type(sType);
				oIcal.cancelDecision(sCancelDecision);
				oIcal.replyDecision(sReplyDecision);
				oIcal.calendarId(sCalendarId);
				oIcal.selectedCalendarId(sSelectedCalendar);
			}
		});
	};

	/**
	 * @param {string} sUid
	 */
	CCalendarCache.prototype.markIcalNonexistent = function (sUid)
	{
		_.each(this.icalAttachments, function (oIcal) {
			if (sUid === oIcal.uid())
			{
				oIcal.markNeededAction();
			}
		});
	};

	/**
	 * @param {string} sUid
	 */
	CCalendarCache.prototype.markIcalNotSaved = function (sUid)
	{
		_.each(this.icalAttachments, function (oIcal) {
			if (sUid === oIcal.uid())
			{
				oIcal.markNotSaved();
			}
		});
	};

	/**
	 * @param {string} sUid
	 */
	CCalendarCache.prototype.markIcalTentative = function (sUid)
	{
		_.each(this.icalAttachments, function (oIcal) {
			if (sUid === oIcal.uid())
			{
				oIcal.markTentative();
			}
		});
	};

	/**
	 * @param {string} sUid
	 */
	CCalendarCache.prototype.markIcalAccepted = function (sUid)
	{
		_.each(this.icalAttachments, function (oIcal) {
			if (sUid === oIcal.uid())
			{
				oIcal.markAccepted();
			}
		});
	};

	module.exports = new CCalendarCache();

/***/ }),

/***/ 276:
/*!*******************************************************************!*\
  !*** ./modules/CalendarWebclient/js/models/CCalendarListModel.js ***!
  \*******************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		
		CCalendarModel = __webpack_require__(/*! modules/CalendarWebclient/js/models/CCalendarModel.js */ 277)
	;

	/**
	 * @param {Object} oParameters
	 * @constructor
	 */
	function CCalendarListModel(oParameters)
	{
		this.parentOnCalendarActiveChange = oParameters.onCalendarActiveChange;
		this.parentOnCalendarCollectionChange = oParameters.onCalendarCollectionChange;
		
		this.defaultCal = ko.observable(null);
		this.currentCal = ko.observable(null);
		
		this.collection = ko.observableArray([]);
		this.collection.subscribe(function () {
			this.pickCurrentCalendar(this.defaultCal());
			
			if (this.parentOnCalendarCollectionChange)
			{
				this.parentOnCalendarCollectionChange();
			}
		}, this);
		this.count = ko.computed(function () {
			return this.collection().length;
		}, this);
		
		this.own = ko.computed(function () {
			var 
				calendars = _.filter(this.collection(), 
					function(oItem){ return (!oItem.isShared()); 
				})
			;
			return calendars;
		}, this);
		this.ownCount = ko.computed(function () {
			return this.own().length;
		}, this);
		this.shared = ko.computed(function () {
			var 
				calendars = _.filter(this.collection(), 
					function(oItem){ return (oItem.isShared() && !oItem.isSharedToAll()); 
				})
			;
			return calendars;
		}, this);
		this.sharedCount = ko.computed(function () {
			return this.shared().length;
		}, this);
		this.sharedToAll = ko.computed(function () {
			var 
				calendars = _.filter(this.collection(), 
					function(oItem){ return (oItem.isShared() && oItem.isSharedToAll()); 
				})
			;
			return calendars;
		}, this);
		this.sharedToAllCount = ko.computed(function () {
			return this.sharedToAll().length;
		}, this);
		this.ids = ko.computed(function () {
			return _.map(this.collection(), function (oCalendar){
				return oCalendar.id;
			}, this);
		}, this);
	}

	/**
	 * @param {Object=} oPickCalendar
	 */
	CCalendarListModel.prototype.pickCurrentCalendar = function (oPickCalendar)
	{
		var
			oFirstActiveCal = _.find(this.collection(), function (oCalendar) {
				return oCalendar.active() && oCalendar.isEditable();
			}, this)
		;
		
		if (!this.currentCal() || !this.currentCal().active())
		{
			if (oPickCalendar && oPickCalendar.active() && oPickCalendar.isEditable())
			{
				this.currentCal(oPickCalendar);
			}
			else if (this.defaultCal() && (this.defaultCal().active() && this.defaultCal().isEditable() || !oFirstActiveCal))
			{
				this.currentCal(this.defaultCal());
			}
			else if (oFirstActiveCal)
			{
				this.currentCal(oFirstActiveCal);
			}
		}
	};

	/**
	 * @param {string} sCalendarId
	 */
	CCalendarListModel.prototype.getCalendarById = function (sCalendarId)
	{
		return _.find(this.collection(), function(oCalendar) {
			return oCalendar.id === sCalendarId;
		}, this);
	};

	/**
	 * @param {Object=} oStart
	 * @param {Object=} oEnd
	 * @return {Array}
	 */
	CCalendarListModel.prototype.getEvents = function (oStart, oEnd)
	{
		var
			aCalendarsEvents = [],
			aCalendarEvents = []
		;
		
		_.each(this.collection(), function (oCalendar) {
			if (oCalendar && oCalendar.active())
			{
				if (oStart && oEnd)
				{
					aCalendarEvents = oCalendar.getEvents(oStart, oEnd);
				}
				else
				{
					aCalendarEvents = oCalendar.events();
				}
				aCalendarsEvents = _.union(aCalendarsEvents, aCalendarEvents);
			}
		}, this);

		return aCalendarsEvents;
	};

	/**
	 * @param {Object} oCalendarData
	 * 
	 * @return {Object}
	 */
	CCalendarListModel.prototype.parseCalendar = function (oCalendarData)
	{
		var	oCalendar = new CCalendarModel();
		oCalendar.parse(oCalendarData);
		
		return oCalendar;
	};
		
	/**
	 * @param {Object} oCalendarData
	 * 
	 * @return {Object}
	 */
	CCalendarListModel.prototype.parseAndAddCalendar = function (oCalendarData)
	{
		var
			mIndex = 0,
			oClientCalendar = null,
			oCalendar = this.parseCalendar(oCalendarData)
		;
		
		oCalendar.active.subscribe(function (value) {
			this.parentOnCalendarActiveChange(oCalendar);
			var oPickCalendar = oCalendar.active() ? oCalendar : this.defaultCal();
			this.pickCurrentCalendar(oPickCalendar);
			Storage.setData(oCalendar.id, value);
		}, this);
		
		if (oCalendar.isDefault)
		{
			this.defaultCal(oCalendar);
		}
		
		mIndex = this.calendarExists(oCalendar.id);
		if (mIndex || mIndex === 0)
		{
			oClientCalendar = this.getCalendarById(oCalendar.id);
			oCalendar.events(oClientCalendar.events());
			this.collection.splice(mIndex, 1, oCalendar);
			
		}
		else
		{
			this.collection.push(oCalendar);
		}
		
		//this.sort();
		
		return oCalendar;
	};

	/**
	 * @param {string|number} sId
	 * 
	 * @return {?}
	 */
	CCalendarListModel.prototype.calendarExists = function (sId)
	{
		var iIndex = _.indexOf(_.map(this.collection(), function(oItem){return oItem.id;}), sId);
		
		return (iIndex < 0) ? false : iIndex;
	};

	/**
	 * @param {string} sId
	 */
	CCalendarListModel.prototype.removeCalendar = function (sId)
	{
		this.collection(_.filter(this.collection(), function(oCalendar) {
			return oCalendar.id !== sId;
		}, this));
	};


	CCalendarListModel.prototype.clearCollection = function ()
	{
		this.collection.removeAll();
	};

	CCalendarListModel.prototype.getColors = function ()
	{
		return _.map(this.collection(), function (oCalendar) {
			return oCalendar.color().toLowerCase();
		}, this);
	};

	/**
	 * @param {string} sId
	 */
	CCalendarListModel.prototype.setDefault = function (sId)
	{
		_.each(this.collection(), function(oCalendar) {
			if (oCalendar.id !== sId)
			{
				oCalendar.isDefault = true;
				this.defaultCal(oCalendar);
			}
			else
			{
				oCalendar.isDefault = false;
			}
		}, this);
	};

	CCalendarListModel.prototype.sort = function ()
	{
		var collection = _.sortBy(this.collection(), function(oCalendar){return oCalendar.name();});
		this.collection(_.sortBy(collection, function(oCalendar){return oCalendar.isShared();}));
	};

	/**
	 * @param {Array} aIds
	 */
	CCalendarListModel.prototype.expunge = function (aIds)
	{
		this.collection(_.filter(this.collection(), function(oCalendar) {
			return _.include(aIds, oCalendar.id);
		}, this));
	};

	module.exports = CCalendarListModel;


/***/ }),

/***/ 277:
/*!***************************************************************!*\
  !*** ./modules/CalendarWebclient/js/models/CCalendarModel.js ***!
  \***************************************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		UrlUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Url.js */ 177),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Storage = __webpack_require__(/*! modules/CoreWebclient/js/Storage.js */ 217),
		
		CalendarUtils = __webpack_require__(/*! modules/CalendarWebclient/js/utils/Calendar.js */ 268),
		Settings = __webpack_require__(/*! modules/CalendarWebclient/js/Settings.js */ 255)
	;

	/**
	 * @constructor
	 */
	function CCalendarModel()
	{
		this.id = 0;
		this.sSyncToken = '';
		this.name = ko.observable('');
		this.description = ko.observable('');
		this.owner = ko.observable('');
		this.isDefault = false;
		this.isShared =  ko.observable(false);
		this.isSharedToAll = ko.observable(false);
		this.sharedToAllAccess = Enums.CalendarAccess.Read;
		this.isPublic = ko.observable(false);
		this.url = ko.observable('');
		this.davUrl = ko.observable('');
		this.exportUrl = ko.observable('');
		this.pubUrl = ko.observable('');
		this.shares = ko.observableArray([]);
		this.events = ko.observableArray([]);
		this.eventsCount = ko.computed(function() {
			return this.events().length;
		}, this);
		this.access = ko.observable(Enums.CalendarAccess.Write);
		
		this.control = ko.computed(function() {
			return !(this.access() === Enums.CalendarAccess.Read && this.isSharedToAll());
		}, this);
		
		this.color = ko.observable('');
		this.color.subscribe(function(){
			
			this.events(_.map(this.events(), function (oEvent) {
				oEvent.backgroundColor = oEvent.borderColor = this.color();
				return oEvent;
			}, this));
			
			this.name.valueHasMutated();

		}, this);
		
		this.active = ko.observable(true);
		
		this.startDateTime = 0;
		this.endDateTime = 0;
		this.canShare = ko.computed(function () {
				return (!this.isShared() || this.isShared() && this.access() === Enums.CalendarAccess.Write || this.isOwner());
			}, this
		);
		this.bAllowShare = Settings.AllowShare;
		this.bAllowAppointments = Settings.AllowAppointments;
	}

	/**
	 * @param {string} sColor
	 * @returns {string}
	 */
	CCalendarModel.prototype.parseCssColor = function (sColor)
	{
		var sCssColor = Types.pString(sColor);
		
		if (sCssColor.length > 7)
		{
			sCssColor = sCssColor.substr(0, 7);
		}
		else if (sCssColor.length > 4 && sCssColor.length < 7)
		{
			sCssColor = sCssColor.substr(0, 4);
		}
		
		if (sCssColor.length === 4)
		{
			sCssColor = sCssColor[0] + sCssColor[1] + sCssColor[1] + sCssColor[2] + sCssColor[2] + sCssColor[3] + sCssColor[3];
		}
		
		if (!sCssColor.match(/^#[A-Fa-f0-9]{6}$/i))
		{
			sCssColor = '#f09650';
		}
		
		return sCssColor;
	};

	/**
	 * @param {Object} oData
	 */
	CCalendarModel.prototype.parse = function (oData)
	{
		this.id = Types.pString(oData.Id);
		this.sSyncToken = oData.SyncToken;
		this.name(Types.pString(oData.Name));
		this.description(Types.pString(oData.Description));
		this.owner(Types.pString(oData.Owner));
		this.active(Storage.hasData(this.id) ? Storage.getData(this.id) : true);
		this.isDefault = !!oData.IsDefault;
		this.isShared(!!oData.Shared);
		this.isSharedToAll(!!oData.SharedToAll);
		this.sharedToAllAccess = oData.SharedToAllAccess;
		this.isPublic(!!oData.IsPublic);
		this.access(oData.Access);

		this.color(this.parseCssColor(oData.Color));
		this.url(Types.pString(oData.Url));
		this.exportUrl(UrlUtils.getAppPath() + '?calendar-download/' + Types.pString(oData.ExportHash));
		this.pubUrl(UrlUtils.getAppPath() + '?calendar-pub=' + Types.pString(oData.PubHash));
		this.shares(oData.Shares || []);
		
		_.each(oData.Events, function (oEvent) {
			this.addEvent(oEvent);
		}, this);
	};

	/**
	 * @param {Object} oEvent
	 */
	CCalendarModel.prototype.updateEvent = function (oEvent)
	{
		var bResult = false;
		if (oEvent)
		{
			this.removeEvent(oEvent.id);
			this.addEvent(oEvent);
		}
		
		return bResult;
	};

	/**
	 * @param {Object} oEvent
	 */
	CCalendarModel.prototype.addEvent = function (oEvent)
	{
		if (oEvent && !this.eventExists(oEvent.id))
		{
			this.events.push(this.parseEvent(oEvent));
		}
	};

	/**
	 * @param {string} sId
	 */
	CCalendarModel.prototype.getEvent = function (sId)
	{
		return _.find(this.events(), function (oEvent) { 
			return oEvent.id === sId;
		}, this);
	};

	/**
	 * @param {string} sId
	 * 
	 * @return {boolean}
	 */
	CCalendarModel.prototype.eventExists = function (sId)
	{
		return !!this.getEvent(sId);
	};

	/**
	 * @param {Object} start
	 * @param {Object} end
	 */
	CCalendarModel.prototype.getEvents = function (start, end)
	{
		var aResult = _.filter(this.events(), function(oEvent){ 
			var 
				iStart = start.unix(),
				iEnd = end.unix(),
				iEventStart = moment.utc(oEvent.start).unix(),
				iEventEnd = moment.utc(oEvent.end).unix()
			;
			return iEventStart >= iStart && iEventEnd <= iEnd ||
					iEventStart <= iStart && iEventEnd >= iEnd ||
					iEventStart >= iStart && iEventStart <= iEnd ||
					iEventEnd <= iEnd && iEventEnd >= iStart 
			;
		}, this);
		
		return aResult || [];
	};

	/**
	 * @param {string} sId
	 */
	CCalendarModel.prototype.removeEvent = function (sId)
	{
		this.events(_.filter(this.events(), function(oEvent){ 
			return oEvent.id !== sId;
		}, this));
	};

	/**
	 * @param {string} sUid
	 * @param {boolean=} bSkipExcluded = false
	 */
	CCalendarModel.prototype.removeEventByUid = function (sUid, bSkipExcluded)
	{
		this.events(_.filter(this.events(), function(oEvent){ 
			return (oEvent.uid !== sUid && (!bSkipExcluded || !oEvent.excluded));
		}, this));
	};

	CCalendarModel.prototype.removeEvents = function ()
	{
		this.events([]);
	};

	/**
	 * @param {Array} aEventIds
	 * @param {number} start
	 * @param {number} end
	 */
	CCalendarModel.prototype.expungeEvents = function (aEventIds, start, end, type)
	{
		var aEventRemoveIds = [];
		_.each(this.getEvents(moment.unix(start), moment.unix(end)), function(oEvent) {
			if (!_.include(aEventIds, oEvent.id) && oEvent.type === type)
			{
				aEventRemoveIds.push(oEvent.id);
			}
		}, this);
		this.events(_.filter(this.events(), function(oEvent){
			return !_.include(aEventRemoveIds, oEvent.id);
		},this));
	};

	/**
	 * @return {boolean}
	 */
	CCalendarModel.prototype.isEditable = function ()
	{
		return this.access() !== Enums.CalendarAccess.Read;
	};

	/**
	 * @return {boolean}
	 */
	CCalendarModel.prototype.isOwner = function ()
	{
		return App.getUserPublicId() === this.owner();
	};

	CCalendarModel.prototype.parseEvent = function (oEvent)
	{
		oEvent.title = CalendarUtils.getTitleForEvent(oEvent.subject, oEvent.description);
		oEvent.editable = oEvent.appointment ? false : true;
		oEvent.backgroundColor = oEvent.borderColor = this.color();
		if (!_.isArray(oEvent.className))
		{
			var className = oEvent.className;
			oEvent.className = [className];
		}
		if (this.access() === Enums.CalendarAccess.Read)
		{
			oEvent.className.push('fc-event-readonly');
			oEvent.editable = false;
		}
		else
		{
			oEvent.className = _.filter(oEvent.className, function(sItem){ 
				return sItem !== 'fc-event-readonly'; 
			});
		}
		if (oEvent.rrule && !oEvent.excluded)
		{
			oEvent.className.push('fc-event-repeat');
		}
		else
		{
			oEvent.className = _.filter(oEvent.className, function(sItem){ 
				return sItem !== 'fc-event-repeat'; 
			});		
		}
		if (Types.isNonEmptyArray(oEvent.attendees) && this.bAllowAppointments)
		{
			oEvent.className.push('fc-event-appointment');
		}
		else
		{
			oEvent.className = _.filter(oEvent.className, function(sItem){ 
				return sItem !== 'fc-event-appointment'; 
			});		
		}
		return oEvent;
	};

	CCalendarModel.prototype.reloadEvents = function ()
	{
		this.events(_.map(this.events(), function (oEvent) {
			return this.parseEvent(oEvent);
		}, this));
	};

	module.exports = CCalendarModel;


/***/ }),

/***/ 278:
/*!**********************************************!*\
  !*** ./~/jquery-ui/ui/widgets/datepicker.js ***!
  \**********************************************/
/***/ (function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;// jscs:disable maximumLineLength
	/* jscs:disable requireCamelCaseOrUpperCaseIdentifiers */
	/*!
	 * jQuery UI Datepicker 1.12.1
	 * http://jqueryui.com
	 *
	 * Copyright jQuery Foundation and other contributors
	 * Released under the MIT license.
	 * http://jquery.org/license
	 */

	//>>label: Datepicker
	//>>group: Widgets
	//>>description: Displays a calendar from an input or inline for selecting dates.
	//>>docs: http://api.jqueryui.com/datepicker/
	//>>demos: http://jqueryui.com/datepicker/
	//>>css.structure: ../../themes/base/core.css
	//>>css.structure: ../../themes/base/datepicker.css
	//>>css.theme: ../../themes/base/theme.css

	( function( factory ) {
		if ( true ) {

			// AMD. Register as an anonymous module.
			!(__WEBPACK_AMD_DEFINE_ARRAY__ = [
				__webpack_require__(/*! jquery */ 1),
				__webpack_require__(/*! ../version */ 205),
				__webpack_require__(/*! ../keycode */ 204)
			], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else {

			// Browser globals
			factory( jQuery );
		}
	}( function( $ ) {

	$.extend( $.ui, { datepicker: { version: "1.12.1" } } );

	var datepicker_instActive;

	function datepicker_getZindex( elem ) {
		var position, value;
		while ( elem.length && elem[ 0 ] !== document ) {

			// Ignore z-index if position is set to a value where z-index is ignored by the browser
			// This makes behavior of this function consistent across browsers
			// WebKit always returns auto if the element is positioned
			position = elem.css( "position" );
			if ( position === "absolute" || position === "relative" || position === "fixed" ) {

				// IE returns 0 when zIndex is not specified
				// other browsers return a string
				// we ignore the case of nested elements with an explicit value of 0
				// <div style="z-index: -10;"><div style="z-index: 0;"></div></div>
				value = parseInt( elem.css( "zIndex" ), 10 );
				if ( !isNaN( value ) && value !== 0 ) {
					return value;
				}
			}
			elem = elem.parent();
		}

		return 0;
	}
	/* Date picker manager.
	   Use the singleton instance of this class, $.datepicker, to interact with the date picker.
	   Settings for (groups of) date pickers are maintained in an instance object,
	   allowing multiple different settings on the same page. */

	function Datepicker() {
		this._curInst = null; // The current instance in use
		this._keyEvent = false; // If the last event was a key event
		this._disabledInputs = []; // List of date picker inputs that have been disabled
		this._datepickerShowing = false; // True if the popup picker is showing , false if not
		this._inDialog = false; // True if showing within a "dialog", false if not
		this._mainDivId = "ui-datepicker-div"; // The ID of the main datepicker division
		this._inlineClass = "ui-datepicker-inline"; // The name of the inline marker class
		this._appendClass = "ui-datepicker-append"; // The name of the append marker class
		this._triggerClass = "ui-datepicker-trigger"; // The name of the trigger marker class
		this._dialogClass = "ui-datepicker-dialog"; // The name of the dialog marker class
		this._disableClass = "ui-datepicker-disabled"; // The name of the disabled covering marker class
		this._unselectableClass = "ui-datepicker-unselectable"; // The name of the unselectable cell marker class
		this._currentClass = "ui-datepicker-current-day"; // The name of the current day marker class
		this._dayOverClass = "ui-datepicker-days-cell-over"; // The name of the day hover marker class
		this.regional = []; // Available regional settings, indexed by language code
		this.regional[ "" ] = { // Default regional settings
			closeText: "Done", // Display text for close link
			prevText: "Prev", // Display text for previous month link
			nextText: "Next", // Display text for next month link
			currentText: "Today", // Display text for current month link
			monthNames: [ "January","February","March","April","May","June",
				"July","August","September","October","November","December" ], // Names of months for drop-down and formatting
			monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ], // For formatting
			dayNames: [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ], // For formatting
			dayNamesShort: [ "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" ], // For formatting
			dayNamesMin: [ "Su","Mo","Tu","We","Th","Fr","Sa" ], // Column headings for days starting at Sunday
			weekHeader: "Wk", // Column header for week of the year
			dateFormat: "mm/dd/yy", // See format options on parseDate
			firstDay: 0, // The first day of the week, Sun = 0, Mon = 1, ...
			isRTL: false, // True if right-to-left language, false if left-to-right
			showMonthAfterYear: false, // True if the year select precedes month, false for month then year
			yearSuffix: "" // Additional text to append to the year in the month headers
		};
		this._defaults = { // Global defaults for all the date picker instances
			showOn: "focus", // "focus" for popup on focus,
				// "button" for trigger button, or "both" for either
			showAnim: "fadeIn", // Name of jQuery animation for popup
			showOptions: {}, // Options for enhanced animations
			defaultDate: null, // Used when field is blank: actual date,
				// +/-number for offset from today, null for today
			appendText: "", // Display text following the input box, e.g. showing the format
			buttonText: "...", // Text for trigger button
			buttonImage: "", // URL for trigger button image
			buttonImageOnly: false, // True if the image appears alone, false if it appears on a button
			hideIfNoPrevNext: false, // True to hide next/previous month links
				// if not applicable, false to just disable them
			navigationAsDateFormat: false, // True if date formatting applied to prev/today/next links
			gotoCurrent: false, // True if today link goes back to current selection instead
			changeMonth: false, // True if month can be selected directly, false if only prev/next
			changeYear: false, // True if year can be selected directly, false if only prev/next
			yearRange: "c-10:c+10", // Range of years to display in drop-down,
				// either relative to today's year (-nn:+nn), relative to currently displayed year
				// (c-nn:c+nn), absolute (nnnn:nnnn), or a combination of the above (nnnn:-n)
			showOtherMonths: false, // True to show dates in other months, false to leave blank
			selectOtherMonths: false, // True to allow selection of dates in other months, false for unselectable
			showWeek: false, // True to show week of the year, false to not show it
			calculateWeek: this.iso8601Week, // How to calculate the week of the year,
				// takes a Date and returns the number of the week for it
			shortYearCutoff: "+10", // Short year values < this are in the current century,
				// > this are in the previous century,
				// string value starting with "+" for current year + value
			minDate: null, // The earliest selectable date, or null for no limit
			maxDate: null, // The latest selectable date, or null for no limit
			duration: "fast", // Duration of display/closure
			beforeShowDay: null, // Function that takes a date and returns an array with
				// [0] = true if selectable, false if not, [1] = custom CSS class name(s) or "",
				// [2] = cell title (optional), e.g. $.datepicker.noWeekends
			beforeShow: null, // Function that takes an input field and
				// returns a set of custom settings for the date picker
			onSelect: null, // Define a callback function when a date is selected
			onChangeMonthYear: null, // Define a callback function when the month or year is changed
			onClose: null, // Define a callback function when the datepicker is closed
			numberOfMonths: 1, // Number of months to show at a time
			showCurrentAtPos: 0, // The position in multipe months at which to show the current month (starting at 0)
			stepMonths: 1, // Number of months to step back/forward
			stepBigMonths: 12, // Number of months to step back/forward for the big links
			altField: "", // Selector for an alternate field to store selected dates into
			altFormat: "", // The date format to use for the alternate field
			constrainInput: true, // The input is constrained by the current date format
			showButtonPanel: false, // True to show button panel, false to not show it
			autoSize: false, // True to size the input for the date format, false to leave as is
			disabled: false // The initial disabled state
		};
		$.extend( this._defaults, this.regional[ "" ] );
		this.regional.en = $.extend( true, {}, this.regional[ "" ] );
		this.regional[ "en-US" ] = $.extend( true, {}, this.regional.en );
		this.dpDiv = datepicker_bindHover( $( "<div id='" + this._mainDivId + "' class='ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>" ) );
	}

	$.extend( Datepicker.prototype, {
		/* Class name added to elements to indicate already configured with a date picker. */
		markerClassName: "hasDatepicker",

		//Keep track of the maximum number of rows displayed (see #7043)
		maxRows: 4,

		// TODO rename to "widget" when switching to widget factory
		_widgetDatepicker: function() {
			return this.dpDiv;
		},

		/* Override the default settings for all instances of the date picker.
		 * @param  settings  object - the new settings to use as defaults (anonymous object)
		 * @return the manager object
		 */
		setDefaults: function( settings ) {
			datepicker_extendRemove( this._defaults, settings || {} );
			return this;
		},

		/* Attach the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 * @param  settings  object - the new settings to use for this date picker instance (anonymous)
		 */
		_attachDatepicker: function( target, settings ) {
			var nodeName, inline, inst;
			nodeName = target.nodeName.toLowerCase();
			inline = ( nodeName === "div" || nodeName === "span" );
			if ( !target.id ) {
				this.uuid += 1;
				target.id = "dp" + this.uuid;
			}
			inst = this._newInst( $( target ), inline );
			inst.settings = $.extend( {}, settings || {} );
			if ( nodeName === "input" ) {
				this._connectDatepicker( target, inst );
			} else if ( inline ) {
				this._inlineDatepicker( target, inst );
			}
		},

		/* Create a new instance object. */
		_newInst: function( target, inline ) {
			var id = target[ 0 ].id.replace( /([^A-Za-z0-9_\-])/g, "\\\\$1" ); // escape jQuery meta chars
			return { id: id, input: target, // associated target
				selectedDay: 0, selectedMonth: 0, selectedYear: 0, // current selection
				drawMonth: 0, drawYear: 0, // month being drawn
				inline: inline, // is datepicker inline or not
				dpDiv: ( !inline ? this.dpDiv : // presentation div
				datepicker_bindHover( $( "<div class='" + this._inlineClass + " ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>" ) ) ) };
		},

		/* Attach the date picker to an input field. */
		_connectDatepicker: function( target, inst ) {
			var input = $( target );
			inst.append = $( [] );
			inst.trigger = $( [] );
			if ( input.hasClass( this.markerClassName ) ) {
				return;
			}
			this._attachments( input, inst );
			input.addClass( this.markerClassName ).on( "keydown", this._doKeyDown ).
				on( "keypress", this._doKeyPress ).on( "keyup", this._doKeyUp );
			this._autoSize( inst );
			$.data( target, "datepicker", inst );

			//If disabled option is true, disable the datepicker once it has been attached to the input (see ticket #5665)
			if ( inst.settings.disabled ) {
				this._disableDatepicker( target );
			}
		},

		/* Make attachments based on settings. */
		_attachments: function( input, inst ) {
			var showOn, buttonText, buttonImage,
				appendText = this._get( inst, "appendText" ),
				isRTL = this._get( inst, "isRTL" );

			if ( inst.append ) {
				inst.append.remove();
			}
			if ( appendText ) {
				inst.append = $( "<span class='" + this._appendClass + "'>" + appendText + "</span>" );
				input[ isRTL ? "before" : "after" ]( inst.append );
			}

			input.off( "focus", this._showDatepicker );

			if ( inst.trigger ) {
				inst.trigger.remove();
			}

			showOn = this._get( inst, "showOn" );
			if ( showOn === "focus" || showOn === "both" ) { // pop-up date picker when in the marked field
				input.on( "focus", this._showDatepicker );
			}
			if ( showOn === "button" || showOn === "both" ) { // pop-up date picker when button clicked
				buttonText = this._get( inst, "buttonText" );
				buttonImage = this._get( inst, "buttonImage" );
				inst.trigger = $( this._get( inst, "buttonImageOnly" ) ?
					$( "<img/>" ).addClass( this._triggerClass ).
						attr( { src: buttonImage, alt: buttonText, title: buttonText } ) :
					$( "<button type='button'></button>" ).addClass( this._triggerClass ).
						html( !buttonImage ? buttonText : $( "<img/>" ).attr(
						{ src:buttonImage, alt:buttonText, title:buttonText } ) ) );
				input[ isRTL ? "before" : "after" ]( inst.trigger );
				inst.trigger.on( "click", function() {
					if ( $.datepicker._datepickerShowing && $.datepicker._lastInput === input[ 0 ] ) {
						$.datepicker._hideDatepicker();
					} else if ( $.datepicker._datepickerShowing && $.datepicker._lastInput !== input[ 0 ] ) {
						$.datepicker._hideDatepicker();
						$.datepicker._showDatepicker( input[ 0 ] );
					} else {
						$.datepicker._showDatepicker( input[ 0 ] );
					}
					return false;
				} );
			}
		},

		/* Apply the maximum length for the date format. */
		_autoSize: function( inst ) {
			if ( this._get( inst, "autoSize" ) && !inst.inline ) {
				var findMax, max, maxI, i,
					date = new Date( 2009, 12 - 1, 20 ), // Ensure double digits
					dateFormat = this._get( inst, "dateFormat" );

				if ( dateFormat.match( /[DM]/ ) ) {
					findMax = function( names ) {
						max = 0;
						maxI = 0;
						for ( i = 0; i < names.length; i++ ) {
							if ( names[ i ].length > max ) {
								max = names[ i ].length;
								maxI = i;
							}
						}
						return maxI;
					};
					date.setMonth( findMax( this._get( inst, ( dateFormat.match( /MM/ ) ?
						"monthNames" : "monthNamesShort" ) ) ) );
					date.setDate( findMax( this._get( inst, ( dateFormat.match( /DD/ ) ?
						"dayNames" : "dayNamesShort" ) ) ) + 20 - date.getDay() );
				}
				inst.input.attr( "size", this._formatDate( inst, date ).length );
			}
		},

		/* Attach an inline date picker to a div. */
		_inlineDatepicker: function( target, inst ) {
			var divSpan = $( target );
			if ( divSpan.hasClass( this.markerClassName ) ) {
				return;
			}
			divSpan.addClass( this.markerClassName ).append( inst.dpDiv );
			$.data( target, "datepicker", inst );
			this._setDate( inst, this._getDefaultDate( inst ), true );
			this._updateDatepicker( inst );
			this._updateAlternate( inst );

			//If disabled option is true, disable the datepicker before showing it (see ticket #5665)
			if ( inst.settings.disabled ) {
				this._disableDatepicker( target );
			}

			// Set display:block in place of inst.dpDiv.show() which won't work on disconnected elements
			// http://bugs.jqueryui.com/ticket/7552 - A Datepicker created on a detached div has zero height
			inst.dpDiv.css( "display", "block" );
		},

		/* Pop-up the date picker in a "dialog" box.
		 * @param  input element - ignored
		 * @param  date	string or Date - the initial date to display
		 * @param  onSelect  function - the function to call when a date is selected
		 * @param  settings  object - update the dialog date picker instance's settings (anonymous object)
		 * @param  pos int[2] - coordinates for the dialog's position within the screen or
		 *					event - with x/y coordinates or
		 *					leave empty for default (screen centre)
		 * @return the manager object
		 */
		_dialogDatepicker: function( input, date, onSelect, settings, pos ) {
			var id, browserWidth, browserHeight, scrollX, scrollY,
				inst = this._dialogInst; // internal instance

			if ( !inst ) {
				this.uuid += 1;
				id = "dp" + this.uuid;
				this._dialogInput = $( "<input type='text' id='" + id +
					"' style='position: absolute; top: -100px; width: 0px;'/>" );
				this._dialogInput.on( "keydown", this._doKeyDown );
				$( "body" ).append( this._dialogInput );
				inst = this._dialogInst = this._newInst( this._dialogInput, false );
				inst.settings = {};
				$.data( this._dialogInput[ 0 ], "datepicker", inst );
			}
			datepicker_extendRemove( inst.settings, settings || {} );
			date = ( date && date.constructor === Date ? this._formatDate( inst, date ) : date );
			this._dialogInput.val( date );

			this._pos = ( pos ? ( pos.length ? pos : [ pos.pageX, pos.pageY ] ) : null );
			if ( !this._pos ) {
				browserWidth = document.documentElement.clientWidth;
				browserHeight = document.documentElement.clientHeight;
				scrollX = document.documentElement.scrollLeft || document.body.scrollLeft;
				scrollY = document.documentElement.scrollTop || document.body.scrollTop;
				this._pos = // should use actual width/height below
					[ ( browserWidth / 2 ) - 100 + scrollX, ( browserHeight / 2 ) - 150 + scrollY ];
			}

			// Move input on screen for focus, but hidden behind dialog
			this._dialogInput.css( "left", ( this._pos[ 0 ] + 20 ) + "px" ).css( "top", this._pos[ 1 ] + "px" );
			inst.settings.onSelect = onSelect;
			this._inDialog = true;
			this.dpDiv.addClass( this._dialogClass );
			this._showDatepicker( this._dialogInput[ 0 ] );
			if ( $.blockUI ) {
				$.blockUI( this.dpDiv );
			}
			$.data( this._dialogInput[ 0 ], "datepicker", inst );
			return this;
		},

		/* Detach a datepicker from its control.
		 * @param  target	element - the target input field or division or span
		 */
		_destroyDatepicker: function( target ) {
			var nodeName,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			$.removeData( target, "datepicker" );
			if ( nodeName === "input" ) {
				inst.append.remove();
				inst.trigger.remove();
				$target.removeClass( this.markerClassName ).
					off( "focus", this._showDatepicker ).
					off( "keydown", this._doKeyDown ).
					off( "keypress", this._doKeyPress ).
					off( "keyup", this._doKeyUp );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				$target.removeClass( this.markerClassName ).empty();
			}

			if ( datepicker_instActive === inst ) {
				datepicker_instActive = null;
			}
		},

		/* Enable the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 */
		_enableDatepicker: function( target ) {
			var nodeName, inline,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			if ( nodeName === "input" ) {
				target.disabled = false;
				inst.trigger.filter( "button" ).
					each( function() { this.disabled = false; } ).end().
					filter( "img" ).css( { opacity: "1.0", cursor: "" } );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				inline = $target.children( "." + this._inlineClass );
				inline.children().removeClass( "ui-state-disabled" );
				inline.find( "select.ui-datepicker-month, select.ui-datepicker-year" ).
					prop( "disabled", false );
			}
			this._disabledInputs = $.map( this._disabledInputs,
				function( value ) { return ( value === target ? null : value ); } ); // delete entry
		},

		/* Disable the date picker to a jQuery selection.
		 * @param  target	element - the target input field or division or span
		 */
		_disableDatepicker: function( target ) {
			var nodeName, inline,
				$target = $( target ),
				inst = $.data( target, "datepicker" );

			if ( !$target.hasClass( this.markerClassName ) ) {
				return;
			}

			nodeName = target.nodeName.toLowerCase();
			if ( nodeName === "input" ) {
				target.disabled = true;
				inst.trigger.filter( "button" ).
					each( function() { this.disabled = true; } ).end().
					filter( "img" ).css( { opacity: "0.5", cursor: "default" } );
			} else if ( nodeName === "div" || nodeName === "span" ) {
				inline = $target.children( "." + this._inlineClass );
				inline.children().addClass( "ui-state-disabled" );
				inline.find( "select.ui-datepicker-month, select.ui-datepicker-year" ).
					prop( "disabled", true );
			}
			this._disabledInputs = $.map( this._disabledInputs,
				function( value ) { return ( value === target ? null : value ); } ); // delete entry
			this._disabledInputs[ this._disabledInputs.length ] = target;
		},

		/* Is the first field in a jQuery collection disabled as a datepicker?
		 * @param  target	element - the target input field or division or span
		 * @return boolean - true if disabled, false if enabled
		 */
		_isDisabledDatepicker: function( target ) {
			if ( !target ) {
				return false;
			}
			for ( var i = 0; i < this._disabledInputs.length; i++ ) {
				if ( this._disabledInputs[ i ] === target ) {
					return true;
				}
			}
			return false;
		},

		/* Retrieve the instance data for the target control.
		 * @param  target  element - the target input field or division or span
		 * @return  object - the associated instance data
		 * @throws  error if a jQuery problem getting data
		 */
		_getInst: function( target ) {
			try {
				return $.data( target, "datepicker" );
			}
			catch ( err ) {
				throw "Missing instance data for this datepicker";
			}
		},

		/* Update or retrieve the settings for a date picker attached to an input field or division.
		 * @param  target  element - the target input field or division or span
		 * @param  name	object - the new settings to update or
		 *				string - the name of the setting to change or retrieve,
		 *				when retrieving also "all" for all instance settings or
		 *				"defaults" for all global defaults
		 * @param  value   any - the new value for the setting
		 *				(omit if above is an object or to retrieve a value)
		 */
		_optionDatepicker: function( target, name, value ) {
			var settings, date, minDate, maxDate,
				inst = this._getInst( target );

			if ( arguments.length === 2 && typeof name === "string" ) {
				return ( name === "defaults" ? $.extend( {}, $.datepicker._defaults ) :
					( inst ? ( name === "all" ? $.extend( {}, inst.settings ) :
					this._get( inst, name ) ) : null ) );
			}

			settings = name || {};
			if ( typeof name === "string" ) {
				settings = {};
				settings[ name ] = value;
			}

			if ( inst ) {
				if ( this._curInst === inst ) {
					this._hideDatepicker();
				}

				date = this._getDateDatepicker( target, true );
				minDate = this._getMinMaxDate( inst, "min" );
				maxDate = this._getMinMaxDate( inst, "max" );
				datepicker_extendRemove( inst.settings, settings );

				// reformat the old minDate/maxDate values if dateFormat changes and a new minDate/maxDate isn't provided
				if ( minDate !== null && settings.dateFormat !== undefined && settings.minDate === undefined ) {
					inst.settings.minDate = this._formatDate( inst, minDate );
				}
				if ( maxDate !== null && settings.dateFormat !== undefined && settings.maxDate === undefined ) {
					inst.settings.maxDate = this._formatDate( inst, maxDate );
				}
				if ( "disabled" in settings ) {
					if ( settings.disabled ) {
						this._disableDatepicker( target );
					} else {
						this._enableDatepicker( target );
					}
				}
				this._attachments( $( target ), inst );
				this._autoSize( inst );
				this._setDate( inst, date );
				this._updateAlternate( inst );
				this._updateDatepicker( inst );
			}
		},

		// Change method deprecated
		_changeDatepicker: function( target, name, value ) {
			this._optionDatepicker( target, name, value );
		},

		/* Redraw the date picker attached to an input field or division.
		 * @param  target  element - the target input field or division or span
		 */
		_refreshDatepicker: function( target ) {
			var inst = this._getInst( target );
			if ( inst ) {
				this._updateDatepicker( inst );
			}
		},

		/* Set the dates for a jQuery selection.
		 * @param  target element - the target input field or division or span
		 * @param  date	Date - the new date
		 */
		_setDateDatepicker: function( target, date ) {
			var inst = this._getInst( target );
			if ( inst ) {
				this._setDate( inst, date );
				this._updateDatepicker( inst );
				this._updateAlternate( inst );
			}
		},

		/* Get the date(s) for the first entry in a jQuery selection.
		 * @param  target element - the target input field or division or span
		 * @param  noDefault boolean - true if no default date is to be used
		 * @return Date - the current date
		 */
		_getDateDatepicker: function( target, noDefault ) {
			var inst = this._getInst( target );
			if ( inst && !inst.inline ) {
				this._setDateFromField( inst, noDefault );
			}
			return ( inst ? this._getDate( inst ) : null );
		},

		/* Handle keystrokes. */
		_doKeyDown: function( event ) {
			var onSelect, dateStr, sel,
				inst = $.datepicker._getInst( event.target ),
				handled = true,
				isRTL = inst.dpDiv.is( ".ui-datepicker-rtl" );

			inst._keyEvent = true;
			if ( $.datepicker._datepickerShowing ) {
				switch ( event.keyCode ) {
					case 9: $.datepicker._hideDatepicker();
							handled = false;
							break; // hide on tab out
					case 13: sel = $( "td." + $.datepicker._dayOverClass + ":not(." +
										$.datepicker._currentClass + ")", inst.dpDiv );
							if ( sel[ 0 ] ) {
								$.datepicker._selectDay( event.target, inst.selectedMonth, inst.selectedYear, sel[ 0 ] );
							}

							onSelect = $.datepicker._get( inst, "onSelect" );
							if ( onSelect ) {
								dateStr = $.datepicker._formatDate( inst );

								// Trigger custom callback
								onSelect.apply( ( inst.input ? inst.input[ 0 ] : null ), [ dateStr, inst ] );
							} else {
								$.datepicker._hideDatepicker();
							}

							return false; // don't submit the form
					case 27: $.datepicker._hideDatepicker();
							break; // hide on escape
					case 33: $.datepicker._adjustDate( event.target, ( event.ctrlKey ?
								-$.datepicker._get( inst, "stepBigMonths" ) :
								-$.datepicker._get( inst, "stepMonths" ) ), "M" );
							break; // previous month/year on page up/+ ctrl
					case 34: $.datepicker._adjustDate( event.target, ( event.ctrlKey ?
								+$.datepicker._get( inst, "stepBigMonths" ) :
								+$.datepicker._get( inst, "stepMonths" ) ), "M" );
							break; // next month/year on page down/+ ctrl
					case 35: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._clearDate( event.target );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // clear on ctrl or command +end
					case 36: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._gotoToday( event.target );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // current on ctrl or command +home
					case 37: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, ( isRTL ? +1 : -1 ), "D" );
							}
							handled = event.ctrlKey || event.metaKey;

							// -1 day on ctrl or command +left
							if ( event.originalEvent.altKey ) {
								$.datepicker._adjustDate( event.target, ( event.ctrlKey ?
									-$.datepicker._get( inst, "stepBigMonths" ) :
									-$.datepicker._get( inst, "stepMonths" ) ), "M" );
							}

							// next month/year on alt +left on Mac
							break;
					case 38: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, -7, "D" );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // -1 week on ctrl or command +up
					case 39: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, ( isRTL ? -1 : +1 ), "D" );
							}
							handled = event.ctrlKey || event.metaKey;

							// +1 day on ctrl or command +right
							if ( event.originalEvent.altKey ) {
								$.datepicker._adjustDate( event.target, ( event.ctrlKey ?
									+$.datepicker._get( inst, "stepBigMonths" ) :
									+$.datepicker._get( inst, "stepMonths" ) ), "M" );
							}

							// next month/year on alt +right
							break;
					case 40: if ( event.ctrlKey || event.metaKey ) {
								$.datepicker._adjustDate( event.target, +7, "D" );
							}
							handled = event.ctrlKey || event.metaKey;
							break; // +1 week on ctrl or command +down
					default: handled = false;
				}
			} else if ( event.keyCode === 36 && event.ctrlKey ) { // display the date picker on ctrl+home
				$.datepicker._showDatepicker( this );
			} else {
				handled = false;
			}

			if ( handled ) {
				event.preventDefault();
				event.stopPropagation();
			}
		},

		/* Filter entered characters - based on date format. */
		_doKeyPress: function( event ) {
			var chars, chr,
				inst = $.datepicker._getInst( event.target );

			if ( $.datepicker._get( inst, "constrainInput" ) ) {
				chars = $.datepicker._possibleChars( $.datepicker._get( inst, "dateFormat" ) );
				chr = String.fromCharCode( event.charCode == null ? event.keyCode : event.charCode );
				return event.ctrlKey || event.metaKey || ( chr < " " || !chars || chars.indexOf( chr ) > -1 );
			}
		},

		/* Synchronise manual entry and field/alternate field. */
		_doKeyUp: function( event ) {
			var date,
				inst = $.datepicker._getInst( event.target );

			if ( inst.input.val() !== inst.lastVal ) {
				try {
					date = $.datepicker.parseDate( $.datepicker._get( inst, "dateFormat" ),
						( inst.input ? inst.input.val() : null ),
						$.datepicker._getFormatConfig( inst ) );

					if ( date ) { // only if valid
						$.datepicker._setDateFromField( inst );
						$.datepicker._updateAlternate( inst );
						$.datepicker._updateDatepicker( inst );
					}
				}
				catch ( err ) {
				}
			}
			return true;
		},

		/* Pop-up the date picker for a given input field.
		 * If false returned from beforeShow event handler do not show.
		 * @param  input  element - the input field attached to the date picker or
		 *					event - if triggered by focus
		 */
		_showDatepicker: function( input ) {
			input = input.target || input;
			if ( input.nodeName.toLowerCase() !== "input" ) { // find from button/image trigger
				input = $( "input", input.parentNode )[ 0 ];
			}

			if ( $.datepicker._isDisabledDatepicker( input ) || $.datepicker._lastInput === input ) { // already here
				return;
			}

			var inst, beforeShow, beforeShowSettings, isFixed,
				offset, showAnim, duration;

			inst = $.datepicker._getInst( input );
			if ( $.datepicker._curInst && $.datepicker._curInst !== inst ) {
				$.datepicker._curInst.dpDiv.stop( true, true );
				if ( inst && $.datepicker._datepickerShowing ) {
					$.datepicker._hideDatepicker( $.datepicker._curInst.input[ 0 ] );
				}
			}

			beforeShow = $.datepicker._get( inst, "beforeShow" );
			beforeShowSettings = beforeShow ? beforeShow.apply( input, [ input, inst ] ) : {};
			if ( beforeShowSettings === false ) {
				return;
			}
			datepicker_extendRemove( inst.settings, beforeShowSettings );

			inst.lastVal = null;
			$.datepicker._lastInput = input;
			$.datepicker._setDateFromField( inst );

			if ( $.datepicker._inDialog ) { // hide cursor
				input.value = "";
			}
			if ( !$.datepicker._pos ) { // position below input
				$.datepicker._pos = $.datepicker._findPos( input );
				$.datepicker._pos[ 1 ] += input.offsetHeight; // add the height
			}

			isFixed = false;
			$( input ).parents().each( function() {
				isFixed |= $( this ).css( "position" ) === "fixed";
				return !isFixed;
			} );

			offset = { left: $.datepicker._pos[ 0 ], top: $.datepicker._pos[ 1 ] };
			$.datepicker._pos = null;

			//to avoid flashes on Firefox
			inst.dpDiv.empty();

			// determine sizing offscreen
			inst.dpDiv.css( { position: "absolute", display: "block", top: "-1000px" } );
			$.datepicker._updateDatepicker( inst );

			// fix width for dynamic number of date pickers
			// and adjust position before showing
			offset = $.datepicker._checkOffset( inst, offset, isFixed );
			inst.dpDiv.css( { position: ( $.datepicker._inDialog && $.blockUI ?
				"static" : ( isFixed ? "fixed" : "absolute" ) ), display: "none",
				left: offset.left + "px", top: offset.top + "px" } );

			if ( !inst.inline ) {
				showAnim = $.datepicker._get( inst, "showAnim" );
				duration = $.datepicker._get( inst, "duration" );
				inst.dpDiv.css( "z-index", datepicker_getZindex( $( input ) ) + 1 );
				$.datepicker._datepickerShowing = true;

				if ( $.effects && $.effects.effect[ showAnim ] ) {
					inst.dpDiv.show( showAnim, $.datepicker._get( inst, "showOptions" ), duration );
				} else {
					inst.dpDiv[ showAnim || "show" ]( showAnim ? duration : null );
				}

				if ( $.datepicker._shouldFocusInput( inst ) ) {
					inst.input.trigger( "focus" );
				}

				$.datepicker._curInst = inst;
			}
		},

		/* Generate the date picker content. */
		_updateDatepicker: function( inst ) {
			this.maxRows = 4; //Reset the max number of rows being displayed (see #7043)
			datepicker_instActive = inst; // for delegate hover events
			inst.dpDiv.empty().append( this._generateHTML( inst ) );
			this._attachHandlers( inst );

			var origyearshtml,
				numMonths = this._getNumberOfMonths( inst ),
				cols = numMonths[ 1 ],
				width = 17,
				activeCell = inst.dpDiv.find( "." + this._dayOverClass + " a" );

			if ( activeCell.length > 0 ) {
				datepicker_handleMouseover.apply( activeCell.get( 0 ) );
			}

			inst.dpDiv.removeClass( "ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4" ).width( "" );
			if ( cols > 1 ) {
				inst.dpDiv.addClass( "ui-datepicker-multi-" + cols ).css( "width", ( width * cols ) + "em" );
			}
			inst.dpDiv[ ( numMonths[ 0 ] !== 1 || numMonths[ 1 ] !== 1 ? "add" : "remove" ) +
				"Class" ]( "ui-datepicker-multi" );
			inst.dpDiv[ ( this._get( inst, "isRTL" ) ? "add" : "remove" ) +
				"Class" ]( "ui-datepicker-rtl" );

			if ( inst === $.datepicker._curInst && $.datepicker._datepickerShowing && $.datepicker._shouldFocusInput( inst ) ) {
				inst.input.trigger( "focus" );
			}

			// Deffered render of the years select (to avoid flashes on Firefox)
			if ( inst.yearshtml ) {
				origyearshtml = inst.yearshtml;
				setTimeout( function() {

					//assure that inst.yearshtml didn't change.
					if ( origyearshtml === inst.yearshtml && inst.yearshtml ) {
						inst.dpDiv.find( "select.ui-datepicker-year:first" ).replaceWith( inst.yearshtml );
					}
					origyearshtml = inst.yearshtml = null;
				}, 0 );
			}
		},

		// #6694 - don't focus the input if it's already focused
		// this breaks the change event in IE
		// Support: IE and jQuery <1.9
		_shouldFocusInput: function( inst ) {
			return inst.input && inst.input.is( ":visible" ) && !inst.input.is( ":disabled" ) && !inst.input.is( ":focus" );
		},

		/* Check positioning to remain on screen. */
		_checkOffset: function( inst, offset, isFixed ) {
			var dpWidth = inst.dpDiv.outerWidth(),
				dpHeight = inst.dpDiv.outerHeight(),
				inputWidth = inst.input ? inst.input.outerWidth() : 0,
				inputHeight = inst.input ? inst.input.outerHeight() : 0,
				viewWidth = document.documentElement.clientWidth + ( isFixed ? 0 : $( document ).scrollLeft() ),
				viewHeight = document.documentElement.clientHeight + ( isFixed ? 0 : $( document ).scrollTop() );

			offset.left -= ( this._get( inst, "isRTL" ) ? ( dpWidth - inputWidth ) : 0 );
			offset.left -= ( isFixed && offset.left === inst.input.offset().left ) ? $( document ).scrollLeft() : 0;
			offset.top -= ( isFixed && offset.top === ( inst.input.offset().top + inputHeight ) ) ? $( document ).scrollTop() : 0;

			// Now check if datepicker is showing outside window viewport - move to a better place if so.
			offset.left -= Math.min( offset.left, ( offset.left + dpWidth > viewWidth && viewWidth > dpWidth ) ?
				Math.abs( offset.left + dpWidth - viewWidth ) : 0 );
			offset.top -= Math.min( offset.top, ( offset.top + dpHeight > viewHeight && viewHeight > dpHeight ) ?
				Math.abs( dpHeight + inputHeight ) : 0 );

			return offset;
		},

		/* Find an object's position on the screen. */
		_findPos: function( obj ) {
			var position,
				inst = this._getInst( obj ),
				isRTL = this._get( inst, "isRTL" );

			while ( obj && ( obj.type === "hidden" || obj.nodeType !== 1 || $.expr.filters.hidden( obj ) ) ) {
				obj = obj[ isRTL ? "previousSibling" : "nextSibling" ];
			}

			position = $( obj ).offset();
			return [ position.left, position.top ];
		},

		/* Hide the date picker from view.
		 * @param  input  element - the input field attached to the date picker
		 */
		_hideDatepicker: function( input ) {
			var showAnim, duration, postProcess, onClose,
				inst = this._curInst;

			if ( !inst || ( input && inst !== $.data( input, "datepicker" ) ) ) {
				return;
			}

			if ( this._datepickerShowing ) {
				showAnim = this._get( inst, "showAnim" );
				duration = this._get( inst, "duration" );
				postProcess = function() {
					$.datepicker._tidyDialog( inst );
				};

				// DEPRECATED: after BC for 1.8.x $.effects[ showAnim ] is not needed
				if ( $.effects && ( $.effects.effect[ showAnim ] || $.effects[ showAnim ] ) ) {
					inst.dpDiv.hide( showAnim, $.datepicker._get( inst, "showOptions" ), duration, postProcess );
				} else {
					inst.dpDiv[ ( showAnim === "slideDown" ? "slideUp" :
						( showAnim === "fadeIn" ? "fadeOut" : "hide" ) ) ]( ( showAnim ? duration : null ), postProcess );
				}

				if ( !showAnim ) {
					postProcess();
				}
				this._datepickerShowing = false;

				onClose = this._get( inst, "onClose" );
				if ( onClose ) {
					onClose.apply( ( inst.input ? inst.input[ 0 ] : null ), [ ( inst.input ? inst.input.val() : "" ), inst ] );
				}

				this._lastInput = null;
				if ( this._inDialog ) {
					this._dialogInput.css( { position: "absolute", left: "0", top: "-100px" } );
					if ( $.blockUI ) {
						$.unblockUI();
						$( "body" ).append( this.dpDiv );
					}
				}
				this._inDialog = false;
			}
		},

		/* Tidy up after a dialog display. */
		_tidyDialog: function( inst ) {
			inst.dpDiv.removeClass( this._dialogClass ).off( ".ui-datepicker-calendar" );
		},

		/* Close date picker if clicked elsewhere. */
		_checkExternalClick: function( event ) {
			if ( !$.datepicker._curInst ) {
				return;
			}

			var $target = $( event.target ),
				inst = $.datepicker._getInst( $target[ 0 ] );

			if ( ( ( $target[ 0 ].id !== $.datepicker._mainDivId &&
					$target.parents( "#" + $.datepicker._mainDivId ).length === 0 &&
					!$target.hasClass( $.datepicker.markerClassName ) &&
					!$target.closest( "." + $.datepicker._triggerClass ).length &&
					$.datepicker._datepickerShowing && !( $.datepicker._inDialog && $.blockUI ) ) ) ||
				( $target.hasClass( $.datepicker.markerClassName ) && $.datepicker._curInst !== inst ) ) {
					$.datepicker._hideDatepicker();
			}
		},

		/* Adjust one of the date sub-fields. */
		_adjustDate: function( id, offset, period ) {
			var target = $( id ),
				inst = this._getInst( target[ 0 ] );

			if ( this._isDisabledDatepicker( target[ 0 ] ) ) {
				return;
			}
			this._adjustInstDate( inst, offset +
				( period === "M" ? this._get( inst, "showCurrentAtPos" ) : 0 ), // undo positioning
				period );
			this._updateDatepicker( inst );
		},

		/* Action for current link. */
		_gotoToday: function( id ) {
			var date,
				target = $( id ),
				inst = this._getInst( target[ 0 ] );

			if ( this._get( inst, "gotoCurrent" ) && inst.currentDay ) {
				inst.selectedDay = inst.currentDay;
				inst.drawMonth = inst.selectedMonth = inst.currentMonth;
				inst.drawYear = inst.selectedYear = inst.currentYear;
			} else {
				date = new Date();
				inst.selectedDay = date.getDate();
				inst.drawMonth = inst.selectedMonth = date.getMonth();
				inst.drawYear = inst.selectedYear = date.getFullYear();
			}
			this._notifyChange( inst );
			this._adjustDate( target );
		},

		/* Action for selecting a new month/year. */
		_selectMonthYear: function( id, select, period ) {
			var target = $( id ),
				inst = this._getInst( target[ 0 ] );

			inst[ "selected" + ( period === "M" ? "Month" : "Year" ) ] =
			inst[ "draw" + ( period === "M" ? "Month" : "Year" ) ] =
				parseInt( select.options[ select.selectedIndex ].value, 10 );

			this._notifyChange( inst );
			this._adjustDate( target );
		},

		/* Action for selecting a day. */
		_selectDay: function( id, month, year, td ) {
			var inst,
				target = $( id );

			if ( $( td ).hasClass( this._unselectableClass ) || this._isDisabledDatepicker( target[ 0 ] ) ) {
				return;
			}

			inst = this._getInst( target[ 0 ] );
			inst.selectedDay = inst.currentDay = $( "a", td ).html();
			inst.selectedMonth = inst.currentMonth = month;
			inst.selectedYear = inst.currentYear = year;
			this._selectDate( id, this._formatDate( inst,
				inst.currentDay, inst.currentMonth, inst.currentYear ) );
		},

		/* Erase the input field and hide the date picker. */
		_clearDate: function( id ) {
			var target = $( id );
			this._selectDate( target, "" );
		},

		/* Update the input field with the selected date. */
		_selectDate: function( id, dateStr ) {
			var onSelect,
				target = $( id ),
				inst = this._getInst( target[ 0 ] );

			dateStr = ( dateStr != null ? dateStr : this._formatDate( inst ) );
			if ( inst.input ) {
				inst.input.val( dateStr );
			}
			this._updateAlternate( inst );

			onSelect = this._get( inst, "onSelect" );
			if ( onSelect ) {
				onSelect.apply( ( inst.input ? inst.input[ 0 ] : null ), [ dateStr, inst ] );  // trigger custom callback
			} else if ( inst.input ) {
				inst.input.trigger( "change" ); // fire the change event
			}

			if ( inst.inline ) {
				this._updateDatepicker( inst );
			} else {
				this._hideDatepicker();
				this._lastInput = inst.input[ 0 ];
				if ( typeof( inst.input[ 0 ] ) !== "object" ) {
					inst.input.trigger( "focus" ); // restore focus
				}
				this._lastInput = null;
			}
		},

		/* Update any alternate field to synchronise with the main field. */
		_updateAlternate: function( inst ) {
			var altFormat, date, dateStr,
				altField = this._get( inst, "altField" );

			if ( altField ) { // update alternate field too
				altFormat = this._get( inst, "altFormat" ) || this._get( inst, "dateFormat" );
				date = this._getDate( inst );
				dateStr = this.formatDate( altFormat, date, this._getFormatConfig( inst ) );
				$( altField ).val( dateStr );
			}
		},

		/* Set as beforeShowDay function to prevent selection of weekends.
		 * @param  date  Date - the date to customise
		 * @return [boolean, string] - is this date selectable?, what is its CSS class?
		 */
		noWeekends: function( date ) {
			var day = date.getDay();
			return [ ( day > 0 && day < 6 ), "" ];
		},

		/* Set as calculateWeek to determine the week of the year based on the ISO 8601 definition.
		 * @param  date  Date - the date to get the week for
		 * @return  number - the number of the week within the year that contains this date
		 */
		iso8601Week: function( date ) {
			var time,
				checkDate = new Date( date.getTime() );

			// Find Thursday of this week starting on Monday
			checkDate.setDate( checkDate.getDate() + 4 - ( checkDate.getDay() || 7 ) );

			time = checkDate.getTime();
			checkDate.setMonth( 0 ); // Compare with Jan 1
			checkDate.setDate( 1 );
			return Math.floor( Math.round( ( time - checkDate ) / 86400000 ) / 7 ) + 1;
		},

		/* Parse a string value into a date object.
		 * See formatDate below for the possible formats.
		 *
		 * @param  format string - the expected format of the date
		 * @param  value string - the date in the above format
		 * @param  settings Object - attributes include:
		 *					shortYearCutoff  number - the cutoff year for determining the century (optional)
		 *					dayNamesShort	string[7] - abbreviated names of the days from Sunday (optional)
		 *					dayNames		string[7] - names of the days from Sunday (optional)
		 *					monthNamesShort string[12] - abbreviated names of the months (optional)
		 *					monthNames		string[12] - names of the months (optional)
		 * @return  Date - the extracted date value or null if value is blank
		 */
		parseDate: function( format, value, settings ) {
			if ( format == null || value == null ) {
				throw "Invalid arguments";
			}

			value = ( typeof value === "object" ? value.toString() : value + "" );
			if ( value === "" ) {
				return null;
			}

			var iFormat, dim, extra,
				iValue = 0,
				shortYearCutoffTemp = ( settings ? settings.shortYearCutoff : null ) || this._defaults.shortYearCutoff,
				shortYearCutoff = ( typeof shortYearCutoffTemp !== "string" ? shortYearCutoffTemp :
					new Date().getFullYear() % 100 + parseInt( shortYearCutoffTemp, 10 ) ),
				dayNamesShort = ( settings ? settings.dayNamesShort : null ) || this._defaults.dayNamesShort,
				dayNames = ( settings ? settings.dayNames : null ) || this._defaults.dayNames,
				monthNamesShort = ( settings ? settings.monthNamesShort : null ) || this._defaults.monthNamesShort,
				monthNames = ( settings ? settings.monthNames : null ) || this._defaults.monthNames,
				year = -1,
				month = -1,
				day = -1,
				doy = -1,
				literal = false,
				date,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				},

				// Extract a number from the string value
				getNumber = function( match ) {
					var isDoubled = lookAhead( match ),
						size = ( match === "@" ? 14 : ( match === "!" ? 20 :
						( match === "y" && isDoubled ? 4 : ( match === "o" ? 3 : 2 ) ) ) ),
						minSize = ( match === "y" ? size : 1 ),
						digits = new RegExp( "^\\d{" + minSize + "," + size + "}" ),
						num = value.substring( iValue ).match( digits );
					if ( !num ) {
						throw "Missing number at position " + iValue;
					}
					iValue += num[ 0 ].length;
					return parseInt( num[ 0 ], 10 );
				},

				// Extract a name from the string value and convert to an index
				getName = function( match, shortNames, longNames ) {
					var index = -1,
						names = $.map( lookAhead( match ) ? longNames : shortNames, function( v, k ) {
							return [ [ k, v ] ];
						} ).sort( function( a, b ) {
							return -( a[ 1 ].length - b[ 1 ].length );
						} );

					$.each( names, function( i, pair ) {
						var name = pair[ 1 ];
						if ( value.substr( iValue, name.length ).toLowerCase() === name.toLowerCase() ) {
							index = pair[ 0 ];
							iValue += name.length;
							return false;
						}
					} );
					if ( index !== -1 ) {
						return index + 1;
					} else {
						throw "Unknown name at position " + iValue;
					}
				},

				// Confirm that a literal character matches the string value
				checkLiteral = function() {
					if ( value.charAt( iValue ) !== format.charAt( iFormat ) ) {
						throw "Unexpected literal at position " + iValue;
					}
					iValue++;
				};

			for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
				if ( literal ) {
					if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
						literal = false;
					} else {
						checkLiteral();
					}
				} else {
					switch ( format.charAt( iFormat ) ) {
						case "d":
							day = getNumber( "d" );
							break;
						case "D":
							getName( "D", dayNamesShort, dayNames );
							break;
						case "o":
							doy = getNumber( "o" );
							break;
						case "m":
							month = getNumber( "m" );
							break;
						case "M":
							month = getName( "M", monthNamesShort, monthNames );
							break;
						case "y":
							year = getNumber( "y" );
							break;
						case "@":
							date = new Date( getNumber( "@" ) );
							year = date.getFullYear();
							month = date.getMonth() + 1;
							day = date.getDate();
							break;
						case "!":
							date = new Date( ( getNumber( "!" ) - this._ticksTo1970 ) / 10000 );
							year = date.getFullYear();
							month = date.getMonth() + 1;
							day = date.getDate();
							break;
						case "'":
							if ( lookAhead( "'" ) ) {
								checkLiteral();
							} else {
								literal = true;
							}
							break;
						default:
							checkLiteral();
					}
				}
			}

			if ( iValue < value.length ) {
				extra = value.substr( iValue );
				if ( !/^\s+/.test( extra ) ) {
					throw "Extra/unparsed characters found in date: " + extra;
				}
			}

			if ( year === -1 ) {
				year = new Date().getFullYear();
			} else if ( year < 100 ) {
				year += new Date().getFullYear() - new Date().getFullYear() % 100 +
					( year <= shortYearCutoff ? 0 : -100 );
			}

			if ( doy > -1 ) {
				month = 1;
				day = doy;
				do {
					dim = this._getDaysInMonth( year, month - 1 );
					if ( day <= dim ) {
						break;
					}
					month++;
					day -= dim;
				} while ( true );
			}

			date = this._daylightSavingAdjust( new Date( year, month - 1, day ) );
			if ( date.getFullYear() !== year || date.getMonth() + 1 !== month || date.getDate() !== day ) {
				throw "Invalid date"; // E.g. 31/02/00
			}
			return date;
		},

		/* Standard date formats. */
		ATOM: "yy-mm-dd", // RFC 3339 (ISO 8601)
		COOKIE: "D, dd M yy",
		ISO_8601: "yy-mm-dd",
		RFC_822: "D, d M y",
		RFC_850: "DD, dd-M-y",
		RFC_1036: "D, d M y",
		RFC_1123: "D, d M yy",
		RFC_2822: "D, d M yy",
		RSS: "D, d M y", // RFC 822
		TICKS: "!",
		TIMESTAMP: "@",
		W3C: "yy-mm-dd", // ISO 8601

		_ticksTo1970: ( ( ( 1970 - 1 ) * 365 + Math.floor( 1970 / 4 ) - Math.floor( 1970 / 100 ) +
			Math.floor( 1970 / 400 ) ) * 24 * 60 * 60 * 10000000 ),

		/* Format a date object into a string value.
		 * The format can be combinations of the following:
		 * d  - day of month (no leading zero)
		 * dd - day of month (two digit)
		 * o  - day of year (no leading zeros)
		 * oo - day of year (three digit)
		 * D  - day name short
		 * DD - day name long
		 * m  - month of year (no leading zero)
		 * mm - month of year (two digit)
		 * M  - month name short
		 * MM - month name long
		 * y  - year (two digit)
		 * yy - year (four digit)
		 * @ - Unix timestamp (ms since 01/01/1970)
		 * ! - Windows ticks (100ns since 01/01/0001)
		 * "..." - literal text
		 * '' - single quote
		 *
		 * @param  format string - the desired format of the date
		 * @param  date Date - the date value to format
		 * @param  settings Object - attributes include:
		 *					dayNamesShort	string[7] - abbreviated names of the days from Sunday (optional)
		 *					dayNames		string[7] - names of the days from Sunday (optional)
		 *					monthNamesShort string[12] - abbreviated names of the months (optional)
		 *					monthNames		string[12] - names of the months (optional)
		 * @return  string - the date in the above format
		 */
		formatDate: function( format, date, settings ) {
			if ( !date ) {
				return "";
			}

			var iFormat,
				dayNamesShort = ( settings ? settings.dayNamesShort : null ) || this._defaults.dayNamesShort,
				dayNames = ( settings ? settings.dayNames : null ) || this._defaults.dayNames,
				monthNamesShort = ( settings ? settings.monthNamesShort : null ) || this._defaults.monthNamesShort,
				monthNames = ( settings ? settings.monthNames : null ) || this._defaults.monthNames,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				},

				// Format a number, with leading zero if necessary
				formatNumber = function( match, value, len ) {
					var num = "" + value;
					if ( lookAhead( match ) ) {
						while ( num.length < len ) {
							num = "0" + num;
						}
					}
					return num;
				},

				// Format a name, short or long as requested
				formatName = function( match, value, shortNames, longNames ) {
					return ( lookAhead( match ) ? longNames[ value ] : shortNames[ value ] );
				},
				output = "",
				literal = false;

			if ( date ) {
				for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
					if ( literal ) {
						if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
							literal = false;
						} else {
							output += format.charAt( iFormat );
						}
					} else {
						switch ( format.charAt( iFormat ) ) {
							case "d":
								output += formatNumber( "d", date.getDate(), 2 );
								break;
							case "D":
								output += formatName( "D", date.getDay(), dayNamesShort, dayNames );
								break;
							case "o":
								output += formatNumber( "o",
									Math.round( ( new Date( date.getFullYear(), date.getMonth(), date.getDate() ).getTime() - new Date( date.getFullYear(), 0, 0 ).getTime() ) / 86400000 ), 3 );
								break;
							case "m":
								output += formatNumber( "m", date.getMonth() + 1, 2 );
								break;
							case "M":
								output += formatName( "M", date.getMonth(), monthNamesShort, monthNames );
								break;
							case "y":
								output += ( lookAhead( "y" ) ? date.getFullYear() :
									( date.getFullYear() % 100 < 10 ? "0" : "" ) + date.getFullYear() % 100 );
								break;
							case "@":
								output += date.getTime();
								break;
							case "!":
								output += date.getTime() * 10000 + this._ticksTo1970;
								break;
							case "'":
								if ( lookAhead( "'" ) ) {
									output += "'";
								} else {
									literal = true;
								}
								break;
							default:
								output += format.charAt( iFormat );
						}
					}
				}
			}
			return output;
		},

		/* Extract all possible characters from the date format. */
		_possibleChars: function( format ) {
			var iFormat,
				chars = "",
				literal = false,

				// Check whether a format character is doubled
				lookAhead = function( match ) {
					var matches = ( iFormat + 1 < format.length && format.charAt( iFormat + 1 ) === match );
					if ( matches ) {
						iFormat++;
					}
					return matches;
				};

			for ( iFormat = 0; iFormat < format.length; iFormat++ ) {
				if ( literal ) {
					if ( format.charAt( iFormat ) === "'" && !lookAhead( "'" ) ) {
						literal = false;
					} else {
						chars += format.charAt( iFormat );
					}
				} else {
					switch ( format.charAt( iFormat ) ) {
						case "d": case "m": case "y": case "@":
							chars += "0123456789";
							break;
						case "D": case "M":
							return null; // Accept anything
						case "'":
							if ( lookAhead( "'" ) ) {
								chars += "'";
							} else {
								literal = true;
							}
							break;
						default:
							chars += format.charAt( iFormat );
					}
				}
			}
			return chars;
		},

		/* Get a setting value, defaulting if necessary. */
		_get: function( inst, name ) {
			return inst.settings[ name ] !== undefined ?
				inst.settings[ name ] : this._defaults[ name ];
		},

		/* Parse existing date and initialise date picker. */
		_setDateFromField: function( inst, noDefault ) {
			if ( inst.input.val() === inst.lastVal ) {
				return;
			}

			var dateFormat = this._get( inst, "dateFormat" ),
				dates = inst.lastVal = inst.input ? inst.input.val() : null,
				defaultDate = this._getDefaultDate( inst ),
				date = defaultDate,
				settings = this._getFormatConfig( inst );

			try {
				date = this.parseDate( dateFormat, dates, settings ) || defaultDate;
			} catch ( event ) {
				dates = ( noDefault ? "" : dates );
			}
			inst.selectedDay = date.getDate();
			inst.drawMonth = inst.selectedMonth = date.getMonth();
			inst.drawYear = inst.selectedYear = date.getFullYear();
			inst.currentDay = ( dates ? date.getDate() : 0 );
			inst.currentMonth = ( dates ? date.getMonth() : 0 );
			inst.currentYear = ( dates ? date.getFullYear() : 0 );
			this._adjustInstDate( inst );
		},

		/* Retrieve the default date shown on opening. */
		_getDefaultDate: function( inst ) {
			return this._restrictMinMax( inst,
				this._determineDate( inst, this._get( inst, "defaultDate" ), new Date() ) );
		},

		/* A date may be specified as an exact value or a relative one. */
		_determineDate: function( inst, date, defaultDate ) {
			var offsetNumeric = function( offset ) {
					var date = new Date();
					date.setDate( date.getDate() + offset );
					return date;
				},
				offsetString = function( offset ) {
					try {
						return $.datepicker.parseDate( $.datepicker._get( inst, "dateFormat" ),
							offset, $.datepicker._getFormatConfig( inst ) );
					}
					catch ( e ) {

						// Ignore
					}

					var date = ( offset.toLowerCase().match( /^c/ ) ?
						$.datepicker._getDate( inst ) : null ) || new Date(),
						year = date.getFullYear(),
						month = date.getMonth(),
						day = date.getDate(),
						pattern = /([+\-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,
						matches = pattern.exec( offset );

					while ( matches ) {
						switch ( matches[ 2 ] || "d" ) {
							case "d" : case "D" :
								day += parseInt( matches[ 1 ], 10 ); break;
							case "w" : case "W" :
								day += parseInt( matches[ 1 ], 10 ) * 7; break;
							case "m" : case "M" :
								month += parseInt( matches[ 1 ], 10 );
								day = Math.min( day, $.datepicker._getDaysInMonth( year, month ) );
								break;
							case "y": case "Y" :
								year += parseInt( matches[ 1 ], 10 );
								day = Math.min( day, $.datepicker._getDaysInMonth( year, month ) );
								break;
						}
						matches = pattern.exec( offset );
					}
					return new Date( year, month, day );
				},
				newDate = ( date == null || date === "" ? defaultDate : ( typeof date === "string" ? offsetString( date ) :
					( typeof date === "number" ? ( isNaN( date ) ? defaultDate : offsetNumeric( date ) ) : new Date( date.getTime() ) ) ) );

			newDate = ( newDate && newDate.toString() === "Invalid Date" ? defaultDate : newDate );
			if ( newDate ) {
				newDate.setHours( 0 );
				newDate.setMinutes( 0 );
				newDate.setSeconds( 0 );
				newDate.setMilliseconds( 0 );
			}
			return this._daylightSavingAdjust( newDate );
		},

		/* Handle switch to/from daylight saving.
		 * Hours may be non-zero on daylight saving cut-over:
		 * > 12 when midnight changeover, but then cannot generate
		 * midnight datetime, so jump to 1AM, otherwise reset.
		 * @param  date  (Date) the date to check
		 * @return  (Date) the corrected date
		 */
		_daylightSavingAdjust: function( date ) {
			if ( !date ) {
				return null;
			}
			date.setHours( date.getHours() > 12 ? date.getHours() + 2 : 0 );
			return date;
		},

		/* Set the date(s) directly. */
		_setDate: function( inst, date, noChange ) {
			var clear = !date,
				origMonth = inst.selectedMonth,
				origYear = inst.selectedYear,
				newDate = this._restrictMinMax( inst, this._determineDate( inst, date, new Date() ) );

			inst.selectedDay = inst.currentDay = newDate.getDate();
			inst.drawMonth = inst.selectedMonth = inst.currentMonth = newDate.getMonth();
			inst.drawYear = inst.selectedYear = inst.currentYear = newDate.getFullYear();
			if ( ( origMonth !== inst.selectedMonth || origYear !== inst.selectedYear ) && !noChange ) {
				this._notifyChange( inst );
			}
			this._adjustInstDate( inst );
			if ( inst.input ) {
				inst.input.val( clear ? "" : this._formatDate( inst ) );
			}
		},

		/* Retrieve the date(s) directly. */
		_getDate: function( inst ) {
			var startDate = ( !inst.currentYear || ( inst.input && inst.input.val() === "" ) ? null :
				this._daylightSavingAdjust( new Date(
				inst.currentYear, inst.currentMonth, inst.currentDay ) ) );
				return startDate;
		},

		/* Attach the onxxx handlers.  These are declared statically so
		 * they work with static code transformers like Caja.
		 */
		_attachHandlers: function( inst ) {
			var stepMonths = this._get( inst, "stepMonths" ),
				id = "#" + inst.id.replace( /\\\\/g, "\\" );
			inst.dpDiv.find( "[data-handler]" ).map( function() {
				var handler = {
					prev: function() {
						$.datepicker._adjustDate( id, -stepMonths, "M" );
					},
					next: function() {
						$.datepicker._adjustDate( id, +stepMonths, "M" );
					},
					hide: function() {
						$.datepicker._hideDatepicker();
					},
					today: function() {
						$.datepicker._gotoToday( id );
					},
					selectDay: function() {
						$.datepicker._selectDay( id, +this.getAttribute( "data-month" ), +this.getAttribute( "data-year" ), this );
						return false;
					},
					selectMonth: function() {
						$.datepicker._selectMonthYear( id, this, "M" );
						return false;
					},
					selectYear: function() {
						$.datepicker._selectMonthYear( id, this, "Y" );
						return false;
					}
				};
				$( this ).on( this.getAttribute( "data-event" ), handler[ this.getAttribute( "data-handler" ) ] );
			} );
		},

		/* Generate the HTML for the current state of the date picker. */
		_generateHTML: function( inst ) {
			var maxDraw, prevText, prev, nextText, next, currentText, gotoDate,
				controls, buttonPanel, firstDay, showWeek, dayNames, dayNamesMin,
				monthNames, monthNamesShort, beforeShowDay, showOtherMonths,
				selectOtherMonths, defaultDate, html, dow, row, group, col, selectedDate,
				cornerClass, calender, thead, day, daysInMonth, leadDays, curRows, numRows,
				printDate, dRow, tbody, daySettings, otherMonth, unselectable,
				tempDate = new Date(),
				today = this._daylightSavingAdjust(
					new Date( tempDate.getFullYear(), tempDate.getMonth(), tempDate.getDate() ) ), // clear time
				isRTL = this._get( inst, "isRTL" ),
				showButtonPanel = this._get( inst, "showButtonPanel" ),
				hideIfNoPrevNext = this._get( inst, "hideIfNoPrevNext" ),
				navigationAsDateFormat = this._get( inst, "navigationAsDateFormat" ),
				numMonths = this._getNumberOfMonths( inst ),
				showCurrentAtPos = this._get( inst, "showCurrentAtPos" ),
				stepMonths = this._get( inst, "stepMonths" ),
				isMultiMonth = ( numMonths[ 0 ] !== 1 || numMonths[ 1 ] !== 1 ),
				currentDate = this._daylightSavingAdjust( ( !inst.currentDay ? new Date( 9999, 9, 9 ) :
					new Date( inst.currentYear, inst.currentMonth, inst.currentDay ) ) ),
				minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				drawMonth = inst.drawMonth - showCurrentAtPos,
				drawYear = inst.drawYear;

			if ( drawMonth < 0 ) {
				drawMonth += 12;
				drawYear--;
			}
			if ( maxDate ) {
				maxDraw = this._daylightSavingAdjust( new Date( maxDate.getFullYear(),
					maxDate.getMonth() - ( numMonths[ 0 ] * numMonths[ 1 ] ) + 1, maxDate.getDate() ) );
				maxDraw = ( minDate && maxDraw < minDate ? minDate : maxDraw );
				while ( this._daylightSavingAdjust( new Date( drawYear, drawMonth, 1 ) ) > maxDraw ) {
					drawMonth--;
					if ( drawMonth < 0 ) {
						drawMonth = 11;
						drawYear--;
					}
				}
			}
			inst.drawMonth = drawMonth;
			inst.drawYear = drawYear;

			prevText = this._get( inst, "prevText" );
			prevText = ( !navigationAsDateFormat ? prevText : this.formatDate( prevText,
				this._daylightSavingAdjust( new Date( drawYear, drawMonth - stepMonths, 1 ) ),
				this._getFormatConfig( inst ) ) );

			prev = ( this._canAdjustMonth( inst, -1, drawYear, drawMonth ) ?
				"<a class='ui-datepicker-prev ui-corner-all' data-handler='prev' data-event='click'" +
				" title='" + prevText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "e" : "w" ) + "'>" + prevText + "</span></a>" :
				( hideIfNoPrevNext ? "" : "<a class='ui-datepicker-prev ui-corner-all ui-state-disabled' title='" + prevText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "e" : "w" ) + "'>" + prevText + "</span></a>" ) );

			nextText = this._get( inst, "nextText" );
			nextText = ( !navigationAsDateFormat ? nextText : this.formatDate( nextText,
				this._daylightSavingAdjust( new Date( drawYear, drawMonth + stepMonths, 1 ) ),
				this._getFormatConfig( inst ) ) );

			next = ( this._canAdjustMonth( inst, +1, drawYear, drawMonth ) ?
				"<a class='ui-datepicker-next ui-corner-all' data-handler='next' data-event='click'" +
				" title='" + nextText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "w" : "e" ) + "'>" + nextText + "</span></a>" :
				( hideIfNoPrevNext ? "" : "<a class='ui-datepicker-next ui-corner-all ui-state-disabled' title='" + nextText + "'><span class='ui-icon ui-icon-circle-triangle-" + ( isRTL ? "w" : "e" ) + "'>" + nextText + "</span></a>" ) );

			currentText = this._get( inst, "currentText" );
			gotoDate = ( this._get( inst, "gotoCurrent" ) && inst.currentDay ? currentDate : today );
			currentText = ( !navigationAsDateFormat ? currentText :
				this.formatDate( currentText, gotoDate, this._getFormatConfig( inst ) ) );

			controls = ( !inst.inline ? "<button type='button' class='ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all' data-handler='hide' data-event='click'>" +
				this._get( inst, "closeText" ) + "</button>" : "" );

			buttonPanel = ( showButtonPanel ) ? "<div class='ui-datepicker-buttonpane ui-widget-content'>" + ( isRTL ? controls : "" ) +
				( this._isInRange( inst, gotoDate ) ? "<button type='button' class='ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all' data-handler='today' data-event='click'" +
				">" + currentText + "</button>" : "" ) + ( isRTL ? "" : controls ) + "</div>" : "";

			firstDay = parseInt( this._get( inst, "firstDay" ), 10 );
			firstDay = ( isNaN( firstDay ) ? 0 : firstDay );

			showWeek = this._get( inst, "showWeek" );
			dayNames = this._get( inst, "dayNames" );
			dayNamesMin = this._get( inst, "dayNamesMin" );
			monthNames = this._get( inst, "monthNames" );
			monthNamesShort = this._get( inst, "monthNamesShort" );
			beforeShowDay = this._get( inst, "beforeShowDay" );
			showOtherMonths = this._get( inst, "showOtherMonths" );
			selectOtherMonths = this._get( inst, "selectOtherMonths" );
			defaultDate = this._getDefaultDate( inst );
			html = "";

			for ( row = 0; row < numMonths[ 0 ]; row++ ) {
				group = "";
				this.maxRows = 4;
				for ( col = 0; col < numMonths[ 1 ]; col++ ) {
					selectedDate = this._daylightSavingAdjust( new Date( drawYear, drawMonth, inst.selectedDay ) );
					cornerClass = " ui-corner-all";
					calender = "";
					if ( isMultiMonth ) {
						calender += "<div class='ui-datepicker-group";
						if ( numMonths[ 1 ] > 1 ) {
							switch ( col ) {
								case 0: calender += " ui-datepicker-group-first";
									cornerClass = " ui-corner-" + ( isRTL ? "right" : "left" ); break;
								case numMonths[ 1 ] - 1: calender += " ui-datepicker-group-last";
									cornerClass = " ui-corner-" + ( isRTL ? "left" : "right" ); break;
								default: calender += " ui-datepicker-group-middle"; cornerClass = ""; break;
							}
						}
						calender += "'>";
					}
					calender += "<div class='ui-datepicker-header ui-widget-header ui-helper-clearfix" + cornerClass + "'>" +
						( /all|left/.test( cornerClass ) && row === 0 ? ( isRTL ? next : prev ) : "" ) +
						( /all|right/.test( cornerClass ) && row === 0 ? ( isRTL ? prev : next ) : "" ) +
						this._generateMonthYearHeader( inst, drawMonth, drawYear, minDate, maxDate,
						row > 0 || col > 0, monthNames, monthNamesShort ) + // draw month headers
						"</div><table class='ui-datepicker-calendar'><thead>" +
						"<tr>";
					thead = ( showWeek ? "<th class='ui-datepicker-week-col'>" + this._get( inst, "weekHeader" ) + "</th>" : "" );
					for ( dow = 0; dow < 7; dow++ ) { // days of the week
						day = ( dow + firstDay ) % 7;
						thead += "<th scope='col'" + ( ( dow + firstDay + 6 ) % 7 >= 5 ? " class='ui-datepicker-week-end'" : "" ) + ">" +
							"<span title='" + dayNames[ day ] + "'>" + dayNamesMin[ day ] + "</span></th>";
					}
					calender += thead + "</tr></thead><tbody>";
					daysInMonth = this._getDaysInMonth( drawYear, drawMonth );
					if ( drawYear === inst.selectedYear && drawMonth === inst.selectedMonth ) {
						inst.selectedDay = Math.min( inst.selectedDay, daysInMonth );
					}
					leadDays = ( this._getFirstDayOfMonth( drawYear, drawMonth ) - firstDay + 7 ) % 7;
					curRows = Math.ceil( ( leadDays + daysInMonth ) / 7 ); // calculate the number of rows to generate
					numRows = ( isMultiMonth ? this.maxRows > curRows ? this.maxRows : curRows : curRows ); //If multiple months, use the higher number of rows (see #7043)
					this.maxRows = numRows;
					printDate = this._daylightSavingAdjust( new Date( drawYear, drawMonth, 1 - leadDays ) );
					for ( dRow = 0; dRow < numRows; dRow++ ) { // create date picker rows
						calender += "<tr>";
						tbody = ( !showWeek ? "" : "<td class='ui-datepicker-week-col'>" +
							this._get( inst, "calculateWeek" )( printDate ) + "</td>" );
						for ( dow = 0; dow < 7; dow++ ) { // create date picker days
							daySettings = ( beforeShowDay ?
								beforeShowDay.apply( ( inst.input ? inst.input[ 0 ] : null ), [ printDate ] ) : [ true, "" ] );
							otherMonth = ( printDate.getMonth() !== drawMonth );
							unselectable = ( otherMonth && !selectOtherMonths ) || !daySettings[ 0 ] ||
								( minDate && printDate < minDate ) || ( maxDate && printDate > maxDate );
							tbody += "<td class='" +
								( ( dow + firstDay + 6 ) % 7 >= 5 ? " ui-datepicker-week-end" : "" ) + // highlight weekends
								( otherMonth ? " ui-datepicker-other-month" : "" ) + // highlight days from other months
								( ( printDate.getTime() === selectedDate.getTime() && drawMonth === inst.selectedMonth && inst._keyEvent ) || // user pressed key
								( defaultDate.getTime() === printDate.getTime() && defaultDate.getTime() === selectedDate.getTime() ) ?

								// or defaultDate is current printedDate and defaultDate is selectedDate
								" " + this._dayOverClass : "" ) + // highlight selected day
								( unselectable ? " " + this._unselectableClass + " ui-state-disabled" : "" ) +  // highlight unselectable days
								( otherMonth && !showOtherMonths ? "" : " " + daySettings[ 1 ] + // highlight custom dates
								( printDate.getTime() === currentDate.getTime() ? " " + this._currentClass : "" ) + // highlight selected day
								( printDate.getTime() === today.getTime() ? " ui-datepicker-today" : "" ) ) + "'" + // highlight today (if different)
								( ( !otherMonth || showOtherMonths ) && daySettings[ 2 ] ? " title='" + daySettings[ 2 ].replace( /'/g, "&#39;" ) + "'" : "" ) + // cell title
								( unselectable ? "" : " data-handler='selectDay' data-event='click' data-month='" + printDate.getMonth() + "' data-year='" + printDate.getFullYear() + "'" ) + ">" + // actions
								( otherMonth && !showOtherMonths ? "&#xa0;" : // display for other months
								( unselectable ? "<span class='ui-state-default'>" + printDate.getDate() + "</span>" : "<a class='ui-state-default" +
								( printDate.getTime() === today.getTime() ? " ui-state-highlight" : "" ) +
								( printDate.getTime() === currentDate.getTime() ? " ui-state-active" : "" ) + // highlight selected day
								( otherMonth ? " ui-priority-secondary" : "" ) + // distinguish dates from other months
								"' href='#'>" + printDate.getDate() + "</a>" ) ) + "</td>"; // display selectable date
							printDate.setDate( printDate.getDate() + 1 );
							printDate = this._daylightSavingAdjust( printDate );
						}
						calender += tbody + "</tr>";
					}
					drawMonth++;
					if ( drawMonth > 11 ) {
						drawMonth = 0;
						drawYear++;
					}
					calender += "</tbody></table>" + ( isMultiMonth ? "</div>" +
								( ( numMonths[ 0 ] > 0 && col === numMonths[ 1 ] - 1 ) ? "<div class='ui-datepicker-row-break'></div>" : "" ) : "" );
					group += calender;
				}
				html += group;
			}
			html += buttonPanel;
			inst._keyEvent = false;
			return html;
		},

		/* Generate the month and year header. */
		_generateMonthYearHeader: function( inst, drawMonth, drawYear, minDate, maxDate,
				secondary, monthNames, monthNamesShort ) {

			var inMinYear, inMaxYear, month, years, thisYear, determineYear, year, endYear,
				changeMonth = this._get( inst, "changeMonth" ),
				changeYear = this._get( inst, "changeYear" ),
				showMonthAfterYear = this._get( inst, "showMonthAfterYear" ),
				html = "<div class='ui-datepicker-title'>",
				monthHtml = "";

			// Month selection
			if ( secondary || !changeMonth ) {
				monthHtml += "<span class='ui-datepicker-month'>" + monthNames[ drawMonth ] + "</span>";
			} else {
				inMinYear = ( minDate && minDate.getFullYear() === drawYear );
				inMaxYear = ( maxDate && maxDate.getFullYear() === drawYear );
				monthHtml += "<select class='ui-datepicker-month' data-handler='selectMonth' data-event='change'>";
				for ( month = 0; month < 12; month++ ) {
					if ( ( !inMinYear || month >= minDate.getMonth() ) && ( !inMaxYear || month <= maxDate.getMonth() ) ) {
						monthHtml += "<option value='" + month + "'" +
							( month === drawMonth ? " selected='selected'" : "" ) +
							">" + monthNamesShort[ month ] + "</option>";
					}
				}
				monthHtml += "</select>";
			}

			if ( !showMonthAfterYear ) {
				html += monthHtml + ( secondary || !( changeMonth && changeYear ) ? "&#xa0;" : "" );
			}

			// Year selection
			if ( !inst.yearshtml ) {
				inst.yearshtml = "";
				if ( secondary || !changeYear ) {
					html += "<span class='ui-datepicker-year'>" + drawYear + "</span>";
				} else {

					// determine range of years to display
					years = this._get( inst, "yearRange" ).split( ":" );
					thisYear = new Date().getFullYear();
					determineYear = function( value ) {
						var year = ( value.match( /c[+\-].*/ ) ? drawYear + parseInt( value.substring( 1 ), 10 ) :
							( value.match( /[+\-].*/ ) ? thisYear + parseInt( value, 10 ) :
							parseInt( value, 10 ) ) );
						return ( isNaN( year ) ? thisYear : year );
					};
					year = determineYear( years[ 0 ] );
					endYear = Math.max( year, determineYear( years[ 1 ] || "" ) );
					year = ( minDate ? Math.max( year, minDate.getFullYear() ) : year );
					endYear = ( maxDate ? Math.min( endYear, maxDate.getFullYear() ) : endYear );
					inst.yearshtml += "<select class='ui-datepicker-year' data-handler='selectYear' data-event='change'>";
					for ( ; year <= endYear; year++ ) {
						inst.yearshtml += "<option value='" + year + "'" +
							( year === drawYear ? " selected='selected'" : "" ) +
							">" + year + "</option>";
					}
					inst.yearshtml += "</select>";

					html += inst.yearshtml;
					inst.yearshtml = null;
				}
			}

			html += this._get( inst, "yearSuffix" );
			if ( showMonthAfterYear ) {
				html += ( secondary || !( changeMonth && changeYear ) ? "&#xa0;" : "" ) + monthHtml;
			}
			html += "</div>"; // Close datepicker_header
			return html;
		},

		/* Adjust one of the date sub-fields. */
		_adjustInstDate: function( inst, offset, period ) {
			var year = inst.selectedYear + ( period === "Y" ? offset : 0 ),
				month = inst.selectedMonth + ( period === "M" ? offset : 0 ),
				day = Math.min( inst.selectedDay, this._getDaysInMonth( year, month ) ) + ( period === "D" ? offset : 0 ),
				date = this._restrictMinMax( inst, this._daylightSavingAdjust( new Date( year, month, day ) ) );

			inst.selectedDay = date.getDate();
			inst.drawMonth = inst.selectedMonth = date.getMonth();
			inst.drawYear = inst.selectedYear = date.getFullYear();
			if ( period === "M" || period === "Y" ) {
				this._notifyChange( inst );
			}
		},

		/* Ensure a date is within any min/max bounds. */
		_restrictMinMax: function( inst, date ) {
			var minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				newDate = ( minDate && date < minDate ? minDate : date );
			return ( maxDate && newDate > maxDate ? maxDate : newDate );
		},

		/* Notify change of month/year. */
		_notifyChange: function( inst ) {
			var onChange = this._get( inst, "onChangeMonthYear" );
			if ( onChange ) {
				onChange.apply( ( inst.input ? inst.input[ 0 ] : null ),
					[ inst.selectedYear, inst.selectedMonth + 1, inst ] );
			}
		},

		/* Determine the number of months to show. */
		_getNumberOfMonths: function( inst ) {
			var numMonths = this._get( inst, "numberOfMonths" );
			return ( numMonths == null ? [ 1, 1 ] : ( typeof numMonths === "number" ? [ 1, numMonths ] : numMonths ) );
		},

		/* Determine the current maximum date - ensure no time components are set. */
		_getMinMaxDate: function( inst, minMax ) {
			return this._determineDate( inst, this._get( inst, minMax + "Date" ), null );
		},

		/* Find the number of days in a given month. */
		_getDaysInMonth: function( year, month ) {
			return 32 - this._daylightSavingAdjust( new Date( year, month, 32 ) ).getDate();
		},

		/* Find the day of the week of the first of a month. */
		_getFirstDayOfMonth: function( year, month ) {
			return new Date( year, month, 1 ).getDay();
		},

		/* Determines if we should allow a "next/prev" month display change. */
		_canAdjustMonth: function( inst, offset, curYear, curMonth ) {
			var numMonths = this._getNumberOfMonths( inst ),
				date = this._daylightSavingAdjust( new Date( curYear,
				curMonth + ( offset < 0 ? offset : numMonths[ 0 ] * numMonths[ 1 ] ), 1 ) );

			if ( offset < 0 ) {
				date.setDate( this._getDaysInMonth( date.getFullYear(), date.getMonth() ) );
			}
			return this._isInRange( inst, date );
		},

		/* Is the given date in the accepted range? */
		_isInRange: function( inst, date ) {
			var yearSplit, currentYear,
				minDate = this._getMinMaxDate( inst, "min" ),
				maxDate = this._getMinMaxDate( inst, "max" ),
				minYear = null,
				maxYear = null,
				years = this._get( inst, "yearRange" );
				if ( years ) {
					yearSplit = years.split( ":" );
					currentYear = new Date().getFullYear();
					minYear = parseInt( yearSplit[ 0 ], 10 );
					maxYear = parseInt( yearSplit[ 1 ], 10 );
					if ( yearSplit[ 0 ].match( /[+\-].*/ ) ) {
						minYear += currentYear;
					}
					if ( yearSplit[ 1 ].match( /[+\-].*/ ) ) {
						maxYear += currentYear;
					}
				}

			return ( ( !minDate || date.getTime() >= minDate.getTime() ) &&
				( !maxDate || date.getTime() <= maxDate.getTime() ) &&
				( !minYear || date.getFullYear() >= minYear ) &&
				( !maxYear || date.getFullYear() <= maxYear ) );
		},

		/* Provide the configuration settings for formatting/parsing. */
		_getFormatConfig: function( inst ) {
			var shortYearCutoff = this._get( inst, "shortYearCutoff" );
			shortYearCutoff = ( typeof shortYearCutoff !== "string" ? shortYearCutoff :
				new Date().getFullYear() % 100 + parseInt( shortYearCutoff, 10 ) );
			return { shortYearCutoff: shortYearCutoff,
				dayNamesShort: this._get( inst, "dayNamesShort" ), dayNames: this._get( inst, "dayNames" ),
				monthNamesShort: this._get( inst, "monthNamesShort" ), monthNames: this._get( inst, "monthNames" ) };
		},

		/* Format the given date for display. */
		_formatDate: function( inst, day, month, year ) {
			if ( !day ) {
				inst.currentDay = inst.selectedDay;
				inst.currentMonth = inst.selectedMonth;
				inst.currentYear = inst.selectedYear;
			}
			var date = ( day ? ( typeof day === "object" ? day :
				this._daylightSavingAdjust( new Date( year, month, day ) ) ) :
				this._daylightSavingAdjust( new Date( inst.currentYear, inst.currentMonth, inst.currentDay ) ) );
			return this.formatDate( this._get( inst, "dateFormat" ), date, this._getFormatConfig( inst ) );
		}
	} );

	/*
	 * Bind hover events for datepicker elements.
	 * Done via delegate so the binding only occurs once in the lifetime of the parent div.
	 * Global datepicker_instActive, set by _updateDatepicker allows the handlers to find their way back to the active picker.
	 */
	function datepicker_bindHover( dpDiv ) {
		var selector = "button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";
		return dpDiv.on( "mouseout", selector, function() {
				$( this ).removeClass( "ui-state-hover" );
				if ( this.className.indexOf( "ui-datepicker-prev" ) !== -1 ) {
					$( this ).removeClass( "ui-datepicker-prev-hover" );
				}
				if ( this.className.indexOf( "ui-datepicker-next" ) !== -1 ) {
					$( this ).removeClass( "ui-datepicker-next-hover" );
				}
			} )
			.on( "mouseover", selector, datepicker_handleMouseover );
	}

	function datepicker_handleMouseover() {
		if ( !$.datepicker._isDisabledDatepicker( datepicker_instActive.inline ? datepicker_instActive.dpDiv.parent()[ 0 ] : datepicker_instActive.input[ 0 ] ) ) {
			$( this ).parents( ".ui-datepicker-calendar" ).find( "a" ).removeClass( "ui-state-hover" );
			$( this ).addClass( "ui-state-hover" );
			if ( this.className.indexOf( "ui-datepicker-prev" ) !== -1 ) {
				$( this ).addClass( "ui-datepicker-prev-hover" );
			}
			if ( this.className.indexOf( "ui-datepicker-next" ) !== -1 ) {
				$( this ).addClass( "ui-datepicker-next-hover" );
			}
		}
	}

	/* jQuery extend now ignores nulls! */
	function datepicker_extendRemove( target, props ) {
		$.extend( target, props );
		for ( var name in props ) {
			if ( props[ name ] == null ) {
				target[ name ] = props[ name ];
			}
		}
		return target;
	}

	/* Invoke the datepicker functionality.
	   @param  options  string - a command, optionally followed by additional parameters or
						Object - settings for attaching new datepicker functionality
	   @return  jQuery object */
	$.fn.datepicker = function( options ) {

		/* Verify an empty collection wasn't passed - Fixes #6976 */
		if ( !this.length ) {
			return this;
		}

		/* Initialise the date picker. */
		if ( !$.datepicker.initialized ) {
			$( document ).on( "mousedown", $.datepicker._checkExternalClick );
			$.datepicker.initialized = true;
		}

		/* Append datepicker main container to body if not exist. */
		if ( $( "#" + $.datepicker._mainDivId ).length === 0 ) {
			$( "body" ).append( $.datepicker.dpDiv );
		}

		var otherArgs = Array.prototype.slice.call( arguments, 1 );
		if ( typeof options === "string" && ( options === "isDisabled" || options === "getDate" || options === "widget" ) ) {
			return $.datepicker[ "_" + options + "Datepicker" ].
				apply( $.datepicker, [ this[ 0 ] ].concat( otherArgs ) );
		}
		if ( options === "option" && arguments.length === 2 && typeof arguments[ 1 ] === "string" ) {
			return $.datepicker[ "_" + options + "Datepicker" ].
				apply( $.datepicker, [ this[ 0 ] ].concat( otherArgs ) );
		}
		return this.each( function() {
			typeof options === "string" ?
				$.datepicker[ "_" + options + "Datepicker" ].
					apply( $.datepicker, [ this ].concat( otherArgs ) ) :
				$.datepicker._attachDatepicker( this, options );
		} );
	};

	$.datepicker = new Datepicker(); // singleton instance
	$.datepicker.initialized = false;
	$.datepicker.uuid = new Date().getTime();
	$.datepicker.version = "1.12.1";

	return $.datepicker;

	} ) );


/***/ }),

/***/ 280:
/*!***********************************************************!*\
  !*** ./modules/CoreWebclient/js/views/CHeaderItemView.js ***!
  \***********************************************************/
/***/ (function(module, exports, __webpack_require__) {

	
	var
		ko = __webpack_require__(/*! knockout */ 46),
		
		Routing = __webpack_require__(/*! modules/CoreWebclient/js/Routing.js */ 190)
	;

	function CHeaderItemView(sLinkText)
	{
		this.sName = '';
		
		this.visible = ko.observable(true);
		this.baseHash = ko.observable('');
		this.hash = ko.observable('');
		this.linkText = ko.observable(sLinkText);
		this.isCurrent = ko.observable(false);
		
		this.recivedAnim = ko.observable(false).extend({'autoResetToFalse': 500});
		this.unseenCount = ko.observable(0);
		
		this.allowChangeTitle = ko.observable(false); // allows to change favicon and browser title when browser is inactive
		this.inactiveTitle = ko.observable('');
		
		this.excludedHashes = ko.observableArray([]);
	}

	CHeaderItemView.prototype.ViewTemplate = 'CoreWebclient_HeaderItemView';

	CHeaderItemView.prototype.setName = function (sName)
	{
		this.sName = sName.toLowerCase();
		if (this.baseHash() === '')
		{
			this.hash(Routing.buildHashFromArray([sName.toLowerCase()]));
			this.baseHash(this.hash());
		}
		else
		{
			this.hash(this.baseHash());
		}
	};

	module.exports = CHeaderItemView;


/***/ }),

/***/ 298:
/*!***********************************************!*\
  !*** ./modules/CoreWebclient/js/CSelector.js ***!
  \***********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		
		App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
		Browser = __webpack_require__(/*! modules/CoreWebclient/js/Browser.js */ 178)
	;

	/**
	 * @param {Function} list (knockout)
	 * @param {Function=} fSelectCallback
	 * @param {Function=} fDeleteCallback
	 * @param {Function=} fDblClickCallback
	 * @param {Function=} fEnterCallback
	 * @param {Function=} multiplyLineFactor (knockout)
	 * @param {boolean=} bResetCheckedOnClick = false
	 * @param {boolean=} bCheckOnSelect = false
	 * @param {boolean=} bUnselectOnCtrl = false
	 * @param {boolean=} bDisableMultiplySelection = false
	 * @param {boolean=} bChangeOnSelect = true
	 * @constructor
	 */
	function CSelector(list, fSelectCallback, fDeleteCallback, fDblClickCallback, fEnterCallback, multiplyLineFactor,
		bResetCheckedOnClick, bCheckOnSelect, bUnselectOnCtrl, bDisableMultiplySelection, bChangeOnSelect)
	{
		this.fSelectCallback = fSelectCallback || function() {};
		this.fDeleteCallback = fDeleteCallback || function() {};
		this.fDblClickCallback = (!App.isMobile() && fDblClickCallback) ? fDblClickCallback : function() {};
		this.fEnterCallback = fEnterCallback || function() {};
		this.bResetCheckedOnClick = !!bResetCheckedOnClick;
		this.bCheckOnSelect = !!bCheckOnSelect;
		this.bUnselectOnCtrl = !!bUnselectOnCtrl;
		this.bDisableMultiplySelection = !!bDisableMultiplySelection;
		this.bChangeOnSelect = (typeof bChangeOnSelect === 'undefined') ? true : !!bChangeOnSelect;
		
		this.useKeyboardKeys = ko.observable(false);

		this.list = ko.observableArray([]);

		if (list && list['subscribe'])
		{
			list['subscribe'](function (mValue) {
				this.list(mValue);
			}, this);
		}
		
		this.multiplyLineFactor = multiplyLineFactor;
		
		this.oLast = null;
		this.oListScope = null;
		this.oScrollScope = null;

		this.iTimer = 0;
		this.iFactor = 1;

		this.KeyUp = Enums.Key.Up;
		this.KeyDown = Enums.Key.Down;
		this.KeyLeft = Enums.Key.Up;
		this.KeyRight = Enums.Key.Down;

		if (this.multiplyLineFactor)
		{
			if (this.multiplyLineFactor.subscribe)
			{
				this.multiplyLineFactor.subscribe(function (iValue) {
					this.iFactor = 0 < iValue ? iValue : 1;
				}, this);
			}
			else
			{
				this.iFactor = Types.pInt(this.multiplyLineFactor);
			}

			this.KeyUp = Enums.Key.Up;
			this.KeyDown = Enums.Key.Down;
			this.KeyLeft = Enums.Key.Left;
			this.KeyRight = Enums.Key.Right;

			if ($('html').hasClass('rtl'))
			{
				this.KeyLeft = Enums.Key.Right;
				this.KeyRight = Enums.Key.Left;
			}
		}

		this.sActionSelector = '';
		this.sSelectabelSelector = '';
		this.sCheckboxSelector = '';

		var self = this;

		// reading returns a list of checked items.
		// recording (bool) puts all checked, or unchecked.
		this.listChecked = ko.computed({
			'read': function () {
				var aList = _.filter(this.list(), function (oItem) {
					var
						bC = oItem.checked(),
						bS = oItem.selected()
					;

					return bC || (self.bCheckOnSelect && bS);
				});

				return aList;
			},
			'write': function (bValue) {
				bValue = !!bValue;
				_.each(this.list(), function (oItem) {
					oItem.checked(bValue);
				});
				this.list.valueHasMutated();
			},
			'owner': this
		});

		this.checkAll = ko.computed({
			'read': function () {
				return 0 < this.listChecked().length;
			},

			'write': function (bValue) {
				this.listChecked(!!bValue);
			},
			'owner': this
		});

		this.selectorHook = ko.observable(null);

		this.selectorHook.subscribe(function () {
			var oPrev = this.selectorHook();
			if (oPrev)
			{
				oPrev.selected(false);
			}
		}, this, 'beforeChange');

		this.selectorHook.subscribe(function (oGroup) {
			if (oGroup)
			{
				oGroup.selected(true);
			}
		}, this);

		this.itemSelected = ko.computed({

			'read': this.selectorHook,

			'write': function (oItemToSelect) {

				this.selectorHook(oItemToSelect);

				if (oItemToSelect)
				{
					self.scrollToSelected();
					this.oLast = oItemToSelect;
				}
			},
			'owner': this
		});

		this.list.subscribe(function (aList) {
			if (_.isArray(aList))
			{
				var	oSelected = this.itemSelected();
				if (oSelected)
				{
					if (!_.find(aList, function (oItem) {
						return oSelected === oItem;
					}))
					{
						this.itemSelected(null);
					}
				}
			}
			else
			{
				this.itemSelected(null);
			}
		}, this);

		this.listCheckedOrSelected = ko.computed({
			'read': function () {
				var
					oSelected = this.itemSelected(),
					aChecked = this.listChecked()
				;
				return 0 < aChecked.length ? aChecked : (oSelected ? [oSelected] : []);
			},
			'write': function (bValue) {
				if (!bValue)
				{
					this.itemSelected(null);
					this.listChecked(false);
				}
				else
				{
					this.listChecked(true);
				}
			},
			'owner': this
		});

		this.listCheckedAndSelected = ko.computed({
			'read': function () {
				var
					aResult = [],
					oSelected = this.itemSelected(),
					aChecked = this.listChecked()
				;

				if (aChecked)
				{
					aResult = aChecked.slice(0);
				}

				if (oSelected && _.indexOf(aChecked, oSelected) === -1)
				{
					aResult.push(oSelected);
				}

				return aResult;
			},
			'write': function (bValue) {
				if (!bValue)
				{
					this.itemSelected(null);
					this.listChecked(false);
				}
				else
				{
					this.listChecked(true);
				}
			},
			'owner': this
		});

		this.isIncompleteChecked = ko.computed(function () {
			var
				iM = this.list().length,
				iC = this.listChecked().length
			;
			return 0 < iM && 0 < iC && iM > iC;
		}, this);

		this.onKeydownBound = _.bind(this.onKeydown, this);
	}

	CSelector.prototype.iTimer = 0;
	CSelector.prototype.bResetCheckedOnClick = false;
	CSelector.prototype.bCheckOnSelect = false;
	CSelector.prototype.bUnselectOnCtrl = false;
	CSelector.prototype.bDisableMultiplySelection = false;

	CSelector.prototype.getLastOrSelected = function ()
	{
		var
			iCheckedCount = 0,
			oLastSelected = null
		;
		
		_.each(this.list(), function (oItem) {
			if (oItem.checked())
			{
				iCheckedCount++;
			}

			if (oItem.selected())
			{
				oLastSelected = oItem;
			}
		});

		return 0 === iCheckedCount && oLastSelected ? oLastSelected : this.oLast;
	};

	/**
	 * @param {string} sActionSelector css-selector for the active for pressing regions of the list
	 * @param {string} sSelectabelSelector css-selector to the item that was selected
	 * @param {string} sCheckboxSelector css-selector to the element that checkbox in the list
	 * @param {*} oListScope
	 * @param {*} oScrollScope
	 */
	CSelector.prototype.initOnApplyBindings = function (sActionSelector, sSelectabelSelector, sCheckboxSelector, oListScope, oScrollScope)
	{
		$(document).on('keydown', this.onKeydownBound);

		this.oListScope = oListScope;
		this.oScrollScope = oScrollScope;
		this.sActionSelector = sActionSelector;
		this.sSelectabelSelector = sSelectabelSelector;
		this.sCheckboxSelector = sCheckboxSelector;

		var
			self = this,

			fEventClickFunction = function (oLast, oItem, oEvent) {

				var
					iIndex = 0,
					iLength = 0,
					oListItem = null,
					bChangeRange = false,
					bIsInRange = false,
					aList = [],
					bChecked = false
				;

				oItem = oItem ? oItem : null;
				if (oEvent && oEvent.shiftKey)
				{
					if (null !== oItem && null !== oLast && oItem !== oLast)
					{
						aList = self.list();
						bChecked = oItem.checked();

						for (iIndex = 0, iLength = aList.length; iIndex < iLength; iIndex++)
						{
							oListItem = aList[iIndex];

							bChangeRange = false;
							if (oListItem === oLast || oListItem === oItem)
							{
								bChangeRange = true;
							}

							if (bChangeRange)
							{
								bIsInRange = !bIsInRange;
							}

							if (bIsInRange || bChangeRange)
							{
								oListItem.checked(bChecked);
							}
						}
					}
				}

				if (oItem)
				{
					self.oLast = oItem;
				}
			}
		;

		$(this.oListScope).on('dblclick', sActionSelector, function (oEvent) {
			var oItem = ko.dataFor(this);
			if (oItem && oEvent && !oEvent.ctrlKey && !oEvent.altKey && !oEvent.shiftKey)
			{
				self.onDblClick(oItem);
			}
		});

		if (Browser.mobileDevice)
		{
			$(this.oListScope).on('touchstart', sActionSelector, function (e) {

				if (!e)
				{
					return;
				}

				var
					t2 = e.timeStamp,
					t1 = $(this).data('lastTouch') || t2,
					dt = t2 - t1,
					fingers = e.originalEvent && e.originalEvent.touches ? e.originalEvent.touches.length : 0
				;

				$(this).data('lastTouch', t2);
				if (!dt || dt > 250 || fingers > 1)
				{
					return;
				}

				e.preventDefault();
				$(this).trigger('dblclick');
			});
		}

		$(this.oListScope).on('click', sActionSelector, function (oEvent) {

			var
				bClick = true,
				oSelected = null,
				oLast = self.getLastOrSelected(),
				oItem = ko.dataFor(this)
			;

			if (oItem && oEvent)
			{
				if (oEvent.shiftKey)
				{
					bClick = false;
					if (!self.bDisableMultiplySelection)
					{
						if (null === self.oLast)
						{
							self.oLast = oItem;
						}


						oItem.checked(!oItem.checked());
						fEventClickFunction(oLast, oItem, oEvent);
					}
				}
				else if (oEvent.ctrlKey)
				{
					bClick = false;
					if (!self.bDisableMultiplySelection)
					{
						self.oLast = oItem;
						oSelected = self.itemSelected();
						if (oSelected && !oSelected.checked() && !oItem.checked())
						{
							oSelected.checked(true);
						}

						if (self.bUnselectOnCtrl && oItem === self.itemSelected())
						{
							oItem.checked(!oItem.selected());
							self.itemSelected(null);
						}
						else
						{
							oItem.checked(!oItem.checked());
						}
					}
				}

				if (bClick)
				{
					self.onSelect(oItem, true);
					self.scrollToSelected();
				}
			}
		});

		$(this.oListScope).on('click', sCheckboxSelector, function (oEvent) {

			var oItem = ko.dataFor(this);
			if (oItem && oEvent && !self.bDisableMultiplySelection)
			{
				if (oEvent.shiftKey)
				{
					if (null === self.oLast)
					{
						self.oLast = oItem;
					}

					fEventClickFunction(self.getLastOrSelected(), oItem, oEvent);
				}
				else
				{
					self.oLast = oItem;
				}
			}

			if (oEvent && oEvent.stopPropagation)
			{
				oEvent.stopPropagation();
			}
		});

		$(this.oListScope).on('dblclick', sCheckboxSelector, function (oEvent) {
			if (oEvent && oEvent.stopPropagation)
			{
				oEvent.stopPropagation();
			}
		});
	};

	/**
	 * @param {Object} oSelected
	 * @param {number} iEventKeyCode
	 * 
	 * @return {Object}
	 */
	CSelector.prototype.getResultSelection = function (oSelected, iEventKeyCode)
	{
		var
			self = this,
			bStop = false,
			bNext = false,
			oResult = null,
			iPageStep = this.iFactor,
			bMultiply = !!this.multiplyLineFactor,
			iIndex = 0,
			iLen = 0,
			aList = []
		;

		if (!oSelected && -1 < $.inArray(iEventKeyCode, [this.KeyUp, this.KeyDown, this.KeyLeft, this.KeyRight,
			Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End]))
		{
			aList = this.list();
			if (aList && 0 < aList.length)
			{
				if (-1 < $.inArray(iEventKeyCode, [this.KeyDown, this.KeyRight, Enums.Key.PageUp, Enums.Key.Home]))
				{
					oResult = aList[0];
				}
				else if (-1 < $.inArray(iEventKeyCode, [this.KeyUp, this.KeyLeft, Enums.Key.PageDown, Enums.Key.End]))
				{
					oResult = aList[aList.length - 1];
				}
			}
		}
		else if (oSelected)
		{
			aList = this.list();
			iLen = aList ? aList.length : 0;

			if (0 < iLen)
			{
				if (
					Enums.Key.Home === iEventKeyCode || Enums.Key.PageUp === iEventKeyCode ||
					Enums.Key.End === iEventKeyCode || Enums.Key.PageDown === iEventKeyCode ||
					(bMultiply && (Enums.Key.Left === iEventKeyCode || Enums.Key.Right === iEventKeyCode)) ||
					(!bMultiply && (Enums.Key.Up === iEventKeyCode || Enums.Key.Down === iEventKeyCode))
				)
				{
					_.each(aList, function (oItem) {
						if (!bStop)
						{
							switch (iEventKeyCode) {
								case self.KeyUp:
								case self.KeyLeft:
									if (oSelected === oItem)
									{
										bStop = true;
									}
									else
									{
										oResult = oItem;
									}
									break;
								case Enums.Key.Home:
								case Enums.Key.PageUp:
									oResult = oItem;
									bStop = true;
									break;
								case self.KeyDown:
								case self.KeyRight:
									if (bNext)
									{
										oResult = oItem;
										bStop = true;
									}
									else if (oSelected === oItem)
									{
										bNext = true;
									}
									break;
								case Enums.Key.End:
								case Enums.Key.PageDown:
									oResult = oItem;
									break;
							}
						}
					});
				}
				else if (bMultiply && this.KeyDown === iEventKeyCode)
				{
					for (; iIndex < iLen; iIndex++)
					{
						if (oSelected === aList[iIndex])
						{
							iIndex += iPageStep;
							if (iLen - 1 < iIndex)
							{
								iIndex -= iPageStep;
							}

							oResult = aList[iIndex];
							break;
						}
					}
				}
				else if (bMultiply && this.KeyUp === iEventKeyCode)
				{
					for (iIndex = iLen; iIndex >= 0; iIndex--)
					{
						if (oSelected === aList[iIndex])
						{
							iIndex -= iPageStep;
							if (0 > iIndex)
							{
								iIndex += iPageStep;
							}

							oResult = aList[iIndex];
							break;
						}
					}
				}
			}
		}

		return oResult;
	};

	/**
	 * @param {Object} oResult
	 * @param {Object} oSelected
	 * @param {number} iEventKeyCode
	 */
	CSelector.prototype.shiftClickResult = function (oResult, oSelected, iEventKeyCode)
	{
		if (oSelected)
		{
			var
				bMultiply = !!this.multiplyLineFactor,
				bInRange = false,
				bSelected = false
			;

			if (-1 < $.inArray(iEventKeyCode,
				bMultiply ? [Enums.Key.Left, Enums.Key.Right] : [Enums.Key.Up, Enums.Key.Down]))
			{
				oSelected.checked(!oSelected.checked());
			}
			else if (-1 < $.inArray(iEventKeyCode, bMultiply ?
				[Enums.Key.Up, Enums.Key.Down, Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End] :
				[Enums.Key.Left, Enums.Key.Right, Enums.Key.PageUp, Enums.Key.PageDown, Enums.Key.Home, Enums.Key.End]
			))
			{
				bSelected = !oSelected.checked();

				_.each(this.list(), function (oItem) {
					var Add = false;
					if (oItem === oResult || oSelected === oItem)
					{
						bInRange = !bInRange;
						Add = true;
					}

					if (bInRange || Add)
					{
						oItem.checked(bSelected);
						Add = false;
					}
				});
				
				if (bMultiply && oResult && (iEventKeyCode === Enums.Key.Up || iEventKeyCode === Enums.Key.Down))
				{
					oResult.checked(!oResult.checked());
				}
			}
		}	
	};

	/**
	 * @param {number} iEventKeyCode
	 * @param {boolean} bShiftKey
	 */
	CSelector.prototype.clickNewSelectPosition = function (iEventKeyCode, bShiftKey)
	{
		var
			oSelected = this.itemSelected(),
			oResult = this.getResultSelection(oSelected, iEventKeyCode)
		;

		if (oResult)
		{
			if (bShiftKey)
			{
				this.shiftClickResult(oResult, oSelected, iEventKeyCode);
			}
			this.selectionFunc(oResult);
		}
	};

	/**
	 * @param {Object} oEvent
	 * 
	 * @return {boolean}
	 */
	CSelector.prototype.onKeydown = function (oEvent)
	{
		var
			bResult = true,
			iCode = 0
		;

		if (this.useKeyboardKeys() && oEvent && !Utils.isTextFieldFocused())// && !App.Screens.hasOpenedMaximizedPopups())
		{
			iCode = oEvent.keyCode;
			if (!oEvent.ctrlKey &&
				(
					this.KeyUp === iCode || this.KeyDown === iCode ||
					this.KeyLeft === iCode || this.KeyRight === iCode ||
					Enums.Key.PageUp === iCode || Enums.Key.PageDown === iCode ||
					Enums.Key.Home === iCode || Enums.Key.End === iCode
				)
			)
			{
				this.clickNewSelectPosition(iCode, oEvent.shiftKey);
				bResult = false;
			}
			else if (Enums.Key.Del === iCode && !oEvent.ctrlKey && !oEvent.shiftKey)
			{
				if (0 < this.list().length)
				{
					this.onDelete();
					bResult = false;
				}
			}
			else if (Enums.Key.Enter === iCode)
			{
				if (0 < this.list().length && !oEvent.ctrlKey)
				{
					this.onEnter(this.itemSelected());
					bResult = false;
				}
			}
			else if (oEvent.ctrlKey && !oEvent.altKey && !oEvent.shiftKey && Enums.Key.a === iCode)
			{
				this.checkAll(!(this.checkAll() && !this.isIncompleteChecked()));
				bResult = false;
			}
		}

		return bResult;
	};

	CSelector.prototype.onDelete = function ()
	{
		this.fDeleteCallback.call(this, this.listCheckedOrSelected());
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.onEnter = function (oItem)
	{
		this.fEnterCallback.call(this, oItem);
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.selectionFunc = function (oItem)
	{
		var
			fProceedSelection = _.bind(function () {
				if (this.bChangeOnSelect)
				{
					this.itemSelected(null);
				}
				if (this.bResetCheckedOnClick)
				{
					this.listChecked(false);
				}
				if (this.bChangeOnSelect)
				{
					this.itemSelected(oItem);
				}
				this.fSelectCallback.call(this, oItem);
			}, this),
			oParams = {
				'Item': oItem,
				'Cancel': false,
				'ProceedSelectionHandler': fProceedSelection
			}
		;
		
		if (!oParams.Cancel)
		{
			fProceedSelection();
		}
	};

	/**
	 * @param {Object} oItem
	 * @param {boolean} bCheckBefore
	 */
	CSelector.prototype.onSelect = function (oItem, bCheckBefore)
	{
		this.selectionFunc(oItem);
	};

	/**
	 * @param {Object} oItem
	 */
	CSelector.prototype.onDblClick = function (oItem)
	{
		this.fDblClickCallback.call(this, oItem);
	};

	CSelector.prototype.koCheckAll = function ()
	{
		return ko.computed({
			'read': this.checkAll,
			'write': this.checkAll,
			'owner': this
		});
	};

	CSelector.prototype.koCheckAllIncomplete = function ()
	{
		return ko.computed({
			'read': this.isIncompleteChecked,
			'write': this.isIncompleteChecked,
			'owner': this
		});
	};

	/**
	 * @return {boolean}
	 */
	CSelector.prototype.scrollToSelected = function ()
	{
		if (!this.oListScope || !this.oScrollScope)
		{
			return false;
		}

		var
			iOffset = 20,
			oSelected = $(this.sSelectabelSelector, this.oScrollScope),
			oPos = oSelected.position(),
			iVisibleHeight = this.oScrollScope.height(),
			iSelectedHeight = oSelected.outerHeight()
		;

		if (oPos && (oPos.top < 0 || oPos.top + iSelectedHeight > iVisibleHeight))
		{
			if (oPos.top < 0)
			{
				this.oScrollScope.scrollTop(this.oScrollScope.scrollTop() + oPos.top - iOffset);
			}
			else
			{
				this.oScrollScope.scrollTop(this.oScrollScope.scrollTop() + oPos.top - iVisibleHeight + iSelectedHeight + iOffset);
			}

			return true;
		}

		return false;
	};

	module.exports = CSelector;


/***/ }),

/***/ 514:
/*!*************************************!*\
  !*** ./modules/Tasks/js/manager.js ***!
  \*************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = function (oAppData) {
		var
			App = __webpack_require__(/*! modules/CoreWebclient/js/App.js */ 179),
			ModulesManager = __webpack_require__(/*! modules/CoreWebclient/js/ModulesManager.js */ 42),
			sModuleName = 'tasks'
		;
		
		if (App.getUserRole() === Enums.UserRole.NormalUser && ModulesManager.isModuleEnabled('CalendarWebclient'))
		{
			var
				_ = __webpack_require__(/*! underscore */ 2),

				TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
				HeaderItemView = null
			;

			return {
				/**
				 * Returns list of functions that are return module screens.
				 * 
				 * @returns {Object}
				 */
				getScreens: function ()
				{
					var oScreens = {};
					
					oScreens[sModuleName] = function () {
						return __webpack_require__(/*! modules/Tasks/js/views/MainView.js */ 515);
					};
					
					return oScreens;
				},
				/**
				 * Returns object of header item view of sales module.
				 * 
				 * @returns {Object}
				 */
				getHeaderItem: function () {
					if (HeaderItemView === null)
					{
						var CHeaderItemView = __webpack_require__(/*! modules/CoreWebclient/js/views/CHeaderItemView.js */ 280);
						HeaderItemView = new CHeaderItemView(TextUtils.i18n('TASKS/ACTION_SHOW_TASKS'));
					}

					return {
						item: HeaderItemView,
						name: sModuleName
					};
				}
			};
		}
		
		return null;
	};

/***/ }),

/***/ 515:
/*!********************************************!*\
  !*** ./modules/Tasks/js/views/MainView.js ***!
  \********************************************/
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var
		_ = __webpack_require__(/*! underscore */ 2),
		$ = __webpack_require__(/*! jquery */ 1),
		ko = __webpack_require__(/*! knockout */ 46),
		moment = __webpack_require__(/*! moment */ 51),
	    
		UserSettings = __webpack_require__(/*! modules/CoreWebclient/js/Settings.js */ 45),
		TextUtils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Text.js */ 43),
		Utils = __webpack_require__(/*! modules/CoreWebclient/js/utils/Common.js */ 213),
		Ajax = __webpack_require__(/*! modules/CoreWebclient/js/Ajax.js */ 186),
		CSelector = __webpack_require__(/*! modules/CoreWebclient/js/CSelector.js */ 298),
		CAbstractScreenView = __webpack_require__(/*! modules/CoreWebclient/js/views/CAbstractScreenView.js */ 193),
		CPageSwitcherView = __webpack_require__(/*! modules/CoreWebclient/js/views/CPageSwitcherView.js */ 243),
		Types = __webpack_require__(/*! modules/CoreWebclient/js/utils/Types.js */ 44),
		Popups = __webpack_require__(/*! modules/CoreWebclient/js/Popups.js */ 187),
		
		CCalendarListModel = __webpack_require__(/*! modules/CalendarWebclient/js/models/CCalendarListModel.js */ 276),
		CCalendarModel = __webpack_require__(/*! modules/CalendarWebclient/js/models/CCalendarModel.js */ 277),
		EditTaskPopup = __webpack_require__(/*! modules/CalendarWebclient/js/popups/EditEventPopup.js */ 267)
	;

	__webpack_require__(/*! jquery-ui/ui/widgets/datepicker */ 278);

	/**
	 * View that is used as screen of sales module.
	 * 
	 * @constructor
	 */
	function CMainView()
	{
		this.sDateFormat = UserSettings.dateFormat();
		
		this.dateFormatMoment = Utils.getDateFormatForMoment(this.sDateFormat);
		
		
		this.saveCommand = Utils.createCommand(this, this.executeSave);	
		this.removeCommand = Utils.createCommand(this, this.executeRemove);	
		this.calendars = new CCalendarListModel({
			onCalendarCollectionChange: function () {},
			onCalendarActiveChange: function () {}
		});

		CAbstractScreenView.call(this, 'Tasks');
		this.iItemsPerPage = 20;
		/**
		 * Text for displaying in browser title when sales screen is shown.
		 */
		this.browserTitle = ko.observable(TextUtils.i18n('TASKS/HEADING_BROWSER_TAB'));
		this.tasksList = ko.observableArray([]);
		this.hiddenTasksList = ko.observableArray([]);
		this.selectedItem = ko.observable(null);
		this.isSearchFocused = ko.observable(false);
		this.searchInput = ko.observable('');
		
		this.selector = new CSelector(
			this.tasksList,
			_.bind(this.viewItem, this),
	        this.executeRemove,
			_.bind(this.taskClickCallback, this)
		);
		
		this.searchClick = ko.observable(false);
		this.isSearch = ko.computed(function () {
			return this.searchInput() !== '' && this.searchClick();
		}, this);
		
		this.pageSwitcherLocked = ko.observable(false);
		this.oPageSwitcher = new CPageSwitcherView(0, this.iItemsPerPage);
		this.oPageSwitcher.currentPage.subscribe(function (iCurrentpage) {
			this.currentPage(iCurrentpage);
			this.getTasks();
		}, this);
		this.currentPage = ko.observable(1);
		this.loadingList = ko.observable(false);
		this.preLoadingList = ko.observable(false);
		this.loadingList.subscribe(function (bLoading) {
			this.preLoadingList(bLoading);
		}, this);
		this.sTimeFormat = ko.computed(function () {
			return (UserSettings.timeFormat() === Enums.TimeFormat.F24) ? 'HH:mm' : 'hh:mm A';
		}, this);
		this.isEmptyList = ko.computed(function () {
			return 0 === this.tasksList().length;
		}, this);
		this.searchText = ko.observable('');
		this.showCompleted = ko.observable(false);
		this.actionCompletedText = ko.computed(function () {
			return this.showCompleted() ?  TextUtils.i18n('TASKS/ACTION_HIDE_COMPLETED') : TextUtils.i18n('TASKS/ACTION_SHOW_COMPLETED');
		}, this);	

	}

	_.extendOwn(CMainView.prototype, CAbstractScreenView.prototype);

	CMainView.prototype.ViewTemplate = 'Tasks_MainView';
	CMainView.prototype.ViewConstructorName = 'CMainView';

	/**
	 * Called every time when screen is shown.
	 */
	CMainView.prototype.onShow = function ()
	{
		this.getCalendars();
	};

	CMainView.prototype.getCalendars = function ()
	{
		this.loadingList(true);
		Ajax.send(
				'Calendar',
				'GetCalendars', 
				{
					'IsPublic': false
				}, 
				this.onGetCalendarsResponse, 
				this
		);
	};

	/**
	 * @param {Object} oResponse
	 * @param {Object} oParameters
	 */
	CMainView.prototype.onGetCalendarsResponse = function (oResponse, oParameters)
	{
		var
			aCalendarIds = [],
			aNewCalendarIds = [],
			oCalendar = null,
			oClientCalendar = null,
			self = this
		;
		
		if (oResponse.Result)
		{
			_.each(oResponse.Result.Calendars, function (oCalendarData) {
				oCalendar = this.calendars.parseCalendar(oCalendarData);
				aCalendarIds.push(oCalendar.id);
				oClientCalendar = this.calendars.getCalendarById(oCalendar.id);
				if (this.needsToReload || (oClientCalendar && oClientCalendar.sSyncToken) !== (oCalendar && oCalendar.sSyncToken))
				{
					oCalendar = this.calendars.parseAndAddCalendar(oCalendarData);
					if (oCalendar)
					{
						var calId = oCalendar.id;
						
						oCalendar.active.subscribe(function (newValue) {
							_.each(self.tasksList(), function(oItem){
								if (oItem.calendarId === calId)
								{
									oItem.visible(newValue);
								}
							});
						}, oCalendar);
						oCalendar.davUrl(Types.pString(oResponse.Result.ServerUrl));
						aNewCalendarIds.push(oCalendar.id);
					}
				}
			}, this);

			this.getTasks(aCalendarIds);
		}
	};

	CMainView.prototype.getTasks = function (aNewCalendarIds)
	{
		this.loadingList(true);
		Ajax.send(
			'Calendar',
			'GetTasks', 
			{
				'CalendarIds': aNewCalendarIds,
				'Completed': this.showCompleted(),
				'Search': this.searchInput()
			},
			this.onGetTasksResponse,
			this
		);
	};

	CMainView.prototype.prepareTask = function (oItem)
	{
		var
			self = this,
			oCalendar = self.calendars.getCalendarById(oItem.calendarId)
		;
		
		oItem.visibleDate = ko.observable('');

		oItem.withDate = ko.observable(false);
		if (oItem.start && oItem.end)
		{
			oItem.withDate(true);
			oItem.start = moment(oItem.start);
			oItem.end = moment(oItem.end);

			var oMomentStart = oItem.start.clone();
			var oMomentEnd = oItem.end.clone();

			if (oMomentEnd && oItem.allDay)
			{
				oMomentEnd.subtract(1, 'days');
			}
			var isEvOneDay = oMomentEnd.diff(oMomentStart, 'days') === 0;
			var isEvOneTime = oMomentEnd.diff(oMomentStart, 'minutes') === 0;					

			var sStartDate = self.getDateWithoutYearIfMonthWord(oMomentStart.format(self.dateFormatMoment));
			var sEndDate = !isEvOneDay ? ' - ' + self.getDateWithoutYearIfMonthWord(oMomentEnd.format(self.dateFormatMoment)) : '';

			var sStartTime = !oItem.allDay ? ', ' + oMomentStart.format(this.sTimeFormat()) : '';
			var sEndTime = !oItem.allDay && !isEvOneTime ? 
				(isEvOneDay ? ' - ' : ', ')  + oMomentEnd.format(this.sTimeFormat()) : '';

			oItem.visibleDate = ko.observable(
				sStartDate +
				sStartTime +
				sEndDate +
				sEndTime
			);
		}

		oItem.selected = ko.observable(false);
		oItem.checked = ko.observable(oItem.status);
		oItem.visible = ko.observable(oCalendar.active());
		oItem.color = oCalendar.color;
		oItem.checked.subscribe(function(newValue){
			self.updateTaskStatus(oItem);
		});
		return oItem;	
	};

	CMainView.prototype.getTaskFromList = function (uid)
	{
		return _.find(this.tasksList(), function (oItem){
			return oItem.uid === uid;
		});
	};

	CMainView.prototype.onGetTasksResponse = function (oResponse)
	{
		var 
			oResult = oResponse.Result,
			self = this;

		if (oResult)
		{
			var
				aNewCollection = Types.isNonEmptyArray(oResult) ? _.compact(_.map(oResult, function (oItem) {
					return self.prepareTask(oItem);
				})) : [];
				
			this.tasksList(aNewCollection);
			this.loadingList(false);
		}
	};

	CMainView.prototype.viewItem = function (oItem)
	{
		this.selectedItem(oItem);
	};

	CMainView.prototype.onBind = function ()
	{
		this.selector.initOnApplyBindings(
			'.sales_sub_list .item',
			'.sales_sub_list .selected.item',
			'.sales_sub_list .selected.item',
			$('.sales_list', this.$viewDom),
			$('.sales_list_scroll.scroll-inner', this.$viewDom)
		);
	};

	CMainView.prototype.searchSubmit = function ()
	{
		if (this.searchInput() !== '')
		{
			this.searchText(
				TextUtils.i18n('TASKS/INFO_SEARCH_RESULT', {
					'SEARCH': this.searchInput()
				})
			);
		}
		else
		{
			this.searchText('');
		}
		
		this.searchClick(true);
		this.tasksList([]);
		this.getCalendars();
	};

	CMainView.prototype.onClearSearchClick = function ()
	{
		// initiation empty search
		this.searchInput('');
		this.searchText('');
		this.searchClick(false);
		this.searchSubmit();
	};

	CMainView.prototype.createTaskInCurrentCalendar = function ()
	{
		this.calendars.pickCurrentCalendar();
		this.createTaskToday(this.calendars.currentCal());
	};

	/**
	 * @param {Object} oCalendar
	 */
	CMainView.prototype.createTaskToday = function (oCalendar)
	{
		this.openTaskPopup(oCalendar, null, null, false);
	};

	/**
	 * @param {Object} oCalendar
	 * @param {Object} oStart
	 * @param {Object} oEnd
	 * @param {boolean} bAllDay
	 */
	CMainView.prototype.openTaskPopup = function (oCalendar, oStart, oEnd, bAllDay)
	{
		if (oCalendar)
		{
			Popups.showPopup(EditTaskPopup, [{
				CallbackSave: _.bind(this.createTask, this),
				CallbackDelete: null,
				Calendars: this.calendars,
				SelectedCalendar: oCalendar ? oCalendar.id : 0,
				Start: oStart,
				End: oEnd,
				AllDay: bAllDay,            
				TimeFormat: this.sTimeFormat(),
				DateFormat: UserSettings.dateFormat(),
	            Type: 'VTODO',
				IsTaskApp: true
			}]);
		}
	};

	/**
	 * @param {Object} oEventData
	 */
	CMainView.prototype.getParamsFromEventData = function (oEventData)
	{
		return {
			id: oEventData.id,
			uid: oEventData.uid,
			calendarId: oEventData.calendarId,
			newCalendarId: oEventData.newCalendarId || oEventData.calendarId,
			subject: oEventData.subject,
			allDay: oEventData.allDay ? 1 : 0,
			location: oEventData.location,
			description: oEventData.description,
			alarms: oEventData.alarms ? JSON.stringify(oEventData.alarms) : '[]',
			attendees: oEventData.attendees ? JSON.stringify(oEventData.attendees) : '[]',
			owner: oEventData.owner,
			recurrenceId: oEventData.recurrenceId,
			excluded: oEventData.excluded,
			allEvents: oEventData.allEvents,
			modified: oEventData.modified ? 1 : 0,
			start: oEventData.start.local().toDate(),
			end: oEventData.end.local().toDate(),
			startTS: oEventData.start.unix(),
			endTS: oEventData.end ? oEventData.end.unix() : oEventData.end.unix(),
			rrule: oEventData.rrule ? JSON.stringify(oEventData.rrule) : null,
			type: oEventData.type,
			status: oEventData.status,
			withDate: oEventData.withDate
		};
	};

	/**
	 * @param {Object} oEventData
	 */
	CMainView.prototype.createTask = function (oData)
	{
		var aParameters = this.getParamsFromEventData(oData);

		aParameters.calendarId = oData.newCalendarId;
	    Ajax.send(
			'Calendar',
			'CreateEvent', 
	        aParameters,
	        this.onCreateTaskResponse,
			this
		);	
	};

	CMainView.prototype.onCreateTaskResponse = function (oResponse)
	{
		var oResult = oResponse.Result;

		if (oResult)
		{
			var oTask = this.prepareTask(oResult.Events[0]);
			this.tasksList.push(oTask);
		}
	};

	/**
	 * @param {Object} oData
	 */
	CMainView.prototype.taskClickCallback = function (oData)
	{
		var
			/**
			 * @param {number} iResult
			 */
			fCallback = _.bind(function (iResult) {
				var oParams = {
						ID: oData.id,
						Uid: oData.uid,
						RecurrenceId: oData.recurrenceId,
						Calendars: this.calendars,
						SelectedCalendar: oData.calendarId,
						AllDay: oData.allDay,
						Location: oData.location,
						Description: oData.description,
						Subject: oData.subject,
						Alarms: oData.alarms,
						Attendees: oData.attendees,
						RRule: oData.rrule,
						Excluded: false,
						Owner: oData.owner,
						Appointment: false,
						OwnerName: oData.ownerName,
						TimeFormat: this.sTimeFormat(),
						DateFormat: UserSettings.dateFormat(),
						AllEvents: iResult,
						CallbackSave: _.bind(this.updateTask, this),
						CallbackDelete: _.bind(this.executeRemove, this),
						Type: oData.type,
						Status: oData.status,
						IsTaskApp: true
					}
				;
				if (iResult !== Enums.CalendarEditRecurrenceEvent.None)
				{
					if (oData.start && oData.end)
					{
						oParams.Start = oData.start.clone();
						oParams.Start = oParams.Start.local();

						oParams.End = oData.end.clone();
						oParams.End = oParams.End.local();
					}
					Popups.showPopup(EditTaskPopup, [oParams]);
				}
			}, this)
		;

		fCallback(Enums.CalendarEditRecurrenceEvent.AllEvents);
	};

	/**
	 * @param {Object} oEventData
	 */
	CMainView.prototype.updateTask = function (oData)
	{
	    var aParameters = this.getParamsFromEventData(oData);

	    Ajax.send(
			'Calendar',
			'UpdateEvent', 
	        aParameters,
			this.onUpdateTaskResponse,
			this
		);	
	};

	CMainView.prototype.onUpdateTaskResponse = function (oResponse, oArguments)
	{
		var oResult = oResponse.Result;

		if (oResult)
		{
			var 
				uid = oResult.Events[0].uid,
				oTask = this.getTaskFromList(uid)
			;
			if(oTask)
			{
				oTask = this.prepareTask(oResult.Events[0]);
				var index = _.findIndex(this.tasksList(), function(oItem){
					return oItem.uid === uid;
				});
				if (index >= 0)
				{
					this.tasksList.splice(index, 1, oTask);
				}
			}
		}
	};

	/**
	 * @param {Object} oEventData
	 */
	CMainView.prototype.executeRemove = function (oData)
	{
		Ajax.send(
			'Calendar',
			'DeleteEvent', 
			{
				'calendarId': oData.calendarId,
				'uid': oData.uid
			},
			this.onDeleteTaskResponse,
			this
		);	
		
	};

	CMainView.prototype.onDeleteTaskResponse = function (oResponse, oArguments)
	{
		if (oResponse.Result)
		{
			var 
				uid = oArguments.Parameters.uid,
				oTask = this.getTaskFromList(uid)
			;
			if(oTask)
			{
				this.tasksList(_.without(this.tasksList(), _.findWhere(this.tasksList(), {
					uid: uid
				})));			
			}
		}
	};

	/**
	 * @param {Object} oData
	 */
	CMainView.prototype.updateTaskStatus = function (oData)
	{
		Ajax.send(
			'Calendar',
			'UpdateTask', 
			{
				'CalendarId': oData.calendarId,
				'TaskId': oData.uid,
				'Subject': oData.subject,
				'Status': oData.checked(),
				'WithDate': oData.withDate()
			},
			this.onUpdateTaskStatusResponse,
			this
		);	
	};

	CMainView.prototype.onUpdateTaskStatusResponse = function (oResponse, oArguments)
	{
	};

	/**
	 * @param {string} sDate
	 */
	CMainView.prototype.getDateWithoutYearIfMonthWord = function (sDate)
	{
		var
			aDate = sDate.split(' '),
			oNowMoment = moment(),
			oNowYear = oNowMoment.format('YYYY')
		;
		
		if (aDate.length === 3 && oNowYear === aDate[2])
		{
			return aDate[0] + ' ' + aDate[1];
		}
		return sDate;
	};

	CMainView.prototype.onShowCompletedClick = function ()
	{
		this.showCompleted(!this.showCompleted());
		this.searchSubmit();
	};

	module.exports = new CMainView();


/***/ })

});